#include "myTypes.h"
#include "TVG.h"
#include "Main.h"
#include "Functions.h"
#include "System_unit.h"
#include "Timers.h"

const Uint32 table_address_variable [256] =
{
     (Uint32)0xFFFFFFFF,            // 0  .
     (Uint32)&tvg.T0,               // 1   
     (Uint32)&tvg.f0,               // 2     .
     (Uint32)&tvg.Kf0,              // 3      
     (Uint32)0xFFFFFFFF,            // 4  .
     (Uint32)0xFFFFFFFF,            // 5  .
     (Uint32)0xFFFFFFFF,            // 6  .
     (Uint32)0xFFFFFFFF,            // 7  .
     (Uint32)0xFFFFFFFF,            // 8  .
     (Uint32)0xFFFFFFFF,            // 9  .
     //adr_10
     (Uint32)0xFFFFFFFF,            // 10  .
     (Uint32)0xFFFFFFFF,            // 11  .
     (Uint32)0xFFFFFFFF,            // 12  .
     (Uint32)0xFFFFFFFF,            // 13  .
     (Uint32)0xFFFFFFFF,            // 14  .
     (Uint32)0xFFFFFFFF,            // 15  .
     (Uint32)0xFFFFFFFF,            // 16  .
     (Uint32)0xFFFFFFFF,            // 17  .
     (Uint32)0xFFFFFFFF,            // 18  .
     (Uint32)0xFFFFFFFF,            // 19  .
     //adr_20
     (Uint32)0xFFFFFFFF,            // 20  .
     (Uint32)0xFFFFFFFF,            // 21  .
     (Uint32)0xFFFFFFFF,            // 22  .
     (Uint32)0xFFFFFFFF,            // 23  .
     (Uint32)0xFFFFFFFF,            // 24  .
     (Uint32)0xFFFFFFFF,            // 25  .
     (Uint32)0xFFFFFFFF,            // 26  .
     (Uint32)0xFFFFFFFF,            // 27  .
     (Uint32)0xFFFFFFFF,            // 28  .
     (Uint32)0xFFFFFFFF,            // 29  .
     //adr_30
     (Uint32)0xFFFFFFFF,            // 30  .
     (Uint32)0xFFFFFFFF,            // 31  .
     (Uint32)0xFFFFFFFF,            // 32  .
     //    
     (Uint32)&Korrect_0,             // 33   0  
     (Uint32)&Temp_koef_0,          // 34 . .  0  
     (Uint32)&Korrect_masshtab,      // 35  .
     (Uint32)&Temp_koef_masshtab,   // 36 .   
     (Uint32)&Temp_koef_0_board,    // 37 . .  0     
     (Uint32)&Temp_koef_masshtab_board,  // 38 .      
     (Uint32)&tvg.TimFiltrKoef,       // 39     

    //adr_40
     (Uint32)&tvg.BruinKoef,        // 40   (       )
     (Uint32)0xFFFFFFFF,            // 41  .
     (Uint32)&tvg.SetAngl,          // 42     a0   
     (Uint32)&SAngl.P,              // 43  Wcp / F0 -     
     (Uint32)&SAngl.PdivQ,          // 44 P / q -   ,   
     (Uint32)&SAngl.Msht,           // 45     
     (Uint32)0xFFFFFFFF,            // 46  ,
     (Uint32)0xFFFFFFFF,            // 47  ,
     (Uint32)0xFFFFFFFF,            // 48  ,
     (Uint32)0xFFFFFFFF,            // 49  ,

     //adr_50
     //      
     (Uint32)&PLL.Kcg,             // 50 ,  -      
     (Uint32)&PLL.Kfg,             // 51 ,         
     //      
     (Uint32)&PLL.Kct,             // 52 ,  -      -
     (Uint32)&PLL.Kft,             // 53 ,         
     //   
     (Uint32)&PLL_KK.Lim,          // 54 ,   
     (Uint32)0xFFFFFFFF,           // 55  ,
     (Uint32)&PLL_KK.Ready_Lim,    // 56    
     (Uint32)0xFFFFFFFF,           // 57  ,
     (Uint32)0xFFFFFFFF,           // 58  ,
     (Uint32)&SearchDeltaF,        // 59   ,   0,2

     //adr_60
     //  
     (Uint32)&Amp_KK.Kc,           // 60 ,  -   
     (Uint32)&Amp_KK.Kf,           // 61 ,      
     (Uint32)0xFFFFFFFF,           // 62  ,
//     (Uint32)&PWMLim,              // 63     PWM (max 1022 *32)
     (Uint32)0xFFFFFFFF,           // 63  ,
     //   A
     (Uint32)&Amp_KK.Lim,          // 64 ,      
     (Uint32)&Amp.Lim_R_gis,       // 65    ,
     (Uint32)&Amp_KK.Ready_Lim,    // 66    
     (Uint32)&Amp.Lim_R[0],        // 67    -  (0,99),
     (Uint32)&Amp.Lim_R[1],        // 68    -  (0,2),
     (Uint32)&Amp.Lim_R[2],        // 69      (0,05)

     //adr_70
     //  
     (Uint32)&Quadr_KK.Kc,         // 70 ,     
     (Uint32)&Quadr_KK.Kf,         // 71 ,      
     (Uint32)0xFFFFFFFF,           // 72  ,
     (Uint32)&OutLim,              // 73     
     //   
     (Uint32)&Quadr_KK.Lim,        // 74 ,      
     (Uint32)0xFFFFFFFF,           // 75 ,     
     (Uint32)&Quadr_KK.Ready_Lim,  // 76    
     (Uint32)0xFFFFFFFF,           // 77  ,
     (Uint32)0xFFFFFFFF,           // 78  ,
     (Uint32)0xFFFFFFFF,           // 79  ,

     //adr_80
     //  
     (Uint32)&AnglS_KK.Kc,         // 80 ,     
     (Uint32)&AnglS_KK.Kf,         // 81 ,      
     (Uint32)0xFFFFFFFF,           // 82  ,
     (Uint32)0xFFFFFFFF,           // 83  ,
     //   
     (Uint32)&AnglS_KK.Lim,        // 84 ,      
     (Uint32)0xFFFFFFFF,           // 85  ,
     (Uint32)&AnglS_KK.Ready_Lim,  // 86    
     (Uint32)0xFFFFFFFF,           // 87  ,
     (Uint32)0xFFFFFFFF,           // 88  ,
     (Uint32)0xFFFFFFFF,           // 89  ,

     //adr_90
     (Uint32)&OutInfo.RQFiltrKoef, // 90       
     (Uint32)&OutInfo.OutFiltrKoef,// 91     
     (Uint32)0xFFFFFFFF,           // 92  .
     (Uint32)&tvg.PWM_korr,        // 93 N0   
     (Uint32)&tvg.directPWM,       // 94    = (nX+(nY<<16))
     (Uint32)&tvg.InFtrKoefGr,     // 95       
     (Uint32)&tvg.InFtrKoefTch,    // 96       
     (Uint32)&ReadyKoef,           // 97    
     (Uint32)&Rdy_gisterezis,      // 98   
     (Uint32)0xFFFFFFFF,           // 99  ,

     //adr_100
     (Uint32)&tvg.Angl_gr,         // 100      /  
     (Uint32)&tvg.W_gr,            // 101        / 
     (Uint32)&tvg.Angl_gis,        // 102     /  ,
     (Uint32)&tvg.W_gis,           // 103      /  
     (Uint32)&Amp.Level_Wave,      //  104   
     (Uint32)0xFFFFFFFF,           // 105  ,
     (Uint32)0xFFFFFFFF,           // 106  ,
     (Uint32)0xFFFFFFFF,           // 107  ,
     (Uint32)0xFFFFFFFF,           // 108  ,
     (Uint32)0xFFFFFFFF,           // 109  ,
     (Uint32)0xFFFFFFFF,           // 110  ,
     (Uint32)0xFFFFFFFF,           // 111  ,

     // 
     //adr_112
     (Uint32)0xFFFFFFFF,          // 112  ,
     (Uint32)0xFFFFFFFF,          // 113  ,
     (Uint32)0xFFFFFFFF,          // 114  ,
     (Uint32)0xFFFFFFFF,          // 115  ,
     (Uint32)0xFFFFFFFF,          // 116  ,
     (Uint32)0xFFFFFFFF,          // 117  ,
     (Uint32)0xFFFFFFFF,          // 118  ,
     (Uint32)0xFFFFFFFF,          // 119  ,

     //adr_120
     (Uint32)0xFFFFFFFF,          // 120  ,
     (Uint32)0xFFFFFFFF,          // 121  ,
     (Uint32)0xFFFFFFFF,          // 122  ,
     (Uint32)0xFFFFFFFF,          // 123  ,
     (Uint32)0xFFFFFFFF,          // 124  ,
     (Uint32)0xFFFFFFFF,          // 125  ,
     (Uint32)0xFFFFFFFF,          // 126  ,
     (Uint32)0xFFFFFFFF,          // 127  ,
     (Uint32)0xFFFFFFFF,          // 128  ,
     (Uint32)0xFFFFFFFF,          // 129  ,

     //adr_130
     (Uint32)0xFFFFFFFF,          // 130  ,
     (Uint32)0xFFFFFFFF,          // 131  ,
     (Uint32)0xFFFFFFFF,          // 132  ,
     (Uint32)0xFFFFFFFF,          // 133  ,
     (Uint32)0xFFFFFFFF,          // 134  ,
     (Uint32)0xFFFFFFFF,          // 135  ,
     (Uint32)0xFFFFFFFF,          // 136  ,
     (Uint32)0xFFFFFFFF,          // 137  ,
     (Uint32)0xFFFFFFFF,          // 138  ,
     (Uint32)0xFFFFFFFF,          // 139  ,

     //adr_140
     (Uint32)0xFFFFFFFF,          // 140  ,
     (Uint32)0xFFFFFFFF,          // 141  ,
     (Uint32)0xFFFFFFFF,          // 142  ,
     (Uint32)0xFFFFFFFF,          // 143  ,
     (Uint32)0xFFFFFFFF,          // 144  ,
     (Uint32)0xFFFFFFFF,          // 145  ,
     (Uint32)0xFFFFFFFF,          // 146  ,
     (Uint32)0xFFFFFFFF,          // 147  ,
     (Uint32)0xFFFFFFFF,          // 148  ,
     (Uint32)0xFFFFFFFF,          // 149  ,

     //adr_150
     (Uint32)0xFFFFFFFF,          // 150  ,
     (Uint32)0xFFFFFFFF,          // 151  ,
     (Uint32)0xFFFFFFFF,          // 152  ,
     (Uint32)0xFFFFFFFF,          // 153  ,
     (Uint32)0xFFFFFFFF,          // 154  ,
     (Uint32)0xFFFFFFFF,          // 155  ,
     (Uint32)0xFFFFFFFF,          // 156  ,
     (Uint32)0xFFFFFFFF,          // 157  ,
     (Uint32)0xFFFFFFFF,          // 158  ,
     (Uint32)0xFFFFFFFF,          // 159  ,

     //adr_160
     (Uint32)&OutInfo.cdus,         //160       
     (Uint32)&OutInfo.cfree,        //161      
     (Uint32)&OutInfo.csovm,        //162      ()
     (Uint32)&OutInfo.acsel,        //163  
     (Uint32)&Tims.Period,          // 164    , *256
     (Uint32)&Func.Speed_outP,      // 165       ,
     (Uint32)&SAngl.Angl_filt,      // 166    
     (Uint32)&SAngl.Angl_fut,       // 167     (  )
     (Uint32)&OutInfo.FiltrR.last_out,   // 168    (.),
     (Uint32)&OutInfo.FiltrQ.last_out,   // 169    (. ),

     //adr_170
     (Uint32)0xFFFFFFFF,            // 170   ,
     (Uint32)&tvg.Ttvg,             // 171  
     (Uint32)0xFFFFFFFF,            // 172   ,
     (Uint32)&tvg.Tpl,              // 173   
     (Uint32)0xFFFFFFFF,            // 174   ,
     (Uint32)&tvg.WorkState,        // 175   
     (Uint32)&tvg.StopCnt,          // 176   /     
     (Uint32)&tvg.f00,              // 177  ,         
     (Uint32)0xFFFFFFFF,            // 178   ,
     (Uint32)0xFFFFFFFF,            // 179  ,

     //adr_180
     (Uint32)&AnglS.dNai,           // 180    
     (Uint32)&AnglS_KK.accL,        // 181       (.)
     (Uint32)&AnglS_KK.out,         // 182       (.)
     (Uint32)&AnglS_KK.PpcL,        // 183       (.)
     (Uint32)&AnglS_KK.PpcH,        // 184       (.)
     (Uint32)&AnglS.out,            // 185    
     (Uint32)&AnglS_KK.Rdy,         // 186    
     (Uint32)&AnglS_PWM.RazXY,      // 187     
     (Uint32)&AnglS_PWM.sumXY,      // 188     ,
     (Uint32)&AnglS.Real_out,       // 189     

     //adr_190
     (Uint32)&SAngl.Z1,             // 190  1   ,
     (Uint32)&SAngl.Z2,             // 191  2   ,
     (Uint32)&Func.cycle,           // 192    = 4 + R1.Nx + R1.Ny
     (Uint32)&OutInfo.deltaAngl,    // 193     ,   
     (Uint32)&OutInfo.deltaTim,     // 194     , *256
     (Uint32)&OutInfo.SumAngl,      // 195     ,   
     (Uint32)&OutInfo.SumTim,       // 196     
     (Uint32)&delta_F,              // 197         
     (Uint32)&delta_Temp,           // 198         
     (Uint32)&sysflag,              // 199   

     //adr_200
     (Uint32)&tvgIn.Xc,             // 200  Ac   (,  )
     (Uint32)&tvgIn.Xs,             // 201  As   (,  )
     (Uint32)&tvgIn.Yc,             // 202  Bc   (,  )
     (Uint32)&tvgIn.Ys,             // 203  Bs   (,  )
     (Uint32)&Func.FXc,             // 204  Ac   ()
     (Uint32)&Func.FXs,             // 205  Ac   ()
     (Uint32)&Func.FYc,             // 206  Ac   ()
     (Uint32)&Func.FYs,             // 207  Ac   ()
     (Uint32)&Func.K5K,             // 208 5 (   )
     (Uint32)&Func.K6K,             // 209 6 (   )

     //adr_210
     (Uint32)&Func.SApFi,           // 210 sin(2a +)
     (Uint32)&Func.CApFi,           // 211 cos(2a + )
     (Uint32)&Func.SAmFi,           // 212 sin(2a - )
     (Uint32)&Func.CAmFi,           // 213 cos(2a - )
     (Uint32)&Func.ApFi,            // 214 2 + ,
     (Uint32)&Func.AmFi,            // 215 2 -  ,
     (Uint32)&Func.R,               // 216 R  
     (Uint32)&Func.p,               // 217 P  
     (Uint32)&Func.Angletmp,        // 218     
     (Uint32)&Func.Fitemp,          // 219     

     //adr_220
     (Uint32)&PLL.dPLLi,            // 220     =  / pi2
     (Uint32)&PLL_KK.accL,          // 221       (.)
     (Uint32)&PLL_KK.out,           // 222       (.)
     (Uint32)&PLL_KK.PpcL,          // 223       (.)
     (Uint32)&PLL_KK.PpcH,          // 224       (.)
     (Uint32)&PLL.out,              // 225    
     (Uint32)&PLL_KK.Rdy,           // 226   
     (Uint32)&tvgOut.PLL,           // 227  
     (Uint32)&Func.F_outP,          // 228   ,
     (Uint32)&tvg.f00,              // 229  

     //adr_230
     (Uint32)&Amp.dNRi,             // 230    
     (Uint32)&Amp_KK.accL,          // 231       (.)
     (Uint32)&Amp_KK.out,           // 232       (.)
     (Uint32)&Amp_KK.PpcL,          // 233       (.)
     (Uint32)&Amp_KK.PpcH,          // 234       (.)
     (Uint32)&Amp.out,              // 235    
     (Uint32)&Amp_KK.Rdy,           // 236    
     (Uint32)&Amp_PWM.RazXY,        // 237   
     (Uint32)&Amp_PWM.sumXY,        // 238   ,
     (Uint32)&Amp.Real_out,         // 239     
     //adr_240
     (Uint32)&Quadr.dNpi,           // 240    
     (Uint32)&Quadr_KK.accL,        // 241       (.)
     (Uint32)&Quadr_KK.out,         // 242       (.)
     (Uint32)&Quadr_KK.PpcL,        // 243       (.)
     (Uint32)&Quadr_KK.PpcH,        // 244       (.)
     (Uint32)&Quadr.out,            // 245    
     (Uint32)&Quadr_KK.Rdy,         // 246    
     (Uint32)&Quadr_PWM.RazXY,      // 247   
     (Uint32)&Quadr_PWM.sumXY,      // 248   ,
     (Uint32)&Quadr.Real_out,       // 249     
     //adr_250
     (Uint32)0xFFFFFFFF,            // 250  ,
     (Uint32)0xFFFFFFFF,            // 251  ,
     (Uint32)0xFFFFFFFF,            // 252  ,
     (Uint32)0xFFFFFFFF,            // 253  ,
     (Uint32)0xFFFFFFFF,            // 254  ,
     (Uint32)0xFFFFFFFF             // 255  ,
};

uint8 table_type_variable [256];





