/****************************************************************************/
/*  C6701.cmd                                                               */
/*  Copyright (c) 2012 Texas Instruments Incorporated                       */
/*  Author: Rafael de Souza                                                 */
/*                                                                          */
/*    Description: This file is a sample linker command file that can be    */
/*                 used for linking programs built with the C compiler and  */
/*                 running the resulting .out file on a C6701               */
/*                 device.  Use it as a guideline.  You will want to        */
/*                 change the memory layout to match your specific C6xxx    */
/*                 target system.  You may want to change the allocation    */
/*                 scheme according to the size of your program.            */
/*                                                                          */
/****************************************************************************/

MEMORY
{
    vecs:          o = 00000000h   l = 00000200h
    IPROG:         o = 00000200h   l = 0000FE00h
    IDATA:	       o = 80000000h   l = 010000h
}
/*
SECTIONS
{
    "vecs"   >       vecs
    .text       >       IPROG
    .cinit		>		IPROG
    .far      	>       IDATA
    .stack      >       IDATA
    .bss        >       IDATA
    .const      >       IPROG
    .data       >       IDATA
    .switch     >       IDATA
}
*/
SECTIONS
{
    "vecs"   >       vecs
    .text       >       IPROG
    .cinit      >       IDATA
    .stack      >       IDATA
    .bss        >       IDATA
    .const      >       IPROG
    .data       >       IDATA
    .switch     >       IDATA
    .sysmem     >       IDATA
    .far        >       IDATA
    .cio        >       IDATA

    .pinit         >  IDATA
    .cinit         >  IDATA

}
