L 1 "../csl/csl_vers.c"
N#include <csl_version.h>
L 1 "E:/TI_workspase/c6701_t/csl/csl_version.h" 1
N/*********************************************************
NAdds a version string to an object file that can be
Nread with the "vers" CCS command-line program.
N
NThe string is placed in a new section named "VERSION",
Nso that it can easily be moved in memory or discarded.
N
Nusage:
N	VERSION(id, rev, tag)
Nwhere
N	id is a module variable name prefix
N	rev is a string, a module revision number
N	tag is a string, a revision control tag
N*********************************************************/
N
N#ifndef _VERSION
N#define _VERSION
N
N/*
NVERSION(id, rev, tag)
N Initialize an int array named <id>_version with a character string
N in the following format:
N	Id:<id> Rev:<rev> Tag:<tag> Built: <date> <time>
N
N The rev and tag arguments are constant character strings.
N
N e.g. if "file.c" contains:
N	VERSION(MP3_TI, "1.01", "RELEASE1");
N
N then "vers version.obj" will produce, e.g.:
N        Id:MP3_TI Rev:1.01 Tag:RELEASE1 Built:Dec 18 2001 18:47:34
N*/
N#ifndef _TMS320C5XX
N/* for every platform except C54x */
N#define VERSION(id, rev, tag) \
N	const char id##_version[] = "@(#)Id:" #id " Rev:" rev " Tag:" tag " Built:" __DATE__ " " __TIME__
X#define VERSION(id, rev, tag) 	const char id##_version[] = "@(#)Id:" #id " Rev:" rev " Tag:" tag " Built:" __DATE__ " " __TIME__
N
N#else
S/* for C54x only */
S#define VERSION(id, rev, tag) \
S	extern const char id##_version[];\
S	asm(" version_string _" #id "_version, \"Id:" #id " Rev:" rev " Tag:" tag " Built:" __DATE__ " " __TIME__ "\"")
X#define VERSION(id, rev, tag) 	extern const char id##_version[];	asm(" version_string _" #id "_version, \"Id:" #id " Rev:" rev " Tag:" tag " Built:" __DATE__ " " __TIME__ "\"")
S
S/*
Scoff_string for C54x
S An assembly macro to initialize a string in DSP memory in a
S format that appears as a byte-wide character string in the
S COFF file on disk.
S*/
Sasm("coff_string .macro str");
Sasm("  .var i");
Sasm("  .asg 1,i");
Sasm("  .loop $symlen(\":str:\")/2");
Sasm("    .field ':str(i+1,1):',8");
Sasm("    .field ':str(i,1):',8");
Sasm("    .eval i+2,i");
Sasm("  .endloop");
Sasm("  .if (i=$symlen(\":str:\"))");
Sasm("    .field 0,8");
Sasm("    .field ':str(i,1):',8");
Sasm("  .else");
Sasm("    .field 0,8");
Sasm("  .endif");
Sasm(" .endm");
S
S/*
Sversion_string
S Initialized an array named "name" with the character string "str",
S so that it can be read using the "vers" CCS command-line program.
S*/
Sasm("version_string .macro name,str");
Sasm("  .sect \".const:VERSION\"");
Sasm("  .global :name:");
Sasm(":name::");
Sasm("  .string \"@(#):str:\"");
Sasm("  .byte 0");
Sasm("  coff_string \"@(#):str:\"");
Sasm("  .text");
Sasm("  .endm");
N#endif
N
N#endif
L 2 "../csl/csl_vers.c" 2
N
NVERSION(CSL_C6000_TI, "C6x_2.31.00.16", "C");
Xconst char CSL_C6000_TI_version[] = "@(#)Id:" "CSL_C6000_TI" " Rev:" "C6x_2.31.00.16" " Tag:" "C" " Built:" "Oct  1 2020" " " "14:46:35";
