#define __FUNCTIONS__C

#include <Main.h>
#include <RAM.h>
#include "myTypes.h"
#include "Functions.h"
#include <System_unit.h>
#include "Main.h"


int64 num;
int64 ost;
int64 tsm;
int64 rez_mult;
int64 rez;
int64 V;
int32 n;
int64 sum;
int64 ff;
int32 r;
int32 delta;
int64 tmps, tmps1;
int32 flg;
AnglFltr_s SAngl;

int32 int_Angle_set;
////////////////////////////////////////////////////////////////////////////////
//   32-   . < 1
// : int32 sma -   ( ),
//     int32 kff - , +-2^31  ,    ,  .
// : int32   sma  kff
////////////////////////////////////////////////////////////////////////////////
int32 Spec_mult (int32 sma, int32 kff)
{

    num = (int64)sma; ost = (int64)kff;
    tsm = num * ost;
    tsm = tsm >> 31;
    return (int32)tsm; // return (int32)( ( (int64)sma * (int64)kff ) >> 31) ;
}
////////////////////////////////////////////////////////////////////////////////
//   64-   . < 1
// : int64 sma -   ( ),
//     int32 kff - , +-2^31  ,    ,  .
// : int64  rez_mult   sma
////////////////////////////////////////////////////////////////////////////////
void int_long_mult (int64 sma, int32 kff)
{

    num = sma;
    if (sma < 0)
        num = -num;
    tsm = (int64) kff;
    if (kff < 0)
        tsm = -tsm;
//	tsm = tsm & c2v31_1;
    ost = num >> 32;
    num &= 0x00000000FFFFFFFF;
    num = (num * tsm) >> 31;
    ost = ((ost * tsm) << 1) + num;
    if ((sma < 0) && (kff > 0) || (sma > 0) && (kff < 0))
        rez_mult = -ost;
    else
        rez_mult = ost;
    return;
}
////////////////////////////////////////////////////////////////////////////////
//   
////////////////////////////////////////////////////////////////////////////////
int32 int_sqrt1 (int64 x)
{

	ost = x;
	if (ost < 0) return -1;
	ff = c2v62 >> 2;
	rez = 0;
	while (ff > 0)
	{
		tsm = rez + ff;
		rez = rez >> 1;
		if ( tsm < ost)
		{
			ost -= tsm; 
			rez += ff;
		};
		ff = ff >> 2;
	};
	r = (int32) rez;
	return r;
}


////////////////////////////////////////////////////////////////////////////////
// 
// : int32 ugol (2^24 = 1 )  |ugol|< 2^31 (   +-pi/2)
// : int32 (.. 2^31 = 1,  +-2^31  ,    
////////////////////////////////////////////////////////////////////////////////
int32 int_sin (int32 ugol)
{
static const int32 tabl_sin[8] = {	0x15555555,
								0x06666666,
								0x030C30C3,
								0x01C71C72,
								0x0129E413,
								0x00D20D21,
								0x009C09C1,
								0x00787878 };

	n=0;
	// 
	delta = ugol;
	if (delta < 0) delta = -delta;
	if (delta >= int_2pi) delta = delta % int_2pi;
	if (delta >= int_pi + int_pi2) delta = delta - int_2pi;
	if (delta > int_pi2) delta = int_pi - delta;
	if (ugol < 0) delta = - delta;
	//  
	sum = ((int64) delta) << 7;
	tmps = sum;
	tmps = (tmps * sum) >> 31;
	V = sum;
	//  
	do
	{
		tmps1 = (tmps * tabl_sin[n]) >> 31;
		tmps1 = tmps1 * (-V);
		V = tmps1 >> 31;
		sum += V;
		n++;
		if (( V > c2v31_1) ||  ( V < -c2v31_1)) { delta = c2v31_1; }
		else  { if ( V < 0) { delta = -V;} else { delta = V;}; };
	} while ((n < 8) && (delta > 0x00000003));
	//  
	if ( sum > c2v31_1)  sum = c2v31_1;
	if ( sum < -c2v31_1)  sum = -c2v31_1;
	// 
	return (int32) sum;
}

////////////////////////////////////////////////////////////////////////////////
// 
// : int32 ugol (2^24 = 1 )  |ugol|< 2^31 (   +-pi/2)
// : int32 (.. 2^31 = 1,  +-2^31  ,    
////////////////////////////////////////////////////////////////////////////////
int32 int_cos (int32 ugol)
{
static	const int32 tabl_cos[9] = { 0x40000000,
								0x0AAAAAAB,
								0x04444444,
								0x02492492,
								0x016C16C1,
								0x00F83E10,
								0x00B40B41,
								0x00888889,
								0x006B15C0 };

	n=0;
	// 
	delta = ugol;
	if (delta < 0) delta = -delta;
	if (delta >= int_2pi) delta = delta % int_2pi;
	if (delta > int_pi) delta = int_2pi - delta;
	//  
	tmps = ((int64) delta) << 7;
	tmps = (tmps * tmps) >> 31;
	V = c2v31;
	sum = c2v31;
	//  
	do
	{
		tmps1 = (tmps * tabl_cos[n]) >> 31;
		tmps1 = tmps1 * (-V);
		V = tmps1 >> 31;
		sum += V;
		n++;
		if (( V > c2v31_1) ||  ( V < -c2v31_1)) { delta = c2v31_1; }
		else  { if ( V < 0) { delta = -V;} else { delta = V;}; };
	} while ((n < 9) && (delta > 0x00000003));
	//  
	if ( sum > c2v31_1)  sum = c2v31_1;
	if ( sum < -c2v31_1)  sum = -c2v31_1;
	// 
	return (int32) sum;
}

////////////////////////////////////////////////////////////////////////////////
// 
// : int32 (.. 2^31 = 1,  +-2^31  ,    , 1   
// prec int32 - ,  "+",  1 ( ),  1024
// :  int32 ugol (2^24 = 1 )  +-pi/2
////////////////////////////////////////////////////////////////////////////////

int32 int_arcsin (int32 x, int32 prec)
{
static const int32 tabl_asin[23] = {0x15555555,    0x3999999A,     0x4C30C30C,     0x571C71C7,
	                             0x5E4129E4,    0x63483483,     0x67027027,     0x69E1E1E2,
	                             0x6C29EB0A,    0x6E04E04E,     0x6F8EAC04,     0x70DA740E,
	                             0x71F5CA07,    0x72EA8FC3,     0x73C0233C,     0x747C1F08,
	                             0x7522D9B5,    0x75B7BC59,     0x763D7ECA,     0x76B6526B,
	                             0x77240122,    0x77880423,     0x77E394F5	};
	

	n=0; flg = 0;
	//   sqrt(2)/2
	delta = x;
	if (x < 0) delta = -delta;
	if (delta >= int_sqrt2_2)
	{
		tmps1 = ((int64) delta);
		tmps = c2v62 - (tmps1 * tmps1);
		delta = int_sqrt1 (tmps);
		flg = 1;
		tmps = tmps >> 31;
	}
	else
	{
		tmps = ((int64) delta);
		tmps = (tmps * tmps) >> 31;
	};
	//  
	V = (int64)delta;
	sum = (int64)delta;
	//  
	do
	{
		tmps1 = (tmps * tabl_asin[n]) >> 31;
		tmps1 = tmps1 * V;
		V = tmps1 >> 31;
		sum += V;
		n++;
		if ( V > c2v31_1) { delta = c2v31_1; }
		else  { delta = V;};
	} while ((n < 23) && (delta > (prec << 6)));
	//  
	tmps = ((int64) int_pi4) << 7;
	if ( sum > tmps)  { delta = int_pi4; }
	else { delta = (int32)(sum >> 7); };
	if (flg) delta = int_pi2 - delta;
	if (x < 0) delta = -delta;
	// 
	return delta;
}

////////////////////////////////////////////////////////////////////////////////
//       
//  *filtr -     
//  -    ()
////////////////////////////////////////////////////////////////////////////////
void korr_fltr (InFLTR_s *filtr, int32 a)
{
    filtr->sum =  ( filtr->last_out << 31 ) / a;
    filtr->last_a = a;
    return;
}

////////////////////////////////////////////////////////////////////////////////
//    
////////////////////////////////////////////////////////////////////////////////
void InFiltrInit (void)
{
    Uint16 i;
    for (i = 0; i < 4; i++)
    {
        Func.FFX[i].last_out = 0; //  
        korr_fltr (&Func.FFX[i], tvg.InFtrKoefGr); //   
        Func.lastsmp[i] = 0; //  
    };
    return;
}
////////////////////////////////////////////////////////////////////////////////
//   1 
//  -   ,
//  *filtr -    
//  -  
//    
//      ( )
////////////////////////////////////////////////////////////////////////////////
int32 int_filter1 (int32 x, InFLTR_s *filtr)
{
	filtr->sum += ((int64)x - filtr->last_out);
	int_long_mult (filtr->sum, filtr->last_a);
	filtr->last_out = rez_mult;
	if (rez_mult > c2v31_1) rez_mult = c2v31_1;
	if (rez_mult < -c2v31_1) rez_mult = -c2v31_1;
	return (int32)rez_mult;
}

////////////////////////////////////////////////////////////////////////////////
//         
////////////////////////////////////////////////////////////////////////////////

void korr_angl_filter (int32 deltaASpeed)
{
    int64 tmps;
    OutInfo.cfree = OutInfo.cfree + deltaASpeed;
    tmps = ((int64)OutInfo.cfree * (int64)tvg.BruinKoef);
    tmps = tmps / (int64)Func.F_outP;
    if (tmps > c2v31_1)
        tmps = c2v31_1;
    if (tmps < -c2v31_1)
        tmps = -c2v31_1;
    SAngl.Angl_sp_out = tmps;
    tmps = (tmps << 31) / SAngl.ASpeed_K1;
    if (tmps > c2v31_1)
        tmps = c2v31_1;
    if (tmps < -c2v31_1)
        tmps = -c2v31_1;
    SAngl.Z1 = (int32)tmps;
    return;
}
////////////////////////////////////////////////////////////////////////////////
//      
////////////////////////////////////////////////////////////////////////////////

void Set_koef_angl_filter (int32 cycle)
{
    SAngl.ASpeed_K2 = SAngl.PdivQ * cycle;
    SAngl.Angl_K0 = (int32)c2v31_1 - SAngl.ASpeed_K2 + 1;
    SAngl.Angl_K1 = SAngl.P * cycle;
    SAngl.Angl_K1 = Spec_mult (SAngl.Angl_K1, SAngl.Angl_K1);
    int_long_mult ( (MaxFreq << 7), SAngl.Angl_K1);
    rez_mult = rez_mult / (int64)cycle;
    SAngl.ASpeed_K1 = rez_mult / (int64)SAngl.Msht;
    return;
}
////////////////////////////////////////////////////////////////////////////////
//        
////////////////////////////////////////////////////////////////////////////////

void init_angl_filter (void)
{
    SAngl.P = 9777563; // = (2*pi *5 / 6900) * 2^31
    SAngl.PdivQ = 13827563; // = P / q, (q=sqrt(2)/2)
    SAngl.Msht = 16; //
    Set_koef_angl_filter (Func.cycle);
    SAngl.last_cikl = Func.cycle;
    return;
}

////////////////////////////////////////////////////////////////////////////////
//           
////////////////////////////////////////////////////////////////////////////////

void Reset_angl_filter (void)
{
    SAngl.Z1 = 0;
    SAngl.Angl_sp_out = 0;
    SAngl.Z2 = tvg.SetAngl_temp * SAngl.Msht;
    SAngl.Angl_fut = tvg.SetAngl_temp;
    SAngl.Angl_filt = tvg.SetAngl_temp;
    Set_koef_angl_filter (Func.cycle);
    SAngl.last_cikl = Func.cycle;
    return;
}

////////////////////////////////////////////////////////////////////////////////
//       
////////////////////////////////////////////////////////////////////////////////

void angl_filter(int32 x)
{
    int32 tmf;
    int32 tma;
    int32 tmpi;
    int64 tmps;
//    const int32 int_8pi = 0x1921FB54; //8 pi

    if (Func.cycle != SAngl.last_cikl)
    {
        SAngl.Z2 = SAngl.Last_Z2 + (SAngl.Z2 - SAngl.Last_Z2) * Func.cycle / SAngl.last_cikl;
        Set_koef_angl_filter (Func.cycle);
        SAngl.last_cikl = Func.cycle;
    };
    tmpi = int_pi2 * SAngl.Msht;
    SAngl.Last_Z2 = SAngl.Z2;

    // 1 
    tma = x * SAngl.Msht - SAngl.Z2;

    //  
    if (tma > tmpi)
        tma -= tmpi * 2;
    if (tma < -tmpi)
        tma += tmpi * 2;

    //   1 
    tmf = Spec_mult(SAngl.Z1, SAngl.Angl_K0);
    tmps = (int64)tmf + (int64)tma;

    //   1 
    if (tmps > c2v31_1)
        tmps = c2v31_1;
    if (tmps < -c2v31_1)
        tmps = -c2v31_1;
    SAngl.Z1 = (int32)tmps;

    //   2 
    tma = Spec_mult(SAngl.Z1, SAngl.Angl_K1);
    tmf = tma + SAngl.Z2;

    //  2 
    if (tmf > tmpi)
        tmf -= tmpi * 2;
    if (tmf < -tmpi)
        tmf += tmpi * 2;
    SAngl.Z2 = tmf;
    SAngl.Angl_filt = SAngl.Z2 / SAngl.Msht;

    //   
    tma = Spec_mult(SAngl.Z1, SAngl.ASpeed_K2) / SAngl.Msht;
    tmf = tma + SAngl.Angl_filt;
    //   
    if (tmf > int_pi2)
        tmf -= int_pi;
    if (tmf < -int_pi2)
        tmf += int_pi;
    SAngl.Angl_fut = tmf;

    //   
    int_long_mult ( SAngl.ASpeed_K1, SAngl.Z1);
    SAngl.Angl_sp_out = rez_mult;

    return;
}

////////////////////////////////////////////////////////////////////////////////
//   -    (x - , y - ,
//  -   ,    2^32  )
//   >0
////////////////////////////////////////////////////////////////////////////////
int32 Spec_int_div (int32 x, int32 y)
{
    int64 tmpm,tmpn;
	if ((x == 0) || (y == 0)) return 0;
	if ((x > 0) && (x >= y)) return 0x7FFFFFFF;
	if ((x < 0) && (-x > y))  return 0x80000000;
	tmpm = x * c2v31; tmpn = y;
	tmpm = tmpm / tmpn;
	return (int32)tmpm;
}

////////////////////////////////////////////////////////////////////////////////
//   -    (x -  64 , y -  64 ,
//  -   ,    2^32  )
//   >0
////////////////////////////////////////////////////////////////////////////////
int32 Spec_int64_div (int64 x, int64 y)
{ 	int64 tmpx,tmpy;
	int32 rez;
	Uint32 tmx,tmy, bit;
	tmpx = x; tmpy = y; tmx = 0; tmy = 0; rez = 0, bit = 0x40000000;
	if ((x == 0) || (y == 0))  { return 0; };
	if ((x > 0) && (x > y)) { return 0x7FFFFFFF; };
	if (x < 0)
	{
		if (-x > y) { return 0x80000000; };
		rez = 0x80000000; tmpx = -tmpx;
	};
	while (bit != 0)
	{
		tmy = tmy >> 1;
		if ((tmpy & 0x00000001) != 0) {tmy += 0x80000000;  };
		tmpy = tmpy >> 1;
		if ((tmpx > tmpy) || ((tmpx == tmpy) && (tmx > tmy)))
		{	tmpx -= tmpy;
			if (tmx < tmy) { tmpx--; };
			tmx -= tmy;
			rez += bit;
		};
		bit = bit >> 1;
	};
	if ((rez & 0x80000000) != 0)
	{ rez = rez & 0x7FFFFFFF; rez = -rez; };
	return rez;
}
////////////////////////////////////////////////////////////////////////////////
//       
// : int32 (.. 2^31 = 1,  +-2^31  ,    , 1   
// prec int32 - ,  "+",  1 ( ),  1024
// :  int32 ugol (2^24 = 1 )  +-pi, . +-3,14*2^24
////////////////////////////////////////////////////////////////////////////////

int32 CalcFullAngle (int32 sinx, int32 cosx)
{
    int32 abss, absc, ang;


    if (sinx < 0) { abss = -sinx; } else { abss = sinx; };
    if (cosx < 0) { absc = -cosx; } else { absc = cosx; };
    //1, 5, 4, 8
    if (abss < absc)
    {
        //1, 5
        ang = int_arcsin (sinx, 1);
        if (cosx < 0)
        {
            //4
            if (sinx > 0) {ang = int_pi - ang; }
            //8
            else {ang = -(int_pi + ang); };
        };
    }
    else
    // 2, 3, 6, 7
    {
        ang = int_arcsin (cosx, 1);
        //2,3
        if (sinx > 0) { ang = int_pi2 - ang; }
        // 6,7
        else {ang = -int_pi2 + ang; };
    };
    return ang;
}
////////////////////////////////////////////////////////////////////////////////


