#ifndef _FUNCTIONS_H_
#define _FUNCTIONS_H_

#include "myTypes.h"
#include "Main.h"


#define MaxFreq 0x00001DCD65000000 // = 32768000000000 = 62,5e6 * 2^32 / 8192 = 7629,39453125  * 2^32
#define c2v31  0x0000000080000000
#define c2v31_1  0x000000007FFFFFFF
#define c2v32  0x0000000100000000
#define c2v62  0x4000000000000000
#define c2v63_1  0x7FFFFFFFFFFFFFFF
#define int_pi  0x03243F6A
#define int_2pi  0x06487ED5
#define int_pi2  0x01921FB5
#define int_pi4  0x00C90FDA
#define int_sqrt2_2  0x5A827999
#define int_sqrt2  0x00000000B504F333



typedef struct //  
{
    int64 sum;
    int64 last_out;
    int32 last_a;
} InFLTR_s;

typedef struct //  
{
    int64 Angl_sp_out;  //     (    f/MaxFreq - 2^31 = 1 rad/sec)
    int32 Z1;   //  (1 )
    int32 Z2;   //  (1 )
    int32 Angl_filt; //  (2 )
    int32 Last_Z2; //   (2 )
    int32 Angl_fut; //   ( )
    int32 Angl_K0; // . 1 
    int32 Angl_K1; // . 2 
    int64 ASpeed_K1; // .    
    int32 ASpeed_K2; // .  1      Angl_fut
    int32 last_cikl; //  
    int32 P;  // Wcp / F0 -   
    int32 PdivQ;  // P / q -   ,   
    int32 Msht;  //  
} AnglFltr_s;

int32 Spec_mult (int32 sma, int32 kff);
void int_long_mult (int64 , int32 );
int32 int_sqrt1 (int64 );
int32 int_sin (int32 );
int32 int_cos (int32 );
int32 int_arcsin (int32, int32 );
void korr_fltr (InFLTR_s *filtr, int32 a);
int32 int_filter1 (int32 x, InFLTR_s *filtr);
void korr_angl_filter (int32 cycle);
void init_angl_filter (void);
void Reset_angl_filter (void);
void angl_filter (int32);
int32 Spec_int64_div (int64, int64);
int32 Spec_int_div (int32, int32);
void InFiltrInit (void);
int32 CalcFullAngle (int32 sinx, int32 cosx);
void Set_koef_angl_filter (int32 cycle);
extern AnglFltr_s SAngl;
extern int32 int_Angle_set;
extern int64 rez_mult;
#endif /* _FUNCTIONS_H_ */
