/*
 * MRAM_interface.c
 */

#define MRAM_INTERFACE_C_

#include <stdint.h>
#include <emif.h>
#include "MRAM_interface.h"
#include "Address_variable_data.h"

Uint32 Table_variable [112] = {
    0xFFFFFFFF,            // 0  .
    2000,                  // 1   
    528911478,             // 2     .
    2252,                  // 3      
    0xFFFFFFFF,            // 4  .
    0xFFFFFFFF,            // 5  .
    0xFFFFFFFF,            // 6  .
    0xFFFFFFFF,            // 7  .
    0xFFFFFFFF,            // 8  .
    0xFFFFFFFF,            // 9  .
    //adr_10
    0xFFFFFFFF,            // 10  .
    0xFFFFFFFF,            // 11  .
    0xFFFFFFFF,            // 12  .
    0xFFFFFFFF,            // 13  .
    0xFFFFFFFF,            // 14  .
    0xFFFFFFFF,            // 15  .
    0xFFFFFFFF,            // 16  .
    0xFFFFFFFF,            // 17  .
    0xFFFFFFFF,            // 18  .
    0xFFFFFFFF,            // 19  .
    //adr_20
    0xFFFFFFFF,            // 20  .
    0xFFFFFFFF,            // 21  .
    0xFFFFFFFF,            // 22  .
    0xFFFFFFFF,            // 23  .
    0xFFFFFFFF,            // 24  .
    0xFFFFFFFF,            // 25  .
    0xFFFFFFFF,            // 26  .
    0xFFFFFFFF,            // 27  .
    0xFFFFFFFF,            // 28  .
    0xFFFFFFFF,            // 29  .
    //adr_30
    0xFFFFFFFF,            // 30  .
    0xFFFFFFFF,            // 31  .
    0xFFFFFFFF,            // 32  .
    //    
    0,                     // 33   0  
    0,                     // 34 . .  0  
    139420237,             // 35  .
    0,                     // 36 .   
    0,                     // 37 . .  0     
    0,                     // 38 .      
    1368859,               // 39     

   //adr_40
    622770257,             // 40   (       )
    0xFFFFFFFF,            // 41  .
    1171270,               // 42     a0  
    9777563,               // 43  Wcp / F0 -     
    13827563,              // 44 P / q -   ,   
    16,                    // 45     
    0xFFFFFFFF,            // 46  ,
    0xFFFFFFFF,            // 47  ,
    0xFFFFFFFF,            // 48  ,
    0xFFFFFFFF,            // 49  ,

    //adr_50
    //      
    275000,                // 50 ,  -      
    365,                   // 51 ,         
    //      
    91000,                 // 52 ,  -      -
    40,                    // 53 ,         
    //   
    2200000,               // 54 ,   
    0xFFFFFFFF,            // 55  ,
    200000,                // 56    
    0xFFFFFFFF,            // 57  ,
    0xFFFFFFFF,            // 58  ,
    56295,                 // 59   ,   0,2

    //adr_60
    //  
    5000000,               // 60 ,  -   
    100,                   // 61 ,      
    1517813760,            // 62      (max 23160 *65536)
    32704,                 // 63     PWM (max 1022 *32)
    //   A
    1517813760,            // 64 ,      
    16000000,              // 65     (1%   ),
    21474836,              // 66    
    0x7EB851EB,            // 67    -  (0,99   ),
    0x19999999,            // 68    -  (0,2   ),
    0x06666666,            // 69      (0,05   )

    //adr_70
    //  
    2400000,               // 70 ,     
    60,                    // 71 ,      
    0xFFFFFFFF,            // 72  ,
    1517813760,            // 73     
    //   
    1517813760,            // 74 ,      
    0xFFFFFFFF,            // 75 ,     
    21474836,              // 76    
    0xFFFFFFFF,            // 77  ,
    0xFFFFFFFF,            // 78  ,
    0xFFFFFFFF,            // 79  ,

    //adr_80
    //  
    2443000,               // 80 ,     
    174,                   // 81 ,      
    0xFFFFFFFF,            // 82  ,
    0xFFFFFFFF,            // 83  ,
    //   
    1517813760,            // 84 ,      
    0xFFFFFFFF,            // 85  ,
    2928,                  // 86    
    0xFFFFFFFF,            // 87  ,
    0xFFFFFFFF,            // 88  ,
    0xFFFFFFFF,            // 89  ,

    //adr_90
    68442950,              // 90       
    6844295,               // 91     
    0xFFFFFFFF,            // 92  .
    10,                    // 93 N0   
    0x00010001,            // 94    = (nX+(nY<<16))
    586653813,             // 95       
    117330762,             // 96       
    6844295,               // 97    
    214748364,             // 98   
    0xFFFFFFFF,            // 99  ,

    //adr_100
    292817,               // 100      /  
    56220990,             // 101        / 
    29281,                // 102     /  ,
    3748066,              // 103      /  
    1599995904,           // 104   
    0xFFFFFFFF,           // 105  ,
    0xFFFFFFFF,           // 106  ,
    0xFFFFFFFF,           // 107  ,
    0xFFFFFFFF,           // 108  ,
    0xFFFFFFFF,           // 109  ,
    0xFFFFFFFF,           // 110  ,
    0xFFFFFFFF,           // 111  ,
};


void InitAddres(void)
{
    uint32  *p, i;
    for (i = 0; i < 112; i++)
    {
        if (table_address_variable[i] != 0xFFFFFFFF)
        {
            p = (uint32*)table_address_variable[i];
            *p = Table_variable[i];
        };
    };
    return;
}

