#define __SYSTEM_UNIT_C

#include <c6x.h>
#include <csl.h> /* CSL library */
#include <csl_legacy.h>
#include <csl_timer.h>
#include <csl_timerhal.h>

#include <Main.h>
#include <RAM.h>
#include "myTypes.h"
#include "TVG.h"
#include "Functions.h"
#include "System_output_information.h"
#include "Timers.h"
#include "Address_variable_data.h"
#include <main.h>


//  
Func_s Func;

//  
PLL_s PLL;
Kontur_s PLL_KK;

//  
Amp_s Amp;
Kontur_s Amp_KK;
PWMOut_s Amp_PWM;

//  
Quadr_s Quadr;
Kontur_s Quadr_KK;
PWMOut_s Quadr_PWM;

//   
Angl_s AnglS;
Kontur_s AnglS_KK;
PWMOut_s AnglS_PWM;

int32 Rdy_gisterezis; //0.1 * 2^31;    
int32 ReadyKoef; // Aready = 0,00554 (1 )
int32 OutLim = 0x5A5EE79A; // 23134,904696 * 65536     
int32 PWMLim = 0x7fc00000; // 32704     PWM (max 1022)

int32 Glob_Lim_R[6];
int32 Temp_koef_0;
int32 Temp_koef_0_board;
int32 Korrect_0;
int32 Temp_koef_masshtab;
int32 Temp_koef_masshtab_board;
int32 Korrect_masshtab;
int32 delta_Temp, delta_F;

int32 KonturProcess (Kontur_s *sys, int32 det);
void RdyReset (Kontur_s *sys);

////////////////////////////////////////////////////////////////////////////////
//   
//  ,  
//    
//    
//  
////////////////////////////////////////////////////////////////////////////////

void PreCalcFunction (void)
{
 /*   int32 tempA, i;
    int64 tmpl, tmpl2, tmpl3;

    //  
    if ((tvgIn.regINVERS & 0x0003) == 3)
    {
        tvgIn.Xs = -tvgIn.Xs;
        tvgIn.Xc = -tvgIn.Xc;
        tvgIn.Ys = -tvgIn.Ys;
        tvgIn.Yc = -tvgIn.Yc;
    };
    //   
    if ((PLL_KK.flags & 0x0001) != (PLL.LastFlags & 0x0001)) //  
    {
        if ((PLL_KK.flags & 0x0001) == 0x0001) {tempA = tvg.InFtrKoefTch;} else {tempA = tvg.InFtrKoefGr;};
        for (i=0; i<4; i++) {korr_fltr(&Func.FFX[i], tempA); };
        PLL.LastFlags = PLL_KK.flags;
    };

    //  Xs
    tempA = (tvgIn.Xs + Func.lastsmp[0]) / 2;
    Func.lastsmp[0] = tvgIn.Xs; //
    Func.FXs = int_filter1(tempA, &Func.FFX[0]);

    //  Xc
    tempA = (tvgIn.Xc + Func.lastsmp[1]) / 2;
    Func.lastsmp[1] = tvgIn.Xc; //
    Func.FXc = int_filter1(tempA,&Func.FFX[1]);

    //  Ys
    tempA = (tvgIn.Ys + Func.lastsmp[2]) / 2;
    Func.lastsmp[2] = tvgIn.Ys; //
    Func.FYs = int_filter1(tempA, &Func.FFX[2]);

    //  Yc
    tempA = (tvgIn.Yc + Func.lastsmp[3]) / 2;
    Func.lastsmp[3] = tvgIn.Yc; //
    Func.FYc = int_filter1(tempA, &Func.FFX[3]);

    //   
    Func.XY1 = (Func.FXs + Func.FYc) / 2;
    Func.XY2 = (Func.FYc - Func.FXs) / 2;
    Func.XY3 = (Func.FXc - Func.FYs) / 2;
    Func.XY4 = (Func.FXc + Func.FYs) / 2;

    tmpl = (int64) Func.XY1;
    tmpl *= tmpl;
    tmpl2 = (int64) Func.XY3;
    tmpl2 *= tmpl2;
    tmpl3 = (tmpl + tmpl2);
    Func.K5K = int_sqrt1(tmpl3); // (R + p)/2

    tmpl = (int64) Func.XY2;
    tmpl *= tmpl;
    tmpl2 = (int64) Func.XY4;
    tmpl2 *= tmpl2;
    tmpl = (tmpl + tmpl2);
    tmpl3 += tmpl;
    Func.K6K = int_sqrt1(tmpl); // (R - p)/2

    //    
    Func.R = Func.K5K + Func.K6K;
    Func.p = Func.K5K - Func.K6K;
    Func.Rp = int_sqrt1(tmpl3); // (R^2 + p^2)/4;
    Func.OutR = int_filter1 ( Func.R, &OutInfo.FiltrR );
    Func.OutP = int_filter1 ( Func.p, &OutInfo.FiltrQ );*/
    return;

}

////////////////////////////////////////////////////////////////////////////////
//   
//     ,  
//       
////////////////////////////////////////////////////////////////////////////////

void SecondCalcFunction (void)
{
    int32 tmpt, Bt; //, tmpt1, tmpt2;
    int64 tmps;

    //       
    Func.SApFi = Spec_int_div(Func.XY1, Func.K5K); // sin(2a+fi)
    Func.CApFi = Spec_int_div(Func.XY3, Func.K5K); // cos(2a+fi)
    Func.SAmFi = Spec_int_div(Func.XY2, Func.K6K); // sin(2a-fi)
    Func.CAmFi = Spec_int_div(Func.XY4, Func.K6K); // cos(2a-fi)

    //   
    Func.ApFi = CalcFullAngle(Func.SApFi, Func.CApFi);
    Func.AmFi = CalcFullAngle(Func.SAmFi, Func.CAmFi);
    Func.Angletmp = (Func.ApFi + Func.AmFi) / 2;
    tmpt = (Func.ApFi - Func.AmFi) / 2;

    if (tmpt > int_pi2)
    {
        tmpt -= int_pi;
        if (Func.Angletmp > 0)
        {
            Func.Angletmp -= int_pi;
        }
        else
        {
            Func.Angletmp += int_pi;
        };
    }
    else
    {
        if (tmpt < (-int_pi2))
        {
            tmpt += int_pi;
            if (Func.Angletmp > 0)
            {
                Func.Angletmp -= int_pi;
            }
            else
            {
                Func.Angletmp += int_pi;
            };

        };
    };
    Func.Angletmp = Func.Angletmp / 2;
    Func.Fitemp = tmpt;
    //  
    PLL.dPLLi = Spec_int_div(tmpt, int_pi2);

    Func.cycle = Func.Last_cycle;
    Func.Last_cycle = 4 + tvgOut.R1.Nx + tvgOut.R1.Ny;

    //    
    angl_filter(Func.Angletmp);

    Bt = SAngl.Angl_fut;
    if (Bt < 0) { Bt = - Bt; };
    if (Bt > int_pi4) { Bt -= int_pi4; };
    tmpt = int_sin (Bt);
    tmpt = Spec_mult (int_sqrt2_2, tmpt);
    if (tmpt > 0x3fffffff) {  tmpt = 0x3fffffff; };
    if (tmpt < 0xc0000000) {  tmpt = 0xc0000000; };
    Func.Ksn = tmpt << 1;
    tmpt = int_sin (int_pi4 - Bt);
    tmpt = Spec_mult (int_sqrt2_2, tmpt);
    if (tmpt > 0x3fffffff) {  tmpt = 0x3fffffff; };
    if (tmpt < 0xc0000000) {  tmpt = 0xc0000000; };
    Func.Kcs = tmpt << 1;

    Func.AnglFlag = Func.Last_AnglFlag;
    Func.Last_AnglFlag = AnglS_KK.flags;

    if ((Func.AnglFlag & 4) != (Func.Last_AnglFlag & 4))
    {
        if ((Func.AnglFlag & 4) != 0)
        {
            korr_angl_filter (OutInfo.cdus);
        }
        else
        {
            korr_angl_filter (-OutInfo.cdus);
        };
    };

    //   
    Func.F_outP = Func.Last_PLL;
    Func.Last_PLL = ( (tvgOut.PLL + 0xc8000000) >> 1 ) & 0x7fffffff; //    = * (62,5*10^6/8192*2^31)     ( 125*10^6)

    delta_Temp = tvg.Tpl - tvg.T0; //   
    delta_F = (Func.F_outP - 0x64000000) * 2 - tvg.f0; //     

    //     
    tmps = (int64) delta_F * (int64) tvg.Tkoef_SetAngl;
    tvg.SetAngl_temp = (int32) (tmps / Koef_popr) + tvg.SetAngl ; // .  

    //  Ny
    Func.Ny = Func.Last_Ny;
    Func.Last_Ny = tvgOut.R1.Ny;

    Func.Na = Func.Last_Na;
    Func.Last_Na = AnglS.Real_out;

    //    
    Calc_Cfee ();
    if ((Func.AnglFlag & 4) != 0)
    {
        Calc_CDUS (Func.Na);
    };
    //    else
    //    {
    //        OutInfo.cdus = 0;
    //    };

    //     
    tmpt = ( Tims.CiklFPGA * 256 ) / Func.cycle; //   * 256 ()
    //   
    if (tmpt > MaxPeriodTvg) tmpt = MaxPeriodTvg;
    if (tmpt < MinPeriodTvg) tmpt = MinPeriodTvg;
    Tims.Period = int_filter1( tmpt, &Tims.FiltrCikle);
    Tims.CiklFPGA = ( tmpt * Func.cycle ) >> 8; //    
    //  () * (); .. 1
    tmpt = Spec_mult (tmpt, Func.F_outP);
    //    ( / )   1,   256 
    tmps = ((uint64)MinPeriodTvg << 31) / tmpt;
    tmps = tmps - c2v31_1 - 1; //   1
    //       +-0,4%
    if (tmps > c2v31_1)
        tmps = c2v31_1;
    if (tmps < -c2v31_1)
        tmps = -c2v31_1;
    Tims.PoprFPGA = int_filter1( (int32)tmps, &Tims.FiltrPopr);
    tvg.DeltaMshT = Tims.PoprFPGA >> 8;
    return;
}
/*!
 *   - 
 */
/*!
 *      
 */
void PLL_Init (void)
{
    PLL.Kcg = 910000;//2500.0;//5000.0;// 
    PLL.Kfg = 4800;//7.0;//50.0;// 

    PLL.Kct = 4900;//91000.0;//5000.0;//100.0;
    PLL.Kft = 3;//40.0;//10.0;//2.0;

    PLL_KK.Lim = 2200000;

    PLL_KK.Ready_Lim = 0x0147ae14;// 0.01 * 2^31; PLL      = pi/2

    tvg.f00 = tvg.f0;

    return;
}

/*!
 *        
 */
void PLL_Reset (void)
{
    PLL_KK.flags = 0; //  ,   
    sysflag.pll_flags = PLL_KK.flags;

    PLL_KK.Kc = PLL.Kcg;
    PLL_KK.Kf = PLL.Kfg;

    RdyReset (&PLL_KK);

    PLL_KK.acc = 0;
    PLL_KK.out = 0;
    PLL_KK.accL = 0;
    PLL_KK.PpcL = 0;
    PLL_KK.PpcH = 0;
    PLL.out = 0;
    tvgOut.PLL = tvg.f00;
    return;
}

////////////////////////////////////////////////////////////////////////////////
//     ( )
////////////////////////////////////////////////////////////////////////////////
void PLL_Process (void)
{
    int32 i;
    //     
    PLL_KK.flags = sysflag.pll_flags;

    //  
    PLL.out = KonturProcess(&PLL_KK, PLL.dPLLi);

    //    /   
    if ((PLL_KK.Rdy < (PLL_KK.Ready_LimiL / 5))
            && ((PLL_KK.flags & 0x0001) == 0))
    {
        PLL_KK.flags |= 0x0001;
        PLL_KK.Kc = PLL.Kct;
        PLL_KK.Kf = PLL.Kft;
        PLL_KK.acc -= (int64)PLL.dPLLi * (int64)(PLL.Kct - PLL.Kcg); //  
        for (i = 0; i < 4; i++)  //  
        {
            korr_fltr(&Func.FFX[i], tvg.InFtrKoefTch);
        };
    };
    if ((PLL_KK.Rdy > (PLL_KK.Ready_LimiH * 3))
            && ((PLL_KK.flags & 0x0001) != 0))
    {
        PLL_KK.flags &= ~0x0001;
        PLL_KK.Kc = PLL.Kcg;
        PLL_KK.Kf = PLL.Kfg;
        PLL_KK.acc -= (int64)PLL.dPLLi * (int64)(PLL.Kcg - PLL.Kct); //  
        for (i = 0; i < 4; i++)  //  
        {
            korr_fltr(&Func.FFX[i], tvg.InFtrKoefGr);
        };
    };

    //   
    tvgOut.PLL = tvg.f00 + (PLL.out << 6); //* 64;
    //    
    sysflag.pll_flags = PLL_KK.flags;
    return;
}

////////////////////////////////////////////////////////////////////////////////
//  - 
////////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////////
//  - 
////////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////////
//      
////////////////////////////////////////////////////////////////////////////////
void Ampl_Init (void)
{
    Amp_KK.Kc = 4900;//91000.0;//5000.0;//100.0;
    Amp_KK.Kf = 3;//40.0;//10.0;//2.0;

    Amp_KK.Lim = OutLim;
    Amp.Level_Wave = 0x5f5e0000; // =1 599 995 904 = 24414 * 65536
    Amp.Lim_R[0] = 0x7EB851EB; // =0,99 * 2^31;
    Amp.Lim_R[1] = 0x19999999; // = 0.2  * 2^31;
    Amp.Lim_R[2] = 0x06666666; // = 0.05  * 2^31;
    Amp.Lim_R_gis = 42949673; //  = 0.02  * 2^31;

    Amp_KK.Ready_Lim = 0x0147ae14;// 0.01 * 2^31; Ampl      = 23160*2^31
    return;
}

////////////////////////////////////////////////////////////////////////////////
//        
////////////////////////////////////////////////////////////////////////////////
void Ampl_Reset (void)
{
    int32 tmpt, tmpt1;

    Amp_KK.flags = 0; //     ,  ,  
    sysflag.ampl_flag = Amp_KK.flags;

    tmpt = Spec_mult (Amp.Level_Wave, Amp.Lim_R_gis);
    tmpt1 = Spec_mult (Amp.Level_Wave, Amp.Lim_R[0]);
    Glob_Lim_R[0] = tmpt1 + tmpt;
    Glob_Lim_R[1] = tmpt1 - tmpt;
    tmpt1 = Spec_mult (Amp.Level_Wave, Amp.Lim_R[1]);
    Glob_Lim_R[2] = tmpt1 + tmpt;
    Glob_Lim_R[3] = tmpt1 - tmpt;
    tmpt1 = Spec_mult (Amp.Level_Wave, Amp.Lim_R[2]);
    Glob_Lim_R[4] = tmpt1 + tmpt;
    Glob_Lim_R[5] = tmpt1 - tmpt;

    RdyReset (&Amp_KK);

    Amp_KK.acc = 0;
    Amp_KK.out = 0;
    Amp_KK.accL = 0;
    Amp_KK.PpcL = 0;
    Amp_KK.PpcH = 0;
    Amp_PWM.Nxacc = 0;
    Amp_PWM.Nyacc = 0;
    Amp_PWM.Nx = 0;
    Amp_PWM.Ny = 0;
    Amp.out = 0;
    tvgOut.Nrx = 0;
    tvgOut.Nry = 0;
    return;
}

////////////////////////////////////////////////////////////////////////////////
//     ( )
////////////////////////////////////////////////////////////////////////////////
void Ampl_Process(void)
{

    //  
    Amp.dNRi = Spec_int_div ( (Amp.Level_Wave - Func.R), Amp.Level_Wave);

    //     
    Amp_KK.flags = sysflag.ampl_flag;

    //  
    Amp.out = KonturProcess(&Amp_KK, Amp.dNRi);

    //   
    Amp.Real_out = PWMOutProc(Amp.out, &Amp_PWM, SAngl.Angl_fut);

    if ((sysflag.ampl_flag & 0x0004) != 0)
    {
        tvgOut.Nrx = Amp_PWM.Nx;
        tvgOut.Nry = Amp_PWM.Ny;
    }
    else
    {
        tvgOut.Nrx = 0;
        tvgOut.Nry = 0;
        Amp.Real_out = 0;
    };
    //    
    sysflag.ampl_flag = Amp_KK.flags;
    return;
}

////////////////////////////////////////////////////////////////////////////////
//  - 
////////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////////
//  - 
////////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////////
//      
////////////////////////////////////////////////////////////////////////////////
void Quadr_Init (void)
{
    Quadr_KK.Kc = 4900;//91000.0;//5000.0;//100.0;
    Quadr_KK.Kf = 3;//40.0;//10.0;//2.0;

    Quadr_KK.Lim = OutLim;

    Quadr_KK.Ready_Lim = 0x0147ae14;// 0.01 * 2^31; Quadr      =  23160*2^31
    return;

}
////////////////////////////////////////////////////////////////////////////////
//        
////////////////////////////////////////////////////////////////////////////////
void Quadr_Reset (void)
{
    Quadr_KK.flags = 0; //     ,  ,  
    sysflag.quadr_flag = Quadr_KK.flags;

    RdyReset (&Quadr_KK);

    Quadr_KK.acc = 0;
    Quadr_KK.out = 0;
    Quadr_KK.accL = 0;
    Quadr_KK.PpcL = 0;
    Quadr_KK.PpcH = 0;
    Quadr_PWM.Nxacc = 0;
    Quadr_PWM.Nyacc = 0;
    Quadr_PWM.Nx = 0;
    Quadr_PWM.Ny = 0;
    tvgOut.Npx = 0;
    tvgOut.Npy = 0;
    return;
}

////////////////////////////////////////////////////////////////////////////////
//     ( )
////////////////////////////////////////////////////////////////////////////////
void Quadr_Process(void)
{

    //  
    Quadr.dNpi = Spec_int_div ( ( - Func.p), Amp.Level_Wave);

    //     
    Quadr_KK.flags = sysflag.quadr_flag;

    //  
    Quadr.out = KonturProcess(&Quadr_KK, Quadr.dNpi);

    //   
    Quadr.Real_out = PWMOutProc(Quadr.out, &Quadr_PWM, SAngl.Angl_fut );

    if ((sysflag.quadr_flag & 0x0004) != 0)
    {
        tvgOut.Npx = Quadr_PWM.Ny;
        tvgOut.Npy = - Quadr_PWM.Nx;
    }
    else
    {
        tvgOut.Npx = 0;
        tvgOut.Npy = 0;
        Quadr.Real_out = 0;
    };
    //    
    sysflag.quadr_flag = Quadr_KK.flags;
    return;
}

////////////////////////////////////////////////////////////////////////////////
//  - 
////////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////////
//  - 
////////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////////
//       
////////////////////////////////////////////////////////////////////////////////
void Angl_Init (void)
{
    AnglS_KK.Kc = 4900;//91000.0;//5000.0;//100.0;
    AnglS_KK.Kf = 3;//40.0;//10.0;//2.0;

    AnglS_KK.Lim = PWMLim;

    AnglS_KK.Ready_Lim = 0x0147ae14;// 0.01 * 2^31; AnglS      = pi/2
    return;

}
////////////////////////////////////////////////////////////////////////////////
//         
////////////////////////////////////////////////////////////////////////////////
void Angl_Reset (void)
{
    AnglS_KK.flags = 0; //    ,  ,  
    sysflag.angl_flag = AnglS_KK.flags;
    RdyReset (&AnglS_KK);
    //    tvg.SetAngl_temp = tvg.SetAngl;

    AnglS_KK.acc = 0;
    AnglS_KK.out = 0;
    AnglS_KK.accL = 0;
    AnglS_KK.PpcL = 0;
    AnglS_KK.PpcH = 0;
    AnglS_PWM.Nxacc = 0;
    AnglS_PWM.Nyacc = 0;
    AnglS_PWM.Nx = 0;
    AnglS_PWM.Ny = 0;
    tvgOut.NaPWM = 0;
    tvgOut.Nax = 0;
    tvgOut.Nay = 0;
    AnglS.Real_out = 0;
    return;
}

////////////////////////////////////////////////////////////////////////////////
//      ( )
////////////////////////////////////////////////////////////////////////////////
void Angl_Process(void)
{

    //  
    AnglS.dNai = Spec_int_div ( (tvg.SetAngl_temp - (Func.Angletmp >> 1)), int_pi2);

    //     
    AnglS_KK.flags = sysflag.angl_flag;

    //  
    AnglS.out = KonturProcess(&AnglS_KK, AnglS.dNai);

    //   
    AnglS.Real_out = PWMOutProc(AnglS.out, &AnglS_PWM, SAngl.Angl_fut );

    if ((sysflag.angl_flag & 0x0004) != 0)
    {
        tvgOut.Nax = - AnglS_PWM.Ny;
        tvgOut.Nay = AnglS_PWM.Nx;
        AnglS.Real_out = 0;
    }
    else
    {
        tvgOut.Nax = 0;
        tvgOut.Nay = 0;
        AnglS.Real_out = 0;
    };
    //    
    sysflag.angl_flag = AnglS_KK.flags;
    return;
}

////////////////////////////////////////////////////////////////////////////////
//   - 
////////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////////
//     
////////////////////////////////////////////////////////////////////////////////

int32 KonturProcess (Kontur_s *sys, int32 det)
{
    int64 tmp;
    int32 tmp0, tmp3;

    // 
    if (det < 0)
    {   tmp0 = -det;}
    else
    {   tmp0 = det;};
    //   1 
    tmp3 = int_filter1 ( tmp0, &(sys->RdyFlt) );
    if (((sys->flags & 0x0008) == 0) && (tmp3 < sys->Ready_LimiL))// 
    {   sys->flags |= 0x0008;};
    if (((sys->flags & 0x0008) == 0x0008) && (tmp3 > sys->Ready_LimiH)) // 
    {   sys->flags &= ~0x0008;}; //  
    sys->Rdy = tmp3;
    //    ()
    //
    tmp = ((int64)det) * ((int64)Func.Last_cycle);
    tmp = tmp * (int64)sys->Kf;
    if ((sys->flags & 0x0002) == 0)
    {   sys->acc += tmp;}
    else
    {   sys->acc = tmp;}; // 
    sys->out = (int32)(sys->acc >> 32);//high(tvgPLL.acc);

    //  .1
    tmp3 = sys->Lim;
    if (sys->out > tmp3)
    {   sys->acc = (int64)tmp3 * c2v32; sys->out = tmp3;};
    if (sys->out < -tmp3)
    {   sys->acc = -((int64)tmp3 * c2v32); sys->out = -tmp3;};
    sys->accL = (Uint32)(sys->acc & 0x00000000FFFFFFFF );

    // 
    tmp = ((int64)sys->Kc) * ((int64)det);
    sys->PpcL = (Uint32)(tmp & 0x00000000FFFFFFFF );
    sys->PpcH = (int32)(tmp >> 32);

    //
    tmp += sys->acc;
    tmp0 = (int32)(tmp >> 32);//high(tmp);

    //  .2
    if (tmp0 > tmp3) tmp0 = tmp3;
    if (tmp0 < -tmp3) tmp0 = - tmp3;

    return tmp0;
}

////////////////////////////////////////////////////////////////////////////////
//       
////////////////////////////////////////////////////////////////////////////////

void RdyReset (Kontur_s *sys)
{
    int32 tmp;

    tmp = Spec_mult (sys->Ready_Lim, Rdy_gisterezis);
    sys->Ready_LimiL = sys->Ready_Lim - tmp;
    sys->Ready_LimiH = sys->Ready_Lim + tmp;
    sys->RdyFlt.last_out = (int64)sys->Ready_Lim * 3;
    korr_fltr (&sys->RdyFlt, ReadyKoef);
    return;
}

////////////////////////////////////////////////////////////////////////////////
//     
////////////////////////////////////////////////////////////////////////////////
int32 PWMOutProc(int32 Nx, PWMOut_s *sysp, int32 ang_raz)
{
    int32 Nix, Niy, anglx, snx, sny, NPWM, Nrez ;
    int64 tmps;

    NPWM = Nx;
    //  
    if (NPWM > OutLim) { NPWM = OutLim;  };
    if (NPWM < (- OutLim) ) { NPWM = - OutLim; };

    //  
    anglx = ang_raz;
    if (anglx > int_pi2) { anglx -= int_pi; };
    if (anglx < -(int_pi2)) { anglx += int_pi; };

    //  
    if (anglx >= 0)
    {
        if (anglx < int_pi4 )
        {
            snx = Func.Kcs;
            sny = Func.Ksn;
        }
        else
        {
            snx = - Func.Ksn;
            sny = Func.Kcs;
        };
    }
    else
    {
        if (anglx > - int_pi4 )
        {
            snx = Func.Kcs;
            sny = - Func.Ksn;
        }
        else
        {
            snx = - Func.Ksn;
            sny = - Func.Kcs;
        };
    };
    //  X  Y
    Nix = Spec_mult (NPWM, snx);
    Niy = Spec_mult (NPWM, sny);
    sysp->RazXY = ((snx >> 16) & 0x0000FFFF) | (sny & 0xFFFF0000);

    NPWM = tvg.PWM_korr << 21;
    //    X
    snx = int_arcsin (Nix, 64);
    tmps = (int_kpwm * (int64)snx) >> 24;

    //     X
    tmps += (int64)sysp->Nxacc;
    if (tmps > (int64)PWMLim) { tmps = (int64)PWMLim; };
    snx = (int32)tmps;
    Nix = snx & 0xFFE00000;
    if ( (Nix > 0) && ( Nix < NPWM) || (Nix < 0) && ( Nix > -NPWM) )
    {
        Nix = 0;
    };
    sysp->Nxacc = snx - Nix;
    sysp->Nx = (int16)(Nix >> 16);

    //    Y
    sny = int_arcsin (Niy, 64);
    tmps = (int_kpwm * (int64)sny) >> 24;

    //     Y
    tmps += (int64)sysp->Nyacc;
    if (tmps > (int64)PWMLim) { tmps = (int64)PWMLim; };
    sny = (int32)tmps;
    Niy = sny & 0xFFE00000;
    if ( (Niy > 0) && ( Niy < NPWM) || (Niy < 0) && ( Niy > -NPWM) )
    {
        Niy = 0;
    };
    sysp->Nyacc = sny - Niy;
    sysp->Ny = (int16)(Niy >> 16);

    //  
    sysp->sumXY = ( (Nix >> 16) & 0x0000FFE0) | Niy;

    //     
    NPWM = (int32)(int_kpwm >> 1);
    Nix = Spec_int_div ((Nix >> 1), NPWM);
    Niy = Spec_int_div ((Niy >> 1), NPWM);
    snx = int_sin (Nix >> 7);
    sny = int_sin (Niy >> 7);;
    tmps = (int64)snx * (int64)sny;
    tmps = tmps * (int64)int_sqrt2_2;
    tmps = tmps * 2 + (int64)snx * (int64)snx;
    tmps = tmps + (int64)sny * (int64)sny;
    Nrez = int_sqrt1 (tmps );
    if (Nx < 0) { Nrez = - Nrez; };
    return Nrez;
}
////////////////////////////////////////////////////////////////////////////////
//    
////////////////////////////////////////////////////////////////////////////////
void OutInfoInit(void)
{
    int i;
    OutInfo.cfree = 0;
    OutInfo.cdus = 0;
    OutInfo.csovm = 0;
    OutInfo.acsel = 0;
    OutInfo.FiltrOut.last_out = 0;
    OutInfo.FiltrR.last_out = 0;
    OutInfo.FiltrQ.last_out = 0;
    korr_fltr (&OutInfo.FiltrOut, OutInfo.OutFiltrKoef);
    korr_fltr (&OutInfo.FiltrR, OutInfo.RQFiltrKoef);
    korr_fltr (&OutInfo.FiltrQ, OutInfo.RQFiltrKoef);
    for (i=0; i<16; i++)
    {
        OutInfo.VarAdr[i] = 0xff;
        OutInfo.VarTipe[i] = 0xff;
        Buf0.variables[i] = 0;
        Buf1.variables[i] = 0;
    };
    sysflag.en_var = 0;

    memcpy (&Buf0.outflag, (void *)&sysflag, 4);
    Buf0.outsumangl = 0;
    Buf0.outspeed = 0;
    Buf0.outtime = 0;
    Buf0.outdeltatime = 0;
    Buf0.outfreq = (int32) Tims.FiltrCikle.last_out;
    Buf0.outampl = 0;
    Buf0.outquad = 0;
    Buf0.outangl = tvg.SetAngl;

    memcpy (&Buf1.outflag, (void *) &sysflag, 4);
    Buf1.outsumangl = 0;
    Buf1.outspeed = 0;
    Buf1.outtime = 0;
    Buf1.outdeltatime = 0;
    Buf1.outfreq = (int32) Tims.FiltrCikle.last_out;
    Buf1.outampl = 0;
    Buf1.outquad = 0;
    Buf1.outangl = tvg.SetAngl;

    return;
}
////////////////////////////////////////////////////////////////////////////////
//    
////////////////////////////////////////////////////////////////////////////////
void SetOutBuf (int32 csum)
{
    OutInfoVPI_s *Bf_now; //, *Bf_last;
    int64 tmps;
    Uint32 gie;
    int32 tmpt1, i, *p;
    uint8 tm;

    //  
    if (Program_Flag.VPI_Buf_flag == 0)
    {
        Bf_now = &Buf1;
        //        Bf_last = &Buf0;
    }
    else
    {
        Bf_now = &Buf0;
        //       Bf_last = &Buf1;
    };

    //     .    
    tmpt1 = Spec_mult (csum, Tims.PoprFPGA) >> 8;
    OutInfo.csovm = csum + tmpt1; //    
    Bf_now->outspeed = int_filter1 ( OutInfo.csovm, &OutInfo.FiltrOut ); //  
    if (sysflag.functional_ready == 0)  { Bf_now->outspeed = 0; };
    //  
    Bf_now->outfreq = Tims.Period; //    (   . (35), *256
    Bf_now->outampl = Func.OutR;
    Bf_now->outquad = Func.OutP;
    Bf_now->outangl = SAngl.Angl_filt;
    //    
    OutInfo.deltaTim =  Tims.Period * Func.cycle; // . 
    tmps = OutInfo.SumTimLong + (uint64)OutInfo.deltaTim;
    //   
    if (tmps >= (c2v32 << 8) )
    {
        tmps -=  c2v32 << 8;
        sysflag.time_out_of_range = 1;
    }
    else
    {
        sysflag.time_out_of_range = 0;
    };
    OutInfo.SumTimLong = tmps;
    OutInfo.SumTim = (Uint32)( tmps >> 8 );
    Bf_now->outtime = OutInfo.SumTim; //  

    //     
    tmpt1 = Spec_mult (OutInfo.deltaTim, Bf_now->outspeed); //.    
    OutInfo.deltaAngl = Spec_mult (tmpt1, AnglMsht); //    
    tmps = (int64)OutInfo.SumAngl + (int64)OutInfo.deltaAngl; //     
    //   
    if (tmps > c2v31_1)
    {
        tmps -=  c2v31_1;
        sysflag.angle_out_of_range = 1;
    }
    else
    {
        if (tmps < -c2v31_1)
        {
            tmps +=  c2v31_1;
            sysflag.angle_out_of_range = 1;
        }
        else
        {
            sysflag.angle_out_of_range = 0;
        };
    };
    OutInfo.SumAngl = (int32)tmps; //   
    if (sysflag.functional_ready == 0)  { OutInfo.SumAngl = 0; };
    Bf_now->outsumangl = OutInfo.SumAngl; //   

    //  
    tmpt1 = 0; //   
    for (i=0; i<16; i++)
    {
        tm = OutInfo.VarAdr[i];
        if ( (tm != 0xff) && (table_address_variable[tm] != 0xffffffff) )
        {
            p = (int32 *)table_address_variable [tm];
            Bf_now->variables[i] = *p;
            OutInfo.VarTipe[i] = table_type_variable[tm];
            tmpt1++;
        }
        else
        {
            Bf_now->variables[i] = 0;
            OutInfo.VarTipe[i] = 0xff;
        };
    };

    if (tmpt1 > 0)
    {
        sysflag.en_var = 1;
    }
    else
    {
        sysflag.en_var = 0;
    };

    memcpy(&Bf_now->outflag, (void *)&sysflag, 4);

    //   
    gie = IRQ_globalDisable();
    if (Program_Flag.VPI_Buf_flag == 0)
    {
        Program_Flag.VPI_Buf_flag = 1;
    }
    else
    {
        Program_Flag.VPI_Buf_flag = 0;
    };
    IRQ_globalRestore(gie);

    return;
}

////////////////////////////////////////////////////////////////////////////////
//    
////////////////////////////////////////////////////////////////////////////////
int32 Calc_CDUS (int32 NA1)
{
    int32 tmpt, tmpt1, tmpt2;
    int64 tmps;

    //     
    tmpt = Spec_int_div((int32)Func.Ny, (int32)Func.cycle);
    tmpt1 = Spec_mult(NA1, tmpt);
    //  
    tmps = (int64) delta_Temp * (int64) Temp_koef_masshtab_board
            + (int64) delta_F * (int64) Temp_koef_masshtab;
    tmpt2 = (int32)(tmps / Koef_popr) + Korrect_masshtab; // .  
    tmps = ((int64) tmpt1 << 31) / (int64) tvg.BruinKoef; //   . 
    int_long_mult(tmps, tmpt2);  //   
    tmps = (int64) delta_Temp * (int64) Temp_koef_0_board
            + (int64) delta_F * (int64) Temp_koef_0;
    rez_mult = (tmps / Koef_popr) + (int64) Korrect_0 + rez_mult; //  . 
    //   
    if (rez_mult > c2v31_1)
        rez_mult = c2v31_1;
    if (rez_mult < -c2v31_1)
        rez_mult = -c2v31_1;
    //     (, , 1/)
    tmpt1 = (int32) rez_mult;
    return tmpt1;
}
////////////////////////////////////////////////////////////////////////////////
//     
////////////////////////////////////////////////////////////////////////////////
void Calc_Cfee (void)
{
    int64 tmps;
    //    ()
    int_long_mult ( SAngl.Angl_sp_out, Func.F_outP );
    if (rez_mult > c2v31_1)
        rez_mult = c2v31_1;
    if (rez_mult < -c2v31_1)
        rez_mult = -c2v31_1;
    Func.Speed_outP = (int32)rez_mult; //      

    tmps = (rez_mult << 31) / (int64)tvg.BruinKoef;
    if (tmps > c2v31_1)
        tmps = c2v31_1;
    if (tmps < -c2v31_1)
        tmps = -c2v31_1;
    //   (. , , 1/)
    OutInfo.cfree = -( (int32)tmps);

    //     
    tmps = tvg.Speed_Korrekt * int_sin( (SAngl.Angl_fut - tvg.SetAngl_temp) * 4);
    OutInfo.cfree = OutInfo.cfree + (int32)( tmps >> 31);
    return;
}
////////////////////////////////////////////////////////////////////////////////

