#ifndef _SYSTEM_UNIT_H_
#define _SYSTEM_UNIT_H_

#include <Main.h>
#include <RAM.h>
#include "myTypes.h"
#include "TVG.h"
#include "Functions.h"

#define Per_To_Freq 119837257 //    .   
#define int_kpwm 0x00000000A2F9836E // 41721,513402 * 65536
#define Koef_popr 0x000186A0 // = 100000  .   
#define MinPeriodTvg 1174405 // = 8192*35*256/62,5     ()
#define MaxPeriodTvg 1503238 // = (2^32)*8192*35**256/62,5*(0xc800 0000)     ()
#define AnglMsht 197745696 //      0,00025"
//3355443200 =0xC800 0000
typedef struct //  
{
    Uint16 flags;
    // 0  - /  
    // 1  -   
    // 2  -    
    // 3  -  
    Uint16 LastFlags;
    int32 Kc; // K1,  
    int32 Kf; // K2, 
    int32 Lim;
    int32 Ready_Lim; // 
    int32 Ready_LimiL;
    int32 Ready_LimiH;
    int32 Rdy;
    int64 acc;//
    Uint32 accL;//
    int32 out;
    Uint32 PpcL;//
    int32 PpcH;
    InFLTR_s RdyFlt;
} Kontur_s;

typedef struct//  
{
    int32 Kcg; // Ki,  
    int32 Kfg; // K2,  
    int32 Kct; // Ki,  
    int32 Kft; // K2,  
    int32 dPLLi; //  
    int32 out;//   
    uint32 LastFlags;
}   PLL_s;

typedef struct//  
{
    int32 Lim_R[3]; // = {Level_Wave * 0.99, Level_Wave * 0.2, Level_Wave * 0.06};   
    int32 Lim_R_gis; // = Level_Wave * 0.02 -    
    int32 Level_Wave; // = 1600000000;
    int32 dNRi; //  
    int32 out;//   
    int32 Real_out;//   
}   Amp_s;

typedef struct//  
{
    int32 dNpi; //  
    int32 out;//   
    int32 Real_out;//   
}   Quadr_s;

typedef struct angl//  
{
    int32 dNai; //  
    int32 out; //   
    int32 Real_out;//   
}   Angl_s;

typedef struct//  
{
    int16 Nx, Ny;
    int32 Nxacc, Nyacc;
    int32 sumXY;
    int32 RazXY;
}   PWMOut_s;

typedef struct//  
{
//   
    int32 lastsmp[4];
    InFLTR_s FFX[4];
    int32 FXs;
    int32 FXc;
    int32 FYs;
    int32 FYc;
    int32 XY1;
    int32 XY2;
    int32 XY3;
    int32 XY4;
    int32 K5K;
    int32 K6K;
    int32 R;
    int32 p;
    int32 Rp;
    int32 SApFi;
    int32 CApFi;
    int32 SAmFi;
    int32 CAmFi;
    int32 ApFi;
    int32 AmFi;
    int32 Angletmp;
    int32 Fitemp;
    int32 OutR;
    int32 OutP;
    int32 Speed_outP;
    int32 Last_PLL;
    int32 F_outP;
    int16 Last_cycle;
    int16 cycle;
    int32 Last_Na;
    int32 Na;
    int32 Last_AnglFlag;
    int32 AnglFlag;
    int32 Nax;
    int32 Nay;
    int32 Ksn;
    int32 Kcs;
    int32 SetKsn;
    int32 SetKcs;
   int16 Last_Ny;
    int16 Ny;
} Func_s;

void PreCalcFunction (void);
void SecondCalcFunction (void);
void SetOutBuf (int32 csovm);

int32 PWMOutProc(int32 Nx, PWMOut_s *sysp, int32 ang_raz);
void OutInfoInit(void);
void SetOutBuf (int32 csovm);
int32 Calc_CDUS (int32 NA1);
void Calc_Cfee (void);

void PLL_Init (void);
void PLL_Reset (void);
void PLL_Process (void);

void Ampl_Init (void);
void Ampl_Reset (void);
void Ampl_Process (void);

void Quadr_Init (void);
void Quadr_Reset (void);
void Quadr_Process (void);

void Angl_Init (void);
void Angl_Reset (void);
void Angl_Process (void);

extern int32 Rdy_gisterezis; //0.1 * 2^31;    
extern int32 ReadyKoef; // Aready = 0,00554 (1 )
extern int32 OutLim; // 23160 * 65536     
extern int32 PWMLim; // 32704     PWM (max 1022)

extern int32 Glob_Lim_R[6];
extern int32 Temp_koef_0;
extern int32 Temp_koef_0_board;
extern int32 Korrect_0;
extern int32 Temp_koef_masshtab;
extern int32 Temp_koef_masshtab_board;
extern int32 Korrect_masshtab;

extern int32 delta_Temp, delta_F;

extern Func_s Func;

//  
extern PLL_s PLL;
extern Kontur_s PLL_KK;

//  
extern Amp_s Amp;
extern Kontur_s Amp_KK;
extern PWMOut_s Amp_PWM;

//  
extern Quadr_s Quadr;
extern Kontur_s Quadr_KK;
extern PWMOut_s Quadr_PWM;

//   
extern Angl_s AnglS;
extern Kontur_s AnglS_KK;
extern PWMOut_s AnglS_PWM;


#endif /* SOURCE_SYSTEM_UNIT_H_ */
