#define __TVG__C

#include <Main.h>
#include <RAM.h>
#include "myTypes.h"
#include "TVG.h"
#include "Main.h"
#include "System_unit.h"
#include "Functions.h"
#include <Timers.h>
#include <MRAM_interface.h>
#include "FPGA_interface.h"

int32 FCount;
uint32 TCount;
uint32 SearchDeltaF;
//   		
tvg_s tvg;

//   

int16 TermCount = 0;

//  
OutInfo_s OutInfo;
OutInfoVPI_s Buf0, Buf1;//

int32 d_angl, abs_angl;
int32 csum;
//Uint16 tvgTimerCnt = 0;

void tvgGetFreqInit (void);
void tvgStartingInit (void);
void tvgRazgonInit (void);
void tvgStabilizationInit (void);
void tvgFreeWaveInit (void);
void tvgAngleReturnInit (void);
void tvgBreakingInit (void);

void tvgInit ( void )
{
    //    
	tvg.StopCnt = 0; //    
	tvg.ControlMode = cntrWork;
	tvg.directPWM = 0x00010001;
    tvg.R1.Nx = tvg.directPWM & 0x00000007;
    tvg.R1.Ny = (tvg.directPWM >> 16) & 0x00000007;
    Func.Last_cycle = 4 + tvg.R1.Nx + tvg.R1.Ny;
    Func.cycle = Func.Last_cycle;
    Func.Last_Na = 0;
    Func.Na = 0;
    Func.Last_Ny = tvg.R1.Ny;
    Func.Ny = Func.Last_Ny;
    tvg.R1.Off = 0;
    tvg.R1.Off_angle_PWM = 0;
    tvg.R1.Off_korrect_PWM = 0;
    tvg.R1.Off_kvadr_PWM = 0;
    tvg.R1.inc_PLL = 0;
    tvg.R1.none1 = 0;
    tvg.R1.short_FD = 0;
    tvg.R1.simul_DATA = 0;
    tvg.R1.test_razgona = 0;
	tvg.InFtrKoefGr = 586653813; // 50   6900   6 (0,27)
	tvg.InFtrKoefTch = 117330762;  // 10   6900   6 (0,05)
	tvg.Ttvg = 2000;        //  , C * 100 (+2000 = 20C)
	tvg.Tpl = 2000;      //  , C * 100 (+2000 = 20C)
	tvg.T0 = 2000;      //  , C * 100 (+2000 = 20C)
	tvg.f0 = 528911478;  //      6900,    (,   0xc800 0000)
	tvg.Kf0 = 2252;  //       ,     0,01C
	delta_Temp = 0;
	delta_F = 0;
	tvg.DeltaMshT = 0; //    
	tvg.TimFiltrKoef = 1368859; // .         0,1 
	tvg.BruinKoef = 622770257; //   (       )
	tvg.Tkoef_SetAngl = 0;
	tvg.Speed_Korrekt = 0;
	tvg.SetAngl = 1171270; // 4 ..
    tvg.Angl_gr = 292817;      //     /   1.
    tvg.W_gr = 56220990;      //       /  1,5 ./
    tvg.Angl_gis = 29281;   //   /     360 .
    tvg.W_gis = 3748066;            //   /      100 ./
    tvg.PWM_korr = 10; //     
	OutLim = 0x5A5EE79A; // 23134,904696 * 65536     
	PWMLim = 0x7fc00000; // 32704 = 1022 * 32     PWM (max 1022)
	ReadyKoef = 6844295;
	Rdy_gisterezis = 214748364;
	Korrect_masshtab =139420237;  // = 0,0649226   
	Korrect_0 = 0; //   
	Temp_koef_masshtab = 0; //         ()
	Temp_koef_masshtab_board = 0;  //        
	Temp_koef_0 = 0; //         ()
	Temp_koef_0_board = 0;  //        
	OutInfo.OutFiltrKoef = 6844295; //     ( 6900 =6  0,5)
	OutInfo.RQFiltrKoef = 68442950; //      ( 6900 =6  5)
	OutInfo.FiltrOut.last_out = 0;
	OutInfo.FiltrR.last_out = 0;
	OutInfo.FiltrQ.last_out = 0;
	SearchDeltaF = 56295; //   ,   0,2
	PLL_Init();
	Ampl_Init();
	Quadr_Init();
	Angl_Init();

    //   MRAM
	InitAddres();
	//         

    tvg.R1.Nx = tvg.directPWM & 0x00000007;
    tvg.R1.Ny = (tvg.directPWM >> 16) & 0x00000007;
    Func.Last_cycle = 4 + tvg.R1.Nx + tvg.R1.Ny;
    Func.cycle = Func.Last_cycle;
    Func.Last_Na = 0;
    Func.Na = 0;
    Func.Last_Ny = tvg.R1.Ny;
    Func.Ny = Func.Last_Ny;

    InFiltrInit();
    init_angl_filter ();
    tvg.f00 = tvg.f0;  //     ,    (,   0xc800 0000)
    Func.F_outP = ((tvg.f0 >> 1) & 0x7fffffff) + 0x64000000;
    Func.Last_PLL = Func.F_outP;
    Tims.FiltrCikle.last_out = ((uint64)MinPeriodTvg << 31) / Func.F_outP; //   
    Tims.Period = (int32)Tims.FiltrCikle.last_out;
    korr_fltr (&Tims.FiltrCikle, tvg.TimFiltrKoef); //
    Tims.FiltrPopr.last_out = 0; //   
    korr_fltr (&Tims.FiltrPopr, tvg.TimFiltrKoef); //

    tvg.WorkState = twsStop;
    tvgStopInit ();
   // RegistrInit();
/*
    PLL_Reset ();
    Ampl_Reset ();
    Quadr_Reset();
    Angl_Reset();
    Reset_angl_filter ();

    sysflag.ampl_stabilised = 0;
    sysflag.big_speed = 0;
    sysflag.big_angle = 0;
    sysflag.mode_TVG = 0;
    sysflag.functional_ready = 0;
    sysflag.accuracy_ready = 0;
    sysflag.mode_tecnology = 0;
    sysflag.time_out_of_range = 0;
    sysflag.angle_out_of_range = 0;
    sysflag.error_out_of_range = 0;
    sysflag.en_var = 0;
    sysflag.mode_abonent = 0;
*/

    Program_Flag.flagISRPLIS = 0;
    Program_Flag.flagTochGot = 0;
    Program_Flag.flagVPICom = 0;
    Program_Flag.ChangeCikl = 0;
    Program_Flag.ChangePLLflag = 0;
    //TODO Program_Flag.TempReady = 0;

 	if(tvg.PWM_korr > 40) { tvg.PWM_korr = 40; };
    if(tvg.PWM_korr < 0) { tvg.PWM_korr = 0; };
    return;
}


////////////////////////////////////////////////////////////////////////////////
//       f = func(tvg.Ttvg)
////////////////////////////////////////////////////////////////////////////////
Uint32 tvgGetF0 (void)
{
    return (tvg.f0 + (tvg.Ttvg - tvg.T0) * tvg.Kf0);
   // return 0;
}

////////////////////////////////////////////////////////////////////////////////
//     (  ,  Breaking )
////////////////////////////////////////////////////////////////////////////////
void tvgStopInit (void)
{
	tvgOut.Nrx = 0; tvgOut.Nry = 0;
	tvgOut.Npx = 0; tvgOut.Npy = 0;
	tvgOut.Nax = 0; tvgOut.Nay = 0;
	tvgOut.NaPWM = 0;
    tvgOut.NrPWM = 0;
    tvgOut.NpPWM = 0;
    sysflag.pll_flags = 0;
    sysflag.ampl_flag = 0;
    sysflag.quadr_flag = 0;
    sysflag.angl_flag = 0;
    sysflag.ampl_stabilised = 0;
    sysflag.big_speed = 0;
    sysflag.big_angle = 0;
    sysflag.mode_TVG = 0;
    sysflag.functional_ready = 0;
    sysflag.accuracy_ready = 0;
    sysflag.mode_tecnology = 0;
    sysflag.time_out_of_range = 0;
    sysflag.angle_out_of_range = 0;
    sysflag.en_var = 0;
    PLL_Reset ();
    Ampl_Reset ();
    Quadr_Reset();
    Angl_Reset();
    Reset_angl_filter ();
    OutInfoInit();
    write_FPGA_data (&tvgOut);
    TCount = HTime + 20;
    tvg.StopCnt = 0;
    FCount = 0;
    return;
}

////////////////////////////////////////////////////////////////////////////////
//      ( )
////////////////////////////////////////////////////////////////////////////////
void tvgSetState(void)
{
    return;
}

////////////////////////////////////////////////////////////////////////////////
//      ( )  0
////////////////////////////////////////////////////////////////////////////////
void tvgStopProcess (void)
{
    // 2     (    1      )
    //    Stop
    if ( (HTime > TCount) && ((HTime - TCount) < 0x7fffffff) )
    {
        tvg.f00 = tvg.f0;
        tvg.WorkState = twsGetFreq; //   ;      tvg.f0
        tvgGetFreqInit ();
    };
    tvg.StopCnt++;
    //   2 ,    
	if (tvg.StopCnt > 20) // 20      
	{
		if (VPI_flag.TempReady != 0) //     2 
		{
		    tvg.f00 = tvgGetF0 (); //   
		}
		else
		{
	        tvg.f00 = tvg.f0;
		};
        tvgOut.PLL = tvg.f00;
        if (sysflag.ampl_stabilised == 0)
        {
            if (Func.Rp > Glob_Lim_R[4]) //    ( )
            {
                FCount = 0;
                sysflag.ampl_stabilised = 1;
                PLL_Reset ();
            }
            else
            {
                FCount++;
                if ( (FCount > 40) && (VPI_flag.TempReady != 0) ) //  40   
                {
                    tvg.WorkState = twsGetFreq; //   ;      tvg.f0
                    tvgGetFreqInit ();
                };
            };
        }
        else
        {
            FCount++;
            if (Func.Rp < Glob_Lim_R[5]) //    ( )
            {
                FCount = 0;
                sysflag.ampl_stabilised = 0; //     
            }
            else
            {
                SecondCalcFunction(); //    
                PLL_Process ();
                if ( (FCount > 40) && (VPI_flag.TempReady != 0) ) //  40   
                {
                    tvg.WorkState = twsStarting; //     PLL
                    tvgStartingInit ();
                };
            };
        };
	};
    write_FPGA_data (&tvgOut);
	return;
}

////////////////////////////////////////////////////////////////////////////////
//     1
////////////////////////////////////////////////////////////////////////////////
void tvgGetFreqInit (void)
{
    int32 tmpt, Bt;

    tvg.R1.Nx = 7; tvg.R1.Ny = 1; tvg.R1.Off = 0;
    tvgOut.R1 = tvg.R1;
    tvg.StopCnt = 0;
    sysflag.ampl_flag = 4;
    Bt = tvg.SetAngl_temp;
    if (Bt < 0) { Bt = - Bt; };
    if (Bt > int_pi4) { Bt -= int_pi4; };
    tmpt = int_sin (Bt);
    tmpt = Spec_mult (int_sqrt2_2, tmpt);
    if (tmpt > 0x3fffffff) {  tmpt = 0x3fffffff; };
    if (tmpt < 0xc0000000) {  tmpt = 0xc0000000; };
    Func.Ksn = tmpt << 1;
    tmpt = int_sin (int_pi4 - Bt);
    tmpt = Spec_mult (int_sqrt2_2, tmpt);
    if (tmpt > 0x3fffffff) {  tmpt = 0x3fffffff; };
    if (tmpt < 0xc0000000) {  tmpt = 0xc0000000; };
    Func.Kcs = tmpt << 1;
    Func.SetKsn = Func.Ksn;
    Func.SetKcs = Func.Kcs;
    Amp.Real_out = PWMOutProc(OutLim, &Amp_PWM, tvg.SetAngl_temp );
    tvgOut.Nrx = Amp_PWM.Nx;
    tvgOut.Nry = Amp_PWM.Ny;
    tvgOut.Npx = 0;
    tvgOut.Npy = 0;
    tvgOut.Nax = 0;
    tvgOut.Nay = 0;
    tvgOut.NaPWM = 0;
    tvgOut.NrPWM = 0;
    tvgOut.NpPWM = 0;
    tvgOut.PLL = tvg.f00;
    FCount = 0;
    TCount = HTime + 20;
    return;
}

void tvgGetFreqProcess (void)
{

    if (Func.Rp > Glob_Lim_R[4])
    {
        tvg.StopCnt++;
        SecondCalcFunction();
        Func.Ksn = Func.SetKsn;
        Func.Kcs = Func.SetKcs;
        Amp.Real_out = PWMOutProc(OutLim, &Amp_PWM, tvg.SetAngl_temp );
        tvgOut.Nrx = Amp_PWM.Nx;
        tvgOut.Nry = Amp_PWM.Ny;
        PLL_Process ();
        write_FPGA_data (&tvgOut);
        if (tvg.StopCnt > 40)
        {
            tvg.f00 = tvg.f00 + FCount * SearchDeltaF;
            tvg.WorkState = twsStarting;
            tvgStartingInit ();
        };
    }
    else
    {
        if (VPI_flag.TempReady != 0)
        {
            tvg.f00 = tvgGetF0 ();
        };
        tvg.StopCnt = 0;
        tvgOut.PLL = tvg.f00 + FCount * SearchDeltaF;
        write_FPGA_data (&tvgOut);
        if ( (HTime >= TCount) && ((HTime - TCount) < 0x7fffffff) )
        {
            TCount = HTime + 20;
            if (FCount <= 0)
            {
                FCount = - FCount + 1;
            }
            else
            {
                FCount = - FCount;
            };
            if (FCount > 50) { FCount = 0; };
        };
    };
    return;
}
////////////////////////////////////////////////////////////////////////////////
//   2
////////////////////////////////////////////////////////////////////////////////
void tvgStartingInit (void)
{
    tvg.R1.Nx = 7; tvg.R1.Ny = 1; tvg.R1.Off = 0;
    tvgOut.R1 = tvg.R1;
    tvg.StopCnt = 0;
    sysflag.ampl_flag = 4;
    Amp.Real_out = PWMOutProc(OutLim, &Amp_PWM, SAngl.Angl_fut);
    tvgOut.Nrx = Amp_PWM.Nx;
    tvgOut.Nry = Amp_PWM.Ny;
    tvgOut.Npx = 0;
    tvgOut.Npy = 0;
    tvgOut.Nax = 0;
    tvgOut.Nay = 0;
    tvgOut.NaPWM = 0;
    tvgOut.NrPWM = 0;
    tvgOut.NpPWM = 0;
    TCount = HTime + 50;
    return;
}

void tvgStartingProcess (void)
{
    int32 i;
    SecondCalcFunction();
    PLL_Process ();
    Amp.Real_out = PWMOutProc(OutLim, &Amp_PWM, SAngl.Angl_fut);
    tvgOut.Nrx = Amp_PWM.Nx;
    tvgOut.Nry = Amp_PWM.Ny;
    write_FPGA_data (&tvgOut);

    if ( (Func.Rp > Glob_Lim_R[4] + 0x01900000) && (PLL_KK.Rdy < (PLL_KK.Ready_LimiL * 2) ) && ( (PLL_KK.flags & 0x0001) == 0 ) )
    {
        PLL_KK.flags |= 0x0001; //  PLL    
        sysflag.pll_flags = PLL_KK.flags;
        PLL_KK.Kc = PLL.Kct;
        PLL_KK.Kf = PLL.Kft;
        PLL_KK.acc -= (int64)PLL.dPLLi * (int64)(PLL.Kct - PLL.Kcg); //  
        for (i = 0; i < 4; i++)  //  
        {
            korr_fltr(&Func.FFX[i], tvg.InFtrKoefTch);
        };
    };
    if ( (PLL_KK.Rdy > PLL_KK.Ready_LimiH * 2) && ( (PLL_KK.flags & 0x0001) != 0 ) )
    {
        PLL_KK.flags &= ~0x0001; //  PLL    
        sysflag.pll_flags = PLL_KK.flags;
        PLL_KK.Kc = PLL.Kcg;
        PLL_KK.Kf = PLL.Kfg;
        PLL_KK.acc -= (int64)PLL.dPLLi * (int64)(PLL.Kcg - PLL.Kct); //  
        for (i = 0; i < 4; i++)  //  
        {
            korr_fltr(&Func.FFX[i], tvg.InFtrKoefGr);
        };
    };
    if ((Func.Rp > Glob_Lim_R[2]) && ((PLL_KK.flags & 0x0009) == 0x0009 ))
    {
        tvg.WorkState = twsRazgon;
        tvgRazgonInit ();
    };
    if ((Func.Rp < Glob_Lim_R[5]) || ((HTime >  TCount ) && ((HTime - TCount) < 0x7fffffff) ))
    {
        tvg.WorkState = twsGetFreq;
        tvgGetFreqInit ();
    };
    return;
}
////////////////////////////////////////////////////////////////////////////////
//    3
////////////////////////////////////////////////////////////////////////////////
void tvgRazgonInit (void)
{
	tvgOut.Npx = 0; tvgOut.Npy = 0;
	tvgOut.Nax = 0; tvgOut.Nay = 0;
	tvg.R1.Nx = 7; tvg.R1.Ny = 1; tvg.R1.Off = 0;
	tvgOut.R1 = tvg.R1;
	sysflag.quadr_flag = 4;
	sysflag.ampl_flag = 4;
	sysflag.angl_flag = 0;
    tvgOut.NaPWM = 0;
    tvgOut.NrPWM = 0;
    tvgOut.NpPWM = 0;
    tvgOut.Nax = 0;
    tvgOut.Nay = 0;
    Ampl_Reset ();
    Quadr_Reset();
    Angl_Reset();
	tvg.StopCnt = 0;
    return;
}

void tvgRazgonProcess (void)
{
    SecondCalcFunction();
    //  
	PLL_Process();
    //   
    Quadr_Process();

    //   
    if ((sysflag.ampl_stabilised == 0) && (Func.OutR > Glob_Lim_R[0]))
    {
        sysflag.ampl_stabilised = 1;
        Amp_KK.acc = (int64) Amp_KK.Lim << 32;
    };
    if ((sysflag.ampl_stabilised != 0) && (Func.OutR < Glob_Lim_R[1]))
    {
        sysflag.ampl_stabilised = 0;
    };
    if (sysflag.ampl_stabilised == 0)
    {
        Amp.Real_out = PWMOutProc(OutLim, &Amp_PWM, SAngl.Angl_fut );
        tvgOut.Nrx = Amp_PWM.Nx;
        tvgOut.Nry = Amp_PWM.Ny;
    }
    else
    {
        Ampl_Process();
    };

    write_FPGA_data (&tvgOut);
    csum = OutInfo.cfree;
    OutInfo.cdus = 0;

    //   
    d_angl = SAngl.Angl_filt - tvg.SetAngl_temp;
    if (d_angl > int_pi2) { d_angl = d_angl - int_pi; };
    if (d_angl < -int_pi2) { d_angl = d_angl + int_pi; };
    if (d_angl >= 0)  //   
    {
        abs_angl = d_angl;
    }
    else
    {
        abs_angl = -d_angl;
    };

    if ((sysflag.big_angle == 0) && (abs_angl > (tvg.Angl_gr + tvg.Angl_gis)))
    {               //    -  
        sysflag.big_angle = 1;
    };
    if ((sysflag.big_angle != 0) && (abs_angl < (tvg.Angl_gr - tvg.Angl_gis)))
    {       //    - 
        sysflag.big_angle = 0;
    };

    //   
    if ((sysflag.big_speed == 0)
            && ( OutInfo.cfree > (tvg.W_gr + tvg.W_gis) ) )
    {
        sysflag.big_speed = 1;
    };
    if ((sysflag.big_speed != 0)
            && ( OutInfo.cfree < (tvg.W_gr - tvg.W_gis)))
    {
        sysflag.big_speed = 0;
    };

    //     
    if ((sysflag.quadr_flag & 8) != 0)
    { sysflag.functional_ready = 1; }
    else  { sysflag.functional_ready = 0; };

    //    
    SetOutBuf(csum);
    tvg.StopCnt++;

//   
    if ( ( (PLL_KK.flags & 0x0009) != 0x0009 ) || ( Func.Rp < Glob_Lim_R[3] ) )
    {
        sysflag.functional_ready = 0;
        tvg.WorkState = twsStarting;
        tvgStartingInit ();
    };
	if (((sysflag.ampl_flag & 8 ) != 0) && (sysflag.functional_ready == 1))
	{
        tvg.WorkState = twsFreeWave;
        tvgFreeWaveInit();
	};
    return;
}
////////////////////////////////////////////////////////////////////////////////
//****************************************************************************//
////////////////////////////////////////////////////////////////////////////////
void tvgStabilizationInit (void)
{
    tvg.R1.Nx = tvg.directPWM & 0x00000007;
    tvg.R1.Ny = (tvg.directPWM >> 16) & 0x00000007;
    tvgOut.R1 = tvg.R1;
    sysflag.quadr_flag = 0xc;
    sysflag.ampl_flag = 0xc;
    sysflag.angl_flag = 0xc;
    tvgOut.NaPWM = 0;
	tvg.StopCnt = 0;
	TCount = 0;
    return;
}

void tvgStabilizationProcess (void)
{
    SecondCalcFunction();
    //  
    PLL_Process();
    //   
    Quadr_Process();
    //   
    Ampl_Process();
    //   
    Angl_Process();

    //   
    if ((sysflag.big_speed == 0)
            && ( (OutInfo.cfree + OutInfo.cdus) > (tvg.W_gr + tvg.W_gis) ) )
    {
        sysflag.big_speed = 1;
        TCount = 0;
    };
    if ((sysflag.big_speed != 0)
            && ((OutInfo.cfree + OutInfo.cdus) < (tvg.W_gr - tvg.W_gis)))
    {
        sysflag.big_speed = 0;
        TCount = 0;
    };

    //    
    if (sysflag.big_speed == 0)
    {
        csum = OutInfo.cdus;
    }
    else
    {
        csum = OutInfo.cfree + OutInfo.cdus;
        TCount++;
    };

    SetOutBuf(csum);
    tvg.StopCnt++;

    //    
    //   
    d_angl = SAngl.Angl_filt - tvg.SetAngl_temp;
    if (d_angl >= 0)
    {
        abs_angl = d_angl;
    }
    else
    {
        abs_angl = -d_angl;
    };

    if ((TCount > 100) || (abs_angl > (tvg.Angl_gr + tvg.Angl_gis)))
    {
        sysflag.big_angle = 1;
        tvg.WorkState = twsFreeWave;
        tvgFreeWaveInit();
    };
    write_FPGA_data (&tvgOut);
    return;
}
////////////////////////////////////////////////////////////////////////////////
//****************************************************************************//
////////////////////////////////////////////////////////////////////////////////
void tvgFreeWaveInit (void)
{
    tvg.R1.Nx = tvg.directPWM & 0x00000007;
    tvg.R1.Ny = (tvg.directPWM >> 16) & 0x00000007;
    tvgOut.R1 = tvg.R1;
    sysflag.quadr_flag = 0xc;
    sysflag.ampl_flag = 0xc;
    sysflag.angl_flag = 0;
    AnglS_KK.flags = 0;
    tvgOut.Nax = 0;
    tvgOut.Nay = 0;
    AnglS.Real_out = 0;
    tvgOut.NaPWM = 0;
    tvg.StopCnt = 0;
    TCount = 0;
    return;
}

void tvgFreeWaveProcess (void)
{
    SecondCalcFunction();
    //  
    PLL_Process();
    //   
    Quadr_Process();
    //   
    Ampl_Process();

    //   
    if ((sysflag.big_speed == 0)
            && ( OutInfo.cfree  > (tvg.W_gr + tvg.W_gis) ) )
    {
        sysflag.big_speed = 1;
        TCount = 0;
    };
    if ((sysflag.big_speed != 0)
            && (OutInfo.cfree < (tvg.W_gr - tvg.W_gis) ) )
    {
        sysflag.big_speed = 0;
        TCount = 0;
    };

    //     
    csum = OutInfo.cfree;
    OutInfo.cdus = 0;
    if (sysflag.big_speed == 0)
    {
        TCount++;
    };
    SetOutBuf(csum);
    tvg.StopCnt++;

    //     
    if (TCount > 100)
    {
        sysflag.big_angle = 1;
        //      
        d_angl = SAngl.Angl_filt - tvg.SetAngl_temp;
        if (d_angl > int_pi2) { d_angl = d_angl - int_pi; };
        if (d_angl < -int_pi2) { d_angl = d_angl + int_pi; };
        if (d_angl > 0)
        {
            AnglS.Real_out = PWMOutProc((-OutLim), &AnglS_PWM,
                                        SAngl.Angl_fut );
        }
        else
        {
            AnglS.Real_out = PWMOutProc(OutLim, &AnglS_PWM,
                                        SAngl.Angl_fut );
        };
        tvgOut.Nax = - AnglS_PWM.Ny;
        tvgOut.Nay = AnglS_PWM.Nx;
        Calc_CDUS (AnglS.Real_out);
        Func.Last_Na = AnglS.Real_out;
        tvg.WorkState = twsAngleReturn;
        tvgAngleReturnInit();
    };
    write_FPGA_data (&tvgOut);
    return;
}

////////////////////////////////////////////////////////////////////////////////
//****************************************************************************//
////////////////////////////////////////////////////////////////////////////////
void tvgAngleReturnInit (void)
{
    tvg.R1.Nx = tvg.directPWM & 0x00000007;
    tvg.R1.Ny = (tvg.directPWM >> 16) & 0x00000007;
    tvgOut.R1 = tvg.R1;
    sysflag.quadr_flag = 0xc;
    sysflag.ampl_flag = 0xc;
    sysflag.angl_flag = 0x4;
    AnglS_KK.flags = 0x4;
//    tvgOut.NaPWM = (int16) (AnglS.PWM_korr << 5);
    tvg.StopCnt = 0;
    TCount = 0;
    return;
}

void tvgAngleReturnProcess (void)
{
    SecondCalcFunction();
    //  
    PLL_Process();
    //   
    Quadr_Process();
    //   
    Ampl_Process();

    //    
    csum = OutInfo.cfree + OutInfo.cdus;

    //   
    if ((sysflag.big_speed == 0)
            && ( csum > (tvg.W_gr + tvg.W_gis) ) )
    {
        sysflag.big_speed = 1;
        TCount = 0;
    };
    if ((sysflag.big_speed != 0)
            && (csum < (tvg.W_gr - tvg.W_gis)))
    {
        sysflag.big_speed = 0;
        TCount = 0;
    };
    if (sysflag.big_speed == 1)
    {
        TCount++;
    };

    //    
    d_angl = SAngl.Angl_filt - tvg.SetAngl_temp;
    if (d_angl > int_pi2) { d_angl = d_angl - int_pi; };
    if (d_angl < -int_pi2) { d_angl = d_angl + int_pi; };
    if (d_angl > 0)
    {
        AnglS.Real_out = PWMOutProc((-OutLim), &AnglS_PWM,
                                    SAngl.Angl_fut );
    }
    else
    {
        AnglS.Real_out = PWMOutProc(OutLim, &AnglS_PWM,
                                    SAngl.Angl_fut );
    };
    tvgOut.Nax = - AnglS_PWM.Ny;
    tvgOut.Nay = AnglS_PWM.Nx;

    SetOutBuf(csum);
    tvg.StopCnt++;

    //    
    //   
    if (d_angl >= 0)
    {
        abs_angl = d_angl;
    }
    else
    {
        abs_angl = -d_angl;
    };
    if (TCount > 100)
    {
        tvg.WorkState = twsFreeWave;
        tvgFreeWaveInit();
    }
    else
    {
        if ( (abs_angl < (tvg.Angl_gr - tvg.Angl_gis)) && (sysflag.big_speed == 0) )
        {
            sysflag.big_angle = 0;
            tvg.WorkState = twsStabilization;
            tvgStabilizationInit();
            sysflag.angl_flag = 0x4;
            AnglS_KK.flags = 0x4;
            AnglS_KK.acc = (int64)AnglS_KK.Lim << 32;
            AnglS_KK.RdyFlt.last_out = (int64)AnglS_KK.Ready_Lim * 3;
            korr_fltr (&AnglS_KK.RdyFlt, ReadyKoef);
        };
    };
    write_FPGA_data (&tvgOut);
    return;

}

////////////////////////////////////////////////////////////////////////////////
//****************************************************************************//
////////////////////////////////////////////////////////////////////////////////
void tvgBreakingInit (void)
{
    tvg.R1.Nx = tvg.directPWM & 0x00000007;
    tvg.R1.Ny = (tvg.directPWM >> 16) & 0x00000007;
    tvgOut.R1 = tvg.R1;
    sysflag.quadr_flag = 0xc;
    sysflag.ampl_flag = 0xc;
    sysflag.angl_flag = 0;
    tvgOut.Nax = 0;
    tvgOut.Nay = 0;
    AnglS.Real_out = 0;
    tvgOut.NaPWM = 0;
    tvg.StopCnt = 0;
    TCount = 0;
    return;
}

void tvgBreakingProcess (void)
{
	if (Func.Rp > Glob_Lim_R[5])
	{
	    SecondCalcFunction();
	    //  
	    PLL_Process();
	    //   
	    Quadr_Process();

	    //   
	    if ((sysflag.big_speed == 0)
	            && ( (OutInfo.cfree + OutInfo.cdus) > (tvg.W_gr + tvg.W_gis) ) )
	    {
	        sysflag.big_speed = 1;
	    };
	    if ((sysflag.big_speed != 0)
	            && ((OutInfo.cfree + OutInfo.cdus) < (tvg.W_gr - tvg.W_gis)))
	    {
	        sysflag.big_speed = 0;
	    };

	    //    
	    Amp.Real_out = PWMOutProc((-OutLim), &Amp_PWM, SAngl.Angl_fut);
        tvgOut.Nrx = Amp_PWM.Nx;
        tvgOut.Nry = Amp_PWM.Ny;
	    write_FPGA_data (&tvgOut);

        //     
	    csum = OutInfo.cfree;
	    SetOutBuf(csum);
	}
	else
	{
	    if (TCount == 0)
	    {
	        tvgStopInit ();
	        write_FPGA_data (&tvgOut);
	        TCount = 1;
	    };
	};
    tvg.StopCnt++;
    return;
}




