#ifndef TVG_H_
#define TVG_H_

#include "myTypes.h"
#include "System_unit.h"
#include <System_output_information.h>
#include "Functions.h"


#define TVG_IN_FIR_TAP		4// 4..64
#define TVG_PLL_FIR_TAP		3
#define TVG_NR_FIR_TAP		3
#define TVG_Np_FIR_TAP		3
#define TVG_Na_FIR_TAP		3 

#define TVG_IN_FIR_TAP_VES		1//4// 4..64
#define TVG_PLL_FIR_TAP_VES		1//8
#define TVG_NR_FIR_TAP_VES		1//8
#define TVG_Np_FIR_TAP_VES		1//8
#define TVG_Na_FIR_TAP_VES		1 
//   R1:

#define TVG_BUF_LEN     100//16
#define TVG_TABLE_LEN       16
#define TVG_OZU_LEN     260

#define TVG_TABLE_LEN       16

#define TVG_TEMP_TABLE_DEF  \
     -52.00,  -40.00,  -28.00,  -16.00,   -4.00,    8.00,   20.00,   32.00, \
      44.00,   56.00,   68.00,   80.00,   92.00,  104.00,  116.00,  228.00

#define TVG_FREQ_TABLE_DEF  \
    7257.39, 7264.82, 7272.26, 7279.69, 7287.13, 7294.56, 7302.00, 7309.44, \
    7316.87, 7324.31, 7331.74, 7339.18, 7346.61, 7354.05, 7361.48, 7368.92


//   :
typedef enum
{
    cntrWork = 0,      // 
    cntrTechnology,    // 
    cntrReprogram     // 
 }
TTVGControlMode;

//   :
typedef enum
{
	twsStop = 0,		// 
	twsGetFreq,			//    5%
	twsStarting,		//   20%
	twsRazgon,			//   80%
	twsStabilization,	//  
	twsFreeWave,		// 
	twsAngleReturn,		//  
	twsBreaking		// 
//	twsUint16 = 0x7FFF
}   TTVGWorkState;

typedef struct
{
    unsigned short Nx : 3;//   X
    unsigned short Ny : 3;//   Y
    unsigned short Off : 1;//NRx =max,NRy = 0   ,  1
    unsigned short Off_kvadr_PWM : 1;//    , 1  - ;
    unsigned short Off_angle_PWM : 1;//     , 1  - 
    unsigned short Off_korrect_PWM : 1;//    , 1 - 
    unsigned short simul_DATA : 1;// X_C, X_S,Y_S, Y_C,  1  
    unsigned short none1 : 2;
    unsigned short test_razgona : 1;//      
    unsigned short short_FD : 1;///  , 1  
    unsigned short inc_PLL : 1;//  , 0   
}   TTVGR1;

typedef struct
{
	Uint32 StopCnt; //    
	TTVGWorkState WorkState;
	TTVGControlMode ControlMode;
	Uint32 directPWM;
    int32 InFtrKoefGr;
    int32 InFtrKoefTch;
    int32 Ttvg;		//  , C * 100 (+2000 = 20C)
    int32 Tpl;      //  , C * 100 (+2000 = 20C)
    int32 T0;      //  , C * 100 (+2000 = 20C)
	Uint32 f0;	//     ,    (,   0xc800 0000)
    int32 Kf0;  //       ,     0,01C
    Uint32 f00;  //     ,    (,   0xc800 0000)
	TTVGR1 R1;	//   R1
	int32 DeltaMshT; //   1   
	int32 TimFiltrKoef; //     
    int32 BruinKoef; //   (       )
    int32 SetAngl; //  
    int32 SetAngl_temp; //    
    int32 Tkoef_SetAngl; //  ( )    (.100000)
    int32 Speed_Korrekt; //        
    int32 Angl_gr;      //      /  
    int32 W_gr;         //       / 
    int32 Angl_gis;    //   /    
    int32 W_gis;       //   /     
    int32 PWM_korr; //   
}   tvg_s;

typedef struct//   
{ 
	int32 Xs; 
	int32 Xc; 
	int32 Ys; 
	int32 Yc; 
	int32 S; 
	int16 regINVERS;
}	tvgIn_s;

typedef struct//   
{
	Uint32 PLL;
	Uint32 F0;
	int16 Nrx;
	int16 Nry;
	int16 Npx;
	int16 Npy;
	int16 Nax;
	int16 Nay;
	TTVGR1 R1;
	Uint16 R2; 
	int16 NrPWM;
	int16 NpPWM;
	int16 NaPWM;
}   tvgOut_s;



void InitAdres(void);
void tvgInit ( void );
Uint32 tvgGetF0 (void);
void tvgStopInit (void);

void tvgSetState();
void tvgStopProcess (void);
void tvgGetFreqProcess (void);
void tvgStartingProcess (void);
void tvgRazgonProcess (void);
void tvgStabilizationProcess (void);
void tvgFreeWaveProcess (void);
void tvgAngleReturnProcess (void);
void tvgBreakingProcess (void);
void tvgOutInfoProcess(void);

extern OutInfo_s OutInfo;
extern OutInfoVPI_s Buf0, Buf1;//
extern tvg_s tvg;
//   
extern volatile tvgIn_s	tvgIn;
//   
extern volatile tvgOut_s tvgOut;
//  
extern OutInfo_s OutInfo;
extern uint32 SearchDeltaF;


#endif /*TVG_H_*/
