/******************************************************************************\
*           Copyright (C) 1999-2000 Texas Instruments Incorporated.
*                           All Rights Reserved
*------------------------------------------------------------------------------
* FILENAME...... csl_dat.c
* DATE CREATED.. 11/11/1999 
* LAST MODIFIED. 10/03/2000 from csl 1.86
\******************************************************************************/
#define _DAT_MOD_
#include "csl_dat.h"
#include "csl_legacy.h"

extern far Uint32 _lmbd(Uint32 src1, Uint32 src2);

#if (DAT_SUPPORT)
#pragma DATA_SECTION(_DAT_stateStruct, ".far:_DAT_stateStruct");

#if (DMA_SUPPORT)                                
/******************************************************************************\
* DMA_SUPPORT DMA_SUPPORT DMA_SUPPORT DMA_SUPPORT DMA_SUPPORT DMA_SUPPORT 
* DMA_SUPPORT DMA_SUPPORT DMA_SUPPORT DMA_SUPPORT DMA_SUPPORT DMA_SUPPORT 
* DMA_SUPPORT DMA_SUPPORT DMA_SUPPORT DMA_SUPPORT DMA_SUPPORT DMA_SUPPORT 
* DMA_SUPPORT DMA_SUPPORT DMA_SUPPORT DMA_SUPPORT DMA_SUPPORT DMA_SUPPORT 
* DMA_SUPPORT DMA_SUPPORT DMA_SUPPORT DMA_SUPPORT DMA_SUPPORT DMA_SUPPORT 
* DMA_SUPPORT DMA_SUPPORT DMA_SUPPORT DMA_SUPPORT DMA_SUPPORT DMA_SUPPORT 
* DMA_SUPPORT DMA_SUPPORT DMA_SUPPORT DMA_SUPPORT DMA_SUPPORT DMA_SUPPORT 
* DMA_SUPPORT DMA_SUPPORT DMA_SUPPORT DMA_SUPPORT DMA_SUPPORT DMA_SUPPORT 
* DMA_SUPPORT DMA_SUPPORT DMA_SUPPORT DMA_SUPPORT DMA_SUPPORT DMA_SUPPORT 
* DMA_SUPPORT DMA_SUPPORT DMA_SUPPORT DMA_SUPPORT DMA_SUPPORT DMA_SUPPORT 
* DMA_SUPPORT DMA_SUPPORT DMA_SUPPORT DMA_SUPPORT DMA_SUPPORT DMA_SUPPORT 
* DMA_SUPPORT DMA_SUPPORT DMA_SUPPORT DMA_SUPPORT DMA_SUPPORT DMA_SUPPORT 
\******************************************************************************/

/******************************************************************************\
*                         L O C A L   S E C T I O N
\******************************************************************************/


/******************************************************************************\
* static macro declarations
\******************************************************************************/
#define DEFAULT_CHA DAT_CHAANY
#define DEFAULT_PRI DAT_PRI_HIGH


/******************************************************************************\
* static typedef declarations
\******************************************************************************/


/******************************************************************************\
* static function declarations
\******************************************************************************/


/******************************************************************************\
* static variable definitions
\******************************************************************************/
static DMA_Handle hDma     = INV;
static Uint32     eventId  = 0x00000000;
static Uint32     openFlag = 0;
static Uint32     gblidxId = 0;
static Uint32     gblcntId = 0;


/******************************************************************************\
* static function definitions
\******************************************************************************/


/******************************************************************************\
*                        G L O B A L   S E C T I O N
\******************************************************************************/


/******************************************************************************\
* global variable definitions
\******************************************************************************/
far Uint16 _DAT_serialTable[] = {
  0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,
  0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,
  0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,
  0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,
  0x0000
}; 

far _DAT_StateStruct _DAT_stateStruct = {
  0x00000400,
  _DMA_BASE_CHA0,
  DMA_ADDR(GBLCNTA),
  DMA_ADDR(GBLIDXA),
  0x03000000
}; 


/******************************************************************************\
* global function definitions
\******************************************************************************/
int DAT_open(int chaNum, int priority, Uint32 flags) {

  Uint32 success = FALSE;
  Uint32 gie;
  int slotNum;

  gie = IRQ_globalDisable();

  if (!openFlag) {

    hDma = DMA_open(chaNum,DMA_OPEN_RESET);

    if (hDma != INV) {
      eventId = DMA_getEventId(hDma);
      _DAT_stateStruct.baseAddr  = (Uint32)(hDma->baseAddr);
      _DAT_stateStruct.useMask   = _IRQ_eventTable[eventId];
      gblidxId = 0;
      gblcntId = 0;
      success  = TRUE;

      IRQ_disable(eventId);
      IRQ_clear(eventId);
      IRQ_set(eventId);

      slotNum = 31-_lmbd(1,_DAT_stateStruct.useMask);
      if (slotNum >= 0) {
        _DAT_serialTable[slotNum] = 0;
      }
    
      if (flags & DAT_OPEN_2D) {

        gblcntId = DMA_allocGlobalReg(DMA_GBL_CNTRLD,0);
        if (gblcntId != 0x00000000) {
          _DAT_stateStruct.gblcntAddr=_DMA_gblRegTbl[gblcntId&_DMA_GBLREG_MASK];
        } else {
          success = FALSE;
        }

        gblidxId = DMA_allocGlobalReg(DMA_GBL_INDEX,0);
        if (gblidxId != 0x00000000) {
          _DAT_stateStruct.gblidxAddr=_DMA_gblRegTbl[gblidxId&_DMA_GBLREG_MASK];
        } else {
          success = FALSE;
        }

      }
    
      _DAT_stateStruct.initPrictl = DMA_PRICTL_RMK(
        DMA_PRICTL_DSTRLD_NONE,
        DMA_PRICTL_SRCRLD_NONE,
        DMA_PRICTL_EMOD_NOHALT,
        DMA_PRICTL_FS_DISABLE,
        DMA_PRICTL_TCINT_ENABLE,
        DMA_PRICTL_PRI_OF(priority),
        DMA_PRICTL_WSYNC_NONE,
        DMA_PRICTL_RSYNC_NONE,
        DMA_PRICTL_INDEX_OF(gblidxId),
        DMA_PRICTL_CNTRLD_OF(gblcntId),
        DMA_PRICTL_SPLIT_DISABLE,
        DMA_PRICTL_ESIZE_32BIT,
        DMA_PRICTL_DSTDIR_NONE,
        DMA_PRICTL_SRCDIR_NONE,
        DMA_PRICTL_START_NORMAL
      );          

      if (success) {
        openFlag = TRUE;
      } else {
        openFlag = FALSE;
        DMA_close(hDma);
        if (gblidxId) DMA_freeGlobalReg(gblidxId);
        if (gblcntId) DMA_freeGlobalReg(gblcntId);
      }  
    }
  }

  IRQ_globalRestore(gie);

  return success;
}

/*----------------------------------------------------------------------------*/
void DAT_close() {

  Uint32 gie;

  gie = IRQ_globalDisable();

  if (openFlag) {
    /* wait for any pending transfers to complete */
    while ((IFR & _DAT_stateStruct.useMask) != _DAT_stateStruct.useMask);
    DMA_close(hDma);
    DMA_freeGlobalReg(gblidxId);
    DMA_freeGlobalReg(gblcntId);
    openFlag = 0;
  }

  IRQ_globalRestore(gie);
}

/*----------------------------------------------------------------------------*/
#endif /* DMA_SUPPORT */


#if (EDMA_SUPPORT)
/******************************************************************************\
* EDMA_SUPPORT EDMA_SUPPORT EDMA_SUPPORT EDMA_SUPPORT EDMA_SUPPORT EDMA_SUPPORT 
* EDMA_SUPPORT EDMA_SUPPORT EDMA_SUPPORT EDMA_SUPPORT EDMA_SUPPORT EDMA_SUPPORT 
* EDMA_SUPPORT EDMA_SUPPORT EDMA_SUPPORT EDMA_SUPPORT EDMA_SUPPORT EDMA_SUPPORT 
* EDMA_SUPPORT EDMA_SUPPORT EDMA_SUPPORT EDMA_SUPPORT EDMA_SUPPORT EDMA_SUPPORT 
* EDMA_SUPPORT EDMA_SUPPORT EDMA_SUPPORT EDMA_SUPPORT EDMA_SUPPORT EDMA_SUPPORT 
* EDMA_SUPPORT EDMA_SUPPORT EDMA_SUPPORT EDMA_SUPPORT EDMA_SUPPORT EDMA_SUPPORT 
* EDMA_SUPPORT EDMA_SUPPORT EDMA_SUPPORT EDMA_SUPPORT EDMA_SUPPORT EDMA_SUPPORT 
* EDMA_SUPPORT EDMA_SUPPORT EDMA_SUPPORT EDMA_SUPPORT EDMA_SUPPORT EDMA_SUPPORT 
* EDMA_SUPPORT EDMA_SUPPORT EDMA_SUPPORT EDMA_SUPPORT EDMA_SUPPORT EDMA_SUPPORT 
* EDMA_SUPPORT EDMA_SUPPORT EDMA_SUPPORT EDMA_SUPPORT EDMA_SUPPORT EDMA_SUPPORT 
* EDMA_SUPPORT EDMA_SUPPORT EDMA_SUPPORT EDMA_SUPPORT EDMA_SUPPORT EDMA_SUPPORT 
* EDMA_SUPPORT EDMA_SUPPORT EDMA_SUPPORT EDMA_SUPPORT EDMA_SUPPORT EDMA_SUPPORT 
\******************************************************************************/


/******************************************************************************\
* static macro declarations
\******************************************************************************/
#define DEFAULT_CHA DAT_CHAANY
#define DEFAULT_PRI DAT_PRI_HIGH 
#define TCC_CNT 4


/******************************************************************************\
* static typedef declarations
\******************************************************************************/


/******************************************************************************\
* static function declarations
\******************************************************************************/


/******************************************************************************\
* static variable definitions
\******************************************************************************/
static Uint32 openFlag = 0;
static char tccCodes[TCC_CNT];

/******************************************************************************\
* static function definitions
\******************************************************************************/


/******************************************************************************\
*                        G L O B A L   S E C T I O N
\******************************************************************************/


/******************************************************************************\
* global variable definitions
\******************************************************************************/
far Uint16 _DAT_serialTable[] = {
  0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,
  0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,
  0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,
  0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,
  0x0000
};

far _DAT_StateStruct _DAT_stateStruct = {
  0x00000000,
  EDMA_ADDR(QOPT),
  0x00000000
};


/******************************************************************************\
* global function definitions
\******************************************************************************/
int DAT_open(int chaNum, int priority, Uint32 flags) {

  int success = FALSE;
  int x,tcc;
  Uint32 useMask,gie;
  volatile Uint32 dummySrc, dummyDst;

  UNREFERENCED_PARAMETER(flags);
  UNREFERENCED_PARAMETER(chaNum);
  UNREFERENCED_PARAMETER(priority);

  gie = IRQ_globalDisable();

  if (!openFlag) {
    
    success = TRUE;

    /* We need to allocate a transfer complete code for each slot.   */
    /* We'll also generate the useMask based on these TCC codes.     */
    /* We also want to make sure the TCC codes are within the lower  */
    /* 32 codes so we only have to use CIPRL in the 64x case.        */
    for (x=0; x<TCC_CNT; x++) {
      tccCodes[x] = -1;
    }
      
    useMask = 0x00000000;
    for (x=0; x<TCC_CNT; x++) {
      tcc = 32;
      while ((tcc>=32)&&success) {
        tcc = EDMA_intAlloc(-1);
        if (tcc == -1) {
          success = 0; /* error, couldn't allocate TCC code */
          break;
        } else if (tcc >= 32) {
          EDMA_intFree(tcc);
        } else {
          tccCodes[x] = tcc;
        }
      }
      useMask = useMask | (1<<tcc);
    }
    _DAT_stateStruct.useMask = useMask;

    
    if (success) {
      /* We need to get the completion code bits set and the only way */
      /* to do this is to submit transfers and let the hardware do it */
      EDMA_RSET(CIER,EDMA_RGET(CIER) & ~useMask);
      EDMA_RSET(CIPR,useMask);

      /* submit a dummy transfer for each bit in the useMask */
      x = 31-_lmbd(1,useMask);
      while (x>=0) {
        _DAT_serialTable[x] = 0;
        /* do dummy transfer using X as TCC value */
        EDMA_RSET(QSRC,  (Uint32)(&dummySrc));
        EDMA_RSET(QDST,  (Uint32)(&dummyDst));
        EDMA_RSET(QCNT,  (Uint32)0x00000001);
        EDMA_RSET(QIDX,  (Uint32)0x00000000);
        EDMA_RSET(QSOPT, (Uint32)0x20100000 | (x<<16));
        useMask = useMask & ~(1<<x);
        x = 31-_lmbd(1,useMask);
      }

      /* wait for all dummy transfers to complete */
      //while ((EDMA_RGET(CIPR) & _DAT_stateStruct.useMask)!=_DAT_stateStruct.useMask);
      DAT_wait(DAT_XFRID_WAITALL);

      /* assemble the baseline OPT value */
      #if (C64_SUPPORT)
        _DAT_stateStruct.initOpt = EDMA_OPT_RMK(
          EDMA_OPT_PRI_OF(priority),
          EDMA_OPT_ESIZE_32BIT,
          EDMA_OPT_2DS_NO,
          EDMA_OPT_SUM_NONE,
          EDMA_OPT_2DD_NO,
          EDMA_OPT_DUM_NONE,
          EDMA_OPT_TCINT_YES,
          EDMA_OPT_TCC_OF(0),
          EDMA_OPT_TCCM_OF(0),
          EDMA_OPT_ATCINT_NO,
          EDMA_OPT_ATCC_OF(0),
          EDMA_OPT_PDTS_DISABLE,
          EDMA_OPT_PDTD_DISABLE,
          EDMA_OPT_LINK_NA,
          EDMA_OPT_FS_NO
        );
      #else
        _DAT_stateStruct.initOpt = EDMA_OPT_RMK(
          EDMA_OPT_PRI_OF(priority),
          EDMA_OPT_ESIZE_32BIT,
          EDMA_OPT_2DS_NO,
          EDMA_OPT_SUM_NONE,
          EDMA_OPT_2DD_NO,
          EDMA_OPT_DUM_NONE,
          EDMA_OPT_TCINT_YES,
          EDMA_OPT_TCC_OF(0),
          EDMA_OPT_LINK_NA,
          EDMA_OPT_FS_NO
        );
      #endif
    }  

    if (success) {
      openFlag = 1;
    } else {
      for (x=0; x<TCC_CNT; x++) {
        if (tccCodes[x] != -1) {
          EDMA_intFree(tccCodes[x]);
        }
      }
    } 

  }

  IRQ_globalRestore(gie);

  return success;
}

/*----------------------------------------------------------------------------*/
void DAT_close() {

  Uint32 gie;
  int x;

  gie = IRQ_globalDisable();

  if (openFlag) {
    /* wait for all pending transfers to complete */
    DAT_wait(DAT_XFRID_WAITALL);

    #if (EDMA_SUPPORT)
      for (x=0; x<TCC_CNT; x++) {
        if (tccCodes[x] != -1) {
          EDMA_intFree(tccCodes[x]);
        }
      }
    #endif
    
    openFlag = 0;
  }

  IRQ_globalRestore(gie);
}

/*----------------------------------------------------------------------------*/
#endif /* EDMA_SUPPORT */


/*----------------------------------------------------------------------------*/


#endif /* DAT_SUPPORT */
/******************************************************************************\
* End of csl_dat.c
\******************************************************************************/

