/******************************************************************************\
*           Copyright (C) 1999-2000 Texas Instruments Incorporated.
*                           All Rights Reserved
*------------------------------------------------------------------------------
* FILENAME...... csl_edmaDsptr.c
* DATE CREATED.. 06/03/2002
* LAST MODIFIED. 07/12/2002
\******************************************************************************/

#define __EDMA_MOD_
#include <csl_edma.h>

/* We need to use the runtime library intrinsic _lmbd() function but */
/* want to declare it as far.                                        */
extern far Uint32 _lmbd(Uint32 src1, Uint32 src2);


#if (EDMA_SUPPORT)
/******************************************************************************\
*                         L O C A L   S E C T I O N
\******************************************************************************/


/******************************************************************************\
* static macro declarations
\******************************************************************************/


/******************************************************************************\
* static typedef declarations
\******************************************************************************/


/******************************************************************************\
* static function declarations
\******************************************************************************/

/******************************************************************************\
* static variable definitions
\******************************************************************************/

#if (!C64_SUPPORT)
  static EDMA_IntHandler funcTable[16] = {
    EDMA_intDefaultHandler, EDMA_intDefaultHandler, EDMA_intDefaultHandler, EDMA_intDefaultHandler,
    EDMA_intDefaultHandler, EDMA_intDefaultHandler, EDMA_intDefaultHandler, EDMA_intDefaultHandler,
    EDMA_intDefaultHandler, EDMA_intDefaultHandler, EDMA_intDefaultHandler, EDMA_intDefaultHandler,
    EDMA_intDefaultHandler, EDMA_intDefaultHandler, EDMA_intDefaultHandler, EDMA_intDefaultHandler
  };
#endif

#if (C64_SUPPORT)
  static EDMA_IntHandler funcTableLow[32] = {
    EDMA_intDefaultHandler, EDMA_intDefaultHandler, EDMA_intDefaultHandler, EDMA_intDefaultHandler,
    EDMA_intDefaultHandler, EDMA_intDefaultHandler, EDMA_intDefaultHandler, EDMA_intDefaultHandler,
    EDMA_intDefaultHandler, EDMA_intDefaultHandler, EDMA_intDefaultHandler, EDMA_intDefaultHandler,
    EDMA_intDefaultHandler, EDMA_intDefaultHandler, EDMA_intDefaultHandler, EDMA_intDefaultHandler,
    EDMA_intDefaultHandler, EDMA_intDefaultHandler, EDMA_intDefaultHandler, EDMA_intDefaultHandler,
    EDMA_intDefaultHandler, EDMA_intDefaultHandler, EDMA_intDefaultHandler, EDMA_intDefaultHandler,
    EDMA_intDefaultHandler, EDMA_intDefaultHandler, EDMA_intDefaultHandler, EDMA_intDefaultHandler,
    EDMA_intDefaultHandler, EDMA_intDefaultHandler, EDMA_intDefaultHandler, EDMA_intDefaultHandler
  };

  static EDMA_IntHandler funcTableHigh[32] = {
    EDMA_intDefaultHandler, EDMA_intDefaultHandler, EDMA_intDefaultHandler, EDMA_intDefaultHandler,
    EDMA_intDefaultHandler, EDMA_intDefaultHandler, EDMA_intDefaultHandler, EDMA_intDefaultHandler,
    EDMA_intDefaultHandler, EDMA_intDefaultHandler, EDMA_intDefaultHandler, EDMA_intDefaultHandler,
    EDMA_intDefaultHandler, EDMA_intDefaultHandler, EDMA_intDefaultHandler, EDMA_intDefaultHandler,
    EDMA_intDefaultHandler, EDMA_intDefaultHandler, EDMA_intDefaultHandler, EDMA_intDefaultHandler,
    EDMA_intDefaultHandler, EDMA_intDefaultHandler, EDMA_intDefaultHandler, EDMA_intDefaultHandler,
    EDMA_intDefaultHandler, EDMA_intDefaultHandler, EDMA_intDefaultHandler, EDMA_intDefaultHandler,
    EDMA_intDefaultHandler, EDMA_intDefaultHandler, EDMA_intDefaultHandler, EDMA_intDefaultHandler
  };
#endif

/******************************************************************************\
* static function definitions
\******************************************************************************/
/*----------------------------------------------------------------------------*/

/******************************************************************************\
*                        G L O B A L   S E C T I O N
\******************************************************************************/


/******************************************************************************\
* global variable definitions
\******************************************************************************/


/******************************************************************************\
* global function definitions
\******************************************************************************/
EDMA_IntHandler EDMA_intHook(int tccNum, EDMA_IntHandler funcAddr) {

  int gie;
  EDMA_IntHandler oldIsr = (EDMA_IntHandler)INV;
  
  gie = IRQ_globalDisable();

  #if (C64_SUPPORT)
    if ((tccNum>=0)&&(tccNum<=31)) {
      oldIsr = funcTableLow[tccNum];
      funcTableLow[tccNum] = funcAddr;
    } else if ((tccNum>=32)&&(tccNum<=63)) {
      oldIsr = funcTableHigh[tccNum-32];
      funcTableHigh[tccNum-32] = funcAddr;
    }
  #endif
  
  #if (!C64_SUPPORT)
    oldIsr = funcTable[tccNum];
    funcTable[tccNum] = funcAddr;
  #endif

  IRQ_globalRestore(gie);
  
  return oldIsr;
}

/*----------------------------------------------------------------------------*/
void EDMA_intDefaultHandler(int tccNum) {
  return;
}

/*----------------------------------------------------------------------------*/
void EDMA_intDispatcher() {
  register Uint32 mask,tcc;                     // try to stuff vars into regs for performance

  #if (!C64_SUPPORT)
    /* dispatcher for 621x/671x devices */
    mask = EDMA_RGET(CIPR) & EDMA_RGET(CIER);   // determine all pending and enabled interrupts
    EDMA_RSET(CIPR,mask);                       // clear all detected bits in pending register
    while (mask) {                              // loop and dispatch while pending/enabled ints exist
      tcc = 31-_lmbd(1,mask);                   // find left-most bit number
      funcTable[tcc](tcc);                      // call the user function
      mask ^= 1<<tcc;                           // clear this bit in the mask
    }
  #endif

  #if (C64_SUPPORT)
    /* dispatcher for 64x devices */
    mask = EDMA_RGET(CIPRH) & EDMA_RGET(CIERH);
    EDMA_RSET(CIPRH,mask);
    while (mask) {
      tcc = 31-_lmbd(1,mask);
        funcTableHigh[tcc](tcc+32);
      mask ^= 1<<tcc;
      }
    mask = EDMA_RGET(CIPRL) & EDMA_RGET(CIERL);
    EDMA_RSET(CIPRL,mask);
    while (mask) {
      tcc = 31-_lmbd(1,mask);
      funcTableLow[tcc](tcc);
      mask ^= 1<<tcc;
    }
  #endif
}

/*----------------------------------------------------------------------------*/

#endif /* EDMA_SUPPORT */
/******************************************************************************\
* End of csl_edmadsptr.c
\******************************************************************************/

