/**************************************************************************\
*              Copyright (C) 2002 Texas Instruments Incorporated.
*                             All Rights Reserved
*--------------------------------------------------------------------------
* MODULE NAME... EMU
* FILENAME...... csl_emu.c
* DATE CREATED.. 05/12/2003
* LAST MODIFIED. 05/20/2003
* PROJECT....... Chip Support Library
* COMPONENT..... Service Layer
* PREREQUISITES.
\**************************************************************************/

/**************************************************************************\
* Private Macro and Include files
\**************************************************************************/
#define _EMU_MOD_

#include <csl_emu.h>

#if (EMU_SUPPORT)

/**************************************************************************\
*                          L O C A L   S E C T I O N
\**************************************************************************/

/**************************************************************************\
* EMU static macro declarations
\**************************************************************************/

/**************************************************************************\
* EMU static typedef declarations
\**************************************************************************/

/**************************************************************************\
* EMU static function declarations
\**************************************************************************/

/**************************************************************************\
*                         G L O B A L   S E C T I O N
\**************************************************************************/

/**************************************************************************\
* EMU global function definitions
\**************************************************************************/

CSLAPI Uint32  EMU_setDBGM(
    void
)
{
	EMU_RSET(MFREG0, EMU_MFREG0_RMK(1, 1, 0, 0, 0, 0));

	if(EMU_FGET(DBGSTAT, DBGMST) == 1)
	{
		return EMU_SUCCESS;
	}
	else
	{
		return EMU_FAILURE;
	}

}

/*------------------------------------------------------------------------*/

CSLAPI Uint32  EMU_clrDBGM(
    void
)
{

	EMU_RSET(MFREG0, EMU_MFREG0_RMK(1, 0, 0, 0, 0, 0));

	if(EMU_FGET(DBGSTAT, DBGMST) == 0)
	{
		return EMU_SUCCESS;
	}
	else
	{
		return EMU_FAILURE;
	}

}

/*------------------------------------------------------------------------*/

CSLAPI Uint32  EMU_getDBGM(
    void
)
{
	return(EMU_FGET(DBGSTAT, DBGMST));
}

/*------------------------------------------------------------------------*/

CSLAPI void  EMU_setABORTI(
    void
)
{
	EMU_RSET(MFREG0, EMU_MFREG0_RMK(0, 0, 1, 1, 0, 0));
}

/*------------------------------------------------------------------------*/

CSLAPI void  EMU_clrABORTI(
    void
)
{
	EMU_RSET(MFREG0, EMU_MFREG0_RMK(0, 0, 1, 0, 0, 0));
}

/*------------------------------------------------------------------------*/

CSLAPI Uint32  EMU_setEALLOW(
    void
)
{
	EMU_RSET(MFREG0, EMU_MFREG0_RMK(0, 0, 0, 0, 1, 1));

	if(EMU_FGET(DBGSTAT, EALLOWST) == 1)
	{
		return EMU_SUCCESS;
	}
	else
	{
		return EMU_FAILURE;
	}

}

/*------------------------------------------------------------------------*/

CSLAPI Uint32  EMU_clrEALLOW(
    void
)
{
	EMU_RSET(MFREG0, EMU_MFREG0_RMK(0, 0, 0, 0, 1, 0));

	if(EMU_FGET(DBGSTAT, EALLOWST) == 0)
	{
		return EMU_SUCCESS;
	}
	else
	{
		return EMU_FAILURE;
	}

}

/*------------------------------------------------------------------------*/

CSLAPI Uint32  EMU_getEALLOW(
    void
)
{
	return(EMU_FGET(DBGSTAT, EALLOWST));
}

/*------------------------------------------------------------------------*/

CSLAPI Uint32  EMU_getDBGSTAT(
    void
)
{
	return(EMU_RGET(DBGSTAT));
}

/*------------------------------------------------------------------------*/

#endif /* EMU_SUPPORT */

/**************************************************************************\
* End of csl_emu.c
\**************************************************************************/
