/******************************************************************************\
*           Copyright (C) 2000 Texas Instruments Incorporated.
*                           All Rights Reserved
*------------------------------------------------------------------------------
* FILENAME...... csl_legacy.c
* DATE CREATED.. 09/07/2000 
* LAST MODIFIED. 10/03/2000
\******************************************************************************/
#define _LEGACY_MOD_
#include "csl_legacy.h"


/******************************************************************************\
*                         L O C A L   S E C T I O N
\******************************************************************************/


/******************************************************************************\
* static macro declarations
\******************************************************************************/


/******************************************************************************\
* static typedef declarations
\******************************************************************************/


/******************************************************************************\
* static function declarations
\******************************************************************************/


/******************************************************************************\
* static variable definitions
\******************************************************************************/
#if (DMA_SUPPORT&&0)
  static Uint32 gblAllocMask = 0x00000000;
#endif


/******************************************************************************\
* static function definitions
\******************************************************************************/


/******************************************************************************\
*                        G L O B A L   S E C T I O N
\******************************************************************************/


/******************************************************************************\
* global variable definitions
\******************************************************************************/
#if (DMA_SUPPORT&&0)
  Uint32 _DMA_gblRegTbl[_DMA_GBLREG_CNT] = {
    /* [0x00] DMA_GBL_ADDRRLD 0 */ 0xFFFFFFFFu,
    /* [0x01] DMA_GBL_ADDRRLD 1 */ HDMA_GBLADDRB_ADDR,
    /* [0x02] DMA_GBL_ADDRRLD 2 */ HDMA_GBLADDRC_ADDR,
    /* [0x03] DMA_GBL_ADDRRLD 3 */ HDMA_GBLADDRD_ADDR,
    /* [0x04] DMA_GBL_INDEX   0 */ HDMA_GBLIDXA_ADDR,
    /* [0x05] DMA_GBL_INDEX   1 */ HDMA_GBLIDXB_ADDR,
    /* [0x06] DMA_GBL_INDEX   2 */ 0xFFFFFFFFu,
    /* [0x07] DMA_GBL_INDEX   3 */ 0xFFFFFFFFu,
    /* [0x08] DMA_GBL_CNTRLD  0 */ HDMA_GBLCNTA_ADDR,
    /* [0x09] DMA_GBL_CNTRLD  1 */ HDMA_GBLCNTB_ADDR,
    /* [0x0A] DMA_GBL_CNTRLD  2 */ 0xFFFFFFFFu,
    /* [0x0B] DMA_GBL_CNTRLD  3 */ 0xFFFFFFFFu,
    /* [0x0C] DMA_GBL_SPLIT   0 */ 0xFFFFFFFFu,
    /* [0x0D] DMA_GBL_SPLIT   1 */ HDMA_GBLADDRA_ADDR,
    /* [0x0E] DMA_GBL_SPLIT   2 */ HDMA_GBLADDRB_ADDR,
    /* [0x0F] DMA_GBL_SPLIT   3 */ HDMA_GBLADDRC_ADDR
  };
#endif


/******************************************************************************\
* global function definitions
\******************************************************************************/
#if (DMA_SUPPORT&&0)
/*----------------------------------------------------------------------------*/
Uint32 DMA_allocGlobalReg(DMA_Gbl regType, Uint32 initVal) {

  Uint32 gie;
  Uint32 regId = 0x00000000;
  Uint32 regNum0=0,regNum1=0,regNum=0;
  Uint32 mask = 0x00000000;

  gie = IRQ_globalDisable();

  switch (regType) {
    case DMA_GBL_ADDRRLD: regNum0=0x01; regNum1=0x03; mask = 0x20000000; break;
    case DMA_GBL_INDEX:   regNum0=0x04; regNum1=0x05; mask = 0x01000000; break;
    case DMA_GBL_CNTRLD:  regNum0=0x08; regNum1=0x09; mask = 0x00100000; break;
    case DMA_GBL_SPLIT:   regNum0=0x0D; regNum1=0x0F; mask = 0x10000000; break;
  }

  for (regNum=regNum0; regNum<=regNum1; regNum++) {
    if ((gblAllocMask & mask)==0) {
      gblAllocMask |= mask;
      regId = mask | regNum;
      DMA_setGlobalReg(regId,initVal);
      break;
    }
    mask = mask << 1;
  }

  IRQ_globalRestore(gie);

  return regId;
}

/*----------------------------------------------------------------------------*/
void DMA_freeGlobalReg(Uint32 regId) {

  Uint32 gie = IRQ_globalDisable();
  gblAllocMask &= ~(regId & 0xFFFF0000);
  IRQ_globalRestore(gie);
}

/*----------------------------------------------------------------------------*/
#endif /* DMA_SUPPORT */

#if (EMIF_SUPPORT)
/*----------------------------------------------------------------------------*/
void EMIF_ConfigA(EMIF_CONFIG *Config) {

  HEMIF_CECTL_SET(HEMIF_CE0CTL_ADDR, Config->ce0ctl);
  HEMIF_CECTL_SET(HEMIF_CE1CTL_ADDR, Config->ce1ctl);
  HEMIF_CECTL_SET(HEMIF_CE2CTL_ADDR, Config->ce2ctl);
  HEMIF_CECTL_SET(HEMIF_CE3CTL_ADDR, Config->ce3ctl);
  HEMIF_SDCTL_SET(HEMIF_SDCTL_ADDR, Config->sdctl);
  HEMIF_SDTIM_SET(HEMIF_SDTIM_ADDR, Config->sdtim);
  HEMIF_SDEXT_SET(HEMIF_SDEXT_ADDR, Config->sdext);
  HEMIF_GBLCTL_SET(HEMIF_GBLCTL_ADDR, Config->gblctl);
}

/*----------------------------------------------------------------------------*/
void EMIF_ConfigB(UINT32 gblctl, UINT32 ce0ctl, UINT32 ce1ctl,
  UINT32 ce2ctl, UINT32 ce3ctl, UINT32 sdctl, UINT32 sdtim, UINT32 sdext) {

  HEMIF_CECTL_SET(HEMIF_CE0CTL_ADDR, ce0ctl);
  HEMIF_CECTL_SET(HEMIF_CE1CTL_ADDR, ce1ctl);
  HEMIF_CECTL_SET(HEMIF_CE2CTL_ADDR, ce2ctl);
  HEMIF_CECTL_SET(HEMIF_CE3CTL_ADDR, ce3ctl);
  HEMIF_SDCTL_SET(HEMIF_SDCTL_ADDR, sdctl);
  HEMIF_SDTIM_SET(HEMIF_SDTIM_ADDR, sdtim);
  HEMIF_SDEXT_SET(HEMIF_SDEXT_ADDR, sdext);
  HEMIF_GBLCTL_SET(HEMIF_GBLCTL_ADDR, gblctl);
}
/*----------------------------------------------------------------------------*/
#endif /* EMIF_SUPPORT */


/******************************************************************************\
* End of csl_legacy.c
\******************************************************************************/

