/*
 * emif.c
 *
 *  Created on: 15 . 2020 .
 *      Author: Anton
 */

#include <c6x.h>
#include <csl.h> /* CSL library */
#include <csl_legacy.h>
#include <rom.h>
#include <csl_emif.h>
#include <Address_variable_data.h>
#include <emif.h>

//uint32 t[16000];

void emif_config()
{
    uint32_t word_GBLCTL = 0,
            word_mram = 0,
            word_fpga = 0,
            word_def = 0,
            word_sdctl = 0,
            word_sdctim = 0;
    /* Create Global Control Register field */
    word_GBLCTL = EMIF_GBLCTL_RMK(EMIF_GBLCTL_NOHOLD_0,
                                  EMIF_GBLCTL_SDCEN_DISABLE,
                                  EMIF_GBLCTL_SSCEN_DISABLE,
                                  EMIF_GBLCTL_CLK1EN_DISABLE,
                                  EMIF_GBLCTL_CLK2EN_DISABLE,
                                  EMIF_GBLCTL_SSCRT_CPU,
                                  EMIF_GBLCTL_RBTR8_HPRI);
    /* Create CE0 Control Register field */
    word_mram = EMIF_CECTL_RMK(EMIF_CECTL_WRSETUP_OF(2), //0-15
                              EMIF_CECTL_WRSTRB_OF(14), //0-63
                              EMIF_CECTL_WRHLD_OF(3),   //0-3
                              EMIF_CECTL_RDSETUP_OF(1), //0-15
                              EMIF_CECTL_RDSTRB_OF(21), //0-63
                              EMIF_CECTL_MTYPE_ASYNC8,
                              EMIF_CECTL_RDHLD_OF(3) ); //0-3
    /* Create CE1 Control Register field */
    word_fpga = EMIF_CECTL_RMK(EMIF_CECTL_WRSETUP_OF(3),
                              EMIF_CECTL_WRSTRB_OF(14),
                              EMIF_CECTL_WRHLD_OF(3),
                              EMIF_CECTL_RDSETUP_OF(1),
                              EMIF_CECTL_RDSTRB_OF(21),
                              EMIF_CECTL_MTYPE_ASYNC16,
                              EMIF_CECTL_RDHLD_OF(3) );
    /* Create CE2 Control Register field */
    word_def = EMIF_CECTL_DEFAULT;
    //word_sdctl = EMIF_MK_SDCTL(EMIF_SDCTL_DEFAULT);
    word_sdctl = EMIF_SDCTL_DEFAULT;

    //word_sdctim = EMIF_MK_SDTIM(EMIF_SDTIM_DEFAULT);
    word_sdctim = EMIF_SDTIM_DEFAULT;

    EMIF_configArgs(EMIF_GBLCTL_OF(word_GBLCTL), /* global control */
                    EMIF_CECTL_OF(word_def), /* CE0 control */
                    EMIF_CECTL_OF(word_mram), /* CE1 control */
                    EMIF_CECTL_OF(word_fpga), /* CE2 control */
                    EMIF_CECTL_OF(word_def), /* CE3 control */
                    EMIF_SDCTL_OF(word_sdctl), /* SDRAM control */
                    EMIF_SDTIM_OF(word_sdctim) /* SDRAM timing */
    );

    // TEST MRAM
    int i =0;
//    setReset(0);
    write_MRAM_data(0, (uint32_t *)rom_bin, rom_bin_size >> 2);
//
//    for (i = 0; i < 40; i++)
//       ((uint8_t *)t)[i] = i;
//
//    write_MRAM_data(0, t, 10);
//    memset(t, rom_bin_test, rom_bin_size);
//    read_MRAM_data(0, (uint32_t *)t, rom_bin_size >> 2);
//    uint8_t *p;
//    p = 0;
//    for (i = 0; i < (rom_bin_size >> 2); i++)
//    {
//        if (p[i] != t[i])
//        {
//            setReset(1);
//        }
//    }


    return;
}

void read_MRAM_data (uint32_t adr_MRAM, uint32_t *p, uint32_t lenght)
{
    int i;
    adr_MRAM = start_adr_MRAM + adr_MRAM;
    for (i = 0; i < lenght; i++)
    {
        p[i] = ((uint32_t *)adr_MRAM)[i];
    }
}

void write_MRAM_data (uint32_t adr_MRAM, uint32_t *p, uint32_t lenght)
{
    int i, j, t;
    adr_MRAM = start_adr_MRAM + adr_MRAM;
    for (i = 0, j = 0; i < lenght; i++, j+=4)
    {
        t = p[i];
//        ((uint32_t *)adr_MRAM)[j] = p[i];
//        ((uint32_t *)adr_MRAM)[j+1] = p[i] >> 8;
//        ((uint32_t *)adr_MRAM)[j+2] = p[i] >> 16;
//        ((uint32_t *)adr_MRAM)[j+3] = p[i] >> 24;
    }
}
