;//Project  Name: quickStartOMAPL1x McASP Chip Support Library Example
;//Texas Instruments Device Platform: Logic Product Development OMAP-L138 Experimentor Kit
;//Copywrite (c) 2011 Texas Instruments Incroporated


;/*===============================================================*/
;/****************************LICENSE *****************************/
;/*===============================================================*/
;/*
; * Copyright (C) 2011 Texas Instruments Incorporated - http://www.ti.com/
; *
; *  Redistribution and use in source and binary forms, with or without
; *  modification, are permitted provided that the following conditions
; *  are met:
; *
; *    Redistributions of source code must retain the above copyright
; *    notice, this list of conditions and the following disclaimer.
; *
; *    Redistributions in binary form must reproduce the above copyright
; *    notice, this list of conditions and the following disclaimer in the
; *    documentation and/or other materials provided with the
; *    distribution.
; *
; *    Neither the name of Texas Instruments Incorporated nor the names of
; *    its contributors may be used to endorse or promote products derived
; *    from this software without specific prior written permission.
; *
; *  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
; *  "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
; *  LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
; *  A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
; *  OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
; *  SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
; *  LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
; *  DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
; *  THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
; *  (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
; *  OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.*/







;*-----------------------------------------------------------------------------
;* Project: TIMER_interrupt_dspL138
;* File: intvecs.asm

;* 
;*	intvecs.asm
;*	-----------
;*
;*	Description:
;*		This file includes a generic setup to map the DSP interrupt service 
;*		table (IST) to the corresponding interrupt service routines (ISR).
;*
;*-----------------------------------------------------------------------------

; Make Symbols Globally Available as C Functions
	.global _c_int00
	.global _vectors
	.global _USELESS_ROUTE
	.global _NULL_ISR
	.global _EXT_INT4_ISR
	.global _EXT_INT5_ISR
	.global _EXT_INT6_ISR
	.global _EXT_INT7_ISR
	.global _DMA_INT0_ISR
	.global _DMA_INT1_ISR
	.global _SD_INT_ISR
	.global _DMA_INT2_ISR
	.global _DMA_INT3_ISR
	.global _DSPINT_ISR
	.global _TINT0_ISR
	.global _TINT1_ISR
    .global _MCBSP0_XINT_ISR
    .global _MCBSP0_RINT_ISR
    .global _MCBSP1_XINT_ISR
    .global _MCBSP1_RINT_ISR
    .global _c_int01
    .global _c_int02
    .global _INT1_ISR
    .global _INT2_ISR
    .global _INT3_ISR
    .global _INT4_ISR
    .global _INT5_ISR
    .global _INT6_ISR
    .global _INT7_ISR
    .global _INT8_ISR
    .global _INT9_ISR
    .global _INT10_ISR
    .global _INT11_ISR
    .global _INT12_ISR
    .global _INT13_ISR
    .global _INT14_ISR
    .global _INT15_ISR
    .global _IRQ_EVT_TINT0

;******************************************************************************
;* VEC_ENTRY: Macro that instantiates one entry in the interrupt service table.
;******************************************************************************

; Notes; This setups up the Interrupt Service Table Fetch Packet
; Interrupt Service Fetch Packet (ISFP) should be <= 8 32 bit words Long
;					
;	|Instruction #1|
;	|Instruction #2|
;	|Instruction #3|
;	|Instruction #4|  > Format of ISFP
;	|Instruction #5|
;	|Instruction #6|
;	|Instruction #7|
;	|Instruction #8|




; Macros
; The TMS320C6x assember supports a macro language that enables you to create your own instructions.
; Refer to the C6x Assembly Language Tools User's Guide for more information 
; SYNTAX
	;<macroname> .macro [Parameter #1] [Parameter #2]
	;            .endm
	
VEC_ENTRY .macro addr
	STW   B0,*--B15				;Store  Current Contents of B0 to the Stack				
	MVKL  addr,B0				;Load Address into B0
	MVKH  addr,B0
	B     B0					;Branch to B0 
	LDW   *B15++,B0				;Return B0 to Original State
	NOP   2						;2 NOP Cycles
	NOP							;  NOP Cycle
	NOP							;  NOP Cycle
		.endm

;**********************************************************************************************************
;* NULL_ISR: Null Interrupt Service Routine used to initialize a NULL Entry in the Interrupt Service Table.
;**********************************************************************************************************
_NULL_ISR:
	B    B3			;B3 is the return register
	NOP  5



;***************************************************************************************
;* Map interrupt service table (IST) to corresponding Interrupt Service Routines (ISR)
;***************************************************************************************
 .sect "vecs"
 .align 1024
;*****DSPintcVectorTable ********

_vectors:
_vector0:		VEC_ENTRY 	_c_int00		    ;RESET Interrupt Vector Entry
_vector1:       VEC_ENTRY   _TINT0_ISR
_vector2:       VEC_ENTRY   _TINT1_ISR
_vector3:		VEC_ENTRY 	_NULL_ISR		    ;Reserved in C674x
_vector4:		VEC_ENTRY 	_INT4_ISR		;C674x Maskable Interrupt #04 Vector Entry 	[INT4]
_vector5:		VEC_ENTRY 	_INT5_ISR		;C674x Maskable Interrupt #05 Vector Entry	[INT5]
_vector6:		VEC_ENTRY 	_INT6_ISR		;C674x Maskable Interrupt #06 Vector Entry	[INT6]
_vector7:		VEC_ENTRY 	_INT7_ISR		;C674x Maskable Interrupt #07 Vector Entry	[INT7]
_vector8:		VEC_ENTRY 	_INT8_ISR		;C674x Maskable Interrupt #08 Vector Entry	[INT8]
_vector9:		VEC_ENTRY 	_INT9_ISR		;C674x Maskable Interrupt #09 Vector Entry	[INT9]
_vector10:		VEC_ENTRY 	_INT10_ISR		;C674x Maskable Interrupt #10 Vector Entry	[INT10]
_vector11:		VEC_ENTRY 	_INT11_ISR		;C674x Maskable Interrupt #11 Vector Entry	[INT11]
_vector12:		VEC_ENTRY 	_INT12_ISR	;C674x Maskable Interrupt #12 Vector Entry	[INT12]
_vector13:		VEC_ENTRY 	_INT13_ISR	;C674x Maskable Interrupt #13 Vector Entry	[INT13]
_vector14:		VEC_ENTRY 	_INT14_ISR	;C674x Maskable Interrupt #14 Vector Entry	[INT14]
_vector15:		VEC_ENTRY 	_INT15_ISR	;C674x Maskable Interrupt #15 Vector Entry	[INT15]

;Notes
; Each externally visable identified is assigned a unique symbol to be used in the object file called
; a 'linkname'. See C6x Assembly Language Tools User's Guide for additional details.
; [a] In the COFF ABI, the linkname for all objects and functions is the same as the name in the C source
;     with an added underscore prefix. This prevents any C identifier from colliding with any idenfier in
;     the assembly code name space, such as an assember keyword
; [b] In EABI no prefix is used. If a C idenfier would colllide with an assembler keyword, the compiler will excape 
;     the identifier with double parallel bars, which instructs the assembler not to treate the identifier as a keyword.
;     The programmer is responsible for making sure that C idenfiers do not collide with user-defined assembler code
;     identifiers.

