/*
 * main.h
 *
 *  Created on: 6 . 2020 .
 *      Author: Anton
 */

#ifndef MAIN_H_
#define MAIN_H_

#include <myTypes.h>
#define M_PI 3.14159265358979323846f

#define CHIP_6701 1
#define flagISRPLIS_mask  0x00000001;
#define flagTochGot_mask  0x00000002;
#define flagVPICom_mask  0x00000004;

typedef struct //   
{
    Uint32 flagISRPLIS : 1; //     
    Uint32 flagTochGot : 1; //       ()
    Uint32 flagVPICom : 1;  //       (  )
    Uint32 ChangePLLflag : 1;  //      ( / )
    Uint32 ChangeCikl : 1;  //     ( / )
    Uint32 VPI_Buf_flag : 1;  //    (10  )
}   TProgram_Flag;

typedef struct                       // 
{
    Uint32 pll_flags:          4;  // 
    Uint32 ampl_flag:          4;  //  .
    Uint32 quadr_flag:         4;  //  
    Uint32 angl_flag:          4;  //  
                                    //0  /    
                                    //1   
                                    //2    
                                    //3  
    Uint32 ampl_stabilised:     1;  //   / 
    Uint32 big_speed:           1;  //    
    Uint32 big_angle:           1;  //     
    Uint32 mode_TVG:            3;  //      腻
    Uint32 functional_ready:    1;  //  
    Uint32 accuracy_ready:      1;  //  
    Uint32 mode_tecnology:      2;  //  - :
                                    //00  ;
                                    //01    ;
                                    //10   ;
                                    //11   ,  .
    Uint32 time_out_of_range:   1;  //  
    Uint32 angle_out_of_range:  1;  //   
    Uint32 error_out_of_range:  1;  //  
    Uint32 en_var:              1;  //  
    Uint32 mode_abonent:        2;  //  :
                                    //00   ; 01   ; 11   .
} Tsystem_flags_s;

typedef struct //   
{
    Uint32 flagVPICom : 1;  //       (  )
    Uint32 VPI_Buf_flag : 1;  //    (10  )
    Uint32 ChangeBuf : 1;  //      ( / )
    Uint32 TempReady : 1;  //    (10  )
}   TVPI_Flag;

extern volatile Tsystem_flags_s sysflag;
extern volatile TProgram_Flag Program_Flag;
extern volatile TVPI_Flag VPI_flag;


#endif /* MAIN_H_ */
