L 1 "../csl/_csl_irq.c"
N/******************************************************************************\
N*           Copyright (C) 1999-2000 Texas Instruments Incorporated.
X
N*                           All Rights Reserved
N*------------------------------------------------------------------------------
N* FILENAME...... _csl_irq.c
N* DATE CREATED.. 02/02/2001
N\******************************************************************************/
N#include "csl_irq.h"
L 1 "..\csl\csl_irq.h" 1
N/******************************************************************************\
N*           Copyright (C) 1999-2000 Texas Instruments Incorporated.
X
N*                           All Rights Reserved
N*------------------------------------------------------------------------------
N* FILENAME...... csl_irq.h
N* DATE CREATED.. 06/09/1999 
N* LAST MODIFIED. 08/02/2004 - Adding support for C6418
N*                07/24/2004 - Re-introducing BIOS components from CSL due to compatibility issues.
N*                02/05/2004 Removed bios related components 
N*                10/03/2001
N*                - CHIP_RSET()/CHIP_RGET() replaced by CHIP_CRSET()/CHIP_CRGET()
N\******************************************************************************/
N#ifndef _CSL_IRQ_H_
N#define _CSL_IRQ_H_
N
N#include <csl_stdinc.h>
L 1 "E:/TI_workspase/c6701_t/csl/csl_stdinc.h" 1
N/******************************************************************************\
N*           Copyright (C) 1999-2000 Texas Instruments Incorporated.
X
N*                           All Rights Reserved
N*------------------------------------------------------------------------------
N* FILENAME...... csl_stdinc.h
N* DATE CREATED.. 03/11/1999 
N* LAST MODIFIED. 10/03/2000
N*                01/06/2005    Added _TI_STD_TYPES  directive to protect 
N*                              multiple definition of datatypes.
N\******************************************************************************/
N#ifndef _CSL_STDINC_H_
N#define _CSL_STDINC_H_
N
N#include <csl_stdinchal.h>
L 1 "E:/TI_workspase/c6701_t/csl/csl_stdinchal.h" 1
N/******************************************************************************\
N*           Copyright (C) 1999-2000 Texas Instruments Incorporated.
X
N*                           All Rights Reserved
N*------------------------------------------------------------------------------
N* FILENAME...... csl_stdinchal.h
N* DATE CREATED.. 03/11/1999 
N* LAST MODIFIED. 03/23/2001
N\******************************************************************************/
N#ifndef _CSL_STDINCHAL_H_
N#define _CSL_STDINCHAL_H_
N
N
N/******************************************************************************\
N* HAL macro definitions
X
N\******************************************************************************/
N
N  #define _VALUEOF(x) ((Uint32)(x))
N
N  /*******************************************************/
N  /* generic macros for field manipulation               */
N  /*******************************************************/
N
N  #define _PER_FSHIFT(PER,REG,FIELD) \
N    _##PER##_##REG##_##FIELD##_SHIFT
X  #define _PER_FSHIFT(PER,REG,FIELD)     _##PER##_##REG##_##FIELD##_SHIFT
N
N  #define _PER_FMASK(PER,REG,FIELD) \
N    _##PER##_##REG##_##FIELD##_MASK
X  #define _PER_FMASK(PER,REG,FIELD)     _##PER##_##REG##_##FIELD##_MASK
N
N  #define _PER_FSYM(PER,REG,FIELD,SYM)\
N    PER##_##REG##_##FIELD##_##SYM
X  #define _PER_FSYM(PER,REG,FIELD,SYM)    PER##_##REG##_##FIELD##_##SYM
N
N  #define _PER_FDEFAULT(PER,REG,FIELD) \
N    ((##PER##_##REG##_##FIELD##_DEFAULT << _##PER##_##REG##_##FIELD##_SHIFT) \
N    & _##PER##_##REG##_##FIELD##_MASK)
X  #define _PER_FDEFAULT(PER,REG,FIELD)     ((##PER##_##REG##_##FIELD##_DEFAULT << _##PER##_##REG##_##FIELD##_SHIFT)     & _##PER##_##REG##_##FIELD##_MASK)
N
N  #define _PER_FMK(PER,REG,FIELD,x) (\
N    (((Uint32)(x))<<_PER_FSHIFT(##PER,##REG,##FIELD))\
N    &_PER_FMASK(##PER,##REG,##FIELD)\
N  )
X  #define _PER_FMK(PER,REG,FIELD,x) (    (((Uint32)(x))<<_PER_FSHIFT(##PER,##REG,##FIELD))    &_PER_FMASK(##PER,##REG,##FIELD)  )
N
N  #define _PER_FMKS(PER,REG,FIELD,SYM) (\
N    (_PER_FSYM(##PER,##REG,##FIELD,##SYM)<<_PER_FSHIFT(##PER,##REG,##FIELD))\
N    &_PER_FMASK(##PER,##REG,##FIELD)\
N  )
X  #define _PER_FMKS(PER,REG,FIELD,SYM) (    (_PER_FSYM(##PER,##REG,##FIELD,##SYM)<<_PER_FSHIFT(##PER,##REG,##FIELD))    &_PER_FMASK(##PER,##REG,##FIELD)  )
N
N  #define _PER_FEXTRACT(PER,REG,FIELD,reg) (Uint32)(\
N    (((Uint32)(reg)&_PER_FMASK(##PER,##REG,##FIELD))\
N    >>_PER_FSHIFT(##PER,##REG,##FIELD))\
N  )
X  #define _PER_FEXTRACT(PER,REG,FIELD,reg) (Uint32)(    (((Uint32)(reg)&_PER_FMASK(##PER,##REG,##FIELD))    >>_PER_FSHIFT(##PER,##REG,##FIELD))  )
N
N  #define _PER_FINSERT(PER,REG,FIELD,reg,field) (Uint32)(\
N    (((Uint32)(reg)&~_PER_FMASK(##PER,##REG,##FIELD))|\
N    (((Uint32)(field)<<_PER_FSHIFT(##PER,##REG,##FIELD))\
N    &_PER_FMASK(##PER,##REG,##FIELD)))\
N  )
X  #define _PER_FINSERT(PER,REG,FIELD,reg,field) (Uint32)(    (((Uint32)(reg)&~_PER_FMASK(##PER,##REG,##FIELD))|    (((Uint32)(field)<<_PER_FSHIFT(##PER,##REG,##FIELD))    &_PER_FMASK(##PER,##REG,##FIELD)))  )
N
N  /*******************************************************/
N  /* macros for memmory mapped registers                 */
N  /*******************************************************/
N
N  #define _PER_RAOI(addr,PER,REG,and,or,inv)\
N    (*(volatile Uint32*)(addr))=(\
N      ((((*(volatile Uint32*)(addr))\
N      &((Uint32)(and)))\
N      |((Uint32)(or)))\
N      ^((Uint32)(inv)))\
N    )
X  #define _PER_RAOI(addr,PER,REG,and,or,inv)    (*(volatile Uint32*)(addr))=(      ((((*(volatile Uint32*)(addr))      &((Uint32)(and)))      |((Uint32)(or)))      ^((Uint32)(inv)))    )
N
N  #define _PER_RGET(addr,PER,REG) \
N    (*(volatile Uint32*)(addr))
X  #define _PER_RGET(addr,PER,REG)     (*(volatile Uint32*)(addr))
N
N  #define _PER_RSET(addr,PER,REG,x) \
N    (*(volatile Uint32*)(addr))=((Uint32)(x))
X  #define _PER_RSET(addr,PER,REG,x)     (*(volatile Uint32*)(addr))=((Uint32)(x))
N
N  #define _PER_FGET(addr,PER,REG,FIELD) \
N    _PER_FEXTRACT(##PER,##REG,##FIELD,_PER_RGET(addr,##PER,##REG))
X  #define _PER_FGET(addr,PER,REG,FIELD)     _PER_FEXTRACT(##PER,##REG,##FIELD,_PER_RGET(addr,##PER,##REG))
N
N  #define _PER_FSET(addr,PER,REG,FIELD,field)\
N    _PER_RSET(addr,##PER,##REG,\
N    _PER_FINSERT(##PER,##REG,##FIELD,_PER_RGET(addr,##PER,##REG),field))
X  #define _PER_FSET(addr,PER,REG,FIELD,field)    _PER_RSET(addr,##PER,##REG,    _PER_FINSERT(##PER,##REG,##FIELD,_PER_RGET(addr,##PER,##REG),field))
N
N  #define _PER_FSETS(addr,PER,REG,FIELD,SYM)\
N    _PER_RSET(addr,##PER,##REG,_PER_FINSERT(##PER,##REG,##FIELD,_PER_RGET(addr,##PER,##REG),\
N    _PER_FSYM(##PER,##REG,##FIELD,##SYM)))
X  #define _PER_FSETS(addr,PER,REG,FIELD,SYM)    _PER_RSET(addr,##PER,##REG,_PER_FINSERT(##PER,##REG,##FIELD,_PER_RGET(addr,##PER,##REG),    _PER_FSYM(##PER,##REG,##FIELD,##SYM)))
N
N  /*******************************************************/
N  /* macros for CPU control registers                    */
N  /*******************************************************/
N
N  #define _PER_CRGET(PER,REG) \
N    REG
X  #define _PER_CRGET(PER,REG)     REG
N
N  #define _PER_CRSET(PER,REG,reg) \
N    REG=((Uint32)(reg))
X  #define _PER_CRSET(PER,REG,reg)     REG=((Uint32)(reg))
N
N  #define _PER_CFGET(PER,REG,FIELD) \
N    _PER_FEXTRACT(##PER,##REG,##FIELD,_PER_CRGET(##PER,##REG))
X  #define _PER_CFGET(PER,REG,FIELD)     _PER_FEXTRACT(##PER,##REG,##FIELD,_PER_CRGET(##PER,##REG))
N
N  #define _PER_CFSET(PER,REG,FIELD,field)\
N    _PER_CRSET(##PER,##REG,\
N    _PER_FINSERT(##PER,##REG,##FIELD,_PER_CRGET(##PER,##REG),field))
X  #define _PER_CFSET(PER,REG,FIELD,field)    _PER_CRSET(##PER,##REG,    _PER_FINSERT(##PER,##REG,##FIELD,_PER_CRGET(##PER,##REG),field))
N
N  #define _PER_CFSETS(PER,REG,FIELD,SYM)\
N    _PER_CRSET(##PER,##REG,\
N    _PER_FINSERT(##PER,##REG,FIELD,_PER_CRGET(##PER,##REG),\
N    _PER_FSYM(##PER,##REG,##FIELD,##SYM)))
X  #define _PER_CFSETS(PER,REG,FIELD,SYM)    _PER_CRSET(##PER,##REG,    _PER_FINSERT(##PER,##REG,FIELD,_PER_CRGET(##PER,##REG),    _PER_FSYM(##PER,##REG,##FIELD,##SYM)))
N
N/*----------------------------------------------------------------------------*/
N
N#endif /* _CSL_STDINCHAL_H_ */
N/******************************************************************************\
N* End of csl_stdinchal.h
X
N\******************************************************************************/
N
L 15 "E:/TI_workspase/c6701_t/csl/csl_stdinc.h" 2
N
N
N/******************************************************************************\
N* macro declarations
X
N\******************************************************************************/
N
N/* a few standard constants */
N#ifndef TRUE
N  #define TRUE   1
N#endif
N#ifndef FALSE
N  #define FALSE  0
N#endif
N
N/* Invalid Pointer                                               */
N/* In many instances, it is better to use INV as opposed to NULL */
N/* because 0 may actually be a valid pointer                     */
N#ifndef INV
N  #define INV    ((void*)(-1))
N#endif
N
N#ifndef UNREFERENCED_PARAMETER
N  #define UNREFERENCED_PARAMETER(P)    ((P)=(P))
N#endif
N
N#ifndef REG32
N  #define REG32(addr) (*(volatile unsigned int*)(addr))
N  #define REG16(addr) (*(volatile unsigned short*)(addr))
N  #define REG8(addr)  (*(volatile unsigned char*)(addr))
N#endif
N
N/******************************************************************************\
N* typedef declarations
X
N\******************************************************************************/
N
N#include <tistdtypes.h> /* use typedefs provided with CCS*/
L 1 "E:/TI_workspase/c6701_t/csl/tistdtypes.h" 1
N/*
N *  ======== tistdtypes.h ========
N */
N
N/*
N * These types are also defined by other TI components.  They are bracketed
N * with _TI_STD_TYPES to avoid warnings for duplicate definition.
N *
N * You may get warnings about duplicate type definitions when using this
N * header file with earlier versions of DSP/BIOS and CSL.
N *
N * You can use the '-pds303' compiler option to suppress these warnings.
N */
N#ifndef _TI_STD_TYPES
N#define _TI_STD_TYPES
N
N/*
N * This '#ifndef STD_' is needed to protect from duplicate definitions
N * of Int, Uns, etc. in DSP/BIOS v4.x (e.g. 4.90, 4.80) since these versions
N * of DSP/BIOS did not contain the '#ifndef_TI_STD_TYPES' logic.
N */
N#ifndef STD_
N
N/*
N * Aliases for standard C types
N */
Ntypedef int			Int;
Ntypedef unsigned		Uns;
Ntypedef char			Char;
N
N/* pointer to null-terminated character sequence */
Ntypedef char			*String;
N
Ntypedef void			*Ptr;		/* pointer to arbitrary type */
N
Ntypedef unsigned short		Bool;		/* boolean */
N
N#endif /* STD_ */
N
N/*
N * Uint8, Uint16, Uint32, etc are defined to be "smallest unit of
N * available storage that is large enough to hold unsigned or integer
N * of specified size".
N */
N
N/* Handle the 6x ISA */
N#if defined(_TMS320C6X)
X#if 1L
N    /* Unsigned integer definitions (32bit, 16bit, 8bit) follow... */
N    typedef unsigned int	Uint32;
N    typedef unsigned short	Uint16;
N    typedef unsigned char	Uint8;
N
N    /* Signed integer definitions (32bit, 16bit, 8bit) follow... */
N    typedef int			Int32;
N    typedef short		Int16;
N    typedef char		Int8;
N
N/* Handle the 54x, 55x and 28x ISAs */
N#elif defined(_TMS320C5XX) || defined(__TMS320C55X__) || defined(_TMS320C28X)
S    /* Unsigned integer definitions (32bit, 16bit, 8bit) follow... */
S    typedef unsigned long	Uint32;
S    typedef unsigned short	Uint16;
S    typedef unsigned char	Uint8;
S
S    /* Signed integer definitions (32bit, 16bit, 8bit) follow... */
S    typedef long		Int32;
S    typedef short		Int16;
S    typedef char		Int8;
S
S#else
S    /* Other ISAs not supported */
S    #error <tistdtypes.h> is not supported for this target
N#endif  /* defined(_6x_) */
N
N#endif  /* _TI_STD_TYPES */
L 51 "E:/TI_workspase/c6701_t/csl/csl_stdinc.h" 2
N
N/******************************************************************************\
N* variable declarations
X
N\******************************************************************************/
N
N
N typedef long             Int40;
N typedef unsigned long    Uint40;
N/******************************************************************************\
N* function declarations
X
N\******************************************************************************/
N
N
N#endif /* _CSL_STDINC_H_ */
N/******************************************************************************\
N* End of csl_stdinc.h
X
N\******************************************************************************/
N
L 17 "..\csl\csl_irq.h" 2
N#include <csl_chip.h>
L 1 "E:/TI_workspase/c6701_t/csl/csl_chip.h" 1
N/******************************************************************************\
N*           Copyright (C) 1999-2001 Texas Instruments Incorporated.
X
N*                           All Rights Reserved
N*------------------------------------------------------------------------------
N* FILENAME...... csl_chip.h
N* DATE CREATED.. 08/19/1999 
N* LAST MODIFIED. 08/02/2004 - Adding support for C6418
N*                06/17/2003   - Added support for 6712C
N*                06/09/2003   - Added support for 6711C
N*                12/03/2001   - CHIP_configArgs
N*                11/08/2001   - CHIP_getSiliconRevId()
N*                             - CHIP_config() / CHIP_getConfig  DM642
N\******************************************************************************/
N#ifndef _CSL_CHIP_H_
N#define _CSL_CHIP_H_
N
N#include <csl_stdinc.h>
N
N#include <csl_chiphal.h>
L 1 "E:/TI_workspase/c6701_t/csl/csl_chiphal.h" 1
N/******************************************************************************\
N*           Copyright (C) 2000 Texas Instruments Incorporated.
X
N*                           All Rights Reserved
N*------------------------------------------------------------------------------
N* FILENAME...... csl_chiphal.h
N* DATE CREATED.. 14 Aug 2000
N* LAST MODIFIED. 14 Jan 2004 Adding support for DRI300 versions (6410, 6413)
N*                05 Aug 2003 Removing external control cregisters EM,ER,IN,OUT and DIER.
N*                26 Jun 2003 Added support for 6411
N*                17 Jun 2003 Added support for 6712C
N*                28 May 2003 Added support for 6711C
N*                05 Nov 2001 DM642 , 6411 remove 6400
N*                03 Oct 2001 - CHIP_6713 - MCASP_SUPPORT - IIC_SUPPORT
N*                           - PERCFG register
N*                           - redefinition of CHIP_RSET() / CHIP_RGET()
N*                           - new CHIP_CRSET() / CHIP_CRGET() => modification of csl_irq.h
N*                04 Apr 2004-  Removing external control cregisters EM,ER,IN,OUT and DIER.
N*                12 Jan 2005-  Removing external control cregisters FMCR,FADCR,FAUCR and GFPGFR
N*                06 Apr 2005-  Removing the macros ATLEN,ATLMEN and ADIV according to data manual 
N*                              tms320c6410(13)-sprs247 dated: Feb26 2004 specifications. 
N*				 26 Jul 2005-  Added C++ support.
N*------------------------------------------------------------------------------
N* REGISTERS
N*
N* CSR    - control/status register
N* IFR    - interrupt flag register
N* ISR    - interrupt set register
N* ICR    - interrupt clear register
N* IER    - interrupt enable register
N* ISTP   - interrupt service table pointer register
N* IRP    - interrupt return pointer
N* NRP    - non-maskable interrupt return pointer
N* AMR    - addressing mode reister
N* PERCFG - Device Configuration register  (4)
N* DEVSTAT - Device Status Register (5)
N* JTAGID - JTAG ID register (5)
N*
N* (1) only supported on 67xx
N* (2) only supported on floating point devices
N* (3) only supported on 6411/14/15/16 devices
N* (4) only supported on 6713/DA610/DM642/6412/6711C/6712C devices
N* (5) only supported on DM642/6412/6410/6413 devices
N*
N\******************************************************************************/
N#ifndef _CSL_CHIPHAL_H_
N#define _CSL_CHIPHAL_H_
N
N#include <csl_stdinc.h>
N
N#ifdef __cplusplus
Sextern "C" {
N#endif
N
N
N/******************************************************************************\
N* CHIP identification section
X
N\******************************************************************************/
N#ifdef CHIP_BASELINE
S  #undef CHIP_BASELINE
S  #define CHIP_BASELINE 1
N#else
N  #define CHIP_BASELINE 0
N#endif
N
N#if (CHIP_BASELINE)
X#if (0)
S  #define CHIP_6201 1
N#endif
N
N#ifdef CHIP_6201
S  #undef CHIP_6201
S  #define CHIP_6201 1
N#else
N  #define CHIP_6201 0
N#endif
N
N#ifdef CHIP_6202
S  #undef CHIP_6202
S  #define CHIP_6202 1
N#else
N  #define CHIP_6202 0
N#endif
N
N#ifdef CHIP_6203
S  #undef CHIP_6203
S  #define CHIP_6203 1
N#else
N  #define CHIP_6203 0
N#endif
N
N#ifdef CHIP_6204
S  #undef CHIP_6204
S  #define CHIP_6204 1
N#else
N  #define CHIP_6204 0
N#endif
N
N#ifdef CHIP_6205
S  #undef CHIP_6205
S  #define CHIP_6205 1
N#else
N  #define CHIP_6205 0
N#endif
N
N#ifdef CHIP_6211
S  #undef CHIP_6211
S  #define CHIP_6211 1
N#else
N  #define CHIP_6211 0
N#endif
N
N#ifdef CHIP_6701
N  #undef CHIP_6701
N  #define CHIP_6701 1
N#else
S  #define CHIP_6701 0
N#endif
N
N#ifdef CHIP_6711
S  #undef CHIP_6711
S  #define CHIP_6711 1
N#else
N  #define CHIP_6711 0
N#endif
N
N#ifdef CHIP_6712
S  #undef CHIP_6712
S  #define CHIP_6712 1
N#else
N  #define CHIP_6712 0
N#endif
N
N
N#ifdef CHIP_6713
S  #undef CHIP_6713
S  #define CHIP_6713 1
N#else
N  #define CHIP_6713 0
N#endif
N
N#ifdef CHIP_DA610
S  #undef CHIP_DA610
S  #define CHIP_DA610 1
N#else
N  #define CHIP_DA610 0
N#endif
N
N#ifdef CHIP_DM642
S  #undef CHIP_DM642
S  #define CHIP_DM642 1
N#else
N  #define CHIP_DM642 0
N#endif
N
N#ifdef CHIP_DM641
S  #undef CHIP_DM641
S  #define CHIP_DM641 1
N#else
N  #define CHIP_DM641 0
N#endif
N
N#ifdef CHIP_DM640
S  #undef CHIP_DM640
S  #define CHIP_DM640 1
N#else
N  #define CHIP_DM640 0
N#endif
N
N#ifdef CHIP_6412
S  #undef CHIP_6412
S  #define CHIP_6412 1
N#else
N  #define CHIP_6412 0
N#endif
N
N#ifdef CHIP_6414
S  #undef CHIP_6414
S  #define CHIP_6414 1
N#else
N  #define CHIP_6414 0
N#endif
N
N#ifdef CHIP_6415
S  #undef CHIP_6415
S  #define CHIP_6415 1
N#else
N  #define CHIP_6415 0
N#endif
N
N#ifdef CHIP_6416
S  #undef CHIP_6416
S  #define CHIP_6416 1
N#else
N  #define CHIP_6416 0
N#endif
N
N#ifdef CHIP_6711C
S  #undef CHIP_6711C
S  #define CHIP_6711C 1
N#else
N  #define CHIP_6711C 0
N#endif
N
N#ifdef CHIP_6712C
S  #undef CHIP_6712C
S  #define CHIP_6712C 1
N#else
N  #define CHIP_6712C 0
N#endif
N
N#ifdef CHIP_6411
S  #undef CHIP_6411
S  #define CHIP_6411 1
N#else
N  #define CHIP_6411 0
N#endif
N
N/* next two are DRI300 versions */
N#ifdef CHIP_6410
S  #undef CHIP_6410
S  #define CHIP_6410 1
N#else
N  #define CHIP_6410 0
N#endif
N
N#ifdef CHIP_6413
S  #undef CHIP_6413
S  #define CHIP_6413 1
N#else
N  #define CHIP_6413 0
N#endif
N
N#ifdef CHIP_6418
S  #undef CHIP_6418
S  #define CHIP_6418 1
N#else
N  #define CHIP_6418 0
N#endif
N
N#define CHIP_OROFALL (\
N  CHIP_6201 | \
N  CHIP_6202 | \
N  CHIP_6203 | \
N  CHIP_6204 | \
N  CHIP_6205 | \
N  CHIP_6211 | \
N  CHIP_6701 | \
N  CHIP_6711 | \
N  CHIP_6712 | \
N  CHIP_6713 | \
N  CHIP_DA610 | \
N  CHIP_DM642 | \
N  CHIP_DM641 | \
N  CHIP_DM640 | \
N  CHIP_6412 | \
N  CHIP_6414 | \
N  CHIP_6415 | \
N  CHIP_6416 |  \
N  CHIP_6711C | \
N  CHIP_6712C | \
N  CHIP_6411 |\
N  CHIP_6410 |\
N  CHIP_6413 |\
N  CHIP_6418 \
N)
X#define CHIP_OROFALL (  CHIP_6201 |   CHIP_6202 |   CHIP_6203 |   CHIP_6204 |   CHIP_6205 |   CHIP_6211 |   CHIP_6701 |   CHIP_6711 |   CHIP_6712 |   CHIP_6713 |   CHIP_DA610 |   CHIP_DM642 |   CHIP_DM641 |   CHIP_DM640 |   CHIP_6412 |   CHIP_6414 |   CHIP_6415 |   CHIP_6416 |    CHIP_6711C |   CHIP_6712C |   CHIP_6411 |  CHIP_6410 |  CHIP_6413 |  CHIP_6418 )
N
N#if (CHIP_OROFALL==0)
X#if (( 0 | 0 | 0 | 0 | 0 | 0 | 1 | 0 | 0 | 0 | 0 | 0 | 0 | 0 | 0 | 0 | 0 | 0 | 0 | 0 | 0 | 0 | 0 | 0 )==0)
S  #error NO CHIP DEFINED (use -dCHIP_XXXX where XXXX is chip number, i.e. 6201)
N#endif
N
N#define CHIP_NONE 0
N
N#define CHIP_SUPPORT(c0,c1,c2,c3,c4,c5,c6,c7,c8,c9,c10,c11,c12,c13,c14,c15,c16,c17,c18,c19,c20,c21,c22,c23,c24) ( \
N  ( c0*CHIP_6201)  | \
N  ( c1*CHIP_6202)  | \
N  ( c2*CHIP_6203)  | \
N  ( c3*CHIP_6204)  | \
N  ( c4*CHIP_6205)  | \
N  ( c5*CHIP_6211)  | \
N  ( c6*CHIP_6701)  | \
N  ( c7*CHIP_6711)  | \
N  ( c8*CHIP_6712)  | \
N  ( c9*CHIP_6713)  | \
N  ( c10*CHIP_DA610)| \
N  ( c11*CHIP_DM642)| \
N  ( c12*CHIP_DM641)| \
N  ( c13*CHIP_DM640)| \
N  ( c14*CHIP_6412) | \
N  ( c15*CHIP_6414) | \
N  ( c16*CHIP_6415) | \
N  ( c17*CHIP_6416) | \
N  ( c18*CHIP_6711C) | \
N  ( c19*CHIP_6712C) | \
N  ( c20*CHIP_6411) | \
N  ( c21*CHIP_6410) | \
N  ( c22*CHIP_6413) | \
N  ( c23*CHIP_6418) | \
N  ( c24*CHIP_NONE)   \
N )
X#define CHIP_SUPPORT(c0,c1,c2,c3,c4,c5,c6,c7,c8,c9,c10,c11,c12,c13,c14,c15,c16,c17,c18,c19,c20,c21,c22,c23,c24) (   ( c0*CHIP_6201)  |   ( c1*CHIP_6202)  |   ( c2*CHIP_6203)  |   ( c3*CHIP_6204)  |   ( c4*CHIP_6205)  |   ( c5*CHIP_6211)  |   ( c6*CHIP_6701)  |   ( c7*CHIP_6711)  |   ( c8*CHIP_6712)  |   ( c9*CHIP_6713)  |   ( c10*CHIP_DA610)|   ( c11*CHIP_DM642)|   ( c12*CHIP_DM641)|   ( c13*CHIP_DM640)|   ( c14*CHIP_6412) |   ( c15*CHIP_6414) |   ( c16*CHIP_6415) |   ( c17*CHIP_6416) |   ( c18*CHIP_6711C) |   ( c19*CHIP_6712C) |   ( c20*CHIP_6411) |   ( c21*CHIP_6410) |   ( c22*CHIP_6413) |   ( c23*CHIP_6418) |   ( c24*CHIP_NONE)    )
N
N/*---------------------------------------------------------------------------------------*/
N/*                                     6 6 6 6 6 6 6 6 6 6 D D D D 6 6 6 6 6 6 6 6 6 6 N */
N/*                                     2 2 2 2 2 2 7 7 7 7 A M M M 4 4 4 4 7 7 4 4 4 4 O */
N/*                                     0 0 0 0 0 1 0 1 1 1 6 6 6 6 1 1 1 1 1 1 1 1 1 1 N */
N/*                                     1 2 3 4 5 1 1 1 2 3 1 4 4 4 2 4 5 6 1 2 1 0 3 8 E */
N/*                                                         0 2 1 0         C C           */
N/*---------------------------------------------------------------------------------------*/
N#define CACHE_SUPPORT     CHIP_SUPPORT(1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0)
N#define DMA_SUPPORT       CHIP_SUPPORT(1,1,1,1,1,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0)
N#define EDMA_SUPPORT      CHIP_SUPPORT(0,0,0,0,0,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0)
N#define EMIF_SUPPORT      CHIP_SUPPORT(1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,0,0,0,0,0)
N#define EMIFA_SUPPORT     CHIP_SUPPORT(0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,1,1,1,1,0)
N#define EMIFB_SUPPORT     CHIP_SUPPORT(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0)
N#define GPIO_SUPPORT      CHIP_SUPPORT(0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0)
N#define HPI_SUPPORT       CHIP_SUPPORT(1,0,0,0,0,1,1,1,0,1,1,1,1,0,1,1,1,1,1,0,1,1,1,1,0)
N#define I2C_SUPPORT       CHIP_SUPPORT(0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,0)
N#define IRQ_SUPPORT       CHIP_SUPPORT(1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0)
N#define MCASP_SUPPORT     CHIP_SUPPORT(0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,0)
N#define MCBSP_SUPPORT     CHIP_SUPPORT(1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0)
N#define PLL_SUPPORT       CHIP_SUPPORT(0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,1,1,0,0,0,0,0)
N#define TIMER_SUPPORT     CHIP_SUPPORT(1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0)
N#define XBUS_SUPPORT      CHIP_SUPPORT(0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0)
N#define PCI_SUPPORT       CHIP_SUPPORT(0,0,0,0,1,0,0,0,0,0,0,1,0,0,1,0,1,1,0,0,1,0,0,0,0)
N/*---------------------------------------------------------------------------------------*/
N/*                                     6 6 6 6 6 6 6 6 6 6 D D D D 6 6 6 6 6 6 6 6 6 6 N */
N/*                                     2 2 2 2 2 2 7 7 7 7 A M M M 4 4 4 4 7 7 4 4 4 4 O */
N/*                                     0 0 0 0 0 1 0 1 1 1 6 6 6 6 1 1 1 1 1 1 1 1 1 1 N */
N/*                                     1 2 3 4 5 1 1 1 2 3 1 4 4 4 2 4 5 6 1 2 1 0 3 8 E */
N/*                                                         0 2 1 0         C C           */
N/*---------------------------------------------------------------------------------------*/
N#define VP_SUPPORT        CHIP_SUPPORT(0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0)
N#define VIC_SUPPORT       CHIP_SUPPORT(0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0)
N#define DAT_SUPPORT       CHIP_SUPPORT(1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0)
N#define PWR_SUPPORT       CHIP_SUPPORT(1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0)
N#define UTOP_SUPPORT      CHIP_SUPPORT(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0)
N#define TCP_SUPPORT       CHIP_SUPPORT(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0)
N#define VCP_SUPPORT       CHIP_SUPPORT(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,1,0)
N#define EMAC_SUPPORT      CHIP_SUPPORT(0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0)
N#define MDIO_SUPPORT      CHIP_SUPPORT(0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0)
N#define EMU_SUPPORT	  CHIP_SUPPORT(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0)
N                                                                                       
N#define L2CACHE_SUPPORT   CHIP_SUPPORT(0,0,0,0,0,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0)
N#define TC_SUPPORT        CHIP_SUPPORT(0,0,0,0,0,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0)
N#define FPU_SUPPORT       CHIP_SUPPORT(0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,1,1,0,0,0,0,0)
N#define C01_SUPPORT       CHIP_SUPPORT(1,1,1,1,1,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0)
N#define C11_SUPPORT       CHIP_SUPPORT(0,0,0,0,0,1,0,1,1,1,1,0,0,0,0,0,0,0,1,1,0,0,0,0,0)
N#define C64_SUPPORT       CHIP_SUPPORT(0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,1,1,1,1,0)
N#define ATL_SUPPORT       CHIP_SUPPORT(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0)
N
N#define CACHE_L2_SUPPORT  L2CACHE_SUPPORT
N/*----------------------------------------------------------------------*/
N
N
N/******************************************************************************\
N* module level register/field access macros
X
N\******************************************************************************/
N
N  /* ----------------- */
N  /* FIELD MAKE MACROS */
N  /* ----------------- */
N
N  #define CHIP_FMK(REG,FIELD,x)\
N    _PER_FMK(CHIP,##REG,##FIELD,x)
X  #define CHIP_FMK(REG,FIELD,x)    _PER_FMK(CHIP,##REG,##FIELD,x)
N
N  #define CHIP_FMKS(REG,FIELD,SYM)\
N    _PER_FMKS(CHIP,##REG,##FIELD,##SYM)
X  #define CHIP_FMKS(REG,FIELD,SYM)    _PER_FMKS(CHIP,##REG,##FIELD,##SYM)
N
N
N  /* -------------------------------- */
N  /* RAW REGISTER/FIELD ACCESS MACROS */
N  /* -------------------------------- */
N
N  #define CHIP_CRGET(REG)\
N    _PER_CRGET(CHIP,##REG)
X  #define CHIP_CRGET(REG)    _PER_CRGET(CHIP,##REG)
N
N  #define CHIP_CRSET(REG,x)\
N    _PER_CRSET(CHIP,##REG,x)
X  #define CHIP_CRSET(REG,x)    _PER_CRSET(CHIP,##REG,x)
N
N  #define CHIP_RGET(REG)\
N   _PER_RGET(_CHIP_##REG##_ADDR,CHIP,##REG)
X  #define CHIP_RGET(REG)   _PER_RGET(_CHIP_##REG##_ADDR,CHIP,##REG)
N
N  #define CHIP_RSET(REG,x)\
N     _PER_RSET(_CHIP_##REG##_ADDR,CHIP,##REG,x)
X  #define CHIP_RSET(REG,x)     _PER_RSET(_CHIP_##REG##_ADDR,CHIP,##REG,x)
N
N
N  #define CHIP_FGET(REG,FIELD)\
N    _CHIP_##REG##_FGET(##FIELD)
X  #define CHIP_FGET(REG,FIELD)    _CHIP_##REG##_FGET(##FIELD)
N
N  #define CHIP_FSET(REG,FIELD,x)\
N    _CHIP_##REG##_FSET(##FIELD,x)
X  #define CHIP_FSET(REG,FIELD,x)    _CHIP_##REG##_FSET(##FIELD,x)
N
N  #define CHIP_FSETS(REG,FIELD,SYM)\
N    _CHIP_##REG##_FSETS(##FIELD,##SYM)
X  #define CHIP_FSETS(REG,FIELD,SYM)    _CHIP_##REG##_FSETS(##FIELD,##SYM)
N
N
N/******************************************************************************\
N* _____________________
X
N* |                   |
N* |  C S R            |
N* |___________________|
N*
N* CSR - control/status register
N*
N* FIELDS (msb -> lsb)
N* (r)  CPUID
N* (r)  REVID
N* (rw) PWRD
N* (rc) SAT
N* (r)  EN
N* (rw) PCC
N* (rw) DCC
N* (rw) PGIE
N* (rw) GIE
N*
N\******************************************************************************/
N  extern far cregister volatile unsigned int CSR;
N
N  #define _CHIP_CSR_CPUID_MASK         0xFF000000u
N  #define _CHIP_CSR_CPUID_SHIFT        0x00000018u
N  #define  CHIP_CSR_CPUID_DEFAULT      0x00000000u
N  #define  CHIP_CSR_CPUID_OF(x)        _VALUEOF(x)
N  #define  CHIP_CSR_CPUID_C62X         0x00000000u
N  #define  CHIP_CSR_CPUID_C67X         0x00000002u
N  #define  CHIP_CSR_CPUID_C64X         0x00000004u
N
N  #define _CHIP_CSR_REVID_MASK         0x00FF0000u
N  #define _CHIP_CSR_REVID_SHIFT        0x00000010u
N  #define  CHIP_CSR_REVID_DEFAULT      0x00000000u
N  #define  CHIP_CSR_REVID_OF(x)        _VALUEOF(x)
N  #define  CHIP_CSR_REVID_620120       0x00000001u
N  #define  CHIP_CSR_REVID_620121       0x00000001u
N  #define  CHIP_CSR_REVID_620130       0x00000002u
N  #define  CHIP_CSR_REVID_670100       0x00000201u
N  #define  CHIP_CSR_REVID_670110       0x00000202u
N  #define  CHIP_CSR_REVID_621110       0x00000002u
N  #define  CHIP_CSR_REVID_640010       0x00000801u
N  #define  CHIP_CSR_REVID_6202         0x00000002u
N  #define  CHIP_CSR_REVID_6202B        0x00000003u
N  #define  CHIP_CSR_REVID_6711         0x00000002u
N  #define  CHIP_CSR_REVID_6711C        0x00000003u
N  #define  CHIP_CSR_REVID_6712         0x00000002u
N  #define  CHIP_CSR_REVID_6712C        0x00000003u
N
N  #define _CHIP_CSR_PWRD_MASK          0x0000FC00u
N  #define _CHIP_CSR_PWRD_SHIFT         0x0000000Au
N  #define  CHIP_CSR_PWRD_DEFAULT       0x00000000u
N  #define  CHIP_CSR_PWRD_OF(x)         _VALUEOF(x)
N  #define  CHIP_CSR_PWRD_NONE          0x00000000u
N  #define  CHIP_CSR_PWRD_PD1A          0x00000009u
N  #define  CHIP_CSR_PWRD_PD1B          0x00000011u
N  #define  CHIP_CSR_PWRD_PD2           0x0000001Au
N  #define  CHIP_CSR_PWRD_PD3           0x0000001Cu
N
N  #define _CHIP_CSR_SAT_MASK           0x00000200u
N  #define _CHIP_CSR_SAT_SHIFT          0x00000009u
N  #define  CHIP_CSR_SAT_DEFAULT        0x00000000u
N  #define  CHIP_CSR_SAT_OF(x)          _VALUEOF(x)
N  #define  CHIP_CSR_SAT_0              0x00000000u
N  #define  CHIP_CSR_SAT_1              0x00000001u
N
N  #define _CHIP_CSR_EN_MASK            0x00000100u
N  #define _CHIP_CSR_EN_SHIFT           0x00000008u
N  #define  CHIP_CSR_EN_DEFAULT         0x00000000u
N  #define  CHIP_CSR_EN_OF(x)           _VALUEOF(x)
N  #define  CHIP_CSR_EN_BIG             0x00000000u
N  #define  CHIP_CSR_EN_LITTLE          0x00000001u
N
N  #define _CHIP_CSR_PCC_MASK           0x000000E0u
N  #define _CHIP_CSR_PCC_SHIFT          0x00000005u
N  #define  CHIP_CSR_PCC_DEFAULT        0x00000000u
N  #define  CHIP_CSR_PCC_OF(x)          _VALUEOF(x)
N  #define  CHIP_CSR_PCC_MAPPED         0x00000000u
N  #define  CHIP_CSR_PCC_ENABLE         0x00000002u
N  #define  CHIP_CSR_PCC_FREEZE         0x00000003u
N  #define  CHIP_CSR_PCC_BYPASS         0x00000004u
N
N  #define _CHIP_CSR_DCC_MASK           0x0000001Cu
N  #define _CHIP_CSR_DCC_SHIFT          0x00000002u
N  #define  CHIP_CSR_DCC_DEFAULT        0x00000000u
N  #define  CHIP_CSR_DCC_OF(x)          _VALUEOF(x)
N  #define  CHIP_CSR_DCC_MAPPED         0x00000000u
N  #define  CHIP_CSR_DCC_ENABLE         0x00000002u
N  #define  CHIP_CSR_DCC_FREEZE         0x00000003u
N  #define  CHIP_CSR_DCC_BYPASS         0x00000004u
N
N  #define _CHIP_CSR_PGIE_MASK          0x00000002u
N  #define _CHIP_CSR_PGIE_SHIFT         0x00000001u
N  #define  CHIP_CSR_PGIE_DEFAULT       0x00000000u
N  #define  CHIP_CSR_PGIE_OF(x)         _VALUEOF(x)
N  #define  CHIP_CSR_PGIE_0             0x00000000u
N  #define  CHIP_CSR_PGIE_1             0x00000001u
N
N  #define _CHIP_CSR_GIE_MASK           0x00000001u
N  #define _CHIP_CSR_GIE_SHIFT          0x00000000u
N  #define  CHIP_CSR_GIE_DEFAULT        0x00000000u
N  #define  CHIP_CSR_GIE_OF(x)          _VALUEOF(x)
N  #define  CHIP_CSR_GIE_0              0x00000000u
N  #define  CHIP_CSR_GIE_1              0x00000001u
N
N  #define  CHIP_CSR_OF(x)              _VALUEOF(x)
N
N  #define CHIP_CSR_DEFAULT (Uint32)( \
N     _PER_FDEFAULT(CHIP,CSR,CPUID) \
N    |_PER_FDEFAULT(CHIP,CSR,REVID) \
N    |_PER_FDEFAULT(CHIP,CSR,PWRD) \
N    |_PER_FDEFAULT(CHIP,CSR,SAT) \
N    |_PER_FDEFAULT(CHIP,CSR,EN) \
N    |_PER_FDEFAULT(CHIP,CSR,PCC) \
N    |_PER_FDEFAULT(CHIP,CSR,DCC) \
N    |_PER_FDEFAULT(CHIP,CSR,PGIE) \
N    |_PER_FDEFAULT(CHIP,CSR,GIE) \
N  )
X  #define CHIP_CSR_DEFAULT (Uint32)(      _PER_FDEFAULT(CHIP,CSR,CPUID)     |_PER_FDEFAULT(CHIP,CSR,REVID)     |_PER_FDEFAULT(CHIP,CSR,PWRD)     |_PER_FDEFAULT(CHIP,CSR,SAT)     |_PER_FDEFAULT(CHIP,CSR,EN)     |_PER_FDEFAULT(CHIP,CSR,PCC)     |_PER_FDEFAULT(CHIP,CSR,DCC)     |_PER_FDEFAULT(CHIP,CSR,PGIE)     |_PER_FDEFAULT(CHIP,CSR,GIE)   )
N
N  #define CHIP_CSR_RMK(pwrd,pcc,dcc,pgie,gie) (Uint32)( \
N     _PER_FMK(CHIP,CSR,PWRD,pwrd) \
N    |_PER_FMK(CHIP,CSR,PCC,pcc) \
N    |_PER_FMK(CHIP,CSR,DCC,dcc) \
N    |_PER_FMK(CHIP,CSR,PGIE,pgie) \
N    |_PER_FMK(CHIP,CSR,GIE,gie) \
N  )
X  #define CHIP_CSR_RMK(pwrd,pcc,dcc,pgie,gie) (Uint32)(      _PER_FMK(CHIP,CSR,PWRD,pwrd)     |_PER_FMK(CHIP,CSR,PCC,pcc)     |_PER_FMK(CHIP,CSR,DCC,dcc)     |_PER_FMK(CHIP,CSR,PGIE,pgie)     |_PER_FMK(CHIP,CSR,GIE,gie)   )
N
N  #define _CHIP_CSR_FGET(FIELD)\
N    _PER_CFGET(CHIP,CSR,##FIELD)
X  #define _CHIP_CSR_FGET(FIELD)    _PER_CFGET(CHIP,CSR,##FIELD)
N
N  #define _CHIP_CSR_FSET(FIELD,field)\
N    _PER_CFSET(CHIP,CSR,##FIELD,field)
X  #define _CHIP_CSR_FSET(FIELD,field)    _PER_CFSET(CHIP,CSR,##FIELD,field)
N
N  #define _CHIP_CSR_FSETS(FIELD,SYM)\
N    _PER_CFSETS(CHIP,CSR,##FIELD,##SYM)
X  #define _CHIP_CSR_FSETS(FIELD,SYM)    _PER_CFSETS(CHIP,CSR,##FIELD,##SYM)
N
N
N/******************************************************************************\
N* _____________________
X
N* |                   |
N* |  I F R            |
N* |___________________|
N*
N* IFR - interruppt flag register
N*
N* FIELDS (msb -> lsb)
N* (rw) IF
N*
N\******************************************************************************/
N  extern far cregister volatile unsigned int IFR;
N
N  #define _CHIP_IFR_IF_MASK          0x0000FFFFu
N  #define _CHIP_IFR_IF_SHIFT         0x00000000u
N  #define  CHIP_IFR_IF_DEFAULT       0x00000000u
N  #define  CHIP_IFR_IF_OF(x)         _VALUEOF(x)
N
N  #define  CHIP_IFR_OF(x)            _VALUEOF(x)
N
N  #define CHIP_IFR_DEFAULT (Uint32)( \
N     _PER_FDEFAULT(CHIP,IFR,IF)\
N  )
X  #define CHIP_IFR_DEFAULT (Uint32)(      _PER_FDEFAULT(CHIP,IFR,IF)  )
N
N  #define CHIP_IFR_RMK(if) (Uint32)( \
N     _PER_FMK(CHIP,IFR,IF,if)\
N  )
X  #define CHIP_IFR_RMK(if) (Uint32)(      _PER_FMK(CHIP,IFR,IF,if)  )
N
N  #define _CHIP_IFR_FGET(FIELD)\
N    _PER_CFGET(CHIP,IFR,##FIELD)
X  #define _CHIP_IFR_FGET(FIELD)    _PER_CFGET(CHIP,IFR,##FIELD)
N
N  #define _CHIP_IFR_FSET(FIELD,field)\
N    _PER_CFSET(CHIP,IFR,##FIELD,field)
X  #define _CHIP_IFR_FSET(FIELD,field)    _PER_CFSET(CHIP,IFR,##FIELD,field)
N
N  #define _CHIP_IFR_FSETS(FIELD,SYM)\
N    _PER_CFSETS(CHIP,IFR,##FIELD,##SYM)
X  #define _CHIP_IFR_FSETS(FIELD,SYM)    _PER_CFSETS(CHIP,IFR,##FIELD,##SYM)
N
N
N/******************************************************************************\
N* _____________________
X
N* |                   |
N* |  I S R            |
N* |___________________|
N*
N* ISR - interruppt set register
N*
N* FIELDS (msb -> lsb)
N* (w) IS
N*
N\******************************************************************************/
N  extern far cregister volatile unsigned int ISR;
N
N  #define _CHIP_ISR_IS_MASK          0x0000FFFFu
N  #define _CHIP_ISR_IS_SHIFT         0x00000000u
N  #define  CHIP_ISR_IS_DEFAULT       0x00000000u
N  #define  CHIP_ISR_IS_OF(x)         _VALUEOF(x)
N
N  #define  CHIP_ISR_OF(x)            _VALUEOF(x)
N
N  #define CHIP_ISR_DEFAULT (Uint32)( \
N     _PER_FDEFAULT(CHIP,ISR,IS)\
N  )
X  #define CHIP_ISR_DEFAULT (Uint32)(      _PER_FDEFAULT(CHIP,ISR,IS)  )
N
N  #define CHIP_ISR_RMK(is) (Uint32)( \
N     _PER_FMK(CHIP,ISR,IS,is)\
N  )
X  #define CHIP_ISR_RMK(is) (Uint32)(      _PER_FMK(CHIP,ISR,IS,is)  )
N
N  #define _CHIP_ISR_FGET(FIELD)\
N    _PER_CFGET(CHIP,ISR,##FIELD)
X  #define _CHIP_ISR_FGET(FIELD)    _PER_CFGET(CHIP,ISR,##FIELD)
N
N  #define _CHIP_ISR_FSET(FIELD,field)\
N    _PER_CFSET(CHIP,ISR,##FIELD,field)
X  #define _CHIP_ISR_FSET(FIELD,field)    _PER_CFSET(CHIP,ISR,##FIELD,field)
N
N  #define _CHIP_ISR_FSETS(FIELD,SYM)\
N    _PER_CFSETS(CHIP,ISR,##FIELD,##SYM)
X  #define _CHIP_ISR_FSETS(FIELD,SYM)    _PER_CFSETS(CHIP,ISR,##FIELD,##SYM)
N
N
N/******************************************************************************\
N* _____________________
X
N* |                   |
N* |  I C R            |
N* |___________________|
N*
N* ICR - interruppt clear register
N*
N* FIELDS (msb -> lsb)
N* (w) IC
N*
N\******************************************************************************/
N  extern far cregister volatile unsigned int ICR;
N
N  #define _CHIP_ICR_IC_MASK          0x0000FFFFu
N  #define _CHIP_ICR_IC_SHIFT         0x00000000u
N  #define  CHIP_ICR_IC_DEFAULT       0x00000000u
N  #define  CHIP_ICR_IC_OF(x)         _VALUEOF(x)
N
N  #define  CHIP_ICR_OF(x)            _VALUEOF(x)
N
N  #define CHIP_ICR_DEFAULT (Uint32)( \
N     _PER_FDEFAULT(CHIP,ICR,IC)\
N  )
X  #define CHIP_ICR_DEFAULT (Uint32)(      _PER_FDEFAULT(CHIP,ICR,IC)  )
N
N  #define CHIP_ICR_RMK(ic) (Uint32)( \
N     _PER_FMK(CHIP,ICR,IC,ic)\
N  )
X  #define CHIP_ICR_RMK(ic) (Uint32)(      _PER_FMK(CHIP,ICR,IC,ic)  )
N
N  #define _CHIP_ICR_FGET(FIELD)\
N    _PER_CFGET(CHIP,ICR,##FIELD)
X  #define _CHIP_ICR_FGET(FIELD)    _PER_CFGET(CHIP,ICR,##FIELD)
N
N  #define _CHIP_ICR_FSET(FIELD,field)\
N    _PER_CFSET(CHIP,ICR,##FIELD,field)
X  #define _CHIP_ICR_FSET(FIELD,field)    _PER_CFSET(CHIP,ICR,##FIELD,field)
N
N  #define _CHIP_ICR_FSETS(FIELD,SYM)\
N    _PER_CFSETS(CHIP,ICR,##FIELD,##SYM)
X  #define _CHIP_ICR_FSETS(FIELD,SYM)    _PER_CFSETS(CHIP,ICR,##FIELD,##SYM)
N
N
N/******************************************************************************\
N* _____________________
X
N* |                   |
N* |  I E R            |
N* |___________________|
N*
N* IER - interruppt enable register
N*
N* FIELDS (msb -> lsb)
N* (rw) IE
N*
N\******************************************************************************/
N  extern far cregister volatile unsigned int IER;
N
N  #define _CHIP_IER_IE_MASK          0x0000FFFFu
N  #define _CHIP_IER_IE_SHIFT         0x00000000u
N  #define  CHIP_IER_IE_DEFAULT       0x00000000u
N  #define  CHIP_IER_IE_OF(x)         _VALUEOF(x)
N
N  #define  CHIP_IER_OF(x)            _VALUEOF(x)
N
N  #define CHIP_IER_DEFAULT (Uint32)( \
N     _PER_FDEFAULT(CHIP,IER,IE)\
N  )
X  #define CHIP_IER_DEFAULT (Uint32)(      _PER_FDEFAULT(CHIP,IER,IE)  )
N
N  #define CHIP_IER_RMK(ie) (Uint32)( \
N     _PER_FMK(CHIP,IER,IE,ie)\
N  )
X  #define CHIP_IER_RMK(ie) (Uint32)(      _PER_FMK(CHIP,IER,IE,ie)  )
N
N  #define _CHIP_IER_FGET(FIELD)\
N    _PER_CFGET(CHIP,IER,##FIELD)
X  #define _CHIP_IER_FGET(FIELD)    _PER_CFGET(CHIP,IER,##FIELD)
N
N  #define _CHIP_IER_FSET(FIELD,field)\
N    _PER_CFSET(CHIP,IER,##FIELD,field)
X  #define _CHIP_IER_FSET(FIELD,field)    _PER_CFSET(CHIP,IER,##FIELD,field)
N
N  #define _CHIP_IER_FSETS(FIELD,SYM)\
N    _PER_CFSETS(CHIP,IER,##FIELD,##SYM)
X  #define _CHIP_IER_FSETS(FIELD,SYM)    _PER_CFSETS(CHIP,IER,##FIELD,##SYM)
N
N
N/******************************************************************************\
N* _____________________
X
N* |                   |
N* |  I S T P          |
N* |___________________|
N*
N* ISTP - interrupt service table pointer
N*
N* FIELDS (msb -> lsb)
N* (r)   HPEINT
N* (rw)  ISTB
N*
N\******************************************************************************/
N  extern far cregister volatile unsigned int ISTP;
N
N  #define _CHIP_ISTP_ISTB_MASK         0xFFFFFC00u
N  #define _CHIP_ISTP_ISTB_SHIFT        0x0000000Au
N  #define  CHIP_ISTP_ISTB_DEFAULT      0x00000000u
N  #define  CHIP_ISTP_ISTB_OF(x)        _VALUEOF(x)
N
N  #define _CHIP_ISTP_HPEINT_MASK       0x000003E0u
N  #define _CHIP_ISTP_HPEINT_SHIFT      0x00000005u
N  #define  CHIP_ISTP_HPEINT_DEFAULT    0x00000000u
N  #define  CHIP_ISTP_HPEINT_OF(x)      _VALUEOF(x)
N
N  #define  CHIP_ISTP_OF(x)             _VALUEOF(x)
N
N  #define CHIP_ISTP_DEFAULT (Uint32)( \
N     _PER_FDEFAULT(CHIP,ISTP,ISTB)\
N    |_PER_FDEFAULT(CHIP,ISTP,HPEINT)\
N  )
X  #define CHIP_ISTP_DEFAULT (Uint32)(      _PER_FDEFAULT(CHIP,ISTP,ISTB)    |_PER_FDEFAULT(CHIP,ISTP,HPEINT)  )
N
N  #define CHIP_ISTP_RMK(istb) (Uint32)( \
N     _PER_FMK(CHIP,ISTP,ISTB,istb)\
N  )
X  #define CHIP_ISTP_RMK(istb) (Uint32)(      _PER_FMK(CHIP,ISTP,ISTB,istb)  )
N
N  #define _CHIP_ISTP_FGET(FIELD)\
N    _PER_CFGET(CHIP,ISTP,##FIELD)
X  #define _CHIP_ISTP_FGET(FIELD)    _PER_CFGET(CHIP,ISTP,##FIELD)
N
N  #define _CHIP_ISTP_FSET(FIELD,field)\
N    _PER_CFSET(CHIP,ISTP,##FIELD,field)
X  #define _CHIP_ISTP_FSET(FIELD,field)    _PER_CFSET(CHIP,ISTP,##FIELD,field)
N
N  #define _CHIP_ISTP_FSETS(FIELD,SYM)\
N    _PER_CFSETS(CHIP,ISTP,##FIELD,##SYM)
X  #define _CHIP_ISTP_FSETS(FIELD,SYM)    _PER_CFSETS(CHIP,ISTP,##FIELD,##SYM)
N
N
N/******************************************************************************\
N* _____________________
X
N* |                   |
N* |  I R P            |
N* |___________________|
N*
N* IRP - interrupt return pointer
N*
N* FIELDS (msb -> lsb)
N* (rw) IRP
N*
N\******************************************************************************/
N  extern far cregister volatile unsigned int IRP;
N
N  #define _CHIP_IRP_IRP_MASK           0xFFFFFFFFu
N  #define _CHIP_IRP_IRP_SHIFT          0x00000000u
N  #define  CHIP_IRP_IRP_DEFAULT        0x00000000u
N  #define  CHIP_IRP_IRP_OF(x)          _VALUEOF(x)
N
N  #define  CHIP_IRP_OF(x)              _VALUEOF(x)
N
N  #define CHIP_IRP_DEFAULT (Uint32)( \
N     _PER_FDEFAULT(CHIP,IRP,IRP)\
N  )
X  #define CHIP_IRP_DEFAULT (Uint32)(      _PER_FDEFAULT(CHIP,IRP,IRP)  )
N
N  #define CHIP_IRP_RMK(irp) (Uint32)( \
N     _PER_FMK(CHIP,IRP,IRP,irp)\
N  )
X  #define CHIP_IRP_RMK(irp) (Uint32)(      _PER_FMK(CHIP,IRP,IRP,irp)  )
N
N  #define _CHIP_IRP_FGET(FIELD)\
N    _PER_CFGET(CHIP,IRP,##FIELD)
X  #define _CHIP_IRP_FGET(FIELD)    _PER_CFGET(CHIP,IRP,##FIELD)
N
N  #define _CHIP_IRP_FSET(FIELD,field)\
N    _PER_CFSET(CHIP,IRP,##FIELD,field)
X  #define _CHIP_IRP_FSET(FIELD,field)    _PER_CFSET(CHIP,IRP,##FIELD,field)
N
N  #define _CHIP_IRP_FSETS(FIELD,SYM)\
N    _PER_CFSETS(CHIP,IRP,##FIELD,##SYM)
X  #define _CHIP_IRP_FSETS(FIELD,SYM)    _PER_CFSETS(CHIP,IRP,##FIELD,##SYM)
N
N
N/******************************************************************************\
N* _____________________
X
N* |                   |
N* |  N R P            |
N* |___________________|
N*
N* NRP - non-maskable interrupt return pointer
N*
N* FIELDS (msb -> lsb)
N* (rw) NRP
N*
N\******************************************************************************/
N  extern far cregister volatile unsigned int NRP;
N
N  #define _CHIP_NRP_NRP_MASK           0xFFFFFFFFu
N  #define _CHIP_NRP_NRP_SHIFT          0x00000000u
N  #define  CHIP_NRP_NRP_DEFAULT        0x00000000u
N  #define  CHIP_NRP_NRP_OF(x)          _VALUEOF(x)
N
N  #define  CHIP_NRP_OF(x)              _VALUEOF(x)
N
N  #define CHIP_NRP_DEFAULT (Uint32)( \
N     _PER_FDEFAULT(CHIP,NRP,NRP)\
N  )
X  #define CHIP_NRP_DEFAULT (Uint32)(      _PER_FDEFAULT(CHIP,NRP,NRP)  )
N
N  #define CHIP_NRP_RMK(nrp) (Uint32)( \
N     _PER_FMK(CHIP,NRP,NRP,nrp)\
N  )
X  #define CHIP_NRP_RMK(nrp) (Uint32)(      _PER_FMK(CHIP,NRP,NRP,nrp)  )
N
N  #define _CHIP_NRP_FGET(FIELD)\
N    _PER_CFGET(CHIP,NRP,##FIELD)
X  #define _CHIP_NRP_FGET(FIELD)    _PER_CFGET(CHIP,NRP,##FIELD)
N
N  #define _CHIP_NRP_FSET(FIELD,field)\
N    _PER_CFSET(CHIP,NRP,##FIELD,field)
X  #define _CHIP_NRP_FSET(FIELD,field)    _PER_CFSET(CHIP,NRP,##FIELD,field)
N
N  #define _CHIP_NRP_FSETS(FIELD,SYM)\
N    _PER_CFSETS(CHIP,NRP,##FIELD,##SYM)
X  #define _CHIP_NRP_FSETS(FIELD,SYM)    _PER_CFSETS(CHIP,NRP,##FIELD,##SYM)
N
N
N/******************************************************************************\
N* _____________________
X
N* |                   |
N* |  A M R            |
N* |___________________|
N*
N* AMR - addressing mode register
N*
N* FIELDS (msb -> lsb)
N* (rw) BK1
N* (rw) BK0
N* (rw) B7MODE
N* (rw) B6MODE
N* (rw) B5MODE
N* (rw) B4MODE
N* (rw) A7MODE
N* (rw) A6MODE
N* (rw) A5MODE
N* (rw) A4MODE
N*
N\******************************************************************************/
N  extern far cregister volatile unsigned int AMR;
N
N  #define _CHIP_AMR_BK1_MASK           0x02E00000u
N  #define _CHIP_AMR_BK1_SHIFT          0x00000015u
N  #define  CHIP_AMR_BK1_DEFAULT        0x00000000u
N  #define  CHIP_AMR_BK1_OF(x)          _VALUEOF(x)
N  #define  CHIP_AMR_BK1_2              0x00000000u
N  #define  CHIP_AMR_BK1_4              0x00000001u
N  #define  CHIP_AMR_BK1_8              0x00000002u
N  #define  CHIP_AMR_BK1_16             0x00000003u
N  #define  CHIP_AMR_BK1_32             0x00000004u
N  #define  CHIP_AMR_BK1_64             0x00000005u
N  #define  CHIP_AMR_BK1_128            0x00000006u
N  #define  CHIP_AMR_BK1_256            0x00000007u
N  #define  CHIP_AMR_BK1_512            0x00000008u
N  #define  CHIP_AMR_BK1_1K             0x00000009u
N  #define  CHIP_AMR_BK1_2K             0x0000000Au
N  #define  CHIP_AMR_BK1_4K             0x0000000Bu
N  #define  CHIP_AMR_BK1_8K             0x0000000Cu
N  #define  CHIP_AMR_BK1_16K            0x0000000Du
N  #define  CHIP_AMR_BK1_32K            0x0000000Eu
N  #define  CHIP_AMR_BK1_64K            0x0000000Fu
N  #define  CHIP_AMR_BK1_128K           0x00000010u
N  #define  CHIP_AMR_BK1_256K           0x00000011u
N  #define  CHIP_AMR_BK1_512K           0x00000012u
N  #define  CHIP_AMR_BK1_1M             0x00000013u
N  #define  CHIP_AMR_BK1_2M             0x00000014u
N  #define  CHIP_AMR_BK1_4M             0x00000015u
N  #define  CHIP_AMR_BK1_8M             0x00000016u
N  #define  CHIP_AMR_BK1_16M            0x00000017u
N  #define  CHIP_AMR_BK1_32M            0x00000018u
N  #define  CHIP_AMR_BK1_64M            0x00000019u
N  #define  CHIP_AMR_BK1_128M           0x0000001Au
N  #define  CHIP_AMR_BK1_256M           0x0000001Bu
N  #define  CHIP_AMR_BK1_512M           0x0000001Cu
N  #define  CHIP_AMR_BK1_1G             0x0000001Du
N  #define  CHIP_AMR_BK1_2G             0x0000001Eu
N  #define  CHIP_AMR_BK1_4G             0x0000001Fu
N
N  #define _CHIP_AMR_BK0_MASK           0x001F0000u
N  #define _CHIP_AMR_BK0_SHIFT          0x00000010u
N  #define  CHIP_AMR_BK0_DEFAULT        0x00000000u
N  #define  CHIP_AMR_BK0_OF(x)          _VALUEOF(x)
N  #define  CHIP_AMR_BK0_2              0x00000000u
N  #define  CHIP_AMR_BK0_4              0x00000001u
N  #define  CHIP_AMR_BK0_8              0x00000002u
N  #define  CHIP_AMR_BK0_16             0x00000003u
N  #define  CHIP_AMR_BK0_32             0x00000004u
N  #define  CHIP_AMR_BK0_64             0x00000005u
N  #define  CHIP_AMR_BK0_128            0x00000006u
N  #define  CHIP_AMR_BK0_256            0x00000007u
N  #define  CHIP_AMR_BK0_512            0x00000008u
N  #define  CHIP_AMR_BK0_1K             0x00000009u
N  #define  CHIP_AMR_BK0_2K             0x0000000Au
N  #define  CHIP_AMR_BK0_4K             0x0000000Bu
N  #define  CHIP_AMR_BK0_8K             0x0000000Cu
N  #define  CHIP_AMR_BK0_16K            0x0000000Du
N  #define  CHIP_AMR_BK0_32K            0x0000000Eu
N  #define  CHIP_AMR_BK0_64K            0x0000000Fu
N  #define  CHIP_AMR_BK0_128K           0x00000010u
N  #define  CHIP_AMR_BK0_256K           0x00000011u
N  #define  CHIP_AMR_BK0_512K           0x00000012u
N  #define  CHIP_AMR_BK0_1M             0x00000013u
N  #define  CHIP_AMR_BK0_2M             0x00000014u
N  #define  CHIP_AMR_BK0_4M             0x00000015u
N  #define  CHIP_AMR_BK0_8M             0x00000016u
N  #define  CHIP_AMR_BK0_16M            0x00000017u
N  #define  CHIP_AMR_BK0_32M            0x00000018u
N  #define  CHIP_AMR_BK0_64M            0x00000019u
N  #define  CHIP_AMR_BK0_128M           0x0000001Au
N  #define  CHIP_AMR_BK0_256M           0x0000001Bu
N  #define  CHIP_AMR_BK0_512M           0x0000001Cu
N  #define  CHIP_AMR_BK0_1G             0x0000001Du
N  #define  CHIP_AMR_BK0_2G             0x0000001Eu
N  #define  CHIP_AMR_BK0_4G             0x0000001Fu
N
N
N  #define _CHIP_AMR_B7MODE_MASK        0x0000C000u
N  #define _CHIP_AMR_B7MODE_SHIFT       0x0000000Eu
N  #define  CHIP_AMR_B7MODE_DEFAULT     0x00000000u
N  #define  CHIP_AMR_B7MODE_OF(x)       _VALUEOF(x)
N  #define  CHIP_AMR_B7MODE_LINEAR      0x00000000u
N  #define  CHIP_AMR_B7MODE_CIRCULAR0   0x00000001u
N  #define  CHIP_AMR_B7MODE_CIRCULAR1   0x00000002u
N
N  #define _CHIP_AMR_B6MODE_MASK        0x00003000u
N  #define _CHIP_AMR_B6MODE_SHIFT       0x0000000Cu
N  #define  CHIP_AMR_B6MODE_DEFAULT     0x00000000u
N  #define  CHIP_AMR_B6MODE_OF(x)       _VALUEOF(x)
N  #define  CHIP_AMR_B6MODE_LINEAR      0x00000000u
N  #define  CHIP_AMR_B6MODE_CIRCULAR0   0x00000001u
N  #define  CHIP_AMR_B6MODE_CIRCULAR1   0x00000002u
N
N  #define _CHIP_AMR_B5MODE_MASK        0x00000C00u
N  #define _CHIP_AMR_B5MODE_SHIFT       0x0000000Au
N  #define  CHIP_AMR_B5MODE_DEFAULT     0x00000000u
N  #define  CHIP_AMR_B5MODE_OF(x)       _VALUEOF(x)
N  #define  CHIP_AMR_B5MODE_LINEAR      0x00000000u
N  #define  CHIP_AMR_B5MODE_CIRCULAR0   0x00000001u
N  #define  CHIP_AMR_B5MODE_CIRCULAR1   0x00000002u
N
N  #define _CHIP_AMR_B4MODE_MASK        0x00000300u
N  #define _CHIP_AMR_B4MODE_SHIFT       0x00000008u
N  #define  CHIP_AMR_B4MODE_DEFAULT     0x00000000u
N  #define  CHIP_AMR_B4MODE_OF(x)       _VALUEOF(x)
N  #define  CHIP_AMR_B4MODE_LINEAR      0x00000000u
N  #define  CHIP_AMR_B4MODE_CIRCULAR0   0x00000001u
N  #define  CHIP_AMR_B4MODE_CIRCULAR1   0x00000002u
N
N  #define _CHIP_AMR_A7MODE_MASK        0x000000C0u
N  #define _CHIP_AMR_A7MODE_SHIFT       0x00000006u
N  #define  CHIP_AMR_A7MODE_DEFAULT     0x00000000u
N  #define  CHIP_AMR_A7MODE_OF(x)       _VALUEOF(x)
N  #define  CHIP_AMR_A7MODE_LINEAR      0x00000000u
N  #define  CHIP_AMR_A7MODE_CIRCULAR0   0x00000001u
N  #define  CHIP_AMR_A7MODE_CIRCULAR1   0x00000002u
N
N  #define _CHIP_AMR_A6MODE_MASK        0x00000030u
N  #define _CHIP_AMR_A6MODE_SHIFT       0x00000004u
N  #define  CHIP_AMR_A6MODE_DEFAULT     0x00000000u
N  #define  CHIP_AMR_A6MODE_OF(x)       _VALUEOF(x)
N  #define  CHIP_AMR_A6MODE_LINEAR      0x00000000u
N  #define  CHIP_AMR_A6MODE_CIRCULAR0   0x00000001u
N  #define  CHIP_AMR_A6MODE_CIRCULAR1   0x00000002u
N
N  #define _CHIP_AMR_A5MODE_MASK        0x0000000Cu
N  #define _CHIP_AMR_A5MODE_SHIFT       0x00000002u
N  #define  CHIP_AMR_A5MODE_DEFAULT     0x00000000u
N  #define  CHIP_AMR_A5MODE_OF(x)       _VALUEOF(x)
N  #define  CHIP_AMR_A5MODE_LINEAR      0x00000000u
N  #define  CHIP_AMR_A5MODE_CIRCULAR0   0x00000001u
N  #define  CHIP_AMR_A5MODE_CIRCULAR1   0x00000002u
N
N  #define _CHIP_AMR_A4MODE_MASK        0x00000003u
N  #define _CHIP_AMR_A4MODE_SHIFT       0x00000000u
N  #define  CHIP_AMR_A4MODE_DEFAULT     0x00000000u
N  #define  CHIP_AMR_A4MODE_OF(x)       _VALUEOF(x)
N  #define  CHIP_AMR_A4MODE_LINEAR      0x00000000u
N  #define  CHIP_AMR_A4MODE_CIRCULAR0   0x00000001u
N  #define  CHIP_AMR_A4MODE_CIRCULAR1   0x00000002u
N
N  #define  CHIP_AMR_OF(x)              _VALUEOF(x)
N
N  #define CHIP_AMR_DEFAULT (Uint32)( \
N     _PER_FDEFAULT(CHIP,AMR,BK1)\
N    |_PER_FDEFAULT(CHIP,AMR,BK0)\
N    |_PER_FDEFAULT(CHIP,AMR,B7MODE)\
N    |_PER_FDEFAULT(CHIP,AMR,B6MODE)\
N    |_PER_FDEFAULT(CHIP,AMR,B5MODE)\
N    |_PER_FDEFAULT(CHIP,AMR,B4MODE)\
N    |_PER_FDEFAULT(CHIP,AMR,A7MODE)\
N    |_PER_FDEFAULT(CHIP,AMR,A6MODE)\
N    |_PER_FDEFAULT(CHIP,AMR,A5MODE)\
N    |_PER_FDEFAULT(CHIP,AMR,A4MODE)\
N  )
X  #define CHIP_AMR_DEFAULT (Uint32)(      _PER_FDEFAULT(CHIP,AMR,BK1)    |_PER_FDEFAULT(CHIP,AMR,BK0)    |_PER_FDEFAULT(CHIP,AMR,B7MODE)    |_PER_FDEFAULT(CHIP,AMR,B6MODE)    |_PER_FDEFAULT(CHIP,AMR,B5MODE)    |_PER_FDEFAULT(CHIP,AMR,B4MODE)    |_PER_FDEFAULT(CHIP,AMR,A7MODE)    |_PER_FDEFAULT(CHIP,AMR,A6MODE)    |_PER_FDEFAULT(CHIP,AMR,A5MODE)    |_PER_FDEFAULT(CHIP,AMR,A4MODE)  )
N
N  #define CHIP_AMR_RMK(bk1,bk0,b7mode,b6mode,b5mode,b4mode,a7,ode,\
N    a6mode,a5mode,a4mode) (Uint32)( \
N     _PER_FMK(CHIP,AMR,BK1,bk1)\
N    |_PER_FMK(CHIP,AMR,BK0,bk0)\
N    |_PER_FMK(CHIP,AMR,B7MODE,b7mode)\
N    |_PER_FMK(CHIP,AMR,B6MODE,b6mode)\
N    |_PER_FMK(CHIP,AMR,B5MODE,b5mode)\
N    |_PER_FMK(CHIP,AMR,B4MODE,b4mode)\
N    |_PER_FMK(CHIP,AMR,A7MODE,a7mode)\
N    |_PER_FMK(CHIP,AMR,A6MODE,a6mode)\
N    |_PER_FMK(CHIP,AMR,A5MODE,a5mode)\
N    |_PER_FMK(CHIP,AMR,A4MODE,a4mode)\
N  )
X  #define CHIP_AMR_RMK(bk1,bk0,b7mode,b6mode,b5mode,b4mode,a7,ode,    a6mode,a5mode,a4mode) (Uint32)(      _PER_FMK(CHIP,AMR,BK1,bk1)    |_PER_FMK(CHIP,AMR,BK0,bk0)    |_PER_FMK(CHIP,AMR,B7MODE,b7mode)    |_PER_FMK(CHIP,AMR,B6MODE,b6mode)    |_PER_FMK(CHIP,AMR,B5MODE,b5mode)    |_PER_FMK(CHIP,AMR,B4MODE,b4mode)    |_PER_FMK(CHIP,AMR,A7MODE,a7mode)    |_PER_FMK(CHIP,AMR,A6MODE,a6mode)    |_PER_FMK(CHIP,AMR,A5MODE,a5mode)    |_PER_FMK(CHIP,AMR,A4MODE,a4mode)  )
N
N  #define _CHIP_AMR_FGET(FIELD)\
N    _PER_CFGET(CHIP,AMR,##FIELD)
X  #define _CHIP_AMR_FGET(FIELD)    _PER_CFGET(CHIP,AMR,##FIELD)
N
N  #define _CHIP_AMR_FSET(FIELD,field)\
N    _PER_CFSET(CHIP,AMR,##FIELD,field)
X  #define _CHIP_AMR_FSET(FIELD,field)    _PER_CFSET(CHIP,AMR,##FIELD,field)
N
N  #define _CHIP_AMR_FSETS(FIELD,SYM)\
N    _PER_CFSETS(CHIP,AMR,##FIELD,##SYM)
X  #define _CHIP_AMR_FSETS(FIELD,SYM)    _PER_CFSETS(CHIP,AMR,##FIELD,##SYM)
N
N
N
N/******************************************************************************\
N* _____________________
X
N* |                   |
N* |  D E V C F G      |
N* |___________________|
N*
N* PERCFG - Device Configuration register (1)
N*
N* FIELDS (msb -> lsb)  CHIP_6713/CHIP_DA610
N* (rw) EKSRC
N* (rw) TOUT1SEL
N* (rw) TOUT0SEL
N* (rw) MCBSP0DIS
N* (rw) MCBSP1DIS
N* (rw) GPIO1EN (only for CHIP_DA610)
N*
N* FIELDS (msb -> lsb)  CHIP_DM642
N* (rw) VP2EN
N* (rw) VP1EN
N* (rw) VP0EN
N* (rw) I2C0EN
N* (rw) MCBSP1EN
N* (rw) MCBSP0EN
N* (rw) MCASP0EN
N*
N* FIELDS (msb -> lsb)  CHIP_6412
N* (rw) I2C0EN
N* (rw) MCBSP1EN
N* (rw) MCBSP0EN
N*
N* FIELDS (msb -> lsb)  CHIP_6711C/CHIP_6712C
N* (rw) EKSRC
N*
N* FIELDS (msb -> lsb)  CHIP_6410/CHIP_6413/CHIP_6418
N* (rw) AFCMUX
N* (rw) MCASP1EN
N* (rw) I2C1EN
N* (rw) I2C0EN
N* (r) MCBSP1EN
N* (r) MCBSP0EN
N* (rw) MCASP0EN
N*
N\******************************************************************************/
N
N#if (CHIP_DA610)
X#if (0)
S
S  #define   _CHIP_DEVCFG_ADDR              0x019C0200u
S  #define   _CHIP_DEVCFG_OFFSET             0
S
S  #define _CHIP_DEVCFG_GPIO1EN_MASK        0x00010000u
S  #define _CHIP_DEVCFG_GPIO1EN_SHIFT       0x0000000Fu
S  #define  CHIP_DEVCFG_GPIO1EN_DEFAULT     0x00000000u
S  #define  CHIP_DEVCFG_GPIO1EN_OF(x)       _VALUEOF(x)
S  #define  CHIP_DEVCFG_GPIO1EN_0           0x00000000u
S  #define  CHIP_DEVCFG_GPIO1EN_1           0x00000001u
S
S  #define _CHIP_DEVCFG_EKSRC_MASK          0x00000010u
S  #define _CHIP_DEVCFG_EKSRC_SHIFT         0x00000004u
S  #define  CHIP_DEVCFG_EKSRC_DEFAULT       0x00000000u
S  #define  CHIP_DEVCFG_EKSRC_OF(x)         _VALUEOF(x)
S  #define  CHIP_DEVCFG_EKSRC_SYSCLK3       0x00000000u
S  #define  CHIP_DEVCFG_EKSRC_ECLKIN        0x00000001u
S
S  #define _CHIP_DEVCFG_TOUT1SEL_MASK       0x00000008u
S  #define _CHIP_DEVCFG_TOUT1SEL_SHIFT      0x00000003u
S  #define  CHIP_DEVCFG_TOUT1SEL_DEFAULT    0x00000000u
S  #define  CHIP_DEVCFG_TOUT1SEL_OF(x)       _VALUEOF(x)
S  #define  CHIP_DEVCFG_TOUT1SEL_TOUT1PIN   0x00000000u
S  #define  CHIP_DEVCFG_TOUT1SEL_MCASPPIN   0x00000001u
S
S  #define _CHIP_DEVCFG_TOUT0SEL_MASK       0x00000004u
S  #define _CHIP_DEVCFG_TOUT0SEL_SHIFT      0x00000002u
S  #define  CHIP_DEVCFG_TOUT0SEL_DEFAULT    0x00000000u
S  #define  CHIP_DEVCFG_TOUT0SEL_OF(x)       _VALUEOF(x)
S  #define  CHIP_DEVCFG_TOUT0SEL_TOUT0PIN   0x00000000u
S  #define  CHIP_DEVCFG_TOUT0SEL_MCASPPIN   0x00000001u
S
S  #define _CHIP_DEVCFG_MCBSP0DIS_MASK       0x00000002u
S  #define _CHIP_DEVCFG_MCBSP0DIS_SHIFT      0x00000001u
S  #define  CHIP_DEVCFG_MCBSP0DIS_DEFAULT    0x00000000u
S  #define  CHIP_DEVCFG_MCBSP0DIS_OF(x)       _VALUEOF(x)
S  #define  CHIP_DEVCFG_MCBSP0DIS_0          0x00000000u
S  #define  CHIP_DEVCFG_MCBSP0DIS_1          0x00000001u
S
S  #define _CHIP_DEVCFG_MCBSP1DIS_MASK         0x00000001u
S  #define _CHIP_DEVCFG_MCBSP1DIS_SHIFT        0x00000000u
S  #define  CHIP_DEVCFG_MCBSP1DIS_DEFAULT      0x00000000u
S  #define  CHIP_DEVCFG_MCBSP1DIS_OF(x)        _VALUEOF(x)
S  #define  CHIP_DEVCFG_MCBSP1DIS_0            0x00000000u
S  #define  CHIP_DEVCFG_MCBSP1DIS_1            0x00000001u
S
S
S  #define  CHIP_DEVCFG_OF(x)              _VALUEOF(x)
S
S  #define CHIP_DEVCFG_DEFAULT (Uint32)( \
S     _PER_FDEFAULT(CHIP,DEVCFG,EKSRC) \
S    |_PER_FDEFAULT(CHIP,DEVCFG,TOUT1SEL) \
S    |_PER_FDEFAULT(CHIP,DEVCFG,TOUT0SEL) \
S    |_PER_FDEFAULT(CHIP,DEVCFG,MCBSP0DIS) \
S    |_PER_FDEFAULT(CHIP,DEVCFG,MCBSP1DIS) \
S    |_PER_FDEFAULT(CHIP,DEVCFG,GPIO1EN) \
S )
X  #define CHIP_DEVCFG_DEFAULT (Uint32)(      _PER_FDEFAULT(CHIP,DEVCFG,EKSRC)     |_PER_FDEFAULT(CHIP,DEVCFG,TOUT1SEL)     |_PER_FDEFAULT(CHIP,DEVCFG,TOUT0SEL)     |_PER_FDEFAULT(CHIP,DEVCFG,MCBSP0DIS)     |_PER_FDEFAULT(CHIP,DEVCFG,MCBSP1DIS)     |_PER_FDEFAULT(CHIP,DEVCFG,GPIO1EN)  )
S
S  #define CHIP_DEVCFG_RMK(eksrc,tout1sel,tout0sel,mcbsp0dis,mcbsp1dis,\
S                          gpio1en ) (Uint32)( \
S      _PER_FMK(CHIP,DEVCFG,EKSRC,eksrc) \
S    |_PER_FMK(CHIP,DEVCFG,TOUT1SEL,tout1sel) \
S    |_PER_FMK(CHIP,DEVCFG,TOUT0SEL,tout0sel) \
S    |_PER_FMK(CHIP,DEVCFG,MCBSP0DIS,mcbsp0dis) \
S    |_PER_FMK(CHIP,DEVCFG,MCBSP1DIS,mcbsp1dis) \
S    |_PER_FMK(CHIP,DEVCFG,GPIO1EN,gpio1en) \
S)
X  #define CHIP_DEVCFG_RMK(eksrc,tout1sel,tout0sel,mcbsp0dis,mcbsp1dis,                          gpio1en ) (Uint32)(       _PER_FMK(CHIP,DEVCFG,EKSRC,eksrc)     |_PER_FMK(CHIP,DEVCFG,TOUT1SEL,tout1sel)     |_PER_FMK(CHIP,DEVCFG,TOUT0SEL,tout0sel)     |_PER_FMK(CHIP,DEVCFG,MCBSP0DIS,mcbsp0dis)     |_PER_FMK(CHIP,DEVCFG,MCBSP1DIS,mcbsp1dis)     |_PER_FMK(CHIP,DEVCFG,GPIO1EN,gpio1en) )
S#elif (CHIP_6713)
X#elif (0)
S  #define   _CHIP_DEVCFG_ADDR              0x019C0200u
S  #define   _CHIP_DEVCFG_OFFSET             0
S
S  #define _CHIP_DEVCFG_EKSRC_MASK          0x00000010u
S  #define _CHIP_DEVCFG_EKSRC_SHIFT         0x00000004u
S  #define  CHIP_DEVCFG_EKSRC_DEFAULT       0x00000000u
S  #define  CHIP_DEVCFG_EKSRC_OF(x)         _VALUEOF(x)
S  #define  CHIP_DEVCFG_EKSRC_SYSCLK3       0x00000000u
S  #define  CHIP_DEVCFG_EKSRC_ECLKIN        0x00000001u
S
S  #define _CHIP_DEVCFG_TOUT1SEL_MASK       0x00000008u
S  #define _CHIP_DEVCFG_TOUT1SEL_SHIFT      0x00000003u
S  #define  CHIP_DEVCFG_TOUT1SEL_DEFAULT    0x00000000u
S  #define  CHIP_DEVCFG_TOUT1SEL_OF(x)       _VALUEOF(x)
S  #define  CHIP_DEVCFG_TOUT1SEL_TOUT1PIN   0x00000000u
S  #define  CHIP_DEVCFG_TOUT1SEL_MCASPPIN   0x00000001u
S
S  #define _CHIP_DEVCFG_TOUT0SEL_MASK       0x00000004u
S  #define _CHIP_DEVCFG_TOUT0SEL_SHIFT      0x00000002u
S  #define  CHIP_DEVCFG_TOUT0SEL_DEFAULT    0x00000000u
S  #define  CHIP_DEVCFG_TOUT0SEL_OF(x)       _VALUEOF(x)
S  #define  CHIP_DEVCFG_TOUT0SEL_TOUT0PIN   0x00000000u
S  #define  CHIP_DEVCFG_TOUT0SEL_MCASPPIN   0x00000001u
S
S  #define _CHIP_DEVCFG_MCBSP0DIS_MASK      0x00000002u
S  #define _CHIP_DEVCFG_MCBSP0DIS_SHIFT     0x00000001u
S  #define  CHIP_DEVCFG_MCBSP0DIS_DEFAULT   0x00000000u
S  #define  CHIP_DEVCFG_MCBSP0DIS_OF(x)     _VALUEOF(x)
S  #define  CHIP_DEVCFG_MCBSP0DIS_0         0x00000000u
S  #define  CHIP_DEVCFG_MCBSP0DIS_1         0x00000001u
S
S  #define _CHIP_DEVCFG_MCBSP1DIS_MASK      0x00000001u
S  #define _CHIP_DEVCFG_MCBSP1DIS_SHIFT     0x00000000u
S  #define  CHIP_DEVCFG_MCBSP1DIS_DEFAULT   0x00000000u
S  #define  CHIP_DEVCFG_MCBSP1DIS_OF(x)     _VALUEOF(x)
S  #define  CHIP_DEVCFG_MCBSP1DIS_0         0x00000000u
S  #define  CHIP_DEVCFG_MCBSP1DIS_1         0x00000001u
S
S
S  #define  CHIP_DEVCFG_OF(x)              _VALUEOF(x)
S
S  #define CHIP_DEVCFG_DEFAULT (Uint32)( \
S     _PER_FDEFAULT(CHIP,DEVCFG,EKSRC) \
S    |_PER_FDEFAULT(CHIP,DEVCFG,TOUT1SEL) \
S    |_PER_FDEFAULT(CHIP,DEVCFG,TOUT0SEL) \
S    |_PER_FDEFAULT(CHIP,DEVCFG,MCBSP0DIS) \
S    |_PER_FDEFAULT(CHIP,DEVCFG,MCBSP1DIS) \
S )
X  #define CHIP_DEVCFG_DEFAULT (Uint32)(      _PER_FDEFAULT(CHIP,DEVCFG,EKSRC)     |_PER_FDEFAULT(CHIP,DEVCFG,TOUT1SEL)     |_PER_FDEFAULT(CHIP,DEVCFG,TOUT0SEL)     |_PER_FDEFAULT(CHIP,DEVCFG,MCBSP0DIS)     |_PER_FDEFAULT(CHIP,DEVCFG,MCBSP1DIS)  )
S
S  #define CHIP_DEVCFG_RMK(eksrc,tout1sel,tout0sel,mcbsp0dis,mcbsp1dis\
S                          ) (Uint32)( \
S      _PER_FMK(CHIP,DEVCFG,EKSRC,eksrc) \
S    |_PER_FMK(CHIP,DEVCFG,TOUT1SEL,tout1sel) \
S    |_PER_FMK(CHIP,DEVCFG,TOUT0SEL,tout0sel) \
S    |_PER_FMK(CHIP,DEVCFG,MCBSP0DIS,mcbsp0dis) \
S    |_PER_FMK(CHIP,DEVCFG,MCBSP1DIS,mcbsp1dis) \
S)
X  #define CHIP_DEVCFG_RMK(eksrc,tout1sel,tout0sel,mcbsp0dis,mcbsp1dis                          ) (Uint32)(       _PER_FMK(CHIP,DEVCFG,EKSRC,eksrc)     |_PER_FMK(CHIP,DEVCFG,TOUT1SEL,tout1sel)     |_PER_FMK(CHIP,DEVCFG,TOUT0SEL,tout0sel)     |_PER_FMK(CHIP,DEVCFG,MCBSP0DIS,mcbsp0dis)     |_PER_FMK(CHIP,DEVCFG,MCBSP1DIS,mcbsp1dis) )
S
N#endif
N
N#if (CHIP_DM642 || CHIP_DM641 || CHIP_DM640 || CHIP_6412)
X#if (0 || 0 || 0 || 0)
S
S  #define   _CHIP_PERCFG_ADDR                0x01B3F000u
S  #define   _CHIP_PERCFG_OFFSET              0
S
S#if (CHIP_DM642)
S  #define _CHIP_PERCFG_VP2EN_MASK            0x00000040u
S  #define _CHIP_PERCFG_VP2EN_SHIFT           0x00000006u
S  #define  CHIP_PERCFG_VP2EN_DEFAULT         0x00000000u
S  #define  CHIP_PERCFG_VP2EN_OF(x)           _VALUEOF(x)
S  #define  CHIP_PERCFG_VP2EN_DISABLE         0x00000000u
S  #define  CHIP_PERCFG_VP2EN_ENABLE          0x00000001u
S#endif
S
S#if (CHIP_DM642 | CHIP_DM641)                          
S  #define _CHIP_PERCFG_VP1EN_MASK            0x00000020u
S  #define _CHIP_PERCFG_VP1EN_SHIFT           0x00000005u
S  #define  CHIP_PERCFG_VP1EN_DEFAULT         0x00000000u
S  #define  CHIP_PERCFG_VP1EN_OF(x)           _VALUEOF(x)
S  #define  CHIP_PERCFG_VP1EN_DISABLE         0x00000000u
S  #define  CHIP_PERCFG_VP1EN_ENABLE          0x00000001u
S#endif
S
S#if (CHIP_DM642 | CHIP_DM641 | CHIP_DM640)                          
S  #define _CHIP_PERCFG_VP0EN_MASK            0x00000010u
S  #define _CHIP_PERCFG_VP0EN_SHIFT           0x00000004u
S  #define  CHIP_PERCFG_VP0EN_DEFAULT         0x00000000u
S  #define  CHIP_PERCFG_VP0EN_OF(x)           _VALUEOF(x)
S  #define  CHIP_PERCFG_VP0EN_DISABLE         0x00000000u
S  #define  CHIP_PERCFG_VP0EN_ENABLE          0x00000001u
S#endif
S
S  #define _CHIP_PERCFG_I2C0EN_MASK           0x00000008u
S  #define _CHIP_PERCFG_I2C0EN_SHIFT          0x00000003u
S  #define  CHIP_PERCFG_I2C0EN_DEFAULT        0x00000000u
S  #define  CHIP_PERCFG_I2C0EN_OF(x)          _VALUEOF(x)
S  #define  CHIP_PERCFG_I2C0EN_DISABLE        0x00000000u
S  #define  CHIP_PERCFG_I2C0EN_ENABLE         0x00000001u
S
S  #define _CHIP_PERCFG_MCBSP1EN_MASK         0x00000004u
S  #define _CHIP_PERCFG_MCBSP1EN_SHIFT        0x00000002u
S  #define  CHIP_PERCFG_MCBSP1EN_DEFAULT      0x00000001u
S  #define  CHIP_PERCFG_MCBSP1EN_OF(x)        _VALUEOF(x)
S  #define  CHIP_PERCFG_MCBSP1EN_DISABLE      0x00000000u
S  #define  CHIP_PERCFG_MCBSP1EN_ENABLE       0x00000001u
S
S  #define _CHIP_PERCFG_MCBSP0EN_MASK         0x00000002u
S  #define _CHIP_PERCFG_MCBSP0EN_SHIFT        0x00000001u
S  #define  CHIP_PERCFG_MCBSP0EN_DEFAULT      0x00000001u
S  #define  CHIP_PERCFG_MCBSP0EN_OF(x)        _VALUEOF(x)
S  #define  CHIP_PERCFG_MCBSP0EN_DISABLE      0x00000000u
S  #define  CHIP_PERCFG_MCBSP0EN_ENABLE       0x00000001u
S
S#if (CHIP_DM642 | CHIP_DM641 | CHIP_DM640)
S  #define _CHIP_PERCFG_MCASP0EN_MASK         0x00000001u
S  #define _CHIP_PERCFG_MCASP0EN_SHIFT        0x00000000u
S  #define  CHIP_PERCFG_MCASP0EN_DEFAULT      0x00000000u
S  #define  CHIP_PERCFG_MCASP0EN_OF(x)         _VALUEOF(x)
S  #define  CHIP_PERCFG_MCASP0EN_DISABLE      0x00000000u
S  #define  CHIP_PERCFG_MCASP0EN_ENABLE       0x00000001u
S#endif
S
S
S  #define  CHIP_PERCFG_OF(x)              _VALUEOF(x)
S
S#if (CHIP_DM642)
S  #define CHIP_PERCFG_DEFAULT (Uint32)( \
S     _PER_FDEFAULT(CHIP,PERCFG,VP2EN) \
S    |_PER_FDEFAULT(CHIP,PERCFG,VP1EN) \
S    |_PER_FDEFAULT(CHIP,PERCFG,VP0EN) \
S    |_PER_FDEFAULT(CHIP,PERCFG,I2C0EN) \
S    |_PER_FDEFAULT(CHIP,PERCFG,MCBSP1EN) \
S    |_PER_FDEFAULT(CHIP,PERCFG,MCBSP0EN) \
S    |_PER_FDEFAULT(CHIP,PERCFG,MCASP0EN) \
S   )
X  #define CHIP_PERCFG_DEFAULT (Uint32)(      _PER_FDEFAULT(CHIP,PERCFG,VP2EN)     |_PER_FDEFAULT(CHIP,PERCFG,VP1EN)     |_PER_FDEFAULT(CHIP,PERCFG,VP0EN)     |_PER_FDEFAULT(CHIP,PERCFG,I2C0EN)     |_PER_FDEFAULT(CHIP,PERCFG,MCBSP1EN)     |_PER_FDEFAULT(CHIP,PERCFG,MCBSP0EN)     |_PER_FDEFAULT(CHIP,PERCFG,MCASP0EN)    )
S
S
S #define CHIP_PERCFG_RMK(vp2en,vp1en,vp0en,i2c0en,mcbsp1en,mcbsp0en,mcasp0en) (Uint32)( \
S     _PER_FMK(CHIP,PERCFG,VP2EN,vp2en) \
S    |_PER_FMK(CHIP,PERCFG,VP1EN,vp1en) \
S    |_PER_FMK(CHIP,PERCFG,VP0EN,vp0en) \
S    |_PER_FMK(CHIP,PERCFG,I2C0EN,i2c0en) \
S    |_PER_FMK(CHIP,PERCFG,MCBSP1EN,mcbsp1en) \
S    |_PER_FMK(CHIP,PERCFG,MCBSP0EN,mcbsp0en) \
S    |_PER_FMK(CHIP,PERCFG,MCASP0EN,mcasp0en) \
S  )
X #define CHIP_PERCFG_RMK(vp2en,vp1en,vp0en,i2c0en,mcbsp1en,mcbsp0en,mcasp0en) (Uint32)(      _PER_FMK(CHIP,PERCFG,VP2EN,vp2en)     |_PER_FMK(CHIP,PERCFG,VP1EN,vp1en)     |_PER_FMK(CHIP,PERCFG,VP0EN,vp0en)     |_PER_FMK(CHIP,PERCFG,I2C0EN,i2c0en)     |_PER_FMK(CHIP,PERCFG,MCBSP1EN,mcbsp1en)     |_PER_FMK(CHIP,PERCFG,MCBSP0EN,mcbsp0en)     |_PER_FMK(CHIP,PERCFG,MCASP0EN,mcasp0en)   )
S#endif
S
S#if (CHIP_DM641)
S  #define CHIP_PERCFG_DEFAULT (Uint32)( \
S     _PER_FDEFAULT(CHIP,PERCFG,VP1EN) \
S    |_PER_FDEFAULT(CHIP,PERCFG,VP0EN) \
S    |_PER_FDEFAULT(CHIP,PERCFG,I2C0EN) \
S    |_PER_FDEFAULT(CHIP,PERCFG,MCBSP1EN) \
S    |_PER_FDEFAULT(CHIP,PERCFG,MCBSP0EN) \
S    |_PER_FDEFAULT(CHIP,PERCFG,MCASP0EN) \
S   )
X  #define CHIP_PERCFG_DEFAULT (Uint32)(      _PER_FDEFAULT(CHIP,PERCFG,VP1EN)     |_PER_FDEFAULT(CHIP,PERCFG,VP0EN)     |_PER_FDEFAULT(CHIP,PERCFG,I2C0EN)     |_PER_FDEFAULT(CHIP,PERCFG,MCBSP1EN)     |_PER_FDEFAULT(CHIP,PERCFG,MCBSP0EN)     |_PER_FDEFAULT(CHIP,PERCFG,MCASP0EN)    )
S
S
S #define CHIP_PERCFG_RMK(vp1en,vp0en,i2c0en,mcbsp1en,mcbsp0en,mcasp0en) (Uint32)( \
S     _PER_FMK(CHIP,PERCFG,VP1EN,vp1en) \
S    |_PER_FMK(CHIP,PERCFG,VP0EN,vp0en) \
S    |_PER_FMK(CHIP,PERCFG,I2C0EN,i2c0en) \
S    |_PER_FMK(CHIP,PERCFG,MCBSP1EN,mcbsp1en) \
S    |_PER_FMK(CHIP,PERCFG,MCBSP0EN,mcbsp0en) \
S    |_PER_FMK(CHIP,PERCFG,MCASP0EN,mcasp0en) \
S  )
X #define CHIP_PERCFG_RMK(vp1en,vp0en,i2c0en,mcbsp1en,mcbsp0en,mcasp0en) (Uint32)(      _PER_FMK(CHIP,PERCFG,VP1EN,vp1en)     |_PER_FMK(CHIP,PERCFG,VP0EN,vp0en)     |_PER_FMK(CHIP,PERCFG,I2C0EN,i2c0en)     |_PER_FMK(CHIP,PERCFG,MCBSP1EN,mcbsp1en)     |_PER_FMK(CHIP,PERCFG,MCBSP0EN,mcbsp0en)     |_PER_FMK(CHIP,PERCFG,MCASP0EN,mcasp0en)   )
S#endif
S
S#if (CHIP_DM640)
S  #define CHIP_PERCFG_DEFAULT (Uint32)( \
S     _PER_FDEFAULT(CHIP,PERCFG,VP0EN) \
S    |_PER_FDEFAULT(CHIP,PERCFG,I2C0EN) \
S    |_PER_FDEFAULT(CHIP,PERCFG,MCBSP1EN) \
S    |_PER_FDEFAULT(CHIP,PERCFG,MCBSP0EN) \
S    |_PER_FDEFAULT(CHIP,PERCFG,MCASP0EN) \
S   )
X  #define CHIP_PERCFG_DEFAULT (Uint32)(      _PER_FDEFAULT(CHIP,PERCFG,VP0EN)     |_PER_FDEFAULT(CHIP,PERCFG,I2C0EN)     |_PER_FDEFAULT(CHIP,PERCFG,MCBSP1EN)     |_PER_FDEFAULT(CHIP,PERCFG,MCBSP0EN)     |_PER_FDEFAULT(CHIP,PERCFG,MCASP0EN)    )
S
S
S #define CHIP_PERCFG_RMK(vp0en,i2c0en,mcbsp1en,mcbsp0en,mcasp0en) (Uint32)( \
S     _PER_FMK(CHIP,PERCFG,VP0EN,vp0en) \
S    |_PER_FMK(CHIP,PERCFG,I2C0EN,i2c0en) \
S    |_PER_FMK(CHIP,PERCFG,MCBSP1EN,mcbsp1en) \
S    |_PER_FMK(CHIP,PERCFG,MCBSP0EN,mcbsp0en) \
S    |_PER_FMK(CHIP,PERCFG,MCASP0EN,mcasp0en) \
S  )
X #define CHIP_PERCFG_RMK(vp0en,i2c0en,mcbsp1en,mcbsp0en,mcasp0en) (Uint32)(      _PER_FMK(CHIP,PERCFG,VP0EN,vp0en)     |_PER_FMK(CHIP,PERCFG,I2C0EN,i2c0en)     |_PER_FMK(CHIP,PERCFG,MCBSP1EN,mcbsp1en)     |_PER_FMK(CHIP,PERCFG,MCBSP0EN,mcbsp0en)     |_PER_FMK(CHIP,PERCFG,MCASP0EN,mcasp0en)   )
S#endif
S
S#if (CHIP_6412)
S  #define CHIP_PERCFG_DEFAULT (Uint32)( \
S     _PER_FDEFAULT(CHIP,PERCFG,I2C0EN) \
S    |_PER_FDEFAULT(CHIP,PERCFG,MCBSP1EN) \
S    |_PER_FDEFAULT(CHIP,PERCFG,MCBSP0EN) \
S   )
X  #define CHIP_PERCFG_DEFAULT (Uint32)(      _PER_FDEFAULT(CHIP,PERCFG,I2C0EN)     |_PER_FDEFAULT(CHIP,PERCFG,MCBSP1EN)     |_PER_FDEFAULT(CHIP,PERCFG,MCBSP0EN)    )
S
S
S #define CHIP_PERCFG_RMK(i2c0en,mcbsp1en,mcbsp0en) (Uint32)( \
S    |_PER_FMK(CHIP,PERCFG,I2C0EN,i2c0en) \
S    |_PER_FMK(CHIP,PERCFG,MCBSP1EN,mcbsp1en) \
S    |_PER_FMK(CHIP,PERCFG,MCBSP0EN,mcbsp0en) \
S  )
X #define CHIP_PERCFG_RMK(i2c0en,mcbsp1en,mcbsp0en) (Uint32)(     |_PER_FMK(CHIP,PERCFG,I2C0EN,i2c0en)     |_PER_FMK(CHIP,PERCFG,MCBSP1EN,mcbsp1en)     |_PER_FMK(CHIP,PERCFG,MCBSP0EN,mcbsp0en)   )
S#endif
S
N#endif /* CHIP_DM642 || CHIP_6412  */
N
N#if (CHIP_6410 || CHIP_6413 || CHIP_6418)
X#if (0 || 0 || 0)
S
S  #define   _CHIP_PERCFG_ADDR                0x01B3F000u
S  #define   _CHIP_PERCFG_OFFSET              0
S  
S  #define _CHIP_PERCFG_AFCMUX_MASK           0x00000600u
S  #define _CHIP_PERCFG_AFCMUX_SHIFT          0x00000009u
S  #define  CHIP_PERCFG_AFCMUX_DEFAULT        0x00000000u
S  #define  CHIP_PERCFG_AFCMUX_OF(x)           _VALUEOF(x)
S  #define  CHIP_PERCFG_AFCMUX_PIN0           0x00000000u
S  #define  CHIP_PERCFG_AFCMUX_PIN1           0x00000001u
S  #define  CHIP_PERCFG_AFCMUX_PIN2           0x00000002u
S  #define  CHIP_PERCFG_AFCMUX_PIN3           0x00000003u
S 
S  #define _CHIP_PERCFG_MCASP1EN_MASK         0x00000100u
S  #define _CHIP_PERCFG_MCASP1EN_SHIFT        0x00000008u
S  #define  CHIP_PERCFG_MCASP1EN_DEFAULT      0x00000000u
S  #define  CHIP_PERCFG_MCASP1EN_OF(x)         _VALUEOF(x)
S  #define  CHIP_PERCFG_MCASP1EN_DISABLE      0x00000000u
S  #define  CHIP_PERCFG_MCASP1EN_ENABLE       0x00000001u
S
S  #define _CHIP_PERCFG_I2C1EN_MASK           0x00000080u
S  #define _CHIP_PERCFG_I2C1EN_SHIFT          0x00000007u
S  #define  CHIP_PERCFG_I2C1EN_DEFAULT        0x00000000u
S  #define  CHIP_PERCFG_I2C1EN_OF(x)          _VALUEOF(x)
S  #define  CHIP_PERCFG_I2C1EN_DISABLE        0x00000000u
S  #define  CHIP_PERCFG_I2C1EN_ENABLE         0x00000001u
S
S  #define _CHIP_PERCFG_I2C0EN_MASK           0x00000008u
S  #define _CHIP_PERCFG_I2C0EN_SHIFT          0x00000003u
S  #define  CHIP_PERCFG_I2C0EN_DEFAULT        0x00000000u
S  #define  CHIP_PERCFG_I2C0EN_OF(x)          _VALUEOF(x)
S  #define  CHIP_PERCFG_I2C0EN_DISABLE        0x00000000u
S  #define  CHIP_PERCFG_I2C0EN_ENABLE         0x00000001u
S
S  #define _CHIP_PERCFG_MCBSP1EN_MASK         0x00000004u
S  #define _CHIP_PERCFG_MCBSP1EN_SHIFT        0x00000002u
S  #define  CHIP_PERCFG_MCBSP1EN_DEFAULT      0x00000001u
S  #define  CHIP_PERCFG_MCBSP1EN_OF(x)        _VALUEOF(x)
S  #define  CHIP_PERCFG_MCBSP1EN_DISABLE      0x00000000u
S  #define  CHIP_PERCFG_MCBSP1EN_ENABLE       0x00000001u
S 
S  #define _CHIP_PERCFG_MCBSP0EN_MASK         0x00000002u
S  #define _CHIP_PERCFG_MCBSP0EN_SHIFT        0x00000001u
S  #define  CHIP_PERCFG_MCBSP0EN_DEFAULT      0x00000001u
S  #define  CHIP_PERCFG_MCBSP0EN_OF(x)        _VALUEOF(x)
S  #define  CHIP_PERCFG_MCBSP0EN_DISABLE      0x00000000u
S  #define  CHIP_PERCFG_MCBSP0EN_ENABLE       0x00000001u
S
S  #define _CHIP_PERCFG_MCASP0EN_MASK         0x00000001u
S  #define _CHIP_PERCFG_MCASP0EN_SHIFT        0x00000000u
S  #define  CHIP_PERCFG_MCASP0EN_DEFAULT      0x00000000u
S  #define  CHIP_PERCFG_MCASP0EN_OF(x)         _VALUEOF(x)
S  #define  CHIP_PERCFG_MCASP0EN_DISABLE      0x00000000u
S  #define  CHIP_PERCFG_MCASP0EN_ENABLE       0x00000001u
S
S  #define  CHIP_PERCFG_OF(x)              _VALUEOF(x)
S
S  #define CHIP_PERCFG_DEFAULT (Uint32)( \
S    _PER_FDEFAULT(CHIP,PERCFG,AFCMUX) \
S    |_PER_FDEFAULT(CHIP,PERCFG,MCASP1EN) \
S    |_PER_FDEFAULT(CHIP,PERCFG,I2C1EN) \
S    |_PER_FDEFAULT(CHIP,PERCFG,I2C0EN) \
S    |_PER_FDEFAULT(CHIP,PERCFG,MCBSP1EN) \
S    |_PER_FDEFAULT(CHIP,PERCFG,MCBSP0EN) \
S    |_PER_FDEFAULT(CHIP,PERCFG,MCASP0EN) \
S   )  
X  #define CHIP_PERCFG_DEFAULT (Uint32)(     _PER_FDEFAULT(CHIP,PERCFG,AFCMUX)     |_PER_FDEFAULT(CHIP,PERCFG,MCASP1EN)     |_PER_FDEFAULT(CHIP,PERCFG,I2C1EN)     |_PER_FDEFAULT(CHIP,PERCFG,I2C0EN)     |_PER_FDEFAULT(CHIP,PERCFG,MCBSP1EN)     |_PER_FDEFAULT(CHIP,PERCFG,MCBSP0EN)     |_PER_FDEFAULT(CHIP,PERCFG,MCASP0EN)    )  
S  
S
S #define CHIP_PERCFG_RMK(afcmux,mcasp1en,i2c1en,i2c0en,mcasp0en) (Uint32)( \
S    _PER_FMK(CHIP,PERCFG,AFCMUX,afcmux) \
S    |_PER_FMK(CHIP,PERCFG,MCASP1EN,mcasp1en) \
S    |_PER_FMK(CHIP,PERCFG,I2C1EN,i2c1en) \
S    |_PER_FMK(CHIP,PERCFG,I2C0EN,i2c0en) \
S    |_PER_FMK(CHIP,PERCFG,MCASP0EN,mcasp0en) \
S  )  
X #define CHIP_PERCFG_RMK(afcmux,mcasp1en,i2c1en,i2c0en,mcasp0en) (Uint32)(     _PER_FMK(CHIP,PERCFG,AFCMUX,afcmux)     |_PER_FMK(CHIP,PERCFG,MCASP1EN,mcasp1en)     |_PER_FMK(CHIP,PERCFG,I2C1EN,i2c1en)     |_PER_FMK(CHIP,PERCFG,I2C0EN,i2c0en)     |_PER_FMK(CHIP,PERCFG,MCASP0EN,mcasp0en)   )  
S
N#endif /* CHIP_6410 || CHIP_6413 || CHIP_6418 */
N
N#if (CHIP_6711C || CHIP_6712C)
X#if (0 || 0)
S  #define   _CHIP_DEVCFG_ADDR              0x019C0200u
S  #define   _CHIP_DEVCFG_OFFSET            0
S
S  #define _CHIP_DEVCFG_EKSRC_MASK          0x00000010u
S  #define _CHIP_DEVCFG_EKSRC_SHIFT         0x00000004u
S  #define  CHIP_DEVCFG_EKSRC_DEFAULT       0x00000000u
S  #define  CHIP_DEVCFG_EKSRC_OF(x)         _VALUEOF(x)
S  #define  CHIP_DEVCFG_EKSRC_SYSCLK3       0x00000000u
S  #define  CHIP_DEVCFG_EKSRC_ECLKIN        0x00000001u
S
S  #define  CHIP_DEVCFG_OF(x)              _VALUEOF(x)
S
S  #define CHIP_DEVCFG_DEFAULT (Uint32)( \
S     _PER_FDEFAULT(CHIP,DEVCFG,EKSRC) \
S )
X  #define CHIP_DEVCFG_DEFAULT (Uint32)(      _PER_FDEFAULT(CHIP,DEVCFG,EKSRC)  )
S
S  #define CHIP_PERCFG_RMK(eksrc) (Uint32)( \
S      _PER_FMK(CHIP,PERCFG,EKSRC,eksrc) \
S)
X  #define CHIP_PERCFG_RMK(eksrc) (Uint32)(       _PER_FMK(CHIP,PERCFG,EKSRC,eksrc) )
S
N#endif /* CHIP_6711C || CHIP_6712C */
N
N#if (CHIP_6711C || CHIP_6712C || CHIP_DA610 || CHIP_6713) 
X#if (0 || 0 || 0 || 0) 
S  #define _CHIP_DEVCFG_FGET(FIELD)\
S    _PER_FGET(_CHIP_DEVCFG_ADDR,CHIP,DEVCFG,##FIELD)
X  #define _CHIP_DEVCFG_FGET(FIELD)    _PER_FGET(_CHIP_DEVCFG_ADDR,CHIP,DEVCFG,##FIELD)
S
S  #define _CHIP_DEVCFG_FSET(FIELD,field)\
S    _PER_FSET(_CHIP_DEVCFG_ADDR,CHIP,DEVCFG,##FIELD,field)
X  #define _CHIP_DEVCFG_FSET(FIELD,field)    _PER_FSET(_CHIP_DEVCFG_ADDR,CHIP,DEVCFG,##FIELD,field)
S
S  #define _CHIP_DEVCFG_FSETS(FIELD,SYM)\
S    _PER_FSETS(_CHIP_DEVCFG_ADDR,CHIP,DEVCFG,##FIELD,##SYM)
X  #define _CHIP_DEVCFG_FSETS(FIELD,SYM)    _PER_FSETS(_CHIP_DEVCFG_ADDR,CHIP,DEVCFG,##FIELD,##SYM)
S   
N#else
N  
N  #define _CHIP_PERCFG_FGET(FIELD)\
N    _PER_FGET(_CHIP_PERCFG_ADDR,CHIP,PERCFG,##FIELD)
X  #define _CHIP_PERCFG_FGET(FIELD)    _PER_FGET(_CHIP_PERCFG_ADDR,CHIP,PERCFG,##FIELD)
N
N  #define _CHIP_PERCFG_FSET(FIELD,field)\
N    _PER_FSET(_CHIP_PERCFG_ADDR,CHIP,PERCFG,##FIELD,field)
X  #define _CHIP_PERCFG_FSET(FIELD,field)    _PER_FSET(_CHIP_PERCFG_ADDR,CHIP,PERCFG,##FIELD,field)
N
N  #define _CHIP_PERCFG_FSETS(FIELD,SYM)\
N    _PER_FSETS(_CHIP_PERCFG_ADDR,CHIP,PERCFG,##FIELD,##SYM)
X  #define _CHIP_PERCFG_FSETS(FIELD,SYM)    _PER_FSETS(_CHIP_PERCFG_ADDR,CHIP,PERCFG,##FIELD,##SYM)
N#endif
N
N/*----------------------------------------------------------------------------*/
N/******************************************************************************\
N* _____________________
X
N* |                   |
N* |  D E V S T A T    |
N* |___________________|
N*
N* DEVSTAT - Device Status Register (1)
N*
N* FIELDS (msb -> lsb)
N* DM642
N* (r) MACEN
N* (r) HPIWIDTH
N* (r) PCIEEAI
N* (r) PCIEN
N* (r) CLKMODE
N* (r) LENDIAN
N* (r) BOOTMODE
N* (r) AECLKINSEL
N*
N* DRI300
N* (r) PLLM
N* (r) OSCEXTRES
N* (r) CLKINSEL
N* (r) CLKMODE3
N* (r) HPIWIDTH
N* (r) HPIENZ
N* (r) CLKMODE2
N* (r) CLKMODE1
N* (r) CLKMODE0
N* (r) LENDIAN
N* (r) BOOTMODE
N* (r) AECLKINSEL
N*
N* 
N\******************************************************************************/
N#if (CHIP_DM642 | CHIP_DM641 | CHIP_DM640 | CHIP_6412)
X#if (0 | 0 | 0 | 0)
S
S  #define   _CHIP_DEVSTAT_ADDR                0x01B3F004u
S  #define   _CHIP_DEVSTAT_OFFSET              0
S
S  #define _CHIP_DEVSTAT_MACEN_MASK            0x00000800u
S  #define _CHIP_DEVSTAT_MACEN_SHIFT           0x0000000Bu
S  #define  CHIP_DEVSTAT_MACEN_DEFAULT         0x00000000u
S  #define  CHIP_DEVSTAT_MACEN_OF(x)           _VALUEOF(x)
S  #define  CHIP_DEVSTAT_MACEN_DISABLE         0x00000000u
S  #define  CHIP_DEVSTAT_MACEN_ENABLE          0x00000001u
S
S #if !(CHIP_DM640)
S  #define _CHIP_DEVSTAT_HPIWIDTH_MASK            0x00000400u
S  #define _CHIP_DEVSTAT_HPIWIDTH_SHIFT           0x0000000Au
S  #define  CHIP_DEVSTAT_HPIWIDTH_DEFAULT         0x00000000u
S  #define  CHIP_DEVSTAT_HPIWIDTH_OF(x)           _VALUEOF(x)
S  #define  CHIP_DEVSTAT_HPIWIDTH_16              0x00000000u
S  #define  CHIP_DEVSTAT_HPIWIDTH_32              0x00000001u
S #endif
S
S #if !(CHIP_DM641 | CHIP_DM640)
S  #define _CHIP_DEVSTAT_PCIEEAI_MASK            0x00000200u
S  #define _CHIP_DEVSTAT_PCIEEAI_SHIFT           0x00000009u
S  #define  CHIP_DEVSTAT_PCIEEAI_DEFAULT         0x00000000u
S  #define  CHIP_DEVSTAT_PCIEEAI_OF(x)           _VALUEOF(x)
S  #define  CHIP_DEVSTAT_PCIEEAI_NONE            0x00000000u
S  #define  CHIP_DEVSTAT_PCIEEAI_INIT            0x00000001u
S
S  #define _CHIP_DEVSTAT_PCIEN_MASK           0x00000100u
S  #define _CHIP_DEVSTAT_PCIEN_SHIFT          0x00000008u
S  #define  CHIP_DEVSTAT_PCIEN_DEFAULT        0x00000000u
S  #define  CHIP_DEVSTAT_PCIEN_OF(x)          _VALUEOF(x)
S  #define  CHIP_DEVSTAT_PCIEN_DISABLE        0x00000000u
S  #define  CHIP_DEVSTAT_PCIEN_ENABLE         0x00000001u
S #endif
S
S  #define _CHIP_DEVSTAT_CLKMODE_MASK         0x00000060u
S  #define _CHIP_DEVSTAT_CLKMODE_SHIFT        0x00000005u
S  #define  CHIP_DEVSTAT_CLKMODE_DEFAULT      0x00000001u
S  #define  CHIP_DEVSTAT_CLKMODE_OF(x)        _VALUEOF(x)
S  #define  CHIP_DEVSTAT_CLKMODE_X1           0x00000000u
S  #define  CHIP_DEVSTAT_CLKMODE_X6           0x00000001u
S  #define  CHIP_DEVSTAT_CLKMODE_X12          0x00000002u
S  #define  CHIP_DEVSTAT_CLKMODE_X20          0x00000003u
S
S  #define _CHIP_DEVSTAT_LENDIAN_MASK         0x00000010u
S  #define _CHIP_DEVSTAT_LENDIAN_SHIFT        0x00000004u
S  #define  CHIP_DEVSTAT_LENDIAN_DEFAULT      0x00000001u
S  #define  CHIP_DEVSTAT_LENDIAN_OF(x)        _VALUEOF(x)
S  #define  CHIP_DEVSTAT_LENDIAN_BIG          0x00000000u
S  #define  CHIP_DEVSTAT_LENDIAN_LITTLE       0x00000001u
S
S  #define _CHIP_DEVSTAT_BOOTMODE_MASK         0x0000000Cu
S  #define _CHIP_DEVSTAT_BOOTMODE_SHIFT        0x00000002u
S  #define  CHIP_DEVSTAT_BOOTMODE_DEFAULT      0x00000000u
S  #define  CHIP_DEVSTAT_BOOTMODE_OF(x)         _VALUEOF(x)
S  #define  CHIP_DEVSTAT_BOOTMODE_NONE         0x00000000u
S  #define  CHIP_DEVSTAT_BOOTMODE_HPIPCI       0x00000001u
S  #define  CHIP_DEVSTAT_BOOTMODE_EMIFA        0x00000003u
S
S  #define _CHIP_DEVSTAT_AECLKINSEL_MASK         0x00000003u
S  #define _CHIP_DEVSTAT_AECLKINSEL_SHIFT        0x00000000u
S  #define  CHIP_DEVSTAT_AECLKINSEL_DEFAULT      0x00000000u
S  #define  CHIP_DEVSTAT_AECLKINSEL_OF(x)         _VALUEOF(x)
S  #define  CHIP_DEVSTAT_AECLKINSEL_ECLKIN       0x00000000u
S  #define  CHIP_DEVSTAT_AECLKINSEL_CLKOUT4      0x00000001u
S  #define  CHIP_DEVSTAT_AECLKINSEL_CLKOUT6      0x00000002u
S  #define  CHIP_DEVSTAT_OF(x)              _VALUEOF(x)
S
S  #define  CHIP_DEVSTAT_OF(x)              _VALUEOF(x)
S
S  /* Read only Register */
S
S  #define _CHIP_DEVSTAT_FGET(FIELD)\
S    _PER_FGET(_CHIP_DEVSTAT_ADDR,CHIP,DEVSTAT,##FIELD)
X  #define _CHIP_DEVSTAT_FGET(FIELD)    _PER_FGET(_CHIP_DEVSTAT_ADDR,CHIP,DEVSTAT,##FIELD)
S
S
N#endif /* CHIP_DM642 | CHIP_6412  */
N
N#if (CHIP_6410 || CHIP_6413 || CHIP_6418)
X#if (0 || 0 || 0)
S
S  #define   _CHIP_DEVSTAT_ADDR                 0x01B3F004u
S  #define   _CHIP_DEVSTAT_OFFSET               0
S
S  #define _CHIP_DEVSTAT_PLLM_MASK              0x00F10000u
S  #define _CHIP_DEVSTAT_PLLM_SHIFT             0x00000013u
S  #define  CHIP_DEVSTAT_PLLM_DEFAULT           0x00000000u
S  #define  CHIP_DEVSTAT_PLLM_OF(x)             _VALUEOF(x)
S  #define  CHIP_DEVSTAT_PLLM_BYPASS            0x00000000u
S  #define  CHIP_DEVSTAT_PLLM_5                 0x00000001u
S  #define  CHIP_DEVSTAT_PLLM_6                 0x00000002u
S  #define  CHIP_DEVSTAT_PLLM_7                 0x00000003u
S  #define  CHIP_DEVSTAT_PLLM_8                 0x00000004u
S  #define  CHIP_DEVSTAT_PLLM_9                 0x00000005u
S  #define  CHIP_DEVSTAT_PLLM_10                0x00000006u
S  #define  CHIP_DEVSTAT_PLLM_11                0x00000007u
S  #define  CHIP_DEVSTAT_PLLM_12                0x00000008u
S  #define  CHIP_DEVSTAT_PLLM_16                0x00000009u
S  #define  CHIP_DEVSTAT_PLLM_18                0x0000000Au
S  #define  CHIP_DEVSTAT_PLLM_19                0x0000000Bu
S  #define  CHIP_DEVSTAT_PLLM_20                0x0000000Cu
S  #define  CHIP_DEVSTAT_PLLM_21                0x0000000Du
S  #define  CHIP_DEVSTAT_PLLM_22                0x0000000Eu
S  #define  CHIP_DEVSTAT_PLLM_24                0x0000000Fu
S 
S  #define _CHIP_DEVSTAT_OSCEXTRES_MASK         0x00020000u
S  #define _CHIP_DEVSTAT_OSCEXTRES_SHIFT        0x00000011u
S  #define  CHIP_DEVSTAT_OSCEXTRES_DEFAUL       0x00000001u
S  #define  CHIP_DEVSTAT_OSCEXTRES_OF(x)        _VALUEOF(x)
S  #define  CHIP_DEVSTAT_OSCEXTRES_DISABL       0x00000000u
S  #define  CHIP_DEVSTAT_OSCEXTRES_ENABLE       0x00000001u
S 
S  #define _CHIP_DEVSTAT_CLKINSEL_MASK          0x00010000u
S  #define _CHIP_DEVSTAT_CLKINSEL_SHIFT         0x00000010u
S  #define  CHIP_DEVSTAT_CLKINSEL_DEFAULT       0x00000000u
S  #define  CHIP_DEVSTAT_CLKINSEL_OF(x)         _VALUEOF(x)
S  #define  CHIP_DEVSTAT_CLKINSEL_DISABLE       0x00000000u
S  #define  CHIP_DEVSTAT_CLKINSEL_ENABLE        0x00000001u
S 
S  #define _CHIP_DEVSTAT_HPIWIDTH_MASK          0x00000400u
S  #define _CHIP_DEVSTAT_HPIWIDTH_SHIFT         0x0000000Au
S  #define  CHIP_DEVSTAT_HPIWIDTH_DEFAUL        0x00000000u
S  #define  CHIP_DEVSTAT_HPIWIDTH_OF(x)         _VALUEOF(x)
S  #define  CHIP_DEVSTAT_HPIWIDTH_16            0x00000000u
S  #define  CHIP_DEVSTAT_HPIWIDTH_32            0x00000001u
S 
S  #define _CHIP_DEVSTAT_HPIENZ_MASK            0x00000100u
S  #define _CHIP_DEVSTAT_HPIENZ_SHIFT           0x00000008u
S  #define  CHIP_DEVSTAT_HPIENZ_DEFAULT         0x00000000u
S  #define  CHIP_DEVSTAT_HPIENZ_OF(x)           _VALUEOF(x)
S  #define  CHIP_DEVSTAT_HPIENZ_ENABLE          0x00000000u
S  #define  CHIP_DEVSTAT_HPIENZ_DISABLE         0x00000001u
S 
S  #define _CHIP_DEVSTAT_CLKMODE_MASK          0x000010E0u
S  #define _CHIP_DEVSTAT_CLKMODE_SHIFT         0x00000005u
S  #define  CHIP_DEVSTAT_CLKMODE_DEFAULT       0x00000001u
S  #define  CHIP_DEVSTAT_CLKMODE_OF(x)         _VALUEOF(x)
S  #define  CHIP_DEVSTAT_CLKMODE_0             0x00000000u
S  #define  CHIP_DEVSTAT_CLKMODE_1             0x00000001u
S  #define  CHIP_DEVSTAT_CLKMODE_2             0x00000002u
S  #define  CHIP_DEVSTAT_CLKMODE_3             0x00000003u
S  #define  CHIP_DEVSTAT_CLKMODE_4             0x00000004u
S  #define  CHIP_DEVSTAT_CLKMODE_5             0x00000005u
S  #define  CHIP_DEVSTAT_CLKMODE_6             0x00000006u
S  #define  CHIP_DEVSTAT_CLKMODE_7             0x00000007u
S  #define  CHIP_DEVSTAT_CLKMODE_8             0x00000080u
S  #define  CHIP_DEVSTAT_CLKMODE_9             0x00000081u
S  #define  CHIP_DEVSTAT_CLKMODE_10            0x00000082u
S  #define  CHIP_DEVSTAT_CLKMODE_11            0x00000083u
S  #define  CHIP_DEVSTAT_CLKMODE_12            0x00000084u
S  #define  CHIP_DEVSTAT_CLKMODE_13            0x00000085u
S  #define  CHIP_DEVSTAT_CLKMODE_14            0x00000086u
S  #define  CHIP_DEVSTAT_CLKMODE_15            0x00000087u
S 
S  #define _CHIP_DEVSTAT_LENDIAN_MASK           0x00000010u
S  #define _CHIP_DEVSTAT_LENDIAN_SHIFT          0x00000004u
S  #define  CHIP_DEVSTAT_LENDIAN_DEFAULT        0x00000001u
S  #define  CHIP_DEVSTAT_LENDIAN_OF(x)          _VALUEOF(x)
S  #define  CHIP_DEVSTAT_LENDIAN_BIG            0x00000000u 
S  #define  CHIP_DEVSTAT_LENDIAN_LITTLE         0x00000001u
S 
S  #define _CHIP_DEVSTAT_BOOTMODE_MASK          0x0000000Cu
S  #define _CHIP_DEVSTAT_BOOTMODE_SHIFT         0x00000002u
S  #define  CHIP_DEVSTAT_BOOTMODE_DEFAULT       0x00000000u
S  #define  CHIP_DEVSTAT_BOOTMODE_OF(x)          _VALUEOF(x)
S  #define  CHIP_DEVSTAT_BOOTMODE_NONE          0x00000000u
S  #define  CHIP_DEVSTAT_BOOTMODE_HPI           0x00000001u
S  #define  CHIP_DEVSTAT_BOOTMODE_EMIFA         0x00000003u
S
S  #define _CHIP_DEVSTAT_AECLKINSEL_MASK        0x00000003u
S  #define _CHIP_DEVSTAT_AECLKINSEL_SHIFT       0x00000000u
S  #define  CHIP_DEVSTAT_AECLKINSEL_DEFAULT     0x00000000u
S  #define  CHIP_DEVSTAT_AECLKINSEL_OF(x)       _VALUEOF(x)
S  #define  CHIP_DEVSTAT_AECLKINSEL_ECLKIN      0x00000000u
S  #define  CHIP_DEVSTAT_AECLKINSEL_CLKOUT4     0x00000001u
S  #define  CHIP_DEVSTAT_AECLKINSEL_CLKOUT6     0x00000002u
S
S  #define  CHIP_DEVSTAT_OF(x)              _VALUEOF(x)
S
S  /* Read only Register */
S
S  #define _CHIP_DEVSTAT_FGET(FIELD)\
S    _PER_FGET(_CHIP_DEVSTAT_ADDR,CHIP,DEVSTAT,##FIELD)
X  #define _CHIP_DEVSTAT_FGET(FIELD)    _PER_FGET(_CHIP_DEVSTAT_ADDR,CHIP,DEVSTAT,##FIELD)
S
S
N#endif /* CHIP_6410 || CHIP_6413 || CHIP_6418 */
N
N/******************************************************************************\
N* _____________________
X
N* |                   |
N* |  J T A G I D      |
N* |___________________|
N*
N* JTAGID - JTAG ID register (1)
N*
N* FIELDS (msb -> lsb)
N* (r) VARIANT
N* (r) PART
N* (r) MANNUFACTURE
N* (r) LSB
N*
N* (1) Only for DM642
N*
N\******************************************************************************/
N
N
N#if (CHIP_DM642 || CHIP_DM641 || CHIP_DM640 || CHIP_6412 )
X#if (0 || 0 || 0 || 0 )
S
S  #define   _CHIP_JTAGID_ADDR                0x01B3F008u
S  #define   _CHIP_JTAGID_OFFSET              0
S
S  #define _CHIP_JTAGID_VARIANT_MASK          0xF0000000u
S  #define _CHIP_JTAGID_VARIANT_SHIFT         0x0000001Cu
S  #define  CHIP_JTAGID_VARIANT_DEFAULT       0x00000000u
S  #define  CHIP_JTAGID_VARIANT_OF(x)         _VALUEOF(x)
S
S  #define _CHIP_JTAGID_PART_MASK             0x0FFFF000u
S  #define _CHIP_JTAGID_PART_SHIFT            0x0000000Cu
S  #define  CHIP_JTAGID_PART_DEFAULT          0x00000079u
S  #define  CHIP_JTAGID_PART_OF(x)            _VALUEOF(x)
S
S  #define _CHIP_JTAGID_MANUFACTURE_MASK      0x00000FFEu
S  #define _CHIP_JTAGID_MANUFACTURE_SHIFT     0x00000001u
S  #define  CHIP_JTAGID_MANUFACTURE_DEFAULT   0x00000017u
S  #define  CHIP_JTAGID_MANUFACTURE_OF(x)     _VALUEOF(x)
S
S  #define _CHIP_JTAGID_LSB_MASK              0x00000001u
S  #define _CHIP_JTAGID_LSB_SHIFT             0x00000000u
S  #define  CHIP_JTAGID_LSB_DEFAULT           0x00000001u
S  #define  CHIP_JTAGID_LSB_OF(x)             _VALUEOF(x)
S
S  #define  CHIP_JTAGID_OF(x)              _VALUEOF(x)
S
S  #define _CHIP_JTAGID_FGET(FIELD)\
S    _PER_FGET(_CHIP_JTAGID_ADDR,CHIP,JTAGID,##FIELD)
X  #define _CHIP_JTAGID_FGET(FIELD)    _PER_FGET(_CHIP_JTAGID_ADDR,CHIP,JTAGID,##FIELD)
S
N#endif /* CHIP_DM642 || CHIP_6412  */
N
N/******************************************************************************\
N* _____________________
X
N* |                   |
N* |  P C F G L O C K  |
N* |___________________|
N*
N* PCFGLOCK - Peripheral Configuration Lock register (1)
N*
N* FIELDS (msb -> lsb)
N* (r) LOCKSTAT
N* (w) LOCK
N*
N* (1) Only for DM642
N*
N\******************************************************************************/
N
N#if (CHIP_DM642 || CHIP_DM641 || CHIP_DM640 || CHIP_6412 || CHIP_6410 || CHIP_6413 || CHIP_6418)
X#if (0 || 0 || 0 || 0 || 0 || 0 || 0)
S
S  #define   _CHIP_PCFGLOCK_ADDR                 0x01B3F018u
S  #define   _CHIP_PCFGLOCK_OFFSET               0
S
S  #define _CHIP_PCFGLOCK_LOCKSTAT_MASK          0x00000001u
S  #define _CHIP_PCFGLOCK_LOCKSTAT_SHIFT         0x00000000u
S  #define  CHIP_PCFGLOCK_LOCKSTAT_DEFAULT       0x00000001u
S  #define  CHIP_PCFGLOCK_LOCKSTAT_OF(x)         _VALUEOF(x)
S  #define  CHIP_PCFGLOCK_LOCKSTAT_UNLOCK        0x00000000u
S  #define  CHIP_PCFGLOCK_LOCKSTAT_LOCK          0x00000001u
S
S  #define _CHIP_PCFGLOCK_LOCK_MASK              0xFFFFFFFFu
S  #define _CHIP_PCFGLOCK_LOCK_SHIFT             0x00000000u
S  #define  CHIP_PCFGLOCK_LOCK_DEFAULT           0x00000000u
S  #define  CHIP_PCFGLOCK_LOCK_OF(x)             _VALUEOF(x)
S  #define  CHIP_PCFGLOCK_LOCK_UNLOCK            0x10C0010Cu
S  #define  CHIP_PCFGLOCK_LOCK_DISABLE           0x10C0010Cu
S
S  #define  CHIP_PCFGLOCK_OF(x)                  _VALUEOF(x)
S
S  #define _CHIP_PCFGLOCK_FGET(FIELD)\
S    _PER_FGET(_CHIP_PCFGLOCK_ADDR,CHIP,PCFGLOCK,##FIELD)
X  #define _CHIP_PCFGLOCK_FGET(FIELD)    _PER_FGET(_CHIP_PCFGLOCK_ADDR,CHIP,PCFGLOCK,##FIELD)
S
S  #define _CHIP_PCFGLOCK_FSET(FIELD,field)\
S    _PER_FSET(_CHIP_PCFGLOCK_ADDR,CHIP,PCFGLOCK,##FIELD,field)
X  #define _CHIP_PCFGLOCK_FSET(FIELD,field)    _PER_FSET(_CHIP_PCFGLOCK_ADDR,CHIP,PCFGLOCK,##FIELD,field)
S
S  #define _CHIP_PCFGLOCK_FSETS(FIELD,SYM)\
S    _PER_FSETS(_CHIP_PCFGLOCK_ADDR,CHIP,PCFGLOCK,##FIELD,##SYM)
X  #define _CHIP_PCFGLOCK_FSETS(FIELD,SYM)    _PER_FSETS(_CHIP_PCFGLOCK_ADDR,CHIP,PCFGLOCK,##FIELD,##SYM)
S
S
N#endif /* CHIP_DM642 || CHIP_DM641 || CHIP_DM640 || CHIP_6412 || CHIP_6410 || CHIP_6413 || CHIP_6418*/
N
N#ifdef __cplusplus
S}
N#endif
N
N/*----------------------------------------------------------------------------*/
N#endif /* _CSL_CHIPHAL_H_ */
N/******************************************************************************\
N* End of csl_chiphal.h
X
N\******************************************************************************/
N
L 20 "E:/TI_workspase/c6701_t/csl/csl_chip.h" 2
N#include <csl_emifhal.h>
L 1 "E:/TI_workspase/c6701_t/csl/csl_emifhal.h" 1
N/******************************************************************************\
N*           Copyright (C) 1999-2000 Texas Instruments Incorporated.
X
N*                           All Rights Reserved
N*------------------------------------------------------------------------------
N* FILENAME...... csl_emifhal.h
N* DATE CREATED.. 06/12/1999 
N* LAST MODIFIED. 06/17/2003  Added CHIP_6712C
N*                05/28/2003  Added CHIP_6711C
N*                10/03/2000
N*------------------------------------------------------------------------------
N* REGISTERS
N*
N* GBLCTL  - global control register
N* CECTL0  - CE space control register 0
N* CECTL1  - CE space control register 1
N* CECTL2  - CE space control register 2
N* CECTL3  - CE space control register 3
N* SDCTL   - SDRAM control regsiter
N* SDTIM   - SDRAM timing register
N* SDEXT   - SDRAM extension register (1)
N*
N* (1) - only supported on 6211,6711,6712,6713,6711C,6712C
N* 
N\******************************************************************************/
N#ifndef _CSL_EMIFHAL_H_
N#define _CSL_EMIFHAL_H_
N
N#include <csl_stdinc.h>
N#include <csl_chip.h>
L 1 "E:/TI_workspase/c6701_t/csl/csl_chip.h" 1
N/******************************************************************************\
N*           Copyright (C) 1999-2001 Texas Instruments Incorporated.
X
N*                           All Rights Reserved
N*------------------------------------------------------------------------------
N* FILENAME...... csl_chip.h
N* DATE CREATED.. 08/19/1999 
N* LAST MODIFIED. 08/02/2004 - Adding support for C6418
N*                06/17/2003   - Added support for 6712C
N*                06/09/2003   - Added support for 6711C
N*                12/03/2001   - CHIP_configArgs
N*                11/08/2001   - CHIP_getSiliconRevId()
N*                             - CHIP_config() / CHIP_getConfig  DM642
N\******************************************************************************/
N#ifndef _CSL_CHIP_H_
S#define _CSL_CHIP_H_
S
S#include <csl_stdinc.h>
S
S#include <csl_chiphal.h>
S#include <csl_emifhal.h>
S
S/******************************************************************************\
S* scope and inline control macros
X
S\******************************************************************************/
S#ifdef __cplusplus
S#define CSLAPI extern "C" far
S#else
S#define CSLAPI extern far
S#endif
S
S#undef  USEDEFS
S#undef  IDECL
S#undef  IDEF
S
S#ifdef  _CHIP_MOD_
S  #define IDECL CSLAPI
S  #define USEDEFS
S  #define IDEF
S#else
S  #ifdef  _INLINE
S    #define IDECL static inline
S    #define USEDEFS
S    #define IDEF  static inline
S  #else
S    #define IDECL CSLAPI
S  #endif
S#endif
S
S
S/******************************************************************************\
S* global macro declarations
X
S\******************************************************************************/
S#define CHIP_ENDIAN_BIG    0
S#define CHIP_ENDIAN_LITTLE 1
S
S#define CHIP_MAP_0         0
S#define CHIP_MAP_1         1
S
S/* Selected devices masks*/
S#if (CHIP_6713 || CHIP_DA610 || CHIP_6711C || CHIP_6712C)
S#define CHIP_EKSRC_SYSCLK3  0x00000000u
S#define CHIP_EKSRC_ECLKIN   0x00000010u
S#endif
S
S#if (CHIP_6713 || CHIP_DA610)
S#define CHIP_TOUT1          0x00000000u
S#define CHIP_AXR04_AXR111   0x00000008u
S
S#define CHIP_TOUT0          0x00000000u
S#define CHIP_AXR02_AXR113   0x00000004u
S
S#define CHIP_MCASP0         0x00000002u
S#define CHIP_MCBSP0         0x00000000u
S
S#define CHIP_I2C1           0x00000001u
S#define CHIP_MCBSP1         0x00000000u
S/* Full mask value */
S#define _CHIP_DEVCFG_MASK  0x0000001Fu
S#endif
S
S#if CHIP_DM642
S#define CHIP_VP2            0x00000040u
S#define CHIP_VP1            0x00000020u
S#define CHIP_VP0            0x00000010u
S#define CHIP_I2C            0x00000008u
S#define CHIP_MCBSP1         0x00000004u
S#define CHIP_MCBSP0         0x00000002u
S#define CHIP_MCASP0         0x00000001u
S
S#define _CHIP_PERCFG_MASK   0x0000007Fu
S#endif
S
S#if CHIP_DM641
S#define CHIP_VP1            0x00000020u
S#define CHIP_VP0            0x00000010u
S#define CHIP_I2C            0x00000008u
S#define CHIP_MCBSP1         0x00000004u
S#define CHIP_MCBSP0         0x00000002u
S#define CHIP_MCASP0         0x00000001u
S
S#define _CHIP_PERCFG_MASK   0x0000003Fu
S#endif
S
S#if CHIP_DM640
S#define CHIP_VP0            0x00000010u
S#define CHIP_I2C            0x00000008u
S#define CHIP_MCBSP1         0x00000004u
S#define CHIP_MCBSP0         0x00000002u
S#define CHIP_MCASP0         0x00000001u
S
S#define _CHIP_PERCFG_MASK   0x0000001Fu
S#endif
S
S#if CHIP_6412
S#define CHIP_I2C            0x00000008u
S#define CHIP_MCBSP1         0x00000004u
S#define CHIP_MCBSP0         0x00000002u
S#define _CHIP_PERCFG_MASK   0x0000000Eu
S#endif
S
S#if (CHIP_6410 || CHIP_6413 || CHIP_6418)
S#define CHIP_AFCMUX         0x00000600u
S#define CHIP_MCASP1         0x00000100u
S#define CHIP_I2C1           0x00000080u
S#define CHIP_I2C0           0x00000008u
S#define CHIP_MCBSP1         0x00000004u
S#define CHIP_MCBSP0         0x00000002u
S#define CHIP_MCASP0         0x00000001u
S
S#define _CHIP_PERCFG_MASK   0x0000078Fu
S#endif
S
S/******************************************************************************\
S* global typedef declarations
X
S\******************************************************************************/
S#if( CHIP_6711C || CHIP_6712C || CHIP_DA610 || CHIP_6713 )
Stypedef struct{
S   Uint32 devcfg;
S} CHIP_Config;
S#elif (CHIP_DM642 || CHIP_DM641 || CHIP_DM640  || CHIP_6412 || CHIP_6410 || CHIP_6413 || CHIP_6418)
Stypedef struct{
S   Uint32 percfg;
S} CHIP_Config; 
S#endif
S/******************************************************************************\
S* global variable declarations
X
S\******************************************************************************/
S
S
S/******************************************************************************\
S* global function declarations
X
S\******************************************************************************/
S
S
S/******************************************************************************\
S* inline function declarations
X
S\******************************************************************************/
SIDECL Uint32 CHIP_getCpuId();
SIDECL Uint32 CHIP_getRevId();
SIDECL Uint32 CHIP_getSiliconRevId();
SIDECL int    CHIP_getEndian();
SIDECL int    CHIP_getMapMode();
S
S#if (CHIP_DM642 || CHIP_DM641 || CHIP_DM640  || CHIP_6412 || CHIP_6410 || CHIP_6413 || CHIP_6418) 
SIDECL void   CHIP_config(CHIP_Config *config);
SIDECL void   CHIP_configArgs(Uint32 percfg);
SIDECL void   CHIP_getConfig(CHIP_Config *config); 
S#elif ( CHIP_6711C || CHIP_6712C || CHIP_DA610 || CHIP_6713 )
SIDECL void   CHIP_config(CHIP_Config *config);
SIDECL void   CHIP_configArgs(Uint32 devcfg);
SIDECL void   CHIP_getConfig(CHIP_Config *config); 
S#endif
S
S/******************************************************************************\
S* inline function definitions
X
S\******************************************************************************/
S#ifdef USEDEFS
S/*----------------------------------------------------------------------------*/
SIDEF Uint32 CHIP_getCpuId() {
S  return CHIP_FGET(CSR,CPUID);
S}
S/*----------------------------------------------------------------------------*/
SIDEF Uint32 CHIP_getRevId() {
S  return CHIP_FGET(CSR,REVID);
S}
S/*----------------------------------------------------------------------------*/
SIDEF Uint32 CHIP_getSiliconRevId() {
S  return (( 0x000F0000 & REG32(0x01B00200))>>16);
S}
S/*----------------------------------------------------------------------------*/
SIDEF int CHIP_getEndian() {
S  return CHIP_FGET(CSR,EN);
S}
S/*----------------------------------------------------------------------------*/
SIDEF int CHIP_getMapMode() {
S  int mapmode = 0;
S  #if (!C11_SUPPORT && !C64_SUPPORT)
S    mapmode = EMIF_FGET(GBLCTL,MAP);
S  #endif
S  return mapmode;
S}
S/*----------------------------------------------------------------------------*/
S#if (CHIP_6713 || CHIP_DM642 || CHIP_DM641 || CHIP_DM640 || CHIP_DA610 || CHIP_6412 || CHIP_6711C || CHIP_6712C || CHIP_6410 || CHIP_6413 || CHIP_6418)
SIDEF void   CHIP_config(CHIP_Config *config) {
S  Uint32 gie = CHIP_FGET(CSR,GIE);
S  
S#if( CHIP_6711C || CHIP_6712C || CHIP_DA610 || CHIP_6713 ) 
S    volatile Uint32 *base = (volatile Uint32 *)(_CHIP_DEVCFG_ADDR);
S    register int x0;
S    CHIP_FSET(CSR,GIE,0);
S    x0 = config->devcfg;
S    base[_CHIP_DEVCFG_OFFSET] = x0;
S    CHIP_FSET(CSR,GIE,gie);
S    
S#else 
S  volatile Uint32 *base = (volatile Uint32 *)(_CHIP_PERCFG_ADDR);
S  register int x0;
S  CHIP_FSET(CSR,GIE,0);
S  CHIP_FSETS(PCFGLOCK,LOCK,UNLOCK);
S  x0 = config->percfg;
S  base[_CHIP_PERCFG_OFFSET] = x0;
S  CHIP_FSET(CSR,GIE,gie);
S  
S#endif
S}      
S#endif
S/*----------------------------------------------------------------------------*/
S#if (CHIP_6713 || CHIP_DM642 || CHIP_DM641 || CHIP_DM640 || CHIP_DA610 || CHIP_6412 || CHIP_6711C || CHIP_6712C || CHIP_6410 || CHIP_6413 || CHIP_6418)
SIDEF void   CHIP_getConfig(CHIP_Config *config) {
S   Uint32 gie = CHIP_FGET(CSR,GIE);
S   
S#if( CHIP_6711C || CHIP_6712C || CHIP_DA610 || CHIP_6713 ) 
S   volatile Uint32 *base = (volatile Uint32 *)(_CHIP_DEVCFG_ADDR);
S   register int x0;
S
S   CHIP_FSET(CSR,GIE,0);
S
S   x0 = base[_CHIP_DEVCFG_OFFSET]; 
S   config->devcfg=x0;
S
S   CHIP_FSET(CSR,GIE,gie);
S   
S#else
S   volatile Uint32 *base = (volatile Uint32 *)(_CHIP_PERCFG_ADDR);
S   register int x0;
S
S   CHIP_FSET(CSR,GIE,0);
S
S   x0 = base[_CHIP_PERCFG_OFFSET]; 
S   config->percfg=x0;
S
S   CHIP_FSET(CSR,GIE,gie);
S   
S#endif
S}      
S#endif
S/*----------------------------------------------------------------------------*/
S   
S#if( CHIP_6711C || CHIP_6712C || CHIP_DA610 || CHIP_6713 )
S   IDEF void   CHIP_configArgs(Uint32 devcfg) {
S   Uint32 gie = CHIP_FGET(CSR,GIE);
S   volatile Uint32 *base = (volatile Uint32 *)(_CHIP_DEVCFG_ADDR);
S   CHIP_FSET(CSR,GIE,0);
S   base[_CHIP_DEVCFG_OFFSET]= devcfg; 
S   CHIP_FSET(CSR,GIE,gie);
S}   
S#elif (CHIP_DM642 || CHIP_DM641 || CHIP_DM640  || CHIP_6412 || CHIP_6410 || CHIP_6413 || CHIP_6418)
S   IDEF void   CHIP_configArgs(Uint32 percfg) {
S   Uint32 gie = CHIP_FGET(CSR,GIE);
S   volatile Uint32 *base = (volatile Uint32 *)(_CHIP_PERCFG_ADDR);
S
S   CHIP_FSET(CSR,GIE,0);
S
S#if(CHIP_DM642 || CHIP_6412)
S   CHIP_FSETS(PCFGLOCK,LOCK,UNLOCK);
S#endif
S
S   base[_CHIP_PERCFG_OFFSET]= percfg; 
S
S   CHIP_FSET(CSR,GIE,gie);
S}   
S#endif
S
S
S/*----------------------------------------------------------------------------*/
S#endif /* USEDEFS */
S
S
N#endif /* _CSL_CHIP_H_ */
N/******************************************************************************\
N* End of csl_chip.h
X
N\******************************************************************************/
N
L 30 "E:/TI_workspase/c6701_t/csl/csl_emifhal.h" 2
N
N#if (EMIF_SUPPORT)
X#if (( ( 1*0) | ( 1*0) | ( 1*0) | ( 1*0) | ( 1*0) | ( 1*0) | ( 1*1) | ( 1*0) | ( 1*0) | ( 1*0) | ( 1*0)| ( 0*0)| ( 0*0)| ( 0*0)| ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 1*0) | ( 1*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) ))
N/******************************************************************************\
N* MISC section
X
N\******************************************************************************/
N#define _EMIF_BASE_GLOBAL   0x01800000u
N
N
N/******************************************************************************\
N* module level register/field access macros
X
N\******************************************************************************/
N
N  /* ----------------- */
N  /* FIELD MAKE MACROS */
N  /* ----------------- */
N
N  #define EMIF_FMK(REG,FIELD,x)\
N    _PER_FMK(EMIF,##REG,##FIELD,x)
X  #define EMIF_FMK(REG,FIELD,x)    _PER_FMK(EMIF,##REG,##FIELD,x)
N
N  #define EMIF_FMKS(REG,FIELD,SYM)\
N    _PER_FMKS(EMIF,##REG,##FIELD,##SYM)
X  #define EMIF_FMKS(REG,FIELD,SYM)    _PER_FMKS(EMIF,##REG,##FIELD,##SYM)
N 
N 
N  /* -------------------------------- */
N  /* RAW REGISTER/FIELD ACCESS MACROS */
N  /* -------------------------------- */
N
N  #define EMIF_ADDR(REG)\
N    _EMIF_##REG##_ADDR
X  #define EMIF_ADDR(REG)    _EMIF_##REG##_ADDR
N
N  #define EMIF_RGET(REG)\
N    _PER_RGET(_EMIF_##REG##_ADDR,EMIF,##REG)
X  #define EMIF_RGET(REG)    _PER_RGET(_EMIF_##REG##_ADDR,EMIF,##REG)
N
N  #define EMIF_RSET(REG,x)\
N    _PER_RSET(_EMIF_##REG##_ADDR,EMIF,##REG,x)
X  #define EMIF_RSET(REG,x)    _PER_RSET(_EMIF_##REG##_ADDR,EMIF,##REG,x)
N
N  #define EMIF_FGET(REG,FIELD)\
N    _EMIF_##REG##_FGET(##FIELD)
X  #define EMIF_FGET(REG,FIELD)    _EMIF_##REG##_FGET(##FIELD)
N
N  #define EMIF_FSET(REG,FIELD,x)\
N    _EMIF_##REG##_FSET(##FIELD,##x)
X  #define EMIF_FSET(REG,FIELD,x)    _EMIF_##REG##_FSET(##FIELD,##x)
N
N  #define EMIF_FSETS(REG,FIELD,SYM)\
N    _EMIF_##REG##_FSETS(##FIELD,##SYM)
X  #define EMIF_FSETS(REG,FIELD,SYM)    _EMIF_##REG##_FSETS(##FIELD,##SYM)
N 
N 
N  /* ------------------------------------------ */
N  /* ADDRESS BASED REGISTER/FIELD ACCESS MACROS */
N  /* ------------------------------------------ */
N
N  #define EMIF_RGETA(addr,REG)\
N    _PER_RGET(addr,EMIF,##REG)
X  #define EMIF_RGETA(addr,REG)    _PER_RGET(addr,EMIF,##REG)
N
N  #define EMIF_RSETA(addr,REG,x)\
N    _PER_RSET(addr,EMIF,##REG,x)
X  #define EMIF_RSETA(addr,REG,x)    _PER_RSET(addr,EMIF,##REG,x)
N
N  #define EMIF_FGETA(addr,REG,FIELD)\
N    _PER_FGET(addr,EMIF,##REG,##FIELD)
X  #define EMIF_FGETA(addr,REG,FIELD)    _PER_FGET(addr,EMIF,##REG,##FIELD)
N
N  #define EMIF_FSETA(addr,REG,FIELD,x)\
N    _PER_FSET(addr,EMIF,##REG,##FIELD,x)
X  #define EMIF_FSETA(addr,REG,FIELD,x)    _PER_FSET(addr,EMIF,##REG,##FIELD,x)
N
N  #define EMIF_FSETSA(addr,REG,FIELD,SYM)\
N    _PER_FSETS(addr,EMIF,##REG,##FIELD,##SYM)
X  #define EMIF_FSETSA(addr,REG,FIELD,SYM)    _PER_FSETS(addr,EMIF,##REG,##FIELD,##SYM)
N
N
N/******************************************************************************\
N* _____________________
X
N* |                   |
N* |  G B L C T L      |
N* |___________________|
N*
N* GBLCTL  - global control register
N*
N* FIELDS (msb -> lsb)
N* (r)  BUSREQ  (1)
N* (r)  ARDY
N* (r)  HOLD
N* (r)  HOLDA
N* (rw) NOHOLD
N* (rw) SDCEN   (2)
N* (rw) SSCEN   (2)
N* (rw) EKEN    (4)
N* (rw) CLK1EN
N* (rw) CLK2EN  (3)
N* (rw) SSCRT   (2)(3)
N* (rw) RBTR8   (2)
N* (r)  MAP     (2)
N*
N* (1) - Field only exists for C11_SUPPORT
N* (2) - Field does not exist for C11_SUPPORT
N* (3) - Field does not exist for 6202/6203/6204/6205 
N* (4) - Field only exixts for C6713, DA610, 6711C, 6712C
N*
N\******************************************************************************/
N  #define _EMIF_GBLCTL_OFFSET          0
N
N  #define _EMIF_GBLCTL_ADDR            0x01800000u
N
N#if (C11_SUPPORT)
X#if (( ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 1*0) | ( 0*1) | ( 1*0) | ( 1*0) | ( 1*0) | ( 1*0)| ( 0*0)| ( 0*0)| ( 0*0)| ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 1*0) | ( 1*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) ))
S  #define _EMIF_GBLCTL_BUSREQ_MASK     0x00000800u
S  #define _EMIF_GBLCTL_BUSREQ_SHIFT    0x0000000Bu
S  #define  EMIF_GBLCTL_BUSREQ_DEFAULT  0x00000000u
S  #define  EMIF_GBLCTL_BUSREQ_OF(x)    _VALUEOF(x)
S  #define  EMIF_GBLCTL_BUSREQ_LOW      0x00000000u
S  #define  EMIF_GBLCTL_BUSREQ_HIGH     0x00000001u
N#endif
N
N  #define _EMIF_GBLCTL_ARDY_MASK       0x00000400u
N  #define _EMIF_GBLCTL_ARDY_SHIFT      0x0000000Au
N  #define  EMIF_GBLCTL_ARDY_DEFAULT    0x00000000u
N  #define  EMIF_GBLCTL_ARDY_OF(x)      _VALUEOF(x)
N  #define  EMIF_GBLCTL_ARDY_LOW        0x00000000u
N  #define  EMIF_GBLCTL_ARDY_HIGH       0x00000001u
N
N  #define _EMIF_GBLCTL_HOLD_MASK       0x00000200u
N  #define _EMIF_GBLCTL_HOLD_SHIFT      0x00000009u
N  #define  EMIF_GBLCTL_HOLD_DEFAULT    0x00000000u
N  #define  EMIF_GBLCTL_HOLD_OF(x)      _VALUEOF(x)
N  #define  EMIF_GBLCTL_HOLD_LOW        0x00000000u
N  #define  EMIF_GBLCTL_HOLD_HIGH       0x00000001u
N
N  #define _EMIF_GBLCTL_HOLDA_MASK      0x00000100u
N  #define _EMIF_GBLCTL_HOLDA_SHIFT     0x00000008u
N  #define  EMIF_GBLCTL_HOLDA_DEFAULT   0x00000000u
N  #define  EMIF_GBLCTL_HOLDA_OF(x)     _VALUEOF(x)
N  #define  EMIF_GBLCTL_HOLDA_LOW       0x00000000u
N  #define  EMIF_GBLCTL_HOLDA_HIGH      0x00000001u
N
N  #define _EMIF_GBLCTL_NOHOLD_MASK     0x00000080u
N  #define _EMIF_GBLCTL_NOHOLD_SHIFT    0x00000007u
N  #define  EMIF_GBLCTL_NOHOLD_DEFAULT  0x00000000u
N  #define  EMIF_GBLCTL_NOHOLD_OF(x)    _VALUEOF(x)
N  #define  EMIF_GBLCTL_NOHOLD_DISABLE  0x00000000u
N  #define  EMIF_GBLCTL_NOHOLD_ENABLE   0x00000001u
N
N#if (CHIP_6201 | CHIP_6202 | CHIP_6203 | CHIP_6204 | CHIP_6205 | CHIP_6701)
X#if (0 | 0 | 0 | 0 | 0 | 1)
N  #define _EMIF_GBLCTL_SDCEN_MASK      0x00000040u
N  #define _EMIF_GBLCTL_SDCEN_SHIFT     0x00000006u
N  #define  EMIF_GBLCTL_SDCEN_DEFAULT   0x00000001u
N  #define  EMIF_GBLCTL_SDCEN_OF(x)     _VALUEOF(x)
N  #define  EMIF_GBLCTL_SDCEN_DISABLE   0x00000000u
N  #define  EMIF_GBLCTL_SDCEN_ENABLE    0x00000001u
N#endif
N
N#if (CHIP_6201 | CHIP_6202 | CHIP_6203 | CHIP_6204 | CHIP_6205 | CHIP_6701)
X#if (0 | 0 | 0 | 0 | 0 | 1)
N  #define _EMIF_GBLCTL_SSCEN_MASK      0x00000020u
N  #define _EMIF_GBLCTL_SSCEN_SHIFT     0x00000005u
N  #define  EMIF_GBLCTL_SSCEN_DEFAULT   0x00000001u
N  #define  EMIF_GBLCTL_SSCEN_OF(x)     _VALUEOF(x)
N  #define  EMIF_GBLCTL_SSCEN_DISABLE   0x00000000u
N  #define  EMIF_GBLCTL_SSCEN_ENABLE    0x00000001u
N#endif
N
N#if (CHIP_6713 || CHIP_DA610 || CHIP_6711C || CHIP_6712C)
X#if (0 || 0 || 0 || 0)
S  #define _EMIF_GBLCTL_EKEN_MASK       0x00000020u
S  #define _EMIF_GBLCTL_EKEN_SHIFT      0x00000005u
S  #define  EMIF_GBLCTL_EKEN_DEFAULT    0x00000001u
S  #define  EMIF_GBLCTL_EKEN_OF(x)      _VALUEOF(x)
S  #define  EMIF_GBLCTL_EKEN_DISABLE    0x00000000u
S  #define  EMIF_GBLCTL_EKEN_ENABLE     0x00000001u
N#endif
N
N  #define _EMIF_GBLCTL_CLK1EN_MASK     0x00000010u
N  #define _EMIF_GBLCTL_CLK1EN_SHIFT    0x00000004u
N
N#if (CHIP_6713 || CHIP_DA610)
X#if (0 || 0)
S  #define  EMIF_GBLCTL_CLK1EN_DEFAULT  0x00000000u
N#else
N  #define  EMIF_GBLCTL_CLK1EN_DEFAULT  0x00000001u
N#endif
N
N  #define  EMIF_GBLCTL_CLK1EN_OF(x)    _VALUEOF(x)
N  #define  EMIF_GBLCTL_CLK1EN_DISABLE  0x00000000u
N  #define  EMIF_GBLCTL_CLK1EN_ENABLE   0x00000001u
N
N#if (!(CHIP_6202|CHIP_6203|CHIP_6204|CHIP_6205))
X#if (!(0|0|0|0))
N  #define _EMIF_GBLCTL_CLK2EN_MASK     0x00000008u
N  #define _EMIF_GBLCTL_CLK2EN_SHIFT    0x00000003u
N  #define  EMIF_GBLCTL_CLK2EN_DEFAULT  0x00000001u
N  #define  EMIF_GBLCTL_CLK2EN_OF(x)    _VALUEOF(x)
N  #define  EMIF_GBLCTL_CLK2EN_DISABLE  0x00000000u
N  #define  EMIF_GBLCTL_CLK2EN_ENABLE   0x00000001u
N#endif
N
N#if (CHIP_6201|CHIP_6701)
X#if (0|1)
N  #define _EMIF_GBLCTL_SSCRT_MASK      0x00000004u
N  #define _EMIF_GBLCTL_SSCRT_SHIFT     0x00000002u
N  #define  EMIF_GBLCTL_SSCRT_DEFAULT   0x00000000u
N  #define  EMIF_GBLCTL_SSCRT_OF(x)     _VALUEOF(x)
N  #define  EMIF_GBLCTL_SSCRT_CPUOVR2   0x00000000u
N  #define  EMIF_GBLCTL_SSCRT_CPU       0x00000001u
N#endif
N
N#if (!C11_SUPPORT)
X#if (!( ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 1*0) | ( 0*1) | ( 1*0) | ( 1*0) | ( 1*0) | ( 1*0)| ( 0*0)| ( 0*0)| ( 0*0)| ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 1*0) | ( 1*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) ))
N  #define _EMIF_GBLCTL_RBTR8_MASK      0x00000002u
N  #define _EMIF_GBLCTL_RBTR8_SHIFT     0x00000001u
N  #define  EMIF_GBLCTL_RBTR8_DEFAULT   0x00000000u
N  #define  EMIF_GBLCTL_RBTR8_OF(x)     _VALUEOF(x)
N  #define  EMIF_GBLCTL_RBTR8_HPRI      0x00000000u
N  #define  EMIF_GBLCTL_RBTR8_8ACC      0x00000001u
N#endif
N
N#if (!C11_SUPPORT)
X#if (!( ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 1*0) | ( 0*1) | ( 1*0) | ( 1*0) | ( 1*0) | ( 1*0)| ( 0*0)| ( 0*0)| ( 0*0)| ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 1*0) | ( 1*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) ))
N  #define _EMIF_GBLCTL_MAP_MASK        0x00000001u
N  #define _EMIF_GBLCTL_MAP_SHIFT       0x00000000u
N  #define  EMIF_GBLCTL_MAP_MAP1        0x00000000u
N  #define  EMIF_GBLCTL_MAP_MAP0        0x00000001u
N  #define  EMIF_GBLCTL_MAP_DEFAULT     0x00000000u
N  #define  EMIF_GBLCTL_MAP_OF(x)       _VALUEOF(x)
N#endif
N
N  #define  EMIF_GBLCTL_OF(x)           _VALUEOF(x)
N
N#if (CHIP_6201|CHIP_6701)
X#if (0|1)
N  #define EMIF_GBLCTL_DEFAULT (Uint32)( \
N    0x00003000\
N    |_PER_FDEFAULT(EMIF,GBLCTL,ARDY)\
N    |_PER_FDEFAULT(EMIF,GBLCTL,HOLD)\
N    |_PER_FDEFAULT(EMIF,GBLCTL,HOLDA)\
N    |_PER_FDEFAULT(EMIF,GBLCTL,NOHOLD)\
N    |_PER_FDEFAULT(EMIF,GBLCTL,SDCEN)\
N    |_PER_FDEFAULT(EMIF,GBLCTL,SSCEN)\
N    |_PER_FDEFAULT(EMIF,GBLCTL,CLK1EN)\
N    |_PER_FDEFAULT(EMIF,GBLCTL,CLK2EN)\
N    |_PER_FDEFAULT(EMIF,GBLCTL,SSCRT)\
N    |_PER_FDEFAULT(EMIF,GBLCTL,RBTR8)\
N    |_PER_FDEFAULT(EMIF,GBLCTL,MAP)\
N  )
X  #define EMIF_GBLCTL_DEFAULT (Uint32)(     0x00003000    |_PER_FDEFAULT(EMIF,GBLCTL,ARDY)    |_PER_FDEFAULT(EMIF,GBLCTL,HOLD)    |_PER_FDEFAULT(EMIF,GBLCTL,HOLDA)    |_PER_FDEFAULT(EMIF,GBLCTL,NOHOLD)    |_PER_FDEFAULT(EMIF,GBLCTL,SDCEN)    |_PER_FDEFAULT(EMIF,GBLCTL,SSCEN)    |_PER_FDEFAULT(EMIF,GBLCTL,CLK1EN)    |_PER_FDEFAULT(EMIF,GBLCTL,CLK2EN)    |_PER_FDEFAULT(EMIF,GBLCTL,SSCRT)    |_PER_FDEFAULT(EMIF,GBLCTL,RBTR8)    |_PER_FDEFAULT(EMIF,GBLCTL,MAP)  )
N
N  #define EMIF_GBLCTL_RMK(nohold,sdcen,sscen,clk1en,clk2en,sscrt,rbtr8) \
N    (Uint32)( \
N     _PER_FMK(EMIF,GBLCTL,NOHOLD,nohold)\
N    |_PER_FMK(EMIF,GBLCTL,SDCEN,sdcen)\
N    |_PER_FMK(EMIF,GBLCTL,SSCEN,sscen)\
N    |_PER_FMK(EMIF,GBLCTL,CLK1EN,clk1en)\
N    |_PER_FMK(EMIF,GBLCTL,CLK2EN,clk2en)\
N    |_PER_FMK(EMIF,GBLCTL,SSCRT,sscrt)\
N    |_PER_FMK(EMIF,GBLCTL,RBTR8,rbtr8)\
N  )
X  #define EMIF_GBLCTL_RMK(nohold,sdcen,sscen,clk1en,clk2en,sscrt,rbtr8)     (Uint32)(      _PER_FMK(EMIF,GBLCTL,NOHOLD,nohold)    |_PER_FMK(EMIF,GBLCTL,SDCEN,sdcen)    |_PER_FMK(EMIF,GBLCTL,SSCEN,sscen)    |_PER_FMK(EMIF,GBLCTL,CLK1EN,clk1en)    |_PER_FMK(EMIF,GBLCTL,CLK2EN,clk2en)    |_PER_FMK(EMIF,GBLCTL,SSCRT,sscrt)    |_PER_FMK(EMIF,GBLCTL,RBTR8,rbtr8)  )
N#endif
N
N#if (CHIP_6211|CHIP_6711)
X#if (0|0)
S  #define EMIF_GBLCTL_DEFAULT (Uint32)( \
S    0x00003000\
S    |_PER_FDEFAULT(EMIF,GBLCTL,BUSREQ)\
S    |_PER_FDEFAULT(EMIF,GBLCTL,ARDY)\
S    |_PER_FDEFAULT(EMIF,GBLCTL,HOLD)\
S    |_PER_FDEFAULT(EMIF,GBLCTL,HOLDA)\
S    |_PER_FDEFAULT(EMIF,GBLCTL,NOHOLD)\
S    |_PER_FDEFAULT(EMIF,GBLCTL,CLK1EN)\
S    |_PER_FDEFAULT(EMIF,GBLCTL,CLK2EN)\
S  )
X  #define EMIF_GBLCTL_DEFAULT (Uint32)(     0x00003000    |_PER_FDEFAULT(EMIF,GBLCTL,BUSREQ)    |_PER_FDEFAULT(EMIF,GBLCTL,ARDY)    |_PER_FDEFAULT(EMIF,GBLCTL,HOLD)    |_PER_FDEFAULT(EMIF,GBLCTL,HOLDA)    |_PER_FDEFAULT(EMIF,GBLCTL,NOHOLD)    |_PER_FDEFAULT(EMIF,GBLCTL,CLK1EN)    |_PER_FDEFAULT(EMIF,GBLCTL,CLK2EN)  )
S
S  #define EMIF_GBLCTL_RMK(nohold,clk1en,clk2en) (Uint32)( \
S     _PER_FMK(EMIF,GBLCTL,NOHOLD,nohold)\
S    |_PER_FMK(EMIF,GBLCTL,CLK1EN,clk1en)\
S    |_PER_FMK(EMIF,GBLCTL,CLK2EN,clk2en)\
S  )
X  #define EMIF_GBLCTL_RMK(nohold,clk1en,clk2en) (Uint32)(      _PER_FMK(EMIF,GBLCTL,NOHOLD,nohold)    |_PER_FMK(EMIF,GBLCTL,CLK1EN,clk1en)    |_PER_FMK(EMIF,GBLCTL,CLK2EN,clk2en)  )
N#endif
N
N#if (CHIP_6202|CHIP_6203|CHIP_6204|CHIP_6205)
X#if (0|0|0|0)
S  #define EMIF_GBLCTL_DEFAULT (Uint32)( \
S    0x00003008\
S    |_PER_FDEFAULT(EMIF,GBLCTL,ARDY)\
S    |_PER_FDEFAULT(EMIF,GBLCTL,HOLD)\
S    |_PER_FDEFAULT(EMIF,GBLCTL,HOLDA)\
S    |_PER_FDEFAULT(EMIF,GBLCTL,NOHOLD)\
S    |_PER_FDEFAULT(EMIF,GBLCTL,SDCEN)\
S    |_PER_FDEFAULT(EMIF,GBLCTL,SSCEN)\
S    |_PER_FDEFAULT(EMIF,GBLCTL,CLK1EN)\
S    |_PER_FDEFAULT(EMIF,GBLCTL,RBTR8)\
S    |_PER_FDEFAULT(EMIF,GBLCTL,MAP)\
S  )
X  #define EMIF_GBLCTL_DEFAULT (Uint32)(     0x00003008    |_PER_FDEFAULT(EMIF,GBLCTL,ARDY)    |_PER_FDEFAULT(EMIF,GBLCTL,HOLD)    |_PER_FDEFAULT(EMIF,GBLCTL,HOLDA)    |_PER_FDEFAULT(EMIF,GBLCTL,NOHOLD)    |_PER_FDEFAULT(EMIF,GBLCTL,SDCEN)    |_PER_FDEFAULT(EMIF,GBLCTL,SSCEN)    |_PER_FDEFAULT(EMIF,GBLCTL,CLK1EN)    |_PER_FDEFAULT(EMIF,GBLCTL,RBTR8)    |_PER_FDEFAULT(EMIF,GBLCTL,MAP)  )
S
S  #define EMIF_GBLCTL_RMK(nohold,sdcen,sscen,clk1en,rbtr8) (Uint32)( \
S     _PER_FMK(EMIF,GBLCTL,NOHOLD,nohold)\
S    |_PER_FMK(EMIF,GBLCTL,SDCEN,sdcen)\
S    |_PER_FMK(EMIF,GBLCTL,SSCEN,sscen)\
S    |_PER_FMK(EMIF,GBLCTL,CLK1EN,clk1en)\
S    |_PER_FMK(EMIF,GBLCTL,RBTR8,rbtr8)\
S  )
X  #define EMIF_GBLCTL_RMK(nohold,sdcen,sscen,clk1en,rbtr8) (Uint32)(      _PER_FMK(EMIF,GBLCTL,NOHOLD,nohold)    |_PER_FMK(EMIF,GBLCTL,SDCEN,sdcen)    |_PER_FMK(EMIF,GBLCTL,SSCEN,sscen)    |_PER_FMK(EMIF,GBLCTL,CLK1EN,clk1en)    |_PER_FMK(EMIF,GBLCTL,RBTR8,rbtr8)  )
N#endif
N
N#if (CHIP_6713 || CHIP_DA610 || CHIP_6711C || CHIP_6712C)
X#if (0 || 0 || 0 || 0)
S  #define EMIF_GBLCTL_DEFAULT (Uint32)( \
S    0x00003000\
S    |_PER_FDEFAULT(EMIF,GBLCTL,BUSREQ)\
S    |_PER_FDEFAULT(EMIF,GBLCTL,ARDY)\
S    |_PER_FDEFAULT(EMIF,GBLCTL,HOLD)\
S    |_PER_FDEFAULT(EMIF,GBLCTL,HOLDA)\
S    |_PER_FDEFAULT(EMIF,GBLCTL,NOHOLD)\
S    |_PER_FDEFAULT(EMIF,GBLCTL,EKEN)\
S    |_PER_FDEFAULT(EMIF,GBLCTL,CLK1EN)\
S    |_PER_FDEFAULT(EMIF,GBLCTL,CLK2EN)\
S  )
X  #define EMIF_GBLCTL_DEFAULT (Uint32)(     0x00003000    |_PER_FDEFAULT(EMIF,GBLCTL,BUSREQ)    |_PER_FDEFAULT(EMIF,GBLCTL,ARDY)    |_PER_FDEFAULT(EMIF,GBLCTL,HOLD)    |_PER_FDEFAULT(EMIF,GBLCTL,HOLDA)    |_PER_FDEFAULT(EMIF,GBLCTL,NOHOLD)    |_PER_FDEFAULT(EMIF,GBLCTL,EKEN)    |_PER_FDEFAULT(EMIF,GBLCTL,CLK1EN)    |_PER_FDEFAULT(EMIF,GBLCTL,CLK2EN)  )
S
S  #define EMIF_GBLCTL_RMK(nohold,eken,clk1en,clk2en) (Uint32)( \
S     _PER_FMK(EMIF,GBLCTL,NOHOLD,nohold)\
S    |_PER_FMK(EMIF,GBLCTL,EKEN,eken)\
S    |_PER_FMK(EMIF,GBLCTL,CLK1EN,clk1en)\
S    |_PER_FMK(EMIF,GBLCTL,CLK2EN,clk2en)\
S  )
X  #define EMIF_GBLCTL_RMK(nohold,eken,clk1en,clk2en) (Uint32)(      _PER_FMK(EMIF,GBLCTL,NOHOLD,nohold)    |_PER_FMK(EMIF,GBLCTL,EKEN,eken)    |_PER_FMK(EMIF,GBLCTL,CLK1EN,clk1en)    |_PER_FMK(EMIF,GBLCTL,CLK2EN,clk2en)  )
N#endif
N
N  #define _EMIF_GBLCTL_FGET(FIELD)\
N    _PER_FGET(_EMIF_GBLCTL_ADDR,EMIF,GBLCTL,##FIELD)
X  #define _EMIF_GBLCTL_FGET(FIELD)    _PER_FGET(_EMIF_GBLCTL_ADDR,EMIF,GBLCTL,##FIELD)
N
N  #define _EMIF_GBLCTL_FSET(FIELD,field)\
N    _PER_FSET(_EMIF_GBLCTL_ADDR,EMIF,GBLCTL,##FIELD,field)
X  #define _EMIF_GBLCTL_FSET(FIELD,field)    _PER_FSET(_EMIF_GBLCTL_ADDR,EMIF,GBLCTL,##FIELD,field)
N
N  #define _EMIF_GBLCTL_FSETS(FIELD,SYM)\
N    _PER_FSETS(_EMIF_GBLCTL_ADDR,EMIF,GBLCTL,##FIELD,##SYM)
X  #define _EMIF_GBLCTL_FSETS(FIELD,SYM)    _PER_FSETS(_EMIF_GBLCTL_ADDR,EMIF,GBLCTL,##FIELD,##SYM)
N
N
N/******************************************************************************\
N* _____________________
X
N* |                   |
N* |  C E C T L        |
N* |___________________|
N*
N* CECTL0 - CE space control register 0
N* CECTL1 - CE space control register 1
N* CECTL2 - CE space control register 2
N* CECTL3 - CE space control register 3
N*
N* FIELDS (msb -> lsb)
N* (rw) WRSETUP
N* (rw) WRSTRB
N* (rw) WRHLD
N* (rw) RDSETUP
N* (rw) TA       (1) 
N* (rw) RDSTRB
N* (rw) MTYPE
N* (rw) WRHLDMSB 
N* (rw) RDHLD
N*
N* (1) - Field only exists for C11_SUPPORT
N* 
N*
N\******************************************************************************/
N  #define _EMIF_CECTL0_OFFSET          2
N  #define _EMIF_CECTL1_OFFSET          1
N  #define _EMIF_CECTL2_OFFSET          4
N  #define _EMIF_CECTL3_OFFSET          5
N
N  #define _EMIF_CECTL0_ADDR            0x01800008u
N  #define _EMIF_CECTL1_ADDR            0x01800004u
N  #define _EMIF_CECTL2_ADDR            0x01800010u
N  #define _EMIF_CECTL3_ADDR            0x01800014u
N
N  #define _EMIF_CECTL_WRSETUP_MASK     0xF0000000u
N  #define _EMIF_CECTL_WRSETUP_SHIFT    0x0000001Cu
N  #define  EMIF_CECTL_WRSETUP_DEFAULT  0x0000000Fu
N  #define  EMIF_CECTL_WRSETUP_OF(x)    _VALUEOF(x)
N
N  #define _EMIF_CECTL_WRSTRB_MASK      0x0FC00000u
N  #define _EMIF_CECTL_WRSTRB_SHIFT     0x00000016u
N  #define  EMIF_CECTL_WRSTRB_DEFAULT   0x0000003Fu
N  #define  EMIF_CECTL_WRSTRB_OF(x)     _VALUEOF(x)
N
N  #define _EMIF_CECTL_WRHLD_MASK       0x00300000u
N  #define _EMIF_CECTL_WRHLD_SHIFT      0x00000014u
N  #define  EMIF_CECTL_WRHLD_DEFAULT    0x00000003u
N  #define  EMIF_CECTL_WRHLD_OF(x)      _VALUEOF(x)
N  
N  #define _EMIF_CECTL_RDSETUP_MASK     0x000F0000u
N  #define _EMIF_CECTL_RDSETUP_SHIFT    0x00000010u
N  #define  EMIF_CECTL_RDSETUP_DEFAULT  0x0000000Fu
N  #define  EMIF_CECTL_RDSETUP_OF(x)    _VALUEOF(x)
N
N#if (C11_SUPPORT)
X#if (( ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 1*0) | ( 0*1) | ( 1*0) | ( 1*0) | ( 1*0) | ( 1*0)| ( 0*0)| ( 0*0)| ( 0*0)| ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 1*0) | ( 1*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) ))
S  #define _EMIF_CECTL_TA_MASK          0x0000C000u
S  #define _EMIF_CECTL_TA_SHIFT         0x0000000Eu
S  #define  EMIF_CECTL_TA_DEFAULT       0x00000003u
S  #define  EMIF_CECTL_TA_OF(x)         _VALUEOF(x)
N#endif
N
N  #define _EMIF_CECTL_RDSTRB_MASK      0x00003F00u
N  #define _EMIF_CECTL_RDSTRB_SHIFT     0x00000008u
N  #define  EMIF_CECTL_RDSTRB_DEFAULT   0x0000003Fu
N  #define  EMIF_CECTL_RDSTRB_OF(x)     _VALUEOF(x)
N  
N#if (C11_SUPPORT)
X#if (( ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 1*0) | ( 0*1) | ( 1*0) | ( 1*0) | ( 1*0) | ( 1*0)| ( 0*0)| ( 0*0)| ( 0*0)| ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 1*0) | ( 1*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) ))
S  #define _EMIF_CECTL_MTYPE_MASK       0x000000F0u
S  #define _EMIF_CECTL_MTYPE_SHIFT      0x00000004u
S  #define  EMIF_CECTL_MTYPE_DEFAULT    0x00000002u
S  #define  EMIF_CECTL_MTYPE_OF(x)      _VALUEOF(x)
S  #if (CHIP_6712 || CHIP_6712C)  /* 16-bit EMIF */ 
S  #define  EMIFB_CECTL_MTYPE_ASYNC8     0x00000000u 
S  #define  EMIFB_CECTL_MTYPE_ASYNC16    0x00000001u 
S  #define  EMIFB_CECTL_MTYPE_SDRAM8     0x00000008u 
S  #define  EMIFB_CECTL_MTYPE_SDRAM16    0x00000009u 
S  #define  EMIFB_CECTL_MTYPE_SYNC8      0x0000000Au 
S  #define  EMIFB_CECTL_MTYPE_SYNC16     0x0000000Bu 
S  #else /* CHIP_6211/C6711/6711C 32-bit EMIF */
S  #define  EMIF_CECTL_MTYPE_ASYNC8     0x00000000u
S  #define  EMIF_CECTL_MTYPE_ASYNC16    0x00000001u
S  #define  EMIF_CECTL_MTYPE_ASYNC32    0x00000002u
S  #define  EMIF_CECTL_MTYPE_SDRAM32    0x00000003u
S  #define  EMIF_CECTL_MTYPE_SBSRAM32   0x00000004u
S  #define  EMIF_CECTL_MTYPE_SDRAM8     0x00000008u
S  #define  EMIF_CECTL_MTYPE_SDRAM16    0x00000009u
S  #define  EMIF_CECTL_MTYPE_SBSRAM8    0x0000000Au
S  #define  EMIF_CECTL_MTYPE_SBSRAM16   0x0000000Bu
S  #endif
S 
N#else
N  #define _EMIF_CECTL_MTYPE_MASK       0x00000070u
N  #define _EMIF_CECTL_MTYPE_SHIFT      0x00000004u
N  #define  EMIF_CECTL_MTYPE_DEFAULT    0x00000002u
N  #define  EMIF_CECTL_MTYPE_OF(x)      _VALUEOF(x)
N  #define  EMIF_CECTL_MTYPE_ASYNC8     0x00000000u
N  #define  EMIF_CECTL_MTYPE_ASYNC16    0x00000001u
N  #define  EMIF_CECTL_MTYPE_ASYNC32    0x00000002u
N  #define  EMIF_CECTL_MTYPE_SDRAM32    0x00000003u
N  #define  EMIF_CECTL_MTYPE_SBSRAM32   0x00000004u
N#endif
N
N
N#if (C11_SUPPORT )
X#if (( ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 1*0) | ( 0*1) | ( 1*0) | ( 1*0) | ( 1*0) | ( 1*0)| ( 0*0)| ( 0*0)| ( 0*0)| ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 1*0) | ( 1*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) ) )
S  #define _EMIF_CECTL_RDHLD_MASK       0x00000007u
S  #define _EMIF_CECTL_RDHLD_SHIFT      0x00000000u
S  #define  EMIF_CECTL_RDHLD_DEFAULT    0x00000003u
S  #define  EMIF_CECTL_RDHLD_OF(x)      _VALUEOF(x)
N#else
N  #define _EMIF_CECTL_RDHLD_MASK       0x00000003u
N  #define _EMIF_CECTL_RDHLD_SHIFT      0x00000000u
N  #define  EMIF_CECTL_RDHLD_DEFAULT    0x00000003u
N  #define  EMIF_CECTL_RDHLD_OF(x)      _VALUEOF(x)
N#endif
N
N  #define  EMIF_CECTL_OF(x)            _VALUEOF(x)
N
N#if (C11_SUPPORT)
X#if (( ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 1*0) | ( 0*1) | ( 1*0) | ( 1*0) | ( 1*0) | ( 1*0)| ( 0*0)| ( 0*0)| ( 0*0)| ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 1*0) | ( 1*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) ))
S  #define EMIF_CECTL_DEFAULT (Uint32)( \
S     _PER_FDEFAULT(EMIF,CECTL,WRSETUP)\
S    |_PER_FDEFAULT(EMIF,CECTL,WRSTRB)\
S    |_PER_FDEFAULT(EMIF,CECTL,WRHLD)\
S    |_PER_FDEFAULT(EMIF,CECTL,RDSETUP)\
S    |_PER_FDEFAULT(EMIF,CECTL,TA)\
S    |_PER_FDEFAULT(EMIF,CECTL,RDSTRB)\
S    |_PER_FDEFAULT(EMIF,CECTL,MTYPE)\
S    |_PER_FDEFAULT(EMIF,CECTL,RDHLD)\
S  )
X  #define EMIF_CECTL_DEFAULT (Uint32)(      _PER_FDEFAULT(EMIF,CECTL,WRSETUP)    |_PER_FDEFAULT(EMIF,CECTL,WRSTRB)    |_PER_FDEFAULT(EMIF,CECTL,WRHLD)    |_PER_FDEFAULT(EMIF,CECTL,RDSETUP)    |_PER_FDEFAULT(EMIF,CECTL,TA)    |_PER_FDEFAULT(EMIF,CECTL,RDSTRB)    |_PER_FDEFAULT(EMIF,CECTL,MTYPE)    |_PER_FDEFAULT(EMIF,CECTL,RDHLD)  )
S
S  #define EMIF_CECTL_RMK(wrsetup,wrstrb,wrhld,rdsetup,ta,rdstrb,mtype,\
S    rdhld) (Uint32)( \
S     _PER_FMK(EMIF,CECTL,WRSETUP,wrsetup)\
S    |_PER_FMK(EMIF,CECTL,WRSTRB,wrstrb)\
S    |_PER_FMK(EMIF,CECTL,WRHLD,wrhld)\
S    |_PER_FMK(EMIF,CECTL,RDSETUP,rdsetup)\
S    |_PER_FMK(EMIF,CECTL,TA,ta)\
S    |_PER_FMK(EMIF,CECTL,RDSTRB,rdstrb)\
S    |_PER_FMK(EMIF,CECTL,MTYPE,mtype)\
S    |_PER_FMK(EMIF,CECTL,RDHLD,rdhld)\
S  )
X  #define EMIF_CECTL_RMK(wrsetup,wrstrb,wrhld,rdsetup,ta,rdstrb,mtype,    rdhld) (Uint32)(      _PER_FMK(EMIF,CECTL,WRSETUP,wrsetup)    |_PER_FMK(EMIF,CECTL,WRSTRB,wrstrb)    |_PER_FMK(EMIF,CECTL,WRHLD,wrhld)    |_PER_FMK(EMIF,CECTL,RDSETUP,rdsetup)    |_PER_FMK(EMIF,CECTL,TA,ta)    |_PER_FMK(EMIF,CECTL,RDSTRB,rdstrb)    |_PER_FMK(EMIF,CECTL,MTYPE,mtype)    |_PER_FMK(EMIF,CECTL,RDHLD,rdhld)  )
N#endif
N
N
N
N#if (!C11_SUPPORT)
X#if (!( ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 1*0) | ( 0*1) | ( 1*0) | ( 1*0) | ( 1*0) | ( 1*0)| ( 0*0)| ( 0*0)| ( 0*0)| ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 1*0) | ( 1*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) ))
N  #define EMIF_CECTL_DEFAULT (Uint32)( \
N     _PER_FDEFAULT(EMIF,CECTL,WRSETUP)\
N    |_PER_FDEFAULT(EMIF,CECTL,WRSTRB)\
N    |_PER_FDEFAULT(EMIF,CECTL,WRHLD)\
N    |_PER_FDEFAULT(EMIF,CECTL,RDSETUP)\
N    |_PER_FDEFAULT(EMIF,CECTL,RDSTRB)\
N    |_PER_FDEFAULT(EMIF,CECTL,MTYPE)\
N    |_PER_FDEFAULT(EMIF,CECTL,RDHLD)\
N  )
X  #define EMIF_CECTL_DEFAULT (Uint32)(      _PER_FDEFAULT(EMIF,CECTL,WRSETUP)    |_PER_FDEFAULT(EMIF,CECTL,WRSTRB)    |_PER_FDEFAULT(EMIF,CECTL,WRHLD)    |_PER_FDEFAULT(EMIF,CECTL,RDSETUP)    |_PER_FDEFAULT(EMIF,CECTL,RDSTRB)    |_PER_FDEFAULT(EMIF,CECTL,MTYPE)    |_PER_FDEFAULT(EMIF,CECTL,RDHLD)  )
N
N  #define EMIF_CECTL_RMK(wrsetup,wrstrb,wrhld,rdsetup,rdstrb,mtype,\
N    rdhld) (Uint32)( \
N     _PER_FMK(EMIF,CECTL,WRSETUP,wrsetup)\
N    |_PER_FMK(EMIF,CECTL,WRSTRB,wrstrb)\
N    |_PER_FMK(EMIF,CECTL,WRHLD,wrhld)\
N    |_PER_FMK(EMIF,CECTL,RDSETUP,rdsetup)\
N    |_PER_FMK(EMIF,CECTL,RDSTRB,rdstrb)\
N    |_PER_FMK(EMIF,CECTL,MTYPE,mtype)\
N    |_PER_FMK(EMIF,CECTL,RDHLD,rdhld)\
N  )
X  #define EMIF_CECTL_RMK(wrsetup,wrstrb,wrhld,rdsetup,rdstrb,mtype,    rdhld) (Uint32)(      _PER_FMK(EMIF,CECTL,WRSETUP,wrsetup)    |_PER_FMK(EMIF,CECTL,WRSTRB,wrstrb)    |_PER_FMK(EMIF,CECTL,WRHLD,wrhld)    |_PER_FMK(EMIF,CECTL,RDSETUP,rdsetup)    |_PER_FMK(EMIF,CECTL,RDSTRB,rdstrb)    |_PER_FMK(EMIF,CECTL,MTYPE,mtype)    |_PER_FMK(EMIF,CECTL,RDHLD,rdhld)  )
N#endif
N
N  #define _EMIF_CECTL_FGET(N,FIELD)\
N    _PER_FGET(_EMIF_CECTL##N##_ADDR,EMIF,CECTL,##FIELD)
X  #define _EMIF_CECTL_FGET(N,FIELD)    _PER_FGET(_EMIF_CECTL##N##_ADDR,EMIF,CECTL,##FIELD)
N
N  #define _EMIF_CECTL_FSET(N,FIELD,f)\
N    _PER_FSET(_EMIF_CECTL##N##_ADDR,EMIF,CECTL,##FIELD,f)
X  #define _EMIF_CECTL_FSET(N,FIELD,f)    _PER_FSET(_EMIF_CECTL##N##_ADDR,EMIF,CECTL,##FIELD,f)
N
N  #define _EMIF_CECTL_FSETS(N,FIELD,SYM)\
N    _PER_FSETS(_EMIF_CECTL##N##_ADDR,EMIF,CECTL,##FIELD,##SYM)
X  #define _EMIF_CECTL_FSETS(N,FIELD,SYM)    _PER_FSETS(_EMIF_CECTL##N##_ADDR,EMIF,CECTL,##FIELD,##SYM)
N
N  #define _EMIF_CECTL0_FGET(FIELD) _EMIF_CECTL_FGET(0,##FIELD)
N  #define _EMIF_CECTL1_FGET(FIELD) _EMIF_CECTL_FGET(1,##FIELD)
N  #define _EMIF_CECTL2_FGET(FIELD) _EMIF_CECTL_FGET(2,##FIELD)
N  #define _EMIF_CECTL3_FGET(FIELD) _EMIF_CECTL_FGET(3,##FIELD)
N
N  #define _EMIF_CECTL0_FSET(FIELD,f) _EMIF_CECTL_FSET(0,##FIELD,f)
N  #define _EMIF_CECTL1_FSET(FIELD,f) _EMIF_CECTL_FSET(1,##FIELD,f)
N  #define _EMIF_CECTL2_FSET(FIELD,f) _EMIF_CECTL_FSET(2,##FIELD,f)
N  #define _EMIF_CECTL3_FSET(FIELD,f) _EMIF_CECTL_FSET(3,##FIELD,f)
N
N  #define _EMIF_CECTL0_FSETS(FIELD,SYM) _EMIF_CECTL_FSETS(0,##FIELD,##SYM)
N  #define _EMIF_CECTL1_FSETS(FIELD,SYM) _EMIF_CECTL_FSETS(1,##FIELD,##SYM)
N  #define _EMIF_CECTL2_FSETS(FIELD,SYM) _EMIF_CECTL_FSETS(2,##FIELD,##SYM)
N  #define _EMIF_CECTL3_FSETS(FIELD,SYM) _EMIF_CECTL_FSETS(3,##FIELD,##SYM)
N
N
N/******************************************************************************\
N* _____________________
X
N* |                   |
N* |  S D C T L        |
N* |___________________|
N*
N* SDCTL   - SDRAM control regsiter
N*
N* FIELDS (msb -> lsb)
N* (rw) SDBSZ (2)
N* (rw) SDRSZ (2)
N* (rw) SDCSZ (2)
N* (rw) SDWID (1)
N* (rw) RFEN
N* (r)  INIT
N* (rw) TRCD
N* (rw) TRP
N* (rw) TRC
N*
N* (1) - Field only exists for C01_SUPPORT
N* (2) - Field only exists for C11_SUPPORT 
N*
N\******************************************************************************/
N  #define _EMIF_SDCTL_OFFSET           6
N
N  #define _EMIF_SDCTL_ADDR             0x01800018u
N
N#if (C11_SUPPORT)
X#if (( ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 1*0) | ( 0*1) | ( 1*0) | ( 1*0) | ( 1*0) | ( 1*0)| ( 0*0)| ( 0*0)| ( 0*0)| ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 1*0) | ( 1*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) ))
S  #define _EMIF_SDCTL_SDBSZ_MASK       0x40000000u
S  #define _EMIF_SDCTL_SDBSZ_SHIFT      0x0000001Eu
S  #define  EMIF_SDCTL_SDBSZ_DEFAULT    0x00000000u
S  #define  EMIF_SDCTL_SDBSZ_OF(x)      _VALUEOF(x)
S  #define  EMIF_SDCTL_SDBSZ_2BANKS     0x00000000u
S  #define  EMIF_SDCTL_SDBSZ_4BANKS     0x00000001u
N#endif
N  
N#if (C11_SUPPORT)
X#if (( ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 1*0) | ( 0*1) | ( 1*0) | ( 1*0) | ( 1*0) | ( 1*0)| ( 0*0)| ( 0*0)| ( 0*0)| ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 1*0) | ( 1*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) ))
S  #define _EMIF_SDCTL_SDRSZ_MASK       0x30000000u
S  #define _EMIF_SDCTL_SDRSZ_SHIFT      0x0000001Cu
S  #define  EMIF_SDCTL_SDRSZ_DEFAULT    0x00000000u
S  #define  EMIF_SDCTL_SDRSZ_OF(x)      _VALUEOF(x)
S  #define  EMIF_SDCTL_SDRSZ_11ROW      0x00000000u
S  #define  EMIF_SDCTL_SDRSZ_12ROW      0x00000001u
S  #define  EMIF_SDCTL_SDRSZ_13ROW      0x00000002u
N#endif
N  
N#if (C11_SUPPORT)
X#if (( ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 1*0) | ( 0*1) | ( 1*0) | ( 1*0) | ( 1*0) | ( 1*0)| ( 0*0)| ( 0*0)| ( 0*0)| ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 1*0) | ( 1*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) ))
S  #define _EMIF_SDCTL_SDCSZ_MASK       0x0C000000u
S  #define _EMIF_SDCTL_SDCSZ_SHIFT      0x0000001Au
S  #define  EMIF_SDCTL_SDCSZ_DEFAULT    0x00000000u
S  #define  EMIF_SDCTL_SDCSZ_OF(x)      _VALUEOF(x)
S  #define  EMIF_SDCTL_SDCSZ_9COL       0x00000000u
S  #define  EMIF_SDCTL_SDCSZ_8COL       0x00000001u
S  #define  EMIF_SDCTL_SDCSZ_10COL      0x00000002u
N#endif
N  
N#if !(C11_SUPPORT) 
X#if !(( ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 1*0) | ( 0*1) | ( 1*0) | ( 1*0) | ( 1*0) | ( 1*0)| ( 0*0)| ( 0*0)| ( 0*0)| ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 1*0) | ( 1*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) )) 
N  #define _EMIF_SDCTL_SDWID_MASK       0x04000000u
N  #define _EMIF_SDCTL_SDWID_SHIFT      0x0000001Au
N  #define  EMIF_SDCTL_SDWID_DEFAULT    0x00000000u
N  #define  EMIF_SDCTL_SDWID_OF(x)      _VALUEOF(x)
N  #define  EMIF_SDCTL_SDWID_4X8BIT     0x00000000u
N  #define  EMIF_SDCTL_SDWID_2X16BIT    0x00000001u
N#endif
N  
N  #define _EMIF_SDCTL_RFEN_MASK        0x02000000u
N  #define _EMIF_SDCTL_RFEN_SHIFT       0x00000019u
N  #define  EMIF_SDCTL_RFEN_DEFAULT     0x00000001u
N  #define  EMIF_SDCTL_RFEN_OF(x)       _VALUEOF(x)
N  #define  EMIF_SDCTL_RFEN_DISABLE     0x00000000u
N  #define  EMIF_SDCTL_RFEN_ENABLE      0x00000001u
N
N  #define _EMIF_SDCTL_INIT_MASK        0x01000000u
N  #define _EMIF_SDCTL_INIT_SHIFT       0x00000018u
N  #define  EMIF_SDCTL_INIT_DEFAULT     0x00000001u
N  #define  EMIF_SDCTL_INIT_OF(x)       _VALUEOF(x)
N  #define  EMIF_SDCTL_INIT_NO          0x00000000u
N  #define  EMIF_SDCTL_INIT_YES         0x00000001u
N
N#if (C11_SUPPORT)
X#if (( ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 1*0) | ( 0*1) | ( 1*0) | ( 1*0) | ( 1*0) | ( 1*0)| ( 0*0)| ( 0*0)| ( 0*0)| ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 1*0) | ( 1*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) ))
S  #define _EMIF_SDCTL_TRCD_MASK        0x00F00000u
S  #define _EMIF_SDCTL_TRCD_SHIFT       0x00000014u
S  #define  EMIF_SDCTL_TRCD_DEFAULT     0x00000004u
S  #define  EMIF_SDCTL_TRCD_OF(x)       _VALUEOF(x)
N#else
N  #define _EMIF_SDCTL_TRCD_MASK        0x00F00000u
N  #define _EMIF_SDCTL_TRCD_SHIFT       0x00000014u
N  #define  EMIF_SDCTL_TRCD_DEFAULT     0x00000008u
N  #define  EMIF_SDCTL_TRCD_OF(x)       _VALUEOF(x)
N#endif
N
N  #define _EMIF_SDCTL_TRP_MASK         0x000F0000u
N  #define _EMIF_SDCTL_TRP_SHIFT        0x00000010u
N  #define  EMIF_SDCTL_TRP_DEFAULT      0x00000008u
N  #define  EMIF_SDCTL_TRP_OF(x)        _VALUEOF(x)
N
N  #define _EMIF_SDCTL_TRC_MASK         0x0000F000u
N  #define _EMIF_SDCTL_TRC_SHIFT        0x0000000Cu
N  #define  EMIF_SDCTL_TRC_DEFAULT      0x0000000Fu
N  #define  EMIF_SDCTL_TRC_OF(x)        _VALUEOF(x)
N
N  #define  EMIF_SDCTL_OF(x)            _VALUEOF(x)
N
N#if (C11_SUPPORT)
X#if (( ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 1*0) | ( 0*1) | ( 1*0) | ( 1*0) | ( 1*0) | ( 1*0)| ( 0*0)| ( 0*0)| ( 0*0)| ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 1*0) | ( 1*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) ))
S  #define EMIF_SDCTL_DEFAULT (Uint32)( \
S     _PER_FDEFAULT(EMIF,SDCTL,SDBSZ)\
S    |_PER_FDEFAULT(EMIF,SDCTL,SDRSZ)\
S    |_PER_FDEFAULT(EMIF,SDCTL,SDCSZ)\
S    |_PER_FDEFAULT(EMIF,SDCTL,RFEN)\
S    |_PER_FDEFAULT(EMIF,SDCTL,INIT)\
S    |_PER_FDEFAULT(EMIF,SDCTL,TRCD)\
S    |_PER_FDEFAULT(EMIF,SDCTL,TRP)\
S    |_PER_FDEFAULT(EMIF,SDCTL,TRC)\
S  )
X  #define EMIF_SDCTL_DEFAULT (Uint32)(      _PER_FDEFAULT(EMIF,SDCTL,SDBSZ)    |_PER_FDEFAULT(EMIF,SDCTL,SDRSZ)    |_PER_FDEFAULT(EMIF,SDCTL,SDCSZ)    |_PER_FDEFAULT(EMIF,SDCTL,RFEN)    |_PER_FDEFAULT(EMIF,SDCTL,INIT)    |_PER_FDEFAULT(EMIF,SDCTL,TRCD)    |_PER_FDEFAULT(EMIF,SDCTL,TRP)    |_PER_FDEFAULT(EMIF,SDCTL,TRC)  )
S
S  #define EMIF_SDCTL_RMK(sdbsz,sdrsz,sdcsz,rfen,init,trcd,trp,trc) (Uint32)(\
S     _PER_FMK(EMIF,SDCTL,SDBSZ,sdbsz)\
S    |_PER_FMK(EMIF,SDCTL,SDRSZ,sdrsz)\
S    |_PER_FMK(EMIF,SDCTL,SDCSZ,sdcsz)\
S    |_PER_FMK(EMIF,SDCTL,RFEN,rfen)\
S    |_PER_FMK(EMIF,SDCTL,INIT,init)\
S    |_PER_FMK(EMIF,SDCTL,TRCD,trcd)\
S    |_PER_FMK(EMIF,SDCTL,TRP,trp)\
S    |_PER_FMK(EMIF,SDCTL,TRC,trc)\
S  )
X  #define EMIF_SDCTL_RMK(sdbsz,sdrsz,sdcsz,rfen,init,trcd,trp,trc) (Uint32)(     _PER_FMK(EMIF,SDCTL,SDBSZ,sdbsz)    |_PER_FMK(EMIF,SDCTL,SDRSZ,sdrsz)    |_PER_FMK(EMIF,SDCTL,SDCSZ,sdcsz)    |_PER_FMK(EMIF,SDCTL,RFEN,rfen)    |_PER_FMK(EMIF,SDCTL,INIT,init)    |_PER_FMK(EMIF,SDCTL,TRCD,trcd)    |_PER_FMK(EMIF,SDCTL,TRP,trp)    |_PER_FMK(EMIF,SDCTL,TRC,trc)  )
N#endif
N
N#if !(C11_SUPPORT)
X#if !(( ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 1*0) | ( 0*1) | ( 1*0) | ( 1*0) | ( 1*0) | ( 1*0)| ( 0*0)| ( 0*0)| ( 0*0)| ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 1*0) | ( 1*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) ))
N  #define EMIF_SDCTL_DEFAULT (Uint32)( \
N     _PER_FDEFAULT(EMIF,SDCTL,SDWID)\
N    |_PER_FDEFAULT(EMIF,SDCTL,RFEN)\
N    |_PER_FDEFAULT(EMIF,SDCTL,INIT)\
N    |_PER_FDEFAULT(EMIF,SDCTL,TRCD)\
N    |_PER_FDEFAULT(EMIF,SDCTL,TRP)\
N    |_PER_FDEFAULT(EMIF,SDCTL,TRC)\
N  )
X  #define EMIF_SDCTL_DEFAULT (Uint32)(      _PER_FDEFAULT(EMIF,SDCTL,SDWID)    |_PER_FDEFAULT(EMIF,SDCTL,RFEN)    |_PER_FDEFAULT(EMIF,SDCTL,INIT)    |_PER_FDEFAULT(EMIF,SDCTL,TRCD)    |_PER_FDEFAULT(EMIF,SDCTL,TRP)    |_PER_FDEFAULT(EMIF,SDCTL,TRC)  )
N
N  #define EMIF_SDCTL_RMK(sdwid,rfen,init,trcd,trp,trc) (Uint32)(\
N     _PER_FMK(EMIF,SDCTL,SDWID,sdwid)\
N    |_PER_FMK(EMIF,SDCTL,RFEN,rfen)\
N    |_PER_FMK(EMIF,SDCTL,INIT,init)\
N    |_PER_FMK(EMIF,SDCTL,TRCD,trcd)\
N    |_PER_FMK(EMIF,SDCTL,TRP,trp)\
N    |_PER_FMK(EMIF,SDCTL,TRC,trc)\
N  )
X  #define EMIF_SDCTL_RMK(sdwid,rfen,init,trcd,trp,trc) (Uint32)(     _PER_FMK(EMIF,SDCTL,SDWID,sdwid)    |_PER_FMK(EMIF,SDCTL,RFEN,rfen)    |_PER_FMK(EMIF,SDCTL,INIT,init)    |_PER_FMK(EMIF,SDCTL,TRCD,trcd)    |_PER_FMK(EMIF,SDCTL,TRP,trp)    |_PER_FMK(EMIF,SDCTL,TRC,trc)  )
N#endif
N
N  #define _EMIF_SDCTL_FGET(FIELD)\
N    _PER_FGET(_EMIF_SDCTL_ADDR,EMIF,SDCTL,##FIELD)
X  #define _EMIF_SDCTL_FGET(FIELD)    _PER_FGET(_EMIF_SDCTL_ADDR,EMIF,SDCTL,##FIELD)
N
N  #define _EMIF_SDCTL_FSET(FIELD,field)\
N    _PER_FSET(_EMIF_SDCTL_ADDR,EMIF,SDCTL,##FIELD,field)
X  #define _EMIF_SDCTL_FSET(FIELD,field)    _PER_FSET(_EMIF_SDCTL_ADDR,EMIF,SDCTL,##FIELD,field)
N
N  #define _EMIF_SDCTL_FSETS(FIELD,SYM)\
N    _PER_FSETS(_EMIF_SDCTL_ADDR,EMIF,SDCTL,##FIELD,##SYM)
X  #define _EMIF_SDCTL_FSETS(FIELD,SYM)    _PER_FSETS(_EMIF_SDCTL_ADDR,EMIF,SDCTL,##FIELD,##SYM)
N
N
N/******************************************************************************\
N* _____________________
X
N* |                   |
N* |  S D T I M        |
N* |___________________|
N*
N* SDTIM   - SDRAM timing register
N*
N* FIELDS (msb -> lsb)
N* (rw) XRFR   (1)
N* (r)  CNTR
N* (rw) PERIOD
N*
N* (1) - Field only exists for C11_SUPPORT
N*
N\******************************************************************************/
N  #define _EMIF_SDTIM_OFFSET           7
N
N  #define _EMIF_SDTIM_ADDR             0x0180001Cu
N
N#if (C11_SUPPORT)
X#if (( ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 1*0) | ( 0*1) | ( 1*0) | ( 1*0) | ( 1*0) | ( 1*0)| ( 0*0)| ( 0*0)| ( 0*0)| ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 1*0) | ( 1*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) ))
S  #define _EMIF_SDTIM_XRFR_MASK        0x03000000u
S  #define _EMIF_SDTIM_XRFR_SHIFT       0x00000018u
S  #define  EMIF_SDTIM_XRFR_DEFAULT     0x00000000u
S  #define  EMIF_SDTIM_XRFR_OF(x)       _VALUEOF(x)
N#endif
N
N#if (C11_SUPPORT)
X#if (( ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 1*0) | ( 0*1) | ( 1*0) | ( 1*0) | ( 1*0) | ( 1*0)| ( 0*0)| ( 0*0)| ( 0*0)| ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 1*0) | ( 1*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) ))
S  #define _EMIF_SDTIM_CNTR_MASK        0x00FFF000u
S  #define _EMIF_SDTIM_CNTR_SHIFT       0x0000000Cu
S  #define  EMIF_SDTIM_CNTR_DEFAULT     0x000005DCu
S  #define  EMIF_SDTIM_CNTR_OF(x)       _VALUEOF(x)
N#else
N  #define _EMIF_SDTIM_CNTR_MASK        0x00FFF000u
N  #define _EMIF_SDTIM_CNTR_SHIFT       0x0000000Cu
N  #define  EMIF_SDTIM_CNTR_DEFAULT     0x00000040u
N  #define  EMIF_SDTIM_CNTR_OF(x)       _VALUEOF(x)
N#endif
N  
N#if (C11_SUPPORT)
X#if (( ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 1*0) | ( 0*1) | ( 1*0) | ( 1*0) | ( 1*0) | ( 1*0)| ( 0*0)| ( 0*0)| ( 0*0)| ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 1*0) | ( 1*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) ))
S  #define _EMIF_SDTIM_PERIOD_MASK      0x00000FFFu
S  #define _EMIF_SDTIM_PERIOD_SHIFT     0x00000000u
S  #define  EMIF_SDTIM_PERIOD_DEFAULT   0x000005DCu
S  #define  EMIF_SDTIM_PERIOD_OF(x)     _VALUEOF(x)
N#else
N  #define _EMIF_SDTIM_PERIOD_MASK      0x00000FFFu
N  #define _EMIF_SDTIM_PERIOD_SHIFT     0x00000000u
N  #define  EMIF_SDTIM_PERIOD_DEFAULT   0x00000040u
N  #define  EMIF_SDTIM_PERIOD_OF(x)     _VALUEOF(x)
N#endif
N
N  #define  EMIF_SDTIM_OF(x)            _VALUEOF(x)
N
N#if (C11_SUPPORT)
X#if (( ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 1*0) | ( 0*1) | ( 1*0) | ( 1*0) | ( 1*0) | ( 1*0)| ( 0*0)| ( 0*0)| ( 0*0)| ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 1*0) | ( 1*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) ))
S  #define EMIF_SDTIM_DEFAULT (Uint32)( \
S     _PER_FDEFAULT(EMIF,SDTIM,XRFR)\
S    |_PER_FDEFAULT(EMIF,SDTIM,CNTR)\
S    |_PER_FDEFAULT(EMIF,SDTIM,PERIOD)\
S  )
X  #define EMIF_SDTIM_DEFAULT (Uint32)(      _PER_FDEFAULT(EMIF,SDTIM,XRFR)    |_PER_FDEFAULT(EMIF,SDTIM,CNTR)    |_PER_FDEFAULT(EMIF,SDTIM,PERIOD)  )
S
S  #define EMIF_SDTIM_RMK(xrfr,period) (Uint32)(\
S     _PER_FMK(EMIF,SDTIM,XRFR,xrfr)\
S    |_PER_FMK(EMIF,SDTIM,PERIOD,period)\
S  )
X  #define EMIF_SDTIM_RMK(xrfr,period) (Uint32)(     _PER_FMK(EMIF,SDTIM,XRFR,xrfr)    |_PER_FMK(EMIF,SDTIM,PERIOD,period)  )
N#endif
N
N#if !(C11_SUPPORT)
X#if !(( ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 1*0) | ( 0*1) | ( 1*0) | ( 1*0) | ( 1*0) | ( 1*0)| ( 0*0)| ( 0*0)| ( 0*0)| ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 1*0) | ( 1*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) ))
N  #define EMIF_SDTIM_DEFAULT (Uint32)( \
N     _PER_FDEFAULT(EMIF,SDTIM,CNTR)\
N    |_PER_FDEFAULT(EMIF,SDTIM,PERIOD)\
N  )
X  #define EMIF_SDTIM_DEFAULT (Uint32)(      _PER_FDEFAULT(EMIF,SDTIM,CNTR)    |_PER_FDEFAULT(EMIF,SDTIM,PERIOD)  )
N
N  #define EMIF_SDTIM_RMK(period) (Uint32)(\
N     _PER_FMK(EMIF,SDTIM,PERIOD,period)\
N  )
X  #define EMIF_SDTIM_RMK(period) (Uint32)(     _PER_FMK(EMIF,SDTIM,PERIOD,period)  )
N#endif
N
N
N  #define _EMIF_SDTIM_FGET(FIELD)\
N    _PER_FGET(_EMIF_SDTIM_ADDR,EMIF,SDTIM,##FIELD)
X  #define _EMIF_SDTIM_FGET(FIELD)    _PER_FGET(_EMIF_SDTIM_ADDR,EMIF,SDTIM,##FIELD)
N
N  #define _EMIF_SDTIM_FSET(FIELD,field)\
N    _PER_FSET(_EMIF_SDTIM_ADDR,EMIF,SDTIM,##FIELD,field)
X  #define _EMIF_SDTIM_FSET(FIELD,field)    _PER_FSET(_EMIF_SDTIM_ADDR,EMIF,SDTIM,##FIELD,field)
N
N  #define _EMIF_SDTIM_FSETS(FIELD,SYM)\
N    _PER_FSETS(_EMIF_SDTIM_ADDR,EMIF,SDTIM,##FIELD,##SYM)
X  #define _EMIF_SDTIM_FSETS(FIELD,SYM)    _PER_FSETS(_EMIF_SDTIM_ADDR,EMIF,SDTIM,##FIELD,##SYM)
N
N
N/******************************************************************************\
N* _____________________
X
N* |                   |
N* |  S D E X T        |
N* |___________________|
N*
N* SDEXT   - SDRAM extension register (1)
N*
N* (1) - only supported on 6211,6711,6713,DA610,6711C,6712C
N*
N* FIELDS (msb -> lsb)
N* (rw) WR2RD
N* (rw) WR2DEAC
N* (rw) WR2WR
N* (rw) R2WDQM
N* (rw) RD2WR
N* (rw) RD2DEAC
N* (rw) RD2RD
N* (rw) THZP
N* (rw) TWR
N* (rw) TRRD
N* (rw) TRAS
N* (rw) TCL
N*
N\******************************************************************************/
N#if (C11_SUPPORT)
X#if (( ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 1*0) | ( 0*1) | ( 1*0) | ( 1*0) | ( 1*0) | ( 1*0)| ( 0*0)| ( 0*0)| ( 0*0)| ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 1*0) | ( 1*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) ))
S  #define _EMIF_SDEXT_OFFSET           8
S
S  #define _EMIF_SDEXT_ADDR             0x01800020u
S
S  #define _EMIF_SDEXT_WR2RD_MASK       0x00100000u
S  #define _EMIF_SDEXT_WR2RD_SHIFT      0x00000014u
S  #define  EMIF_SDEXT_WR2RD_DEFAULT    0x00000001u
S  #define  EMIF_SDEXT_WR2RD_OF(x)      _VALUEOF(x)
S
S  #define _EMIF_SDEXT_WR2DEAC_MASK     0x000C0000u
S  #define _EMIF_SDEXT_WR2DEAC_SHIFT    0x00000012u
S  #define  EMIF_SDEXT_WR2DEAC_DEFAULT  0x00000001u
S  #define  EMIF_SDEXT_WR2DEAC_OF(x)    _VALUEOF(x)
S
S  #define _EMIF_SDEXT_WR2WR_MASK       0x00020000u
S  #define _EMIF_SDEXT_WR2WR_SHIFT      0x00000011u
S  #define  EMIF_SDEXT_WR2WR_DEFAULT    0x00000001u
S  #define  EMIF_SDEXT_WR2WR_OF(x)      _VALUEOF(x)
S
S  #define _EMIF_SDEXT_R2WDQM_MASK      0x00018000u
S  #define _EMIF_SDEXT_R2WDQM_SHIFT     0x0000000Fu
S  #define  EMIF_SDEXT_R2WDQM_DEFAULT   0x00000003u
S  #define  EMIF_SDEXT_R2WDQM_OF(x)     _VALUEOF(x)
S
S  #define _EMIF_SDEXT_RD2WR_MASK       0x00007000u
S  #define _EMIF_SDEXT_RD2WR_SHIFT      0x0000000Cu
S  #define  EMIF_SDEXT_RD2WR_DEFAULT    0x00000005u
S  #define  EMIF_SDEXT_RD2WR_OF(x)      _VALUEOF(x)
S
S  #define _EMIF_SDEXT_RD2DEAC_MASK     0x00000C00u
S  #define _EMIF_SDEXT_RD2DEAC_SHIFT    0x0000000Au
S  #define  EMIF_SDEXT_RD2DEAC_DEFAULT  0x00000003u
S  #define  EMIF_SDEXT_RD2DEAC_OF(x)    _VALUEOF(x)
S
S  #define _EMIF_SDEXT_RD2RD_MASK       0x00000200u
S  #define _EMIF_SDEXT_RD2RD_SHIFT      0x00000009u
S  #define  EMIF_SDEXT_RD2RD_DEFAULT    0x00000001u
S  #define  EMIF_SDEXT_RD2RD_OF(x)      _VALUEOF(x)
S
S  #define _EMIF_SDEXT_THZP_MASK        0x00000180u
S  #define _EMIF_SDEXT_THZP_SHIFT       0x00000007u
S  #define  EMIF_SDEXT_THZP_DEFAULT     0x00000002u
S  #define  EMIF_SDEXT_THZP_OF(x)       _VALUEOF(x)
S
S  #define _EMIF_SDEXT_TWR_MASK         0x00000060u
S  #define _EMIF_SDEXT_TWR_SHIFT        0x00000005u
S  #define  EMIF_SDEXT_TWR_DEFAULT      0x00000001u
S  #define  EMIF_SDEXT_TWR_OF(x)        _VALUEOF(x)
S
S  #define _EMIF_SDEXT_TRRD_MASK        0x00000010u
S  #define _EMIF_SDEXT_TRRD_SHIFT       0x00000004u
S  #define  EMIF_SDEXT_TRRD_DEFAULT     0x00000001u
S  #define  EMIF_SDEXT_TRRD_OF(x)       _VALUEOF(x)
S
S  #define _EMIF_SDEXT_TRAS_MASK        0x0000000Eu
S  #define _EMIF_SDEXT_TRAS_SHIFT       0x00000001u
S  #define  EMIF_SDEXT_TRAS_DEFAULT     0x00000007u
S  #define  EMIF_SDEXT_TRAS_OF(x)       _VALUEOF(x)
S
S  #define _EMIF_SDEXT_TCL_MASK         0x00000001u
S  #define _EMIF_SDEXT_TCL_SHIFT        0x00000000u
S  #define  EMIF_SDEXT_TCL_DEFAULT      0x00000001u
S  #define  EMIF_SDEXT_TCL_OF(x)        _VALUEOF(x)
S
S  #define  EMIF_SDEXT_OF(x)            _VALUEOF(x)
S
S  #define EMIF_SDEXT_DEFAULT (Uint32)( \
S     _PER_FDEFAULT(EMIF,SDEXT,WR2RD)\
S    |_PER_FDEFAULT(EMIF,SDEXT,WR2DEAC)\
S    |_PER_FDEFAULT(EMIF,SDEXT,WR2WR)\
S    |_PER_FDEFAULT(EMIF,SDEXT,R2WDQM)\
S    |_PER_FDEFAULT(EMIF,SDEXT,RD2WR)\
S    |_PER_FDEFAULT(EMIF,SDEXT,RD2DEAC)\
S    |_PER_FDEFAULT(EMIF,SDEXT,RD2RD)\
S    |_PER_FDEFAULT(EMIF,SDEXT,THZP)\
S    |_PER_FDEFAULT(EMIF,SDEXT,TWR)\
S    |_PER_FDEFAULT(EMIF,SDEXT,TRRD)\
S    |_PER_FDEFAULT(EMIF,SDEXT,TRAS)\
S    |_PER_FDEFAULT(EMIF,SDEXT,TCL)\
S  )
X  #define EMIF_SDEXT_DEFAULT (Uint32)(      _PER_FDEFAULT(EMIF,SDEXT,WR2RD)    |_PER_FDEFAULT(EMIF,SDEXT,WR2DEAC)    |_PER_FDEFAULT(EMIF,SDEXT,WR2WR)    |_PER_FDEFAULT(EMIF,SDEXT,R2WDQM)    |_PER_FDEFAULT(EMIF,SDEXT,RD2WR)    |_PER_FDEFAULT(EMIF,SDEXT,RD2DEAC)    |_PER_FDEFAULT(EMIF,SDEXT,RD2RD)    |_PER_FDEFAULT(EMIF,SDEXT,THZP)    |_PER_FDEFAULT(EMIF,SDEXT,TWR)    |_PER_FDEFAULT(EMIF,SDEXT,TRRD)    |_PER_FDEFAULT(EMIF,SDEXT,TRAS)    |_PER_FDEFAULT(EMIF,SDEXT,TCL)  )
S
S  #define EMIF_SDEXT_RMK(wr2rd,wr2deac,wr2wr,r2wdqm,rd2wr,rd2deac,\
S    rd2rd,thzp,twr,trrd,tras,tcl) (Uint32)( \
S     _PER_FMK(EMIF,SDEXT,WR2RD,wr2rd)\
S    |_PER_FMK(EMIF,SDEXT,WR2DEAC,wr2deac)\
S    |_PER_FMK(EMIF,SDEXT,WR2WR,wr2wr)\
S    |_PER_FMK(EMIF,SDEXT,R2WDQM,r2wdqm)\
S    |_PER_FMK(EMIF,SDEXT,RD2WR,rd2wr)\
S    |_PER_FMK(EMIF,SDEXT,RD2DEAC,rd2deac)\
S    |_PER_FMK(EMIF,SDEXT,RD2RD,rd2rd)\
S    |_PER_FMK(EMIF,SDEXT,THZP,thzp)\
S    |_PER_FMK(EMIF,SDEXT,TWR,twr)\
S    |_PER_FMK(EMIF,SDEXT,TRRD,trrd)\
S    |_PER_FMK(EMIF,SDEXT,TRAS,tras)\
S    |_PER_FMK(EMIF,SDEXT,TCL,tcl)\
S  )
X  #define EMIF_SDEXT_RMK(wr2rd,wr2deac,wr2wr,r2wdqm,rd2wr,rd2deac,    rd2rd,thzp,twr,trrd,tras,tcl) (Uint32)(      _PER_FMK(EMIF,SDEXT,WR2RD,wr2rd)    |_PER_FMK(EMIF,SDEXT,WR2DEAC,wr2deac)    |_PER_FMK(EMIF,SDEXT,WR2WR,wr2wr)    |_PER_FMK(EMIF,SDEXT,R2WDQM,r2wdqm)    |_PER_FMK(EMIF,SDEXT,RD2WR,rd2wr)    |_PER_FMK(EMIF,SDEXT,RD2DEAC,rd2deac)    |_PER_FMK(EMIF,SDEXT,RD2RD,rd2rd)    |_PER_FMK(EMIF,SDEXT,THZP,thzp)    |_PER_FMK(EMIF,SDEXT,TWR,twr)    |_PER_FMK(EMIF,SDEXT,TRRD,trrd)    |_PER_FMK(EMIF,SDEXT,TRAS,tras)    |_PER_FMK(EMIF,SDEXT,TCL,tcl)  )
S
S  #define _EMIF_SDEXT_FGET(FIELD)\
S    _PER_FGET(_EMIF_SDEXT_ADDR,EMIF,SDEXT,##FIELD)
X  #define _EMIF_SDEXT_FGET(FIELD)    _PER_FGET(_EMIF_SDEXT_ADDR,EMIF,SDEXT,##FIELD)
S
S  #define _EMIF_SDEXT_FSET(FIELD,field)\
S    _PER_FSET(_EMIF_SDEXT_ADDR,EMIF,SDEXT,##FIELD,field)
X  #define _EMIF_SDEXT_FSET(FIELD,field)    _PER_FSET(_EMIF_SDEXT_ADDR,EMIF,SDEXT,##FIELD,field)
S
S  #define _EMIF_SDEXT_FSETS(FIELD,SYM)\
S    _PER_FSETS(_EMIF_SDEXT_ADDR,EMIF,SDEXT,##FIELD,##SYM)
X  #define _EMIF_SDEXT_FSETS(FIELD,SYM)    _PER_FSETS(_EMIF_SDEXT_ADDR,EMIF,SDEXT,##FIELD,##SYM)
S
N#endif
N
N/*----------------------------------------------------------------------------*/
N
N#endif /* EMIF_SUPPORT */
N#endif /* _CSL_EMIFHAL_H_ */
N/******************************************************************************\
N* End of csl_emifhal.h
X
N\******************************************************************************/
N
L 21 "E:/TI_workspase/c6701_t/csl/csl_chip.h" 2
N
N/******************************************************************************\
N* scope and inline control macros
X
N\******************************************************************************/
N#ifdef __cplusplus
S#define CSLAPI extern "C" far
N#else
N#define CSLAPI extern far
N#endif
N
N#undef  USEDEFS
N#undef  IDECL
N#undef  IDEF
N
N#ifdef  _CHIP_MOD_
S  #define IDECL CSLAPI
S  #define USEDEFS
S  #define IDEF
N#else
N  #ifdef  _INLINE
S    #define IDECL static inline
S    #define USEDEFS
S    #define IDEF  static inline
N  #else
N    #define IDECL CSLAPI
N  #endif
N#endif
N
N
N/******************************************************************************\
N* global macro declarations
X
N\******************************************************************************/
N#define CHIP_ENDIAN_BIG    0
N#define CHIP_ENDIAN_LITTLE 1
N
N#define CHIP_MAP_0         0
N#define CHIP_MAP_1         1
N
N/* Selected devices masks*/
N#if (CHIP_6713 || CHIP_DA610 || CHIP_6711C || CHIP_6712C)
X#if (0 || 0 || 0 || 0)
S#define CHIP_EKSRC_SYSCLK3  0x00000000u
S#define CHIP_EKSRC_ECLKIN   0x00000010u
N#endif
N
N#if (CHIP_6713 || CHIP_DA610)
X#if (0 || 0)
S#define CHIP_TOUT1          0x00000000u
S#define CHIP_AXR04_AXR111   0x00000008u
S
S#define CHIP_TOUT0          0x00000000u
S#define CHIP_AXR02_AXR113   0x00000004u
S
S#define CHIP_MCASP0         0x00000002u
S#define CHIP_MCBSP0         0x00000000u
S
S#define CHIP_I2C1           0x00000001u
S#define CHIP_MCBSP1         0x00000000u
S/* Full mask value */
S#define _CHIP_DEVCFG_MASK  0x0000001Fu
N#endif
N
N#if CHIP_DM642
X#if 0
S#define CHIP_VP2            0x00000040u
S#define CHIP_VP1            0x00000020u
S#define CHIP_VP0            0x00000010u
S#define CHIP_I2C            0x00000008u
S#define CHIP_MCBSP1         0x00000004u
S#define CHIP_MCBSP0         0x00000002u
S#define CHIP_MCASP0         0x00000001u
S
S#define _CHIP_PERCFG_MASK   0x0000007Fu
N#endif
N
N#if CHIP_DM641
X#if 0
S#define CHIP_VP1            0x00000020u
S#define CHIP_VP0            0x00000010u
S#define CHIP_I2C            0x00000008u
S#define CHIP_MCBSP1         0x00000004u
S#define CHIP_MCBSP0         0x00000002u
S#define CHIP_MCASP0         0x00000001u
S
S#define _CHIP_PERCFG_MASK   0x0000003Fu
N#endif
N
N#if CHIP_DM640
X#if 0
S#define CHIP_VP0            0x00000010u
S#define CHIP_I2C            0x00000008u
S#define CHIP_MCBSP1         0x00000004u
S#define CHIP_MCBSP0         0x00000002u
S#define CHIP_MCASP0         0x00000001u
S
S#define _CHIP_PERCFG_MASK   0x0000001Fu
N#endif
N
N#if CHIP_6412
X#if 0
S#define CHIP_I2C            0x00000008u
S#define CHIP_MCBSP1         0x00000004u
S#define CHIP_MCBSP0         0x00000002u
S#define _CHIP_PERCFG_MASK   0x0000000Eu
N#endif
N
N#if (CHIP_6410 || CHIP_6413 || CHIP_6418)
X#if (0 || 0 || 0)
S#define CHIP_AFCMUX         0x00000600u
S#define CHIP_MCASP1         0x00000100u
S#define CHIP_I2C1           0x00000080u
S#define CHIP_I2C0           0x00000008u
S#define CHIP_MCBSP1         0x00000004u
S#define CHIP_MCBSP0         0x00000002u
S#define CHIP_MCASP0         0x00000001u
S
S#define _CHIP_PERCFG_MASK   0x0000078Fu
N#endif
N
N/******************************************************************************\
N* global typedef declarations
X
N\******************************************************************************/
N#if( CHIP_6711C || CHIP_6712C || CHIP_DA610 || CHIP_6713 )
X#if( 0 || 0 || 0 || 0 )
Stypedef struct{
S   Uint32 devcfg;
S} CHIP_Config;
S#elif (CHIP_DM642 || CHIP_DM641 || CHIP_DM640  || CHIP_6412 || CHIP_6410 || CHIP_6413 || CHIP_6418)
X#elif (0 || 0 || 0  || 0 || 0 || 0 || 0)
Stypedef struct{
S   Uint32 percfg;
S} CHIP_Config; 
N#endif
N/******************************************************************************\
N* global variable declarations
X
N\******************************************************************************/
N
N
N/******************************************************************************\
N* global function declarations
X
N\******************************************************************************/
N
N
N/******************************************************************************\
N* inline function declarations
X
N\******************************************************************************/
NIDECL Uint32 CHIP_getCpuId();
Xextern far Uint32 CHIP_getCpuId();
NIDECL Uint32 CHIP_getRevId();
Xextern far Uint32 CHIP_getRevId();
NIDECL Uint32 CHIP_getSiliconRevId();
Xextern far Uint32 CHIP_getSiliconRevId();
NIDECL int    CHIP_getEndian();
Xextern far int    CHIP_getEndian();
NIDECL int    CHIP_getMapMode();
Xextern far int    CHIP_getMapMode();
N
N#if (CHIP_DM642 || CHIP_DM641 || CHIP_DM640  || CHIP_6412 || CHIP_6410 || CHIP_6413 || CHIP_6418) 
X#if (0 || 0 || 0  || 0 || 0 || 0 || 0) 
SIDECL void   CHIP_config(CHIP_Config *config);
SIDECL void   CHIP_configArgs(Uint32 percfg);
SIDECL void   CHIP_getConfig(CHIP_Config *config); 
S#elif ( CHIP_6711C || CHIP_6712C || CHIP_DA610 || CHIP_6713 )
X#elif ( 0 || 0 || 0 || 0 )
SIDECL void   CHIP_config(CHIP_Config *config);
SIDECL void   CHIP_configArgs(Uint32 devcfg);
SIDECL void   CHIP_getConfig(CHIP_Config *config); 
N#endif
N
N/******************************************************************************\
N* inline function definitions
X
N\******************************************************************************/
N#ifdef USEDEFS
S/*----------------------------------------------------------------------------*/
SIDEF Uint32 CHIP_getCpuId() {
S  return CHIP_FGET(CSR,CPUID);
S}
S/*----------------------------------------------------------------------------*/
SIDEF Uint32 CHIP_getRevId() {
S  return CHIP_FGET(CSR,REVID);
S}
S/*----------------------------------------------------------------------------*/
SIDEF Uint32 CHIP_getSiliconRevId() {
S  return (( 0x000F0000 & REG32(0x01B00200))>>16);
S}
S/*----------------------------------------------------------------------------*/
SIDEF int CHIP_getEndian() {
S  return CHIP_FGET(CSR,EN);
S}
S/*----------------------------------------------------------------------------*/
SIDEF int CHIP_getMapMode() {
S  int mapmode = 0;
S  #if (!C11_SUPPORT && !C64_SUPPORT)
S    mapmode = EMIF_FGET(GBLCTL,MAP);
S  #endif
S  return mapmode;
S}
S/*----------------------------------------------------------------------------*/
S#if (CHIP_6713 || CHIP_DM642 || CHIP_DM641 || CHIP_DM640 || CHIP_DA610 || CHIP_6412 || CHIP_6711C || CHIP_6712C || CHIP_6410 || CHIP_6413 || CHIP_6418)
SIDEF void   CHIP_config(CHIP_Config *config) {
S  Uint32 gie = CHIP_FGET(CSR,GIE);
S  
S#if( CHIP_6711C || CHIP_6712C || CHIP_DA610 || CHIP_6713 ) 
S    volatile Uint32 *base = (volatile Uint32 *)(_CHIP_DEVCFG_ADDR);
S    register int x0;
S    CHIP_FSET(CSR,GIE,0);
S    x0 = config->devcfg;
S    base[_CHIP_DEVCFG_OFFSET] = x0;
S    CHIP_FSET(CSR,GIE,gie);
S    
S#else 
S  volatile Uint32 *base = (volatile Uint32 *)(_CHIP_PERCFG_ADDR);
S  register int x0;
S  CHIP_FSET(CSR,GIE,0);
S  CHIP_FSETS(PCFGLOCK,LOCK,UNLOCK);
S  x0 = config->percfg;
S  base[_CHIP_PERCFG_OFFSET] = x0;
S  CHIP_FSET(CSR,GIE,gie);
S  
S#endif
S}      
S#endif
S/*----------------------------------------------------------------------------*/
S#if (CHIP_6713 || CHIP_DM642 || CHIP_DM641 || CHIP_DM640 || CHIP_DA610 || CHIP_6412 || CHIP_6711C || CHIP_6712C || CHIP_6410 || CHIP_6413 || CHIP_6418)
SIDEF void   CHIP_getConfig(CHIP_Config *config) {
S   Uint32 gie = CHIP_FGET(CSR,GIE);
S   
S#if( CHIP_6711C || CHIP_6712C || CHIP_DA610 || CHIP_6713 ) 
S   volatile Uint32 *base = (volatile Uint32 *)(_CHIP_DEVCFG_ADDR);
S   register int x0;
S
S   CHIP_FSET(CSR,GIE,0);
S
S   x0 = base[_CHIP_DEVCFG_OFFSET]; 
S   config->devcfg=x0;
S
S   CHIP_FSET(CSR,GIE,gie);
S   
S#else
S   volatile Uint32 *base = (volatile Uint32 *)(_CHIP_PERCFG_ADDR);
S   register int x0;
S
S   CHIP_FSET(CSR,GIE,0);
S
S   x0 = base[_CHIP_PERCFG_OFFSET]; 
S   config->percfg=x0;
S
S   CHIP_FSET(CSR,GIE,gie);
S   
S#endif
S}      
S#endif
S/*----------------------------------------------------------------------------*/
S   
S#if( CHIP_6711C || CHIP_6712C || CHIP_DA610 || CHIP_6713 )
S   IDEF void   CHIP_configArgs(Uint32 devcfg) {
S   Uint32 gie = CHIP_FGET(CSR,GIE);
S   volatile Uint32 *base = (volatile Uint32 *)(_CHIP_DEVCFG_ADDR);
S   CHIP_FSET(CSR,GIE,0);
S   base[_CHIP_DEVCFG_OFFSET]= devcfg; 
S   CHIP_FSET(CSR,GIE,gie);
S}   
S#elif (CHIP_DM642 || CHIP_DM641 || CHIP_DM640  || CHIP_6412 || CHIP_6410 || CHIP_6413 || CHIP_6418)
S   IDEF void   CHIP_configArgs(Uint32 percfg) {
S   Uint32 gie = CHIP_FGET(CSR,GIE);
S   volatile Uint32 *base = (volatile Uint32 *)(_CHIP_PERCFG_ADDR);
S
S   CHIP_FSET(CSR,GIE,0);
S
S#if(CHIP_DM642 || CHIP_6412)
S   CHIP_FSETS(PCFGLOCK,LOCK,UNLOCK);
S#endif
S
S   base[_CHIP_PERCFG_OFFSET]= percfg; 
S
S   CHIP_FSET(CSR,GIE,gie);
S}   
S#endif
S
S
S/*----------------------------------------------------------------------------*/
N#endif /* USEDEFS */
N
N
N#endif /* _CSL_CHIP_H_ */
N/******************************************************************************\
N* End of csl_chip.h
X
N\******************************************************************************/
N
L 18 "..\csl\csl_irq.h" 2
N#include <csl_irqhal.h>
L 1 "E:/TI_workspase/c6701_t/csl/csl_irqhal.h" 1
N/******************************************************************************\
N*           Copyright (C) 1999-2000 Texas Instruments Incorporated.
X
N*                           All Rights Reserved
N*------------------------------------------------------------------------------
N* FILENAME...... csl_irqhal.h
N* DATE CREATED.. 06/20/1999 
N* LAST MODIFIED. 10/03/2000
N*------------------------------------------------------------------------------
N* REGISTERS
N*
N* MUXH   - interrupt multiplexer high register
N* MUXL   - interrupt multiplexer low register
N* EXTPOL - external interrupt polarity register
N*
N\******************************************************************************/
N#ifndef _CSL_IRQHAL_H_
N#define _CSL_IRQHAL_H_
N
N#include <csl_stdinchal.h>
N#include <csl_chip.h>
N
N#if (IRQ_SUPPORT)
X#if (( ( 1*0) | ( 1*0) | ( 1*0) | ( 1*0) | ( 1*0) | ( 1*0) | ( 1*1) | ( 1*0) | ( 1*0) | ( 1*0) | ( 1*0)| ( 1*0)| ( 1*0)| ( 1*0)| ( 1*0) | ( 1*0) | ( 1*0) | ( 1*0) | ( 1*0) | ( 1*0) | ( 1*0) | ( 1*0) | ( 1*0) | ( 1*0) | ( 0*0) ))
N/******************************************************************************\
N* MISC section
X
N\******************************************************************************/
N
N
N/******************************************************************************\
N* module level register/field access macros
X
N\******************************************************************************/
N
N  /* ----------------- */
N  /* FIELD MAKE MACROS */
N  /* ----------------- */
N
N  #define IRQ_FMK(REG,FIELD,x)\
N    _PER_FMK(IRQ,##REG,##FIELD,x)
X  #define IRQ_FMK(REG,FIELD,x)    _PER_FMK(IRQ,##REG,##FIELD,x)
N
N  #define IRQ_FMKS(REG,FIELD,SYM)\
N    _PER_FMKS(IRQ,##REG,##FIELD,##SYM)
X  #define IRQ_FMKS(REG,FIELD,SYM)    _PER_FMKS(IRQ,##REG,##FIELD,##SYM)
N 
N 
N  /* -------------------------------- */
N  /* RAW REGISTER/FIELD ACCESS MACROS */
N  /* -------------------------------- */
N
N  #define IRQ_ADDR(REG)\
N    _IRQ_##REG##_ADDR
X  #define IRQ_ADDR(REG)    _IRQ_##REG##_ADDR
N
N  #define IRQ_RGET(REG)\
N    _PER_RGET(_IRQ_##REG##_ADDR,IRQ,##REG)
X  #define IRQ_RGET(REG)    _PER_RGET(_IRQ_##REG##_ADDR,IRQ,##REG)
N
N  #define IRQ_RSET(REG,x)\
N    _PER_RSET(_IRQ_##REG##_ADDR,IRQ,##REG,x)
X  #define IRQ_RSET(REG,x)    _PER_RSET(_IRQ_##REG##_ADDR,IRQ,##REG,x)
N
N  #define IRQ_FGET(REG,FIELD)\
N    _IRQ_##REG##_FGET(##FIELD)
X  #define IRQ_FGET(REG,FIELD)    _IRQ_##REG##_FGET(##FIELD)
N
N  #define IRQ_FSET(REG,FIELD,x)\
N    _IRQ_##REG##_FSET(##FIELD,##x)
X  #define IRQ_FSET(REG,FIELD,x)    _IRQ_##REG##_FSET(##FIELD,##x)
N
N  #define IRQ_FSETS(REG,FIELD,SYM)\
N    _IRQ_##REG##_FSETS(##FIELD,##SYM)
X  #define IRQ_FSETS(REG,FIELD,SYM)    _IRQ_##REG##_FSETS(##FIELD,##SYM)
N 
N 
N  /* ------------------------------------------ */
N  /* ADDRESS BASED REGISTER/FIELD ACCESS MACROS */
N  /* ------------------------------------------ */
N
N  #define IRQ_RGETA(addr,REG)\
N    _PER_RGET(addr,IRQ,##REG)
X  #define IRQ_RGETA(addr,REG)    _PER_RGET(addr,IRQ,##REG)
N
N  #define IRQ_RSETA(addr,REG,x)\
N    _PER_RSET(addr,IRQ,##REG,x)
X  #define IRQ_RSETA(addr,REG,x)    _PER_RSET(addr,IRQ,##REG,x)
N
N  #define IRQ_FGETA(addr,REG,FIELD)\
N    _PER_FGET(addr,IRQ,##REG,##FIELD)
X  #define IRQ_FGETA(addr,REG,FIELD)    _PER_FGET(addr,IRQ,##REG,##FIELD)
N
N  #define IRQ_FSETA(addr,REG,FIELD,x)\
N    _PER_FSET(addr,IRQ,##REG,##FIELD,x)
X  #define IRQ_FSETA(addr,REG,FIELD,x)    _PER_FSET(addr,IRQ,##REG,##FIELD,x)
N
N  #define IRQ_FSETSA(addr,REG,FIELD,SYM)\
N    _PER_FSETS(addr,IRQ,##REG,##FIELD,##SYM)
X  #define IRQ_FSETSA(addr,REG,FIELD,SYM)    _PER_FSETS(addr,IRQ,##REG,##FIELD,##SYM)
N
N
N/******************************************************************************\
N* _____________________
X
N* |                   |
N* |  M U X H          |
N* |___________________|
N*
N* MUXH - interrupt multiplexer high register
N*
N* FIELDS (msb -> lsb)
N* (rw) INTSEL15
N* (rw) INTSEL14
N* (rw) INTSEL13
N* (rw) INTSEL12
N* (rw) INTSEL11
N* (rw) INTSEL10
N*
N\******************************************************************************/
N  #define _IRQ_MUXH_ADDR               0x019C0000u
N
N  #define _IRQ_MUXH_INTSEL15_MASK      0x7C000000u
N  #define _IRQ_MUXH_INTSEL15_SHIFT     0x0000001Au
N  #define  IRQ_MUXH_INTSEL15_DEFAULT   0x00000002u
N  #define  IRQ_MUXH_INTSEL15_OF(x)     _VALUEOF(x)
N
N  #define _IRQ_MUXH_INTSEL14_MASK      0x03E00000u
N  #define _IRQ_MUXH_INTSEL14_SHIFT     0x00000015u
N  #define  IRQ_MUXH_INTSEL14_DEFAULT   0x00000001u
N  #define  IRQ_MUXH_INTSEL14_OF(x)     _VALUEOF(x)
N
N  #define _IRQ_MUXH_INTSEL13_MASK      0x001F0000u
N  #define _IRQ_MUXH_INTSEL13_SHIFT     0x00000010u
N  #define  IRQ_MUXH_INTSEL13_DEFAULT   0x00000000u
N  #define  IRQ_MUXH_INTSEL13_OF(x)     _VALUEOF(x)
N
N  #define _IRQ_MUXH_INTSEL12_MASK      0x00007C00u
N  #define _IRQ_MUXH_INTSEL12_SHIFT     0x0000000Au
N  #define  IRQ_MUXH_INTSEL12_DEFAULT   0x0000000Bu
N  #define  IRQ_MUXH_INTSEL12_OF(x)     _VALUEOF(x)
N
N  #define _IRQ_MUXH_INTSEL11_MASK      0x000003E0u
N  #define _IRQ_MUXH_INTSEL11_SHIFT     0x00000005u
N  #define  IRQ_MUXH_INTSEL11_DEFAULT   0x0000000Au
N  #define  IRQ_MUXH_INTSEL11_OF(x)     _VALUEOF(x)
N
N  #define _IRQ_MUXH_INTSEL10_MASK      0x0000001Fu
N  #define _IRQ_MUXH_INTSEL10_SHIFT     0x00000000u
N  #define  IRQ_MUXH_INTSEL10_DEFAULT   0x00000003u
N  #define  IRQ_MUXH_INTSEL10_OF(x)     _VALUEOF(x)
N
N  #define  IRQ_MUXH_OF(x)              _VALUEOF(x)
N
N  #define IRQ_MUXH_DEFAULT (Uint32)( \
N     _PER_FDEFAULT(IRQ,MUXH,INTSEL15) \
N    |_PER_FDEFAULT(IRQ,MUXH,INTSEL14) \
N    |_PER_FDEFAULT(IRQ,MUXH,INTSEL13) \
N    |_PER_FDEFAULT(IRQ,MUXH,INTSEL12) \
N    |_PER_FDEFAULT(IRQ,MUXH,INTSEL11) \
N    |_PER_FDEFAULT(IRQ,MUXH,INTSEL10) \
N  )
X  #define IRQ_MUXH_DEFAULT (Uint32)(      _PER_FDEFAULT(IRQ,MUXH,INTSEL15)     |_PER_FDEFAULT(IRQ,MUXH,INTSEL14)     |_PER_FDEFAULT(IRQ,MUXH,INTSEL13)     |_PER_FDEFAULT(IRQ,MUXH,INTSEL12)     |_PER_FDEFAULT(IRQ,MUXH,INTSEL11)     |_PER_FDEFAULT(IRQ,MUXH,INTSEL10)   )
N
N  #define IRQ_MUXH_RMK(intsel15,intsel14,intsel13,intsel12,intsel11,intsel10) \
N    (Uint32)( \
N     _PER_FMK(IRQ,MUXH,INTSEL15,intsel15) \
N    |_PER_FMK(IRQ,MUXH,INTSEL14,intsel14) \
N    |_PER_FMK(IRQ,MUXH,INTSEL13,intsel13) \
N    |_PER_FMK(IRQ,MUXH,INTSEL12,intsel12) \
N    |_PER_FMK(IRQ,MUXH,INTSEL11,intsel11) \
N    |_PER_FMK(IRQ,MUXH,INTSEL10,intsel10) \
N   )
X  #define IRQ_MUXH_RMK(intsel15,intsel14,intsel13,intsel12,intsel11,intsel10)     (Uint32)(      _PER_FMK(IRQ,MUXH,INTSEL15,intsel15)     |_PER_FMK(IRQ,MUXH,INTSEL14,intsel14)     |_PER_FMK(IRQ,MUXH,INTSEL13,intsel13)     |_PER_FMK(IRQ,MUXH,INTSEL12,intsel12)     |_PER_FMK(IRQ,MUXH,INTSEL11,intsel11)     |_PER_FMK(IRQ,MUXH,INTSEL10,intsel10)    )
N
N  #define _IRQ_MUXH_FGET(FIELD)\
N    _PER_FGET(_IRQ_MUXH_ADDR,IRQ,MUXH,##FIELD)
X  #define _IRQ_MUXH_FGET(FIELD)    _PER_FGET(_IRQ_MUXH_ADDR,IRQ,MUXH,##FIELD)
N
N  #define _IRQ_MUXH_FSET(FIELD,field)\
N    _PER_FSET(_IRQ_MUXH_ADDR,IRQ,MUXH,##FIELD,field)
X  #define _IRQ_MUXH_FSET(FIELD,field)    _PER_FSET(_IRQ_MUXH_ADDR,IRQ,MUXH,##FIELD,field)
N
N  #define _IRQ_MUXH_FSETS(FIELD,SYM)\
N    _PER_FSETS(_IRQ_MUXH_ADDR,IRQ,MUXH,##FIELD,##SYM)
X  #define _IRQ_MUXH_FSETS(FIELD,SYM)    _PER_FSETS(_IRQ_MUXH_ADDR,IRQ,MUXH,##FIELD,##SYM)
N
N
N/******************************************************************************\
N* _____________________
X
N* |                   |
N* |  M U X L          |
N* |___________________|
N*
N* MUXL - interrupt multiplexer low register
N*
N* FIELDS (msb -> lsb)
N* (rw) INTSEL9
N* (rw) INTSEL8
N* (rw) INTSEL7
N* (rw) INTSEL6
N* (rw) INTSEL5
N* (rw) INTSEL4
N*
N\******************************************************************************/
N  #define _IRQ_MUXL_ADDR               0x019C0004u
N
N  #define _IRQ_MUXL_INTSEL9_MASK       0x7C000000u
N  #define _IRQ_MUXL_INTSEL9_SHIFT      0x0000001Au
N  #define  IRQ_MUXL_INTSEL9_DEFAULT    0x00000009u
N  #define  IRQ_MUXL_INTSEL9_OF(x)      _VALUEOF(x)
N
N  #define _IRQ_MUXL_INTSEL8_MASK       0x03E00000u
N  #define _IRQ_MUXL_INTSEL8_SHIFT      0x00000015u
N  #define  IRQ_MUXL_INTSEL8_DEFAULT    0x00000008u
N  #define  IRQ_MUXL_INTSEL8_OF(x)      _VALUEOF(x)
N
N  #define _IRQ_MUXL_INTSEL7_MASK       0x001F0000u
N  #define _IRQ_MUXL_INTSEL7_SHIFT      0x00000010u
N  #define  IRQ_MUXL_INTSEL7_DEFAULT    0x00000007u
N  #define  IRQ_MUXL_INTSEL7_OF(x)      _VALUEOF(x)
N
N  #define _IRQ_MUXL_INTSEL6_MASK       0x00007C00u
N  #define _IRQ_MUXL_INTSEL6_SHIFT      0x0000000Au
N  #define  IRQ_MUXL_INTSEL6_DEFAULT    0x00000006u
N  #define  IRQ_MUXL_INTSEL6_OF(x)      _VALUEOF(x)
N
N  #define _IRQ_MUXL_INTSEL5_MASK       0x000003E0u
N  #define _IRQ_MUXL_INTSEL5_SHIFT      0x00000005u
N  #define  IRQ_MUXL_INTSEL5_DEFAULT    0x00000005u
N  #define  IRQ_MUXL_INTSEL5_OF(x)      _VALUEOF(x)
N
N  #define _IRQ_MUXL_INTSEL4_MASK       0x0000001Fu
N  #define _IRQ_MUXL_INTSEL4_SHIFT      0x00000000u
N  #define  IRQ_MUXL_INTSEL4_DEFAULT    0x00000004u
N  #define  IRQ_MUXL_INTSEL4_OF(x)      _VALUEOF(x)
N
N  #define  IRQ_MUXL_OF(x)              _VALUEOF(x)
N
N  #define IRQ_MUXL_DEFAULT (Uint32)( \
N     _PER_FDEFAULT(IRQ,MUXL,INTSEL9) \
N    |_PER_FDEFAULT(IRQ,MUXL,INTSEL8) \
N    |_PER_FDEFAULT(IRQ,MUXL,INTSEL7) \
N    |_PER_FDEFAULT(IRQ,MUXL,INTSEL6) \
N    |_PER_FDEFAULT(IRQ,MUXL,INTSEL5) \
N    |_PER_FDEFAULT(IRQ,MUXL,INTSEL4) \
N  )
X  #define IRQ_MUXL_DEFAULT (Uint32)(      _PER_FDEFAULT(IRQ,MUXL,INTSEL9)     |_PER_FDEFAULT(IRQ,MUXL,INTSEL8)     |_PER_FDEFAULT(IRQ,MUXL,INTSEL7)     |_PER_FDEFAULT(IRQ,MUXL,INTSEL6)     |_PER_FDEFAULT(IRQ,MUXL,INTSEL5)     |_PER_FDEFAULT(IRQ,MUXL,INTSEL4)   )
N
N  #define IRQ_MUXL_RMK(intsel9,intsel8,intsel7,intsel6,intsel5,intsel4) \
N    (Uint32)( \
N     _PER_FMK(IRQ,MUXL,INTSEL9,intsel9) \
N    |_PER_FMK(IRQ,MUXL,INTSEL8,intsel8) \
N    |_PER_FMK(IRQ,MUXL,INTSEL7,intsel7) \
N    |_PER_FMK(IRQ,MUXL,INTSEL6,intsel6) \
N    |_PER_FMK(IRQ,MUXL,INTSEL5,intsel5) \
N    |_PER_FMK(IRQ,MUXL,INTSEL4,intsel4) \
N   )
X  #define IRQ_MUXL_RMK(intsel9,intsel8,intsel7,intsel6,intsel5,intsel4)     (Uint32)(      _PER_FMK(IRQ,MUXL,INTSEL9,intsel9)     |_PER_FMK(IRQ,MUXL,INTSEL8,intsel8)     |_PER_FMK(IRQ,MUXL,INTSEL7,intsel7)     |_PER_FMK(IRQ,MUXL,INTSEL6,intsel6)     |_PER_FMK(IRQ,MUXL,INTSEL5,intsel5)     |_PER_FMK(IRQ,MUXL,INTSEL4,intsel4)    )
N
N  #define _IRQ_MUXL_FGET(FIELD)\
N    _PER_FGET(_IRQ_MUXL_ADDR,IRQ,MUXL,##FIELD)
X  #define _IRQ_MUXL_FGET(FIELD)    _PER_FGET(_IRQ_MUXL_ADDR,IRQ,MUXL,##FIELD)
N
N  #define _IRQ_MUXL_FSET(FIELD,field)\
N    _PER_FSET(_IRQ_MUXL_ADDR,IRQ,MUXL,##FIELD,field)
X  #define _IRQ_MUXL_FSET(FIELD,field)    _PER_FSET(_IRQ_MUXL_ADDR,IRQ,MUXL,##FIELD,field)
N
N  #define _IRQ_MUXL_FSETS(FIELD,SYM)\
N    _PER_FSETS(_IRQ_MUXL_ADDR,IRQ,MUXL,##FIELD,##SYM)
X  #define _IRQ_MUXL_FSETS(FIELD,SYM)    _PER_FSETS(_IRQ_MUXL_ADDR,IRQ,MUXL,##FIELD,##SYM)
N
N
N/******************************************************************************\
N* _____________________
X
N* |                   |
N* |  E X T P O L      |
N* |___________________|
N*
N* EXTPOL - external interrupt polarity register
N*
N* FIELDS (msb -> lsb)
N* (rw) XIP
N*
N\******************************************************************************/
N  #define _IRQ_EXTPOL_ADDR            0x019C0008u
N
N  #define _IRQ_EXTPOL_XIP_MASK        0x0000000Fu
N  #define _IRQ_EXTPOL_XIP_SHIFT       0x00000000u
N  #define  IRQ_EXTPOL_XIP_DEFAULT     0x00000000u
N  #define  IRQ_EXTPOL_XIP_OF(x)       _VALUEOF(x)
N
N  #define  IRQ_EXTPOL_OF(x)           _VALUEOF(x)
N
N  #define IRQ_EXTPOL_DEFAULT (Uint32)( \
N     _PER_FDEFAULT(IRQ,EXTPOL,XIP) \
N  )
X  #define IRQ_EXTPOL_DEFAULT (Uint32)(      _PER_FDEFAULT(IRQ,EXTPOL,XIP)   )
N
N  #define IRQ_EXTPOL_RMK(xip) (Uint32)( \
N     _PER_FMK(IRQ,EXTPOL,XIP,xip) \
N  )
X  #define IRQ_EXTPOL_RMK(xip) (Uint32)(      _PER_FMK(IRQ,EXTPOL,XIP,xip)   )
N
N  #define _IRQ_EXTPOL_FGET(FIELD)\
N    _PER_FGET(_IRQ_EXTPOL_ADDR,IRQ,EXTPOL,##FIELD)
X  #define _IRQ_EXTPOL_FGET(FIELD)    _PER_FGET(_IRQ_EXTPOL_ADDR,IRQ,EXTPOL,##FIELD)
N
N  #define _IRQ_EXTPOL_FSET(FIELD,field)\
N    _PER_FSET(_IRQ_EXTPOL_ADDR,IRQ,EXTPOL,##FIELD,field)
X  #define _IRQ_EXTPOL_FSET(FIELD,field)    _PER_FSET(_IRQ_EXTPOL_ADDR,IRQ,EXTPOL,##FIELD,field)
N
N  #define _IRQ_EXTPOL_FSETS(FIELD,SYM)\
N    _PER_FSETS(_IRQ_EXTPOL_ADDR,IRQ,EXTPOL,##FIELD,##SYM)
X  #define _IRQ_EXTPOL_FSETS(FIELD,SYM)    _PER_FSETS(_IRQ_EXTPOL_ADDR,IRQ,EXTPOL,##FIELD,##SYM)
N
N
N/*----------------------------------------------------------------------------*/
N
N#endif /* IRQ_SUPPORT */
N#endif /* _CSL_IRQHAL_H_ */
N/******************************************************************************\
N* End of csl_irqhal.h
X
N\******************************************************************************/
N
L 19 "..\csl\csl_irq.h" 2
N
N
N#if (IRQ_SUPPORT)
X#if (( ( 1*0) | ( 1*0) | ( 1*0) | ( 1*0) | ( 1*0) | ( 1*0) | ( 1*1) | ( 1*0) | ( 1*0) | ( 1*0) | ( 1*0)| ( 1*0)| ( 1*0)| ( 1*0)| ( 1*0) | ( 1*0) | ( 1*0) | ( 1*0) | ( 1*0) | ( 1*0) | ( 1*0) | ( 1*0) | ( 1*0) | ( 1*0) | ( 0*0) ))
N/******************************************************************************\
N* scope and inline control macros
X
N\******************************************************************************/
N#ifdef __cplusplus
S#define CSLAPI extern "C" far 
N#else
N#define CSLAPI extern far
N#endif
N
N#undef  USEDEFS
N#undef  IDECL
N#undef  IDEF
N
N#ifdef  _IRQ_MOD_
S  #define IDECL CSLAPI
S  #define USEDEFS
S  #define IDEF
N#else
N  #ifdef  _INLINE
S    #define IDECL static inline
S    #define USEDEFS
S    #define IDEF  static inline
N  #else
N    #define IDECL CSLAPI
N  #endif
N#endif
N
N
N/******************************************************************************\
N* global macro declarations
X
N\******************************************************************************/
N
N/* misc global settings */
N#define IRQ_INT_CNT     16
N#define IRQ_EVENT_CNT   32
N
N#define IRQ_EVT_NA         IRQ_EVENT_CNT
N
N/* event id definitions */
N#if (CHIP_6410 | CHIP_6413 | CHIP_6418)
X#if (0 | 0 | 0)
S  
S    #define IRQ_EVT_DSPINT     0
S    #define IRQ_EVT_TINT0      1
S    #define IRQ_EVT_TINT1      2
S    #define IRQ_EVT_SDINTA     3
S    #define IRQ_EVT_EXTINT4    4
S    #define IRQ_EVT_GPINT4     4
S    #define IRQ_EVT_EXTINT5    5
S    #define IRQ_EVT_GPINT5     5
S    #define IRQ_EVT_EXTINT6    6
S    #define IRQ_EVT_GPINT6     6
S    #define IRQ_EVT_EXTINT7    7
S    #define IRQ_EVT_GPINT7     7
S    #define IRQ_EVT_EDMAINT    8
S    #define IRQ_EVT_EMUDTDMA   9
S    #define IRQ_EVT_EMURTDXRX  10
S    #define IRQ_EVT_EMURTDXTX  11
S    #define IRQ_EVT_XINT0      12
S    #define IRQ_EVT_RINT0      13
S    #define IRQ_EVT_XINT1      14
S    #define IRQ_EVT_RINT1      15
S    #define IRQ_EVT_GPINT0     16
S    #define IRQ_EVT_TINT2      19
S    #define IRQ_EVT_I2CINT0    22
S    #define IRQ_EVT_I2CINT1    23
S    #define IRQ_EVT_AXINT1     24
S    #define IRQ_EVT_ARINT1     25
S    #define IRQ_EVT_AXINT0     28
S    #define IRQ_EVT_ARINT0     29
S
S  #if (CHIP_6418)
S    #define IRQ_EVT_VCPINT     30
S  #endif
S
N#else 
N
N  #if (CHIP_DM642 | CHIP_DM641 | CHIP_DM640 | CHIP_6412)
X  #if (0 | 0 | 0 | 0)
S
S    #define IRQ_EVT_DSPINT     0
S    #define IRQ_EVT_TINT0      1
S    #define IRQ_EVT_TINT1      2
S    #define IRQ_EVT_SDINTA     3
S    #define IRQ_EVT_EXTINT4    4
S    #define IRQ_EVT_GPINT4     4
S    #define IRQ_EVT_EXTINT5    5
S    #define IRQ_EVT_GPINT5     5
S    #define IRQ_EVT_EXTINT6    6
S    #define IRQ_EVT_GPINT6     6
S    #define IRQ_EVT_EXTINT7    7
S    #define IRQ_EVT_GPINT7     7
S    #define IRQ_EVT_EDMAINT    8
S    #define IRQ_EVT_EMUDTDMA   9
S    #define IRQ_EVT_EMURTDXRX  10
S    #define IRQ_EVT_EMURTDXTX  11
S    #define IRQ_EVT_XINT0      12
S    #define IRQ_EVT_RINT0      13
S    #define IRQ_EVT_XINT1      14
S    #define IRQ_EVT_RINT1      15
S    #define IRQ_EVT_GPINT0     16
S    #define IRQ_EVT_TINT2      19
S    #define IRQ_EVT_I2CINT0    22
S    #define IRQ_EVT_MACINT     24
S
S   #if !(CHIP_6412)
S    #define IRQ_EVT_VINT0      25
S    #define IRQ_EVT_VINT1      26
S   #endif
S
S   #if (CHIP_DM642)
S    #define IRQ_EVT_VINT2      27
S   #endif
S
S   #if !(CHIP_6412)
S    #define IRQ_EVT_AXINT0     28
S    #define IRQ_EVT_ARINT0     29
S   #endif
S
N  #else
N
N    #define IRQ_EVT_DSPINT     0
N    #define IRQ_EVT_TINT0      1
N    #define IRQ_EVT_TINT1      2
N    #define IRQ_EVT_SDINT      3
N    #define IRQ_EVT_SDINTA     3
N    #define IRQ_EVT_EXTINT4    4
N    #define IRQ_EVT_GPINT4     4
N    #define IRQ_EVT_EXTINT5    5
N    #define IRQ_EVT_GPINT5     5
N    #define IRQ_EVT_EXTINT6    6
N    #define IRQ_EVT_GPINT6     6
N    #define IRQ_EVT_EXTINT7    7
N    #define IRQ_EVT_GPINT7     7
N    #define IRQ_EVT_EDMAINT    8
N    #define IRQ_EVT_DMAINT0    8
N    #define IRQ_EVT_EMUDTDMA   9
N    #define IRQ_EVT_DMAINT1    9
N    #define IRQ_EVT_EMURTDXRX  10
N    #define IRQ_EVT_DMAINT2    10
N    #define IRQ_EVT_EMURTDXTX  11
N    #define IRQ_EVT_DMAINT3    11
N    #define IRQ_EVT_XINT0      12
N    #define IRQ_EVT_RINT0      13
N    #define IRQ_EVT_XINT1      14
N    #define IRQ_EVT_RINT1      15
N    #define IRQ_EVT_GPINT0     16
N    #define IRQ_EVT_XINT2      17
N    #define IRQ_EVT_RINT2      18
N    #define IRQ_EVT_TINT2      19
N    #define IRQ_EVT_SDINTB     20
N    #define IRQ_EVT_PCIWAKE    21
N    #define IRQ_EVT_MDIO       21
N    #define IRQ_EVT_QDMAERR    22
N    #define IRQ_EVT_I2CINT0    22 /* 6713 */
N    #define IRQ_EVT_UINT       23
N    #define IRQ_EVT_I2CINT1    23 /* 6713 */
N    #define IRQ_EVT_I2CINT2    23 
N    #define IRQ_EVT_I2CINT3    22 
N    #define IRQ_EVT_I2CINT4    23 
N
N    #define IRQ_EVT_MACINT     24 /* DM642 */
N    #define IRQ_EVT_VINT0      25 /* DM642 */
N    #define IRQ_EVT_VINT1      26 /* DM642 */
N    #define IRQ_EVT_VINT2      27 /* DM642 */
N    #define IRQ_EVT_AXINT0     28 /* 6713 / DM642 */
N    #define IRQ_EVT_ARINT0     29 /* 6713 / DM642 */
N    #define IRQ_EVT_AXINT3     IRQ_EVT_EXTINT4 /* 6713 */
N    #define IRQ_EVT_ARINT3     IRQ_EVT_EXTINT5 /* 6713 */
N    #define IRQ_EVT_VCPINT     30
N    #define IRQ_EVT_AXINT1     30 /* 6713 */
N
N    #define IRQ_EVT_AXINT2     30 /* 6713 */
N    #define IRQ_EVT_AXINT4     IRQ_EVT_EXTINT6
N    #define IRQ_EVT_TCPINT     31
N    #define IRQ_EVT_ARINT1     31 /* 6713 */
N
N    #define IRQ_EVT_ARINT2     31 /* 6713 */
N    #define IRQ_EVT_ARINT4     IRQ_EVT_EXTINT7
N
N  #endif
N
N#endif
N/* interrupt masks */
N#define IRQ_MASK_NA 0x00000000
N#define IRQ_MASK_00 0x00000001
N#define IRQ_MASK_01 0x00000002
N#define IRQ_MASK_02 0x00000004
N#define IRQ_MASK_03 0x00000008
N#define IRQ_MASK_04 0x00000010
N#define IRQ_MASK_05 0x00000020
N#define IRQ_MASK_06 0x00000040
N#define IRQ_MASK_07 0x00000080
N#define IRQ_MASK_08 0x00000100
N#define IRQ_MASK_09 0x00000200
N#define IRQ_MASK_10 0x00000400
N#define IRQ_MASK_11 0x00000800
N#define IRQ_MASK_12 0x00001000
N#define IRQ_MASK_13 0x00002000
N#define IRQ_MASK_14 0x00004000
N#define IRQ_MASK_15 0x00008000
N
N/* defines used with the dispatcher functions */
N#define IRQ_CCMASK_NONE        0x00000001u
N#define IRQ_CCMASK_PCC_MAPPED  0x00000000u
N#define IRQ_CCMASK_PCC_ENABLE  0x00000040u
N#define IRQ_CCMASK_PCC_FREEZE  0x00000060u
N#define IRQ_CCMASK_PCC_BYPASS  0x00000080u
N#define IRQ_CCMASK_DCC_MAPPED  0x00000000u
N#define IRQ_CCMASK_DCC_ENABLE  0x00000008u
N#define IRQ_CCMASK_DCC_FREEZE  0x0000000Cu
N#define IRQ_CCMASK_DCC_BYPASS  0x00000010u
N#define IRQ_CCMASK_DEFAULT     IRQ_CCMASK_NONE
N#define IRQ_IEMASK_SELF        0x80000000u
N#define IRQ_IEMASK_ALL         0x0000FFFFu
N#define IRQ_IEMASK_DEFAULT     IRQ_IEMASK_SELF
N
N
N/* private stuff */
N#define _IRQ_DISPATCHTABLE_CNT   (IRQ_INT_CNT)
N#define _IRQ_EVENT2INTTABLE_CNT  (IRQ_EVENT_CNT+1)
N#define _IRQ_INT2EVENTTABLE_CNT  (IRQ_INT_CNT)
N
N
N/******************************************************************************\
N* global typedef declarations
X
N\******************************************************************************/
Ntypedef struct {
N  void   *funcAddr;
N  Uint32 ieMask;
N  Uint32 ccMask;
N  Uint32 funcArg;
N} _IRQ_Dispatch;
N
Ntypedef struct {
N  void   *funcAddr;
N  Uint32 funcArg;
N  Uint32 ccMask;
N  Uint32 ieMask;
N} IRQ_Config;
N
N
N/******************************************************************************\
N* global variable declarations
X
N\******************************************************************************/
N
N/* private vars */
Nextern far Uint32 _IRQ_eventTable[IRQ_EVENT_CNT+1];
Xextern far Uint32 _IRQ_eventTable[32+1];
Nextern far Uint32 _IRQ_intTable[IRQ_INT_CNT];
Xextern far Uint32 _IRQ_intTable[16];
Nextern far _IRQ_Dispatch _IRQ_internalDispatchTable[_IRQ_DISPATCHTABLE_CNT];
Xextern far _IRQ_Dispatch _IRQ_internalDispatchTable[(16)];
Nextern far _IRQ_Dispatch *_IRQ_dispatchTable;
N
N/******************************************************************************\
N* global function declarations
X
N\******************************************************************************/
N
N/* private functions */
NCSLAPI void _IRQ_init(Uint32 biosPresent, _IRQ_Dispatch *dispatchTable);
Xextern far void _IRQ_init(Uint32 biosPresent, _IRQ_Dispatch *dispatchTable);
N
N/* API functions */
NCSLAPI void IRQ_map(Uint32 eventId, Uint32 intNumber);
Xextern far void IRQ_map(Uint32 eventId, Uint32 intNumber);
NCSLAPI void *IRQ_setVecs(void *vecs);
Xextern far void *IRQ_setVecs(void *vecs);
NCSLAPI Uint32 IRQ_biosPresent();
Xextern far Uint32 IRQ_biosPresent();
NCSLAPI void IRQ_hook(int intNum, void *func);
Xextern far void IRQ_hook(int intNum, void *func);
N
N/* These functions only work with the DSP/BIOS HWI dispatcher */
NCSLAPI void IRQ_config(Uint32 eventId, IRQ_Config *config);
Xextern far void IRQ_config(Uint32 eventId, IRQ_Config *config);
NCSLAPI void IRQ_configArgs(Uint32 eventId, void *funcAddr, Uint32 funcArg,
Xextern far void IRQ_configArgs(Uint32 eventId, void *funcAddr, Uint32 funcArg,
N  Uint32 ccMask, Uint32 ieMask);
NCSLAPI void IRQ_getConfig(Uint32 eventId, IRQ_Config *config);
Xextern far void IRQ_getConfig(Uint32 eventId, IRQ_Config *config);
NCSLAPI Uint32 IRQ_getArg(Uint32 eventId);
Xextern far Uint32 IRQ_getArg(Uint32 eventId);
NCSLAPI void IRQ_setArg(Uint32 eventId, Uint32 arg);
Xextern far void IRQ_setArg(Uint32 eventId, Uint32 arg);
N
N
N/******************************************************************************\
N* inline function declarations
X
N\******************************************************************************/
NIDECL void IRQ_enable(Uint32 eventId);
Xextern far void IRQ_enable(Uint32 eventId);
NIDECL Uint32 IRQ_disable(Uint32 eventId);
Xextern far Uint32 IRQ_disable(Uint32 eventId);
NIDECL void IRQ_restore(Uint32 eventId, Uint32 ie);
Xextern far void IRQ_restore(Uint32 eventId, Uint32 ie);
NIDECL void IRQ_set(Uint32 eventId);
Xextern far void IRQ_set(Uint32 eventId);
NIDECL void IRQ_clear(Uint32 eventId);
Xextern far void IRQ_clear(Uint32 eventId);
NIDECL Uint32 IRQ_test(Uint32 eventId);
Xextern far Uint32 IRQ_test(Uint32 eventId);
NIDECL void IRQ_reset(Uint32 eventId);
Xextern far void IRQ_reset(Uint32 eventId);
NIDECL void IRQ_resetAll();
Xextern far void IRQ_resetAll();
N
NIDECL void IRQ_globalEnable();
Xextern far void IRQ_globalEnable();
NIDECL Uint32 IRQ_globalDisable();
Xextern far Uint32 IRQ_globalDisable();
NIDECL void IRQ_globalRestore(Uint32 gie);
Xextern far void IRQ_globalRestore(Uint32 gie);
N
NIDECL void IRQ_nmiEnable();
Xextern far void IRQ_nmiEnable();
NIDECL void IRQ_nmiDisable();
Xextern far void IRQ_nmiDisable();
N
N
N/******************************************************************************\
N* inline function definitions
X
N\******************************************************************************/
N#ifdef USEDEFS
S/*----------------------------------------------------------------------------*/
SIDEF void IRQ_enable(Uint32 eventId) {
S  IER |= _IRQ_eventTable[eventId];
S}
S/*----------------------------------------------------------------------------*/
SIDEF Uint32 IRQ_disable(Uint32 eventId) {
S  Uint32 ie = IER & _IRQ_eventTable[eventId];
S  IER &= ~_IRQ_eventTable[eventId];
S  return ie;
S}
S/*----------------------------------------------------------------------------*/
SIDEF void IRQ_restore(Uint32 eventId, Uint32 ie) {
S  if (ie) {
S    IER |= _IRQ_eventTable[eventId];
S  } else {
S    IER &= ~_IRQ_eventTable[eventId];
S  }
S}
S/*----------------------------------------------------------------------------*/
SIDEF void IRQ_set(Uint32 eventId) {
S  ISR = _IRQ_eventTable[eventId];
S}
S/*----------------------------------------------------------------------------*/
SIDEF void IRQ_clear(Uint32 eventId) {
S  ICR = _IRQ_eventTable[eventId];
S}
S/*----------------------------------------------------------------------------*/
SIDEF Uint32 IRQ_test(Uint32 eventId) {
S  return (Uint32)((IFR & _IRQ_eventTable[eventId]) ? 1 : 0);
S}
S/*----------------------------------------------------------------------------*/
SIDEF void IRQ_globalEnable() {
S  CHIP_FSET(CSR,GIE,1);
S}
S/*----------------------------------------------------------------------------*/
SIDEF Uint32 IRQ_globalDisable() {
S  Uint32 gie = CHIP_FGET(CSR,GIE);
S  CHIP_FSET(CSR,GIE,0);
S  return gie;
S}
S/*----------------------------------------------------------------------------*/
SIDEF void IRQ_globalRestore(Uint32 gie) {
S  CHIP_FSET(CSR,GIE,gie);
S}
S/*----------------------------------------------------------------------------*/
SIDEF void IRQ_reset(Uint32 eventId) {
S  IER &= ~_IRQ_eventTable[eventId];
S  ICR = _IRQ_eventTable[eventId];
S}
S/*----------------------------------------------------------------------------*/
SIDEF void IRQ_resetAll() {
S  CHIP_FSET(CSR,GIE,0);
S  CHIP_CRSET(IER,0x00000000);
S  CHIP_CRSET(ICR,0xFFFFFFFF);
S}
S/*----------------------------------------------------------------------------*/
SIDEF void IRQ_nmiEnable() {
S  IER |= 0x00000002;
S}
S/*----------------------------------------------------------------------------*/
SIDEF void IRQ_nmiDisable() {
S  IER &= ~0x00000002;
S}
S/*----------------------------------------------------------------------------*/
N#endif /* USEDEFS */
N
N
N#endif /* IRQ_SUPPORT */
N#endif /* _CSL_IRQ_H_ */
N/******************************************************************************\
N* End of csl_irq.h
X
N\******************************************************************************/
N
L 9 "../csl/_csl_irq.c" 2
N
N#if (IRQ_SUPPORT)
X#if (( ( 1*0) | ( 1*0) | ( 1*0) | ( 1*0) | ( 1*0) | ( 1*0) | ( 1*1) | ( 1*0) | ( 1*0) | ( 1*0) | ( 1*0)| ( 1*0)| ( 1*0)| ( 1*0)| ( 1*0) | ( 1*0) | ( 1*0) | ( 1*0) | ( 1*0) | ( 1*0) | ( 1*0) | ( 1*0) | ( 1*0) | ( 1*0) | ( 0*0) ))
N/******************************************************************************\
N*                         L O C A L   S E C T I O N
X
N\******************************************************************************/
N
N/* We need to use the runtime library intrinsic _lmbd() function but */
Nextern far Uint32 _lmbd(Uint32 src1, Uint32 src2);
N
Nextern far void _IRQ_vecs();
N
N/******************************************************************************\
N* static macro declarations
X
N\******************************************************************************/
N
N
N/******************************************************************************\
N* static typedef declarations
X
N\******************************************************************************/
N
N
N/******************************************************************************\
N* static function declarations
X
N\******************************************************************************/
Nstatic void dummyIsr(Uint32 arg, Uint32 eventId);
N
N
N/******************************************************************************\
N* static variable definitions
X
N\******************************************************************************/
N
N/******************************************************************************\
N* static function definitions
X
N\******************************************************************************/
N
N/*----------------------------------------------------------------------------*/
Nvoid dummyIsr(Uint32 arg, Uint32 eventId) {
N}
N
N/*----------------------------------------------------------------------------*/
N
N/******************************************************************************\
N*                        G L O B A L   S E C T I O N
X
N\******************************************************************************/
N
N
N/******************************************************************************\
N* global variable definitions
X
N\******************************************************************************/
N_IRQ_Dispatch _IRQ_internalDispatchTable[_IRQ_DISPATCHTABLE_CNT] = {
X_IRQ_Dispatch _IRQ_internalDispatchTable[(16)] = {
N  {dummyIsr, IRQ_IEMASK_DEFAULT, IRQ_CCMASK_DEFAULT, 0x00000000},
X  {dummyIsr, 0x80000000u, 0x00000001u, 0x00000000},
N  {dummyIsr, IRQ_IEMASK_DEFAULT, IRQ_CCMASK_DEFAULT, 0x00000000},
X  {dummyIsr, 0x80000000u, 0x00000001u, 0x00000000},
N  {dummyIsr, IRQ_IEMASK_DEFAULT, IRQ_CCMASK_DEFAULT, 0x00000000},
X  {dummyIsr, 0x80000000u, 0x00000001u, 0x00000000},
N  {dummyIsr, IRQ_IEMASK_DEFAULT, IRQ_CCMASK_DEFAULT, 0x00000000},
X  {dummyIsr, 0x80000000u, 0x00000001u, 0x00000000},
N  {dummyIsr, IRQ_IEMASK_DEFAULT, IRQ_CCMASK_DEFAULT, 0x00000000},
X  {dummyIsr, 0x80000000u, 0x00000001u, 0x00000000},
N  {dummyIsr, IRQ_IEMASK_DEFAULT, IRQ_CCMASK_DEFAULT, 0x00000000},
X  {dummyIsr, 0x80000000u, 0x00000001u, 0x00000000},
N  {dummyIsr, IRQ_IEMASK_DEFAULT, IRQ_CCMASK_DEFAULT, 0x00000000},
X  {dummyIsr, 0x80000000u, 0x00000001u, 0x00000000},
N  {dummyIsr, IRQ_IEMASK_DEFAULT, IRQ_CCMASK_DEFAULT, 0x00000000},
X  {dummyIsr, 0x80000000u, 0x00000001u, 0x00000000},
N  {dummyIsr, IRQ_IEMASK_DEFAULT, IRQ_CCMASK_DEFAULT, 0x00000000},
X  {dummyIsr, 0x80000000u, 0x00000001u, 0x00000000},
N  {dummyIsr, IRQ_IEMASK_DEFAULT, IRQ_CCMASK_DEFAULT, 0x00000000},
X  {dummyIsr, 0x80000000u, 0x00000001u, 0x00000000},
N  {dummyIsr, IRQ_IEMASK_DEFAULT, IRQ_CCMASK_DEFAULT, 0x00000000},
X  {dummyIsr, 0x80000000u, 0x00000001u, 0x00000000},
N  {dummyIsr, IRQ_IEMASK_DEFAULT, IRQ_CCMASK_DEFAULT, 0x00000000},
X  {dummyIsr, 0x80000000u, 0x00000001u, 0x00000000},
N  {dummyIsr, IRQ_IEMASK_DEFAULT, IRQ_CCMASK_DEFAULT, 0x00000000},
X  {dummyIsr, 0x80000000u, 0x00000001u, 0x00000000},
N  {dummyIsr, IRQ_IEMASK_DEFAULT, IRQ_CCMASK_DEFAULT, 0x00000000},
X  {dummyIsr, 0x80000000u, 0x00000001u, 0x00000000},
N  {dummyIsr, IRQ_IEMASK_DEFAULT, IRQ_CCMASK_DEFAULT, 0x00000000},
X  {dummyIsr, 0x80000000u, 0x00000001u, 0x00000000},
N  {dummyIsr, IRQ_IEMASK_DEFAULT, IRQ_CCMASK_DEFAULT, 0x00000000}
X  {dummyIsr, 0x80000000u, 0x00000001u, 0x00000000}
N};
N
N/******************************************************************************\
N* global function definitions
X
N\******************************************************************************/
N
N/*----------------------------------------------------------------------------*/
Nvoid IRQ_dispatcherSetup() {
N
N  int gie;
N
N  gie = IRQ_globalDisable();
N
N  _IRQ_init(IRQ_biosPresent(), _IRQ_internalDispatchTable);
N  //IRQ_setVecs(0);
N  IRQ_nmiEnable();
N  gie = 1;
N
N  IRQ_globalRestore(gie);
N  
N}
N
N/*----------------------------------------------------------------------------*/
N
N
N#endif /* IRQ_SUPPORT */
N/******************************************************************************\
N* End of _csl_irq.c
X
N\******************************************************************************/
N
