L 1 "../csl/csl_emac.c"
N/*****************************************************************************\
N*           Copyright (C) 1999-2003 Texas Instruments Incorporated.
X
N*                           All Rights Reserved
N*------------------------------------------------------------------------------
N* FILENAME...... csl_emac.c
N* DATE CREATED.. 02/08/2002
N* LAST MODIFIED. 01/08/2004  Modified emacDequeueRx() function-fixed the problem 
N*                            with RX overflow.  
N*------------------------------------------------------------------------------
N* NOTE:
N*   When used in an multitasking environment, no EMAC function may be
N*   called while another EMAC function is operating on the same device
N*   handle in another thread. It is the responsibility of the application
N*   to assure adherence to this restriction.
N*
N\******************************************************************************/
N
N/* Include the EMAC file from CSL */
N#include <csl_emachal.h>
L 1 "E:/TI_workspase/c6701_t/csl/csl_emachal.h" 1
N/*****************************************************************************\
N*           Copyright (C) 1999-2003 Texas Instruments Incorporated.
X
N*                           All Rights Reserved
N*------------------------------------------------------------------------------
N* FILENAME...... csl_emachal.h
N* DATE CREATED.. 02/04/2002
N* LAST MODIFIED. 03/05/2003
N*------------------------------------------------------------------------------
N* REGISTERS/PARAMETERS
N*
N* TXIDVER           - TX Identification and Version Register
N* TXCONTROL         - TX Control Register
N* TXTEARDOWN        - TX Teardown Register
N* RXIDVER           - RX Identification and Version Register
N* RXCONTROL         - RX Control Register
N* RXTEARDOWN        - RX Teardown Register
N* RXMBPENABLE       - RX Mulicast/Bcast/Promisc Channel Enable Register
N* RXUNICASTSET      - RX Unicast Set Register
N* RXUNICASTCLEAR    - RX Unicast Clear Register
N* RXMAXLEN          - RX Maximum Length Register
N* RXBUFFEROFFSET    - RX Buffer Offset Register
N* RXFILTERLOWTHRESH - RX Filer Low Priority Packets Threshhold
N* RX0FLOWTHRESH     - RX Channel 0 Flow Control Threshhold
N* RX1FLOWTHRESH     - RX Channel 1 Flow Control Threshhold
N* RX2FLOWTHRESH     - RX Channel 2 Flow Control Threshhold
N* RX3FLOWTHRESH     - RX Channel 3 Flow Control Threshhold
N* RX4FLOWTHRESH     - RX Channel 4 Flow Control Threshhold
N* RX5FLOWTHRESH     - RX Channel 5 Flow Control Threshhold
N* RX6FLOWTHRESH     - RX Channel 6 Flow Control Threshhold
N* RX7FLOWTHRESH     - RX Channel 7 Flow Control Threshhold
N* RX0FREEBUFFER     - RX Channel 0 Free Buffer Count Register
N* RX1FREEBUFFER     - RX Channel 1 Free Buffer Count Register
N* RX2FREEBUFFER     - RX Channel 2 Free Buffer Count Register
N* RX3FREEBUFFER     - RX Channel 3 Free Buffer Count Register
N* RX4FREEBUFFER     - RX Channel 4 Free Buffer Count Register
N* RX5FREEBUFFER     - RX Channel 5 Free Buffer Count Register
N* RX6FREEBUFFER     - RX Channel 6 Free Buffer Count Register
N* RX7FREEBUFFER     - RX Channel 7 Free Buffer Count Register
N* MACCONTROL        - MAC Control Register
N* MACSTATUS         - MAC Status Register
N* EMCONTROL         - Emulation Control Register
N* TXINTSTATRAW      - TX Interrupt Status Register (Unmasked)
N* TXINTSTATMASKED   - TX Interrupt Status Register (Masked)
N* TXINTMASKSET      - TX Interrupt Mask Set Register
N* TXINTMASKCLEAR    - TX Interrupt Mask Clear Register
N* MACINVECTOR       - MAC Input Vector
N* MACEOIVECTOR      - MAC EOI Vector
N* RXINTSTATRAW      - RX Interrupt Status Register (Unmasked)
N* RXINTSTATMASKED   - RX Interrupt Status Register (Masked)
N* RXINTMASKSET      - RX Interrupt Mask Set Register
N* RXINTMASKCLEAR    - RX Interrupt Mask Clear Register
N* MACINTSTATRAW     - MAC Interrupt Status Register (Unmasked)
N* MACINTSTATMASKED  - MAC Interrupt Status Register (Masked)
N* MACINTMASKSET     - MAC Interrupt Mask Set Register
N* MACINTMASKCLEAR   - MAC Interrupt Mask Clear Register
N* MACADDRL0         - MAC Address Channel 0 Lower Byte Register
N* MACADDRL1         - MAC Address Channel 1 Lower Byte Register
N* MACADDRL2         - MAC Address Channel 2 Lower Byte Register
N* MACADDRL3         - MAC Address Channel 3 Lower Byte Register
N* MACADDRL4         - MAC Address Channel 4 Lower Byte Register
N* MACADDRL5         - MAC Address Channel 5 Lower Byte Register
N* MACADDRL6         - MAC Address Channel 6 Lower Byte Register
N* MACADDRL7         - MAC Address Channel 7 Lower Byte Register
N* MACADDRM          - MAC Address Middle Byte Register
N* MACADDRH          - MAC Address High Bytes Register
N* MACHASH1          - MAC Address Hash 1 Register
N* MACHASH2          - MAC Address Hash 2 Register
N* BOFFTEST          - Backoff Test Register
N* TPACETEST         - Transmit Pacing Test Register
N* RXPAUSE           - Receive Pause Timer Register
N* TXPAUSE           - Transmit Pause Timer Register
N* RXGOODFRAMES      - Number of Good Frames Received
N* RXBCASTFRAMES     - Number of Good Broadcast Frames Received
N* RXMCASTFRAMES     - Number of Good Multicast Frames Received
N* RXPAUSEFRAMES     - Number of PauseRX Frames Received
N* RXCRCERRORS       - Number of Frames Received with CRC Errors
N* RXALIGNCODEERRORS - Number of Frames Received with Alignment/Code Errors
N* RXOVERSIZED       - Number of Oversized Frames Received
N* RXJABBER          - Number of Jabber Frames Received
N* RXUNDERSIZED      - Number of Undersized Frames Received
N* RXFRAGMENTS       - Number of RX Frame Fragments Received
N* RXFILTERED        - Number of RX Frames Filtered Based on Address
N* RXQOSFILTERED     - Number of RX Frames Filtered Based on QoS Filtering
N* RXOCTETS          - Total Number of Received Bytes in Good Frames
N* TXGOODFRAMES      - Number of Good Frames Sent
N* TXBCASTFRAMES     - Number of Good Broadcast Frames Sent
N* TXMCASTFRAMES     - Number of Good Multicast Frames Sent
N* TXPAUSEFRAMES     - Number of PauseTX Frames Sent
N* TXDEFERRED        - Number of Frames Where Transmission was Deferred
N* TXCOLLISION       - Total Number of Frames Sent That Experienced a Collision
N* TXSINGLECOLL      - Number of Frames Sent with Exactly One Collision
N* TXMULTICOLL       - Number of Frames Sent with Multiple Colisions
N* TXEXCESSIVECOLL   - Number of TX Frames Lost Due to Excessive Collisions
N* TXLATECOLL        - Number of TX Frames Lost Due to a Late Collision
N* TXUNDERRUN        - Number of TX Frames Lost with Transmit Underrun Error
N* TXCARRIERSLOSS    - Numebr of TX Frames Lost Due to Carrier Sense Loss
N* TXOCTETS          - Total Nu,ber of Transmitted Bytes in Good Frames
N* FRAME64           - Total TX & RX Frames with Octet Size of 64
N* FRAME65T127       - Total TX & RX Frames with Octet Size of 65 to 127
N* FRAME128T255      - Total TX & RX Frames with Octet Size of 128 to 255
N* FRAME256T511      - Total TX & RX Frames with Octet Size of 256 to 511
N* FRAME512T1023     - Total TX & RX Frames with Octet Size of 512 to 1023
N* FRAME1024TUP      - Total TX & RX Frames with Octet Size of 1024 or above
N* NETOCTETS         - Sum of all Octets Sent or Received on the Network
N* RXSOFOVERRUNS     - Total RX Start of Frame Overruns (FIFO or DMA)
N* RXMOFOVERRUNS     - Total RX Middle of Frame Overruns (FIFO or DMA)
N* RXDMAOVERRUNS     - Total RX DMA Overruns
N* TX0HDP            - TX Channel 0 DMA Head Descriptor Pointer Register
N* TX1HDP            - TX Channel 1 DMA Head Descriptor Pointer Register
N* TX2HDP            - TX Channel 2 DMA Head Descriptor Pointer Register
N* TX3HDP            - TX Channel 3 DMA Head Descriptor Pointer Register
N* TX4HDP            - TX Channel 4 DMA Head Descriptor Pointer Register
N* TX5HDP            - TX Channel 5 DMA Head Descriptor Pointer Register
N* TX6HDP            - TX Channel 6 DMA Head Descriptor Pointer Register
N* TX7HDP            - TX Channel 7 DMA Head Descriptor Pointer Register
N* RX0HDP            - RX Channel 0 DMA Head Descriptor Pointer Register
N* RX1HDP            - RX Channel 1 DMA Head Descriptor Pointer Register
N* RX2HDP            - RX Channel 2 DMA Head Descriptor Pointer Register
N* RX3HDP            - RX Channel 3 DMA Head Descriptor Pointer Register
N* RX4HDP            - RX Channel 4 DMA Head Descriptor Pointer Register
N* RX5HDP            - RX Channel 5 DMA Head Descriptor Pointer Register
N* RX6HDP            - RX Channel 6 DMA Head Descriptor Pointer Register
N* RX7HDP            - RX Channel 7 DMA Head Descriptor Pointer Register
N* TX0INTACK         - TX Channel 0 Interrupt Acknowledge Register
N* TX1INTACK         - TX Channel 1 Interrupt Acknowledge Register
N* TX2INTACK         - TX Channel 2 Interrupt Acknowledge Register
N* TX3INTACK         - TX Channel 3 Interrupt Acknowledge Register
N* TX4INTACK         - TX Channel 4 Interrupt Acknowledge Register
N* TX5INTACK         - TX Channel 5 Interrupt Acknowledge Register
N* TX6INTACK         - TX Channel 6 Interrupt Acknowledge Register
N* TX7INTACK         - TX Channel 7 Interrupt Acknowledge Register
N* RX0INTACK         - RX Channel 0 Interrupt Acknowledge Register
N* RX1INTACK         - RX Channel 1 Interrupt Acknowledge Register
N* RX2INTACK         - RX Channel 2 Interrupt Acknowledge Register
N* RX3INTACK         - RX Channel 3 Interrupt Acknowledge Register
N* RX4INTACK         - RX Channel 4 Interrupt Acknowledge Register
N* RX5INTACK         - RX Channel 5 Interrupt Acknowledge Register
N* RX6INTACK         - RX Channel 6 Interrupt Acknowledge Register
N* RX7INTACK         - RX Channel 7 Interrupt Acknowledge Register
N*
N*
N* WRAPPER REGISTERS
N*
N* INTCTL            - Interrupt control register
N*
N*
N* DESCRIPTOR FIELDS
N*
N* DSC_NEXTDSC       - Pointer to Next Descriptor
N* DSC_BUFFER        - Pointer to Buffer
N* DSC_OFFLEN        - Buffer Offset and Length
N* DSC_STATUS        - Packet Status
N*
N*\******************************************************************************/
N#ifndef _CSL_EMACHAL_H
N#define _CSL_EMACHAL_H_
N
N#include <csl_stdinc.h>
L 1 "E:/TI_workspase/c6701_t/csl/csl_stdinc.h" 1
N/******************************************************************************\
N*           Copyright (C) 1999-2000 Texas Instruments Incorporated.
X
N*                           All Rights Reserved
N*------------------------------------------------------------------------------
N* FILENAME...... csl_stdinc.h
N* DATE CREATED.. 03/11/1999 
N* LAST MODIFIED. 10/03/2000
N*                01/06/2005    Added _TI_STD_TYPES  directive to protect 
N*                              multiple definition of datatypes.
N\******************************************************************************/
N#ifndef _CSL_STDINC_H_
N#define _CSL_STDINC_H_
N
N#include <csl_stdinchal.h>
L 1 "E:/TI_workspase/c6701_t/csl/csl_stdinchal.h" 1
N/******************************************************************************\
N*           Copyright (C) 1999-2000 Texas Instruments Incorporated.
X
N*                           All Rights Reserved
N*------------------------------------------------------------------------------
N* FILENAME...... csl_stdinchal.h
N* DATE CREATED.. 03/11/1999 
N* LAST MODIFIED. 03/23/2001
N\******************************************************************************/
N#ifndef _CSL_STDINCHAL_H_
N#define _CSL_STDINCHAL_H_
N
N
N/******************************************************************************\
N* HAL macro definitions
X
N\******************************************************************************/
N
N  #define _VALUEOF(x) ((Uint32)(x))
N
N  /*******************************************************/
N  /* generic macros for field manipulation               */
N  /*******************************************************/
N
N  #define _PER_FSHIFT(PER,REG,FIELD) \
N    _##PER##_##REG##_##FIELD##_SHIFT
X  #define _PER_FSHIFT(PER,REG,FIELD)     _##PER##_##REG##_##FIELD##_SHIFT
N
N  #define _PER_FMASK(PER,REG,FIELD) \
N    _##PER##_##REG##_##FIELD##_MASK
X  #define _PER_FMASK(PER,REG,FIELD)     _##PER##_##REG##_##FIELD##_MASK
N
N  #define _PER_FSYM(PER,REG,FIELD,SYM)\
N    PER##_##REG##_##FIELD##_##SYM
X  #define _PER_FSYM(PER,REG,FIELD,SYM)    PER##_##REG##_##FIELD##_##SYM
N
N  #define _PER_FDEFAULT(PER,REG,FIELD) \
N    ((##PER##_##REG##_##FIELD##_DEFAULT << _##PER##_##REG##_##FIELD##_SHIFT) \
N    & _##PER##_##REG##_##FIELD##_MASK)
X  #define _PER_FDEFAULT(PER,REG,FIELD)     ((##PER##_##REG##_##FIELD##_DEFAULT << _##PER##_##REG##_##FIELD##_SHIFT)     & _##PER##_##REG##_##FIELD##_MASK)
N
N  #define _PER_FMK(PER,REG,FIELD,x) (\
N    (((Uint32)(x))<<_PER_FSHIFT(##PER,##REG,##FIELD))\
N    &_PER_FMASK(##PER,##REG,##FIELD)\
N  )
X  #define _PER_FMK(PER,REG,FIELD,x) (    (((Uint32)(x))<<_PER_FSHIFT(##PER,##REG,##FIELD))    &_PER_FMASK(##PER,##REG,##FIELD)  )
N
N  #define _PER_FMKS(PER,REG,FIELD,SYM) (\
N    (_PER_FSYM(##PER,##REG,##FIELD,##SYM)<<_PER_FSHIFT(##PER,##REG,##FIELD))\
N    &_PER_FMASK(##PER,##REG,##FIELD)\
N  )
X  #define _PER_FMKS(PER,REG,FIELD,SYM) (    (_PER_FSYM(##PER,##REG,##FIELD,##SYM)<<_PER_FSHIFT(##PER,##REG,##FIELD))    &_PER_FMASK(##PER,##REG,##FIELD)  )
N
N  #define _PER_FEXTRACT(PER,REG,FIELD,reg) (Uint32)(\
N    (((Uint32)(reg)&_PER_FMASK(##PER,##REG,##FIELD))\
N    >>_PER_FSHIFT(##PER,##REG,##FIELD))\
N  )
X  #define _PER_FEXTRACT(PER,REG,FIELD,reg) (Uint32)(    (((Uint32)(reg)&_PER_FMASK(##PER,##REG,##FIELD))    >>_PER_FSHIFT(##PER,##REG,##FIELD))  )
N
N  #define _PER_FINSERT(PER,REG,FIELD,reg,field) (Uint32)(\
N    (((Uint32)(reg)&~_PER_FMASK(##PER,##REG,##FIELD))|\
N    (((Uint32)(field)<<_PER_FSHIFT(##PER,##REG,##FIELD))\
N    &_PER_FMASK(##PER,##REG,##FIELD)))\
N  )
X  #define _PER_FINSERT(PER,REG,FIELD,reg,field) (Uint32)(    (((Uint32)(reg)&~_PER_FMASK(##PER,##REG,##FIELD))|    (((Uint32)(field)<<_PER_FSHIFT(##PER,##REG,##FIELD))    &_PER_FMASK(##PER,##REG,##FIELD)))  )
N
N  /*******************************************************/
N  /* macros for memmory mapped registers                 */
N  /*******************************************************/
N
N  #define _PER_RAOI(addr,PER,REG,and,or,inv)\
N    (*(volatile Uint32*)(addr))=(\
N      ((((*(volatile Uint32*)(addr))\
N      &((Uint32)(and)))\
N      |((Uint32)(or)))\
N      ^((Uint32)(inv)))\
N    )
X  #define _PER_RAOI(addr,PER,REG,and,or,inv)    (*(volatile Uint32*)(addr))=(      ((((*(volatile Uint32*)(addr))      &((Uint32)(and)))      |((Uint32)(or)))      ^((Uint32)(inv)))    )
N
N  #define _PER_RGET(addr,PER,REG) \
N    (*(volatile Uint32*)(addr))
X  #define _PER_RGET(addr,PER,REG)     (*(volatile Uint32*)(addr))
N
N  #define _PER_RSET(addr,PER,REG,x) \
N    (*(volatile Uint32*)(addr))=((Uint32)(x))
X  #define _PER_RSET(addr,PER,REG,x)     (*(volatile Uint32*)(addr))=((Uint32)(x))
N
N  #define _PER_FGET(addr,PER,REG,FIELD) \
N    _PER_FEXTRACT(##PER,##REG,##FIELD,_PER_RGET(addr,##PER,##REG))
X  #define _PER_FGET(addr,PER,REG,FIELD)     _PER_FEXTRACT(##PER,##REG,##FIELD,_PER_RGET(addr,##PER,##REG))
N
N  #define _PER_FSET(addr,PER,REG,FIELD,field)\
N    _PER_RSET(addr,##PER,##REG,\
N    _PER_FINSERT(##PER,##REG,##FIELD,_PER_RGET(addr,##PER,##REG),field))
X  #define _PER_FSET(addr,PER,REG,FIELD,field)    _PER_RSET(addr,##PER,##REG,    _PER_FINSERT(##PER,##REG,##FIELD,_PER_RGET(addr,##PER,##REG),field))
N
N  #define _PER_FSETS(addr,PER,REG,FIELD,SYM)\
N    _PER_RSET(addr,##PER,##REG,_PER_FINSERT(##PER,##REG,##FIELD,_PER_RGET(addr,##PER,##REG),\
N    _PER_FSYM(##PER,##REG,##FIELD,##SYM)))
X  #define _PER_FSETS(addr,PER,REG,FIELD,SYM)    _PER_RSET(addr,##PER,##REG,_PER_FINSERT(##PER,##REG,##FIELD,_PER_RGET(addr,##PER,##REG),    _PER_FSYM(##PER,##REG,##FIELD,##SYM)))
N
N  /*******************************************************/
N  /* macros for CPU control registers                    */
N  /*******************************************************/
N
N  #define _PER_CRGET(PER,REG) \
N    REG
X  #define _PER_CRGET(PER,REG)     REG
N
N  #define _PER_CRSET(PER,REG,reg) \
N    REG=((Uint32)(reg))
X  #define _PER_CRSET(PER,REG,reg)     REG=((Uint32)(reg))
N
N  #define _PER_CFGET(PER,REG,FIELD) \
N    _PER_FEXTRACT(##PER,##REG,##FIELD,_PER_CRGET(##PER,##REG))
X  #define _PER_CFGET(PER,REG,FIELD)     _PER_FEXTRACT(##PER,##REG,##FIELD,_PER_CRGET(##PER,##REG))
N
N  #define _PER_CFSET(PER,REG,FIELD,field)\
N    _PER_CRSET(##PER,##REG,\
N    _PER_FINSERT(##PER,##REG,##FIELD,_PER_CRGET(##PER,##REG),field))
X  #define _PER_CFSET(PER,REG,FIELD,field)    _PER_CRSET(##PER,##REG,    _PER_FINSERT(##PER,##REG,##FIELD,_PER_CRGET(##PER,##REG),field))
N
N  #define _PER_CFSETS(PER,REG,FIELD,SYM)\
N    _PER_CRSET(##PER,##REG,\
N    _PER_FINSERT(##PER,##REG,FIELD,_PER_CRGET(##PER,##REG),\
N    _PER_FSYM(##PER,##REG,##FIELD,##SYM)))
X  #define _PER_CFSETS(PER,REG,FIELD,SYM)    _PER_CRSET(##PER,##REG,    _PER_FINSERT(##PER,##REG,FIELD,_PER_CRGET(##PER,##REG),    _PER_FSYM(##PER,##REG,##FIELD,##SYM)))
N
N/*----------------------------------------------------------------------------*/
N
N#endif /* _CSL_STDINCHAL_H_ */
N/******************************************************************************\
N* End of csl_stdinchal.h
X
N\******************************************************************************/
N
L 15 "E:/TI_workspase/c6701_t/csl/csl_stdinc.h" 2
N
N
N/******************************************************************************\
N* macro declarations
X
N\******************************************************************************/
N
N/* a few standard constants */
N#ifndef TRUE
N  #define TRUE   1
N#endif
N#ifndef FALSE
N  #define FALSE  0
N#endif
N
N/* Invalid Pointer                                               */
N/* In many instances, it is better to use INV as opposed to NULL */
N/* because 0 may actually be a valid pointer                     */
N#ifndef INV
N  #define INV    ((void*)(-1))
N#endif
N
N#ifndef UNREFERENCED_PARAMETER
N  #define UNREFERENCED_PARAMETER(P)    ((P)=(P))
N#endif
N
N#ifndef REG32
N  #define REG32(addr) (*(volatile unsigned int*)(addr))
N  #define REG16(addr) (*(volatile unsigned short*)(addr))
N  #define REG8(addr)  (*(volatile unsigned char*)(addr))
N#endif
N
N/******************************************************************************\
N* typedef declarations
X
N\******************************************************************************/
N
N#include <tistdtypes.h> /* use typedefs provided with CCS*/
L 1 "E:/TI_workspase/c6701_t/csl/tistdtypes.h" 1
N/*
N *  ======== tistdtypes.h ========
N */
N
N/*
N * These types are also defined by other TI components.  They are bracketed
N * with _TI_STD_TYPES to avoid warnings for duplicate definition.
N *
N * You may get warnings about duplicate type definitions when using this
N * header file with earlier versions of DSP/BIOS and CSL.
N *
N * You can use the '-pds303' compiler option to suppress these warnings.
N */
N#ifndef _TI_STD_TYPES
N#define _TI_STD_TYPES
N
N/*
N * This '#ifndef STD_' is needed to protect from duplicate definitions
N * of Int, Uns, etc. in DSP/BIOS v4.x (e.g. 4.90, 4.80) since these versions
N * of DSP/BIOS did not contain the '#ifndef_TI_STD_TYPES' logic.
N */
N#ifndef STD_
N
N/*
N * Aliases for standard C types
N */
Ntypedef int			Int;
Ntypedef unsigned		Uns;
Ntypedef char			Char;
N
N/* pointer to null-terminated character sequence */
Ntypedef char			*String;
N
Ntypedef void			*Ptr;		/* pointer to arbitrary type */
N
Ntypedef unsigned short		Bool;		/* boolean */
N
N#endif /* STD_ */
N
N/*
N * Uint8, Uint16, Uint32, etc are defined to be "smallest unit of
N * available storage that is large enough to hold unsigned or integer
N * of specified size".
N */
N
N/* Handle the 6x ISA */
N#if defined(_TMS320C6X)
X#if 1L
N    /* Unsigned integer definitions (32bit, 16bit, 8bit) follow... */
N    typedef unsigned int	Uint32;
N    typedef unsigned short	Uint16;
N    typedef unsigned char	Uint8;
N
N    /* Signed integer definitions (32bit, 16bit, 8bit) follow... */
N    typedef int			Int32;
N    typedef short		Int16;
N    typedef char		Int8;
N
N/* Handle the 54x, 55x and 28x ISAs */
N#elif defined(_TMS320C5XX) || defined(__TMS320C55X__) || defined(_TMS320C28X)
S    /* Unsigned integer definitions (32bit, 16bit, 8bit) follow... */
S    typedef unsigned long	Uint32;
S    typedef unsigned short	Uint16;
S    typedef unsigned char	Uint8;
S
S    /* Signed integer definitions (32bit, 16bit, 8bit) follow... */
S    typedef long		Int32;
S    typedef short		Int16;
S    typedef char		Int8;
S
S#else
S    /* Other ISAs not supported */
S    #error <tistdtypes.h> is not supported for this target
N#endif  /* defined(_6x_) */
N
N#endif  /* _TI_STD_TYPES */
L 51 "E:/TI_workspase/c6701_t/csl/csl_stdinc.h" 2
N
N/******************************************************************************\
N* variable declarations
X
N\******************************************************************************/
N
N
N typedef long             Int40;
N typedef unsigned long    Uint40;
N/******************************************************************************\
N* function declarations
X
N\******************************************************************************/
N
N
N#endif /* _CSL_STDINC_H_ */
N/******************************************************************************\
N* End of csl_stdinc.h
X
N\******************************************************************************/
N
L 159 "E:/TI_workspase/c6701_t/csl/csl_emachal.h" 2
N#include <csl_chip.h>
L 1 "E:/TI_workspase/c6701_t/csl/csl_chip.h" 1
N/******************************************************************************\
N*           Copyright (C) 1999-2001 Texas Instruments Incorporated.
X
N*                           All Rights Reserved
N*------------------------------------------------------------------------------
N* FILENAME...... csl_chip.h
N* DATE CREATED.. 08/19/1999 
N* LAST MODIFIED. 08/02/2004 - Adding support for C6418
N*                06/17/2003   - Added support for 6712C
N*                06/09/2003   - Added support for 6711C
N*                12/03/2001   - CHIP_configArgs
N*                11/08/2001   - CHIP_getSiliconRevId()
N*                             - CHIP_config() / CHIP_getConfig  DM642
N\******************************************************************************/
N#ifndef _CSL_CHIP_H_
N#define _CSL_CHIP_H_
N
N#include <csl_stdinc.h>
N
N#include <csl_chiphal.h>
L 1 "E:/TI_workspase/c6701_t/csl/csl_chiphal.h" 1
N/******************************************************************************\
N*           Copyright (C) 2000 Texas Instruments Incorporated.
X
N*                           All Rights Reserved
N*------------------------------------------------------------------------------
N* FILENAME...... csl_chiphal.h
N* DATE CREATED.. 14 Aug 2000
N* LAST MODIFIED. 14 Jan 2004 Adding support for DRI300 versions (6410, 6413)
N*                05 Aug 2003 Removing external control cregisters EM,ER,IN,OUT and DIER.
N*                26 Jun 2003 Added support for 6411
N*                17 Jun 2003 Added support for 6712C
N*                28 May 2003 Added support for 6711C
N*                05 Nov 2001 DM642 , 6411 remove 6400
N*                03 Oct 2001 - CHIP_6713 - MCASP_SUPPORT - IIC_SUPPORT
N*                           - PERCFG register
N*                           - redefinition of CHIP_RSET() / CHIP_RGET()
N*                           - new CHIP_CRSET() / CHIP_CRGET() => modification of csl_irq.h
N*                04 Apr 2004-  Removing external control cregisters EM,ER,IN,OUT and DIER.
N*                12 Jan 2005-  Removing external control cregisters FMCR,FADCR,FAUCR and GFPGFR
N*                06 Apr 2005-  Removing the macros ATLEN,ATLMEN and ADIV according to data manual 
N*                              tms320c6410(13)-sprs247 dated: Feb26 2004 specifications. 
N*				 26 Jul 2005-  Added C++ support.
N*------------------------------------------------------------------------------
N* REGISTERS
N*
N* CSR    - control/status register
N* IFR    - interrupt flag register
N* ISR    - interrupt set register
N* ICR    - interrupt clear register
N* IER    - interrupt enable register
N* ISTP   - interrupt service table pointer register
N* IRP    - interrupt return pointer
N* NRP    - non-maskable interrupt return pointer
N* AMR    - addressing mode reister
N* PERCFG - Device Configuration register  (4)
N* DEVSTAT - Device Status Register (5)
N* JTAGID - JTAG ID register (5)
N*
N* (1) only supported on 67xx
N* (2) only supported on floating point devices
N* (3) only supported on 6411/14/15/16 devices
N* (4) only supported on 6713/DA610/DM642/6412/6711C/6712C devices
N* (5) only supported on DM642/6412/6410/6413 devices
N*
N\******************************************************************************/
N#ifndef _CSL_CHIPHAL_H_
N#define _CSL_CHIPHAL_H_
N
N#include <csl_stdinc.h>
N
N#ifdef __cplusplus
Sextern "C" {
N#endif
N
N
N/******************************************************************************\
N* CHIP identification section
X
N\******************************************************************************/
N#ifdef CHIP_BASELINE
S  #undef CHIP_BASELINE
S  #define CHIP_BASELINE 1
N#else
N  #define CHIP_BASELINE 0
N#endif
N
N#if (CHIP_BASELINE)
X#if (0)
S  #define CHIP_6201 1
N#endif
N
N#ifdef CHIP_6201
S  #undef CHIP_6201
S  #define CHIP_6201 1
N#else
N  #define CHIP_6201 0
N#endif
N
N#ifdef CHIP_6202
S  #undef CHIP_6202
S  #define CHIP_6202 1
N#else
N  #define CHIP_6202 0
N#endif
N
N#ifdef CHIP_6203
S  #undef CHIP_6203
S  #define CHIP_6203 1
N#else
N  #define CHIP_6203 0
N#endif
N
N#ifdef CHIP_6204
S  #undef CHIP_6204
S  #define CHIP_6204 1
N#else
N  #define CHIP_6204 0
N#endif
N
N#ifdef CHIP_6205
S  #undef CHIP_6205
S  #define CHIP_6205 1
N#else
N  #define CHIP_6205 0
N#endif
N
N#ifdef CHIP_6211
S  #undef CHIP_6211
S  #define CHIP_6211 1
N#else
N  #define CHIP_6211 0
N#endif
N
N#ifdef CHIP_6701
N  #undef CHIP_6701
N  #define CHIP_6701 1
N#else
S  #define CHIP_6701 0
N#endif
N
N#ifdef CHIP_6711
S  #undef CHIP_6711
S  #define CHIP_6711 1
N#else
N  #define CHIP_6711 0
N#endif
N
N#ifdef CHIP_6712
S  #undef CHIP_6712
S  #define CHIP_6712 1
N#else
N  #define CHIP_6712 0
N#endif
N
N
N#ifdef CHIP_6713
S  #undef CHIP_6713
S  #define CHIP_6713 1
N#else
N  #define CHIP_6713 0
N#endif
N
N#ifdef CHIP_DA610
S  #undef CHIP_DA610
S  #define CHIP_DA610 1
N#else
N  #define CHIP_DA610 0
N#endif
N
N#ifdef CHIP_DM642
S  #undef CHIP_DM642
S  #define CHIP_DM642 1
N#else
N  #define CHIP_DM642 0
N#endif
N
N#ifdef CHIP_DM641
S  #undef CHIP_DM641
S  #define CHIP_DM641 1
N#else
N  #define CHIP_DM641 0
N#endif
N
N#ifdef CHIP_DM640
S  #undef CHIP_DM640
S  #define CHIP_DM640 1
N#else
N  #define CHIP_DM640 0
N#endif
N
N#ifdef CHIP_6412
S  #undef CHIP_6412
S  #define CHIP_6412 1
N#else
N  #define CHIP_6412 0
N#endif
N
N#ifdef CHIP_6414
S  #undef CHIP_6414
S  #define CHIP_6414 1
N#else
N  #define CHIP_6414 0
N#endif
N
N#ifdef CHIP_6415
S  #undef CHIP_6415
S  #define CHIP_6415 1
N#else
N  #define CHIP_6415 0
N#endif
N
N#ifdef CHIP_6416
S  #undef CHIP_6416
S  #define CHIP_6416 1
N#else
N  #define CHIP_6416 0
N#endif
N
N#ifdef CHIP_6711C
S  #undef CHIP_6711C
S  #define CHIP_6711C 1
N#else
N  #define CHIP_6711C 0
N#endif
N
N#ifdef CHIP_6712C
S  #undef CHIP_6712C
S  #define CHIP_6712C 1
N#else
N  #define CHIP_6712C 0
N#endif
N
N#ifdef CHIP_6411
S  #undef CHIP_6411
S  #define CHIP_6411 1
N#else
N  #define CHIP_6411 0
N#endif
N
N/* next two are DRI300 versions */
N#ifdef CHIP_6410
S  #undef CHIP_6410
S  #define CHIP_6410 1
N#else
N  #define CHIP_6410 0
N#endif
N
N#ifdef CHIP_6413
S  #undef CHIP_6413
S  #define CHIP_6413 1
N#else
N  #define CHIP_6413 0
N#endif
N
N#ifdef CHIP_6418
S  #undef CHIP_6418
S  #define CHIP_6418 1
N#else
N  #define CHIP_6418 0
N#endif
N
N#define CHIP_OROFALL (\
N  CHIP_6201 | \
N  CHIP_6202 | \
N  CHIP_6203 | \
N  CHIP_6204 | \
N  CHIP_6205 | \
N  CHIP_6211 | \
N  CHIP_6701 | \
N  CHIP_6711 | \
N  CHIP_6712 | \
N  CHIP_6713 | \
N  CHIP_DA610 | \
N  CHIP_DM642 | \
N  CHIP_DM641 | \
N  CHIP_DM640 | \
N  CHIP_6412 | \
N  CHIP_6414 | \
N  CHIP_6415 | \
N  CHIP_6416 |  \
N  CHIP_6711C | \
N  CHIP_6712C | \
N  CHIP_6411 |\
N  CHIP_6410 |\
N  CHIP_6413 |\
N  CHIP_6418 \
N)
X#define CHIP_OROFALL (  CHIP_6201 |   CHIP_6202 |   CHIP_6203 |   CHIP_6204 |   CHIP_6205 |   CHIP_6211 |   CHIP_6701 |   CHIP_6711 |   CHIP_6712 |   CHIP_6713 |   CHIP_DA610 |   CHIP_DM642 |   CHIP_DM641 |   CHIP_DM640 |   CHIP_6412 |   CHIP_6414 |   CHIP_6415 |   CHIP_6416 |    CHIP_6711C |   CHIP_6712C |   CHIP_6411 |  CHIP_6410 |  CHIP_6413 |  CHIP_6418 )
N
N#if (CHIP_OROFALL==0)
X#if (( 0 | 0 | 0 | 0 | 0 | 0 | 1 | 0 | 0 | 0 | 0 | 0 | 0 | 0 | 0 | 0 | 0 | 0 | 0 | 0 | 0 | 0 | 0 | 0 )==0)
S  #error NO CHIP DEFINED (use -dCHIP_XXXX where XXXX is chip number, i.e. 6201)
N#endif
N
N#define CHIP_NONE 0
N
N#define CHIP_SUPPORT(c0,c1,c2,c3,c4,c5,c6,c7,c8,c9,c10,c11,c12,c13,c14,c15,c16,c17,c18,c19,c20,c21,c22,c23,c24) ( \
N  ( c0*CHIP_6201)  | \
N  ( c1*CHIP_6202)  | \
N  ( c2*CHIP_6203)  | \
N  ( c3*CHIP_6204)  | \
N  ( c4*CHIP_6205)  | \
N  ( c5*CHIP_6211)  | \
N  ( c6*CHIP_6701)  | \
N  ( c7*CHIP_6711)  | \
N  ( c8*CHIP_6712)  | \
N  ( c9*CHIP_6713)  | \
N  ( c10*CHIP_DA610)| \
N  ( c11*CHIP_DM642)| \
N  ( c12*CHIP_DM641)| \
N  ( c13*CHIP_DM640)| \
N  ( c14*CHIP_6412) | \
N  ( c15*CHIP_6414) | \
N  ( c16*CHIP_6415) | \
N  ( c17*CHIP_6416) | \
N  ( c18*CHIP_6711C) | \
N  ( c19*CHIP_6712C) | \
N  ( c20*CHIP_6411) | \
N  ( c21*CHIP_6410) | \
N  ( c22*CHIP_6413) | \
N  ( c23*CHIP_6418) | \
N  ( c24*CHIP_NONE)   \
N )
X#define CHIP_SUPPORT(c0,c1,c2,c3,c4,c5,c6,c7,c8,c9,c10,c11,c12,c13,c14,c15,c16,c17,c18,c19,c20,c21,c22,c23,c24) (   ( c0*CHIP_6201)  |   ( c1*CHIP_6202)  |   ( c2*CHIP_6203)  |   ( c3*CHIP_6204)  |   ( c4*CHIP_6205)  |   ( c5*CHIP_6211)  |   ( c6*CHIP_6701)  |   ( c7*CHIP_6711)  |   ( c8*CHIP_6712)  |   ( c9*CHIP_6713)  |   ( c10*CHIP_DA610)|   ( c11*CHIP_DM642)|   ( c12*CHIP_DM641)|   ( c13*CHIP_DM640)|   ( c14*CHIP_6412) |   ( c15*CHIP_6414) |   ( c16*CHIP_6415) |   ( c17*CHIP_6416) |   ( c18*CHIP_6711C) |   ( c19*CHIP_6712C) |   ( c20*CHIP_6411) |   ( c21*CHIP_6410) |   ( c22*CHIP_6413) |   ( c23*CHIP_6418) |   ( c24*CHIP_NONE)    )
N
N/*---------------------------------------------------------------------------------------*/
N/*                                     6 6 6 6 6 6 6 6 6 6 D D D D 6 6 6 6 6 6 6 6 6 6 N */
N/*                                     2 2 2 2 2 2 7 7 7 7 A M M M 4 4 4 4 7 7 4 4 4 4 O */
N/*                                     0 0 0 0 0 1 0 1 1 1 6 6 6 6 1 1 1 1 1 1 1 1 1 1 N */
N/*                                     1 2 3 4 5 1 1 1 2 3 1 4 4 4 2 4 5 6 1 2 1 0 3 8 E */
N/*                                                         0 2 1 0         C C           */
N/*---------------------------------------------------------------------------------------*/
N#define CACHE_SUPPORT     CHIP_SUPPORT(1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0)
N#define DMA_SUPPORT       CHIP_SUPPORT(1,1,1,1,1,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0)
N#define EDMA_SUPPORT      CHIP_SUPPORT(0,0,0,0,0,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0)
N#define EMIF_SUPPORT      CHIP_SUPPORT(1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,0,0,0,0,0)
N#define EMIFA_SUPPORT     CHIP_SUPPORT(0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,1,1,1,1,0)
N#define EMIFB_SUPPORT     CHIP_SUPPORT(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0)
N#define GPIO_SUPPORT      CHIP_SUPPORT(0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0)
N#define HPI_SUPPORT       CHIP_SUPPORT(1,0,0,0,0,1,1,1,0,1,1,1,1,0,1,1,1,1,1,0,1,1,1,1,0)
N#define I2C_SUPPORT       CHIP_SUPPORT(0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,0)
N#define IRQ_SUPPORT       CHIP_SUPPORT(1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0)
N#define MCASP_SUPPORT     CHIP_SUPPORT(0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,0)
N#define MCBSP_SUPPORT     CHIP_SUPPORT(1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0)
N#define PLL_SUPPORT       CHIP_SUPPORT(0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,1,1,0,0,0,0,0)
N#define TIMER_SUPPORT     CHIP_SUPPORT(1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0)
N#define XBUS_SUPPORT      CHIP_SUPPORT(0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0)
N#define PCI_SUPPORT       CHIP_SUPPORT(0,0,0,0,1,0,0,0,0,0,0,1,0,0,1,0,1,1,0,0,1,0,0,0,0)
N/*---------------------------------------------------------------------------------------*/
N/*                                     6 6 6 6 6 6 6 6 6 6 D D D D 6 6 6 6 6 6 6 6 6 6 N */
N/*                                     2 2 2 2 2 2 7 7 7 7 A M M M 4 4 4 4 7 7 4 4 4 4 O */
N/*                                     0 0 0 0 0 1 0 1 1 1 6 6 6 6 1 1 1 1 1 1 1 1 1 1 N */
N/*                                     1 2 3 4 5 1 1 1 2 3 1 4 4 4 2 4 5 6 1 2 1 0 3 8 E */
N/*                                                         0 2 1 0         C C           */
N/*---------------------------------------------------------------------------------------*/
N#define VP_SUPPORT        CHIP_SUPPORT(0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0)
N#define VIC_SUPPORT       CHIP_SUPPORT(0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0)
N#define DAT_SUPPORT       CHIP_SUPPORT(1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0)
N#define PWR_SUPPORT       CHIP_SUPPORT(1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0)
N#define UTOP_SUPPORT      CHIP_SUPPORT(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0)
N#define TCP_SUPPORT       CHIP_SUPPORT(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0)
N#define VCP_SUPPORT       CHIP_SUPPORT(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,1,0)
N#define EMAC_SUPPORT      CHIP_SUPPORT(0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0)
N#define MDIO_SUPPORT      CHIP_SUPPORT(0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0)
N#define EMU_SUPPORT	  CHIP_SUPPORT(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0)
N                                                                                       
N#define L2CACHE_SUPPORT   CHIP_SUPPORT(0,0,0,0,0,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0)
N#define TC_SUPPORT        CHIP_SUPPORT(0,0,0,0,0,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0)
N#define FPU_SUPPORT       CHIP_SUPPORT(0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,1,1,0,0,0,0,0)
N#define C01_SUPPORT       CHIP_SUPPORT(1,1,1,1,1,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0)
N#define C11_SUPPORT       CHIP_SUPPORT(0,0,0,0,0,1,0,1,1,1,1,0,0,0,0,0,0,0,1,1,0,0,0,0,0)
N#define C64_SUPPORT       CHIP_SUPPORT(0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,1,1,1,1,0)
N#define ATL_SUPPORT       CHIP_SUPPORT(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0)
N
N#define CACHE_L2_SUPPORT  L2CACHE_SUPPORT
N/*----------------------------------------------------------------------*/
N
N
N/******************************************************************************\
N* module level register/field access macros
X
N\******************************************************************************/
N
N  /* ----------------- */
N  /* FIELD MAKE MACROS */
N  /* ----------------- */
N
N  #define CHIP_FMK(REG,FIELD,x)\
N    _PER_FMK(CHIP,##REG,##FIELD,x)
X  #define CHIP_FMK(REG,FIELD,x)    _PER_FMK(CHIP,##REG,##FIELD,x)
N
N  #define CHIP_FMKS(REG,FIELD,SYM)\
N    _PER_FMKS(CHIP,##REG,##FIELD,##SYM)
X  #define CHIP_FMKS(REG,FIELD,SYM)    _PER_FMKS(CHIP,##REG,##FIELD,##SYM)
N
N
N  /* -------------------------------- */
N  /* RAW REGISTER/FIELD ACCESS MACROS */
N  /* -------------------------------- */
N
N  #define CHIP_CRGET(REG)\
N    _PER_CRGET(CHIP,##REG)
X  #define CHIP_CRGET(REG)    _PER_CRGET(CHIP,##REG)
N
N  #define CHIP_CRSET(REG,x)\
N    _PER_CRSET(CHIP,##REG,x)
X  #define CHIP_CRSET(REG,x)    _PER_CRSET(CHIP,##REG,x)
N
N  #define CHIP_RGET(REG)\
N   _PER_RGET(_CHIP_##REG##_ADDR,CHIP,##REG)
X  #define CHIP_RGET(REG)   _PER_RGET(_CHIP_##REG##_ADDR,CHIP,##REG)
N
N  #define CHIP_RSET(REG,x)\
N     _PER_RSET(_CHIP_##REG##_ADDR,CHIP,##REG,x)
X  #define CHIP_RSET(REG,x)     _PER_RSET(_CHIP_##REG##_ADDR,CHIP,##REG,x)
N
N
N  #define CHIP_FGET(REG,FIELD)\
N    _CHIP_##REG##_FGET(##FIELD)
X  #define CHIP_FGET(REG,FIELD)    _CHIP_##REG##_FGET(##FIELD)
N
N  #define CHIP_FSET(REG,FIELD,x)\
N    _CHIP_##REG##_FSET(##FIELD,x)
X  #define CHIP_FSET(REG,FIELD,x)    _CHIP_##REG##_FSET(##FIELD,x)
N
N  #define CHIP_FSETS(REG,FIELD,SYM)\
N    _CHIP_##REG##_FSETS(##FIELD,##SYM)
X  #define CHIP_FSETS(REG,FIELD,SYM)    _CHIP_##REG##_FSETS(##FIELD,##SYM)
N
N
N/******************************************************************************\
N* _____________________
X
N* |                   |
N* |  C S R            |
N* |___________________|
N*
N* CSR - control/status register
N*
N* FIELDS (msb -> lsb)
N* (r)  CPUID
N* (r)  REVID
N* (rw) PWRD
N* (rc) SAT
N* (r)  EN
N* (rw) PCC
N* (rw) DCC
N* (rw) PGIE
N* (rw) GIE
N*
N\******************************************************************************/
N  extern far cregister volatile unsigned int CSR;
N
N  #define _CHIP_CSR_CPUID_MASK         0xFF000000u
N  #define _CHIP_CSR_CPUID_SHIFT        0x00000018u
N  #define  CHIP_CSR_CPUID_DEFAULT      0x00000000u
N  #define  CHIP_CSR_CPUID_OF(x)        _VALUEOF(x)
N  #define  CHIP_CSR_CPUID_C62X         0x00000000u
N  #define  CHIP_CSR_CPUID_C67X         0x00000002u
N  #define  CHIP_CSR_CPUID_C64X         0x00000004u
N
N  #define _CHIP_CSR_REVID_MASK         0x00FF0000u
N  #define _CHIP_CSR_REVID_SHIFT        0x00000010u
N  #define  CHIP_CSR_REVID_DEFAULT      0x00000000u
N  #define  CHIP_CSR_REVID_OF(x)        _VALUEOF(x)
N  #define  CHIP_CSR_REVID_620120       0x00000001u
N  #define  CHIP_CSR_REVID_620121       0x00000001u
N  #define  CHIP_CSR_REVID_620130       0x00000002u
N  #define  CHIP_CSR_REVID_670100       0x00000201u
N  #define  CHIP_CSR_REVID_670110       0x00000202u
N  #define  CHIP_CSR_REVID_621110       0x00000002u
N  #define  CHIP_CSR_REVID_640010       0x00000801u
N  #define  CHIP_CSR_REVID_6202         0x00000002u
N  #define  CHIP_CSR_REVID_6202B        0x00000003u
N  #define  CHIP_CSR_REVID_6711         0x00000002u
N  #define  CHIP_CSR_REVID_6711C        0x00000003u
N  #define  CHIP_CSR_REVID_6712         0x00000002u
N  #define  CHIP_CSR_REVID_6712C        0x00000003u
N
N  #define _CHIP_CSR_PWRD_MASK          0x0000FC00u
N  #define _CHIP_CSR_PWRD_SHIFT         0x0000000Au
N  #define  CHIP_CSR_PWRD_DEFAULT       0x00000000u
N  #define  CHIP_CSR_PWRD_OF(x)         _VALUEOF(x)
N  #define  CHIP_CSR_PWRD_NONE          0x00000000u
N  #define  CHIP_CSR_PWRD_PD1A          0x00000009u
N  #define  CHIP_CSR_PWRD_PD1B          0x00000011u
N  #define  CHIP_CSR_PWRD_PD2           0x0000001Au
N  #define  CHIP_CSR_PWRD_PD3           0x0000001Cu
N
N  #define _CHIP_CSR_SAT_MASK           0x00000200u
N  #define _CHIP_CSR_SAT_SHIFT          0x00000009u
N  #define  CHIP_CSR_SAT_DEFAULT        0x00000000u
N  #define  CHIP_CSR_SAT_OF(x)          _VALUEOF(x)
N  #define  CHIP_CSR_SAT_0              0x00000000u
N  #define  CHIP_CSR_SAT_1              0x00000001u
N
N  #define _CHIP_CSR_EN_MASK            0x00000100u
N  #define _CHIP_CSR_EN_SHIFT           0x00000008u
N  #define  CHIP_CSR_EN_DEFAULT         0x00000000u
N  #define  CHIP_CSR_EN_OF(x)           _VALUEOF(x)
N  #define  CHIP_CSR_EN_BIG             0x00000000u
N  #define  CHIP_CSR_EN_LITTLE          0x00000001u
N
N  #define _CHIP_CSR_PCC_MASK           0x000000E0u
N  #define _CHIP_CSR_PCC_SHIFT          0x00000005u
N  #define  CHIP_CSR_PCC_DEFAULT        0x00000000u
N  #define  CHIP_CSR_PCC_OF(x)          _VALUEOF(x)
N  #define  CHIP_CSR_PCC_MAPPED         0x00000000u
N  #define  CHIP_CSR_PCC_ENABLE         0x00000002u
N  #define  CHIP_CSR_PCC_FREEZE         0x00000003u
N  #define  CHIP_CSR_PCC_BYPASS         0x00000004u
N
N  #define _CHIP_CSR_DCC_MASK           0x0000001Cu
N  #define _CHIP_CSR_DCC_SHIFT          0x00000002u
N  #define  CHIP_CSR_DCC_DEFAULT        0x00000000u
N  #define  CHIP_CSR_DCC_OF(x)          _VALUEOF(x)
N  #define  CHIP_CSR_DCC_MAPPED         0x00000000u
N  #define  CHIP_CSR_DCC_ENABLE         0x00000002u
N  #define  CHIP_CSR_DCC_FREEZE         0x00000003u
N  #define  CHIP_CSR_DCC_BYPASS         0x00000004u
N
N  #define _CHIP_CSR_PGIE_MASK          0x00000002u
N  #define _CHIP_CSR_PGIE_SHIFT         0x00000001u
N  #define  CHIP_CSR_PGIE_DEFAULT       0x00000000u
N  #define  CHIP_CSR_PGIE_OF(x)         _VALUEOF(x)
N  #define  CHIP_CSR_PGIE_0             0x00000000u
N  #define  CHIP_CSR_PGIE_1             0x00000001u
N
N  #define _CHIP_CSR_GIE_MASK           0x00000001u
N  #define _CHIP_CSR_GIE_SHIFT          0x00000000u
N  #define  CHIP_CSR_GIE_DEFAULT        0x00000000u
N  #define  CHIP_CSR_GIE_OF(x)          _VALUEOF(x)
N  #define  CHIP_CSR_GIE_0              0x00000000u
N  #define  CHIP_CSR_GIE_1              0x00000001u
N
N  #define  CHIP_CSR_OF(x)              _VALUEOF(x)
N
N  #define CHIP_CSR_DEFAULT (Uint32)( \
N     _PER_FDEFAULT(CHIP,CSR,CPUID) \
N    |_PER_FDEFAULT(CHIP,CSR,REVID) \
N    |_PER_FDEFAULT(CHIP,CSR,PWRD) \
N    |_PER_FDEFAULT(CHIP,CSR,SAT) \
N    |_PER_FDEFAULT(CHIP,CSR,EN) \
N    |_PER_FDEFAULT(CHIP,CSR,PCC) \
N    |_PER_FDEFAULT(CHIP,CSR,DCC) \
N    |_PER_FDEFAULT(CHIP,CSR,PGIE) \
N    |_PER_FDEFAULT(CHIP,CSR,GIE) \
N  )
X  #define CHIP_CSR_DEFAULT (Uint32)(      _PER_FDEFAULT(CHIP,CSR,CPUID)     |_PER_FDEFAULT(CHIP,CSR,REVID)     |_PER_FDEFAULT(CHIP,CSR,PWRD)     |_PER_FDEFAULT(CHIP,CSR,SAT)     |_PER_FDEFAULT(CHIP,CSR,EN)     |_PER_FDEFAULT(CHIP,CSR,PCC)     |_PER_FDEFAULT(CHIP,CSR,DCC)     |_PER_FDEFAULT(CHIP,CSR,PGIE)     |_PER_FDEFAULT(CHIP,CSR,GIE)   )
N
N  #define CHIP_CSR_RMK(pwrd,pcc,dcc,pgie,gie) (Uint32)( \
N     _PER_FMK(CHIP,CSR,PWRD,pwrd) \
N    |_PER_FMK(CHIP,CSR,PCC,pcc) \
N    |_PER_FMK(CHIP,CSR,DCC,dcc) \
N    |_PER_FMK(CHIP,CSR,PGIE,pgie) \
N    |_PER_FMK(CHIP,CSR,GIE,gie) \
N  )
X  #define CHIP_CSR_RMK(pwrd,pcc,dcc,pgie,gie) (Uint32)(      _PER_FMK(CHIP,CSR,PWRD,pwrd)     |_PER_FMK(CHIP,CSR,PCC,pcc)     |_PER_FMK(CHIP,CSR,DCC,dcc)     |_PER_FMK(CHIP,CSR,PGIE,pgie)     |_PER_FMK(CHIP,CSR,GIE,gie)   )
N
N  #define _CHIP_CSR_FGET(FIELD)\
N    _PER_CFGET(CHIP,CSR,##FIELD)
X  #define _CHIP_CSR_FGET(FIELD)    _PER_CFGET(CHIP,CSR,##FIELD)
N
N  #define _CHIP_CSR_FSET(FIELD,field)\
N    _PER_CFSET(CHIP,CSR,##FIELD,field)
X  #define _CHIP_CSR_FSET(FIELD,field)    _PER_CFSET(CHIP,CSR,##FIELD,field)
N
N  #define _CHIP_CSR_FSETS(FIELD,SYM)\
N    _PER_CFSETS(CHIP,CSR,##FIELD,##SYM)
X  #define _CHIP_CSR_FSETS(FIELD,SYM)    _PER_CFSETS(CHIP,CSR,##FIELD,##SYM)
N
N
N/******************************************************************************\
N* _____________________
X
N* |                   |
N* |  I F R            |
N* |___________________|
N*
N* IFR - interruppt flag register
N*
N* FIELDS (msb -> lsb)
N* (rw) IF
N*
N\******************************************************************************/
N  extern far cregister volatile unsigned int IFR;
N
N  #define _CHIP_IFR_IF_MASK          0x0000FFFFu
N  #define _CHIP_IFR_IF_SHIFT         0x00000000u
N  #define  CHIP_IFR_IF_DEFAULT       0x00000000u
N  #define  CHIP_IFR_IF_OF(x)         _VALUEOF(x)
N
N  #define  CHIP_IFR_OF(x)            _VALUEOF(x)
N
N  #define CHIP_IFR_DEFAULT (Uint32)( \
N     _PER_FDEFAULT(CHIP,IFR,IF)\
N  )
X  #define CHIP_IFR_DEFAULT (Uint32)(      _PER_FDEFAULT(CHIP,IFR,IF)  )
N
N  #define CHIP_IFR_RMK(if) (Uint32)( \
N     _PER_FMK(CHIP,IFR,IF,if)\
N  )
X  #define CHIP_IFR_RMK(if) (Uint32)(      _PER_FMK(CHIP,IFR,IF,if)  )
N
N  #define _CHIP_IFR_FGET(FIELD)\
N    _PER_CFGET(CHIP,IFR,##FIELD)
X  #define _CHIP_IFR_FGET(FIELD)    _PER_CFGET(CHIP,IFR,##FIELD)
N
N  #define _CHIP_IFR_FSET(FIELD,field)\
N    _PER_CFSET(CHIP,IFR,##FIELD,field)
X  #define _CHIP_IFR_FSET(FIELD,field)    _PER_CFSET(CHIP,IFR,##FIELD,field)
N
N  #define _CHIP_IFR_FSETS(FIELD,SYM)\
N    _PER_CFSETS(CHIP,IFR,##FIELD,##SYM)
X  #define _CHIP_IFR_FSETS(FIELD,SYM)    _PER_CFSETS(CHIP,IFR,##FIELD,##SYM)
N
N
N/******************************************************************************\
N* _____________________
X
N* |                   |
N* |  I S R            |
N* |___________________|
N*
N* ISR - interruppt set register
N*
N* FIELDS (msb -> lsb)
N* (w) IS
N*
N\******************************************************************************/
N  extern far cregister volatile unsigned int ISR;
N
N  #define _CHIP_ISR_IS_MASK          0x0000FFFFu
N  #define _CHIP_ISR_IS_SHIFT         0x00000000u
N  #define  CHIP_ISR_IS_DEFAULT       0x00000000u
N  #define  CHIP_ISR_IS_OF(x)         _VALUEOF(x)
N
N  #define  CHIP_ISR_OF(x)            _VALUEOF(x)
N
N  #define CHIP_ISR_DEFAULT (Uint32)( \
N     _PER_FDEFAULT(CHIP,ISR,IS)\
N  )
X  #define CHIP_ISR_DEFAULT (Uint32)(      _PER_FDEFAULT(CHIP,ISR,IS)  )
N
N  #define CHIP_ISR_RMK(is) (Uint32)( \
N     _PER_FMK(CHIP,ISR,IS,is)\
N  )
X  #define CHIP_ISR_RMK(is) (Uint32)(      _PER_FMK(CHIP,ISR,IS,is)  )
N
N  #define _CHIP_ISR_FGET(FIELD)\
N    _PER_CFGET(CHIP,ISR,##FIELD)
X  #define _CHIP_ISR_FGET(FIELD)    _PER_CFGET(CHIP,ISR,##FIELD)
N
N  #define _CHIP_ISR_FSET(FIELD,field)\
N    _PER_CFSET(CHIP,ISR,##FIELD,field)
X  #define _CHIP_ISR_FSET(FIELD,field)    _PER_CFSET(CHIP,ISR,##FIELD,field)
N
N  #define _CHIP_ISR_FSETS(FIELD,SYM)\
N    _PER_CFSETS(CHIP,ISR,##FIELD,##SYM)
X  #define _CHIP_ISR_FSETS(FIELD,SYM)    _PER_CFSETS(CHIP,ISR,##FIELD,##SYM)
N
N
N/******************************************************************************\
N* _____________________
X
N* |                   |
N* |  I C R            |
N* |___________________|
N*
N* ICR - interruppt clear register
N*
N* FIELDS (msb -> lsb)
N* (w) IC
N*
N\******************************************************************************/
N  extern far cregister volatile unsigned int ICR;
N
N  #define _CHIP_ICR_IC_MASK          0x0000FFFFu
N  #define _CHIP_ICR_IC_SHIFT         0x00000000u
N  #define  CHIP_ICR_IC_DEFAULT       0x00000000u
N  #define  CHIP_ICR_IC_OF(x)         _VALUEOF(x)
N
N  #define  CHIP_ICR_OF(x)            _VALUEOF(x)
N
N  #define CHIP_ICR_DEFAULT (Uint32)( \
N     _PER_FDEFAULT(CHIP,ICR,IC)\
N  )
X  #define CHIP_ICR_DEFAULT (Uint32)(      _PER_FDEFAULT(CHIP,ICR,IC)  )
N
N  #define CHIP_ICR_RMK(ic) (Uint32)( \
N     _PER_FMK(CHIP,ICR,IC,ic)\
N  )
X  #define CHIP_ICR_RMK(ic) (Uint32)(      _PER_FMK(CHIP,ICR,IC,ic)  )
N
N  #define _CHIP_ICR_FGET(FIELD)\
N    _PER_CFGET(CHIP,ICR,##FIELD)
X  #define _CHIP_ICR_FGET(FIELD)    _PER_CFGET(CHIP,ICR,##FIELD)
N
N  #define _CHIP_ICR_FSET(FIELD,field)\
N    _PER_CFSET(CHIP,ICR,##FIELD,field)
X  #define _CHIP_ICR_FSET(FIELD,field)    _PER_CFSET(CHIP,ICR,##FIELD,field)
N
N  #define _CHIP_ICR_FSETS(FIELD,SYM)\
N    _PER_CFSETS(CHIP,ICR,##FIELD,##SYM)
X  #define _CHIP_ICR_FSETS(FIELD,SYM)    _PER_CFSETS(CHIP,ICR,##FIELD,##SYM)
N
N
N/******************************************************************************\
N* _____________________
X
N* |                   |
N* |  I E R            |
N* |___________________|
N*
N* IER - interruppt enable register
N*
N* FIELDS (msb -> lsb)
N* (rw) IE
N*
N\******************************************************************************/
N  extern far cregister volatile unsigned int IER;
N
N  #define _CHIP_IER_IE_MASK          0x0000FFFFu
N  #define _CHIP_IER_IE_SHIFT         0x00000000u
N  #define  CHIP_IER_IE_DEFAULT       0x00000000u
N  #define  CHIP_IER_IE_OF(x)         _VALUEOF(x)
N
N  #define  CHIP_IER_OF(x)            _VALUEOF(x)
N
N  #define CHIP_IER_DEFAULT (Uint32)( \
N     _PER_FDEFAULT(CHIP,IER,IE)\
N  )
X  #define CHIP_IER_DEFAULT (Uint32)(      _PER_FDEFAULT(CHIP,IER,IE)  )
N
N  #define CHIP_IER_RMK(ie) (Uint32)( \
N     _PER_FMK(CHIP,IER,IE,ie)\
N  )
X  #define CHIP_IER_RMK(ie) (Uint32)(      _PER_FMK(CHIP,IER,IE,ie)  )
N
N  #define _CHIP_IER_FGET(FIELD)\
N    _PER_CFGET(CHIP,IER,##FIELD)
X  #define _CHIP_IER_FGET(FIELD)    _PER_CFGET(CHIP,IER,##FIELD)
N
N  #define _CHIP_IER_FSET(FIELD,field)\
N    _PER_CFSET(CHIP,IER,##FIELD,field)
X  #define _CHIP_IER_FSET(FIELD,field)    _PER_CFSET(CHIP,IER,##FIELD,field)
N
N  #define _CHIP_IER_FSETS(FIELD,SYM)\
N    _PER_CFSETS(CHIP,IER,##FIELD,##SYM)
X  #define _CHIP_IER_FSETS(FIELD,SYM)    _PER_CFSETS(CHIP,IER,##FIELD,##SYM)
N
N
N/******************************************************************************\
N* _____________________
X
N* |                   |
N* |  I S T P          |
N* |___________________|
N*
N* ISTP - interrupt service table pointer
N*
N* FIELDS (msb -> lsb)
N* (r)   HPEINT
N* (rw)  ISTB
N*
N\******************************************************************************/
N  extern far cregister volatile unsigned int ISTP;
N
N  #define _CHIP_ISTP_ISTB_MASK         0xFFFFFC00u
N  #define _CHIP_ISTP_ISTB_SHIFT        0x0000000Au
N  #define  CHIP_ISTP_ISTB_DEFAULT      0x00000000u
N  #define  CHIP_ISTP_ISTB_OF(x)        _VALUEOF(x)
N
N  #define _CHIP_ISTP_HPEINT_MASK       0x000003E0u
N  #define _CHIP_ISTP_HPEINT_SHIFT      0x00000005u
N  #define  CHIP_ISTP_HPEINT_DEFAULT    0x00000000u
N  #define  CHIP_ISTP_HPEINT_OF(x)      _VALUEOF(x)
N
N  #define  CHIP_ISTP_OF(x)             _VALUEOF(x)
N
N  #define CHIP_ISTP_DEFAULT (Uint32)( \
N     _PER_FDEFAULT(CHIP,ISTP,ISTB)\
N    |_PER_FDEFAULT(CHIP,ISTP,HPEINT)\
N  )
X  #define CHIP_ISTP_DEFAULT (Uint32)(      _PER_FDEFAULT(CHIP,ISTP,ISTB)    |_PER_FDEFAULT(CHIP,ISTP,HPEINT)  )
N
N  #define CHIP_ISTP_RMK(istb) (Uint32)( \
N     _PER_FMK(CHIP,ISTP,ISTB,istb)\
N  )
X  #define CHIP_ISTP_RMK(istb) (Uint32)(      _PER_FMK(CHIP,ISTP,ISTB,istb)  )
N
N  #define _CHIP_ISTP_FGET(FIELD)\
N    _PER_CFGET(CHIP,ISTP,##FIELD)
X  #define _CHIP_ISTP_FGET(FIELD)    _PER_CFGET(CHIP,ISTP,##FIELD)
N
N  #define _CHIP_ISTP_FSET(FIELD,field)\
N    _PER_CFSET(CHIP,ISTP,##FIELD,field)
X  #define _CHIP_ISTP_FSET(FIELD,field)    _PER_CFSET(CHIP,ISTP,##FIELD,field)
N
N  #define _CHIP_ISTP_FSETS(FIELD,SYM)\
N    _PER_CFSETS(CHIP,ISTP,##FIELD,##SYM)
X  #define _CHIP_ISTP_FSETS(FIELD,SYM)    _PER_CFSETS(CHIP,ISTP,##FIELD,##SYM)
N
N
N/******************************************************************************\
N* _____________________
X
N* |                   |
N* |  I R P            |
N* |___________________|
N*
N* IRP - interrupt return pointer
N*
N* FIELDS (msb -> lsb)
N* (rw) IRP
N*
N\******************************************************************************/
N  extern far cregister volatile unsigned int IRP;
N
N  #define _CHIP_IRP_IRP_MASK           0xFFFFFFFFu
N  #define _CHIP_IRP_IRP_SHIFT          0x00000000u
N  #define  CHIP_IRP_IRP_DEFAULT        0x00000000u
N  #define  CHIP_IRP_IRP_OF(x)          _VALUEOF(x)
N
N  #define  CHIP_IRP_OF(x)              _VALUEOF(x)
N
N  #define CHIP_IRP_DEFAULT (Uint32)( \
N     _PER_FDEFAULT(CHIP,IRP,IRP)\
N  )
X  #define CHIP_IRP_DEFAULT (Uint32)(      _PER_FDEFAULT(CHIP,IRP,IRP)  )
N
N  #define CHIP_IRP_RMK(irp) (Uint32)( \
N     _PER_FMK(CHIP,IRP,IRP,irp)\
N  )
X  #define CHIP_IRP_RMK(irp) (Uint32)(      _PER_FMK(CHIP,IRP,IRP,irp)  )
N
N  #define _CHIP_IRP_FGET(FIELD)\
N    _PER_CFGET(CHIP,IRP,##FIELD)
X  #define _CHIP_IRP_FGET(FIELD)    _PER_CFGET(CHIP,IRP,##FIELD)
N
N  #define _CHIP_IRP_FSET(FIELD,field)\
N    _PER_CFSET(CHIP,IRP,##FIELD,field)
X  #define _CHIP_IRP_FSET(FIELD,field)    _PER_CFSET(CHIP,IRP,##FIELD,field)
N
N  #define _CHIP_IRP_FSETS(FIELD,SYM)\
N    _PER_CFSETS(CHIP,IRP,##FIELD,##SYM)
X  #define _CHIP_IRP_FSETS(FIELD,SYM)    _PER_CFSETS(CHIP,IRP,##FIELD,##SYM)
N
N
N/******************************************************************************\
N* _____________________
X
N* |                   |
N* |  N R P            |
N* |___________________|
N*
N* NRP - non-maskable interrupt return pointer
N*
N* FIELDS (msb -> lsb)
N* (rw) NRP
N*
N\******************************************************************************/
N  extern far cregister volatile unsigned int NRP;
N
N  #define _CHIP_NRP_NRP_MASK           0xFFFFFFFFu
N  #define _CHIP_NRP_NRP_SHIFT          0x00000000u
N  #define  CHIP_NRP_NRP_DEFAULT        0x00000000u
N  #define  CHIP_NRP_NRP_OF(x)          _VALUEOF(x)
N
N  #define  CHIP_NRP_OF(x)              _VALUEOF(x)
N
N  #define CHIP_NRP_DEFAULT (Uint32)( \
N     _PER_FDEFAULT(CHIP,NRP,NRP)\
N  )
X  #define CHIP_NRP_DEFAULT (Uint32)(      _PER_FDEFAULT(CHIP,NRP,NRP)  )
N
N  #define CHIP_NRP_RMK(nrp) (Uint32)( \
N     _PER_FMK(CHIP,NRP,NRP,nrp)\
N  )
X  #define CHIP_NRP_RMK(nrp) (Uint32)(      _PER_FMK(CHIP,NRP,NRP,nrp)  )
N
N  #define _CHIP_NRP_FGET(FIELD)\
N    _PER_CFGET(CHIP,NRP,##FIELD)
X  #define _CHIP_NRP_FGET(FIELD)    _PER_CFGET(CHIP,NRP,##FIELD)
N
N  #define _CHIP_NRP_FSET(FIELD,field)\
N    _PER_CFSET(CHIP,NRP,##FIELD,field)
X  #define _CHIP_NRP_FSET(FIELD,field)    _PER_CFSET(CHIP,NRP,##FIELD,field)
N
N  #define _CHIP_NRP_FSETS(FIELD,SYM)\
N    _PER_CFSETS(CHIP,NRP,##FIELD,##SYM)
X  #define _CHIP_NRP_FSETS(FIELD,SYM)    _PER_CFSETS(CHIP,NRP,##FIELD,##SYM)
N
N
N/******************************************************************************\
N* _____________________
X
N* |                   |
N* |  A M R            |
N* |___________________|
N*
N* AMR - addressing mode register
N*
N* FIELDS (msb -> lsb)
N* (rw) BK1
N* (rw) BK0
N* (rw) B7MODE
N* (rw) B6MODE
N* (rw) B5MODE
N* (rw) B4MODE
N* (rw) A7MODE
N* (rw) A6MODE
N* (rw) A5MODE
N* (rw) A4MODE
N*
N\******************************************************************************/
N  extern far cregister volatile unsigned int AMR;
N
N  #define _CHIP_AMR_BK1_MASK           0x02E00000u
N  #define _CHIP_AMR_BK1_SHIFT          0x00000015u
N  #define  CHIP_AMR_BK1_DEFAULT        0x00000000u
N  #define  CHIP_AMR_BK1_OF(x)          _VALUEOF(x)
N  #define  CHIP_AMR_BK1_2              0x00000000u
N  #define  CHIP_AMR_BK1_4              0x00000001u
N  #define  CHIP_AMR_BK1_8              0x00000002u
N  #define  CHIP_AMR_BK1_16             0x00000003u
N  #define  CHIP_AMR_BK1_32             0x00000004u
N  #define  CHIP_AMR_BK1_64             0x00000005u
N  #define  CHIP_AMR_BK1_128            0x00000006u
N  #define  CHIP_AMR_BK1_256            0x00000007u
N  #define  CHIP_AMR_BK1_512            0x00000008u
N  #define  CHIP_AMR_BK1_1K             0x00000009u
N  #define  CHIP_AMR_BK1_2K             0x0000000Au
N  #define  CHIP_AMR_BK1_4K             0x0000000Bu
N  #define  CHIP_AMR_BK1_8K             0x0000000Cu
N  #define  CHIP_AMR_BK1_16K            0x0000000Du
N  #define  CHIP_AMR_BK1_32K            0x0000000Eu
N  #define  CHIP_AMR_BK1_64K            0x0000000Fu
N  #define  CHIP_AMR_BK1_128K           0x00000010u
N  #define  CHIP_AMR_BK1_256K           0x00000011u
N  #define  CHIP_AMR_BK1_512K           0x00000012u
N  #define  CHIP_AMR_BK1_1M             0x00000013u
N  #define  CHIP_AMR_BK1_2M             0x00000014u
N  #define  CHIP_AMR_BK1_4M             0x00000015u
N  #define  CHIP_AMR_BK1_8M             0x00000016u
N  #define  CHIP_AMR_BK1_16M            0x00000017u
N  #define  CHIP_AMR_BK1_32M            0x00000018u
N  #define  CHIP_AMR_BK1_64M            0x00000019u
N  #define  CHIP_AMR_BK1_128M           0x0000001Au
N  #define  CHIP_AMR_BK1_256M           0x0000001Bu
N  #define  CHIP_AMR_BK1_512M           0x0000001Cu
N  #define  CHIP_AMR_BK1_1G             0x0000001Du
N  #define  CHIP_AMR_BK1_2G             0x0000001Eu
N  #define  CHIP_AMR_BK1_4G             0x0000001Fu
N
N  #define _CHIP_AMR_BK0_MASK           0x001F0000u
N  #define _CHIP_AMR_BK0_SHIFT          0x00000010u
N  #define  CHIP_AMR_BK0_DEFAULT        0x00000000u
N  #define  CHIP_AMR_BK0_OF(x)          _VALUEOF(x)
N  #define  CHIP_AMR_BK0_2              0x00000000u
N  #define  CHIP_AMR_BK0_4              0x00000001u
N  #define  CHIP_AMR_BK0_8              0x00000002u
N  #define  CHIP_AMR_BK0_16             0x00000003u
N  #define  CHIP_AMR_BK0_32             0x00000004u
N  #define  CHIP_AMR_BK0_64             0x00000005u
N  #define  CHIP_AMR_BK0_128            0x00000006u
N  #define  CHIP_AMR_BK0_256            0x00000007u
N  #define  CHIP_AMR_BK0_512            0x00000008u
N  #define  CHIP_AMR_BK0_1K             0x00000009u
N  #define  CHIP_AMR_BK0_2K             0x0000000Au
N  #define  CHIP_AMR_BK0_4K             0x0000000Bu
N  #define  CHIP_AMR_BK0_8K             0x0000000Cu
N  #define  CHIP_AMR_BK0_16K            0x0000000Du
N  #define  CHIP_AMR_BK0_32K            0x0000000Eu
N  #define  CHIP_AMR_BK0_64K            0x0000000Fu
N  #define  CHIP_AMR_BK0_128K           0x00000010u
N  #define  CHIP_AMR_BK0_256K           0x00000011u
N  #define  CHIP_AMR_BK0_512K           0x00000012u
N  #define  CHIP_AMR_BK0_1M             0x00000013u
N  #define  CHIP_AMR_BK0_2M             0x00000014u
N  #define  CHIP_AMR_BK0_4M             0x00000015u
N  #define  CHIP_AMR_BK0_8M             0x00000016u
N  #define  CHIP_AMR_BK0_16M            0x00000017u
N  #define  CHIP_AMR_BK0_32M            0x00000018u
N  #define  CHIP_AMR_BK0_64M            0x00000019u
N  #define  CHIP_AMR_BK0_128M           0x0000001Au
N  #define  CHIP_AMR_BK0_256M           0x0000001Bu
N  #define  CHIP_AMR_BK0_512M           0x0000001Cu
N  #define  CHIP_AMR_BK0_1G             0x0000001Du
N  #define  CHIP_AMR_BK0_2G             0x0000001Eu
N  #define  CHIP_AMR_BK0_4G             0x0000001Fu
N
N
N  #define _CHIP_AMR_B7MODE_MASK        0x0000C000u
N  #define _CHIP_AMR_B7MODE_SHIFT       0x0000000Eu
N  #define  CHIP_AMR_B7MODE_DEFAULT     0x00000000u
N  #define  CHIP_AMR_B7MODE_OF(x)       _VALUEOF(x)
N  #define  CHIP_AMR_B7MODE_LINEAR      0x00000000u
N  #define  CHIP_AMR_B7MODE_CIRCULAR0   0x00000001u
N  #define  CHIP_AMR_B7MODE_CIRCULAR1   0x00000002u
N
N  #define _CHIP_AMR_B6MODE_MASK        0x00003000u
N  #define _CHIP_AMR_B6MODE_SHIFT       0x0000000Cu
N  #define  CHIP_AMR_B6MODE_DEFAULT     0x00000000u
N  #define  CHIP_AMR_B6MODE_OF(x)       _VALUEOF(x)
N  #define  CHIP_AMR_B6MODE_LINEAR      0x00000000u
N  #define  CHIP_AMR_B6MODE_CIRCULAR0   0x00000001u
N  #define  CHIP_AMR_B6MODE_CIRCULAR1   0x00000002u
N
N  #define _CHIP_AMR_B5MODE_MASK        0x00000C00u
N  #define _CHIP_AMR_B5MODE_SHIFT       0x0000000Au
N  #define  CHIP_AMR_B5MODE_DEFAULT     0x00000000u
N  #define  CHIP_AMR_B5MODE_OF(x)       _VALUEOF(x)
N  #define  CHIP_AMR_B5MODE_LINEAR      0x00000000u
N  #define  CHIP_AMR_B5MODE_CIRCULAR0   0x00000001u
N  #define  CHIP_AMR_B5MODE_CIRCULAR1   0x00000002u
N
N  #define _CHIP_AMR_B4MODE_MASK        0x00000300u
N  #define _CHIP_AMR_B4MODE_SHIFT       0x00000008u
N  #define  CHIP_AMR_B4MODE_DEFAULT     0x00000000u
N  #define  CHIP_AMR_B4MODE_OF(x)       _VALUEOF(x)
N  #define  CHIP_AMR_B4MODE_LINEAR      0x00000000u
N  #define  CHIP_AMR_B4MODE_CIRCULAR0   0x00000001u
N  #define  CHIP_AMR_B4MODE_CIRCULAR1   0x00000002u
N
N  #define _CHIP_AMR_A7MODE_MASK        0x000000C0u
N  #define _CHIP_AMR_A7MODE_SHIFT       0x00000006u
N  #define  CHIP_AMR_A7MODE_DEFAULT     0x00000000u
N  #define  CHIP_AMR_A7MODE_OF(x)       _VALUEOF(x)
N  #define  CHIP_AMR_A7MODE_LINEAR      0x00000000u
N  #define  CHIP_AMR_A7MODE_CIRCULAR0   0x00000001u
N  #define  CHIP_AMR_A7MODE_CIRCULAR1   0x00000002u
N
N  #define _CHIP_AMR_A6MODE_MASK        0x00000030u
N  #define _CHIP_AMR_A6MODE_SHIFT       0x00000004u
N  #define  CHIP_AMR_A6MODE_DEFAULT     0x00000000u
N  #define  CHIP_AMR_A6MODE_OF(x)       _VALUEOF(x)
N  #define  CHIP_AMR_A6MODE_LINEAR      0x00000000u
N  #define  CHIP_AMR_A6MODE_CIRCULAR0   0x00000001u
N  #define  CHIP_AMR_A6MODE_CIRCULAR1   0x00000002u
N
N  #define _CHIP_AMR_A5MODE_MASK        0x0000000Cu
N  #define _CHIP_AMR_A5MODE_SHIFT       0x00000002u
N  #define  CHIP_AMR_A5MODE_DEFAULT     0x00000000u
N  #define  CHIP_AMR_A5MODE_OF(x)       _VALUEOF(x)
N  #define  CHIP_AMR_A5MODE_LINEAR      0x00000000u
N  #define  CHIP_AMR_A5MODE_CIRCULAR0   0x00000001u
N  #define  CHIP_AMR_A5MODE_CIRCULAR1   0x00000002u
N
N  #define _CHIP_AMR_A4MODE_MASK        0x00000003u
N  #define _CHIP_AMR_A4MODE_SHIFT       0x00000000u
N  #define  CHIP_AMR_A4MODE_DEFAULT     0x00000000u
N  #define  CHIP_AMR_A4MODE_OF(x)       _VALUEOF(x)
N  #define  CHIP_AMR_A4MODE_LINEAR      0x00000000u
N  #define  CHIP_AMR_A4MODE_CIRCULAR0   0x00000001u
N  #define  CHIP_AMR_A4MODE_CIRCULAR1   0x00000002u
N
N  #define  CHIP_AMR_OF(x)              _VALUEOF(x)
N
N  #define CHIP_AMR_DEFAULT (Uint32)( \
N     _PER_FDEFAULT(CHIP,AMR,BK1)\
N    |_PER_FDEFAULT(CHIP,AMR,BK0)\
N    |_PER_FDEFAULT(CHIP,AMR,B7MODE)\
N    |_PER_FDEFAULT(CHIP,AMR,B6MODE)\
N    |_PER_FDEFAULT(CHIP,AMR,B5MODE)\
N    |_PER_FDEFAULT(CHIP,AMR,B4MODE)\
N    |_PER_FDEFAULT(CHIP,AMR,A7MODE)\
N    |_PER_FDEFAULT(CHIP,AMR,A6MODE)\
N    |_PER_FDEFAULT(CHIP,AMR,A5MODE)\
N    |_PER_FDEFAULT(CHIP,AMR,A4MODE)\
N  )
X  #define CHIP_AMR_DEFAULT (Uint32)(      _PER_FDEFAULT(CHIP,AMR,BK1)    |_PER_FDEFAULT(CHIP,AMR,BK0)    |_PER_FDEFAULT(CHIP,AMR,B7MODE)    |_PER_FDEFAULT(CHIP,AMR,B6MODE)    |_PER_FDEFAULT(CHIP,AMR,B5MODE)    |_PER_FDEFAULT(CHIP,AMR,B4MODE)    |_PER_FDEFAULT(CHIP,AMR,A7MODE)    |_PER_FDEFAULT(CHIP,AMR,A6MODE)    |_PER_FDEFAULT(CHIP,AMR,A5MODE)    |_PER_FDEFAULT(CHIP,AMR,A4MODE)  )
N
N  #define CHIP_AMR_RMK(bk1,bk0,b7mode,b6mode,b5mode,b4mode,a7,ode,\
N    a6mode,a5mode,a4mode) (Uint32)( \
N     _PER_FMK(CHIP,AMR,BK1,bk1)\
N    |_PER_FMK(CHIP,AMR,BK0,bk0)\
N    |_PER_FMK(CHIP,AMR,B7MODE,b7mode)\
N    |_PER_FMK(CHIP,AMR,B6MODE,b6mode)\
N    |_PER_FMK(CHIP,AMR,B5MODE,b5mode)\
N    |_PER_FMK(CHIP,AMR,B4MODE,b4mode)\
N    |_PER_FMK(CHIP,AMR,A7MODE,a7mode)\
N    |_PER_FMK(CHIP,AMR,A6MODE,a6mode)\
N    |_PER_FMK(CHIP,AMR,A5MODE,a5mode)\
N    |_PER_FMK(CHIP,AMR,A4MODE,a4mode)\
N  )
X  #define CHIP_AMR_RMK(bk1,bk0,b7mode,b6mode,b5mode,b4mode,a7,ode,    a6mode,a5mode,a4mode) (Uint32)(      _PER_FMK(CHIP,AMR,BK1,bk1)    |_PER_FMK(CHIP,AMR,BK0,bk0)    |_PER_FMK(CHIP,AMR,B7MODE,b7mode)    |_PER_FMK(CHIP,AMR,B6MODE,b6mode)    |_PER_FMK(CHIP,AMR,B5MODE,b5mode)    |_PER_FMK(CHIP,AMR,B4MODE,b4mode)    |_PER_FMK(CHIP,AMR,A7MODE,a7mode)    |_PER_FMK(CHIP,AMR,A6MODE,a6mode)    |_PER_FMK(CHIP,AMR,A5MODE,a5mode)    |_PER_FMK(CHIP,AMR,A4MODE,a4mode)  )
N
N  #define _CHIP_AMR_FGET(FIELD)\
N    _PER_CFGET(CHIP,AMR,##FIELD)
X  #define _CHIP_AMR_FGET(FIELD)    _PER_CFGET(CHIP,AMR,##FIELD)
N
N  #define _CHIP_AMR_FSET(FIELD,field)\
N    _PER_CFSET(CHIP,AMR,##FIELD,field)
X  #define _CHIP_AMR_FSET(FIELD,field)    _PER_CFSET(CHIP,AMR,##FIELD,field)
N
N  #define _CHIP_AMR_FSETS(FIELD,SYM)\
N    _PER_CFSETS(CHIP,AMR,##FIELD,##SYM)
X  #define _CHIP_AMR_FSETS(FIELD,SYM)    _PER_CFSETS(CHIP,AMR,##FIELD,##SYM)
N
N
N
N/******************************************************************************\
N* _____________________
X
N* |                   |
N* |  D E V C F G      |
N* |___________________|
N*
N* PERCFG - Device Configuration register (1)
N*
N* FIELDS (msb -> lsb)  CHIP_6713/CHIP_DA610
N* (rw) EKSRC
N* (rw) TOUT1SEL
N* (rw) TOUT0SEL
N* (rw) MCBSP0DIS
N* (rw) MCBSP1DIS
N* (rw) GPIO1EN (only for CHIP_DA610)
N*
N* FIELDS (msb -> lsb)  CHIP_DM642
N* (rw) VP2EN
N* (rw) VP1EN
N* (rw) VP0EN
N* (rw) I2C0EN
N* (rw) MCBSP1EN
N* (rw) MCBSP0EN
N* (rw) MCASP0EN
N*
N* FIELDS (msb -> lsb)  CHIP_6412
N* (rw) I2C0EN
N* (rw) MCBSP1EN
N* (rw) MCBSP0EN
N*
N* FIELDS (msb -> lsb)  CHIP_6711C/CHIP_6712C
N* (rw) EKSRC
N*
N* FIELDS (msb -> lsb)  CHIP_6410/CHIP_6413/CHIP_6418
N* (rw) AFCMUX
N* (rw) MCASP1EN
N* (rw) I2C1EN
N* (rw) I2C0EN
N* (r) MCBSP1EN
N* (r) MCBSP0EN
N* (rw) MCASP0EN
N*
N\******************************************************************************/
N
N#if (CHIP_DA610)
X#if (0)
S
S  #define   _CHIP_DEVCFG_ADDR              0x019C0200u
S  #define   _CHIP_DEVCFG_OFFSET             0
S
S  #define _CHIP_DEVCFG_GPIO1EN_MASK        0x00010000u
S  #define _CHIP_DEVCFG_GPIO1EN_SHIFT       0x0000000Fu
S  #define  CHIP_DEVCFG_GPIO1EN_DEFAULT     0x00000000u
S  #define  CHIP_DEVCFG_GPIO1EN_OF(x)       _VALUEOF(x)
S  #define  CHIP_DEVCFG_GPIO1EN_0           0x00000000u
S  #define  CHIP_DEVCFG_GPIO1EN_1           0x00000001u
S
S  #define _CHIP_DEVCFG_EKSRC_MASK          0x00000010u
S  #define _CHIP_DEVCFG_EKSRC_SHIFT         0x00000004u
S  #define  CHIP_DEVCFG_EKSRC_DEFAULT       0x00000000u
S  #define  CHIP_DEVCFG_EKSRC_OF(x)         _VALUEOF(x)
S  #define  CHIP_DEVCFG_EKSRC_SYSCLK3       0x00000000u
S  #define  CHIP_DEVCFG_EKSRC_ECLKIN        0x00000001u
S
S  #define _CHIP_DEVCFG_TOUT1SEL_MASK       0x00000008u
S  #define _CHIP_DEVCFG_TOUT1SEL_SHIFT      0x00000003u
S  #define  CHIP_DEVCFG_TOUT1SEL_DEFAULT    0x00000000u
S  #define  CHIP_DEVCFG_TOUT1SEL_OF(x)       _VALUEOF(x)
S  #define  CHIP_DEVCFG_TOUT1SEL_TOUT1PIN   0x00000000u
S  #define  CHIP_DEVCFG_TOUT1SEL_MCASPPIN   0x00000001u
S
S  #define _CHIP_DEVCFG_TOUT0SEL_MASK       0x00000004u
S  #define _CHIP_DEVCFG_TOUT0SEL_SHIFT      0x00000002u
S  #define  CHIP_DEVCFG_TOUT0SEL_DEFAULT    0x00000000u
S  #define  CHIP_DEVCFG_TOUT0SEL_OF(x)       _VALUEOF(x)
S  #define  CHIP_DEVCFG_TOUT0SEL_TOUT0PIN   0x00000000u
S  #define  CHIP_DEVCFG_TOUT0SEL_MCASPPIN   0x00000001u
S
S  #define _CHIP_DEVCFG_MCBSP0DIS_MASK       0x00000002u
S  #define _CHIP_DEVCFG_MCBSP0DIS_SHIFT      0x00000001u
S  #define  CHIP_DEVCFG_MCBSP0DIS_DEFAULT    0x00000000u
S  #define  CHIP_DEVCFG_MCBSP0DIS_OF(x)       _VALUEOF(x)
S  #define  CHIP_DEVCFG_MCBSP0DIS_0          0x00000000u
S  #define  CHIP_DEVCFG_MCBSP0DIS_1          0x00000001u
S
S  #define _CHIP_DEVCFG_MCBSP1DIS_MASK         0x00000001u
S  #define _CHIP_DEVCFG_MCBSP1DIS_SHIFT        0x00000000u
S  #define  CHIP_DEVCFG_MCBSP1DIS_DEFAULT      0x00000000u
S  #define  CHIP_DEVCFG_MCBSP1DIS_OF(x)        _VALUEOF(x)
S  #define  CHIP_DEVCFG_MCBSP1DIS_0            0x00000000u
S  #define  CHIP_DEVCFG_MCBSP1DIS_1            0x00000001u
S
S
S  #define  CHIP_DEVCFG_OF(x)              _VALUEOF(x)
S
S  #define CHIP_DEVCFG_DEFAULT (Uint32)( \
S     _PER_FDEFAULT(CHIP,DEVCFG,EKSRC) \
S    |_PER_FDEFAULT(CHIP,DEVCFG,TOUT1SEL) \
S    |_PER_FDEFAULT(CHIP,DEVCFG,TOUT0SEL) \
S    |_PER_FDEFAULT(CHIP,DEVCFG,MCBSP0DIS) \
S    |_PER_FDEFAULT(CHIP,DEVCFG,MCBSP1DIS) \
S    |_PER_FDEFAULT(CHIP,DEVCFG,GPIO1EN) \
S )
X  #define CHIP_DEVCFG_DEFAULT (Uint32)(      _PER_FDEFAULT(CHIP,DEVCFG,EKSRC)     |_PER_FDEFAULT(CHIP,DEVCFG,TOUT1SEL)     |_PER_FDEFAULT(CHIP,DEVCFG,TOUT0SEL)     |_PER_FDEFAULT(CHIP,DEVCFG,MCBSP0DIS)     |_PER_FDEFAULT(CHIP,DEVCFG,MCBSP1DIS)     |_PER_FDEFAULT(CHIP,DEVCFG,GPIO1EN)  )
S
S  #define CHIP_DEVCFG_RMK(eksrc,tout1sel,tout0sel,mcbsp0dis,mcbsp1dis,\
S                          gpio1en ) (Uint32)( \
S      _PER_FMK(CHIP,DEVCFG,EKSRC,eksrc) \
S    |_PER_FMK(CHIP,DEVCFG,TOUT1SEL,tout1sel) \
S    |_PER_FMK(CHIP,DEVCFG,TOUT0SEL,tout0sel) \
S    |_PER_FMK(CHIP,DEVCFG,MCBSP0DIS,mcbsp0dis) \
S    |_PER_FMK(CHIP,DEVCFG,MCBSP1DIS,mcbsp1dis) \
S    |_PER_FMK(CHIP,DEVCFG,GPIO1EN,gpio1en) \
S)
X  #define CHIP_DEVCFG_RMK(eksrc,tout1sel,tout0sel,mcbsp0dis,mcbsp1dis,                          gpio1en ) (Uint32)(       _PER_FMK(CHIP,DEVCFG,EKSRC,eksrc)     |_PER_FMK(CHIP,DEVCFG,TOUT1SEL,tout1sel)     |_PER_FMK(CHIP,DEVCFG,TOUT0SEL,tout0sel)     |_PER_FMK(CHIP,DEVCFG,MCBSP0DIS,mcbsp0dis)     |_PER_FMK(CHIP,DEVCFG,MCBSP1DIS,mcbsp1dis)     |_PER_FMK(CHIP,DEVCFG,GPIO1EN,gpio1en) )
S#elif (CHIP_6713)
X#elif (0)
S  #define   _CHIP_DEVCFG_ADDR              0x019C0200u
S  #define   _CHIP_DEVCFG_OFFSET             0
S
S  #define _CHIP_DEVCFG_EKSRC_MASK          0x00000010u
S  #define _CHIP_DEVCFG_EKSRC_SHIFT         0x00000004u
S  #define  CHIP_DEVCFG_EKSRC_DEFAULT       0x00000000u
S  #define  CHIP_DEVCFG_EKSRC_OF(x)         _VALUEOF(x)
S  #define  CHIP_DEVCFG_EKSRC_SYSCLK3       0x00000000u
S  #define  CHIP_DEVCFG_EKSRC_ECLKIN        0x00000001u
S
S  #define _CHIP_DEVCFG_TOUT1SEL_MASK       0x00000008u
S  #define _CHIP_DEVCFG_TOUT1SEL_SHIFT      0x00000003u
S  #define  CHIP_DEVCFG_TOUT1SEL_DEFAULT    0x00000000u
S  #define  CHIP_DEVCFG_TOUT1SEL_OF(x)       _VALUEOF(x)
S  #define  CHIP_DEVCFG_TOUT1SEL_TOUT1PIN   0x00000000u
S  #define  CHIP_DEVCFG_TOUT1SEL_MCASPPIN   0x00000001u
S
S  #define _CHIP_DEVCFG_TOUT0SEL_MASK       0x00000004u
S  #define _CHIP_DEVCFG_TOUT0SEL_SHIFT      0x00000002u
S  #define  CHIP_DEVCFG_TOUT0SEL_DEFAULT    0x00000000u
S  #define  CHIP_DEVCFG_TOUT0SEL_OF(x)       _VALUEOF(x)
S  #define  CHIP_DEVCFG_TOUT0SEL_TOUT0PIN   0x00000000u
S  #define  CHIP_DEVCFG_TOUT0SEL_MCASPPIN   0x00000001u
S
S  #define _CHIP_DEVCFG_MCBSP0DIS_MASK      0x00000002u
S  #define _CHIP_DEVCFG_MCBSP0DIS_SHIFT     0x00000001u
S  #define  CHIP_DEVCFG_MCBSP0DIS_DEFAULT   0x00000000u
S  #define  CHIP_DEVCFG_MCBSP0DIS_OF(x)     _VALUEOF(x)
S  #define  CHIP_DEVCFG_MCBSP0DIS_0         0x00000000u
S  #define  CHIP_DEVCFG_MCBSP0DIS_1         0x00000001u
S
S  #define _CHIP_DEVCFG_MCBSP1DIS_MASK      0x00000001u
S  #define _CHIP_DEVCFG_MCBSP1DIS_SHIFT     0x00000000u
S  #define  CHIP_DEVCFG_MCBSP1DIS_DEFAULT   0x00000000u
S  #define  CHIP_DEVCFG_MCBSP1DIS_OF(x)     _VALUEOF(x)
S  #define  CHIP_DEVCFG_MCBSP1DIS_0         0x00000000u
S  #define  CHIP_DEVCFG_MCBSP1DIS_1         0x00000001u
S
S
S  #define  CHIP_DEVCFG_OF(x)              _VALUEOF(x)
S
S  #define CHIP_DEVCFG_DEFAULT (Uint32)( \
S     _PER_FDEFAULT(CHIP,DEVCFG,EKSRC) \
S    |_PER_FDEFAULT(CHIP,DEVCFG,TOUT1SEL) \
S    |_PER_FDEFAULT(CHIP,DEVCFG,TOUT0SEL) \
S    |_PER_FDEFAULT(CHIP,DEVCFG,MCBSP0DIS) \
S    |_PER_FDEFAULT(CHIP,DEVCFG,MCBSP1DIS) \
S )
X  #define CHIP_DEVCFG_DEFAULT (Uint32)(      _PER_FDEFAULT(CHIP,DEVCFG,EKSRC)     |_PER_FDEFAULT(CHIP,DEVCFG,TOUT1SEL)     |_PER_FDEFAULT(CHIP,DEVCFG,TOUT0SEL)     |_PER_FDEFAULT(CHIP,DEVCFG,MCBSP0DIS)     |_PER_FDEFAULT(CHIP,DEVCFG,MCBSP1DIS)  )
S
S  #define CHIP_DEVCFG_RMK(eksrc,tout1sel,tout0sel,mcbsp0dis,mcbsp1dis\
S                          ) (Uint32)( \
S      _PER_FMK(CHIP,DEVCFG,EKSRC,eksrc) \
S    |_PER_FMK(CHIP,DEVCFG,TOUT1SEL,tout1sel) \
S    |_PER_FMK(CHIP,DEVCFG,TOUT0SEL,tout0sel) \
S    |_PER_FMK(CHIP,DEVCFG,MCBSP0DIS,mcbsp0dis) \
S    |_PER_FMK(CHIP,DEVCFG,MCBSP1DIS,mcbsp1dis) \
S)
X  #define CHIP_DEVCFG_RMK(eksrc,tout1sel,tout0sel,mcbsp0dis,mcbsp1dis                          ) (Uint32)(       _PER_FMK(CHIP,DEVCFG,EKSRC,eksrc)     |_PER_FMK(CHIP,DEVCFG,TOUT1SEL,tout1sel)     |_PER_FMK(CHIP,DEVCFG,TOUT0SEL,tout0sel)     |_PER_FMK(CHIP,DEVCFG,MCBSP0DIS,mcbsp0dis)     |_PER_FMK(CHIP,DEVCFG,MCBSP1DIS,mcbsp1dis) )
S
N#endif
N
N#if (CHIP_DM642 || CHIP_DM641 || CHIP_DM640 || CHIP_6412)
X#if (0 || 0 || 0 || 0)
S
S  #define   _CHIP_PERCFG_ADDR                0x01B3F000u
S  #define   _CHIP_PERCFG_OFFSET              0
S
S#if (CHIP_DM642)
S  #define _CHIP_PERCFG_VP2EN_MASK            0x00000040u
S  #define _CHIP_PERCFG_VP2EN_SHIFT           0x00000006u
S  #define  CHIP_PERCFG_VP2EN_DEFAULT         0x00000000u
S  #define  CHIP_PERCFG_VP2EN_OF(x)           _VALUEOF(x)
S  #define  CHIP_PERCFG_VP2EN_DISABLE         0x00000000u
S  #define  CHIP_PERCFG_VP2EN_ENABLE          0x00000001u
S#endif
S
S#if (CHIP_DM642 | CHIP_DM641)                          
S  #define _CHIP_PERCFG_VP1EN_MASK            0x00000020u
S  #define _CHIP_PERCFG_VP1EN_SHIFT           0x00000005u
S  #define  CHIP_PERCFG_VP1EN_DEFAULT         0x00000000u
S  #define  CHIP_PERCFG_VP1EN_OF(x)           _VALUEOF(x)
S  #define  CHIP_PERCFG_VP1EN_DISABLE         0x00000000u
S  #define  CHIP_PERCFG_VP1EN_ENABLE          0x00000001u
S#endif
S
S#if (CHIP_DM642 | CHIP_DM641 | CHIP_DM640)                          
S  #define _CHIP_PERCFG_VP0EN_MASK            0x00000010u
S  #define _CHIP_PERCFG_VP0EN_SHIFT           0x00000004u
S  #define  CHIP_PERCFG_VP0EN_DEFAULT         0x00000000u
S  #define  CHIP_PERCFG_VP0EN_OF(x)           _VALUEOF(x)
S  #define  CHIP_PERCFG_VP0EN_DISABLE         0x00000000u
S  #define  CHIP_PERCFG_VP0EN_ENABLE          0x00000001u
S#endif
S
S  #define _CHIP_PERCFG_I2C0EN_MASK           0x00000008u
S  #define _CHIP_PERCFG_I2C0EN_SHIFT          0x00000003u
S  #define  CHIP_PERCFG_I2C0EN_DEFAULT        0x00000000u
S  #define  CHIP_PERCFG_I2C0EN_OF(x)          _VALUEOF(x)
S  #define  CHIP_PERCFG_I2C0EN_DISABLE        0x00000000u
S  #define  CHIP_PERCFG_I2C0EN_ENABLE         0x00000001u
S
S  #define _CHIP_PERCFG_MCBSP1EN_MASK         0x00000004u
S  #define _CHIP_PERCFG_MCBSP1EN_SHIFT        0x00000002u
S  #define  CHIP_PERCFG_MCBSP1EN_DEFAULT      0x00000001u
S  #define  CHIP_PERCFG_MCBSP1EN_OF(x)        _VALUEOF(x)
S  #define  CHIP_PERCFG_MCBSP1EN_DISABLE      0x00000000u
S  #define  CHIP_PERCFG_MCBSP1EN_ENABLE       0x00000001u
S
S  #define _CHIP_PERCFG_MCBSP0EN_MASK         0x00000002u
S  #define _CHIP_PERCFG_MCBSP0EN_SHIFT        0x00000001u
S  #define  CHIP_PERCFG_MCBSP0EN_DEFAULT      0x00000001u
S  #define  CHIP_PERCFG_MCBSP0EN_OF(x)        _VALUEOF(x)
S  #define  CHIP_PERCFG_MCBSP0EN_DISABLE      0x00000000u
S  #define  CHIP_PERCFG_MCBSP0EN_ENABLE       0x00000001u
S
S#if (CHIP_DM642 | CHIP_DM641 | CHIP_DM640)
S  #define _CHIP_PERCFG_MCASP0EN_MASK         0x00000001u
S  #define _CHIP_PERCFG_MCASP0EN_SHIFT        0x00000000u
S  #define  CHIP_PERCFG_MCASP0EN_DEFAULT      0x00000000u
S  #define  CHIP_PERCFG_MCASP0EN_OF(x)         _VALUEOF(x)
S  #define  CHIP_PERCFG_MCASP0EN_DISABLE      0x00000000u
S  #define  CHIP_PERCFG_MCASP0EN_ENABLE       0x00000001u
S#endif
S
S
S  #define  CHIP_PERCFG_OF(x)              _VALUEOF(x)
S
S#if (CHIP_DM642)
S  #define CHIP_PERCFG_DEFAULT (Uint32)( \
S     _PER_FDEFAULT(CHIP,PERCFG,VP2EN) \
S    |_PER_FDEFAULT(CHIP,PERCFG,VP1EN) \
S    |_PER_FDEFAULT(CHIP,PERCFG,VP0EN) \
S    |_PER_FDEFAULT(CHIP,PERCFG,I2C0EN) \
S    |_PER_FDEFAULT(CHIP,PERCFG,MCBSP1EN) \
S    |_PER_FDEFAULT(CHIP,PERCFG,MCBSP0EN) \
S    |_PER_FDEFAULT(CHIP,PERCFG,MCASP0EN) \
S   )
X  #define CHIP_PERCFG_DEFAULT (Uint32)(      _PER_FDEFAULT(CHIP,PERCFG,VP2EN)     |_PER_FDEFAULT(CHIP,PERCFG,VP1EN)     |_PER_FDEFAULT(CHIP,PERCFG,VP0EN)     |_PER_FDEFAULT(CHIP,PERCFG,I2C0EN)     |_PER_FDEFAULT(CHIP,PERCFG,MCBSP1EN)     |_PER_FDEFAULT(CHIP,PERCFG,MCBSP0EN)     |_PER_FDEFAULT(CHIP,PERCFG,MCASP0EN)    )
S
S
S #define CHIP_PERCFG_RMK(vp2en,vp1en,vp0en,i2c0en,mcbsp1en,mcbsp0en,mcasp0en) (Uint32)( \
S     _PER_FMK(CHIP,PERCFG,VP2EN,vp2en) \
S    |_PER_FMK(CHIP,PERCFG,VP1EN,vp1en) \
S    |_PER_FMK(CHIP,PERCFG,VP0EN,vp0en) \
S    |_PER_FMK(CHIP,PERCFG,I2C0EN,i2c0en) \
S    |_PER_FMK(CHIP,PERCFG,MCBSP1EN,mcbsp1en) \
S    |_PER_FMK(CHIP,PERCFG,MCBSP0EN,mcbsp0en) \
S    |_PER_FMK(CHIP,PERCFG,MCASP0EN,mcasp0en) \
S  )
X #define CHIP_PERCFG_RMK(vp2en,vp1en,vp0en,i2c0en,mcbsp1en,mcbsp0en,mcasp0en) (Uint32)(      _PER_FMK(CHIP,PERCFG,VP2EN,vp2en)     |_PER_FMK(CHIP,PERCFG,VP1EN,vp1en)     |_PER_FMK(CHIP,PERCFG,VP0EN,vp0en)     |_PER_FMK(CHIP,PERCFG,I2C0EN,i2c0en)     |_PER_FMK(CHIP,PERCFG,MCBSP1EN,mcbsp1en)     |_PER_FMK(CHIP,PERCFG,MCBSP0EN,mcbsp0en)     |_PER_FMK(CHIP,PERCFG,MCASP0EN,mcasp0en)   )
S#endif
S
S#if (CHIP_DM641)
S  #define CHIP_PERCFG_DEFAULT (Uint32)( \
S     _PER_FDEFAULT(CHIP,PERCFG,VP1EN) \
S    |_PER_FDEFAULT(CHIP,PERCFG,VP0EN) \
S    |_PER_FDEFAULT(CHIP,PERCFG,I2C0EN) \
S    |_PER_FDEFAULT(CHIP,PERCFG,MCBSP1EN) \
S    |_PER_FDEFAULT(CHIP,PERCFG,MCBSP0EN) \
S    |_PER_FDEFAULT(CHIP,PERCFG,MCASP0EN) \
S   )
X  #define CHIP_PERCFG_DEFAULT (Uint32)(      _PER_FDEFAULT(CHIP,PERCFG,VP1EN)     |_PER_FDEFAULT(CHIP,PERCFG,VP0EN)     |_PER_FDEFAULT(CHIP,PERCFG,I2C0EN)     |_PER_FDEFAULT(CHIP,PERCFG,MCBSP1EN)     |_PER_FDEFAULT(CHIP,PERCFG,MCBSP0EN)     |_PER_FDEFAULT(CHIP,PERCFG,MCASP0EN)    )
S
S
S #define CHIP_PERCFG_RMK(vp1en,vp0en,i2c0en,mcbsp1en,mcbsp0en,mcasp0en) (Uint32)( \
S     _PER_FMK(CHIP,PERCFG,VP1EN,vp1en) \
S    |_PER_FMK(CHIP,PERCFG,VP0EN,vp0en) \
S    |_PER_FMK(CHIP,PERCFG,I2C0EN,i2c0en) \
S    |_PER_FMK(CHIP,PERCFG,MCBSP1EN,mcbsp1en) \
S    |_PER_FMK(CHIP,PERCFG,MCBSP0EN,mcbsp0en) \
S    |_PER_FMK(CHIP,PERCFG,MCASP0EN,mcasp0en) \
S  )
X #define CHIP_PERCFG_RMK(vp1en,vp0en,i2c0en,mcbsp1en,mcbsp0en,mcasp0en) (Uint32)(      _PER_FMK(CHIP,PERCFG,VP1EN,vp1en)     |_PER_FMK(CHIP,PERCFG,VP0EN,vp0en)     |_PER_FMK(CHIP,PERCFG,I2C0EN,i2c0en)     |_PER_FMK(CHIP,PERCFG,MCBSP1EN,mcbsp1en)     |_PER_FMK(CHIP,PERCFG,MCBSP0EN,mcbsp0en)     |_PER_FMK(CHIP,PERCFG,MCASP0EN,mcasp0en)   )
S#endif
S
S#if (CHIP_DM640)
S  #define CHIP_PERCFG_DEFAULT (Uint32)( \
S     _PER_FDEFAULT(CHIP,PERCFG,VP0EN) \
S    |_PER_FDEFAULT(CHIP,PERCFG,I2C0EN) \
S    |_PER_FDEFAULT(CHIP,PERCFG,MCBSP1EN) \
S    |_PER_FDEFAULT(CHIP,PERCFG,MCBSP0EN) \
S    |_PER_FDEFAULT(CHIP,PERCFG,MCASP0EN) \
S   )
X  #define CHIP_PERCFG_DEFAULT (Uint32)(      _PER_FDEFAULT(CHIP,PERCFG,VP0EN)     |_PER_FDEFAULT(CHIP,PERCFG,I2C0EN)     |_PER_FDEFAULT(CHIP,PERCFG,MCBSP1EN)     |_PER_FDEFAULT(CHIP,PERCFG,MCBSP0EN)     |_PER_FDEFAULT(CHIP,PERCFG,MCASP0EN)    )
S
S
S #define CHIP_PERCFG_RMK(vp0en,i2c0en,mcbsp1en,mcbsp0en,mcasp0en) (Uint32)( \
S     _PER_FMK(CHIP,PERCFG,VP0EN,vp0en) \
S    |_PER_FMK(CHIP,PERCFG,I2C0EN,i2c0en) \
S    |_PER_FMK(CHIP,PERCFG,MCBSP1EN,mcbsp1en) \
S    |_PER_FMK(CHIP,PERCFG,MCBSP0EN,mcbsp0en) \
S    |_PER_FMK(CHIP,PERCFG,MCASP0EN,mcasp0en) \
S  )
X #define CHIP_PERCFG_RMK(vp0en,i2c0en,mcbsp1en,mcbsp0en,mcasp0en) (Uint32)(      _PER_FMK(CHIP,PERCFG,VP0EN,vp0en)     |_PER_FMK(CHIP,PERCFG,I2C0EN,i2c0en)     |_PER_FMK(CHIP,PERCFG,MCBSP1EN,mcbsp1en)     |_PER_FMK(CHIP,PERCFG,MCBSP0EN,mcbsp0en)     |_PER_FMK(CHIP,PERCFG,MCASP0EN,mcasp0en)   )
S#endif
S
S#if (CHIP_6412)
S  #define CHIP_PERCFG_DEFAULT (Uint32)( \
S     _PER_FDEFAULT(CHIP,PERCFG,I2C0EN) \
S    |_PER_FDEFAULT(CHIP,PERCFG,MCBSP1EN) \
S    |_PER_FDEFAULT(CHIP,PERCFG,MCBSP0EN) \
S   )
X  #define CHIP_PERCFG_DEFAULT (Uint32)(      _PER_FDEFAULT(CHIP,PERCFG,I2C0EN)     |_PER_FDEFAULT(CHIP,PERCFG,MCBSP1EN)     |_PER_FDEFAULT(CHIP,PERCFG,MCBSP0EN)    )
S
S
S #define CHIP_PERCFG_RMK(i2c0en,mcbsp1en,mcbsp0en) (Uint32)( \
S    |_PER_FMK(CHIP,PERCFG,I2C0EN,i2c0en) \
S    |_PER_FMK(CHIP,PERCFG,MCBSP1EN,mcbsp1en) \
S    |_PER_FMK(CHIP,PERCFG,MCBSP0EN,mcbsp0en) \
S  )
X #define CHIP_PERCFG_RMK(i2c0en,mcbsp1en,mcbsp0en) (Uint32)(     |_PER_FMK(CHIP,PERCFG,I2C0EN,i2c0en)     |_PER_FMK(CHIP,PERCFG,MCBSP1EN,mcbsp1en)     |_PER_FMK(CHIP,PERCFG,MCBSP0EN,mcbsp0en)   )
S#endif
S
N#endif /* CHIP_DM642 || CHIP_6412  */
N
N#if (CHIP_6410 || CHIP_6413 || CHIP_6418)
X#if (0 || 0 || 0)
S
S  #define   _CHIP_PERCFG_ADDR                0x01B3F000u
S  #define   _CHIP_PERCFG_OFFSET              0
S  
S  #define _CHIP_PERCFG_AFCMUX_MASK           0x00000600u
S  #define _CHIP_PERCFG_AFCMUX_SHIFT          0x00000009u
S  #define  CHIP_PERCFG_AFCMUX_DEFAULT        0x00000000u
S  #define  CHIP_PERCFG_AFCMUX_OF(x)           _VALUEOF(x)
S  #define  CHIP_PERCFG_AFCMUX_PIN0           0x00000000u
S  #define  CHIP_PERCFG_AFCMUX_PIN1           0x00000001u
S  #define  CHIP_PERCFG_AFCMUX_PIN2           0x00000002u
S  #define  CHIP_PERCFG_AFCMUX_PIN3           0x00000003u
S 
S  #define _CHIP_PERCFG_MCASP1EN_MASK         0x00000100u
S  #define _CHIP_PERCFG_MCASP1EN_SHIFT        0x00000008u
S  #define  CHIP_PERCFG_MCASP1EN_DEFAULT      0x00000000u
S  #define  CHIP_PERCFG_MCASP1EN_OF(x)         _VALUEOF(x)
S  #define  CHIP_PERCFG_MCASP1EN_DISABLE      0x00000000u
S  #define  CHIP_PERCFG_MCASP1EN_ENABLE       0x00000001u
S
S  #define _CHIP_PERCFG_I2C1EN_MASK           0x00000080u
S  #define _CHIP_PERCFG_I2C1EN_SHIFT          0x00000007u
S  #define  CHIP_PERCFG_I2C1EN_DEFAULT        0x00000000u
S  #define  CHIP_PERCFG_I2C1EN_OF(x)          _VALUEOF(x)
S  #define  CHIP_PERCFG_I2C1EN_DISABLE        0x00000000u
S  #define  CHIP_PERCFG_I2C1EN_ENABLE         0x00000001u
S
S  #define _CHIP_PERCFG_I2C0EN_MASK           0x00000008u
S  #define _CHIP_PERCFG_I2C0EN_SHIFT          0x00000003u
S  #define  CHIP_PERCFG_I2C0EN_DEFAULT        0x00000000u
S  #define  CHIP_PERCFG_I2C0EN_OF(x)          _VALUEOF(x)
S  #define  CHIP_PERCFG_I2C0EN_DISABLE        0x00000000u
S  #define  CHIP_PERCFG_I2C0EN_ENABLE         0x00000001u
S
S  #define _CHIP_PERCFG_MCBSP1EN_MASK         0x00000004u
S  #define _CHIP_PERCFG_MCBSP1EN_SHIFT        0x00000002u
S  #define  CHIP_PERCFG_MCBSP1EN_DEFAULT      0x00000001u
S  #define  CHIP_PERCFG_MCBSP1EN_OF(x)        _VALUEOF(x)
S  #define  CHIP_PERCFG_MCBSP1EN_DISABLE      0x00000000u
S  #define  CHIP_PERCFG_MCBSP1EN_ENABLE       0x00000001u
S 
S  #define _CHIP_PERCFG_MCBSP0EN_MASK         0x00000002u
S  #define _CHIP_PERCFG_MCBSP0EN_SHIFT        0x00000001u
S  #define  CHIP_PERCFG_MCBSP0EN_DEFAULT      0x00000001u
S  #define  CHIP_PERCFG_MCBSP0EN_OF(x)        _VALUEOF(x)
S  #define  CHIP_PERCFG_MCBSP0EN_DISABLE      0x00000000u
S  #define  CHIP_PERCFG_MCBSP0EN_ENABLE       0x00000001u
S
S  #define _CHIP_PERCFG_MCASP0EN_MASK         0x00000001u
S  #define _CHIP_PERCFG_MCASP0EN_SHIFT        0x00000000u
S  #define  CHIP_PERCFG_MCASP0EN_DEFAULT      0x00000000u
S  #define  CHIP_PERCFG_MCASP0EN_OF(x)         _VALUEOF(x)
S  #define  CHIP_PERCFG_MCASP0EN_DISABLE      0x00000000u
S  #define  CHIP_PERCFG_MCASP0EN_ENABLE       0x00000001u
S
S  #define  CHIP_PERCFG_OF(x)              _VALUEOF(x)
S
S  #define CHIP_PERCFG_DEFAULT (Uint32)( \
S    _PER_FDEFAULT(CHIP,PERCFG,AFCMUX) \
S    |_PER_FDEFAULT(CHIP,PERCFG,MCASP1EN) \
S    |_PER_FDEFAULT(CHIP,PERCFG,I2C1EN) \
S    |_PER_FDEFAULT(CHIP,PERCFG,I2C0EN) \
S    |_PER_FDEFAULT(CHIP,PERCFG,MCBSP1EN) \
S    |_PER_FDEFAULT(CHIP,PERCFG,MCBSP0EN) \
S    |_PER_FDEFAULT(CHIP,PERCFG,MCASP0EN) \
S   )  
X  #define CHIP_PERCFG_DEFAULT (Uint32)(     _PER_FDEFAULT(CHIP,PERCFG,AFCMUX)     |_PER_FDEFAULT(CHIP,PERCFG,MCASP1EN)     |_PER_FDEFAULT(CHIP,PERCFG,I2C1EN)     |_PER_FDEFAULT(CHIP,PERCFG,I2C0EN)     |_PER_FDEFAULT(CHIP,PERCFG,MCBSP1EN)     |_PER_FDEFAULT(CHIP,PERCFG,MCBSP0EN)     |_PER_FDEFAULT(CHIP,PERCFG,MCASP0EN)    )  
S  
S
S #define CHIP_PERCFG_RMK(afcmux,mcasp1en,i2c1en,i2c0en,mcasp0en) (Uint32)( \
S    _PER_FMK(CHIP,PERCFG,AFCMUX,afcmux) \
S    |_PER_FMK(CHIP,PERCFG,MCASP1EN,mcasp1en) \
S    |_PER_FMK(CHIP,PERCFG,I2C1EN,i2c1en) \
S    |_PER_FMK(CHIP,PERCFG,I2C0EN,i2c0en) \
S    |_PER_FMK(CHIP,PERCFG,MCASP0EN,mcasp0en) \
S  )  
X #define CHIP_PERCFG_RMK(afcmux,mcasp1en,i2c1en,i2c0en,mcasp0en) (Uint32)(     _PER_FMK(CHIP,PERCFG,AFCMUX,afcmux)     |_PER_FMK(CHIP,PERCFG,MCASP1EN,mcasp1en)     |_PER_FMK(CHIP,PERCFG,I2C1EN,i2c1en)     |_PER_FMK(CHIP,PERCFG,I2C0EN,i2c0en)     |_PER_FMK(CHIP,PERCFG,MCASP0EN,mcasp0en)   )  
S
N#endif /* CHIP_6410 || CHIP_6413 || CHIP_6418 */
N
N#if (CHIP_6711C || CHIP_6712C)
X#if (0 || 0)
S  #define   _CHIP_DEVCFG_ADDR              0x019C0200u
S  #define   _CHIP_DEVCFG_OFFSET            0
S
S  #define _CHIP_DEVCFG_EKSRC_MASK          0x00000010u
S  #define _CHIP_DEVCFG_EKSRC_SHIFT         0x00000004u
S  #define  CHIP_DEVCFG_EKSRC_DEFAULT       0x00000000u
S  #define  CHIP_DEVCFG_EKSRC_OF(x)         _VALUEOF(x)
S  #define  CHIP_DEVCFG_EKSRC_SYSCLK3       0x00000000u
S  #define  CHIP_DEVCFG_EKSRC_ECLKIN        0x00000001u
S
S  #define  CHIP_DEVCFG_OF(x)              _VALUEOF(x)
S
S  #define CHIP_DEVCFG_DEFAULT (Uint32)( \
S     _PER_FDEFAULT(CHIP,DEVCFG,EKSRC) \
S )
X  #define CHIP_DEVCFG_DEFAULT (Uint32)(      _PER_FDEFAULT(CHIP,DEVCFG,EKSRC)  )
S
S  #define CHIP_PERCFG_RMK(eksrc) (Uint32)( \
S      _PER_FMK(CHIP,PERCFG,EKSRC,eksrc) \
S)
X  #define CHIP_PERCFG_RMK(eksrc) (Uint32)(       _PER_FMK(CHIP,PERCFG,EKSRC,eksrc) )
S
N#endif /* CHIP_6711C || CHIP_6712C */
N
N#if (CHIP_6711C || CHIP_6712C || CHIP_DA610 || CHIP_6713) 
X#if (0 || 0 || 0 || 0) 
S  #define _CHIP_DEVCFG_FGET(FIELD)\
S    _PER_FGET(_CHIP_DEVCFG_ADDR,CHIP,DEVCFG,##FIELD)
X  #define _CHIP_DEVCFG_FGET(FIELD)    _PER_FGET(_CHIP_DEVCFG_ADDR,CHIP,DEVCFG,##FIELD)
S
S  #define _CHIP_DEVCFG_FSET(FIELD,field)\
S    _PER_FSET(_CHIP_DEVCFG_ADDR,CHIP,DEVCFG,##FIELD,field)
X  #define _CHIP_DEVCFG_FSET(FIELD,field)    _PER_FSET(_CHIP_DEVCFG_ADDR,CHIP,DEVCFG,##FIELD,field)
S
S  #define _CHIP_DEVCFG_FSETS(FIELD,SYM)\
S    _PER_FSETS(_CHIP_DEVCFG_ADDR,CHIP,DEVCFG,##FIELD,##SYM)
X  #define _CHIP_DEVCFG_FSETS(FIELD,SYM)    _PER_FSETS(_CHIP_DEVCFG_ADDR,CHIP,DEVCFG,##FIELD,##SYM)
S   
N#else
N  
N  #define _CHIP_PERCFG_FGET(FIELD)\
N    _PER_FGET(_CHIP_PERCFG_ADDR,CHIP,PERCFG,##FIELD)
X  #define _CHIP_PERCFG_FGET(FIELD)    _PER_FGET(_CHIP_PERCFG_ADDR,CHIP,PERCFG,##FIELD)
N
N  #define _CHIP_PERCFG_FSET(FIELD,field)\
N    _PER_FSET(_CHIP_PERCFG_ADDR,CHIP,PERCFG,##FIELD,field)
X  #define _CHIP_PERCFG_FSET(FIELD,field)    _PER_FSET(_CHIP_PERCFG_ADDR,CHIP,PERCFG,##FIELD,field)
N
N  #define _CHIP_PERCFG_FSETS(FIELD,SYM)\
N    _PER_FSETS(_CHIP_PERCFG_ADDR,CHIP,PERCFG,##FIELD,##SYM)
X  #define _CHIP_PERCFG_FSETS(FIELD,SYM)    _PER_FSETS(_CHIP_PERCFG_ADDR,CHIP,PERCFG,##FIELD,##SYM)
N#endif
N
N/*----------------------------------------------------------------------------*/
N/******************************************************************************\
N* _____________________
X
N* |                   |
N* |  D E V S T A T    |
N* |___________________|
N*
N* DEVSTAT - Device Status Register (1)
N*
N* FIELDS (msb -> lsb)
N* DM642
N* (r) MACEN
N* (r) HPIWIDTH
N* (r) PCIEEAI
N* (r) PCIEN
N* (r) CLKMODE
N* (r) LENDIAN
N* (r) BOOTMODE
N* (r) AECLKINSEL
N*
N* DRI300
N* (r) PLLM
N* (r) OSCEXTRES
N* (r) CLKINSEL
N* (r) CLKMODE3
N* (r) HPIWIDTH
N* (r) HPIENZ
N* (r) CLKMODE2
N* (r) CLKMODE1
N* (r) CLKMODE0
N* (r) LENDIAN
N* (r) BOOTMODE
N* (r) AECLKINSEL
N*
N* 
N\******************************************************************************/
N#if (CHIP_DM642 | CHIP_DM641 | CHIP_DM640 | CHIP_6412)
X#if (0 | 0 | 0 | 0)
S
S  #define   _CHIP_DEVSTAT_ADDR                0x01B3F004u
S  #define   _CHIP_DEVSTAT_OFFSET              0
S
S  #define _CHIP_DEVSTAT_MACEN_MASK            0x00000800u
S  #define _CHIP_DEVSTAT_MACEN_SHIFT           0x0000000Bu
S  #define  CHIP_DEVSTAT_MACEN_DEFAULT         0x00000000u
S  #define  CHIP_DEVSTAT_MACEN_OF(x)           _VALUEOF(x)
S  #define  CHIP_DEVSTAT_MACEN_DISABLE         0x00000000u
S  #define  CHIP_DEVSTAT_MACEN_ENABLE          0x00000001u
S
S #if !(CHIP_DM640)
S  #define _CHIP_DEVSTAT_HPIWIDTH_MASK            0x00000400u
S  #define _CHIP_DEVSTAT_HPIWIDTH_SHIFT           0x0000000Au
S  #define  CHIP_DEVSTAT_HPIWIDTH_DEFAULT         0x00000000u
S  #define  CHIP_DEVSTAT_HPIWIDTH_OF(x)           _VALUEOF(x)
S  #define  CHIP_DEVSTAT_HPIWIDTH_16              0x00000000u
S  #define  CHIP_DEVSTAT_HPIWIDTH_32              0x00000001u
S #endif
S
S #if !(CHIP_DM641 | CHIP_DM640)
S  #define _CHIP_DEVSTAT_PCIEEAI_MASK            0x00000200u
S  #define _CHIP_DEVSTAT_PCIEEAI_SHIFT           0x00000009u
S  #define  CHIP_DEVSTAT_PCIEEAI_DEFAULT         0x00000000u
S  #define  CHIP_DEVSTAT_PCIEEAI_OF(x)           _VALUEOF(x)
S  #define  CHIP_DEVSTAT_PCIEEAI_NONE            0x00000000u
S  #define  CHIP_DEVSTAT_PCIEEAI_INIT            0x00000001u
S
S  #define _CHIP_DEVSTAT_PCIEN_MASK           0x00000100u
S  #define _CHIP_DEVSTAT_PCIEN_SHIFT          0x00000008u
S  #define  CHIP_DEVSTAT_PCIEN_DEFAULT        0x00000000u
S  #define  CHIP_DEVSTAT_PCIEN_OF(x)          _VALUEOF(x)
S  #define  CHIP_DEVSTAT_PCIEN_DISABLE        0x00000000u
S  #define  CHIP_DEVSTAT_PCIEN_ENABLE         0x00000001u
S #endif
S
S  #define _CHIP_DEVSTAT_CLKMODE_MASK         0x00000060u
S  #define _CHIP_DEVSTAT_CLKMODE_SHIFT        0x00000005u
S  #define  CHIP_DEVSTAT_CLKMODE_DEFAULT      0x00000001u
S  #define  CHIP_DEVSTAT_CLKMODE_OF(x)        _VALUEOF(x)
S  #define  CHIP_DEVSTAT_CLKMODE_X1           0x00000000u
S  #define  CHIP_DEVSTAT_CLKMODE_X6           0x00000001u
S  #define  CHIP_DEVSTAT_CLKMODE_X12          0x00000002u
S  #define  CHIP_DEVSTAT_CLKMODE_X20          0x00000003u
S
S  #define _CHIP_DEVSTAT_LENDIAN_MASK         0x00000010u
S  #define _CHIP_DEVSTAT_LENDIAN_SHIFT        0x00000004u
S  #define  CHIP_DEVSTAT_LENDIAN_DEFAULT      0x00000001u
S  #define  CHIP_DEVSTAT_LENDIAN_OF(x)        _VALUEOF(x)
S  #define  CHIP_DEVSTAT_LENDIAN_BIG          0x00000000u
S  #define  CHIP_DEVSTAT_LENDIAN_LITTLE       0x00000001u
S
S  #define _CHIP_DEVSTAT_BOOTMODE_MASK         0x0000000Cu
S  #define _CHIP_DEVSTAT_BOOTMODE_SHIFT        0x00000002u
S  #define  CHIP_DEVSTAT_BOOTMODE_DEFAULT      0x00000000u
S  #define  CHIP_DEVSTAT_BOOTMODE_OF(x)         _VALUEOF(x)
S  #define  CHIP_DEVSTAT_BOOTMODE_NONE         0x00000000u
S  #define  CHIP_DEVSTAT_BOOTMODE_HPIPCI       0x00000001u
S  #define  CHIP_DEVSTAT_BOOTMODE_EMIFA        0x00000003u
S
S  #define _CHIP_DEVSTAT_AECLKINSEL_MASK         0x00000003u
S  #define _CHIP_DEVSTAT_AECLKINSEL_SHIFT        0x00000000u
S  #define  CHIP_DEVSTAT_AECLKINSEL_DEFAULT      0x00000000u
S  #define  CHIP_DEVSTAT_AECLKINSEL_OF(x)         _VALUEOF(x)
S  #define  CHIP_DEVSTAT_AECLKINSEL_ECLKIN       0x00000000u
S  #define  CHIP_DEVSTAT_AECLKINSEL_CLKOUT4      0x00000001u
S  #define  CHIP_DEVSTAT_AECLKINSEL_CLKOUT6      0x00000002u
S  #define  CHIP_DEVSTAT_OF(x)              _VALUEOF(x)
S
S  #define  CHIP_DEVSTAT_OF(x)              _VALUEOF(x)
S
S  /* Read only Register */
S
S  #define _CHIP_DEVSTAT_FGET(FIELD)\
S    _PER_FGET(_CHIP_DEVSTAT_ADDR,CHIP,DEVSTAT,##FIELD)
X  #define _CHIP_DEVSTAT_FGET(FIELD)    _PER_FGET(_CHIP_DEVSTAT_ADDR,CHIP,DEVSTAT,##FIELD)
S
S
N#endif /* CHIP_DM642 | CHIP_6412  */
N
N#if (CHIP_6410 || CHIP_6413 || CHIP_6418)
X#if (0 || 0 || 0)
S
S  #define   _CHIP_DEVSTAT_ADDR                 0x01B3F004u
S  #define   _CHIP_DEVSTAT_OFFSET               0
S
S  #define _CHIP_DEVSTAT_PLLM_MASK              0x00F10000u
S  #define _CHIP_DEVSTAT_PLLM_SHIFT             0x00000013u
S  #define  CHIP_DEVSTAT_PLLM_DEFAULT           0x00000000u
S  #define  CHIP_DEVSTAT_PLLM_OF(x)             _VALUEOF(x)
S  #define  CHIP_DEVSTAT_PLLM_BYPASS            0x00000000u
S  #define  CHIP_DEVSTAT_PLLM_5                 0x00000001u
S  #define  CHIP_DEVSTAT_PLLM_6                 0x00000002u
S  #define  CHIP_DEVSTAT_PLLM_7                 0x00000003u
S  #define  CHIP_DEVSTAT_PLLM_8                 0x00000004u
S  #define  CHIP_DEVSTAT_PLLM_9                 0x00000005u
S  #define  CHIP_DEVSTAT_PLLM_10                0x00000006u
S  #define  CHIP_DEVSTAT_PLLM_11                0x00000007u
S  #define  CHIP_DEVSTAT_PLLM_12                0x00000008u
S  #define  CHIP_DEVSTAT_PLLM_16                0x00000009u
S  #define  CHIP_DEVSTAT_PLLM_18                0x0000000Au
S  #define  CHIP_DEVSTAT_PLLM_19                0x0000000Bu
S  #define  CHIP_DEVSTAT_PLLM_20                0x0000000Cu
S  #define  CHIP_DEVSTAT_PLLM_21                0x0000000Du
S  #define  CHIP_DEVSTAT_PLLM_22                0x0000000Eu
S  #define  CHIP_DEVSTAT_PLLM_24                0x0000000Fu
S 
S  #define _CHIP_DEVSTAT_OSCEXTRES_MASK         0x00020000u
S  #define _CHIP_DEVSTAT_OSCEXTRES_SHIFT        0x00000011u
S  #define  CHIP_DEVSTAT_OSCEXTRES_DEFAUL       0x00000001u
S  #define  CHIP_DEVSTAT_OSCEXTRES_OF(x)        _VALUEOF(x)
S  #define  CHIP_DEVSTAT_OSCEXTRES_DISABL       0x00000000u
S  #define  CHIP_DEVSTAT_OSCEXTRES_ENABLE       0x00000001u
S 
S  #define _CHIP_DEVSTAT_CLKINSEL_MASK          0x00010000u
S  #define _CHIP_DEVSTAT_CLKINSEL_SHIFT         0x00000010u
S  #define  CHIP_DEVSTAT_CLKINSEL_DEFAULT       0x00000000u
S  #define  CHIP_DEVSTAT_CLKINSEL_OF(x)         _VALUEOF(x)
S  #define  CHIP_DEVSTAT_CLKINSEL_DISABLE       0x00000000u
S  #define  CHIP_DEVSTAT_CLKINSEL_ENABLE        0x00000001u
S 
S  #define _CHIP_DEVSTAT_HPIWIDTH_MASK          0x00000400u
S  #define _CHIP_DEVSTAT_HPIWIDTH_SHIFT         0x0000000Au
S  #define  CHIP_DEVSTAT_HPIWIDTH_DEFAUL        0x00000000u
S  #define  CHIP_DEVSTAT_HPIWIDTH_OF(x)         _VALUEOF(x)
S  #define  CHIP_DEVSTAT_HPIWIDTH_16            0x00000000u
S  #define  CHIP_DEVSTAT_HPIWIDTH_32            0x00000001u
S 
S  #define _CHIP_DEVSTAT_HPIENZ_MASK            0x00000100u
S  #define _CHIP_DEVSTAT_HPIENZ_SHIFT           0x00000008u
S  #define  CHIP_DEVSTAT_HPIENZ_DEFAULT         0x00000000u
S  #define  CHIP_DEVSTAT_HPIENZ_OF(x)           _VALUEOF(x)
S  #define  CHIP_DEVSTAT_HPIENZ_ENABLE          0x00000000u
S  #define  CHIP_DEVSTAT_HPIENZ_DISABLE         0x00000001u
S 
S  #define _CHIP_DEVSTAT_CLKMODE_MASK          0x000010E0u
S  #define _CHIP_DEVSTAT_CLKMODE_SHIFT         0x00000005u
S  #define  CHIP_DEVSTAT_CLKMODE_DEFAULT       0x00000001u
S  #define  CHIP_DEVSTAT_CLKMODE_OF(x)         _VALUEOF(x)
S  #define  CHIP_DEVSTAT_CLKMODE_0             0x00000000u
S  #define  CHIP_DEVSTAT_CLKMODE_1             0x00000001u
S  #define  CHIP_DEVSTAT_CLKMODE_2             0x00000002u
S  #define  CHIP_DEVSTAT_CLKMODE_3             0x00000003u
S  #define  CHIP_DEVSTAT_CLKMODE_4             0x00000004u
S  #define  CHIP_DEVSTAT_CLKMODE_5             0x00000005u
S  #define  CHIP_DEVSTAT_CLKMODE_6             0x00000006u
S  #define  CHIP_DEVSTAT_CLKMODE_7             0x00000007u
S  #define  CHIP_DEVSTAT_CLKMODE_8             0x00000080u
S  #define  CHIP_DEVSTAT_CLKMODE_9             0x00000081u
S  #define  CHIP_DEVSTAT_CLKMODE_10            0x00000082u
S  #define  CHIP_DEVSTAT_CLKMODE_11            0x00000083u
S  #define  CHIP_DEVSTAT_CLKMODE_12            0x00000084u
S  #define  CHIP_DEVSTAT_CLKMODE_13            0x00000085u
S  #define  CHIP_DEVSTAT_CLKMODE_14            0x00000086u
S  #define  CHIP_DEVSTAT_CLKMODE_15            0x00000087u
S 
S  #define _CHIP_DEVSTAT_LENDIAN_MASK           0x00000010u
S  #define _CHIP_DEVSTAT_LENDIAN_SHIFT          0x00000004u
S  #define  CHIP_DEVSTAT_LENDIAN_DEFAULT        0x00000001u
S  #define  CHIP_DEVSTAT_LENDIAN_OF(x)          _VALUEOF(x)
S  #define  CHIP_DEVSTAT_LENDIAN_BIG            0x00000000u 
S  #define  CHIP_DEVSTAT_LENDIAN_LITTLE         0x00000001u
S 
S  #define _CHIP_DEVSTAT_BOOTMODE_MASK          0x0000000Cu
S  #define _CHIP_DEVSTAT_BOOTMODE_SHIFT         0x00000002u
S  #define  CHIP_DEVSTAT_BOOTMODE_DEFAULT       0x00000000u
S  #define  CHIP_DEVSTAT_BOOTMODE_OF(x)          _VALUEOF(x)
S  #define  CHIP_DEVSTAT_BOOTMODE_NONE          0x00000000u
S  #define  CHIP_DEVSTAT_BOOTMODE_HPI           0x00000001u
S  #define  CHIP_DEVSTAT_BOOTMODE_EMIFA         0x00000003u
S
S  #define _CHIP_DEVSTAT_AECLKINSEL_MASK        0x00000003u
S  #define _CHIP_DEVSTAT_AECLKINSEL_SHIFT       0x00000000u
S  #define  CHIP_DEVSTAT_AECLKINSEL_DEFAULT     0x00000000u
S  #define  CHIP_DEVSTAT_AECLKINSEL_OF(x)       _VALUEOF(x)
S  #define  CHIP_DEVSTAT_AECLKINSEL_ECLKIN      0x00000000u
S  #define  CHIP_DEVSTAT_AECLKINSEL_CLKOUT4     0x00000001u
S  #define  CHIP_DEVSTAT_AECLKINSEL_CLKOUT6     0x00000002u
S
S  #define  CHIP_DEVSTAT_OF(x)              _VALUEOF(x)
S
S  /* Read only Register */
S
S  #define _CHIP_DEVSTAT_FGET(FIELD)\
S    _PER_FGET(_CHIP_DEVSTAT_ADDR,CHIP,DEVSTAT,##FIELD)
X  #define _CHIP_DEVSTAT_FGET(FIELD)    _PER_FGET(_CHIP_DEVSTAT_ADDR,CHIP,DEVSTAT,##FIELD)
S
S
N#endif /* CHIP_6410 || CHIP_6413 || CHIP_6418 */
N
N/******************************************************************************\
N* _____________________
X
N* |                   |
N* |  J T A G I D      |
N* |___________________|
N*
N* JTAGID - JTAG ID register (1)
N*
N* FIELDS (msb -> lsb)
N* (r) VARIANT
N* (r) PART
N* (r) MANNUFACTURE
N* (r) LSB
N*
N* (1) Only for DM642
N*
N\******************************************************************************/
N
N
N#if (CHIP_DM642 || CHIP_DM641 || CHIP_DM640 || CHIP_6412 )
X#if (0 || 0 || 0 || 0 )
S
S  #define   _CHIP_JTAGID_ADDR                0x01B3F008u
S  #define   _CHIP_JTAGID_OFFSET              0
S
S  #define _CHIP_JTAGID_VARIANT_MASK          0xF0000000u
S  #define _CHIP_JTAGID_VARIANT_SHIFT         0x0000001Cu
S  #define  CHIP_JTAGID_VARIANT_DEFAULT       0x00000000u
S  #define  CHIP_JTAGID_VARIANT_OF(x)         _VALUEOF(x)
S
S  #define _CHIP_JTAGID_PART_MASK             0x0FFFF000u
S  #define _CHIP_JTAGID_PART_SHIFT            0x0000000Cu
S  #define  CHIP_JTAGID_PART_DEFAULT          0x00000079u
S  #define  CHIP_JTAGID_PART_OF(x)            _VALUEOF(x)
S
S  #define _CHIP_JTAGID_MANUFACTURE_MASK      0x00000FFEu
S  #define _CHIP_JTAGID_MANUFACTURE_SHIFT     0x00000001u
S  #define  CHIP_JTAGID_MANUFACTURE_DEFAULT   0x00000017u
S  #define  CHIP_JTAGID_MANUFACTURE_OF(x)     _VALUEOF(x)
S
S  #define _CHIP_JTAGID_LSB_MASK              0x00000001u
S  #define _CHIP_JTAGID_LSB_SHIFT             0x00000000u
S  #define  CHIP_JTAGID_LSB_DEFAULT           0x00000001u
S  #define  CHIP_JTAGID_LSB_OF(x)             _VALUEOF(x)
S
S  #define  CHIP_JTAGID_OF(x)              _VALUEOF(x)
S
S  #define _CHIP_JTAGID_FGET(FIELD)\
S    _PER_FGET(_CHIP_JTAGID_ADDR,CHIP,JTAGID,##FIELD)
X  #define _CHIP_JTAGID_FGET(FIELD)    _PER_FGET(_CHIP_JTAGID_ADDR,CHIP,JTAGID,##FIELD)
S
N#endif /* CHIP_DM642 || CHIP_6412  */
N
N/******************************************************************************\
N* _____________________
X
N* |                   |
N* |  P C F G L O C K  |
N* |___________________|
N*
N* PCFGLOCK - Peripheral Configuration Lock register (1)
N*
N* FIELDS (msb -> lsb)
N* (r) LOCKSTAT
N* (w) LOCK
N*
N* (1) Only for DM642
N*
N\******************************************************************************/
N
N#if (CHIP_DM642 || CHIP_DM641 || CHIP_DM640 || CHIP_6412 || CHIP_6410 || CHIP_6413 || CHIP_6418)
X#if (0 || 0 || 0 || 0 || 0 || 0 || 0)
S
S  #define   _CHIP_PCFGLOCK_ADDR                 0x01B3F018u
S  #define   _CHIP_PCFGLOCK_OFFSET               0
S
S  #define _CHIP_PCFGLOCK_LOCKSTAT_MASK          0x00000001u
S  #define _CHIP_PCFGLOCK_LOCKSTAT_SHIFT         0x00000000u
S  #define  CHIP_PCFGLOCK_LOCKSTAT_DEFAULT       0x00000001u
S  #define  CHIP_PCFGLOCK_LOCKSTAT_OF(x)         _VALUEOF(x)
S  #define  CHIP_PCFGLOCK_LOCKSTAT_UNLOCK        0x00000000u
S  #define  CHIP_PCFGLOCK_LOCKSTAT_LOCK          0x00000001u
S
S  #define _CHIP_PCFGLOCK_LOCK_MASK              0xFFFFFFFFu
S  #define _CHIP_PCFGLOCK_LOCK_SHIFT             0x00000000u
S  #define  CHIP_PCFGLOCK_LOCK_DEFAULT           0x00000000u
S  #define  CHIP_PCFGLOCK_LOCK_OF(x)             _VALUEOF(x)
S  #define  CHIP_PCFGLOCK_LOCK_UNLOCK            0x10C0010Cu
S  #define  CHIP_PCFGLOCK_LOCK_DISABLE           0x10C0010Cu
S
S  #define  CHIP_PCFGLOCK_OF(x)                  _VALUEOF(x)
S
S  #define _CHIP_PCFGLOCK_FGET(FIELD)\
S    _PER_FGET(_CHIP_PCFGLOCK_ADDR,CHIP,PCFGLOCK,##FIELD)
X  #define _CHIP_PCFGLOCK_FGET(FIELD)    _PER_FGET(_CHIP_PCFGLOCK_ADDR,CHIP,PCFGLOCK,##FIELD)
S
S  #define _CHIP_PCFGLOCK_FSET(FIELD,field)\
S    _PER_FSET(_CHIP_PCFGLOCK_ADDR,CHIP,PCFGLOCK,##FIELD,field)
X  #define _CHIP_PCFGLOCK_FSET(FIELD,field)    _PER_FSET(_CHIP_PCFGLOCK_ADDR,CHIP,PCFGLOCK,##FIELD,field)
S
S  #define _CHIP_PCFGLOCK_FSETS(FIELD,SYM)\
S    _PER_FSETS(_CHIP_PCFGLOCK_ADDR,CHIP,PCFGLOCK,##FIELD,##SYM)
X  #define _CHIP_PCFGLOCK_FSETS(FIELD,SYM)    _PER_FSETS(_CHIP_PCFGLOCK_ADDR,CHIP,PCFGLOCK,##FIELD,##SYM)
S
S
N#endif /* CHIP_DM642 || CHIP_DM641 || CHIP_DM640 || CHIP_6412 || CHIP_6410 || CHIP_6413 || CHIP_6418*/
N
N#ifdef __cplusplus
S}
N#endif
N
N/*----------------------------------------------------------------------------*/
N#endif /* _CSL_CHIPHAL_H_ */
N/******************************************************************************\
N* End of csl_chiphal.h
X
N\******************************************************************************/
N
L 20 "E:/TI_workspase/c6701_t/csl/csl_chip.h" 2
N#include <csl_emifhal.h>
L 1 "E:/TI_workspase/c6701_t/csl/csl_emifhal.h" 1
N/******************************************************************************\
N*           Copyright (C) 1999-2000 Texas Instruments Incorporated.
X
N*                           All Rights Reserved
N*------------------------------------------------------------------------------
N* FILENAME...... csl_emifhal.h
N* DATE CREATED.. 06/12/1999 
N* LAST MODIFIED. 06/17/2003  Added CHIP_6712C
N*                05/28/2003  Added CHIP_6711C
N*                10/03/2000
N*------------------------------------------------------------------------------
N* REGISTERS
N*
N* GBLCTL  - global control register
N* CECTL0  - CE space control register 0
N* CECTL1  - CE space control register 1
N* CECTL2  - CE space control register 2
N* CECTL3  - CE space control register 3
N* SDCTL   - SDRAM control regsiter
N* SDTIM   - SDRAM timing register
N* SDEXT   - SDRAM extension register (1)
N*
N* (1) - only supported on 6211,6711,6712,6713,6711C,6712C
N* 
N\******************************************************************************/
N#ifndef _CSL_EMIFHAL_H_
N#define _CSL_EMIFHAL_H_
N
N#include <csl_stdinc.h>
N#include <csl_chip.h>
L 1 "E:/TI_workspase/c6701_t/csl/csl_chip.h" 1
N/******************************************************************************\
N*           Copyright (C) 1999-2001 Texas Instruments Incorporated.
X
N*                           All Rights Reserved
N*------------------------------------------------------------------------------
N* FILENAME...... csl_chip.h
N* DATE CREATED.. 08/19/1999 
N* LAST MODIFIED. 08/02/2004 - Adding support for C6418
N*                06/17/2003   - Added support for 6712C
N*                06/09/2003   - Added support for 6711C
N*                12/03/2001   - CHIP_configArgs
N*                11/08/2001   - CHIP_getSiliconRevId()
N*                             - CHIP_config() / CHIP_getConfig  DM642
N\******************************************************************************/
N#ifndef _CSL_CHIP_H_
S#define _CSL_CHIP_H_
S
S#include <csl_stdinc.h>
S
S#include <csl_chiphal.h>
S#include <csl_emifhal.h>
S
S/******************************************************************************\
S* scope and inline control macros
X
S\******************************************************************************/
S#ifdef __cplusplus
S#define CSLAPI extern "C" far
S#else
S#define CSLAPI extern far
S#endif
S
S#undef  USEDEFS
S#undef  IDECL
S#undef  IDEF
S
S#ifdef  _CHIP_MOD_
S  #define IDECL CSLAPI
S  #define USEDEFS
S  #define IDEF
S#else
S  #ifdef  _INLINE
S    #define IDECL static inline
S    #define USEDEFS
S    #define IDEF  static inline
S  #else
S    #define IDECL CSLAPI
S  #endif
S#endif
S
S
S/******************************************************************************\
S* global macro declarations
X
S\******************************************************************************/
S#define CHIP_ENDIAN_BIG    0
S#define CHIP_ENDIAN_LITTLE 1
S
S#define CHIP_MAP_0         0
S#define CHIP_MAP_1         1
S
S/* Selected devices masks*/
S#if (CHIP_6713 || CHIP_DA610 || CHIP_6711C || CHIP_6712C)
S#define CHIP_EKSRC_SYSCLK3  0x00000000u
S#define CHIP_EKSRC_ECLKIN   0x00000010u
S#endif
S
S#if (CHIP_6713 || CHIP_DA610)
S#define CHIP_TOUT1          0x00000000u
S#define CHIP_AXR04_AXR111   0x00000008u
S
S#define CHIP_TOUT0          0x00000000u
S#define CHIP_AXR02_AXR113   0x00000004u
S
S#define CHIP_MCASP0         0x00000002u
S#define CHIP_MCBSP0         0x00000000u
S
S#define CHIP_I2C1           0x00000001u
S#define CHIP_MCBSP1         0x00000000u
S/* Full mask value */
S#define _CHIP_DEVCFG_MASK  0x0000001Fu
S#endif
S
S#if CHIP_DM642
S#define CHIP_VP2            0x00000040u
S#define CHIP_VP1            0x00000020u
S#define CHIP_VP0            0x00000010u
S#define CHIP_I2C            0x00000008u
S#define CHIP_MCBSP1         0x00000004u
S#define CHIP_MCBSP0         0x00000002u
S#define CHIP_MCASP0         0x00000001u
S
S#define _CHIP_PERCFG_MASK   0x0000007Fu
S#endif
S
S#if CHIP_DM641
S#define CHIP_VP1            0x00000020u
S#define CHIP_VP0            0x00000010u
S#define CHIP_I2C            0x00000008u
S#define CHIP_MCBSP1         0x00000004u
S#define CHIP_MCBSP0         0x00000002u
S#define CHIP_MCASP0         0x00000001u
S
S#define _CHIP_PERCFG_MASK   0x0000003Fu
S#endif
S
S#if CHIP_DM640
S#define CHIP_VP0            0x00000010u
S#define CHIP_I2C            0x00000008u
S#define CHIP_MCBSP1         0x00000004u
S#define CHIP_MCBSP0         0x00000002u
S#define CHIP_MCASP0         0x00000001u
S
S#define _CHIP_PERCFG_MASK   0x0000001Fu
S#endif
S
S#if CHIP_6412
S#define CHIP_I2C            0x00000008u
S#define CHIP_MCBSP1         0x00000004u
S#define CHIP_MCBSP0         0x00000002u
S#define _CHIP_PERCFG_MASK   0x0000000Eu
S#endif
S
S#if (CHIP_6410 || CHIP_6413 || CHIP_6418)
S#define CHIP_AFCMUX         0x00000600u
S#define CHIP_MCASP1         0x00000100u
S#define CHIP_I2C1           0x00000080u
S#define CHIP_I2C0           0x00000008u
S#define CHIP_MCBSP1         0x00000004u
S#define CHIP_MCBSP0         0x00000002u
S#define CHIP_MCASP0         0x00000001u
S
S#define _CHIP_PERCFG_MASK   0x0000078Fu
S#endif
S
S/******************************************************************************\
S* global typedef declarations
X
S\******************************************************************************/
S#if( CHIP_6711C || CHIP_6712C || CHIP_DA610 || CHIP_6713 )
Stypedef struct{
S   Uint32 devcfg;
S} CHIP_Config;
S#elif (CHIP_DM642 || CHIP_DM641 || CHIP_DM640  || CHIP_6412 || CHIP_6410 || CHIP_6413 || CHIP_6418)
Stypedef struct{
S   Uint32 percfg;
S} CHIP_Config; 
S#endif
S/******************************************************************************\
S* global variable declarations
X
S\******************************************************************************/
S
S
S/******************************************************************************\
S* global function declarations
X
S\******************************************************************************/
S
S
S/******************************************************************************\
S* inline function declarations
X
S\******************************************************************************/
SIDECL Uint32 CHIP_getCpuId();
SIDECL Uint32 CHIP_getRevId();
SIDECL Uint32 CHIP_getSiliconRevId();
SIDECL int    CHIP_getEndian();
SIDECL int    CHIP_getMapMode();
S
S#if (CHIP_DM642 || CHIP_DM641 || CHIP_DM640  || CHIP_6412 || CHIP_6410 || CHIP_6413 || CHIP_6418) 
SIDECL void   CHIP_config(CHIP_Config *config);
SIDECL void   CHIP_configArgs(Uint32 percfg);
SIDECL void   CHIP_getConfig(CHIP_Config *config); 
S#elif ( CHIP_6711C || CHIP_6712C || CHIP_DA610 || CHIP_6713 )
SIDECL void   CHIP_config(CHIP_Config *config);
SIDECL void   CHIP_configArgs(Uint32 devcfg);
SIDECL void   CHIP_getConfig(CHIP_Config *config); 
S#endif
S
S/******************************************************************************\
S* inline function definitions
X
S\******************************************************************************/
S#ifdef USEDEFS
S/*----------------------------------------------------------------------------*/
SIDEF Uint32 CHIP_getCpuId() {
S  return CHIP_FGET(CSR,CPUID);
S}
S/*----------------------------------------------------------------------------*/
SIDEF Uint32 CHIP_getRevId() {
S  return CHIP_FGET(CSR,REVID);
S}
S/*----------------------------------------------------------------------------*/
SIDEF Uint32 CHIP_getSiliconRevId() {
S  return (( 0x000F0000 & REG32(0x01B00200))>>16);
S}
S/*----------------------------------------------------------------------------*/
SIDEF int CHIP_getEndian() {
S  return CHIP_FGET(CSR,EN);
S}
S/*----------------------------------------------------------------------------*/
SIDEF int CHIP_getMapMode() {
S  int mapmode = 0;
S  #if (!C11_SUPPORT && !C64_SUPPORT)
S    mapmode = EMIF_FGET(GBLCTL,MAP);
S  #endif
S  return mapmode;
S}
S/*----------------------------------------------------------------------------*/
S#if (CHIP_6713 || CHIP_DM642 || CHIP_DM641 || CHIP_DM640 || CHIP_DA610 || CHIP_6412 || CHIP_6711C || CHIP_6712C || CHIP_6410 || CHIP_6413 || CHIP_6418)
SIDEF void   CHIP_config(CHIP_Config *config) {
S  Uint32 gie = CHIP_FGET(CSR,GIE);
S  
S#if( CHIP_6711C || CHIP_6712C || CHIP_DA610 || CHIP_6713 ) 
S    volatile Uint32 *base = (volatile Uint32 *)(_CHIP_DEVCFG_ADDR);
S    register int x0;
S    CHIP_FSET(CSR,GIE,0);
S    x0 = config->devcfg;
S    base[_CHIP_DEVCFG_OFFSET] = x0;
S    CHIP_FSET(CSR,GIE,gie);
S    
S#else 
S  volatile Uint32 *base = (volatile Uint32 *)(_CHIP_PERCFG_ADDR);
S  register int x0;
S  CHIP_FSET(CSR,GIE,0);
S  CHIP_FSETS(PCFGLOCK,LOCK,UNLOCK);
S  x0 = config->percfg;
S  base[_CHIP_PERCFG_OFFSET] = x0;
S  CHIP_FSET(CSR,GIE,gie);
S  
S#endif
S}      
S#endif
S/*----------------------------------------------------------------------------*/
S#if (CHIP_6713 || CHIP_DM642 || CHIP_DM641 || CHIP_DM640 || CHIP_DA610 || CHIP_6412 || CHIP_6711C || CHIP_6712C || CHIP_6410 || CHIP_6413 || CHIP_6418)
SIDEF void   CHIP_getConfig(CHIP_Config *config) {
S   Uint32 gie = CHIP_FGET(CSR,GIE);
S   
S#if( CHIP_6711C || CHIP_6712C || CHIP_DA610 || CHIP_6713 ) 
S   volatile Uint32 *base = (volatile Uint32 *)(_CHIP_DEVCFG_ADDR);
S   register int x0;
S
S   CHIP_FSET(CSR,GIE,0);
S
S   x0 = base[_CHIP_DEVCFG_OFFSET]; 
S   config->devcfg=x0;
S
S   CHIP_FSET(CSR,GIE,gie);
S   
S#else
S   volatile Uint32 *base = (volatile Uint32 *)(_CHIP_PERCFG_ADDR);
S   register int x0;
S
S   CHIP_FSET(CSR,GIE,0);
S
S   x0 = base[_CHIP_PERCFG_OFFSET]; 
S   config->percfg=x0;
S
S   CHIP_FSET(CSR,GIE,gie);
S   
S#endif
S}      
S#endif
S/*----------------------------------------------------------------------------*/
S   
S#if( CHIP_6711C || CHIP_6712C || CHIP_DA610 || CHIP_6713 )
S   IDEF void   CHIP_configArgs(Uint32 devcfg) {
S   Uint32 gie = CHIP_FGET(CSR,GIE);
S   volatile Uint32 *base = (volatile Uint32 *)(_CHIP_DEVCFG_ADDR);
S   CHIP_FSET(CSR,GIE,0);
S   base[_CHIP_DEVCFG_OFFSET]= devcfg; 
S   CHIP_FSET(CSR,GIE,gie);
S}   
S#elif (CHIP_DM642 || CHIP_DM641 || CHIP_DM640  || CHIP_6412 || CHIP_6410 || CHIP_6413 || CHIP_6418)
S   IDEF void   CHIP_configArgs(Uint32 percfg) {
S   Uint32 gie = CHIP_FGET(CSR,GIE);
S   volatile Uint32 *base = (volatile Uint32 *)(_CHIP_PERCFG_ADDR);
S
S   CHIP_FSET(CSR,GIE,0);
S
S#if(CHIP_DM642 || CHIP_6412)
S   CHIP_FSETS(PCFGLOCK,LOCK,UNLOCK);
S#endif
S
S   base[_CHIP_PERCFG_OFFSET]= percfg; 
S
S   CHIP_FSET(CSR,GIE,gie);
S}   
S#endif
S
S
S/*----------------------------------------------------------------------------*/
S#endif /* USEDEFS */
S
S
N#endif /* _CSL_CHIP_H_ */
N/******************************************************************************\
N* End of csl_chip.h
X
N\******************************************************************************/
N
L 30 "E:/TI_workspase/c6701_t/csl/csl_emifhal.h" 2
N
N#if (EMIF_SUPPORT)
X#if (( ( 1*0) | ( 1*0) | ( 1*0) | ( 1*0) | ( 1*0) | ( 1*0) | ( 1*1) | ( 1*0) | ( 1*0) | ( 1*0) | ( 1*0)| ( 0*0)| ( 0*0)| ( 0*0)| ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 1*0) | ( 1*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) ))
N/******************************************************************************\
N* MISC section
X
N\******************************************************************************/
N#define _EMIF_BASE_GLOBAL   0x01800000u
N
N
N/******************************************************************************\
N* module level register/field access macros
X
N\******************************************************************************/
N
N  /* ----------------- */
N  /* FIELD MAKE MACROS */
N  /* ----------------- */
N
N  #define EMIF_FMK(REG,FIELD,x)\
N    _PER_FMK(EMIF,##REG,##FIELD,x)
X  #define EMIF_FMK(REG,FIELD,x)    _PER_FMK(EMIF,##REG,##FIELD,x)
N
N  #define EMIF_FMKS(REG,FIELD,SYM)\
N    _PER_FMKS(EMIF,##REG,##FIELD,##SYM)
X  #define EMIF_FMKS(REG,FIELD,SYM)    _PER_FMKS(EMIF,##REG,##FIELD,##SYM)
N 
N 
N  /* -------------------------------- */
N  /* RAW REGISTER/FIELD ACCESS MACROS */
N  /* -------------------------------- */
N
N  #define EMIF_ADDR(REG)\
N    _EMIF_##REG##_ADDR
X  #define EMIF_ADDR(REG)    _EMIF_##REG##_ADDR
N
N  #define EMIF_RGET(REG)\
N    _PER_RGET(_EMIF_##REG##_ADDR,EMIF,##REG)
X  #define EMIF_RGET(REG)    _PER_RGET(_EMIF_##REG##_ADDR,EMIF,##REG)
N
N  #define EMIF_RSET(REG,x)\
N    _PER_RSET(_EMIF_##REG##_ADDR,EMIF,##REG,x)
X  #define EMIF_RSET(REG,x)    _PER_RSET(_EMIF_##REG##_ADDR,EMIF,##REG,x)
N
N  #define EMIF_FGET(REG,FIELD)\
N    _EMIF_##REG##_FGET(##FIELD)
X  #define EMIF_FGET(REG,FIELD)    _EMIF_##REG##_FGET(##FIELD)
N
N  #define EMIF_FSET(REG,FIELD,x)\
N    _EMIF_##REG##_FSET(##FIELD,##x)
X  #define EMIF_FSET(REG,FIELD,x)    _EMIF_##REG##_FSET(##FIELD,##x)
N
N  #define EMIF_FSETS(REG,FIELD,SYM)\
N    _EMIF_##REG##_FSETS(##FIELD,##SYM)
X  #define EMIF_FSETS(REG,FIELD,SYM)    _EMIF_##REG##_FSETS(##FIELD,##SYM)
N 
N 
N  /* ------------------------------------------ */
N  /* ADDRESS BASED REGISTER/FIELD ACCESS MACROS */
N  /* ------------------------------------------ */
N
N  #define EMIF_RGETA(addr,REG)\
N    _PER_RGET(addr,EMIF,##REG)
X  #define EMIF_RGETA(addr,REG)    _PER_RGET(addr,EMIF,##REG)
N
N  #define EMIF_RSETA(addr,REG,x)\
N    _PER_RSET(addr,EMIF,##REG,x)
X  #define EMIF_RSETA(addr,REG,x)    _PER_RSET(addr,EMIF,##REG,x)
N
N  #define EMIF_FGETA(addr,REG,FIELD)\
N    _PER_FGET(addr,EMIF,##REG,##FIELD)
X  #define EMIF_FGETA(addr,REG,FIELD)    _PER_FGET(addr,EMIF,##REG,##FIELD)
N
N  #define EMIF_FSETA(addr,REG,FIELD,x)\
N    _PER_FSET(addr,EMIF,##REG,##FIELD,x)
X  #define EMIF_FSETA(addr,REG,FIELD,x)    _PER_FSET(addr,EMIF,##REG,##FIELD,x)
N
N  #define EMIF_FSETSA(addr,REG,FIELD,SYM)\
N    _PER_FSETS(addr,EMIF,##REG,##FIELD,##SYM)
X  #define EMIF_FSETSA(addr,REG,FIELD,SYM)    _PER_FSETS(addr,EMIF,##REG,##FIELD,##SYM)
N
N
N/******************************************************************************\
N* _____________________
X
N* |                   |
N* |  G B L C T L      |
N* |___________________|
N*
N* GBLCTL  - global control register
N*
N* FIELDS (msb -> lsb)
N* (r)  BUSREQ  (1)
N* (r)  ARDY
N* (r)  HOLD
N* (r)  HOLDA
N* (rw) NOHOLD
N* (rw) SDCEN   (2)
N* (rw) SSCEN   (2)
N* (rw) EKEN    (4)
N* (rw) CLK1EN
N* (rw) CLK2EN  (3)
N* (rw) SSCRT   (2)(3)
N* (rw) RBTR8   (2)
N* (r)  MAP     (2)
N*
N* (1) - Field only exists for C11_SUPPORT
N* (2) - Field does not exist for C11_SUPPORT
N* (3) - Field does not exist for 6202/6203/6204/6205 
N* (4) - Field only exixts for C6713, DA610, 6711C, 6712C
N*
N\******************************************************************************/
N  #define _EMIF_GBLCTL_OFFSET          0
N
N  #define _EMIF_GBLCTL_ADDR            0x01800000u
N
N#if (C11_SUPPORT)
X#if (( ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 1*0) | ( 0*1) | ( 1*0) | ( 1*0) | ( 1*0) | ( 1*0)| ( 0*0)| ( 0*0)| ( 0*0)| ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 1*0) | ( 1*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) ))
S  #define _EMIF_GBLCTL_BUSREQ_MASK     0x00000800u
S  #define _EMIF_GBLCTL_BUSREQ_SHIFT    0x0000000Bu
S  #define  EMIF_GBLCTL_BUSREQ_DEFAULT  0x00000000u
S  #define  EMIF_GBLCTL_BUSREQ_OF(x)    _VALUEOF(x)
S  #define  EMIF_GBLCTL_BUSREQ_LOW      0x00000000u
S  #define  EMIF_GBLCTL_BUSREQ_HIGH     0x00000001u
N#endif
N
N  #define _EMIF_GBLCTL_ARDY_MASK       0x00000400u
N  #define _EMIF_GBLCTL_ARDY_SHIFT      0x0000000Au
N  #define  EMIF_GBLCTL_ARDY_DEFAULT    0x00000000u
N  #define  EMIF_GBLCTL_ARDY_OF(x)      _VALUEOF(x)
N  #define  EMIF_GBLCTL_ARDY_LOW        0x00000000u
N  #define  EMIF_GBLCTL_ARDY_HIGH       0x00000001u
N
N  #define _EMIF_GBLCTL_HOLD_MASK       0x00000200u
N  #define _EMIF_GBLCTL_HOLD_SHIFT      0x00000009u
N  #define  EMIF_GBLCTL_HOLD_DEFAULT    0x00000000u
N  #define  EMIF_GBLCTL_HOLD_OF(x)      _VALUEOF(x)
N  #define  EMIF_GBLCTL_HOLD_LOW        0x00000000u
N  #define  EMIF_GBLCTL_HOLD_HIGH       0x00000001u
N
N  #define _EMIF_GBLCTL_HOLDA_MASK      0x00000100u
N  #define _EMIF_GBLCTL_HOLDA_SHIFT     0x00000008u
N  #define  EMIF_GBLCTL_HOLDA_DEFAULT   0x00000000u
N  #define  EMIF_GBLCTL_HOLDA_OF(x)     _VALUEOF(x)
N  #define  EMIF_GBLCTL_HOLDA_LOW       0x00000000u
N  #define  EMIF_GBLCTL_HOLDA_HIGH      0x00000001u
N
N  #define _EMIF_GBLCTL_NOHOLD_MASK     0x00000080u
N  #define _EMIF_GBLCTL_NOHOLD_SHIFT    0x00000007u
N  #define  EMIF_GBLCTL_NOHOLD_DEFAULT  0x00000000u
N  #define  EMIF_GBLCTL_NOHOLD_OF(x)    _VALUEOF(x)
N  #define  EMIF_GBLCTL_NOHOLD_DISABLE  0x00000000u
N  #define  EMIF_GBLCTL_NOHOLD_ENABLE   0x00000001u
N
N#if (CHIP_6201 | CHIP_6202 | CHIP_6203 | CHIP_6204 | CHIP_6205 | CHIP_6701)
X#if (0 | 0 | 0 | 0 | 0 | 1)
N  #define _EMIF_GBLCTL_SDCEN_MASK      0x00000040u
N  #define _EMIF_GBLCTL_SDCEN_SHIFT     0x00000006u
N  #define  EMIF_GBLCTL_SDCEN_DEFAULT   0x00000001u
N  #define  EMIF_GBLCTL_SDCEN_OF(x)     _VALUEOF(x)
N  #define  EMIF_GBLCTL_SDCEN_DISABLE   0x00000000u
N  #define  EMIF_GBLCTL_SDCEN_ENABLE    0x00000001u
N#endif
N
N#if (CHIP_6201 | CHIP_6202 | CHIP_6203 | CHIP_6204 | CHIP_6205 | CHIP_6701)
X#if (0 | 0 | 0 | 0 | 0 | 1)
N  #define _EMIF_GBLCTL_SSCEN_MASK      0x00000020u
N  #define _EMIF_GBLCTL_SSCEN_SHIFT     0x00000005u
N  #define  EMIF_GBLCTL_SSCEN_DEFAULT   0x00000001u
N  #define  EMIF_GBLCTL_SSCEN_OF(x)     _VALUEOF(x)
N  #define  EMIF_GBLCTL_SSCEN_DISABLE   0x00000000u
N  #define  EMIF_GBLCTL_SSCEN_ENABLE    0x00000001u
N#endif
N
N#if (CHIP_6713 || CHIP_DA610 || CHIP_6711C || CHIP_6712C)
X#if (0 || 0 || 0 || 0)
S  #define _EMIF_GBLCTL_EKEN_MASK       0x00000020u
S  #define _EMIF_GBLCTL_EKEN_SHIFT      0x00000005u
S  #define  EMIF_GBLCTL_EKEN_DEFAULT    0x00000001u
S  #define  EMIF_GBLCTL_EKEN_OF(x)      _VALUEOF(x)
S  #define  EMIF_GBLCTL_EKEN_DISABLE    0x00000000u
S  #define  EMIF_GBLCTL_EKEN_ENABLE     0x00000001u
N#endif
N
N  #define _EMIF_GBLCTL_CLK1EN_MASK     0x00000010u
N  #define _EMIF_GBLCTL_CLK1EN_SHIFT    0x00000004u
N
N#if (CHIP_6713 || CHIP_DA610)
X#if (0 || 0)
S  #define  EMIF_GBLCTL_CLK1EN_DEFAULT  0x00000000u
N#else
N  #define  EMIF_GBLCTL_CLK1EN_DEFAULT  0x00000001u
N#endif
N
N  #define  EMIF_GBLCTL_CLK1EN_OF(x)    _VALUEOF(x)
N  #define  EMIF_GBLCTL_CLK1EN_DISABLE  0x00000000u
N  #define  EMIF_GBLCTL_CLK1EN_ENABLE   0x00000001u
N
N#if (!(CHIP_6202|CHIP_6203|CHIP_6204|CHIP_6205))
X#if (!(0|0|0|0))
N  #define _EMIF_GBLCTL_CLK2EN_MASK     0x00000008u
N  #define _EMIF_GBLCTL_CLK2EN_SHIFT    0x00000003u
N  #define  EMIF_GBLCTL_CLK2EN_DEFAULT  0x00000001u
N  #define  EMIF_GBLCTL_CLK2EN_OF(x)    _VALUEOF(x)
N  #define  EMIF_GBLCTL_CLK2EN_DISABLE  0x00000000u
N  #define  EMIF_GBLCTL_CLK2EN_ENABLE   0x00000001u
N#endif
N
N#if (CHIP_6201|CHIP_6701)
X#if (0|1)
N  #define _EMIF_GBLCTL_SSCRT_MASK      0x00000004u
N  #define _EMIF_GBLCTL_SSCRT_SHIFT     0x00000002u
N  #define  EMIF_GBLCTL_SSCRT_DEFAULT   0x00000000u
N  #define  EMIF_GBLCTL_SSCRT_OF(x)     _VALUEOF(x)
N  #define  EMIF_GBLCTL_SSCRT_CPUOVR2   0x00000000u
N  #define  EMIF_GBLCTL_SSCRT_CPU       0x00000001u
N#endif
N
N#if (!C11_SUPPORT)
X#if (!( ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 1*0) | ( 0*1) | ( 1*0) | ( 1*0) | ( 1*0) | ( 1*0)| ( 0*0)| ( 0*0)| ( 0*0)| ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 1*0) | ( 1*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) ))
N  #define _EMIF_GBLCTL_RBTR8_MASK      0x00000002u
N  #define _EMIF_GBLCTL_RBTR8_SHIFT     0x00000001u
N  #define  EMIF_GBLCTL_RBTR8_DEFAULT   0x00000000u
N  #define  EMIF_GBLCTL_RBTR8_OF(x)     _VALUEOF(x)
N  #define  EMIF_GBLCTL_RBTR8_HPRI      0x00000000u
N  #define  EMIF_GBLCTL_RBTR8_8ACC      0x00000001u
N#endif
N
N#if (!C11_SUPPORT)
X#if (!( ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 1*0) | ( 0*1) | ( 1*0) | ( 1*0) | ( 1*0) | ( 1*0)| ( 0*0)| ( 0*0)| ( 0*0)| ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 1*0) | ( 1*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) ))
N  #define _EMIF_GBLCTL_MAP_MASK        0x00000001u
N  #define _EMIF_GBLCTL_MAP_SHIFT       0x00000000u
N  #define  EMIF_GBLCTL_MAP_MAP1        0x00000000u
N  #define  EMIF_GBLCTL_MAP_MAP0        0x00000001u
N  #define  EMIF_GBLCTL_MAP_DEFAULT     0x00000000u
N  #define  EMIF_GBLCTL_MAP_OF(x)       _VALUEOF(x)
N#endif
N
N  #define  EMIF_GBLCTL_OF(x)           _VALUEOF(x)
N
N#if (CHIP_6201|CHIP_6701)
X#if (0|1)
N  #define EMIF_GBLCTL_DEFAULT (Uint32)( \
N    0x00003000\
N    |_PER_FDEFAULT(EMIF,GBLCTL,ARDY)\
N    |_PER_FDEFAULT(EMIF,GBLCTL,HOLD)\
N    |_PER_FDEFAULT(EMIF,GBLCTL,HOLDA)\
N    |_PER_FDEFAULT(EMIF,GBLCTL,NOHOLD)\
N    |_PER_FDEFAULT(EMIF,GBLCTL,SDCEN)\
N    |_PER_FDEFAULT(EMIF,GBLCTL,SSCEN)\
N    |_PER_FDEFAULT(EMIF,GBLCTL,CLK1EN)\
N    |_PER_FDEFAULT(EMIF,GBLCTL,CLK2EN)\
N    |_PER_FDEFAULT(EMIF,GBLCTL,SSCRT)\
N    |_PER_FDEFAULT(EMIF,GBLCTL,RBTR8)\
N    |_PER_FDEFAULT(EMIF,GBLCTL,MAP)\
N  )
X  #define EMIF_GBLCTL_DEFAULT (Uint32)(     0x00003000    |_PER_FDEFAULT(EMIF,GBLCTL,ARDY)    |_PER_FDEFAULT(EMIF,GBLCTL,HOLD)    |_PER_FDEFAULT(EMIF,GBLCTL,HOLDA)    |_PER_FDEFAULT(EMIF,GBLCTL,NOHOLD)    |_PER_FDEFAULT(EMIF,GBLCTL,SDCEN)    |_PER_FDEFAULT(EMIF,GBLCTL,SSCEN)    |_PER_FDEFAULT(EMIF,GBLCTL,CLK1EN)    |_PER_FDEFAULT(EMIF,GBLCTL,CLK2EN)    |_PER_FDEFAULT(EMIF,GBLCTL,SSCRT)    |_PER_FDEFAULT(EMIF,GBLCTL,RBTR8)    |_PER_FDEFAULT(EMIF,GBLCTL,MAP)  )
N
N  #define EMIF_GBLCTL_RMK(nohold,sdcen,sscen,clk1en,clk2en,sscrt,rbtr8) \
N    (Uint32)( \
N     _PER_FMK(EMIF,GBLCTL,NOHOLD,nohold)\
N    |_PER_FMK(EMIF,GBLCTL,SDCEN,sdcen)\
N    |_PER_FMK(EMIF,GBLCTL,SSCEN,sscen)\
N    |_PER_FMK(EMIF,GBLCTL,CLK1EN,clk1en)\
N    |_PER_FMK(EMIF,GBLCTL,CLK2EN,clk2en)\
N    |_PER_FMK(EMIF,GBLCTL,SSCRT,sscrt)\
N    |_PER_FMK(EMIF,GBLCTL,RBTR8,rbtr8)\
N  )
X  #define EMIF_GBLCTL_RMK(nohold,sdcen,sscen,clk1en,clk2en,sscrt,rbtr8)     (Uint32)(      _PER_FMK(EMIF,GBLCTL,NOHOLD,nohold)    |_PER_FMK(EMIF,GBLCTL,SDCEN,sdcen)    |_PER_FMK(EMIF,GBLCTL,SSCEN,sscen)    |_PER_FMK(EMIF,GBLCTL,CLK1EN,clk1en)    |_PER_FMK(EMIF,GBLCTL,CLK2EN,clk2en)    |_PER_FMK(EMIF,GBLCTL,SSCRT,sscrt)    |_PER_FMK(EMIF,GBLCTL,RBTR8,rbtr8)  )
N#endif
N
N#if (CHIP_6211|CHIP_6711)
X#if (0|0)
S  #define EMIF_GBLCTL_DEFAULT (Uint32)( \
S    0x00003000\
S    |_PER_FDEFAULT(EMIF,GBLCTL,BUSREQ)\
S    |_PER_FDEFAULT(EMIF,GBLCTL,ARDY)\
S    |_PER_FDEFAULT(EMIF,GBLCTL,HOLD)\
S    |_PER_FDEFAULT(EMIF,GBLCTL,HOLDA)\
S    |_PER_FDEFAULT(EMIF,GBLCTL,NOHOLD)\
S    |_PER_FDEFAULT(EMIF,GBLCTL,CLK1EN)\
S    |_PER_FDEFAULT(EMIF,GBLCTL,CLK2EN)\
S  )
X  #define EMIF_GBLCTL_DEFAULT (Uint32)(     0x00003000    |_PER_FDEFAULT(EMIF,GBLCTL,BUSREQ)    |_PER_FDEFAULT(EMIF,GBLCTL,ARDY)    |_PER_FDEFAULT(EMIF,GBLCTL,HOLD)    |_PER_FDEFAULT(EMIF,GBLCTL,HOLDA)    |_PER_FDEFAULT(EMIF,GBLCTL,NOHOLD)    |_PER_FDEFAULT(EMIF,GBLCTL,CLK1EN)    |_PER_FDEFAULT(EMIF,GBLCTL,CLK2EN)  )
S
S  #define EMIF_GBLCTL_RMK(nohold,clk1en,clk2en) (Uint32)( \
S     _PER_FMK(EMIF,GBLCTL,NOHOLD,nohold)\
S    |_PER_FMK(EMIF,GBLCTL,CLK1EN,clk1en)\
S    |_PER_FMK(EMIF,GBLCTL,CLK2EN,clk2en)\
S  )
X  #define EMIF_GBLCTL_RMK(nohold,clk1en,clk2en) (Uint32)(      _PER_FMK(EMIF,GBLCTL,NOHOLD,nohold)    |_PER_FMK(EMIF,GBLCTL,CLK1EN,clk1en)    |_PER_FMK(EMIF,GBLCTL,CLK2EN,clk2en)  )
N#endif
N
N#if (CHIP_6202|CHIP_6203|CHIP_6204|CHIP_6205)
X#if (0|0|0|0)
S  #define EMIF_GBLCTL_DEFAULT (Uint32)( \
S    0x00003008\
S    |_PER_FDEFAULT(EMIF,GBLCTL,ARDY)\
S    |_PER_FDEFAULT(EMIF,GBLCTL,HOLD)\
S    |_PER_FDEFAULT(EMIF,GBLCTL,HOLDA)\
S    |_PER_FDEFAULT(EMIF,GBLCTL,NOHOLD)\
S    |_PER_FDEFAULT(EMIF,GBLCTL,SDCEN)\
S    |_PER_FDEFAULT(EMIF,GBLCTL,SSCEN)\
S    |_PER_FDEFAULT(EMIF,GBLCTL,CLK1EN)\
S    |_PER_FDEFAULT(EMIF,GBLCTL,RBTR8)\
S    |_PER_FDEFAULT(EMIF,GBLCTL,MAP)\
S  )
X  #define EMIF_GBLCTL_DEFAULT (Uint32)(     0x00003008    |_PER_FDEFAULT(EMIF,GBLCTL,ARDY)    |_PER_FDEFAULT(EMIF,GBLCTL,HOLD)    |_PER_FDEFAULT(EMIF,GBLCTL,HOLDA)    |_PER_FDEFAULT(EMIF,GBLCTL,NOHOLD)    |_PER_FDEFAULT(EMIF,GBLCTL,SDCEN)    |_PER_FDEFAULT(EMIF,GBLCTL,SSCEN)    |_PER_FDEFAULT(EMIF,GBLCTL,CLK1EN)    |_PER_FDEFAULT(EMIF,GBLCTL,RBTR8)    |_PER_FDEFAULT(EMIF,GBLCTL,MAP)  )
S
S  #define EMIF_GBLCTL_RMK(nohold,sdcen,sscen,clk1en,rbtr8) (Uint32)( \
S     _PER_FMK(EMIF,GBLCTL,NOHOLD,nohold)\
S    |_PER_FMK(EMIF,GBLCTL,SDCEN,sdcen)\
S    |_PER_FMK(EMIF,GBLCTL,SSCEN,sscen)\
S    |_PER_FMK(EMIF,GBLCTL,CLK1EN,clk1en)\
S    |_PER_FMK(EMIF,GBLCTL,RBTR8,rbtr8)\
S  )
X  #define EMIF_GBLCTL_RMK(nohold,sdcen,sscen,clk1en,rbtr8) (Uint32)(      _PER_FMK(EMIF,GBLCTL,NOHOLD,nohold)    |_PER_FMK(EMIF,GBLCTL,SDCEN,sdcen)    |_PER_FMK(EMIF,GBLCTL,SSCEN,sscen)    |_PER_FMK(EMIF,GBLCTL,CLK1EN,clk1en)    |_PER_FMK(EMIF,GBLCTL,RBTR8,rbtr8)  )
N#endif
N
N#if (CHIP_6713 || CHIP_DA610 || CHIP_6711C || CHIP_6712C)
X#if (0 || 0 || 0 || 0)
S  #define EMIF_GBLCTL_DEFAULT (Uint32)( \
S    0x00003000\
S    |_PER_FDEFAULT(EMIF,GBLCTL,BUSREQ)\
S    |_PER_FDEFAULT(EMIF,GBLCTL,ARDY)\
S    |_PER_FDEFAULT(EMIF,GBLCTL,HOLD)\
S    |_PER_FDEFAULT(EMIF,GBLCTL,HOLDA)\
S    |_PER_FDEFAULT(EMIF,GBLCTL,NOHOLD)\
S    |_PER_FDEFAULT(EMIF,GBLCTL,EKEN)\
S    |_PER_FDEFAULT(EMIF,GBLCTL,CLK1EN)\
S    |_PER_FDEFAULT(EMIF,GBLCTL,CLK2EN)\
S  )
X  #define EMIF_GBLCTL_DEFAULT (Uint32)(     0x00003000    |_PER_FDEFAULT(EMIF,GBLCTL,BUSREQ)    |_PER_FDEFAULT(EMIF,GBLCTL,ARDY)    |_PER_FDEFAULT(EMIF,GBLCTL,HOLD)    |_PER_FDEFAULT(EMIF,GBLCTL,HOLDA)    |_PER_FDEFAULT(EMIF,GBLCTL,NOHOLD)    |_PER_FDEFAULT(EMIF,GBLCTL,EKEN)    |_PER_FDEFAULT(EMIF,GBLCTL,CLK1EN)    |_PER_FDEFAULT(EMIF,GBLCTL,CLK2EN)  )
S
S  #define EMIF_GBLCTL_RMK(nohold,eken,clk1en,clk2en) (Uint32)( \
S     _PER_FMK(EMIF,GBLCTL,NOHOLD,nohold)\
S    |_PER_FMK(EMIF,GBLCTL,EKEN,eken)\
S    |_PER_FMK(EMIF,GBLCTL,CLK1EN,clk1en)\
S    |_PER_FMK(EMIF,GBLCTL,CLK2EN,clk2en)\
S  )
X  #define EMIF_GBLCTL_RMK(nohold,eken,clk1en,clk2en) (Uint32)(      _PER_FMK(EMIF,GBLCTL,NOHOLD,nohold)    |_PER_FMK(EMIF,GBLCTL,EKEN,eken)    |_PER_FMK(EMIF,GBLCTL,CLK1EN,clk1en)    |_PER_FMK(EMIF,GBLCTL,CLK2EN,clk2en)  )
N#endif
N
N  #define _EMIF_GBLCTL_FGET(FIELD)\
N    _PER_FGET(_EMIF_GBLCTL_ADDR,EMIF,GBLCTL,##FIELD)
X  #define _EMIF_GBLCTL_FGET(FIELD)    _PER_FGET(_EMIF_GBLCTL_ADDR,EMIF,GBLCTL,##FIELD)
N
N  #define _EMIF_GBLCTL_FSET(FIELD,field)\
N    _PER_FSET(_EMIF_GBLCTL_ADDR,EMIF,GBLCTL,##FIELD,field)
X  #define _EMIF_GBLCTL_FSET(FIELD,field)    _PER_FSET(_EMIF_GBLCTL_ADDR,EMIF,GBLCTL,##FIELD,field)
N
N  #define _EMIF_GBLCTL_FSETS(FIELD,SYM)\
N    _PER_FSETS(_EMIF_GBLCTL_ADDR,EMIF,GBLCTL,##FIELD,##SYM)
X  #define _EMIF_GBLCTL_FSETS(FIELD,SYM)    _PER_FSETS(_EMIF_GBLCTL_ADDR,EMIF,GBLCTL,##FIELD,##SYM)
N
N
N/******************************************************************************\
N* _____________________
X
N* |                   |
N* |  C E C T L        |
N* |___________________|
N*
N* CECTL0 - CE space control register 0
N* CECTL1 - CE space control register 1
N* CECTL2 - CE space control register 2
N* CECTL3 - CE space control register 3
N*
N* FIELDS (msb -> lsb)
N* (rw) WRSETUP
N* (rw) WRSTRB
N* (rw) WRHLD
N* (rw) RDSETUP
N* (rw) TA       (1) 
N* (rw) RDSTRB
N* (rw) MTYPE
N* (rw) WRHLDMSB 
N* (rw) RDHLD
N*
N* (1) - Field only exists for C11_SUPPORT
N* 
N*
N\******************************************************************************/
N  #define _EMIF_CECTL0_OFFSET          2
N  #define _EMIF_CECTL1_OFFSET          1
N  #define _EMIF_CECTL2_OFFSET          4
N  #define _EMIF_CECTL3_OFFSET          5
N
N  #define _EMIF_CECTL0_ADDR            0x01800008u
N  #define _EMIF_CECTL1_ADDR            0x01800004u
N  #define _EMIF_CECTL2_ADDR            0x01800010u
N  #define _EMIF_CECTL3_ADDR            0x01800014u
N
N  #define _EMIF_CECTL_WRSETUP_MASK     0xF0000000u
N  #define _EMIF_CECTL_WRSETUP_SHIFT    0x0000001Cu
N  #define  EMIF_CECTL_WRSETUP_DEFAULT  0x0000000Fu
N  #define  EMIF_CECTL_WRSETUP_OF(x)    _VALUEOF(x)
N
N  #define _EMIF_CECTL_WRSTRB_MASK      0x0FC00000u
N  #define _EMIF_CECTL_WRSTRB_SHIFT     0x00000016u
N  #define  EMIF_CECTL_WRSTRB_DEFAULT   0x0000003Fu
N  #define  EMIF_CECTL_WRSTRB_OF(x)     _VALUEOF(x)
N
N  #define _EMIF_CECTL_WRHLD_MASK       0x00300000u
N  #define _EMIF_CECTL_WRHLD_SHIFT      0x00000014u
N  #define  EMIF_CECTL_WRHLD_DEFAULT    0x00000003u
N  #define  EMIF_CECTL_WRHLD_OF(x)      _VALUEOF(x)
N  
N  #define _EMIF_CECTL_RDSETUP_MASK     0x000F0000u
N  #define _EMIF_CECTL_RDSETUP_SHIFT    0x00000010u
N  #define  EMIF_CECTL_RDSETUP_DEFAULT  0x0000000Fu
N  #define  EMIF_CECTL_RDSETUP_OF(x)    _VALUEOF(x)
N
N#if (C11_SUPPORT)
X#if (( ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 1*0) | ( 0*1) | ( 1*0) | ( 1*0) | ( 1*0) | ( 1*0)| ( 0*0)| ( 0*0)| ( 0*0)| ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 1*0) | ( 1*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) ))
S  #define _EMIF_CECTL_TA_MASK          0x0000C000u
S  #define _EMIF_CECTL_TA_SHIFT         0x0000000Eu
S  #define  EMIF_CECTL_TA_DEFAULT       0x00000003u
S  #define  EMIF_CECTL_TA_OF(x)         _VALUEOF(x)
N#endif
N
N  #define _EMIF_CECTL_RDSTRB_MASK      0x00003F00u
N  #define _EMIF_CECTL_RDSTRB_SHIFT     0x00000008u
N  #define  EMIF_CECTL_RDSTRB_DEFAULT   0x0000003Fu
N  #define  EMIF_CECTL_RDSTRB_OF(x)     _VALUEOF(x)
N  
N#if (C11_SUPPORT)
X#if (( ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 1*0) | ( 0*1) | ( 1*0) | ( 1*0) | ( 1*0) | ( 1*0)| ( 0*0)| ( 0*0)| ( 0*0)| ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 1*0) | ( 1*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) ))
S  #define _EMIF_CECTL_MTYPE_MASK       0x000000F0u
S  #define _EMIF_CECTL_MTYPE_SHIFT      0x00000004u
S  #define  EMIF_CECTL_MTYPE_DEFAULT    0x00000002u
S  #define  EMIF_CECTL_MTYPE_OF(x)      _VALUEOF(x)
S  #if (CHIP_6712 || CHIP_6712C)  /* 16-bit EMIF */ 
S  #define  EMIFB_CECTL_MTYPE_ASYNC8     0x00000000u 
S  #define  EMIFB_CECTL_MTYPE_ASYNC16    0x00000001u 
S  #define  EMIFB_CECTL_MTYPE_SDRAM8     0x00000008u 
S  #define  EMIFB_CECTL_MTYPE_SDRAM16    0x00000009u 
S  #define  EMIFB_CECTL_MTYPE_SYNC8      0x0000000Au 
S  #define  EMIFB_CECTL_MTYPE_SYNC16     0x0000000Bu 
S  #else /* CHIP_6211/C6711/6711C 32-bit EMIF */
S  #define  EMIF_CECTL_MTYPE_ASYNC8     0x00000000u
S  #define  EMIF_CECTL_MTYPE_ASYNC16    0x00000001u
S  #define  EMIF_CECTL_MTYPE_ASYNC32    0x00000002u
S  #define  EMIF_CECTL_MTYPE_SDRAM32    0x00000003u
S  #define  EMIF_CECTL_MTYPE_SBSRAM32   0x00000004u
S  #define  EMIF_CECTL_MTYPE_SDRAM8     0x00000008u
S  #define  EMIF_CECTL_MTYPE_SDRAM16    0x00000009u
S  #define  EMIF_CECTL_MTYPE_SBSRAM8    0x0000000Au
S  #define  EMIF_CECTL_MTYPE_SBSRAM16   0x0000000Bu
S  #endif
S 
N#else
N  #define _EMIF_CECTL_MTYPE_MASK       0x00000070u
N  #define _EMIF_CECTL_MTYPE_SHIFT      0x00000004u
N  #define  EMIF_CECTL_MTYPE_DEFAULT    0x00000002u
N  #define  EMIF_CECTL_MTYPE_OF(x)      _VALUEOF(x)
N  #define  EMIF_CECTL_MTYPE_ASYNC8     0x00000000u
N  #define  EMIF_CECTL_MTYPE_ASYNC16    0x00000001u
N  #define  EMIF_CECTL_MTYPE_ASYNC32    0x00000002u
N  #define  EMIF_CECTL_MTYPE_SDRAM32    0x00000003u
N  #define  EMIF_CECTL_MTYPE_SBSRAM32   0x00000004u
N#endif
N
N
N#if (C11_SUPPORT )
X#if (( ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 1*0) | ( 0*1) | ( 1*0) | ( 1*0) | ( 1*0) | ( 1*0)| ( 0*0)| ( 0*0)| ( 0*0)| ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 1*0) | ( 1*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) ) )
S  #define _EMIF_CECTL_RDHLD_MASK       0x00000007u
S  #define _EMIF_CECTL_RDHLD_SHIFT      0x00000000u
S  #define  EMIF_CECTL_RDHLD_DEFAULT    0x00000003u
S  #define  EMIF_CECTL_RDHLD_OF(x)      _VALUEOF(x)
N#else
N  #define _EMIF_CECTL_RDHLD_MASK       0x00000003u
N  #define _EMIF_CECTL_RDHLD_SHIFT      0x00000000u
N  #define  EMIF_CECTL_RDHLD_DEFAULT    0x00000003u
N  #define  EMIF_CECTL_RDHLD_OF(x)      _VALUEOF(x)
N#endif
N
N  #define  EMIF_CECTL_OF(x)            _VALUEOF(x)
N
N#if (C11_SUPPORT)
X#if (( ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 1*0) | ( 0*1) | ( 1*0) | ( 1*0) | ( 1*0) | ( 1*0)| ( 0*0)| ( 0*0)| ( 0*0)| ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 1*0) | ( 1*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) ))
S  #define EMIF_CECTL_DEFAULT (Uint32)( \
S     _PER_FDEFAULT(EMIF,CECTL,WRSETUP)\
S    |_PER_FDEFAULT(EMIF,CECTL,WRSTRB)\
S    |_PER_FDEFAULT(EMIF,CECTL,WRHLD)\
S    |_PER_FDEFAULT(EMIF,CECTL,RDSETUP)\
S    |_PER_FDEFAULT(EMIF,CECTL,TA)\
S    |_PER_FDEFAULT(EMIF,CECTL,RDSTRB)\
S    |_PER_FDEFAULT(EMIF,CECTL,MTYPE)\
S    |_PER_FDEFAULT(EMIF,CECTL,RDHLD)\
S  )
X  #define EMIF_CECTL_DEFAULT (Uint32)(      _PER_FDEFAULT(EMIF,CECTL,WRSETUP)    |_PER_FDEFAULT(EMIF,CECTL,WRSTRB)    |_PER_FDEFAULT(EMIF,CECTL,WRHLD)    |_PER_FDEFAULT(EMIF,CECTL,RDSETUP)    |_PER_FDEFAULT(EMIF,CECTL,TA)    |_PER_FDEFAULT(EMIF,CECTL,RDSTRB)    |_PER_FDEFAULT(EMIF,CECTL,MTYPE)    |_PER_FDEFAULT(EMIF,CECTL,RDHLD)  )
S
S  #define EMIF_CECTL_RMK(wrsetup,wrstrb,wrhld,rdsetup,ta,rdstrb,mtype,\
S    rdhld) (Uint32)( \
S     _PER_FMK(EMIF,CECTL,WRSETUP,wrsetup)\
S    |_PER_FMK(EMIF,CECTL,WRSTRB,wrstrb)\
S    |_PER_FMK(EMIF,CECTL,WRHLD,wrhld)\
S    |_PER_FMK(EMIF,CECTL,RDSETUP,rdsetup)\
S    |_PER_FMK(EMIF,CECTL,TA,ta)\
S    |_PER_FMK(EMIF,CECTL,RDSTRB,rdstrb)\
S    |_PER_FMK(EMIF,CECTL,MTYPE,mtype)\
S    |_PER_FMK(EMIF,CECTL,RDHLD,rdhld)\
S  )
X  #define EMIF_CECTL_RMK(wrsetup,wrstrb,wrhld,rdsetup,ta,rdstrb,mtype,    rdhld) (Uint32)(      _PER_FMK(EMIF,CECTL,WRSETUP,wrsetup)    |_PER_FMK(EMIF,CECTL,WRSTRB,wrstrb)    |_PER_FMK(EMIF,CECTL,WRHLD,wrhld)    |_PER_FMK(EMIF,CECTL,RDSETUP,rdsetup)    |_PER_FMK(EMIF,CECTL,TA,ta)    |_PER_FMK(EMIF,CECTL,RDSTRB,rdstrb)    |_PER_FMK(EMIF,CECTL,MTYPE,mtype)    |_PER_FMK(EMIF,CECTL,RDHLD,rdhld)  )
N#endif
N
N
N
N#if (!C11_SUPPORT)
X#if (!( ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 1*0) | ( 0*1) | ( 1*0) | ( 1*0) | ( 1*0) | ( 1*0)| ( 0*0)| ( 0*0)| ( 0*0)| ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 1*0) | ( 1*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) ))
N  #define EMIF_CECTL_DEFAULT (Uint32)( \
N     _PER_FDEFAULT(EMIF,CECTL,WRSETUP)\
N    |_PER_FDEFAULT(EMIF,CECTL,WRSTRB)\
N    |_PER_FDEFAULT(EMIF,CECTL,WRHLD)\
N    |_PER_FDEFAULT(EMIF,CECTL,RDSETUP)\
N    |_PER_FDEFAULT(EMIF,CECTL,RDSTRB)\
N    |_PER_FDEFAULT(EMIF,CECTL,MTYPE)\
N    |_PER_FDEFAULT(EMIF,CECTL,RDHLD)\
N  )
X  #define EMIF_CECTL_DEFAULT (Uint32)(      _PER_FDEFAULT(EMIF,CECTL,WRSETUP)    |_PER_FDEFAULT(EMIF,CECTL,WRSTRB)    |_PER_FDEFAULT(EMIF,CECTL,WRHLD)    |_PER_FDEFAULT(EMIF,CECTL,RDSETUP)    |_PER_FDEFAULT(EMIF,CECTL,RDSTRB)    |_PER_FDEFAULT(EMIF,CECTL,MTYPE)    |_PER_FDEFAULT(EMIF,CECTL,RDHLD)  )
N
N  #define EMIF_CECTL_RMK(wrsetup,wrstrb,wrhld,rdsetup,rdstrb,mtype,\
N    rdhld) (Uint32)( \
N     _PER_FMK(EMIF,CECTL,WRSETUP,wrsetup)\
N    |_PER_FMK(EMIF,CECTL,WRSTRB,wrstrb)\
N    |_PER_FMK(EMIF,CECTL,WRHLD,wrhld)\
N    |_PER_FMK(EMIF,CECTL,RDSETUP,rdsetup)\
N    |_PER_FMK(EMIF,CECTL,RDSTRB,rdstrb)\
N    |_PER_FMK(EMIF,CECTL,MTYPE,mtype)\
N    |_PER_FMK(EMIF,CECTL,RDHLD,rdhld)\
N  )
X  #define EMIF_CECTL_RMK(wrsetup,wrstrb,wrhld,rdsetup,rdstrb,mtype,    rdhld) (Uint32)(      _PER_FMK(EMIF,CECTL,WRSETUP,wrsetup)    |_PER_FMK(EMIF,CECTL,WRSTRB,wrstrb)    |_PER_FMK(EMIF,CECTL,WRHLD,wrhld)    |_PER_FMK(EMIF,CECTL,RDSETUP,rdsetup)    |_PER_FMK(EMIF,CECTL,RDSTRB,rdstrb)    |_PER_FMK(EMIF,CECTL,MTYPE,mtype)    |_PER_FMK(EMIF,CECTL,RDHLD,rdhld)  )
N#endif
N
N  #define _EMIF_CECTL_FGET(N,FIELD)\
N    _PER_FGET(_EMIF_CECTL##N##_ADDR,EMIF,CECTL,##FIELD)
X  #define _EMIF_CECTL_FGET(N,FIELD)    _PER_FGET(_EMIF_CECTL##N##_ADDR,EMIF,CECTL,##FIELD)
N
N  #define _EMIF_CECTL_FSET(N,FIELD,f)\
N    _PER_FSET(_EMIF_CECTL##N##_ADDR,EMIF,CECTL,##FIELD,f)
X  #define _EMIF_CECTL_FSET(N,FIELD,f)    _PER_FSET(_EMIF_CECTL##N##_ADDR,EMIF,CECTL,##FIELD,f)
N
N  #define _EMIF_CECTL_FSETS(N,FIELD,SYM)\
N    _PER_FSETS(_EMIF_CECTL##N##_ADDR,EMIF,CECTL,##FIELD,##SYM)
X  #define _EMIF_CECTL_FSETS(N,FIELD,SYM)    _PER_FSETS(_EMIF_CECTL##N##_ADDR,EMIF,CECTL,##FIELD,##SYM)
N
N  #define _EMIF_CECTL0_FGET(FIELD) _EMIF_CECTL_FGET(0,##FIELD)
N  #define _EMIF_CECTL1_FGET(FIELD) _EMIF_CECTL_FGET(1,##FIELD)
N  #define _EMIF_CECTL2_FGET(FIELD) _EMIF_CECTL_FGET(2,##FIELD)
N  #define _EMIF_CECTL3_FGET(FIELD) _EMIF_CECTL_FGET(3,##FIELD)
N
N  #define _EMIF_CECTL0_FSET(FIELD,f) _EMIF_CECTL_FSET(0,##FIELD,f)
N  #define _EMIF_CECTL1_FSET(FIELD,f) _EMIF_CECTL_FSET(1,##FIELD,f)
N  #define _EMIF_CECTL2_FSET(FIELD,f) _EMIF_CECTL_FSET(2,##FIELD,f)
N  #define _EMIF_CECTL3_FSET(FIELD,f) _EMIF_CECTL_FSET(3,##FIELD,f)
N
N  #define _EMIF_CECTL0_FSETS(FIELD,SYM) _EMIF_CECTL_FSETS(0,##FIELD,##SYM)
N  #define _EMIF_CECTL1_FSETS(FIELD,SYM) _EMIF_CECTL_FSETS(1,##FIELD,##SYM)
N  #define _EMIF_CECTL2_FSETS(FIELD,SYM) _EMIF_CECTL_FSETS(2,##FIELD,##SYM)
N  #define _EMIF_CECTL3_FSETS(FIELD,SYM) _EMIF_CECTL_FSETS(3,##FIELD,##SYM)
N
N
N/******************************************************************************\
N* _____________________
X
N* |                   |
N* |  S D C T L        |
N* |___________________|
N*
N* SDCTL   - SDRAM control regsiter
N*
N* FIELDS (msb -> lsb)
N* (rw) SDBSZ (2)
N* (rw) SDRSZ (2)
N* (rw) SDCSZ (2)
N* (rw) SDWID (1)
N* (rw) RFEN
N* (r)  INIT
N* (rw) TRCD
N* (rw) TRP
N* (rw) TRC
N*
N* (1) - Field only exists for C01_SUPPORT
N* (2) - Field only exists for C11_SUPPORT 
N*
N\******************************************************************************/
N  #define _EMIF_SDCTL_OFFSET           6
N
N  #define _EMIF_SDCTL_ADDR             0x01800018u
N
N#if (C11_SUPPORT)
X#if (( ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 1*0) | ( 0*1) | ( 1*0) | ( 1*0) | ( 1*0) | ( 1*0)| ( 0*0)| ( 0*0)| ( 0*0)| ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 1*0) | ( 1*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) ))
S  #define _EMIF_SDCTL_SDBSZ_MASK       0x40000000u
S  #define _EMIF_SDCTL_SDBSZ_SHIFT      0x0000001Eu
S  #define  EMIF_SDCTL_SDBSZ_DEFAULT    0x00000000u
S  #define  EMIF_SDCTL_SDBSZ_OF(x)      _VALUEOF(x)
S  #define  EMIF_SDCTL_SDBSZ_2BANKS     0x00000000u
S  #define  EMIF_SDCTL_SDBSZ_4BANKS     0x00000001u
N#endif
N  
N#if (C11_SUPPORT)
X#if (( ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 1*0) | ( 0*1) | ( 1*0) | ( 1*0) | ( 1*0) | ( 1*0)| ( 0*0)| ( 0*0)| ( 0*0)| ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 1*0) | ( 1*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) ))
S  #define _EMIF_SDCTL_SDRSZ_MASK       0x30000000u
S  #define _EMIF_SDCTL_SDRSZ_SHIFT      0x0000001Cu
S  #define  EMIF_SDCTL_SDRSZ_DEFAULT    0x00000000u
S  #define  EMIF_SDCTL_SDRSZ_OF(x)      _VALUEOF(x)
S  #define  EMIF_SDCTL_SDRSZ_11ROW      0x00000000u
S  #define  EMIF_SDCTL_SDRSZ_12ROW      0x00000001u
S  #define  EMIF_SDCTL_SDRSZ_13ROW      0x00000002u
N#endif
N  
N#if (C11_SUPPORT)
X#if (( ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 1*0) | ( 0*1) | ( 1*0) | ( 1*0) | ( 1*0) | ( 1*0)| ( 0*0)| ( 0*0)| ( 0*0)| ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 1*0) | ( 1*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) ))
S  #define _EMIF_SDCTL_SDCSZ_MASK       0x0C000000u
S  #define _EMIF_SDCTL_SDCSZ_SHIFT      0x0000001Au
S  #define  EMIF_SDCTL_SDCSZ_DEFAULT    0x00000000u
S  #define  EMIF_SDCTL_SDCSZ_OF(x)      _VALUEOF(x)
S  #define  EMIF_SDCTL_SDCSZ_9COL       0x00000000u
S  #define  EMIF_SDCTL_SDCSZ_8COL       0x00000001u
S  #define  EMIF_SDCTL_SDCSZ_10COL      0x00000002u
N#endif
N  
N#if !(C11_SUPPORT) 
X#if !(( ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 1*0) | ( 0*1) | ( 1*0) | ( 1*0) | ( 1*0) | ( 1*0)| ( 0*0)| ( 0*0)| ( 0*0)| ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 1*0) | ( 1*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) )) 
N  #define _EMIF_SDCTL_SDWID_MASK       0x04000000u
N  #define _EMIF_SDCTL_SDWID_SHIFT      0x0000001Au
N  #define  EMIF_SDCTL_SDWID_DEFAULT    0x00000000u
N  #define  EMIF_SDCTL_SDWID_OF(x)      _VALUEOF(x)
N  #define  EMIF_SDCTL_SDWID_4X8BIT     0x00000000u
N  #define  EMIF_SDCTL_SDWID_2X16BIT    0x00000001u
N#endif
N  
N  #define _EMIF_SDCTL_RFEN_MASK        0x02000000u
N  #define _EMIF_SDCTL_RFEN_SHIFT       0x00000019u
N  #define  EMIF_SDCTL_RFEN_DEFAULT     0x00000001u
N  #define  EMIF_SDCTL_RFEN_OF(x)       _VALUEOF(x)
N  #define  EMIF_SDCTL_RFEN_DISABLE     0x00000000u
N  #define  EMIF_SDCTL_RFEN_ENABLE      0x00000001u
N
N  #define _EMIF_SDCTL_INIT_MASK        0x01000000u
N  #define _EMIF_SDCTL_INIT_SHIFT       0x00000018u
N  #define  EMIF_SDCTL_INIT_DEFAULT     0x00000001u
N  #define  EMIF_SDCTL_INIT_OF(x)       _VALUEOF(x)
N  #define  EMIF_SDCTL_INIT_NO          0x00000000u
N  #define  EMIF_SDCTL_INIT_YES         0x00000001u
N
N#if (C11_SUPPORT)
X#if (( ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 1*0) | ( 0*1) | ( 1*0) | ( 1*0) | ( 1*0) | ( 1*0)| ( 0*0)| ( 0*0)| ( 0*0)| ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 1*0) | ( 1*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) ))
S  #define _EMIF_SDCTL_TRCD_MASK        0x00F00000u
S  #define _EMIF_SDCTL_TRCD_SHIFT       0x00000014u
S  #define  EMIF_SDCTL_TRCD_DEFAULT     0x00000004u
S  #define  EMIF_SDCTL_TRCD_OF(x)       _VALUEOF(x)
N#else
N  #define _EMIF_SDCTL_TRCD_MASK        0x00F00000u
N  #define _EMIF_SDCTL_TRCD_SHIFT       0x00000014u
N  #define  EMIF_SDCTL_TRCD_DEFAULT     0x00000008u
N  #define  EMIF_SDCTL_TRCD_OF(x)       _VALUEOF(x)
N#endif
N
N  #define _EMIF_SDCTL_TRP_MASK         0x000F0000u
N  #define _EMIF_SDCTL_TRP_SHIFT        0x00000010u
N  #define  EMIF_SDCTL_TRP_DEFAULT      0x00000008u
N  #define  EMIF_SDCTL_TRP_OF(x)        _VALUEOF(x)
N
N  #define _EMIF_SDCTL_TRC_MASK         0x0000F000u
N  #define _EMIF_SDCTL_TRC_SHIFT        0x0000000Cu
N  #define  EMIF_SDCTL_TRC_DEFAULT      0x0000000Fu
N  #define  EMIF_SDCTL_TRC_OF(x)        _VALUEOF(x)
N
N  #define  EMIF_SDCTL_OF(x)            _VALUEOF(x)
N
N#if (C11_SUPPORT)
X#if (( ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 1*0) | ( 0*1) | ( 1*0) | ( 1*0) | ( 1*0) | ( 1*0)| ( 0*0)| ( 0*0)| ( 0*0)| ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 1*0) | ( 1*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) ))
S  #define EMIF_SDCTL_DEFAULT (Uint32)( \
S     _PER_FDEFAULT(EMIF,SDCTL,SDBSZ)\
S    |_PER_FDEFAULT(EMIF,SDCTL,SDRSZ)\
S    |_PER_FDEFAULT(EMIF,SDCTL,SDCSZ)\
S    |_PER_FDEFAULT(EMIF,SDCTL,RFEN)\
S    |_PER_FDEFAULT(EMIF,SDCTL,INIT)\
S    |_PER_FDEFAULT(EMIF,SDCTL,TRCD)\
S    |_PER_FDEFAULT(EMIF,SDCTL,TRP)\
S    |_PER_FDEFAULT(EMIF,SDCTL,TRC)\
S  )
X  #define EMIF_SDCTL_DEFAULT (Uint32)(      _PER_FDEFAULT(EMIF,SDCTL,SDBSZ)    |_PER_FDEFAULT(EMIF,SDCTL,SDRSZ)    |_PER_FDEFAULT(EMIF,SDCTL,SDCSZ)    |_PER_FDEFAULT(EMIF,SDCTL,RFEN)    |_PER_FDEFAULT(EMIF,SDCTL,INIT)    |_PER_FDEFAULT(EMIF,SDCTL,TRCD)    |_PER_FDEFAULT(EMIF,SDCTL,TRP)    |_PER_FDEFAULT(EMIF,SDCTL,TRC)  )
S
S  #define EMIF_SDCTL_RMK(sdbsz,sdrsz,sdcsz,rfen,init,trcd,trp,trc) (Uint32)(\
S     _PER_FMK(EMIF,SDCTL,SDBSZ,sdbsz)\
S    |_PER_FMK(EMIF,SDCTL,SDRSZ,sdrsz)\
S    |_PER_FMK(EMIF,SDCTL,SDCSZ,sdcsz)\
S    |_PER_FMK(EMIF,SDCTL,RFEN,rfen)\
S    |_PER_FMK(EMIF,SDCTL,INIT,init)\
S    |_PER_FMK(EMIF,SDCTL,TRCD,trcd)\
S    |_PER_FMK(EMIF,SDCTL,TRP,trp)\
S    |_PER_FMK(EMIF,SDCTL,TRC,trc)\
S  )
X  #define EMIF_SDCTL_RMK(sdbsz,sdrsz,sdcsz,rfen,init,trcd,trp,trc) (Uint32)(     _PER_FMK(EMIF,SDCTL,SDBSZ,sdbsz)    |_PER_FMK(EMIF,SDCTL,SDRSZ,sdrsz)    |_PER_FMK(EMIF,SDCTL,SDCSZ,sdcsz)    |_PER_FMK(EMIF,SDCTL,RFEN,rfen)    |_PER_FMK(EMIF,SDCTL,INIT,init)    |_PER_FMK(EMIF,SDCTL,TRCD,trcd)    |_PER_FMK(EMIF,SDCTL,TRP,trp)    |_PER_FMK(EMIF,SDCTL,TRC,trc)  )
N#endif
N
N#if !(C11_SUPPORT)
X#if !(( ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 1*0) | ( 0*1) | ( 1*0) | ( 1*0) | ( 1*0) | ( 1*0)| ( 0*0)| ( 0*0)| ( 0*0)| ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 1*0) | ( 1*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) ))
N  #define EMIF_SDCTL_DEFAULT (Uint32)( \
N     _PER_FDEFAULT(EMIF,SDCTL,SDWID)\
N    |_PER_FDEFAULT(EMIF,SDCTL,RFEN)\
N    |_PER_FDEFAULT(EMIF,SDCTL,INIT)\
N    |_PER_FDEFAULT(EMIF,SDCTL,TRCD)\
N    |_PER_FDEFAULT(EMIF,SDCTL,TRP)\
N    |_PER_FDEFAULT(EMIF,SDCTL,TRC)\
N  )
X  #define EMIF_SDCTL_DEFAULT (Uint32)(      _PER_FDEFAULT(EMIF,SDCTL,SDWID)    |_PER_FDEFAULT(EMIF,SDCTL,RFEN)    |_PER_FDEFAULT(EMIF,SDCTL,INIT)    |_PER_FDEFAULT(EMIF,SDCTL,TRCD)    |_PER_FDEFAULT(EMIF,SDCTL,TRP)    |_PER_FDEFAULT(EMIF,SDCTL,TRC)  )
N
N  #define EMIF_SDCTL_RMK(sdwid,rfen,init,trcd,trp,trc) (Uint32)(\
N     _PER_FMK(EMIF,SDCTL,SDWID,sdwid)\
N    |_PER_FMK(EMIF,SDCTL,RFEN,rfen)\
N    |_PER_FMK(EMIF,SDCTL,INIT,init)\
N    |_PER_FMK(EMIF,SDCTL,TRCD,trcd)\
N    |_PER_FMK(EMIF,SDCTL,TRP,trp)\
N    |_PER_FMK(EMIF,SDCTL,TRC,trc)\
N  )
X  #define EMIF_SDCTL_RMK(sdwid,rfen,init,trcd,trp,trc) (Uint32)(     _PER_FMK(EMIF,SDCTL,SDWID,sdwid)    |_PER_FMK(EMIF,SDCTL,RFEN,rfen)    |_PER_FMK(EMIF,SDCTL,INIT,init)    |_PER_FMK(EMIF,SDCTL,TRCD,trcd)    |_PER_FMK(EMIF,SDCTL,TRP,trp)    |_PER_FMK(EMIF,SDCTL,TRC,trc)  )
N#endif
N
N  #define _EMIF_SDCTL_FGET(FIELD)\
N    _PER_FGET(_EMIF_SDCTL_ADDR,EMIF,SDCTL,##FIELD)
X  #define _EMIF_SDCTL_FGET(FIELD)    _PER_FGET(_EMIF_SDCTL_ADDR,EMIF,SDCTL,##FIELD)
N
N  #define _EMIF_SDCTL_FSET(FIELD,field)\
N    _PER_FSET(_EMIF_SDCTL_ADDR,EMIF,SDCTL,##FIELD,field)
X  #define _EMIF_SDCTL_FSET(FIELD,field)    _PER_FSET(_EMIF_SDCTL_ADDR,EMIF,SDCTL,##FIELD,field)
N
N  #define _EMIF_SDCTL_FSETS(FIELD,SYM)\
N    _PER_FSETS(_EMIF_SDCTL_ADDR,EMIF,SDCTL,##FIELD,##SYM)
X  #define _EMIF_SDCTL_FSETS(FIELD,SYM)    _PER_FSETS(_EMIF_SDCTL_ADDR,EMIF,SDCTL,##FIELD,##SYM)
N
N
N/******************************************************************************\
N* _____________________
X
N* |                   |
N* |  S D T I M        |
N* |___________________|
N*
N* SDTIM   - SDRAM timing register
N*
N* FIELDS (msb -> lsb)
N* (rw) XRFR   (1)
N* (r)  CNTR
N* (rw) PERIOD
N*
N* (1) - Field only exists for C11_SUPPORT
N*
N\******************************************************************************/
N  #define _EMIF_SDTIM_OFFSET           7
N
N  #define _EMIF_SDTIM_ADDR             0x0180001Cu
N
N#if (C11_SUPPORT)
X#if (( ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 1*0) | ( 0*1) | ( 1*0) | ( 1*0) | ( 1*0) | ( 1*0)| ( 0*0)| ( 0*0)| ( 0*0)| ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 1*0) | ( 1*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) ))
S  #define _EMIF_SDTIM_XRFR_MASK        0x03000000u
S  #define _EMIF_SDTIM_XRFR_SHIFT       0x00000018u
S  #define  EMIF_SDTIM_XRFR_DEFAULT     0x00000000u
S  #define  EMIF_SDTIM_XRFR_OF(x)       _VALUEOF(x)
N#endif
N
N#if (C11_SUPPORT)
X#if (( ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 1*0) | ( 0*1) | ( 1*0) | ( 1*0) | ( 1*0) | ( 1*0)| ( 0*0)| ( 0*0)| ( 0*0)| ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 1*0) | ( 1*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) ))
S  #define _EMIF_SDTIM_CNTR_MASK        0x00FFF000u
S  #define _EMIF_SDTIM_CNTR_SHIFT       0x0000000Cu
S  #define  EMIF_SDTIM_CNTR_DEFAULT     0x000005DCu
S  #define  EMIF_SDTIM_CNTR_OF(x)       _VALUEOF(x)
N#else
N  #define _EMIF_SDTIM_CNTR_MASK        0x00FFF000u
N  #define _EMIF_SDTIM_CNTR_SHIFT       0x0000000Cu
N  #define  EMIF_SDTIM_CNTR_DEFAULT     0x00000040u
N  #define  EMIF_SDTIM_CNTR_OF(x)       _VALUEOF(x)
N#endif
N  
N#if (C11_SUPPORT)
X#if (( ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 1*0) | ( 0*1) | ( 1*0) | ( 1*0) | ( 1*0) | ( 1*0)| ( 0*0)| ( 0*0)| ( 0*0)| ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 1*0) | ( 1*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) ))
S  #define _EMIF_SDTIM_PERIOD_MASK      0x00000FFFu
S  #define _EMIF_SDTIM_PERIOD_SHIFT     0x00000000u
S  #define  EMIF_SDTIM_PERIOD_DEFAULT   0x000005DCu
S  #define  EMIF_SDTIM_PERIOD_OF(x)     _VALUEOF(x)
N#else
N  #define _EMIF_SDTIM_PERIOD_MASK      0x00000FFFu
N  #define _EMIF_SDTIM_PERIOD_SHIFT     0x00000000u
N  #define  EMIF_SDTIM_PERIOD_DEFAULT   0x00000040u
N  #define  EMIF_SDTIM_PERIOD_OF(x)     _VALUEOF(x)
N#endif
N
N  #define  EMIF_SDTIM_OF(x)            _VALUEOF(x)
N
N#if (C11_SUPPORT)
X#if (( ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 1*0) | ( 0*1) | ( 1*0) | ( 1*0) | ( 1*0) | ( 1*0)| ( 0*0)| ( 0*0)| ( 0*0)| ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 1*0) | ( 1*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) ))
S  #define EMIF_SDTIM_DEFAULT (Uint32)( \
S     _PER_FDEFAULT(EMIF,SDTIM,XRFR)\
S    |_PER_FDEFAULT(EMIF,SDTIM,CNTR)\
S    |_PER_FDEFAULT(EMIF,SDTIM,PERIOD)\
S  )
X  #define EMIF_SDTIM_DEFAULT (Uint32)(      _PER_FDEFAULT(EMIF,SDTIM,XRFR)    |_PER_FDEFAULT(EMIF,SDTIM,CNTR)    |_PER_FDEFAULT(EMIF,SDTIM,PERIOD)  )
S
S  #define EMIF_SDTIM_RMK(xrfr,period) (Uint32)(\
S     _PER_FMK(EMIF,SDTIM,XRFR,xrfr)\
S    |_PER_FMK(EMIF,SDTIM,PERIOD,period)\
S  )
X  #define EMIF_SDTIM_RMK(xrfr,period) (Uint32)(     _PER_FMK(EMIF,SDTIM,XRFR,xrfr)    |_PER_FMK(EMIF,SDTIM,PERIOD,period)  )
N#endif
N
N#if !(C11_SUPPORT)
X#if !(( ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 1*0) | ( 0*1) | ( 1*0) | ( 1*0) | ( 1*0) | ( 1*0)| ( 0*0)| ( 0*0)| ( 0*0)| ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 1*0) | ( 1*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) ))
N  #define EMIF_SDTIM_DEFAULT (Uint32)( \
N     _PER_FDEFAULT(EMIF,SDTIM,CNTR)\
N    |_PER_FDEFAULT(EMIF,SDTIM,PERIOD)\
N  )
X  #define EMIF_SDTIM_DEFAULT (Uint32)(      _PER_FDEFAULT(EMIF,SDTIM,CNTR)    |_PER_FDEFAULT(EMIF,SDTIM,PERIOD)  )
N
N  #define EMIF_SDTIM_RMK(period) (Uint32)(\
N     _PER_FMK(EMIF,SDTIM,PERIOD,period)\
N  )
X  #define EMIF_SDTIM_RMK(period) (Uint32)(     _PER_FMK(EMIF,SDTIM,PERIOD,period)  )
N#endif
N
N
N  #define _EMIF_SDTIM_FGET(FIELD)\
N    _PER_FGET(_EMIF_SDTIM_ADDR,EMIF,SDTIM,##FIELD)
X  #define _EMIF_SDTIM_FGET(FIELD)    _PER_FGET(_EMIF_SDTIM_ADDR,EMIF,SDTIM,##FIELD)
N
N  #define _EMIF_SDTIM_FSET(FIELD,field)\
N    _PER_FSET(_EMIF_SDTIM_ADDR,EMIF,SDTIM,##FIELD,field)
X  #define _EMIF_SDTIM_FSET(FIELD,field)    _PER_FSET(_EMIF_SDTIM_ADDR,EMIF,SDTIM,##FIELD,field)
N
N  #define _EMIF_SDTIM_FSETS(FIELD,SYM)\
N    _PER_FSETS(_EMIF_SDTIM_ADDR,EMIF,SDTIM,##FIELD,##SYM)
X  #define _EMIF_SDTIM_FSETS(FIELD,SYM)    _PER_FSETS(_EMIF_SDTIM_ADDR,EMIF,SDTIM,##FIELD,##SYM)
N
N
N/******************************************************************************\
N* _____________________
X
N* |                   |
N* |  S D E X T        |
N* |___________________|
N*
N* SDEXT   - SDRAM extension register (1)
N*
N* (1) - only supported on 6211,6711,6713,DA610,6711C,6712C
N*
N* FIELDS (msb -> lsb)
N* (rw) WR2RD
N* (rw) WR2DEAC
N* (rw) WR2WR
N* (rw) R2WDQM
N* (rw) RD2WR
N* (rw) RD2DEAC
N* (rw) RD2RD
N* (rw) THZP
N* (rw) TWR
N* (rw) TRRD
N* (rw) TRAS
N* (rw) TCL
N*
N\******************************************************************************/
N#if (C11_SUPPORT)
X#if (( ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 1*0) | ( 0*1) | ( 1*0) | ( 1*0) | ( 1*0) | ( 1*0)| ( 0*0)| ( 0*0)| ( 0*0)| ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 1*0) | ( 1*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) ))
S  #define _EMIF_SDEXT_OFFSET           8
S
S  #define _EMIF_SDEXT_ADDR             0x01800020u
S
S  #define _EMIF_SDEXT_WR2RD_MASK       0x00100000u
S  #define _EMIF_SDEXT_WR2RD_SHIFT      0x00000014u
S  #define  EMIF_SDEXT_WR2RD_DEFAULT    0x00000001u
S  #define  EMIF_SDEXT_WR2RD_OF(x)      _VALUEOF(x)
S
S  #define _EMIF_SDEXT_WR2DEAC_MASK     0x000C0000u
S  #define _EMIF_SDEXT_WR2DEAC_SHIFT    0x00000012u
S  #define  EMIF_SDEXT_WR2DEAC_DEFAULT  0x00000001u
S  #define  EMIF_SDEXT_WR2DEAC_OF(x)    _VALUEOF(x)
S
S  #define _EMIF_SDEXT_WR2WR_MASK       0x00020000u
S  #define _EMIF_SDEXT_WR2WR_SHIFT      0x00000011u
S  #define  EMIF_SDEXT_WR2WR_DEFAULT    0x00000001u
S  #define  EMIF_SDEXT_WR2WR_OF(x)      _VALUEOF(x)
S
S  #define _EMIF_SDEXT_R2WDQM_MASK      0x00018000u
S  #define _EMIF_SDEXT_R2WDQM_SHIFT     0x0000000Fu
S  #define  EMIF_SDEXT_R2WDQM_DEFAULT   0x00000003u
S  #define  EMIF_SDEXT_R2WDQM_OF(x)     _VALUEOF(x)
S
S  #define _EMIF_SDEXT_RD2WR_MASK       0x00007000u
S  #define _EMIF_SDEXT_RD2WR_SHIFT      0x0000000Cu
S  #define  EMIF_SDEXT_RD2WR_DEFAULT    0x00000005u
S  #define  EMIF_SDEXT_RD2WR_OF(x)      _VALUEOF(x)
S
S  #define _EMIF_SDEXT_RD2DEAC_MASK     0x00000C00u
S  #define _EMIF_SDEXT_RD2DEAC_SHIFT    0x0000000Au
S  #define  EMIF_SDEXT_RD2DEAC_DEFAULT  0x00000003u
S  #define  EMIF_SDEXT_RD2DEAC_OF(x)    _VALUEOF(x)
S
S  #define _EMIF_SDEXT_RD2RD_MASK       0x00000200u
S  #define _EMIF_SDEXT_RD2RD_SHIFT      0x00000009u
S  #define  EMIF_SDEXT_RD2RD_DEFAULT    0x00000001u
S  #define  EMIF_SDEXT_RD2RD_OF(x)      _VALUEOF(x)
S
S  #define _EMIF_SDEXT_THZP_MASK        0x00000180u
S  #define _EMIF_SDEXT_THZP_SHIFT       0x00000007u
S  #define  EMIF_SDEXT_THZP_DEFAULT     0x00000002u
S  #define  EMIF_SDEXT_THZP_OF(x)       _VALUEOF(x)
S
S  #define _EMIF_SDEXT_TWR_MASK         0x00000060u
S  #define _EMIF_SDEXT_TWR_SHIFT        0x00000005u
S  #define  EMIF_SDEXT_TWR_DEFAULT      0x00000001u
S  #define  EMIF_SDEXT_TWR_OF(x)        _VALUEOF(x)
S
S  #define _EMIF_SDEXT_TRRD_MASK        0x00000010u
S  #define _EMIF_SDEXT_TRRD_SHIFT       0x00000004u
S  #define  EMIF_SDEXT_TRRD_DEFAULT     0x00000001u
S  #define  EMIF_SDEXT_TRRD_OF(x)       _VALUEOF(x)
S
S  #define _EMIF_SDEXT_TRAS_MASK        0x0000000Eu
S  #define _EMIF_SDEXT_TRAS_SHIFT       0x00000001u
S  #define  EMIF_SDEXT_TRAS_DEFAULT     0x00000007u
S  #define  EMIF_SDEXT_TRAS_OF(x)       _VALUEOF(x)
S
S  #define _EMIF_SDEXT_TCL_MASK         0x00000001u
S  #define _EMIF_SDEXT_TCL_SHIFT        0x00000000u
S  #define  EMIF_SDEXT_TCL_DEFAULT      0x00000001u
S  #define  EMIF_SDEXT_TCL_OF(x)        _VALUEOF(x)
S
S  #define  EMIF_SDEXT_OF(x)            _VALUEOF(x)
S
S  #define EMIF_SDEXT_DEFAULT (Uint32)( \
S     _PER_FDEFAULT(EMIF,SDEXT,WR2RD)\
S    |_PER_FDEFAULT(EMIF,SDEXT,WR2DEAC)\
S    |_PER_FDEFAULT(EMIF,SDEXT,WR2WR)\
S    |_PER_FDEFAULT(EMIF,SDEXT,R2WDQM)\
S    |_PER_FDEFAULT(EMIF,SDEXT,RD2WR)\
S    |_PER_FDEFAULT(EMIF,SDEXT,RD2DEAC)\
S    |_PER_FDEFAULT(EMIF,SDEXT,RD2RD)\
S    |_PER_FDEFAULT(EMIF,SDEXT,THZP)\
S    |_PER_FDEFAULT(EMIF,SDEXT,TWR)\
S    |_PER_FDEFAULT(EMIF,SDEXT,TRRD)\
S    |_PER_FDEFAULT(EMIF,SDEXT,TRAS)\
S    |_PER_FDEFAULT(EMIF,SDEXT,TCL)\
S  )
X  #define EMIF_SDEXT_DEFAULT (Uint32)(      _PER_FDEFAULT(EMIF,SDEXT,WR2RD)    |_PER_FDEFAULT(EMIF,SDEXT,WR2DEAC)    |_PER_FDEFAULT(EMIF,SDEXT,WR2WR)    |_PER_FDEFAULT(EMIF,SDEXT,R2WDQM)    |_PER_FDEFAULT(EMIF,SDEXT,RD2WR)    |_PER_FDEFAULT(EMIF,SDEXT,RD2DEAC)    |_PER_FDEFAULT(EMIF,SDEXT,RD2RD)    |_PER_FDEFAULT(EMIF,SDEXT,THZP)    |_PER_FDEFAULT(EMIF,SDEXT,TWR)    |_PER_FDEFAULT(EMIF,SDEXT,TRRD)    |_PER_FDEFAULT(EMIF,SDEXT,TRAS)    |_PER_FDEFAULT(EMIF,SDEXT,TCL)  )
S
S  #define EMIF_SDEXT_RMK(wr2rd,wr2deac,wr2wr,r2wdqm,rd2wr,rd2deac,\
S    rd2rd,thzp,twr,trrd,tras,tcl) (Uint32)( \
S     _PER_FMK(EMIF,SDEXT,WR2RD,wr2rd)\
S    |_PER_FMK(EMIF,SDEXT,WR2DEAC,wr2deac)\
S    |_PER_FMK(EMIF,SDEXT,WR2WR,wr2wr)\
S    |_PER_FMK(EMIF,SDEXT,R2WDQM,r2wdqm)\
S    |_PER_FMK(EMIF,SDEXT,RD2WR,rd2wr)\
S    |_PER_FMK(EMIF,SDEXT,RD2DEAC,rd2deac)\
S    |_PER_FMK(EMIF,SDEXT,RD2RD,rd2rd)\
S    |_PER_FMK(EMIF,SDEXT,THZP,thzp)\
S    |_PER_FMK(EMIF,SDEXT,TWR,twr)\
S    |_PER_FMK(EMIF,SDEXT,TRRD,trrd)\
S    |_PER_FMK(EMIF,SDEXT,TRAS,tras)\
S    |_PER_FMK(EMIF,SDEXT,TCL,tcl)\
S  )
X  #define EMIF_SDEXT_RMK(wr2rd,wr2deac,wr2wr,r2wdqm,rd2wr,rd2deac,    rd2rd,thzp,twr,trrd,tras,tcl) (Uint32)(      _PER_FMK(EMIF,SDEXT,WR2RD,wr2rd)    |_PER_FMK(EMIF,SDEXT,WR2DEAC,wr2deac)    |_PER_FMK(EMIF,SDEXT,WR2WR,wr2wr)    |_PER_FMK(EMIF,SDEXT,R2WDQM,r2wdqm)    |_PER_FMK(EMIF,SDEXT,RD2WR,rd2wr)    |_PER_FMK(EMIF,SDEXT,RD2DEAC,rd2deac)    |_PER_FMK(EMIF,SDEXT,RD2RD,rd2rd)    |_PER_FMK(EMIF,SDEXT,THZP,thzp)    |_PER_FMK(EMIF,SDEXT,TWR,twr)    |_PER_FMK(EMIF,SDEXT,TRRD,trrd)    |_PER_FMK(EMIF,SDEXT,TRAS,tras)    |_PER_FMK(EMIF,SDEXT,TCL,tcl)  )
S
S  #define _EMIF_SDEXT_FGET(FIELD)\
S    _PER_FGET(_EMIF_SDEXT_ADDR,EMIF,SDEXT,##FIELD)
X  #define _EMIF_SDEXT_FGET(FIELD)    _PER_FGET(_EMIF_SDEXT_ADDR,EMIF,SDEXT,##FIELD)
S
S  #define _EMIF_SDEXT_FSET(FIELD,field)\
S    _PER_FSET(_EMIF_SDEXT_ADDR,EMIF,SDEXT,##FIELD,field)
X  #define _EMIF_SDEXT_FSET(FIELD,field)    _PER_FSET(_EMIF_SDEXT_ADDR,EMIF,SDEXT,##FIELD,field)
S
S  #define _EMIF_SDEXT_FSETS(FIELD,SYM)\
S    _PER_FSETS(_EMIF_SDEXT_ADDR,EMIF,SDEXT,##FIELD,##SYM)
X  #define _EMIF_SDEXT_FSETS(FIELD,SYM)    _PER_FSETS(_EMIF_SDEXT_ADDR,EMIF,SDEXT,##FIELD,##SYM)
S
N#endif
N
N/*----------------------------------------------------------------------------*/
N
N#endif /* EMIF_SUPPORT */
N#endif /* _CSL_EMIFHAL_H_ */
N/******************************************************************************\
N* End of csl_emifhal.h
X
N\******************************************************************************/
N
L 21 "E:/TI_workspase/c6701_t/csl/csl_chip.h" 2
N
N/******************************************************************************\
N* scope and inline control macros
X
N\******************************************************************************/
N#ifdef __cplusplus
S#define CSLAPI extern "C" far
N#else
N#define CSLAPI extern far
N#endif
N
N#undef  USEDEFS
N#undef  IDECL
N#undef  IDEF
N
N#ifdef  _CHIP_MOD_
S  #define IDECL CSLAPI
S  #define USEDEFS
S  #define IDEF
N#else
N  #ifdef  _INLINE
S    #define IDECL static inline
S    #define USEDEFS
S    #define IDEF  static inline
N  #else
N    #define IDECL CSLAPI
N  #endif
N#endif
N
N
N/******************************************************************************\
N* global macro declarations
X
N\******************************************************************************/
N#define CHIP_ENDIAN_BIG    0
N#define CHIP_ENDIAN_LITTLE 1
N
N#define CHIP_MAP_0         0
N#define CHIP_MAP_1         1
N
N/* Selected devices masks*/
N#if (CHIP_6713 || CHIP_DA610 || CHIP_6711C || CHIP_6712C)
X#if (0 || 0 || 0 || 0)
S#define CHIP_EKSRC_SYSCLK3  0x00000000u
S#define CHIP_EKSRC_ECLKIN   0x00000010u
N#endif
N
N#if (CHIP_6713 || CHIP_DA610)
X#if (0 || 0)
S#define CHIP_TOUT1          0x00000000u
S#define CHIP_AXR04_AXR111   0x00000008u
S
S#define CHIP_TOUT0          0x00000000u
S#define CHIP_AXR02_AXR113   0x00000004u
S
S#define CHIP_MCASP0         0x00000002u
S#define CHIP_MCBSP0         0x00000000u
S
S#define CHIP_I2C1           0x00000001u
S#define CHIP_MCBSP1         0x00000000u
S/* Full mask value */
S#define _CHIP_DEVCFG_MASK  0x0000001Fu
N#endif
N
N#if CHIP_DM642
X#if 0
S#define CHIP_VP2            0x00000040u
S#define CHIP_VP1            0x00000020u
S#define CHIP_VP0            0x00000010u
S#define CHIP_I2C            0x00000008u
S#define CHIP_MCBSP1         0x00000004u
S#define CHIP_MCBSP0         0x00000002u
S#define CHIP_MCASP0         0x00000001u
S
S#define _CHIP_PERCFG_MASK   0x0000007Fu
N#endif
N
N#if CHIP_DM641
X#if 0
S#define CHIP_VP1            0x00000020u
S#define CHIP_VP0            0x00000010u
S#define CHIP_I2C            0x00000008u
S#define CHIP_MCBSP1         0x00000004u
S#define CHIP_MCBSP0         0x00000002u
S#define CHIP_MCASP0         0x00000001u
S
S#define _CHIP_PERCFG_MASK   0x0000003Fu
N#endif
N
N#if CHIP_DM640
X#if 0
S#define CHIP_VP0            0x00000010u
S#define CHIP_I2C            0x00000008u
S#define CHIP_MCBSP1         0x00000004u
S#define CHIP_MCBSP0         0x00000002u
S#define CHIP_MCASP0         0x00000001u
S
S#define _CHIP_PERCFG_MASK   0x0000001Fu
N#endif
N
N#if CHIP_6412
X#if 0
S#define CHIP_I2C            0x00000008u
S#define CHIP_MCBSP1         0x00000004u
S#define CHIP_MCBSP0         0x00000002u
S#define _CHIP_PERCFG_MASK   0x0000000Eu
N#endif
N
N#if (CHIP_6410 || CHIP_6413 || CHIP_6418)
X#if (0 || 0 || 0)
S#define CHIP_AFCMUX         0x00000600u
S#define CHIP_MCASP1         0x00000100u
S#define CHIP_I2C1           0x00000080u
S#define CHIP_I2C0           0x00000008u
S#define CHIP_MCBSP1         0x00000004u
S#define CHIP_MCBSP0         0x00000002u
S#define CHIP_MCASP0         0x00000001u
S
S#define _CHIP_PERCFG_MASK   0x0000078Fu
N#endif
N
N/******************************************************************************\
N* global typedef declarations
X
N\******************************************************************************/
N#if( CHIP_6711C || CHIP_6712C || CHIP_DA610 || CHIP_6713 )
X#if( 0 || 0 || 0 || 0 )
Stypedef struct{
S   Uint32 devcfg;
S} CHIP_Config;
S#elif (CHIP_DM642 || CHIP_DM641 || CHIP_DM640  || CHIP_6412 || CHIP_6410 || CHIP_6413 || CHIP_6418)
X#elif (0 || 0 || 0  || 0 || 0 || 0 || 0)
Stypedef struct{
S   Uint32 percfg;
S} CHIP_Config; 
N#endif
N/******************************************************************************\
N* global variable declarations
X
N\******************************************************************************/
N
N
N/******************************************************************************\
N* global function declarations
X
N\******************************************************************************/
N
N
N/******************************************************************************\
N* inline function declarations
X
N\******************************************************************************/
NIDECL Uint32 CHIP_getCpuId();
Xextern far Uint32 CHIP_getCpuId();
NIDECL Uint32 CHIP_getRevId();
Xextern far Uint32 CHIP_getRevId();
NIDECL Uint32 CHIP_getSiliconRevId();
Xextern far Uint32 CHIP_getSiliconRevId();
NIDECL int    CHIP_getEndian();
Xextern far int    CHIP_getEndian();
NIDECL int    CHIP_getMapMode();
Xextern far int    CHIP_getMapMode();
N
N#if (CHIP_DM642 || CHIP_DM641 || CHIP_DM640  || CHIP_6412 || CHIP_6410 || CHIP_6413 || CHIP_6418) 
X#if (0 || 0 || 0  || 0 || 0 || 0 || 0) 
SIDECL void   CHIP_config(CHIP_Config *config);
SIDECL void   CHIP_configArgs(Uint32 percfg);
SIDECL void   CHIP_getConfig(CHIP_Config *config); 
S#elif ( CHIP_6711C || CHIP_6712C || CHIP_DA610 || CHIP_6713 )
X#elif ( 0 || 0 || 0 || 0 )
SIDECL void   CHIP_config(CHIP_Config *config);
SIDECL void   CHIP_configArgs(Uint32 devcfg);
SIDECL void   CHIP_getConfig(CHIP_Config *config); 
N#endif
N
N/******************************************************************************\
N* inline function definitions
X
N\******************************************************************************/
N#ifdef USEDEFS
S/*----------------------------------------------------------------------------*/
SIDEF Uint32 CHIP_getCpuId() {
S  return CHIP_FGET(CSR,CPUID);
S}
S/*----------------------------------------------------------------------------*/
SIDEF Uint32 CHIP_getRevId() {
S  return CHIP_FGET(CSR,REVID);
S}
S/*----------------------------------------------------------------------------*/
SIDEF Uint32 CHIP_getSiliconRevId() {
S  return (( 0x000F0000 & REG32(0x01B00200))>>16);
S}
S/*----------------------------------------------------------------------------*/
SIDEF int CHIP_getEndian() {
S  return CHIP_FGET(CSR,EN);
S}
S/*----------------------------------------------------------------------------*/
SIDEF int CHIP_getMapMode() {
S  int mapmode = 0;
S  #if (!C11_SUPPORT && !C64_SUPPORT)
S    mapmode = EMIF_FGET(GBLCTL,MAP);
S  #endif
S  return mapmode;
S}
S/*----------------------------------------------------------------------------*/
S#if (CHIP_6713 || CHIP_DM642 || CHIP_DM641 || CHIP_DM640 || CHIP_DA610 || CHIP_6412 || CHIP_6711C || CHIP_6712C || CHIP_6410 || CHIP_6413 || CHIP_6418)
SIDEF void   CHIP_config(CHIP_Config *config) {
S  Uint32 gie = CHIP_FGET(CSR,GIE);
S  
S#if( CHIP_6711C || CHIP_6712C || CHIP_DA610 || CHIP_6713 ) 
S    volatile Uint32 *base = (volatile Uint32 *)(_CHIP_DEVCFG_ADDR);
S    register int x0;
S    CHIP_FSET(CSR,GIE,0);
S    x0 = config->devcfg;
S    base[_CHIP_DEVCFG_OFFSET] = x0;
S    CHIP_FSET(CSR,GIE,gie);
S    
S#else 
S  volatile Uint32 *base = (volatile Uint32 *)(_CHIP_PERCFG_ADDR);
S  register int x0;
S  CHIP_FSET(CSR,GIE,0);
S  CHIP_FSETS(PCFGLOCK,LOCK,UNLOCK);
S  x0 = config->percfg;
S  base[_CHIP_PERCFG_OFFSET] = x0;
S  CHIP_FSET(CSR,GIE,gie);
S  
S#endif
S}      
S#endif
S/*----------------------------------------------------------------------------*/
S#if (CHIP_6713 || CHIP_DM642 || CHIP_DM641 || CHIP_DM640 || CHIP_DA610 || CHIP_6412 || CHIP_6711C || CHIP_6712C || CHIP_6410 || CHIP_6413 || CHIP_6418)
SIDEF void   CHIP_getConfig(CHIP_Config *config) {
S   Uint32 gie = CHIP_FGET(CSR,GIE);
S   
S#if( CHIP_6711C || CHIP_6712C || CHIP_DA610 || CHIP_6713 ) 
S   volatile Uint32 *base = (volatile Uint32 *)(_CHIP_DEVCFG_ADDR);
S   register int x0;
S
S   CHIP_FSET(CSR,GIE,0);
S
S   x0 = base[_CHIP_DEVCFG_OFFSET]; 
S   config->devcfg=x0;
S
S   CHIP_FSET(CSR,GIE,gie);
S   
S#else
S   volatile Uint32 *base = (volatile Uint32 *)(_CHIP_PERCFG_ADDR);
S   register int x0;
S
S   CHIP_FSET(CSR,GIE,0);
S
S   x0 = base[_CHIP_PERCFG_OFFSET]; 
S   config->percfg=x0;
S
S   CHIP_FSET(CSR,GIE,gie);
S   
S#endif
S}      
S#endif
S/*----------------------------------------------------------------------------*/
S   
S#if( CHIP_6711C || CHIP_6712C || CHIP_DA610 || CHIP_6713 )
S   IDEF void   CHIP_configArgs(Uint32 devcfg) {
S   Uint32 gie = CHIP_FGET(CSR,GIE);
S   volatile Uint32 *base = (volatile Uint32 *)(_CHIP_DEVCFG_ADDR);
S   CHIP_FSET(CSR,GIE,0);
S   base[_CHIP_DEVCFG_OFFSET]= devcfg; 
S   CHIP_FSET(CSR,GIE,gie);
S}   
S#elif (CHIP_DM642 || CHIP_DM641 || CHIP_DM640  || CHIP_6412 || CHIP_6410 || CHIP_6413 || CHIP_6418)
S   IDEF void   CHIP_configArgs(Uint32 percfg) {
S   Uint32 gie = CHIP_FGET(CSR,GIE);
S   volatile Uint32 *base = (volatile Uint32 *)(_CHIP_PERCFG_ADDR);
S
S   CHIP_FSET(CSR,GIE,0);
S
S#if(CHIP_DM642 || CHIP_6412)
S   CHIP_FSETS(PCFGLOCK,LOCK,UNLOCK);
S#endif
S
S   base[_CHIP_PERCFG_OFFSET]= percfg; 
S
S   CHIP_FSET(CSR,GIE,gie);
S}   
S#endif
S
S
S/*----------------------------------------------------------------------------*/
N#endif /* USEDEFS */
N
N
N#endif /* _CSL_CHIP_H_ */
N/******************************************************************************\
N* End of csl_chip.h
X
N\******************************************************************************/
N
L 160 "E:/TI_workspase/c6701_t/csl/csl_emachal.h" 2
N
N
N#if (EMAC_SUPPORT)
X#if (( ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*1) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0)| ( 1*0)| ( 1*0)| ( 1*0)| ( 1*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) ))
S/******************************************************************************\
S* EMAC Register section
X
S\******************************************************************************/
S
S#define _EMAC_BASE_ADDR             0x01c80000u
S
S/* ----------------- */
S/* FIELD MAKE MACROS */
S/* ----------------- */
S
S/* User Supplied Value */
S#define EMAC_FMK(REG,FIELD,x)\
S  ((x<<_EMAC_##REG##_##FIELD##_SHIFT)&_EMAC_##REG##_##FIELD##_MASK)
X#define EMAC_FMK(REG,FIELD,x)  ((x<<_EMAC_##REG##_##FIELD##_SHIFT)&_EMAC_##REG##_##FIELD##_MASK)
S
S/* Symbolic Value Name */
S#define EMAC_FMKS(REG,FIELD,SYM)\
S  ((EMAC_##REG##_##FIELD##_##SYM<<_EMAC_##REG##_##FIELD##_SHIFT)\
S  &_EMAC_##REG##_##FIELD##_MASK)
X#define EMAC_FMKS(REG,FIELD,SYM)  ((EMAC_##REG##_##FIELD##_##SYM<<_EMAC_##REG##_##FIELD##_SHIFT)  &_EMAC_##REG##_##FIELD##_MASK)
S
S/* Channel Flag */
S#define EMAC_FMKCHF(CHANNEL)    (1u<<(CHANNEL))
S
S
S/* -------------------------------- */
S/* RAW REGISTER/FIELD ACCESS MACROS */
S/* -------------------------------- */
S
S#define EMAC_ADDR(REG)\
S    ((volatile Uint32 *)_EMAC_##REG##_ADDR)
X#define EMAC_ADDR(REG)    ((volatile Uint32 *)_EMAC_##REG##_ADDR)
S
S#define EMAC_REG(REG)\
S    *(volatile Uint32*)(_EMAC_##REG##_ADDR)
X#define EMAC_REG(REG)    *(volatile Uint32*)(_EMAC_##REG##_ADDR)
S
S/* Standard Registers */
S#define EMAC_RGET(REG)\
S    (*(volatile Uint32*)(_EMAC_##REG##_ADDR))
X#define EMAC_RGET(REG)    (*(volatile Uint32*)(_EMAC_##REG##_ADDR))
S
S#define EMAC_RSET(REG,x)\
S    (*(volatile Uint32*)(_EMAC_##REG##_ADDR)=(x))
X#define EMAC_RSET(REG,x)    (*(volatile Uint32*)(_EMAC_##REG##_ADDR)=(x))
S
S#define EMAC_FGET(REG,FIELD)\
S    ((EMAC_RGET(REG)&_EMAC_##REG##_##FIELD##_MASK)\
S    >>_EMAC_##REG##_##FIELD##_SHIFT)
X#define EMAC_FGET(REG,FIELD)    ((EMAC_RGET(REG)&_EMAC_##REG##_##FIELD##_MASK)    >>_EMAC_##REG##_##FIELD##_SHIFT)
S
S#define EMAC_FSET(REG,FIELD,x)\
S    EMAC_RSET(REG,(EMAC_RGET(REG)&~_EMAC_##REG##_##FIELD##_MASK)|\
S    EMAC_FMK(REG,FIELD,x))
X#define EMAC_FSET(REG,FIELD,x)    EMAC_RSET(REG,(EMAC_RGET(REG)&~_EMAC_##REG##_##FIELD##_MASK)|    EMAC_FMK(REG,FIELD,x))
S
S#define EMAC_FSETS(REG,FIELD,SYM)\
S    EMAC_RSET(REG,(EMAC_RGET(REG)&~_EMAC_##REG##_##FIELD##_MASK)|\
S    EMAC_FMKS(REG,FIELD,SYM))
X#define EMAC_FSETS(REG,FIELD,SYM)    EMAC_RSET(REG,(EMAC_RGET(REG)&~_EMAC_##REG##_##FIELD##_MASK)|    EMAC_FMKS(REG,FIELD,SYM))
S
S
S/* Index Based Registers */
S#define EMAC_RGETI(REGBASE,IDX)\
S    (*(volatile Uint32*)(_EMAC_##REGBASE##_BASEADDR+((IDX)*sizeof(Uint32 *))))
X#define EMAC_RGETI(REGBASE,IDX)    (*(volatile Uint32*)(_EMAC_##REGBASE##_BASEADDR+((IDX)*sizeof(Uint32 *))))
S
S#define EMAC_RSETI(REGBASE,IDX,x)\
S    (*(volatile Uint32*)(_EMAC_##REGBASE##_BASEADDR+((IDX)*sizeof(Uint32 *)))=(x))
X#define EMAC_RSETI(REGBASE,IDX,x)    (*(volatile Uint32*)(_EMAC_##REGBASE##_BASEADDR+((IDX)*sizeof(Uint32 *)))=(x))
S
S#define EMAC_FGETI(REGBASE,IDX,FIELD)\
S    ((EMAC_RGETI(REGBASE,IDX)&_EMAC_##REGBASE##_##FIELD##_MASK)\
S    >>_EMAC_##REGBASE##_##FIELD##_SHIFT)
X#define EMAC_FGETI(REGBASE,IDX,FIELD)    ((EMAC_RGETI(REGBASE,IDX)&_EMAC_##REGBASE##_##FIELD##_MASK)    >>_EMAC_##REGBASE##_##FIELD##_SHIFT)
S
S#define EMAC_FSETI(REGBASE,IDX,FIELD,x)\
S    EMAC_RSETI(REGBASE,IDX,(EMAC_RGETI(REGBASE,IDX)&\
S    ~_EMAC_##REGBASE##_##FIELD##_MASK)|EMAC_FMK(REGBASE,FIELD,x))
X#define EMAC_FSETI(REGBASE,IDX,FIELD,x)    EMAC_RSETI(REGBASE,IDX,(EMAC_RGETI(REGBASE,IDX)&    ~_EMAC_##REGBASE##_##FIELD##_MASK)|EMAC_FMK(REGBASE,FIELD,x))
S
S#define EMAC_FSETSI(REGBASE,IDX,FIELD,SYM)\
S    EMAC_RSETI(REGBASE,IDX,(EMAC_RGETI(REGBASE,IDX)&\
S    ~_EMAC_##REGBASE##_##FIELD##_MASK)|EMAC_FMKS(REGBASE,FIELD,SYM))
X#define EMAC_FSETSI(REGBASE,IDX,FIELD,SYM)    EMAC_RSETI(REGBASE,IDX,(EMAC_RGETI(REGBASE,IDX)&    ~_EMAC_##REGBASE##_##FIELD##_MASK)|EMAC_FMKS(REGBASE,FIELD,SYM))
S
S
S
S/******************************************************************************\
S* EMAC Descriptor section
X
S\******************************************************************************/
S
S#define _EMAC_DSC_BASE_ADDR         0x01c81000u
S
S/* EMAC Descriptor Size and Element Count */
S#define _EMAC_DSC_SIZE              4096
S#define _EMAC_DSC_ENTRY_SIZE        16
S#define _EDMA_DSC_ENTRY_COUNT       (_EMAC_DSC_SIZE/_EMAC_DSC_ENTRY_SIZE)
S
S
S/*
S// EMAC Descriptor
S//
S// The following is the format of a single buffer descriptor
S// on the EMAC.
S*/
Stypedef struct _EMAC_Desc {
S  struct _EMAC_Desc *pNext;     /* Pointer to next descriptor in chain */
S  Uint8             *pBuffer;   /* Pointer to data buffer              */
S  Uint32            BufOffLen;  /* Buffer Offset(MSW) and Length(LSW)  */
S  Uint32            PktFlgLen;  /* Packet Flags(MSW) and Length(LSW)   */
S} EMAC_Desc;
S
S
S/* ------------------------ */
S/* DESCRIPTOR ACCESS MACROS */
S/* ------------------------ */
S
S/* Packet Flags */
S#define EMAC_DSC_FLAG_SOP                       0x80000000u
S#define EMAC_DSC_FLAG_EOP                       0x40000000u
S#define EMAC_DSC_FLAG_OWNER                     0x20000000u
S#define EMAC_DSC_FLAG_EOQ                       0x10000000u
S#define EMAC_DSC_FLAG_TDOWNCMPLT                0x08000000u
S#define EMAC_DSC_FLAG_PASSCRC                   0x04000000u
S#define EMAC_DSC_FLAG_JABBER                    0x02000000u
S#define EMAC_DSC_FLAG_OVERSIZE                  0x01000000u
S#define EMAC_DSC_FLAG_FRAGMENT                  0x00800000u
S#define EMAC_DSC_FLAG_UNDERSIZED                0x00400000u
S#define EMAC_DSC_FLAG_CONTROL                   0x00200000u
S#define EMAC_DSC_FLAG_OVERRUN                   0x00100000u
S#define EMAC_DSC_FLAG_CODEERROR                 0x00080000u
S#define EMAC_DSC_FLAG_ALIGNERROR                0x00040000u
S#define EMAC_DSC_FLAG_CRCERROR                  0x00020000u
S#define EMAC_DSC_FLAG_NOMATCH                   0x00010000u
S
S
S/******************************************************************************\
S* module level register/field access macros
X
S\******************************************************************************/
S
S/******************************************************************************\
S* _____________________
X
S* |                   |
S* |  TXIDVER          |
S* |___________________|
S*
S* TXIDVER           - TX Identification and Version Register
S*
S* FIELDS (msb -> lsb)
S* (r)   TXIDENT
S* (r)   TXMAJORVER
S* (r)   TXMINORVER
S*
S* MACROS SUPPORTED
S*  EMAC_FMK     y
S*  EMAC_FMKS    .
S*  EMAC_FMKCHF  .
S*  EMAC_ADDR    y
S*  EMAC_REG     y
S*  EMAC_RGET    y
S*  EMAC_RSET    y
S*  EMAC_FGET    y
S*  EMAC_FSET    y
S*  EMAC_FSETS   .
S*  EMAC_RGETI   .
S*  EMAC_RSETI   .
S*  EMAC_FGETI   .
S*  EMAC_FSETI   .
S*  EMAC_FSETSI  .
S*
S\******************************************************************************/
S#define _EMAC_TXIDVER_ADDR                      (_EMAC_BASE_ADDR+0x0000u)
S
S#define EMAC_TXIDVER                            EMAC_REG(TXIDVER)
S
S#define _EMAC_TXIDVER_TXIDENT_MASK              0xFFFF0000u
S#define _EMAC_TXIDVER_TXIDENT_SHIFT             16u
S#define  EMAC_TXIDVER_TXIDENT_DEFAULT           0x00000004u
S
S#define _EMAC_TXIDVER_TXMAJORVER_MASK           0x0000FF00u
S#define _EMAC_TXIDVER_TXMAJORVER_SHIFT          8u
S#define  EMAC_TXIDVER_TXMAJORVER_DEFAULT        0x00000000u
S
S#define _EMAC_TXIDVER_TXMINORVER_MASK           0x000000FFu
S#define _EMAC_TXIDVER_TXMINORVER_SHIFT          0u
S#define  EMAC_TXIDVER_TXMINORVER_DEFAULT        0x00000000u
S
S
S
S/******************************************************************************\
S* _____________________
X
S* |                   |
S* |  TXCONTROL        |
S* |___________________|
S*
S* TXCONTROL         - TX Control Register
S*
S* FIELDS (msb -> lsb)
S* (rw)  TXEN        - Transmit Enable
S*
S* MACROS SUPPORTED
S*  EMAC_FMK     y
S*  EMAC_FMKS    y
S*  EMAC_FMKCHF  .
S*  EMAC_ADDR    y
S*  EMAC_REG     y
S*  EMAC_RGET    y
S*  EMAC_RSET    y
S*  EMAC_FGET    y
S*  EMAC_FSET    y
S*  EMAC_FSETS   .
S*  EMAC_RGETI   .
S*  EMAC_RSETI   .
S*  EMAC_FGETI   .
S*  EMAC_FSETI   .
S*  EMAC_FSETSI  .
S*
S\******************************************************************************/
S#define _EMAC_TXCONTROL_ADDR                    (_EMAC_BASE_ADDR+0x0004u)
S
S#define EMAC_TXCONTROL                          EMAC_REG(TXCONTROL)
S
S#define _EMAC_TXCONTROL_TXEN_MASK               0x00000001u
S#define _EMAC_TXCONTROL_TXEN_SHIFT              0u
S#define  EMAC_TXCONTROL_TXEN_DEFAULT		0x00000000u
S#define EMAC_TXCONTROL_TXEN_DISABLE             0u
S#define EMAC_TXCONTROL_TXEN_ENABLE              1u
S
S
S
S/******************************************************************************\
S* _____________________
X
S* |                   |
S* |  TXTEARDOWN       |
S* |___________________|
S*
S* TXTEARDOWN        - TX Teardown Register
S*
S* FIELDS (msb -> lsb)
S* (w)  TXTDNCH      - Teardown Channel Number
S*
S* MACROS SUPPORTED
S*  EMAC_FMK     y
S*  EMAC_FMKS    .
S*  EMAC_FMKCHF  .
S*  EMAC_ADDR    y
S*  EMAC_REG     y
S*  EMAC_RGET    y
S*  EMAC_RSET    y
S*  EMAC_FGET    y
S*  EMAC_FSET    y
S*  EMAC_FSETS   .
S*  EMAC_RGETI   .
S*  EMAC_RSETI   .
S*  EMAC_FGETI   .
S*  EMAC_FSETI   .
S*  EMAC_FSETSI  .
S*
S\******************************************************************************/
S#define _EMAC_TXTEARDOWN_ADDR                   (_EMAC_BASE_ADDR+0x0008u)
S
S#define EMAC_TXTEARDOWN                         EMAC_REG(TXTEARDOWN)
S
S#define _EMAC_TXTEARDOWN_TXTDNCH_MASK           0x00000007u
S#define _EMAC_TXTEARDOWN_TXTDNCH_SHIFT          0u
S#define  EMAC_TXTEARDOWN_TXTDNCH_DEFAULT	0x00000000u
S
S
S/******************************************************************************\
S* _____________________
X
S* |                   |
S* |  RXIDVER          |
S* |___________________|
S*
S* RXIDVER           - RX Identification and Version Register
S*
S* FIELDS (msb -> lsb)
S* (r)   RXIDENT
S* (r)   RXMAJORVER
S* (r)   RXMINORVER
S*
S* MACROS SUPPORTED
S*  EMAC_FMK     y
S*  EMAC_FMKS    .
S*  EMAC_FMKCHF  .
S*  EMAC_ADDR    y
S*  EMAC_REG     y
S*  EMAC_RGET    y
S*  EMAC_RSET    y
S*  EMAC_FGET    y
S*  EMAC_FSET    y
S*  EMAC_FSETS   .
S*  EMAC_RGETI   .
S*  EMAC_RSETI   .
S*  EMAC_FGETI   .
S*  EMAC_FSETI   .
S*  EMAC_FSETSI  .
S*
S\******************************************************************************/
S#define _EMAC_RXIDVER_ADDR                      (_EMAC_BASE_ADDR+0x0010u)
S
S#define EMAC_RXIDVER                            EMAC_REG(RXIDVER)
S
S#define _EMAC_RXIDVER_RXIDENT_MASK              0xFFFF0000u
S#define _EMAC_RXIDVER_RXIDENT_SHIFT             16u
S#define  EMAC_RXIDVER_RXIDENT_DEFAULT		0x00000004u
S
S#define _EMAC_RXIDVER_RXMAJORVER_MASK           0x0000FF00u
S#define _EMAC_RXIDVER_RXMAJORVER_SHIFT          8u
S#define	 EMAC_RXIDVER_RXMAJORVER_DEFAULT	0x00000000u
S
S#define _EMAC_RXIDVER_RXMINORVER_MASK           0x000000FFu
S#define _EMAC_RXIDVER_RXMINORVER_SHIFT          0u
S#define  EMAC_RXIDVER_RXMINORVER_DEFAULT	0x00000000u
S
S
S/******************************************************************************\
S* _____________________
X
S* |                   |
S* |  RXCONTROL        |
S* |___________________|
S*
S* RXCONTROL         - RX Control Register
S*
S* FIELDS (msb -> lsb)
S* (rw)  RXEN        - Receive Enable
S*
S* MACROS SUPPORTED
S*  EMAC_FMK     y
S*  EMAC_FMKS    y
S*  EMAC_FMKCHF  .
S*  EMAC_ADDR    y
S*  EMAC_REG     y
S*  EMAC_RGET    y
S*  EMAC_RSET    y
S*  EMAC_FGET    y
S*  EMAC_FSET    y
S*  EMAC_FSETS   y
S*  EMAC_RGETI   .
S*  EMAC_RSETI   .
S*  EMAC_FGETI   .
S*  EMAC_FSETI   .
S*  EMAC_FSETSI  .
S*
S\******************************************************************************/
S#define _EMAC_RXCONTROL_ADDR                    (_EMAC_BASE_ADDR+0x0014u)
S
S#define EMAC_RXCONTROL                          EMAC_REG(RXCONTROL)
S
S#define _EMAC_RXCONTROL_RXEN_MASK               0x00000001u
S#define _EMAC_RXCONTROL_RXEN_SHIFT              0u
S#define  EMAC_RXCONTROL_RXEN_DEFAULT		0x00000000u
S#define EMAC_RXCONTROL_RXEN_DISABLE             0u
S#define EMAC_RXCONTROL_RXEN_ENABLE              1u
S
S
S
S/******************************************************************************\
S* _____________________
X
S* |                   |
S* |  RXTEARDOWN       |
S* |___________________|
S*
S* RXTEARDOWN        - RX Teardown Register
S*
S* FIELDS (msb -> lsb)
S* (w)  RXTDNCH      - Teardown Channel Number
S*
S* MACROS SUPPORTED
S*  EMAC_FMK     y
S*  EMAC_FMKS    .
S*  EMAC_FMKCHF  .
S*  EMAC_ADDR    y
S*  EMAC_RGET    y
S*  EMAC_RSET    y
S*  EMAC_FGET    y
S*  EMAC_FSET    y
S*  EMAC_FSETS   .
S*  EMAC_RGETI   .
S*  EMAC_RSETI   .
S*  EMAC_FGETI   .
S*  EMAC_FSETI   .
S*  EMAC_FSETSI  .
S*
S\******************************************************************************/
S#define _EMAC_RXTEARDOWN_ADDR                   (_EMAC_BASE_ADDR+0x0018u)
S
S#define EMAC_RXTEARDOWN                         EMAC_REG(RXTEARDOWN)
S
S#define _EMAC_RXTEARDOWN_RXTDNCH_MASK           0x000000007u
S#define _EMAC_RXTEARDOWN_RXTDNCH_SHIFT          0u
S#define  EMAC_RXTEARDOWN_RXTDNCH_DEFAULT	0x00000000u
S
S
S/******************************************************************************\
S* _____________________
X
S* |                   |
S* |  RXMBPENABLE      |
S* |___________________|
S*
S* RXMBPENABLE       - RX Mulicast/Bcast/Promisc Channel Enable Register
S*
S* FIELDS (msb -> lsb)
S* (rw)  RXPASSCRC   - Pass Receive CRC
S* (rw)  RXQOSEN     - RX QOS Enable
S* (rw)  RXNOCHAIN   - RX No Buffer Chaining
S* (rw)  RXCMFEN     - RX Copy MAC Control Frames Enable
S* (rw)  RXCSFEN     - RX Copy Short Frames Enable
S* (rw)  RXCEFEN     - RX Copy Error Frames Enable
S* (rw)  RXCAFEN     - RX Copy All Frames Enable
S* (rw)  RXPROMCH    - RX Promiscusous Channel Select
S* (rw)  RXBROADEN   - RX Broadcast Frame Enable
S* (rw)  RXBROADCH   - RX Broadcast Channel Select
S* (rw)  RXMULTEN    - RX Multicast Enable
S* (rw)  RXMULTCH    - RX Multicast Channel Select
S*
S* MACROS SUPPORTED
S*  EMAC_FMK     y
S*  EMAC_FMKS    y
S*  EMAC_FMKCHF  .
S*  EMAC_ADDR    y
S*  EMAC_REG     y
S*  EMAC_RGET    y
S*  EMAC_RSET    y
S*  EMAC_FGET    y
S*  EMAC_FSET    y
S*  EMAC_FSETS   y
S*  EMAC_RGETI   .
S*  EMAC_RSETI   .
S*  EMAC_FGETI   .
S*  EMAC_FSETI   .
S*  EMAC_FSETSI  .
S*
S\******************************************************************************/
S#define _EMAC_RXMBPENABLE_ADDR                  (_EMAC_BASE_ADDR+0x0100u)
S
S#define EMAC_RXMBPENABLE                        EMAC_REG(RXMBPENABLE)
S
S#define _EMAC_RXMBPENABLE_RXPASSCRC_MASK        0x40000000u
S#define _EMAC_RXMBPENABLE_RXPASSCRC_SHIFT       30u
S#define  EMAC_RXMBPENABLE_RXPASSCRC_DEFAULT	0x00000000u
S#define EMAC_RXMBPENABLE_RXPASSCRC_DISCARD      0u
S#define EMAC_RXMBPENABLE_RXPASSCRC_INCLUDE      1u
S
S#define _EMAC_RXMBPENABLE_RXQOSEN_MASK          0x20000000u
S#define _EMAC_RXMBPENABLE_RXQOSEN_SHIFT         29u
S#define  EMAC_RXMBPENABLE_RXQOSEN_DEFAULT	0x00000000u
S#define EMAC_RXMBPENABLE_RXQOSEN_DISABLE        0u
S#define EMAC_RXMBPENABLE_RXQOSEN_ENABLE         1u
S
S#define _EMAC_RXMBPENABLE_RXNOCHAIN_MASK        0x10000000u
S#define _EMAC_RXMBPENABLE_RXNOCHAIN_SHIFT       28u
S#define  EMAC_RXMBPENABLE_RXNOCHAIN_DEFAULT	0x00000000u
S#define EMAC_RXMBPENABLE_RXNOCHAIN_DISABLE      0u
S#define EMAC_RXMBPENABLE_RXNOCHAIN_ENABLE       1u
S
S#define _EMAC_RXMBPENABLE_RXCMFEN_MASK          0x01000000u
S#define _EMAC_RXMBPENABLE_RXCMFEN_SHIFT         24u
S#define  EMAC_RXMBPENABLE_RXCMFEN_DEFAULT	0x00000000u
S#define EMAC_RXMBPENABLE_RXCMFEN_DISABLE        0u
S#define EMAC_RXMBPENABLE_RXCMFEN_ENABLE         1u
S
S#define _EMAC_RXMBPENABLE_RXCSFEN_MASK          0x00800000u
S#define _EMAC_RXMBPENABLE_RXCSFEN_SHIFT         23u
S#define  EMAC_RXMBPENABLE_RXCSFEN_DEFAULT	0x00000000u
S#define EMAC_RXMBPENABLE_RXCSFEN_DISABLE        0u
S#define EMAC_RXMBPENABLE_RXCSFEN_ENABLE         1u
S
S#define _EMAC_RXMBPENABLE_RXCEFEN_MASK          0x00400000u
S#define _EMAC_RXMBPENABLE_RXCEFEN_SHIFT         22u
S#define  EMAC_RXMBPENABLE_RXCEFEN_DEFAULT	0x00000000u
S#define EMAC_RXMBPENABLE_RXCEFEN_DISABLE        0u
S#define EMAC_RXMBPENABLE_RXCEFEN_ENABLE         1u
S
S#define _EMAC_RXMBPENABLE_RXCAFEN_MASK          0x00200000u
S#define _EMAC_RXMBPENABLE_RXCAFEN_SHIFT         21u
S#define  EMAC_RXMBPENABLE_RXCAFEN_DEFAULT	0x00000000u
S#define EMAC_RXMBPENABLE_RXCAFEN_DISABLE        0u
S#define EMAC_RXMBPENABLE_RXCAFEN_ENABLE         1u
S
S#define _EMAC_RXMBPENABLE_PROMCH_MASK           0x00070000u
S#define _EMAC_RXMBPENABLE_PROMCH_SHIFT          16u
S#define  EMAC_RXMBPENABLE_PROMCH_DEFAULT	0x00000000u
S
S#define _EMAC_RXMBPENABLE_BROADEN_MASK          0x00002000u
S#define _EMAC_RXMBPENABLE_BROADEN_SHIFT         13u
S#define  EMAC_RXMBPENABLE_BROADEN_DEFAULT	0x00000000u
S#define  EMAC_RXMBPENABLE_BROADEN_DISABLE	0u
S#define  EMAC_RXMBPENABLE_BROADEN_ENABLE         1u
S
S#define _EMAC_RXMBPENABLE_BROADCH_MASK          0x00000700u
S#define _EMAC_RXMBPENABLE_BROADCH_SHIFT         8u
S#define  EMAC_RXMBPENABLE_BROADCH_DEFAULT	0x00000000u
S
S#define _EMAC_RXMBPENABLE_MULTEN_MASK           0x00000020u
S#define _EMAC_RXMBPENABLE_MULTEN_SHIFT          5u
S#define  EMAC_RXMBPENABLE_MULTEN_DEFAULT	0x00000000u
S#define EMAC_RXMBPENABLE_MULTEN_DISABLE         0u
S#define EMAC_RXMBPENABLE_MULTEN_ENABLE          1u
S
S#define _EMAC_RXMBPENABLE_MULTCH_MASK           0x00000007u
S#define _EMAC_RXMBPENABLE_MULTCH_SHIFT          0u
S#define  EMAC_RXMBPENABLE_MULTCH_DEFAULT	0x00000000u
S/******************************************************************************\
S* _____________________
X
S* |                   |
S* |  RXUNICASTSET     |
S* |  RXUNICASTCLEAR   |
S* |___________________|
S*
S* RXUNICASTSET      - RX Unicast Set Register
S* RXUNICASTCLEAR    - RX Unicast Clear Register
S*
S* FIELDS (msb -> lsb)
S*  (r/ws)(r/wc)  Channel Flags (use EMAC_FMKCHF)
S*
S* MACROS SUPPORTED
S*  EMAC_FMK     .
S*  EMAC_FMKS    .
S*  EMAC_FMKCHF  y
S*  EMAC_ADDR    y
S*  EMAC_REG     y
S*  EMAC_RGET    y
S*  EMAC_RSET    y
S*  EMAC_FGET    .
S*  EMAC_FSET    .
S*  EMAC_FSETS   .
S*  EMAC_RGETI   .
S*  EMAC_RSETI   .
S*  EMAC_FGETI   .
S*  EMAC_FSETI   .
S*  EMAC_FSETSI  .
S*
S\******************************************************************************/
S#define _EMAC_RXUNICASTSET_ADDR                 (_EMAC_BASE_ADDR+0x0104u)
S#define _EMAC_RXUNICASTCLEAR_ADDR               (_EMAC_BASE_ADDR+0x0108u)
S
S#define EMAC_RXUNICASTSET                       EMAC_REG(RXUNICASTSET)
S#define EMAC_RXUNICASTCLEAR                     EMAC_REG(RXUNICASTCLEAR)
S
S
S
S/******************************************************************************\
S* _____________________
X
S* |                   |
S* |  RXMAXLEN         |
S* |___________________|
S*
S* MAXLEN            - RX Maximum Length Register
S*
S* FIELDS (msb -> lsb)
S*  (rw)  RXMAXLEN
S*
S* MACROS SUPPORTED
S*  EMAC_FMK     y
S*  EMAC_FMKS    .
S*  EMAC_FMKCHF  .
S*  EMAC_ADDR    y
S*  EMAC_REG     y
S*  EMAC_RGET    y
S*  EMAC_RSET    y
S*  EMAC_FGET    y
S*  EMAC_FSET    y
S*  EMAC_FSETS   .
S*  EMAC_RGETI   .
S*  EMAC_RSETI   .
S*  EMAC_FGETI   .
S*  EMAC_FSETI   .
S*  EMAC_FSETSI  .
S*
S\******************************************************************************/
S#define _EMAC_RXMAXLEN_ADDR                     (_EMAC_BASE_ADDR+0x010Cu)
S
S#define EMAC_RXMAXLEN                           EMAC_REG(RXMAXLEN)
S
S#define _EMAC_RXMAXLEN_MAXLEN_MASK              0x0000FFFFu
S#define _EMAC_RXMAXLEN_MAXLEN_SHIFT             0u
S#define  EMAC_RXMAXLEN_MAXLEN_DEFAULT		0x000005EEu
S
S/******************************************************************************\
S* _____________________
X
S* |                   |
S* |  RXBUFFEROFFSET   |
S* |___________________|
S*
S* RXBUFFEROFFSET        - RX Buffer Offset Register
S*
S* FIELDS (msb -> lsb)
S*  (rw)  BUFFEROFFSET
S*
S* MACROS SUPPORTED
S*  EMAC_FMK     y
S*  EMAC_FMKS    .
S*  EMAC_FMKCHF  .
S*  EMAC_ADDR    y
S*  EMAC_REG     y
S*  EMAC_RGET    y
S*  EMAC_RSET    y
S*  EMAC_FGET    y
S*  EMAC_FSET    y
S*  EMAC_FSETS   .
S*  EMAC_RGETI   .
S*  EMAC_RSETI   .
S*  EMAC_FGETI   .
S*  EMAC_FSETI   .
S*  EMAC_FSETSI  .
S*
S\******************************************************************************/
S#define _EMAC_RXBUFFEROFFSET_ADDR               (_EMAC_BASE_ADDR+0x0110u)
S
S#define EMAC_RXBUFFEROFFSET                     EMAC_REG(RXBUFFEROFFSET)
S
S#define _EMAC_RXBUFFEROFFSET_BUFFEROFFSET_MASK  0x0000FFFFu
S#define _EMAC_RXBUFFEROFFSET_BUFFEROFFSET_SHIFT 0u
S#define  EMAC_RXBUFFEROFFSET_BUFFEROFFSET_DEFAULT 0x00000000u
S/******************************************************************************\
S* _____________________
X
S* |                   |
S* | RXFILTERLOWTHRESH |
S* |___________________|
S*
S* RXFILTERLOWTHRESH - RX Filer Low Priority Packets Threshhold
S*
S* FIELDS (msb -> lsb)
S*  (rw)  FILTERTHRESH
S*
S* MACROS SUPPORTED
S*  EMAC_FMK     y
S*  EMAC_FMKS    .
S*  EMAC_FMKCHF  .
S*  EMAC_ADDR    y
S*  EMAC_REG     y
S*  EMAC_RGET    y
S*  EMAC_RSET    y
S*  EMAC_FGET    y
S*  EMAC_FSET    y
S*  EMAC_FSETS   .
S*  EMAC_RGETI   .
S*  EMAC_RSETI   .
S*  EMAC_FGETI   .
S*  EMAC_FSETI   .
S*  EMAC_FSETSI  .
S*
S\******************************************************************************/
S#define _EMAC_RXFILTERLOWTHRESH_ADDR            (_EMAC_BASE_ADDR+0x0114u)
S
S#define EMAC_RXFILTERLOWTHRESH                  EMAC_REG(RXFILTERLOWTHRESH)
S
S#define _EMAC_RXFILTERLOWTHRESH_FILTERTHRESH_MASK    0x000000FFu
S#define _EMAC_RXFILTERLOWTHRESH_FILTERTHRESH_SHIFT   0u
S#define  EMAC_RXFILTERLOWTHRESH_FILTERTHRESH_DEFAULT 0x00000000u
S
S
S/******************************************************************************\
S* _____________________
X
S* |                   |
S* |   RXFLOWTHRESH    |
S* |   RXnFLOWTHRESH   |
S* |___________________|
S*
S* RXFLOWTHRESH      - RX Flow Control Threshhold for RSETI/RGETI
S* RX0FLOWTHRESH     - RX Channel 0 Flow Control Threshhold
S* RX1FLOWTHRESH     - RX Channel 1 Flow Control Threshhold
S* RX2FLOWTHRESH     - RX Channel 2 Flow Control Threshhold
S* RX3FLOWTHRESH     - RX Channel 3 Flow Control Threshhold
S* RX4FLOWTHRESH     - RX Channel 4 Flow Control Threshhold
S* RX5FLOWTHRESH     - RX Channel 5 Flow Control Threshhold
S* RX6FLOWTHRESH     - RX Channel 6 Flow Control Threshhold
S* RX7FLOWTHRESH     - RX Channel 7 Flow Control Threshhold
S*
S* FIELDS (msb -> lsb)
S*  (rw)  FLOWTHRESH
S*
S* MACROS SUPPORTED
S*  EMAC_FMK     y
S*  EMAC_FMKS    .
S*  EMAC_FMKCHF  .
S*  EMAC_ADDR    y
S*  EMAC_REG     y
S*  EMAC_RGET    y
S*  EMAC_RSET    y
S*  EMAC_FGET    y
S*  EMAC_FSET    y
S*  EMAC_FSETS   .
S*  EMAC_RGETI   y
S*  EMAC_RSETI   y
S*  EMAC_FGETI   y
S*  EMAC_FSETI   y
S*  EMAC_FSETSI  .
S*
S\******************************************************************************/
S#define _EMAC_RXFLOWTHRESH_BASEADDR             (_EMAC_BASE_ADDR+0x0120u)
S#define _EMAC_RX0FLOWTHRESH_ADDR                (_EMAC_BASE_ADDR+0x0120u)
S#define _EMAC_RX1FLOWTHRESH_ADDR                (_EMAC_BASE_ADDR+0x0124u)
S#define _EMAC_RX2FLOWTHRESH_ADDR                (_EMAC_BASE_ADDR+0x0128u)
S#define _EMAC_RX3FLOWTHRESH_ADDR                (_EMAC_BASE_ADDR+0x012Cu)
S#define _EMAC_RX4FLOWTHRESH_ADDR                (_EMAC_BASE_ADDR+0x0130u)
S#define _EMAC_RX5FLOWTHRESH_ADDR                (_EMAC_BASE_ADDR+0x0134u)
S#define _EMAC_RX6FLOWTHRESH_ADDR                (_EMAC_BASE_ADDR+0x0138u)
S#define _EMAC_RX7FLOWTHRESH_ADDR                (_EMAC_BASE_ADDR+0x013Cu)
S
S#define EMAC_RX0FLOWTHRESH                      EMAC_REG(RX0FLOWTHRESH)
S#define EMAC_RX1FLOWTHRESH                      EMAC_REG(RX1FLOWTHRESH)
S#define EMAC_RX2FLOWTHRESH                      EMAC_REG(RX2FLOWTHRESH)
S#define EMAC_RX3FLOWTHRESH                      EMAC_REG(RX3FLOWTHRESH)
S#define EMAC_RX4FLOWTHRESH                      EMAC_REG(RX4FLOWTHRESH)
S#define EMAC_RX5FLOWTHRESH                      EMAC_REG(RX5FLOWTHRESH)
S#define EMAC_RX6FLOWTHRESH                      EMAC_REG(RX6FLOWTHRESH)
S#define EMAC_RX7FLOWTHRESH                      EMAC_REG(RX7FLOWTHRESH)
S
S#define _EMAC_RXFLOWTHRESH_FLOWTHRESH_MASK      0x000000FFu
S#define _EMAC_RXFLOWTHRESH_FLOWTHRESH_SHIFT     0u
S#define  EMAC_RXFLOWTHRESH_FLOWTHRESH_DEFAULT	0x00000000u
S#define _EMAC_RX0FLOWTHRESH_FLOWTHRESH_MASK     0x000000FFu
S#define _EMAC_RX0FLOWTHRESH_FLOWTHRESH_SHIFT    0u
S#define  EMAC_RX0FLOWTHRESH_FLOWTHRESH_DEFAULT	0x00000000u
S#define _EMAC_RX1FLOWTHRESH_FLOWTHRESH_MASK     0x000000FFu
S#define _EMAC_RX1FLOWTHRESH_FLOWTHRESH_SHIFT    0u
S#define  EMAC_RX1FLOWTHRESH_FLOWTHRESH_DEFAULT	0x00000000u
S#define _EMAC_RX2FLOWTHRESH_FLOWTHRESH_MASK     0x000000FFu
S#define _EMAC_RX2FLOWTHRESH_FLOWTHRESH_SHIFT    0u
S#define  EMAC_RX2FLOWTHRESH_FLOWTHRESH_DEFAULT	0x00000000u
S#define _EMAC_RX3FLOWTHRESH_FLOWTHRESH_MASK     0x000000FFu
S#define _EMAC_RX3FLOWTHRESH_FLOWTHRESH_SHIFT    0u
S#define  EMAC_RX3FLOWTHRESH_FLOWTHRESH_DEFAULT	0x00000000u
S#define _EMAC_RX4FLOWTHRESH_FLOWTHRESH_MASK     0x000000FFu
S#define _EMAC_RX4FLOWTHRESH_FLOWTHRESH_SHIFT    0u
S#define  EMAC_RX4FLOWTHRESH_FLOWTHRESH_DEFAULT	0x00000000u
S#define _EMAC_RX5FLOWTHRESH_FLOWTHRESH_MASK     0x000000FFu
S#define _EMAC_RX5FLOWTHRESH_FLOWTHRESH_SHIFT    0u
S#define  EMAC_RX5FLOWTHRESH_FLOWTHRESH_DEFAULT	0x00000000u
S#define _EMAC_RX6FLOWTHRESH_FLOWTHRESH_MASK     0x000000FFu
S#define _EMAC_RX6FLOWTHRESH_FLOWTHRESH_SHIFT    0u
S#define  EMAC_RX6FLOWTHRESH_FLOWTHRESH_DEFAULT	0x00000000u
S#define _EMAC_RX7FLOWTHRESH_FLOWTHRESH_MASK     0x000000FFu
S#define _EMAC_RX7FLOWTHRESH_FLOWTHRESH_SHIFT    0u
S#define  EMAC_RX7FLOWTHRESH_FLOWTHRESH_DEFAULT	0x00000000u
S/******************************************************************************\
S* _____________________
X
S* |                   |
S* |   RXFREEBUFFER    |
S* |   RXnFREEBUFFER   |
S* |___________________|
S*
S* RXFREEBUFFER      - RX Free Buffer Count for RSETI/RGETI
S* RX0FREEBUFFER     - RX Channel 0 Free Buffer Count Register
S* RX1FREEBUFFER     - RX Channel 1 Free Buffer Count Register
S* RX2FREEBUFFER     - RX Channel 2 Free Buffer Count Register
S* RX3FREEBUFFER     - RX Channel 3 Free Buffer Count Register
S* RX4FREEBUFFER     - RX Channel 4 Free Buffer Count Register
S* RX5FREEBUFFER     - RX Channel 5 Free Buffer Count Register
S* RX6FREEBUFFER     - RX Channel 6 Free Buffer Count Register
S* RX7FREEBUFFER     - RX Channel 7 Free Buffer Count Register
S*
S* FIELDS (msb -> lsb)
S*  (rw)  FREEBUF
S*
S* MACROS SUPPORTED
S*  EMAC_FMK     y
S*  EMAC_FMKS    .
S*  EMAC_FMKCHF  .
S*  EMAC_ADDR    y
S*  EMAC_REG     y
S*  EMAC_RGET    y
S*  EMAC_RSET    y
S*  EMAC_FGET    y
S*  EMAC_FSET    y
S*  EMAC_FSETS   .
S*  EMAC_RGETI   y
S*  EMAC_RSETI   y
S*  EMAC_FGETI   y
S*  EMAC_FSETI   y
S*  EMAC_FSETSI  .
S*
S\******************************************************************************/
S#define _EMAC_RXFREEBUFFER_BASEADDR             (_EMAC_BASE_ADDR+0x0140u)
S#define _EMAC_RX0FREEBUFFER_ADDR                (_EMAC_BASE_ADDR+0x0140u)
S#define _EMAC_RX1FREEBUFFER_ADDR                (_EMAC_BASE_ADDR+0x0144u)
S#define _EMAC_RX2FREEBUFFER_ADDR                (_EMAC_BASE_ADDR+0x0148u)
S#define _EMAC_RX3FREEBUFFER_ADDR                (_EMAC_BASE_ADDR+0x014Cu)
S#define _EMAC_RX4FREEBUFFER_ADDR                (_EMAC_BASE_ADDR+0x0150u)
S#define _EMAC_RX5FREEBUFFER_ADDR                (_EMAC_BASE_ADDR+0x0154u)
S#define _EMAC_RX6FREEBUFFER_ADDR                (_EMAC_BASE_ADDR+0x0158u)
S#define _EMAC_RX7FREEBUFFER_ADDR                (_EMAC_BASE_ADDR+0x015Cu)
S
S#define EMAC_RX0FREEBUFFER                      EMAC_REG(RX0FREEBUFFER)
S#define EMAC_RX1FREEBUFFER                      EMAC_REG(RX1FREEBUFFER)
S#define EMAC_RX2FREEBUFFER                      EMAC_REG(RX2FREEBUFFER)
S#define EMAC_RX3FREEBUFFER                      EMAC_REG(RX3FREEBUFFER)
S#define EMAC_RX4FREEBUFFER                      EMAC_REG(RX4FREEBUFFER)
S#define EMAC_RX5FREEBUFFER                      EMAC_REG(RX5FREEBUFFER)
S#define EMAC_RX6FREEBUFFER                      EMAC_REG(RX6FREEBUFFER)
S#define EMAC_RX7FREEBUFFER                      EMAC_REG(RX7FREEBUFFER)
S
S#define _EMAC_RXFREEBUFFER_FREEBUF_MASK         0x0000FFFFu
S#define _EMAC_RXFREEBUFFER_FREEBUF_SHIFT        0u
S#define	 EMAC_RXFREEBUFFER_FREEBUF_DEFAULT	0x00000000u
S#define _EMAC_RX0FREEBUFFER_FREEBUF_MASK        0x0000FFFFu
S#define _EMAC_RX0FREEBUFFER_FREEBUF_SHIFT       0u
S#define  EMAC_RX0FREEBUFFER_FREEBUF_DEFAULT	0x00000000u
S#define _EMAC_RX1FREEBUFFER_FREEBUF_MASK        0x0000FFFFu
S#define _EMAC_RX1FREEBUFFER_FREEBUF_SHIFT       0u
S#define  EMAC_RX1FREEBUFFER_FREEBUF_DEFAULT	0x00000000u
S#define _EMAC_RX2FREEBUFFER_FREEBUF_MASK        0x0000FFFFu
S#define _EMAC_RX2FREEBUFFER_FREEBUF_SHIFT       0u
S#define  EMAC_RX2FREEBUFFER_FREEBUF_DEFAULT	0x00000000u
S#define _EMAC_RX3FREEBUFFER_FREEBUF_MASK        0x0000FFFFu
S#define _EMAC_RX3FREEBUFFER_FREEBUF_SHIFT       0u
S#define  EMAC_RX3FREEBUFFER_FREEBUF_DEFAULT	0x00000000u
S#define _EMAC_RX4FREEBUFFER_FREEBUF_MASK        0x0000FFFFu
S#define _EMAC_RX4FREEBUFFER_FREEBUF_SHIFT       0u
S#define  EMAC_RX4FREEBUFFER_FREEBUF_DEFAULT	0x00000000u
S#define _EMAC_RX5FREEBUFFER_FREEBUF_MASK        0x0000FFFFu
S#define _EMAC_RX5FREEBUFFER_FREEBUF_SHIFT       0u
S#define  EMAC_RX5FREEBUFFER_FREEBUF_DEFAULT	0x00000000u
S#define _EMAC_RX6FREEBUFFER_FREEBUF_MASK        0x0000FFFFu
S#define _EMAC_RX6FREEBUFFER_FREEBUF_SHIFT       0u
S#define  EMAC_RX6FREEBUFFER_FREEBUF_DEFAULT	0x00000000u
S#define _EMAC_RX7FREEBUFFER_FREEBUF_MASK        0x0000FFFFu
S#define _EMAC_RX7FREEBUFFER_FREEBUF_SHIFT       0u
S#define  EMAC_RX7FREEBUFFER_FREEBUF_DEFAULT	0x00000000u
S
S
S/******************************************************************************\
S* _____________________
X
S* |                   |
S* |   MACCONTROL      |
S* |___________________|
S*
S* MACCONTROL        - MAC Control Register
S*
S* FIELDS (msb -> lsb)
S* (rw)  TXPTYPE     - TX Priority Queue Type
S* (rw)  TXPACE      - TX Pacing Enable
S* (rw)  MIIEN       - MII Enable
S* (rw)  TXFLOWEN    - TX Flow Control Enable
S* (rw)  RXFLOWEN    - RX Flow Control Enable
S* (rw)  MTEST       - Manufacturer's Test Enable
S* (rw)  LOOPBACK    - Loopback Mode Enable
S* (rw)  FULLDUPLEX  - Full Duplex Mode Enable
S*
S* MACROS SUPPORTED
S*  EMAC_FMK     y
S*  EMAC_FMKS    y
S*  EMAC_FMKCHF  .
S*  EMAC_ADDR    y
S*  EMAC_REG     y
S*  EMAC_RGET    y
S*  EMAC_RSET    y
S*  EMAC_FGET    y
S*  EMAC_FSET    y
S*  EMAC_FSETS   y
S*  EMAC_RGETI   .
S*  EMAC_RSETI   .
S*  EMAC_FGETI   .
S*  EMAC_FSETI   .
S*  EMAC_FSETSI  .
S*
S\******************************************************************************/
S#define _EMAC_MACCONTROL_ADDR                   (_EMAC_BASE_ADDR+0x0160u)
S
S#define EMAC_MACCONTROL                         EMAC_REG(MACCONTROL)
S
S#define _EMAC_MACCONTROL_TXPTYPE_MASK           0x00000200u
S#define _EMAC_MACCONTROL_TXPTYPE_SHIFT          9u
S#define  EMAC_MACCONTROL_TXPTYPE_DEFAULT	0x00000000u
S#define EMAC_MACCONTROL_TXPTYPE_RROBIN          0u
S#define EMAC_MACCONTROL_TXPTYPE_CHANNELPRI      1u
S
S#define _EMAC_MACCONTROL_TXPACE_MASK            0x00000040u
S#define _EMAC_MACCONTROL_TXPACE_SHIFT           6u
S#define  EMAC_MACCONTROL_TXPACE_DEFAULT		0x00000000u
S#define EMAC_MACCONTROL_TXPACE_DISABLE          0u
S#define EMAC_MACCONTROL_TXPACE_ENABLE           1u
S
S#define _EMAC_MACCONTROL_MIIEN_MASK             0x00000020u
S#define _EMAC_MACCONTROL_MIIEN_SHIFT            5u
S#define  EMAC_MACCONTROL_MIIEN_DEFAULT		0x00000000u
S#define EMAC_MACCONTROL_MIIEN_DISABLE           0u
S#define EMAC_MACCONTROL_MIIEN_ENABLE            1u
S
S#define _EMAC_MACCONTROL_TXFLOWEN_MASK          0x00000010u
S#define _EMAC_MACCONTROL_TXFLOWEN_SHIFT         4u
S#define  EMAC_MACCONTROL_TXFLOWEN_DEFAULT	0x00000000u
S#define EMAC_MACCONTROL_TXFLOWEN_DISABLE        0u
S#define EMAC_MACCONTROL_TXFLOWEN_ENABLE         1u
S
S#define _EMAC_MACCONTROL_RXFLOWEN_MASK          0x00000008u
S#define _EMAC_MACCONTROL_RXFLOWEN_SHIFT         3u
S#define  EMAC_MACCONTROL_RXFLOWEN_DEFAULT	0x00000000u
S#define EMAC_MACCONTROL_RXFLOWEN_DISABLE        0u
S#define EMAC_MACCONTROL_RXFLOWEN_ENABLE         1u
S
S#define _EMAC_MACCONTROL_MTEST_MASK             0x00000004u
S#define _EMAC_MACCONTROL_MTEST_SHIFT            2u
S#define  EMAC_MACCONTROL_MTEST_DEFAULT		0x00000000u
S#define EMAC_MACCONTROL_MTEST_DISABLE           0u
S#define EMAC_MACCONTROL_MTEST_ENABLE            1u
S
S#define _EMAC_MACCONTROL_LOOPBACK_MASK          0x00000002u
S#define _EMAC_MACCONTROL_LOOPBACK_SHIFT         1u
S#define  EMAC_MACCONTROL_LOOPBACK_DEFAULT	0x00000000u
S#define EMAC_MACCONTROL_LOOPBACK_DISABLE        0u
S#define EMAC_MACCONTROL_LOOPBACK_ENABLE         1u
S
S#define _EMAC_MACCONTROL_FULLDUPLEX_MASK        0x00000001u
S#define _EMAC_MACCONTROL_FULLDUPLEX_SHIFT       0u
S#define  EMAC_MACCONTROL_FULLDUPLEX_DEFAULT	0x00000000u
S#define EMAC_MACCONTROL_FULLDUPLEX_DISABLE      0u
S#define EMAC_MACCONTROL_FULLDUPLEX_ENABLE       1u
S
S
S
S/******************************************************************************\
S* _____________________
X
S* |                   |
S* |   MACSTATUS       |
S* |___________________|
S*
S* MACSTATUS         - MAC Status Register
S*
S* FIELDS (msb -> lsb)
S* (r)  TXERRCODE    - TX Host Error Code
S* (r)  THERRCH      - TX Host Error Channel
S* (r)  RXERRCODE    - RX Host Error Code
S* (r)  RXERRCH      - RX Host Error Channel
S* (r)  RXQOSACT     - RX QOS Service Currently Active
S* (r)  RXFLOWACT    - RX Flow Control Currently Active
S* (r)  TXFLOWACT    - TX Flow Control Currently Active
S*
S* MACROS SUPPORTED
S*  EMAC_FMK     y
S*  EMAC_FMKS    y
S*  EMAC_FMKCHF  .
S*  EMAC_ADDR    y
S*  EMAC_REG     y
S*  EMAC_RGET    y
S*  EMAC_RSET    y
S*  EMAC_FGET    y
S*  EMAC_FSET    y
S*  EMAC_FSETS   y
S*  EMAC_RGETI   .
S*  EMAC_RSETI   .
S*  EMAC_FGETI   .
S*  EMAC_FSETI   .
S*  EMAC_FSETSI  .
S*
S\******************************************************************************/
S#define _EMAC_MACSTATUS_ADDR                    (_EMAC_BASE_ADDR+0x0164u)
S
S#define EMAC_MACSTATUS                          EMAC_REG(MACSTATUS)
S
S#define _EMAC_MACSTATUS_TXERRCODE_MASK          0x00F00000u
S#define _EMAC_MACSTATUS_TXERRCODE_SHIFT         20u
S#define  EMAC_MACSTATUS_TXERRCODE_DEFAULT	0x00000000u
S#define EMAC_MACSTATUS_TXERRCODE_NOERROR        0u
S#define EMAC_MACSTATUS_TXERRCODE_SOPERROR       1u
S#define EMAC_MACSTATUS_TXERRCODE_OWNERSHIP      2u
S#define EMAC_MACSTATUS_TXERRCODE_NOEOP          3u
S#define EMAC_MACSTATUS_TXERRCODE_NULLPTR        4u
S#define EMAC_MACSTATUS_TXERRCODE_NULLLEN        5u
S#define EMAC_MACSTATUS_TXERRCODE_LENRRROR       6u
S
S#define _EMAC_MACSTATUS_TXERRCH_MASK            0x00070000u
S#define _EMAC_MACSTATUS_TXERRCH_SHIFT           16u
S#define  EMAC_MACSTATUS_TXERRCH_DEFAULT		0x00000000u
S
S#define _EMAC_MACSTATUS_RXERRCODE_MASK          0x0000F000u
S#define _EMAC_MACSTATUS_RXERRCODE_SHIFT         12u
S#define  EMAC_MACSTATUS_RXERRCODE_DEFAULT	0x00000000u
S#define EMAC_MACSTATUS_RXERRCODE_NOERROR        0u
S#define EMAC_MACSTATUS_RXERRCODE_SOPERROR       1u
S#define EMAC_MACSTATUS_RXERRCODE_OWNERSHIP      2u
S#define EMAC_MACSTATUS_RXERRCODE_NOEOP          3u
S#define EMAC_MACSTATUS_RXERRCODE_NULLPTR        4u
S#define EMAC_MACSTATUS_RXERRCODE_NULLLEN        5u
S#define EMAC_MACSTATUS_RXERRCODE_LENRRROR       6u
S
S#define _EMAC_MACSTATUS_RXERRCH_MASK            0x00000700u
S#define _EMAC_MACSTATUS_RXERRCH_SHIFT           8u
S#define  EMAC_MACSTATUS_RXERRCH_DEFAULT		0x00000000u
S
S#define _EMAC_MACSTATUS_RXQOSACT_MASK           0x00000004u
S#define _EMAC_MACSTATUS_RXQOSACT_SHIFT          2u
S#define  EMAC_MACSTATUS_RXQOSACT_DEFAULT	0x00000000u
S
S#define _EMAC_MACSTATUS_RXFLOWACT_MASK          0x00000002u
S#define _EMAC_MACSTATUS_RXFLOWACT_SHIFT         1u
S#define  EMAC_MACSTATUS_RXFLOWACT_DEFAULT	0x00000000u
S
S#define _EMAC_MACSTATUS_TXFLOWACT_MASK          0x00000001u
S#define _EMAC_MACSTATUS_TXFLOWACT_SHIFT         0u
S#define  EMAC_MACSTATUS_TXFLOWACT_DEFAULT	0x00000000u
S
S/******************************************************************************\
S* _____________________
X
S* |                   |
S* |   EMCONTROL       |
S* |___________________|
S*
S* EMCONTROL         - Emulation Control Register
S*
S* FIELDS (msb -> lsb)
S* (rw)  SOFT    - Emulation Soft Bit
S* (rw)  FREE    - Emulation Free Bit
S*
S* MACROS SUPPORTED
S*  EMAC_FMK     y
S*  EMAC_FMKS    .
S*  EMAC_FMKCHF  .
S*  EMAC_ADDR    y
S*  EMAC_REG     y
S*  EMAC_RGET    y
S*  EMAC_RSET    y
S*  EMAC_FGET    y
S*  EMAC_FSET    y
S*  EMAC_FSETS   .
S*  EMAC_RGETI   .
S*  EMAC_RSETI   .
S*  EMAC_FGETI   .
S*  EMAC_FSETI   .
S*  EMAC_FSETSI  .
S*
S\******************************************************************************/
S#define _EMAC_EMCONTROL_ADDR                    (_EMAC_BASE_ADDR+0x0168u)
S
S#define EMAC_EMCONTROL                          EMAC_REG(EMCONTROL)
S
S#define _EMAC_EMCONTROL_SOFT_MASK               0x00000002u
S#define _EMAC_EMCONTROL_SOFT_SHIFT              1u
S
S#define _EMAC_EMCONTROL_FREE_MASK               0x00000001u
S#define _EMAC_EMCONTROL_FREE_SHIFT              0u
S
S
S
S/******************************************************************************\
S* _____________________
X
S* |                   |
S* |  MACINVECTOR      |
S* |___________________|
S*
S* MACINVECTOR       - MAC Input Vector
S*
S* FIELDS (msb -> lsb)
S*  (r) USERINT  - MDIO User Interrupt
S*  (r) LINKINT  - MDIO Link Change Interrupt
S*  (r) HOSTPEND - Host Pending Interrupt
S*  (r) STATPEND - Statistics Interrupt
S*  (r) RXPEND   - RX Pending Interrupt Flags (7-0)
S*  (r) TXPEND   - TX Pending Interrupt Falgs (7-0)
S*
S* MACROS SUPPORTED
S*  EMAC_FMK     y
S*  EMAC_FMKS    .
S*  EMAC_FMKCHF  .
S*  EMAC_ADDR    y
S*  EMAC_REG     y
S*  EMAC_RGET    y
S*  EMAC_RSET    .
S*  EMAC_FGET    y
S*  EMAC_FSET    .
S*  EMAC_FSETS   .
S*  EMAC_RGETI   .
S*  EMAC_RSETI   .
S*  EMAC_FGETI   .
S*  EMAC_FSETI   .
S*  EMAC_FSETSI  .
S*
S\******************************************************************************/
S#define _EMAC_MACINVECTOR_ADDR                  (_EMAC_BASE_ADDR+0x0180u)
S
S#define EMAC_MACINVECTOR                        EMAC_REG(MACINVECTOR)
S
S#define _EMAC_MACINVECTOR_USERINT_MASK          0x80000000u
S#define _EMAC_MACINVECTOR_USERINT_SHIFT         31u
S#define  EMAC_MACINVECTOR_USERINT_DEFAULT	0x00000000u
S#define _EMAC_MACINVECTOR_LINKINT_MASK          0x40000000u
S#define _EMAC_MACINVECTOR_LINKINT_SHIFT         30u
S#define  EMAC_MACINVECTOR_LINKINT_DEFAULT	0x00000000u
S#define _EMAC_MACINVECTOR_HOSTPEND_MASK         0x00020000u
S#define _EMAC_MACINVECTOR_HOSTPEND_SHIFT        17u
S#define  EMAC_MACINVECTOR_HOSTPEND_DEFAULT	0x00000000u
S#define _EMAC_MACINVECTOR_STATPEND_MASK         0x00010000u
S#define _EMAC_MACINVECTOR_STATPEND_SHIFT        16u
S#define  EMAC_MACINVECTOR_STATPEND_DEFAULT	0x00000000u
S#define _EMAC_MACINVECTOR_RXPEND_MASK           0x0000FF00u
S#define _EMAC_MACINVECTOR_RXPEND_SHIFT          8u
S#define  EMAC_MACINVECTOR_RXPEND_DEFAULT	0x00000000u
S#define _EMAC_MACINVECTOR_TXPEND_MASK           0x000000FFu
S#define _EMAC_MACINVECTOR_TXPEND_SHIFT          0u
S#define  EMAC_MACINVECTOR_TXPEND_DEFAULT	0x00000000u
S
S
S/******************************************************************************\
S* _____________________
X
S* |                   |
S* |  MACEOIVECTOR     |
S* |___________________|
S*
S* MACEOIVECTOR      - MAC EOI Vector
S*
S* FIELDS (msb -> lsb)
S*  (r/w) Flags
S*
S* MACROS SUPPORTED
S*  EMAC_FMK     .
S*  EMAC_FMKS    .
S*  EMAC_FMKCHF  .
S*  EMAC_ADDR    y
S*  EMAC_REG     y
S*  EMAC_RGET    y
S*  EMAC_RSET    y
S*  EMAC_FGET    .
S*  EMAC_FSET    .
S*  EMAC_FSETS   .
S*  EMAC_RGETI   .
S*  EMAC_RSETI   .
S*  EMAC_FGETI   .
S*  EMAC_FSETI   .
S*  EMAC_FSETSI  .
S*
S\******************************************************************************/
S#define _EMAC_MACEOIVECTOR_ADDR                 (_EMAC_BASE_ADDR+0x0184u)
S
S#define EMAC_MACEOIVECTOR                       EMAC_REG(MACEOIVECTOR)
S
S
S/******************************************************************************\
S* _____________________
X
S* |                   |
S* |  TXINTSTATRAW     |
S* |  TXINTSTATMASKED  |
S* |  TXINTMASKSET     |
S* |  TXINTMASKCLEAR   |
S* |  RXINTSTATRAW     |
S* |  RXINTSTATMASKED  |
S* |  RXINTMASKSET     |
S* |  RXINTMASKCLEAR   |
S* |___________________|
S*
S* TXINTSTATRAW      - TX Interrupt Status Register (Unmasked)
S* TXINTSTATMASKED   - TX Interrupt Status Register (Masked)
S* TXINTMASKSET      - TX Interrupt Mask Set Register
S* TXINTMASKCLEAR    - TX Interrupt Mask Clear Register
S* RXINTSTATRAW      - RX Interrupt Status Register (Unmasked)
S* RXINTSTATMASKED   - RX Interrupt Status Register (Masked)
S* RXINTMASKSET      - RX Interrupt Mask Set Register
S* RXINTMASKCLEAR    - RX Interrupt Mask Clear Register
S*
S* FIELDS (msb -> lsb)
S*  (r)(r/ws)(r/wc) Channel Flags (use EMAC_FMKCHF)
S*
S* MACROS SUPPORTED
S*  EMAC_FMK     .
S*  EMAC_FMKS    .
S*  EMAC_FMKCHF  y
S*  EMAC_ADDR    y
S*  EMAC_REG     y
S*  EMAC_RGET    y
S*  EMAC_RSET    y
S*  EMAC_FGET    .
S*  EMAC_FSET    .
S*  EMAC_FSETS   .
S*  EMAC_RGETI   .
S*  EMAC_RSETI   .
S*  EMAC_FGETI   .
S*  EMAC_FSETI   .
S*  EMAC_FSETSI  .
S*
S\******************************************************************************/
S#define _EMAC_TXINTSTATRAW_ADDR                 (_EMAC_BASE_ADDR+0x0170u)
S#define _EMAC_TXINTSTATMASKED_ADDR              (_EMAC_BASE_ADDR+0x0174u)
S#define _EMAC_TXINTMASKSET_ADDR                 (_EMAC_BASE_ADDR+0x0178u)
S#define _EMAC_TXINTMASKCLEAR_ADDR               (_EMAC_BASE_ADDR+0x017Cu)
S#define _EMAC_RXINTSTATRAW_ADDR                 (_EMAC_BASE_ADDR+0x0190u)
S#define _EMAC_RXINTSTATMASKED_ADDR              (_EMAC_BASE_ADDR+0x0194u)
S#define _EMAC_RXINTMASKSET_ADDR                 (_EMAC_BASE_ADDR+0x0198u)
S#define _EMAC_RXINTMASKCLEAR_ADDR               (_EMAC_BASE_ADDR+0x019Cu)
S
S#define EMAC_TXINTSTATRAW                       EMAC_REG(TXINTSTATRAW)
S#define EMAC_TXINTSTATMASKED                    EMAC_REG(TXINTSTATMASKED)
S#define EMAC_TXINTMASKSET                       EMAC_REG(TXINTMASKSET)
S#define EMAC_TXINTMASKCLEAR                     EMAC_REG(TXINTMASKCLEAR)
S#define EMAC_RXINTSTATRAW                       EMAC_REG(RXINTSTATRAW)
S#define EMAC_RXINTSTATMASKED                    EMAC_REG(RXINTSTATMASKED)
S#define EMAC_RXINTMASKSET                       EMAC_REG(RXINTMASKSET)
S#define EMAC_RXINTMASKCLEAR                     EMAC_REG(RXINTMASKCLEAR)
S
S
S
S/******************************************************************************\
S* _____________________
X
S* |                   |
S* |  MACINTSTATRAW    |
S* |  MACINTSTATMASKED |
S* |  MACINTMASKSET    |
S* |  MACINTMASKCLEAR  |
S* |___________________|
S*
S* MACINTSTATRAW     - MAC Interrupt Status Register (Unmasked)
S* MACINTSTATMASKED  - MAC Interrupt Status Register (Masked)
S* MACINTMASKSET     - MAC Interrupt Mask Set Register
S* MACINTMASKCLEAR   - MAC Interrupt Mask Clear Register
S*
S* FIELDS (msb -> lsb)
S* (r)(r/ws)(r/wc) HOSTERRINT  - Host Error Interrupt
S* (r)(r/ws)(r/wc) STATINT     - Statistics Interrupt
S*
S* MACROS SUPPORTED
S*  EMAC_FMK     y
S*  EMAC_FMKS    .
S*  EMAC_FMKCHF  .
S*  EMAC_ADDR    y
S*  EMAC_REG     y
S*  EMAC_RGET    y
S*  EMAC_RSET    y
S*  EMAC_FGET    y
S*  EMAC_FSET    y
S*  EMAC_FSETS   .
S*  EMAC_RGETI   .
S*  EMAC_RSETI   .
S*  EMAC_FGETI   .
S*  EMAC_FSETI   .
S*  EMAC_FSETSI  .
S*
S\******************************************************************************/
S#define _EMAC_MACINTSTATRAW_ADDR                (_EMAC_BASE_ADDR+0x01A0u)
S#define _EMAC_MACINTSTATMASKED_ADDR             (_EMAC_BASE_ADDR+0x01A4u)
S#define _EMAC_MACINTMASKSET_ADDR                (_EMAC_BASE_ADDR+0x01A8u)
S#define _EMAC_MACINTMASKCLEAR_ADDR              (_EMAC_BASE_ADDR+0x01ACu)
S
S#define EMAC_MACINTSTATRAW                      EMAC_REG(MACINTSTATRAW)
S#define EMAC_MACINTSTATMASKED                   EMAC_REG(MACINTSTATMASKED)
S#define EMAC_MACINTMASKSET                      EMAC_REG(MACINTMASKSET)
S#define EMAC_MACINTMASKCLEAR                    EMAC_REG(MACINTMASKCLEAR)
S
S#define _EMAC_MACINTSTATRAW_HOSTERRINT_MASK     0x00000002u
S#define _EMAC_MACINTSTATMASKED_HOSTERRINT_MASK  0x00000002u
S#define _EMAC_MACINTMASKSET_HOSTERRINT_MASK     0x00000002u
S#define _EMAC_MACINTMASKCLEAR_HOSTERRINT_MASK   0x00000002u
S#define _EMAC_MACINTSTATRAW_HOSTERRINT_SHIFT    1u
S#define  EMAC_MACINTSTATRAW_HOSTERRINT_DEFAULT	0x00000000u
S#define _EMAC_MACINTSTATMASKED_HOSTERRINT_SHIFT 1u
S#define  EMAC_MACINTSTATMASKED_HOSTERRINT_DEFAULT 0x00000000u
S#define _EMAC_MACINTMASKSET_HOSTERRINT_SHIFT    1u
S#define  EMAC_MACINTMASKSET_HOSTERRINT_DEFAULT	0x00000000u
S#define _EMAC_MACINTMASKCLEAR_HOSTERRINT_SHIFT  1u
S#define  EMAC_MACINTMASKCLEAR_HOSTERRINT_DEFAULT 0x00000000u
S
S#define _EMAC_MACINTSTATRAW_STATINT_MASK        0x00000001u
S#define _EMAC_MACINTSTATMASKED_STATINT_MASK     0x00000001u
S#define _EMAC_MACINTMASKSET_STATINT_MASK        0x00000001u
S#define _EMAC_MACINTMASKCLEAR_STATINT_MASK      0x00000001u
S#define _EMAC_MACINTSTATRAW_STATINT_SHIFT       0u
S#define  EMAC_MACINTSTATRAW_STATINT_DEFAULT	0x00000000u
S#define _EMAC_MACINTSTATMASKED_STATINT_SHIFT    0u
S#define  EMAC_MACINTSTATMASKED_STATINT_DEFAULT	0x00000000u
S#define _EMAC_MACINTMASKSET_STATINT_SHIFT       0u
S#define  EMAC_MACINTMASKSET_STATINT_DEFAULT	0x00000000u
S#define _EMAC_MACINTMASKCLEAR_STATINT_SHIFT     0u
S#define  EMAC_MACINTMASKCLEAR_STATINT_DEFAULT	0x00000000u
S
S/******************************************************************************\
S* _____________________
X
S* |                   |
S* |   MACADDRL        |
S* |   MACADDRLn       |
S* |___________________|
S*
S* MACADDRL          - MAC Address Lower Byte Register for RSETI/RGETI
S* MACADDRL0         - MAC Address Channel 0 Lower Byte Register
S* MACADDRL1         - MAC Address Channel 1 Lower Byte Register
S* MACADDRL2         - MAC Address Channel 2 Lower Byte Register
S* MACADDRL3         - MAC Address Channel 3 Lower Byte Register
S* MACADDRL4         - MAC Address Channel 4 Lower Byte Register
S* MACADDRL5         - MAC Address Channel 5 Lower Byte Register
S* MACADDRL6         - MAC Address Channel 6 Lower Byte Register
S* MACADDRL7         - MAC Address Channel 7 Lower Byte Register
S*
S* FIELDS (msb -> lsb)
S*  (rw)  MACADDR8   - 8 bits of MAC Address
S*
S* MACROS SUPPORTED
S*  EMAC_FMK     y
S*  EMAC_FMKS    .
S*  EMAC_FMKCHF  .
S*  EMAC_ADDR    y
S*  EMAC_REG     y
S*  EMAC_RGET    y
S*  EMAC_RSET    y
S*  EMAC_FGET    y
S*  EMAC_FSET    y
S*  EMAC_FSETS   .
S*  EMAC_RGETI   y
S*  EMAC_RSETI   y
S*  EMAC_FGETI   y
S*  EMAC_FSETI   y
S*  EMAC_FSETSI  .
S*
S\******************************************************************************/
S#define _EMAC_MACADDRL_BASEADDR                 (_EMAC_BASE_ADDR+0x01B0u)
S#define _EMAC_MACADDRL0_ADDR                    (_EMAC_BASE_ADDR+0x01B0u)
S#define _EMAC_MACADDRL1_ADDR                    (_EMAC_BASE_ADDR+0x01B4u)
S#define _EMAC_MACADDRL2_ADDR                    (_EMAC_BASE_ADDR+0x01B8u)
S#define _EMAC_MACADDRL3_ADDR                    (_EMAC_BASE_ADDR+0x01BCu)
S#define _EMAC_MACADDRL4_ADDR                    (_EMAC_BASE_ADDR+0x01C0u)
S#define _EMAC_MACADDRL5_ADDR                    (_EMAC_BASE_ADDR+0x01C4u)
S#define _EMAC_MACADDRL6_ADDR                    (_EMAC_BASE_ADDR+0x01C8u)
S#define _EMAC_MACADDRL7_ADDR                    (_EMAC_BASE_ADDR+0x01CCu)
S
S#define EMAC_MACADDRL0                          EMAC_REG(MACADDRL0)
S#define EMAC_MACADDRL1                          EMAC_REG(MACADDRL1)
S#define EMAC_MACADDRL2                          EMAC_REG(MACADDRL2)
S#define EMAC_MACADDRL3                          EMAC_REG(MACADDRL3)
S#define EMAC_MACADDRL4                          EMAC_REG(MACADDRL4)
S#define EMAC_MACADDRL5                          EMAC_REG(MACADDRL5)
S#define EMAC_MACADDRL6                          EMAC_REG(MACADDRL6)
S#define EMAC_MACADDRL7                          EMAC_REG(MACADDRL7)
S
S#define _EMAC_MACADDRL_MACADDR8_MASK            0x000000FFu
S#define _EMAC_MACADDRL_MACADDR8_SHIFT           0u
S#define  EMAC_MACADDRL_MACADDR8_DEFAULT		0x00000000u
S#define _EMAC_MACADDRL0_MACADDR8_MASK           0x000000FFu
S#define _EMAC_MACADDRL0_MACADDR8_SHIFT          0u
S#define  EMAC_MACADDRL0_MACADDR8_DEFAULT	0x00000000u
S#define _EMAC_MACADDRL1_MACADDR8_MASK           0x000000FFu
S#define _EMAC_MACADDRL1_MACADDR8_SHIFT          0u
S#define  EMAC_MACADDRL1_MACADDR8_DEFAULT	0x00000000u
S#define _EMAC_MACADDRL2_MACADDR8_MASK           0x000000FFu
S#define _EMAC_MACADDRL2_MACADDR8_SHIFT          0u
S#define  EMAC_MACADDRL2_MACADDR8_DEFAULT	0x00000000u
S#define _EMAC_MACADDRL3_MACADDR8_MASK           0x000000FFu
S#define _EMAC_MACADDRL3_MACADDR8_SHIFT          0u
S#define  EMAC_MACADDRL3_MACADDR8_DEFAULT	0x00000000u
S#define _EMAC_MACADDRL4_MACADDR8_MASK           0x000000FFu
S#define _EMAC_MACADDRL4_MACADDR8_SHIFT          0u
S#define  EMAC_MACADDRL4_MACADDR8_DEFAULT	0x00000000u
S#define _EMAC_MACADDRL5_MACADDR8_MASK           0x000000FFu
S#define _EMAC_MACADDRL5_MACADDR8_SHIFT          0u
S#define  EMAC_MACADDRL5_MACADDR8_DEFAULT	0x00000000u
S#define _EMAC_MACADDRL6_MACADDR8_MASK           0x000000FFu
S#define _EMAC_MACADDRL6_MACADDR8_SHIFT          0u
S#define  EMAC_MACADDRL6_MACADDR8_DEFAULT	0x00000000u
S#define _EMAC_MACADDRL7_MACADDR8_MASK           0x000000FFu
S#define _EMAC_MACADDRL7_MACADDR8_SHIFT          0u
S#define  EMAC_MACADDRL7_MACADDR8_DEFAULT	0x00000000u
S
S
S/******************************************************************************\
S* _____________________
X
S* |                   |
S* |   MACADDRM        |
S* |___________________|
S*
S* MACADDRM          - MAC Address Byte 1 Register (bits 15:8)
S*
S* FIELDS (msb -> lsb)
S*  (rw)  MACADDR8   - 8 bits of MAC Address
S*
S* MACROS SUPPORTED
S*  EMAC_FMK     y
S*  EMAC_FMKS    .
S*  EMAC_FMKCHF  .
S*  EMAC_ADDR    y
S*  EMAC_RGET    y
S*  EMAC_RSET    y
S*  EMAC_FGET    y
S*  EMAC_FSET    y
S*  EMAC_FSETS   .
S*  EMAC_RGETI   .
S*  EMAC_RSETI   .
S*  EMAC_FGETI   .
S*  EMAC_FSETI   .
S*  EMAC_FSETSI  .
S*
S\******************************************************************************/
S#define _EMAC_MACADDRM_ADDR                     (_EMAC_BASE_ADDR+0x01D0u)
S
S#define EMAC_MACADDRM                           EMAC_REG(MACADDRM)
S
S#define _EMAC_MACADDRM_MACADDR8_MASK            0x000000FFu
S#define _EMAC_MACADDRM_MACADDR8_SHIFT           0u
S#define  EMAC_MACADDRM_MACADDR8_DEFAULT		0x00000000u
S
S
S
S/******************************************************************************\
S* _____________________
X
S* |                   |
S* |   MACADDRH        |
S* |___________________|
S*
S* MACADDRH          - MAC Address High Bytes Register (bits 47:16)
S*
S* FIELDS (msb -> lsb)
S*  (rw)  MACADDR32  - 32 bits of MAC Address
S*
S* MACROS SUPPORTED
S*  EMAC_FMK     y
S*  EMAC_FMKS    .
S*  EMAC_FMKCHF  .
S*  EMAC_ADDR    y
S*  EMAC_REG     y
S*  EMAC_RGET    y
S*  EMAC_RSET    y
S*  EMAC_FGET    y
S*  EMAC_FSET    y
S*  EMAC_FSETS   .
S*  EMAC_RGETI   .
S*  EMAC_RSETI   .
S*  EMAC_FGETI   .
S*  EMAC_FSETI   .
S*  EMAC_FSETSI  .
S*
S\******************************************************************************/
S#define _EMAC_MACADDRH_ADDR                     (_EMAC_BASE_ADDR+0x01D4u)
S
S#define EMAC_MACADDRH                           EMAC_REG(MACADDRH)
S
S#define _EMAC_MACADDRH_MACADDR32_MASK           0xFFFFFFFFu
S#define _EMAC_MACADDRH_MACADDR32_SHIFT          0u
S#define  EMAC_MACADDRH_MACADDR32_DEFAULT	0x00000000u
S
S
S
S/******************************************************************************\
S* _____________________
X
S* |                   |
S* |   MACHASH1        |
S* |   MACHASH2        |
S* |___________________|
S*
S* MACHASH1          - MAC Address Hash 1 Register
S* MACHASH2          - MAC Address Hash 2 Register
S*
S* FIELDS (msb -> lsb)
S*  (rw)  HASHBITS   - 32 Hash Bits
S*
S* MACROS SUPPORTED
S*  EMAC_FMK     y
S*  EMAC_FMKS    .
S*  EMAC_FMKCHF  .
S*  EMAC_ADDR    y
S*  EMAC_REG     y
S*  EMAC_RGET    y
S*  EMAC_RSET    y
S*  EMAC_FGET    y
S*  EMAC_FSET    y
S*  EMAC_FSETS   .
S*  EMAC_RGETI   .
S*  EMAC_RSETI   .
S*  EMAC_FGETI   .
S*  EMAC_FSETI   .
S*  EMAC_FSETSI  .
S*
S\******************************************************************************/
S#define _EMAC_MACHASH1_ADDR                     (_EMAC_BASE_ADDR+0x01D8u)
S#define _EMAC_MACHASH2_ADDR                     (_EMAC_BASE_ADDR+0x01DCu)
S
S#define EMAC_MACHASH1                           EMAC_REG(MACHASH1)
S#define EMAC_MACHASH2                           EMAC_REG(MACHASH2)
S
S#define _EMAC_MACHASH1_HASHBITS_MASK            0xFFFFFFFFu
S#define  EMAC_MACHASH1_HASHBITS_DEFAULT		0x00000000u
S#define _EMAC_MACHASH1_HASHBITS_SHIFT           0u
S#define _EMAC_MACHASH2_HASHBITS_MASK            0xFFFFFFFFu
S#define _EMAC_MACHASH2_HASHBITS_SHIFT           0u
S#define  EMAC_MACHASH2_HASHBITS_DEFAULT		0x00000000u
S
S
S
S
S/******************************************************************************\
S* _____________________
X
S* |                   |
S* |   BOFFTEST        |
S* |___________________|
S*
S* BOFFTEST          - Backoff Test Register
S*
S* FIELDS (msb -> lsb)
S*  (rw)  BOFFHALT   - Halt Random Number Generator
S*  (rw)  ATTEMPT    - Initial Collision Attempt Count
S*  (rw)  BOFFRNG    - Backoff Random Number Generator
S*  (rw)  RETRYCOUNT - Retry Count
S*  (rw)  BOFFCOUNT  - Backoff Current Count
S*
S* MACROS SUPPORTED
S*  EMAC_FMK     y
S*  EMAC_FMKS    .
S*  EMAC_FMKCHF  .
S*  EMAC_ADDR    y
S*  EMAC_REG     y
S*  EMAC_RGET    y
S*  EMAC_RSET    y
S*  EMAC_FGET    y
S*  EMAC_FSET    y
S*  EMAC_FSETS   .
S*  EMAC_RGETI   .
S*  EMAC_RSETI   .
S*  EMAC_FGETI   .
S*  EMAC_FSETI   .
S*  EMAC_FSETSI  .
S*
S\******************************************************************************/
S#define _EMAC_BOFFTEST_ADDR                     (_EMAC_BASE_ADDR+0x01E0u)
S
S#define EMAC_BOFFTEST                           EMAC_REG(BOFFTEST)
S
S#define _EMAC_BOFFTEST_BOFFHALT_MASK            0x8000000u
S#define _EMAC_BOFFTEST_BOFFHALT_SHIFT           31u
S#define	 EMAC_BOFFTEST_BOFFHALT_DEFAULT		0x00000000u
S
S#define _EMAC_BOFFTEST_ATTEMPT_MASK             0x78000000u
S#define _EMAC_BOFFTEST_ATTEMPT_SHIFT            27u
S#define  EMAC_BOFFTEST_ATTEMPT_DEFAULT		0x00000000u
S
S#define _EMAC_BOFFTEST_BOFFRNG_MASK             0x07FF0000u
S#define _EMAC_BOFFTEST_BOFFRNG_SHIFT            16u
S#define  EMAC_BOFFTEST_BOFFRNG_DEFAULT		0x00000000u
S
S#define _EMAC_BOFFTEST_RETRYCOUNT_MASK          0x0000F000u
S#define _EMAC_BOFFTEST_RETRYCOUNT_SHIFT         12u
S#define  EMAC_BOFFTEST_RETRYCOUNT_DEFAULT	0x00000000u
S
S#define _EMAC_BOFFTEST_BOFFCOUNT_MASK           0x000003FFu
S#define _EMAC_BOFFTEST_BOFFCOUNT_SHIFT          0u
S#define  EMAC_BOFFTEST_BOFFCOUNT_DEFAULT	0x00000000u
S
S
S/******************************************************************************\
S* _____________________
X
S* |                   |
S* |   TPACETEST       |
S* |___________________|
S*
S* TPACETEST         - Transmit Pacing Test Register
S*
S* FIELDS (msb -> lsb)
S*  (rw)  PACEVAL    - Pace Register Current Value
S*  (rw)  PACEINIT   - Pace Register Initial Value
S*
S* MACROS SUPPORTED
S*  EMAC_FMK     y
S*  EMAC_FMKS    .
S*  EMAC_FMKCHF  .
S*  EMAC_ADDR    y
S*  EMAC_REG     y
S*  EMAC_RGET    y
S*  EMAC_RSET    y
S*  EMAC_FGET    y
S*  EMAC_FSET    y
S*  EMAC_FSETS   .
S*  EMAC_RGETI   .
S*  EMAC_RSETI   .
S*  EMAC_FGETI   .
S*  EMAC_FSETI   .
S*  EMAC_FSETSI  .
S*
S\******************************************************************************/
S#define _EMAC_TPACETEST_ADDR                      (_EMAC_BASE_ADDR+0x01E4u)
S
S#define EMAC_TPACETEST                            EMAC_REG(TPACETEST)
S
S#define _EMAC_TPACETEST_PACEVAL_MASK              0x0000001Fu
S#define _EMAC_TPACETEST_PACEVAL_SHIFT             0u
S#define  EMAC_TPACETEST_PACEVAL_DEFAULT		  0x00000000u 
S
S/******************************************************************************\
S* _____________________
X
S* |                   |
S* |    RXPAUSE        |
S* |    TXPAUSE        |
S* |___________________|
S*
S* RXPAUSE           - Receive Pause Timer Register
S* TXPAUSE           - Transmit Pause Timer Register
S*
S* FIELDS (msb -> lsb)
S*  (rw)  PAUSETIMER - Pause Timer
S*
S* MACROS SUPPORTED
S*  EMAC_FMK     y
S*  EMAC_FMKS    .
S*  EMAC_FMKCHF  .
S*  EMAC_ADDR    y
S*  EMAC_REG     y
S*  EMAC_RGET    y
S*  EMAC_RSET    y
S*  EMAC_FGET    y
S*  EMAC_FSET    y
S*  EMAC_FSETS   .
S*  EMAC_RGETI   .
S*  EMAC_RSETI   .
S*  EMAC_FGETI   .
S*  EMAC_FSETI   .
S*  EMAC_FSETSI  .
S*
S\******************************************************************************/
S#define _EMAC_RXPAUSE_ADDR                      (_EMAC_BASE_ADDR+0x01E8u)
S#define _EMAC_TXPAUSE_ADDR                      (_EMAC_BASE_ADDR+0x01ECu)
S
S#define EMAC_RXPAUSE                            EMAC_REG(RXPAUSE)
S#define EMAC_TXPAUSE                            EMAC_REG(TXPAUSE)
S
S#define _EMAC_RXPAUSE_PAUSETIMER_MASK           0x0000FFFFu
S#define _EMAC_RXPAUSE_PAUSETIMER_SHIFT          0u
S#define  EMAC_RXPAUSE_PAUSETIMER_DEFAULT	0x00000000u
S
S#define _EMAC_TXPAUSE_PAUSETIMER_MASK           0x0000FFFFu
S#define _EMAC_TXPAUSE_PAUSETIMER_SHIFT          0u
S#define  EMAC_TXPAUSE_PAUSETIMER_DEFAULT	0x00000000u
S
S/******************************************************************************\
S* _____________________
X
S* |                   |
S* |   TXHDP           |
S* |   TXnHDP          |
S* |___________________|
S*
S* TXHDP             - TX DMA Head Descriptor Pointer Register for RSETI/RGETI
S* TX0HDP            - TX Channel 0 DMA Head Descriptor Pointer Register
S* TX1HDP            - TX Channel 1 DMA Head Descriptor Pointer Register
S* TX2HDP            - TX Channel 2 DMA Head Descriptor Pointer Register
S* TX3HDP            - TX Channel 3 DMA Head Descriptor Pointer Register
S* TX4HDP            - TX Channel 4 DMA Head Descriptor Pointer Register
S* TX5HDP            - TX Channel 5 DMA Head Descriptor Pointer Register
S* TX6HDP            - TX Channel 6 DMA Head Descriptor Pointer Register
S* TX7HDP            - TX Channel 7 DMA Head Descriptor Pointer Register
S*
S* FIELDS (msb -> lsb)
S*  (rw) DESCPTR     - Descriptor Pointer
S*
S* MACROS SUPPORTED
S*  EMAC_FMK     y
S*  EMAC_FMKS    .
S*  EMAC_FMKCHF  .
S*  EMAC_ADDR    y
S*  EMAC_REG     y
S*  EMAC_RGET    y
S*  EMAC_RSET    y
S*  EMAC_FGET    y
S*  EMAC_FSET    y
S*  EMAC_FSETS   .
S*  EMAC_RGETI   y
S*  EMAC_RSETI   y
S*  EMAC_FGETI   y
S*  EMAC_FSETI   y
S*  EMAC_FSETSI  .
S*
S\******************************************************************************/
S#define _EMAC_TXHDP_BASEADDR                (_EMAC_BASE_ADDR+0x0600u)
S#define _EMAC_TX0HDP_ADDR                   (_EMAC_BASE_ADDR+0x0600u)
S#define _EMAC_TX1HDP_ADDR                   (_EMAC_BASE_ADDR+0x0604u)
S#define _EMAC_TX2HDP_ADDR                   (_EMAC_BASE_ADDR+0x0608u)
S#define _EMAC_TX3HDP_ADDR                   (_EMAC_BASE_ADDR+0x060Cu)
S#define _EMAC_TX4HDP_ADDR                   (_EMAC_BASE_ADDR+0x0610u)
S#define _EMAC_TX5HDP_ADDR                   (_EMAC_BASE_ADDR+0x0614u)
S#define _EMAC_TX6HDP_ADDR                   (_EMAC_BASE_ADDR+0x0618u)
S#define _EMAC_TX7HDP_ADDR                   (_EMAC_BASE_ADDR+0x061Cu)
S
S#define EMAC_TX0HDP                         EMAC_REG(TX0HDP)
S#define EMAC_TX1HDP                         EMAC_REG(TX1HDP)
S#define EMAC_TX2HDP                         EMAC_REG(TX2HDP)
S#define EMAC_TX3HDP                         EMAC_REG(TX3HDP)
S#define EMAC_TX4HDP                         EMAC_REG(TX4HDP)
S#define EMAC_TX5HDP                         EMAC_REG(TX5HDP)
S#define EMAC_TX6HDP                         EMAC_REG(TX6HDP)
S#define EMAC_TX7HDP                         EMAC_REG(TX7HDP)
S
S#define _EMAC_TXHDP_DESCPTR_MASK            0xFFFFFFFFu
S#define _EMAC_TXHDP_DESCPTR_SHIFT           0u
S#define  EMAC_TXHDP_DESCPTR_DEFAULT         0x00000000u  
S#define _EMAC_TX0HDP_DESCPTR_MASK           0xFFFFFFFFu
S#define _EMAC_TX0HDP_DESCPTR_SHIFT          0u
S#define  EMAC_TX0HDP_DESCPTR_DEFAULT	    0x00000000u
S#define _EMAC_TX1HDP_DESCPTR_MASK           0xFFFFFFFFu
S#define _EMAC_TX1HDP_DESCPTR_SHIFT          0u
S#define  EMAC_TX1HDP_DESCPTR_DEFAULT	    0x00000000u
S#define _EMAC_TX2HDP_DESCPTR_MASK           0xFFFFFFFFu
S#define _EMAC_TX2HDP_DESCPTR_SHIFT          0u
S#define  EMAC_TX2HDP_DESCPTR_DEFAULT	    0x00000000u
S#define _EMAC_TX3HDP_DESCPTR_MASK           0xFFFFFFFFu
S#define _EMAC_TX3HDP_DESCPTR_SHIFT          0u
S#define  EMAC_TX3HDP_DESCPTR_DEFAULT	    0x00000000u
S#define _EMAC_TX4HDP_DESCPTR_MASK           0xFFFFFFFFu
S#define _EMAC_TX4HDP_DESCPTR_SHIFT          0u
S#define  EMAC_TX4HDP_DESCPTR_DEFAULT	    0x00000000u
S#define _EMAC_TX5HDP_DESCPTR_MASK           0xFFFFFFFFu
S#define _EMAC_TX5HDP_DESCPTR_SHIFT          0u
S#define  EMAC_TX5HDP_DESCPTR_DEFAULT	    0x00000000u
S#define _EMAC_TX6HDP_DESCPTR_MASK           0xFFFFFFFFu
S#define _EMAC_TX6HDP_DESCPTR_SHIFT          0u
S#define  EMAC_TX6HDP_DESCPTR_DEFAULT	    0x00000000u
S#define _EMAC_TX7HDP_DESCPTR_MASK           0xFFFFFFFFu
S#define _EMAC_TX7HDP_DESCPTR_SHIFT          0u
S#define  EMAC_TX7HDP_DESCPTR_DEFAULT	    0x00000000u
S
S
S/******************************************************************************\
S* _____________________
X
S* |                   |
S* |   RXHDP           |
S* |   RXnHDP          |
S* |___________________|
S*
S* RXHDP             - RX DMA Head Descriptor Pointer Register for RSETI/RGETI
S* RX0HDP            - RX Channel 0 DMA Head Descriptor Pointer Register
S* RX1HDP            - RX Channel 1 DMA Head Descriptor Pointer Register
S* RX2HDP            - RX Channel 2 DMA Head Descriptor Pointer Register
S* RX3HDP            - RX Channel 3 DMA Head Descriptor Pointer Register
S* RX4HDP            - RX Channel 4 DMA Head Descriptor Pointer Register
S* RX5HDP            - RX Channel 5 DMA Head Descriptor Pointer Register
S* RX6HDP            - RX Channel 6 DMA Head Descriptor Pointer Register
S* RX7HDP            - RX Channel 7 DMA Head Descriptor Pointer Register
S*
S* FIELDS (msb -> lsb)
S*  (rw) DESCPTR     - Descriptor Pointer
S*
S* MACROS SUPPORTED
S*  EMAC_FMK     y
S*  EMAC_FMKS    .
S*  EMAC_FMKCHF  .
S*  EMAC_ADDR    y
S*  EMAC_REG     y
S*  EMAC_RGET    y
S*  EMAC_RSET    y
S*  EMAC_FGET    y
S*  EMAC_FSET    y
S*  EMAC_FSETS   .
S*  EMAC_RGETI   y
S*  EMAC_RSETI   y
S*  EMAC_FGETI   y
S*  EMAC_FSETI   y
S*  EMAC_FSETSI  .
S*
S\******************************************************************************/
S#define _EMAC_RXHDP_BASEADDR                (_EMAC_BASE_ADDR+0x0620u)
S#define _EMAC_RX0HDP_ADDR                   (_EMAC_BASE_ADDR+0x0620u)
S#define _EMAC_RX1HDP_ADDR                   (_EMAC_BASE_ADDR+0x0624u)
S#define _EMAC_RX2HDP_ADDR                   (_EMAC_BASE_ADDR+0x0628u)
S#define _EMAC_RX3HDP_ADDR                   (_EMAC_BASE_ADDR+0x062Cu)
S#define _EMAC_RX4HDP_ADDR                   (_EMAC_BASE_ADDR+0x0630u)
S#define _EMAC_RX5HDP_ADDR                   (_EMAC_BASE_ADDR+0x0634u)
S#define _EMAC_RX6HDP_ADDR                   (_EMAC_BASE_ADDR+0x0638u)
S#define _EMAC_RX7HDP_ADDR                   (_EMAC_BASE_ADDR+0x063Cu)
S
S#define EMAC_RX0HDP                         EMAC_REG(RX0HDP)
S#define EMAC_RX1HDP                         EMAC_REG(RX1HDP)
S#define EMAC_RX2HDP                         EMAC_REG(RX2HDP)
S#define EMAC_RX3HDP                         EMAC_REG(RX3HDP)
S#define EMAC_RX4HDP                         EMAC_REG(RX4HDP)
S#define EMAC_RX5HDP                         EMAC_REG(RX5HDP)
S#define EMAC_RX6HDP                         EMAC_REG(RX6HDP)
S#define EMAC_RX7HDP                         EMAC_REG(RX7HDP)
S
S#define _EMAC_RXHDP_DESCPTR_MASK            0xFFFFFFFFu
S#define _EMAC_RXHDP_DESCPTR_SHIFT           0u
S#define  EMAC_RXHDP_DESCPTR_DEFAULT	    0x00000000u
S#define _EMAC_RX0HDP_DESCPTR_MASK           0xFFFFFFFFu
S#define _EMAC_RX0HDP_DESCPTR_SHIFT          0u
S#define  EMAC_RX0HDP_DESCPTR_DEFAULT	    0x00000000u
S#define _EMAC_RX1HDP_DESCPTR_MASK           0xFFFFFFFFu
S#define _EMAC_RX1HDP_DESCPTR_SHIFT          0u
S#define  EMAC_RX1HDP_DESCPTR_DEFAULT	    0x00000000u
S#define _EMAC_RX2HDP_DESCPTR_MASK           0xFFFFFFFFu
S#define _EMAC_RX2HDP_DESCPTR_SHIFT          0u
S#define  EMAC_RX2HDP_DESCPTR_DEFAULT	    0x00000000u
S#define _EMAC_RX3HDP_DESCPTR_MASK           0xFFFFFFFFu
S#define _EMAC_RX3HDP_DESCPTR_SHIFT          0u
S#define  EMAC_Rx3HDP_DESCPTR_DEFAULT	    0x00000000u
S#define _EMAC_RX4HDP_DESCPTR_MASK           0xFFFFFFFFu
S#define _EMAC_RX4HDP_DESCPTR_SHIFT          0u
S#define  EMAC_RX4HDP_DESCPTR_DEFAULT        0x00000000u
S#define _EMAC_RX5HDP_DESCPTR_MASK           0xFFFFFFFFu
S#define _EMAC_RX5HDP_DESCPTR_SHIFT          0u
S#define  EMAC_RX5HDP_DESCPTR_DEFAULT	    0x00000000u
S#define _EMAC_RX6HDP_DESCPTR_MASK           0xFFFFFFFFu
S#define _EMAC_RX6HDP_DESCPTR_SHIFT          0u
S#define  EMAC_RX6HDP_DESCPTR_DEFAULT	    0x00000000u
S#define _EMAC_RX7HDP_DESCPTR_MASK           0xFFFFFFFFu
S#define _EMAC_RX7HDP_DESCPTR_SHIFT          0u
S#define  EMAC_RX7HDP_DESCPTR_DEFAULT	    0x00000000u
S/***************************************************************************************************************************\
S*  ___________________
X
S* |   TXINTACK        |
S* |   TXnINTACK       |
S* |___________________|
S*
S* TXINTACK          - TX Interrupt Ack Register for RSETI/RGETI
S* TX0INTACK         - TX Channel 0 Interrupt Acknowledge Register
S* TX1INTACK         - TX Channel 1 Interrupt Acknowledge Register
S* TX2INTACK         - TX Channel 2 Interrupt Acknowledge Register
S* TX3INTACK         - TX Channel 3 Interrupt Acknowledge Register
S* TX4INTACK         - TX Channel 4 Interrupt Acknowledge Register
S* TX5INTACK         - TX Channel 5 Interrupt Acknowledge Register
S* TX6INTACK         - TX Channel 6 Interrupt Acknowledge Register
S* TX7INTACK         - TX Channel 7 Interrupt Acknowledge Register
S*
S* FIELDS (msb -> lsb)
S*  (rw) DESCPTR     - Descriptor Pointer
S*
S* MACROS SUPPORTED
S*  EMAC_FMK     y
S*  EMAC_FMKS    .
S*  EMAC_FMKCHF  .
S*  EMAC_ADDR    y
S*  EMAC_REG     y
S*  EMAC_RGET    y
S*  EMAC_RSET    y
S*  EMAC_FGET    y
S*  EMAC_FSET    y
S*  EMAC_FSETS   .
S*  EMAC_RGETI   y
S*  EMAC_RSETI   y
S*  EMAC_FGETI   y
S*  EMAC_FSETI   y
S*  EMAC_FSETSI  .
S*
S\******************************************************************************/
S#define _EMAC_TXINTACK_BASEADDR             (_EMAC_BASE_ADDR+0x0640u)
S#define _EMAC_TX0INTACK_ADDR                (_EMAC_BASE_ADDR+0x0640u)
S#define _EMAC_TX1INTACK_ADDR                (_EMAC_BASE_ADDR+0x0644u)
S#define _EMAC_TX2INTACK_ADDR                (_EMAC_BASE_ADDR+0x0648u)
S#define _EMAC_TX3INTACK_ADDR                (_EMAC_BASE_ADDR+0x064Cu)
S#define _EMAC_TX4INTACK_ADDR                (_EMAC_BASE_ADDR+0x0650u)
S#define _EMAC_TX5INTACK_ADDR                (_EMAC_BASE_ADDR+0x0654u)
S#define _EMAC_TX6INTACK_ADDR                (_EMAC_BASE_ADDR+0x0658u)
S#define _EMAC_TX7INTACK_ADDR                (_EMAC_BASE_ADDR+0x065Cu)
S
S#define EMAC_TX0INTACK                      EMAC_REG(TX0INTACK)
S#define EMAC_TX1INTACK                      EMAC_REG(TX1INTACK)
S#define EMAC_TX2INTACK                      EMAC_REG(TX2INTACK)
S#define EMAC_TX3INTACK                      EMAC_REG(TX3INTACK)
S#define EMAC_TX4INTACK                      EMAC_REG(TX4INTACK)
S#define EMAC_TX5INTACK                      EMAC_REG(TX5INTACK)
S#define EMAC_TX6INTACK                      EMAC_REG(TX6INTACK)
S#define EMAC_TX7INTACK                      EMAC_REG(TX7INTACK)
S
S#define _EMAC_TXINTACK_DESCPTR_MASK         0xFFFFFFFFu
S#define _EMAC_TXINTACK_DESCPTR_SHIFT        0u
S#define  EMAC_TXINTACK_DESCPTR_DEFAULT	    0x00000000u
S#define _EMAC_TX0INTACK_DESCPTR_MASK        0xFFFFFFFFu
S#define _EMAC_TX0INTACK_DESCPTR_SHIFT       0u
S#define  EMAC_TX0INTACK_DESCPTR_DEFAULT	    0x00000000u 	 
S#define _EMAC_TX1INTACK_DESCPTR_MASK        0xFFFFFFFFu
S#define _EMAC_TX1INTACK_DESCPTR_SHIFT       0u
S#define  EMAC_TX1INTACK_DESCPTR_DEFAULT	    0x00000000u
S#define _EMAC_TX2INTACK_DESCPTR_MASK        0xFFFFFFFFu
S#define _EMAC_TX2INTACK_DESCPTR_SHIFT       0u
S#define  EMAC_TX2INTACK_DESCPTR_DEFAULT	    0x00000000u
S#define _EMAC_TX3INTACK_DESCPTR_MASK        0xFFFFFFFFu
S#define _EMAC_TX3INTACK_DESCPTR_SHIFT       0u
S#define  EMAC_TX3INTACK_DESCPTR_DEFAULT	    0x00000000u
S#define _EMAC_TX4INTACK_DESCPTR_MASK        0xFFFFFFFFu
S#define _EMAC_TX4INTACK_DESCPTR_SHIFT       0u
S#define  EMAC_TX4INTACK_DESCPTR_DEFAULT     0x00000000u
S#define _EMAC_TX5INTACK_DESCPTR_MASK        0xFFFFFFFFu
S#define _EMAC_TX5INTACK_DESCPTR_SHIFT       0u
S#define  EMAC_TX5INTACK_DESCPTR_DEFAULT	    0x00000000u
S#define _EMAC_TX6INTACK_DESCPTR_MASK        0xFFFFFFFFu
S#define _EMAC_TX6INTACK_DESCPTR_SHIFT       0u
S#define  EMAC_TX6INTACK_DESCPTR_DEFAULT	    0x00000000u
S#define _EMAC_TX7INTACK_DESCPTR_MASK        0xFFFFFFFFu
S#define _EMAC_TX7INTACK_DESCPTR_SHIFT       0u
S#define  EMAC_TX7INTACK_DESCPTR_DEFAULT	    0x00000000u
S
S/******************************************************************************\
S* _____________________
X
S* |                   |
S* |   RXINTACK        |
S* |   RXnINTACK       |
S* |___________________|
S*
S* RXINTACK          - RX Channel 0 Interrupt Ack Register for RSETI/RGETI
S* RX0INTACK         - RX Channel 0 Interrupt Acknowledge Register
S* RX1INTACK         - RX Channel 1 Interrupt Acknowledge Register
S* RX2INTACK         - RX Channel 2 Interrupt Acknowledge Register
S* RX3INTACK         - RX Channel 3 Interrupt Acknowledge Register
S* RX4INTACK         - RX Channel 4 Interrupt Acknowledge Register
S* RX5INTACK         - RX Channel 5 Interrupt Acknowledge Register
S* RX6INTACK         - RX Channel 6 Interrupt Acknowledge Register
S* RX7INTACK         - RX Channel 7 Interrupt Acknowledge Register
S*
S* FIELDS (msb -> lsb)
S*  (rw) DESCPTR     - Descriptor Pointer
S*
S* MACROS SUPPORTED
S*  EMAC_FMK     y
S*  EMAC_FMKS    .
S*  EMAC_FMKCHF  .
S*  EMAC_ADDR    y
S*  EMAC_REG     y
S*  EMAC_RGET    y
S*  EMAC_RSET    y
S*  EMAC_FGET    y
S*  EMAC_FSET    y
S*  EMAC_FSETS   .
S*  EMAC_RGETI   y
S*  EMAC_RSETI   y
S*  EMAC_FGETI   y
S*  EMAC_FSETI   y
S*  EMAC_FSETSI  .
S*
S\******************************************************************************/
S#define _EMAC_RXINTACK_BASEADDR             (_EMAC_BASE_ADDR+0x0660u)
S#define _EMAC_RX0INTACK_ADDR                (_EMAC_BASE_ADDR+0x0660u)
S#define _EMAC_RX1INTACK_ADDR                (_EMAC_BASE_ADDR+0x0664u)
S#define _EMAC_RX2INTACK_ADDR                (_EMAC_BASE_ADDR+0x0668u)
S#define _EMAC_RX3INTACK_ADDR                (_EMAC_BASE_ADDR+0x066Cu)
S#define _EMAC_RX4INTACK_ADDR                (_EMAC_BASE_ADDR+0x0670u)
S#define _EMAC_RX5INTACK_ADDR                (_EMAC_BASE_ADDR+0x0674u)
S#define _EMAC_RX6INTACK_ADDR                (_EMAC_BASE_ADDR+0x0678u)
S#define _EMAC_RX7INTACK_ADDR                (_EMAC_BASE_ADDR+0x067Cu)
S
S#define EMAC_RX0INTACK                      EMAC_REG(RX0INTACK)
S#define EMAC_RX1INTACK                      EMAC_REG(RX1INTACK)
S#define EMAC_RX2INTACK                      EMAC_REG(RX2INTACK)
S#define EMAC_RX3INTACK                      EMAC_REG(RX3INTACK)
S#define EMAC_RX4INTACK                      EMAC_REG(RX4INTACK)
S#define EMAC_RX5INTACK                      EMAC_REG(RX5INTACK)
S#define EMAC_RX6INTACK                      EMAC_REG(RX6INTACK)
S#define EMAC_RX7INTACK                      EMAC_REG(RX7INTACK)
S
S#define _EMAC_RXINTACK_DESCPTR_MASK         0xFFFFFFFFu
S#define _EMAC_RXINTACK_DESCPTR_SHIFT        0u
S#define  EMAC_RXINTACK_DESCPTR_DEFAULT      0x00000000u
S#define _EMAC_RX0INTACK_DESCPTR_MASK        0xFFFFFFFFu
S#define _EMAC_RX0INTACK_DESCPTR_SHIFT       0u
S#define  EMAC_RX0INTACK_DESCPTR_DEFAULT     0x00000000u
S#define _EMAC_RX1INTACK_DESCPTR_MASK        0xFFFFFFFFu
S#define _EMAC_RX1INTACK_DESCPTR_SHIFT       0u
S#define  EMAC_RX1INTACK_DESCPTR_DEFAULT	    0x00000000u
S#define _EMAC_RX2INTACK_DESCPTR_MASK        0xFFFFFFFFu
S#define _EMAC_RX2INTACK_DESCPTR_SHIFT       0u
S#define  EMAC_RX2INTACK_DESCPTR_DEFAULT     0x00000000u
S#define _EMAC_RX3INTACK_DESCPTR_MASK        0xFFFFFFFFu
S#define _EMAC_RX3INTACK_DESCPTR_SHIFT       0u
S#define  EMAC_RX3INTACK_DESCPTR_DEFAULT	    0x00000000u
S#define _EMAC_RX4INTACK_DESCPTR_MASK        0xFFFFFFFFu
S#define _EMAC_RX4INTACK_DESCPTR_SHIFT       0u
S#define  EMAC_RX4INTACK_DESCPTR_DEFAULT     0x00000000u
S#define _EMAC_RX5INTACK_DESCPTR_MASK        0xFFFFFFFFu
S#define _EMAC_RX5INTACK_DESCPTR_SHIFT       0u
S#define  EMAC_RX5INTACK_DESCPTR_DEFAULT     0x00000000u
S#define _EMAC_RX6INTACK_DESCPTR_MASK        0xFFFFFFFFu
S#define _EMAC_RX6INTACK_DESCPTR_SHIFT       0u
S#define  EMAC_RX6INTACK_DESCPTR_DEFAULT     0x00000000u
S#define _EMAC_RX7INTACK_DESCPTR_MASK        0xFFFFFFFFu
S#define _EMAC_RX7INTACK_DESCPTR_SHIFT       0u
S#define  EMAC_RX7INTACK_DESCPTR_DEFAULT     0x00000000u
S
S
S/******************************************************************************\
S* _____________________
X
S* |                   |
S* | RXGOODFRAMES      |
S* | RXBCASTFRAMES     |
S* | RXMCASTFRAMES     |
S* | RXPAUSEFRAMES     |
S* | RXCRCERRORS       |
S* | RXALIGNCODEERRORS |
S* | RXOVERSIZED       |
S* | RXJABBER          |
S* | RXUNDERSIZED      |
S* | RXFRAGMENTS       |
S* | RXFILTERED        |
S* | RXQOSFILTERED     |
S* | RXOCTETS          |
S* | TXGOODFRAMES      |
S* | TXBCASTFRAMES     |
S* | TXMCASTFRAMES     |
S* | TXPAUSEFRAMES     |
S* | TXDEFERRED        |
S* | TXCOLLISION       |
S* | TXSINGLECOLL      |
S* | TXMULTICOLL       |
S* | TXEXCESSIVECOLL   |
S* | TXLATECOLL        |
S* | TXUNDERRUN        |
S* | TXCARRIERSLOSS    |
S* | TXOCTETS          |
S* | FRAME64           |
S* | FRAME65T127       |
S* | FRAME128T255      |
S* | FRAME256T511      |
S* | FRAME512T1023     |
S* | FRAME1024TUP      |
S* | NETOCTETS         |
S* | RXSOFOVERRUNS     |
S* | RXMOFOVERRUNS     |
S* | RXDMAOVERRUNS     |
S* |___________________|
S*
S* RXGOODFRAMES      - Number of Good Frames Received
S* RXBCASTFRAMES     - Number of Good Broadcast Frames Received
S* RXMCASTFRAMES     - Number of Good Multicast Frames Received
S* RXPAUSEFRAMES     - Number of PauseRX Frames Received
S* RXCRCERRORS       - Number of Frames Received with CRC Errors
S* RXALIGNCODEERRORS - Number of Frames Received with Alignment/Code Errors
S* RXOVERSIZED       - Number of Oversized Frames Received
S* RXJABBER          - Number of Jabber Frames Received
S* RXUNDERSIZED      - Number of Undersized Frames Received
S* RXFRAGMENTS       - Number of RX Frame Fragments Received
S* RXFILTERED        - Number of RX Frames Filtered Based on Address
S* RXQOSFILTERED     - Number of RX Frames Filtered Based on QoS Filtering
S* RXOCTETS          - Total Number of Received Bytes in Good Frames
S* TXGOODFRAMES      - Number of Good Frames Sent
S* TXBCASTFRAMES     - Number of Good Broadcast Frames Sent
S* TXMCASTFRAMES     - Number of Good Multicast Frames Sent
S* TXPAUSEFRAMES     - Number of PauseTX Frames Sent
S* TXDEFERRED        - Number of Frames Where Transmission was Deferred
S* TXCOLLISION       - Total Number of Frames Sent That Experienced a Collision
S* TXSINGLECOLL      - Number of Frames Sent with Exactly One Collision
S* TXMULTICOLL       - Number of Frames Sent with Multiple Colisions
S* TXEXCESSIVECOLL   - Number of TX Frames Lost Due to Excessive Collisions
S* TXLATECOLL        - Number of TX Frames Lost Due to a Late Collision
S* TXUNDERRUN        - Number of TX Frames Lost with Transmit Underrun Error
S* TXCARRIERSLOSS    - Numebr of TX Frames Lost Due to Carrier Sense Loss
S* TXOCTETS          - Total Nu,ber of Transmitted Bytes in Good Frames
S* FRAME64           - Total TX & RX Frames with Octet Size of 64
S* FRAME65T127       - Total TX & RX Frames with Octet Size of 65 to 127
S* FRAME128T255      - Total TX & RX Frames with Octet Size of 128 to 255
S* FRAME256T511      - Total TX & RX Frames with Octet Size of 256 to 511
S* FRAME512T1023     - Total TX & RX Frames with Octet Size of 512 to 1023
S* FRAME1024TUP      - Total TX & RX Frames with Octet Size of 1024 or above
S* NETOCTETS         - Sum of all Octets Sent or Received on the Network
S* RXSOFOVERRUNS     - Total RX Start of Frame Overruns (FIFO or DMA)
S* RXMOFOVERRUNS     - Total RX Middle of Frame Overruns (FIFO or DMA)
S* RXDMAOVERRUNS     - Total RX DMA Overruns
S*
S* FIELDS (msb -> lsb)
S*  (rw) COUNT       - 32 bit count value
S*
S* MACROS SUPPORTED
S*  EMAC_FMK     y
S*  EMAC_FMKS    .
S*  EMAC_FMKCHF  .
S*  EMAC_ADDR    y
S*  EMAC_REG     y
S*  EMAC_RGET    y
S*  EMAC_RSET    y
S*  EMAC_FGET    y
S*  EMAC_FSET    y
S*  EMAC_FSETS   .
S*  EMAC_RGETI   .
S*  EMAC_RSETI   .
S*  EMAC_FGETI   .
S*  EMAC_FSETI   .
S*  EMAC_FSETSI  .
S*
S\******************************************************************************/
S#define _EMAC_RXGOODFRAMES_ADDR             (_EMAC_BASE_ADDR+0x0200u)
S#define _EMAC_RXBCASTFRAMES_ADDR            (_EMAC_BASE_ADDR+0x0204u)
S#define _EMAC_RXMCASTFRAMES_ADDR            (_EMAC_BASE_ADDR+0x0208u)
S#define _EMAC_RXPAUSEFRAMES_ADDR            (_EMAC_BASE_ADDR+0x020Cu)
S#define _EMAC_RXCRCERRORS_ADDR              (_EMAC_BASE_ADDR+0x0210u)
S#define _EMAC_RXALIGNCODEERRORS_ADDR        (_EMAC_BASE_ADDR+0x0214u)
S#define _EMAC_RXOVERSIZED_ADDR              (_EMAC_BASE_ADDR+0x0218u)
S#define _EMAC_RXJABBER_ADDR                 (_EMAC_BASE_ADDR+0x021Cu)
S#define _EMAC_RXUNDERSIZED_ADDR             (_EMAC_BASE_ADDR+0x0220u)
S#define _EMAC_RXFRAGMENTS_ADDR              (_EMAC_BASE_ADDR+0x0224u)
S#define _EMAC_RXFILTERED_ADDR               (_EMAC_BASE_ADDR+0x0228u)
S#define _EMAC_RXQOSFILTERED_ADDR            (_EMAC_BASE_ADDR+0x022Cu)
S#define _EMAC_RXOCTETS_ADDR                 (_EMAC_BASE_ADDR+0x0230u)
S#define _EMAC_TXGOODFRAMES_ADDR             (_EMAC_BASE_ADDR+0x0234u)
S#define _EMAC_TXBCASTFRAMES_ADDR            (_EMAC_BASE_ADDR+0x0238u)
S#define _EMAC_TXMCASTFRAMES_ADDR            (_EMAC_BASE_ADDR+0x023Cu)
S#define _EMAC_TXPAUSEFRAMES_ADDR            (_EMAC_BASE_ADDR+0x0240u)
S#define _EMAC_TXDEFERRED_ADDR               (_EMAC_BASE_ADDR+0x0244u)
S#define _EMAC_TXCOLLISION_ADDR              (_EMAC_BASE_ADDR+0x0248u)
S#define _EMAC_TXSINGLECOLL_ADDR             (_EMAC_BASE_ADDR+0x024Cu)
S#define _EMAC_TXMULTICOLL_ADDR              (_EMAC_BASE_ADDR+0x0250u)
S#define _EMAC_TXEXCESSIVECOLL_ADDR          (_EMAC_BASE_ADDR+0x0254u)
S#define _EMAC_TXLATECOLL_ADDR               (_EMAC_BASE_ADDR+0x0258u)
S#define _EMAC_TXUNDERRUN_ADDR               (_EMAC_BASE_ADDR+0x025Cu)
S#define _EMAC_TXCARRIERSLOSS_ADDR           (_EMAC_BASE_ADDR+0x0260u)
S#define _EMAC_TXOCTETS_ADDR                 (_EMAC_BASE_ADDR+0x0264u)
S#define _EMAC_FRAME64_ADDR                  (_EMAC_BASE_ADDR+0x0268u)
S#define _EMAC_FRAME65T127_ADDR              (_EMAC_BASE_ADDR+0x026Cu)
S#define _EMAC_FRAME128T255_ADDR             (_EMAC_BASE_ADDR+0x0270u)
S#define _EMAC_FRAME256T511_ADDR             (_EMAC_BASE_ADDR+0x0274u)
S#define _EMAC_FRAME512T1023_ADDR            (_EMAC_BASE_ADDR+0x0278u)
S#define _EMAC_FRAME1024TUP_ADDR             (_EMAC_BASE_ADDR+0x027Cu)
S#define _EMAC_NETOCTETS_ADDR                (_EMAC_BASE_ADDR+0x0280u)
S#define _EMAC_RXSOFOVERRUNS_ADDR            (_EMAC_BASE_ADDR+0x0284u)
S#define _EMAC_RXMOFOVERRUNS_ADDR            (_EMAC_BASE_ADDR+0x0288u)
S#define _EMAC_RXDMAOVERRUNS_ADDR            (_EMAC_BASE_ADDR+0x028Cu)
S
S#define EMAC_RXGOODFRAMES                   EMAC_REG(RXGOODFRAMES)
S#define EMAC_RXBCASTFRAMES                  EMAC_REG(RXBCASTFRAMES)
S#define EMAC_RXMCASTFRAMES                  EMAC_REG(RXMCASTFRAMES)
S#define EMAC_RXPAUSEFRAMES                  EMAC_REG(RXPAUSEFRAMES)
S#define EMAC_RXCRCERRORS                    EMAC_REG(RXCRCERRORS)
S#define EMAC_RXALIGNCODEERRORS              EMAC_REG(RXALIGNCODEERRORS)
S#define EMAC_RXOVERSIZED                    EMAC_REG(RXOVERSIZED)
S#define EMAC_RXJABBER                       EMAC_REG(RXJABBER)
S#define EMAC_RXUNDERSIZED                   EMAC_REG(RXUNDERSIZED)
S#define EMAC_RXFRAGMENTS                    EMAC_REG(RXFRAGMENTS)
S#define EMAC_RXFILTERED                     EMAC_REG(RXFILTERED)
S#define EMAC_RXQOSFILTERED                  EMAC_REG(RXQOSFILTERED)
S#define EMAC_RXOCTETS                       EMAC_REG(RXOCTETS)
S#define EMAC_TXGOODFRAMES                   EMAC_REG(TXGOODFRAMES)
S#define EMAC_TXBCASTFRAMES                  EMAC_REG(TXBCASTFRAMES)
S#define EMAC_TXMCASTFRAMES                  EMAC_REG(TXMCASTFRAMES)
S#define EMAC_TXPAUSEFRAMES                  EMAC_REG(TXPAUSEFRAMES)
S#define EMAC_TXDEFERRED                     EMAC_REG(TXDEFERRED)
S#define EMAC_TXCOLLISION                    EMAC_REG(TXCOLLISION)
S#define EMAC_TXSINGLECOLL                   EMAC_REG(TXSINGLECOLL)
S#define EMAC_TXMULTICOLL                    EMAC_REG(TXMULTICOLL)
S#define EMAC_TXEXCESSIVECOLL                EMAC_REG(TXEXCESSIVECOLL)
S#define EMAC_TXLATECOLL                     EMAC_REG(TXLATECOLL)
S#define EMAC_TXUNDERRUN                     EMAC_REG(TXUNDERRUN)
S#define EMAC_TXCARRIERSLOSS                 EMAC_REG(TXCARRIERSLOSS)
S#define EMAC_TXOCTETS                       EMAC_REG(TXOCTETS)
S#define EMAC_FRAME64                        EMAC_REG(FRAME64)
S#define EMAC_FRAME65T127                    EMAC_REG(FRAME65T127)
S#define EMAC_FRAME128T255                   EMAC_REG(FRAME128T255)
S#define EMAC_FRAME256T511                   EMAC_REG(FRAME256T511)
S#define EMAC_FRAME512T1023                  EMAC_REG(FRAME512T1023)
S#define EMAC_FRAME1024TUP                   EMAC_REG(FRAME1024TUP)
S#define EMAC_NETOCTETS                      EMAC_REG(NETOCTETS)
S#define EMAC_RXSOFOVERRUNS                  EMAC_REG(RXSOFOVERRUNS)
S#define EMAC_RXMOFOVERRUNS                  EMAC_REG(RXMOFOVERRUNS)
S#define EMAC_RXDMAOVERRUNS                  EMAC_REG(RXDMAOVERRUNS)
S
S#define _EMAC_RXGOODFRAMES_COUNT_MASK       0xFFFFFFFFu
S#define _EMAC_RXBCASTFRAMES_COUNT_MASK      0xFFFFFFFFu
S#define _EMAC_RXMCASTFRAMES_COUNT_MASK      0xFFFFFFFFu
S#define _EMAC_RXPAUSEFRAMES_COUNT_MASK      0xFFFFFFFFu
S#define _EMAC_RXCRCERRORS_COUNT_MASK        0xFFFFFFFFu
S#define _EMAC_RXALIGNCODEERRORS_COUNT_MASK  0xFFFFFFFFu
S#define _EMAC_RXOVERSIZED_COUNT_MASK        0xFFFFFFFFu
S#define _EMAC_RXJABBER_COUNT_MASK           0xFFFFFFFFu
S#define _EMAC_RXUNDERSIZED_COUNT_MASK       0xFFFFFFFFu
S#define _EMAC_RXFRAGMENTS_COUNT_MASK        0xFFFFFFFFu
S#define _EMAC_RXFILTERED_COUNT_MASK         0xFFFFFFFFu
S#define _EMAC_RXQOSFILTERED_COUNT_MASK      0xFFFFFFFFu
S#define _EMAC_RXOCTETS_COUNT_MASK           0xFFFFFFFFu
S#define _EMAC_TXGOODFRAMES_COUNT_MASK       0xFFFFFFFFu
S#define _EMAC_TXBCASTFRAMES_COUNT_MASK      0xFFFFFFFFu
S#define _EMAC_TXMCASTFRAMES_COUNT_MASK      0xFFFFFFFFu
S#define _EMAC_TXPAUSEFRAMES_COUNT_MASK      0xFFFFFFFFu
S#define _EMAC_TXDEFERRED_COUNT_MASK         0xFFFFFFFFu
S#define _EMAC_TXCOLLISION_COUNT_MASK        0xFFFFFFFFu
S#define _EMAC_TXSINGLECOLL_COUNT_MASK       0xFFFFFFFFu
S#define _EMAC_TXMULTICOLL_COUNT_MASK        0xFFFFFFFFu
S#define _EMAC_TXEXCESSIVECOLL_COUNT_MASK    0xFFFFFFFFu
S#define _EMAC_TXLATECOLL_COUNT_MASK         0xFFFFFFFFu
S#define _EMAC_TXUNDERRUN_COUNT_MASK         0xFFFFFFFFu
S#define _EMAC_TXCARRIERSLOSS_COUNT_MASK     0xFFFFFFFFu
S#define _EMAC_TXOCTETS_COUNT_MASK           0xFFFFFFFFu
S#define _EMAC_FRAME64_COUNT_MASK            0xFFFFFFFFu
S#define _EMAC_FRAME65T127_COUNT_MASK        0xFFFFFFFFu
S#define _EMAC_FRAME128T255_COUNT_MASK       0xFFFFFFFFu
S#define _EMAC_FRAME256T511_COUNT_MASK       0xFFFFFFFFu
S#define _EMAC_FRAME512T1023_COUNT_MASK      0xFFFFFFFFu
S#define _EMAC_FRAME1024TUP_COUNT_MASK       0xFFFFFFFFu
S#define _EMAC_NETOCTETS_COUNT_MASK          0xFFFFFFFFu
S#define _EMAC_RXSOFOVERRUNS_COUNT_MASK      0xFFFFFFFFu
S#define _EMAC_RXMOFOVERRUNS_COUNT_MASK      0xFFFFFFFFu
S#define _EMAC_RXDMAOVERRUNS_COUNT_MASK      0xFFFFFFFFu
S
S#define _EMAC_RXGOODFRAMES_COUNT_SHIFT      0u
S#define _EMAC_RXBCASTFRAMES_COUNT_SHIFT     0u
S#define _EMAC_RXMCASTFRAMES_COUNT_SHIFT     0u
S#define _EMAC_RXPAUSEFRAMES_COUNT_SHIFT     0u
S#define _EMAC_RXCRCERRORS_COUNT_SHIFT       0u
S#define _EMAC_RXALIGNCODEERRORS_COUNT_SHIFT 0u
S#define _EMAC_RXOVERSIZED_COUNT_SHIFT       0u
S#define _EMAC_RXJABBER_COUNT_SHIFT          0u
S#define _EMAC_RXUNDERSIZED_COUNT_SHIFT      0u
S#define _EMAC_RXFRAGMENTS_COUNT_SHIFT       0u
S#define _EMAC_RXFILTERED_COUNT_SHIFT        0u
S#define _EMAC_RXQOSFILTERED_COUNT_SHIFT     0u
S#define _EMAC_RXOCTETS_COUNT_SHIFT          0u
S#define _EMAC_TXGOODFRAMES_COUNT_SHIFT      0u
S#define _EMAC_TXBCASTFRAMES_COUNT_SHIFT     0u
S#define _EMAC_TXMCASTFRAMES_COUNT_SHIFT     0u
S#define _EMAC_TXPAUSEFRAMES_COUNT_SHIFT     0u
S#define _EMAC_TXDEFERRED_COUNT_SHIFT        0u
S#define _EMAC_TXCOLLISION_COUNT_SHIFT       0u
S#define _EMAC_TXSINGLECOLL_COUNT_SHIFT      0u
S#define _EMAC_TXMULTICOLL_COUNT_SHIFT       0u
S#define _EMAC_TXEXCESSIVECOLL_COUNT_SHIFT   0u
S#define _EMAC_TXLATECOLL_COUNT_SHIFT        0u
S#define _EMAC_TXUNDERRUN_COUNT_SHIFT        0u
S#define _EMAC_TXCARRIERSLOSS_COUNT_SHIFT    0u
S#define _EMAC_TXOCTETS_COUNT_SHIFT          0u
S#define _EMAC_FRAME64_COUNT_SHIFT           0u
S#define _EMAC_FRAME65T127_COUNT_SHIFT       0u
S#define _EMAC_FRAME128T255_COUNT_SHIFT      0u
S#define _EMAC_FRAME256T511_COUNT_SHIFT      0u
S#define _EMAC_FRAME512T1023_COUNT_SHIFT     0u
S#define _EMAC_FRAME1024TUP_COUNT_SHIFT      0u
S#define _EMAC_NETOCTETS_COUNT_SHIFT         0u
S#define _EMAC_RXSOFOVERRUNS_COUNT_SHIFT     0u
S#define _EMAC_RXMOFOVERRUNS_COUNT_SHIFT     0u
S#define _EMAC_RXDMAOVERRUNS_COUNT_SHIFT     0u
S
S#define EMAC_RXGOODFRAMES_COUNT_DEFAULT	    0x00000000u
S#define	EMAC_RXBCASTFRAMES_COUNT_DEFAULT    0x00000000u
S#define EMAC_RXMCASTFRAMES_COUNT_DEFAULT    0x00000000u
S#define EMAC_RXPAUSEFRAMES_COUNT_DEFAULT    0x00000000u
S#define EMAC_RXCRCERRORS_COUNT_DEFAULT      0x00000000u
S#define EMAC_RXALIGNCODEERRORS_COUNT_DEFAULT 0x00000000u
S#define	EMAC_RXOVERSIZED_COUNT_DEFAULT       0x00000000u
S#define EMAC_RXJABBER_COUNT_DEFAULT          0x00000000u
S#define EMAC_RXUNDERSIZED_COUNT_DEFAULT      0X00000000u
S#define EMAC_RXFRAGMENTS_COUNT_DEFAULT	     0x00000000u
S#define EMAC_RXFILTERED_COUNT_DEFAULT        0x00000000u
S#define EMAC_RXQOSFILTERED_COUNT_DEFAULT     0x00000000u
S#define EMAC_RXOCTETS_COUNT_DEFAULT          0x00000000u
S#define EMAC_TXGOODFRAMES_COUNT_DEFAULT	     0x00000000u
S#define EMAC_TXBCASTFRAMES_COUNT_DEFAULT     0x00000000u
S#define EMAC_TXMCASTFRAMES_COUNT_DEFAULT     0x00000000u
S#define EMAC_TXPAUSEFRAMES_COUNT_DEFAULT     0x00000000u
S#define EMAC_TXDEFERRED_COUNT_DEFAULT        0x00000000u
S#define EMAC_TXCOLLISION_COUNT_DEFAULT       0x00000000u
S#define EMAC_TXSINGLECOLL_COUNT_DEFAULT      0x00000000u
S#define EMAC_TXMULTICOLL_COUNT_DEFAULT       0x00000000u
S#define EMAC_TXEXCESSIVECOLL_COUNT_DEFAULT   0x00000000u
S#define EMAC_TXLATECOLL_COUNT_DEFAULT        0x00000000u
S#define EMAC_TXUNDERRUN_COUNT_DEFAULT        0x00000000u
S#define EMAC_TXCARRIERSLOSS_COUNT_DEFAULT    0x00000000u
S#define EMAC_TXOCTETS_COUNT_DEFAULT          0x00000000u
S#define EMAC_FRAME64_COUNT_DEFAULT           0x00000000u
S#define EMAC_FRAME65T127_COUNT_DEFAULT	     0x00000000u
S#define EMAC_FRAME128T255_COUNT_DEFAULT      0x00000000u
S#define EMAC_FRAME256T511_COUNT_DEFAULT      0x00000000u
S#define EMAC_FRAME512T1023_COUNT_DEFAULT     0x00000000u
S#define EMAC_FRAME1024TUP_COUNT_DEFAULT      0x00000000u
S#define EMAC_NETOCTETS_COUNT_DEFAULT         0x00000000u
S#define EMAC_RXSOFOVERRUNS_COUNT_DEFAULT     0x00000000u
S#define EMAC_RXMOFOVERRUNS_COUNT_DEFAULT     0x00000000u
S#define EMAC_RXDMAOVERRUNS_COUNT_DEFAULT     0x00000000u
S/******************************************************************************\
S* _____________________
X
S* |                   |
S* |   EWTRCTRL        |
S* |___________________|
S*
S* EWTRCTRL         - TR Control
S*
S* FIELDS (msb -> lsb)
S*
S* MACROS SUPPORTED
S*  EMAC_FMK     .
S*  EMAC_FMKS    .
S*  EMAC_FMKCHF  .
S*  EMAC_ADDR    y
S*  EMAC_REG     y
S*  EMAC_RGET    y
S*  EMAC_RSET    y
S*  EMAC_FGET    .
S*  EMAC_FSET    .
S*  EMAC_FSETS   .
S*  EMAC_RGETI   .
S*  EMAC_RSETI   .
S*  EMAC_FGETI   .
S*  EMAC_FSETI   .
S*  EMAC_FSETSI  .
S*
S\******************************************************************************/
S#define _EMAC_EWTRCTRL_ADDR                     (_EMAC_BASE_ADDR+0x3000u)
S
S#define EMAC_EWTRCTRL                           EMAC_REG(EWTRCTRL)
S
S/******************************************************************************\
S* _____________________
X
S* |                   |
S* |   EWCTL           |
S* |___________________|
S*
S* EWCTL             - Interrupt control register
S*
S* FIELDS (msb -> lsb)
S*  (rw)  EMACRST    - EMAC Reset
S*  (rw)  MDIORST    - MDIO Reset
S*  (rw)  INTEN      - EMAC/MDIO Global Interrupt Enable
S*
S* MACROS SUPPORTED
S*  EMAC_FMK     y
S*  EMAC_FMKS    y
S*  EMAC_FMKCHF  .
S*  EMAC_ADDR    y
S*  EMAC_REG     y
S*  EMAC_RGET    y
S*  EMAC_RSET    y
S*  EMAC_FGET    y
S*  EMAC_FSET    y
S*  EMAC_FSETS   y
S*  EMAC_RGETI   .
S*  EMAC_RSETI   .
S*  EMAC_FGETI   .
S*  EMAC_FSETI   .
S*  EMAC_FSETSI  .
S*
S\******************************************************************************/
S#define _EMAC_EWCTL_ADDR                        (_EMAC_BASE_ADDR+0x3004u)
S
S#define EMAC_EWCTL                              EMAC_REG(EWCTL)
S
S#define _EMAC_EWCTL_EMACRST_MASK                0x4u
S#define _EMAC_EWCTL_EMACRST_SHIFT               2u
S#define  EMAC_EWCTL_EMACRST_DEFAULT             0x00000000u
S#define EMAC_EWCTL_EMACRST_YES                  1u
S#define EMAC_EWCTL_EMACRST_NO                   0u
S
S#define _EMAC_EWCTL_MDIORST_MASK                0x2u
S#define _EMAC_EWCTL_MDIORST_SHIFT               1u
S#define  EMAC_EWCTL_MDIORST_DEFAULT             0x00000000u
S#define EMAC_EWCTL_MDIORST_YES                  1u
S#define EMAC_EWCTL_MDIORST_NO                   0u
S
S#define _EMAC_EWCTL_INTEN_MASK                  0x1u
S#define _EMAC_EWCTL_INTEN_SHIFT                 0u
S#define  EMAC_EWCTL_INTEN_DEFAULT               0x00000000u
S#define EMAC_EWCTL_INTEN_ENABLE                 1u
S#define EMAC_EWCTL_INTEN_DISABLE                0u
S
S/******************************************************************************\
S* _____________________
X
S* |                   |
S* |   EWINTTCNT       |
S* |___________________|
S*
S* EWINTTCNT         - Interrupt Timer Count
S*
S* FIELDS (msb -> lsb)
S*
S* MACROS SUPPORTED
S*  EMAC_FMK     .
S*  EMAC_FMKS    .
S*  EMAC_FMKCHF  .
S*  EMAC_ADDR    y
S*  EMAC_REG     y
S*  EMAC_RGET    y
S*  EMAC_RSET    y
S*  EMAC_FGET    .
S*  EMAC_FSET    .
S*  EMAC_FSETS   .
S*  EMAC_RGETI   .
S*  EMAC_RSETI   .
S*  EMAC_FGETI   .
S*  EMAC_FSETI   .
S*  EMAC_FSETSI  .
S*
S\******************************************************************************/
S#define _EMAC_EWINTTCNT_ADDR                    (_EMAC_BASE_ADDR+0x3008u)
S
S#define EMAC_EWINTTCNT                          EMAC_REG(EWINTTCNT)
S
S
S
N#endif /* EMAC_SUPPORT */
N
N#endif /* _CSL_EMACHAL_H_ */
N/******************************************************************************\
N* End of csl_emachal.h
X
N\******************************************************************************/
N
N
N
N
N
L 20 "../csl/csl_emac.c" 2
N#include <csl_emac.h>
L 1 "E:/TI_workspase/c6701_t/csl/csl_emac.h" 1
N/*****************************************************************************\
N*           Copyright (C) 1999-2003 Texas Instruments Incorporated.
X
N*                           All Rights Reserved
N*------------------------------------------------------------------------------
N* FILENAME...... csl_emac.h
N* DATE CREATED.. 02/08/2002
N* LAST MODIFIED. 04/24/2003
N*------------------------------------------------------------------------------
N* NOTE:
N*   When used in an multitasking environment, no EMAC function may be
N*   called while another EMAC function is operating on the same device
N*   handle in another thread. It is the responsibility of the application
N*   to assure adherence to this restriction.
N*
N\******************************************************************************/
N#ifndef _CSL_EMAC_H
N#define _CSL_EMAC_H_
N
N/* Include the main CSL file */
N#include <csl.h>
L 1 "E:/TI_workspase/c6701_t/csl/csl.h" 1
N/******************************************************************************\
N*           Copyright (C) 2000 Texas Instruments Incorporated.
X
N*                           All Rights Reserved
N*------------------------------------------------------------------------------
N* FILENAME...... csl.h
N* DATE CREATED.. 06/13/2000 
N* LAST MODIFIED. 08/02/2004 - Adding support for C6418
N*                07/24/2004 - Re-introducing BIOS components from CSL due to compatibility issues.
N*                06/26/2003  Added CHIP_6411
N*                06/17/2003  Added CHIP_6712C
N*                05/28/2003  Added CHIP_6711C
N*                03/26/2003 -  6412,DM642 check libraries 
N*                10/10/2001 -  6712-6713-6414-6416-6415  check libraries
N*                11/19/2003 - Removed BIOS components from CSL - _CSL_Config
N*
N\******************************************************************************/
N#ifndef _CSL_H_
N#define _CSL_H_
N
N#include <csl_chip.h>
N#include <csl_irq.h>
L 1 "E:/TI_workspase/c6701_t/csl/csl_irq.h" 1
N/******************************************************************************\
N*           Copyright (C) 1999-2000 Texas Instruments Incorporated.
X
N*                           All Rights Reserved
N*------------------------------------------------------------------------------
N* FILENAME...... csl_irq.h
N* DATE CREATED.. 06/09/1999 
N* LAST MODIFIED. 08/02/2004 - Adding support for C6418
N*                07/24/2004 - Re-introducing BIOS components from CSL due to compatibility issues.
N*                02/05/2004 Removed bios related components 
N*                10/03/2001
N*                - CHIP_RSET()/CHIP_RGET() replaced by CHIP_CRSET()/CHIP_CRGET()
N\******************************************************************************/
N#ifndef _CSL_IRQ_H_
N#define _CSL_IRQ_H_
N
N#include <csl_stdinc.h>
N#include <csl_chip.h>
N#include <csl_irqhal.h>
L 1 "E:/TI_workspase/c6701_t/csl/csl_irqhal.h" 1
N/******************************************************************************\
N*           Copyright (C) 1999-2000 Texas Instruments Incorporated.
X
N*                           All Rights Reserved
N*------------------------------------------------------------------------------
N* FILENAME...... csl_irqhal.h
N* DATE CREATED.. 06/20/1999 
N* LAST MODIFIED. 10/03/2000
N*------------------------------------------------------------------------------
N* REGISTERS
N*
N* MUXH   - interrupt multiplexer high register
N* MUXL   - interrupt multiplexer low register
N* EXTPOL - external interrupt polarity register
N*
N\******************************************************************************/
N#ifndef _CSL_IRQHAL_H_
N#define _CSL_IRQHAL_H_
N
N#include <csl_stdinchal.h>
N#include <csl_chip.h>
N
N#if (IRQ_SUPPORT)
X#if (( ( 1*0) | ( 1*0) | ( 1*0) | ( 1*0) | ( 1*0) | ( 1*0) | ( 1*1) | ( 1*0) | ( 1*0) | ( 1*0) | ( 1*0)| ( 1*0)| ( 1*0)| ( 1*0)| ( 1*0) | ( 1*0) | ( 1*0) | ( 1*0) | ( 1*0) | ( 1*0) | ( 1*0) | ( 1*0) | ( 1*0) | ( 1*0) | ( 0*0) ))
N/******************************************************************************\
N* MISC section
X
N\******************************************************************************/
N
N
N/******************************************************************************\
N* module level register/field access macros
X
N\******************************************************************************/
N
N  /* ----------------- */
N  /* FIELD MAKE MACROS */
N  /* ----------------- */
N
N  #define IRQ_FMK(REG,FIELD,x)\
N    _PER_FMK(IRQ,##REG,##FIELD,x)
X  #define IRQ_FMK(REG,FIELD,x)    _PER_FMK(IRQ,##REG,##FIELD,x)
N
N  #define IRQ_FMKS(REG,FIELD,SYM)\
N    _PER_FMKS(IRQ,##REG,##FIELD,##SYM)
X  #define IRQ_FMKS(REG,FIELD,SYM)    _PER_FMKS(IRQ,##REG,##FIELD,##SYM)
N 
N 
N  /* -------------------------------- */
N  /* RAW REGISTER/FIELD ACCESS MACROS */
N  /* -------------------------------- */
N
N  #define IRQ_ADDR(REG)\
N    _IRQ_##REG##_ADDR
X  #define IRQ_ADDR(REG)    _IRQ_##REG##_ADDR
N
N  #define IRQ_RGET(REG)\
N    _PER_RGET(_IRQ_##REG##_ADDR,IRQ,##REG)
X  #define IRQ_RGET(REG)    _PER_RGET(_IRQ_##REG##_ADDR,IRQ,##REG)
N
N  #define IRQ_RSET(REG,x)\
N    _PER_RSET(_IRQ_##REG##_ADDR,IRQ,##REG,x)
X  #define IRQ_RSET(REG,x)    _PER_RSET(_IRQ_##REG##_ADDR,IRQ,##REG,x)
N
N  #define IRQ_FGET(REG,FIELD)\
N    _IRQ_##REG##_FGET(##FIELD)
X  #define IRQ_FGET(REG,FIELD)    _IRQ_##REG##_FGET(##FIELD)
N
N  #define IRQ_FSET(REG,FIELD,x)\
N    _IRQ_##REG##_FSET(##FIELD,##x)
X  #define IRQ_FSET(REG,FIELD,x)    _IRQ_##REG##_FSET(##FIELD,##x)
N
N  #define IRQ_FSETS(REG,FIELD,SYM)\
N    _IRQ_##REG##_FSETS(##FIELD,##SYM)
X  #define IRQ_FSETS(REG,FIELD,SYM)    _IRQ_##REG##_FSETS(##FIELD,##SYM)
N 
N 
N  /* ------------------------------------------ */
N  /* ADDRESS BASED REGISTER/FIELD ACCESS MACROS */
N  /* ------------------------------------------ */
N
N  #define IRQ_RGETA(addr,REG)\
N    _PER_RGET(addr,IRQ,##REG)
X  #define IRQ_RGETA(addr,REG)    _PER_RGET(addr,IRQ,##REG)
N
N  #define IRQ_RSETA(addr,REG,x)\
N    _PER_RSET(addr,IRQ,##REG,x)
X  #define IRQ_RSETA(addr,REG,x)    _PER_RSET(addr,IRQ,##REG,x)
N
N  #define IRQ_FGETA(addr,REG,FIELD)\
N    _PER_FGET(addr,IRQ,##REG,##FIELD)
X  #define IRQ_FGETA(addr,REG,FIELD)    _PER_FGET(addr,IRQ,##REG,##FIELD)
N
N  #define IRQ_FSETA(addr,REG,FIELD,x)\
N    _PER_FSET(addr,IRQ,##REG,##FIELD,x)
X  #define IRQ_FSETA(addr,REG,FIELD,x)    _PER_FSET(addr,IRQ,##REG,##FIELD,x)
N
N  #define IRQ_FSETSA(addr,REG,FIELD,SYM)\
N    _PER_FSETS(addr,IRQ,##REG,##FIELD,##SYM)
X  #define IRQ_FSETSA(addr,REG,FIELD,SYM)    _PER_FSETS(addr,IRQ,##REG,##FIELD,##SYM)
N
N
N/******************************************************************************\
N* _____________________
X
N* |                   |
N* |  M U X H          |
N* |___________________|
N*
N* MUXH - interrupt multiplexer high register
N*
N* FIELDS (msb -> lsb)
N* (rw) INTSEL15
N* (rw) INTSEL14
N* (rw) INTSEL13
N* (rw) INTSEL12
N* (rw) INTSEL11
N* (rw) INTSEL10
N*
N\******************************************************************************/
N  #define _IRQ_MUXH_ADDR               0x019C0000u
N
N  #define _IRQ_MUXH_INTSEL15_MASK      0x7C000000u
N  #define _IRQ_MUXH_INTSEL15_SHIFT     0x0000001Au
N  #define  IRQ_MUXH_INTSEL15_DEFAULT   0x00000002u
N  #define  IRQ_MUXH_INTSEL15_OF(x)     _VALUEOF(x)
N
N  #define _IRQ_MUXH_INTSEL14_MASK      0x03E00000u
N  #define _IRQ_MUXH_INTSEL14_SHIFT     0x00000015u
N  #define  IRQ_MUXH_INTSEL14_DEFAULT   0x00000001u
N  #define  IRQ_MUXH_INTSEL14_OF(x)     _VALUEOF(x)
N
N  #define _IRQ_MUXH_INTSEL13_MASK      0x001F0000u
N  #define _IRQ_MUXH_INTSEL13_SHIFT     0x00000010u
N  #define  IRQ_MUXH_INTSEL13_DEFAULT   0x00000000u
N  #define  IRQ_MUXH_INTSEL13_OF(x)     _VALUEOF(x)
N
N  #define _IRQ_MUXH_INTSEL12_MASK      0x00007C00u
N  #define _IRQ_MUXH_INTSEL12_SHIFT     0x0000000Au
N  #define  IRQ_MUXH_INTSEL12_DEFAULT   0x0000000Bu
N  #define  IRQ_MUXH_INTSEL12_OF(x)     _VALUEOF(x)
N
N  #define _IRQ_MUXH_INTSEL11_MASK      0x000003E0u
N  #define _IRQ_MUXH_INTSEL11_SHIFT     0x00000005u
N  #define  IRQ_MUXH_INTSEL11_DEFAULT   0x0000000Au
N  #define  IRQ_MUXH_INTSEL11_OF(x)     _VALUEOF(x)
N
N  #define _IRQ_MUXH_INTSEL10_MASK      0x0000001Fu
N  #define _IRQ_MUXH_INTSEL10_SHIFT     0x00000000u
N  #define  IRQ_MUXH_INTSEL10_DEFAULT   0x00000003u
N  #define  IRQ_MUXH_INTSEL10_OF(x)     _VALUEOF(x)
N
N  #define  IRQ_MUXH_OF(x)              _VALUEOF(x)
N
N  #define IRQ_MUXH_DEFAULT (Uint32)( \
N     _PER_FDEFAULT(IRQ,MUXH,INTSEL15) \
N    |_PER_FDEFAULT(IRQ,MUXH,INTSEL14) \
N    |_PER_FDEFAULT(IRQ,MUXH,INTSEL13) \
N    |_PER_FDEFAULT(IRQ,MUXH,INTSEL12) \
N    |_PER_FDEFAULT(IRQ,MUXH,INTSEL11) \
N    |_PER_FDEFAULT(IRQ,MUXH,INTSEL10) \
N  )
X  #define IRQ_MUXH_DEFAULT (Uint32)(      _PER_FDEFAULT(IRQ,MUXH,INTSEL15)     |_PER_FDEFAULT(IRQ,MUXH,INTSEL14)     |_PER_FDEFAULT(IRQ,MUXH,INTSEL13)     |_PER_FDEFAULT(IRQ,MUXH,INTSEL12)     |_PER_FDEFAULT(IRQ,MUXH,INTSEL11)     |_PER_FDEFAULT(IRQ,MUXH,INTSEL10)   )
N
N  #define IRQ_MUXH_RMK(intsel15,intsel14,intsel13,intsel12,intsel11,intsel10) \
N    (Uint32)( \
N     _PER_FMK(IRQ,MUXH,INTSEL15,intsel15) \
N    |_PER_FMK(IRQ,MUXH,INTSEL14,intsel14) \
N    |_PER_FMK(IRQ,MUXH,INTSEL13,intsel13) \
N    |_PER_FMK(IRQ,MUXH,INTSEL12,intsel12) \
N    |_PER_FMK(IRQ,MUXH,INTSEL11,intsel11) \
N    |_PER_FMK(IRQ,MUXH,INTSEL10,intsel10) \
N   )
X  #define IRQ_MUXH_RMK(intsel15,intsel14,intsel13,intsel12,intsel11,intsel10)     (Uint32)(      _PER_FMK(IRQ,MUXH,INTSEL15,intsel15)     |_PER_FMK(IRQ,MUXH,INTSEL14,intsel14)     |_PER_FMK(IRQ,MUXH,INTSEL13,intsel13)     |_PER_FMK(IRQ,MUXH,INTSEL12,intsel12)     |_PER_FMK(IRQ,MUXH,INTSEL11,intsel11)     |_PER_FMK(IRQ,MUXH,INTSEL10,intsel10)    )
N
N  #define _IRQ_MUXH_FGET(FIELD)\
N    _PER_FGET(_IRQ_MUXH_ADDR,IRQ,MUXH,##FIELD)
X  #define _IRQ_MUXH_FGET(FIELD)    _PER_FGET(_IRQ_MUXH_ADDR,IRQ,MUXH,##FIELD)
N
N  #define _IRQ_MUXH_FSET(FIELD,field)\
N    _PER_FSET(_IRQ_MUXH_ADDR,IRQ,MUXH,##FIELD,field)
X  #define _IRQ_MUXH_FSET(FIELD,field)    _PER_FSET(_IRQ_MUXH_ADDR,IRQ,MUXH,##FIELD,field)
N
N  #define _IRQ_MUXH_FSETS(FIELD,SYM)\
N    _PER_FSETS(_IRQ_MUXH_ADDR,IRQ,MUXH,##FIELD,##SYM)
X  #define _IRQ_MUXH_FSETS(FIELD,SYM)    _PER_FSETS(_IRQ_MUXH_ADDR,IRQ,MUXH,##FIELD,##SYM)
N
N
N/******************************************************************************\
N* _____________________
X
N* |                   |
N* |  M U X L          |
N* |___________________|
N*
N* MUXL - interrupt multiplexer low register
N*
N* FIELDS (msb -> lsb)
N* (rw) INTSEL9
N* (rw) INTSEL8
N* (rw) INTSEL7
N* (rw) INTSEL6
N* (rw) INTSEL5
N* (rw) INTSEL4
N*
N\******************************************************************************/
N  #define _IRQ_MUXL_ADDR               0x019C0004u
N
N  #define _IRQ_MUXL_INTSEL9_MASK       0x7C000000u
N  #define _IRQ_MUXL_INTSEL9_SHIFT      0x0000001Au
N  #define  IRQ_MUXL_INTSEL9_DEFAULT    0x00000009u
N  #define  IRQ_MUXL_INTSEL9_OF(x)      _VALUEOF(x)
N
N  #define _IRQ_MUXL_INTSEL8_MASK       0x03E00000u
N  #define _IRQ_MUXL_INTSEL8_SHIFT      0x00000015u
N  #define  IRQ_MUXL_INTSEL8_DEFAULT    0x00000008u
N  #define  IRQ_MUXL_INTSEL8_OF(x)      _VALUEOF(x)
N
N  #define _IRQ_MUXL_INTSEL7_MASK       0x001F0000u
N  #define _IRQ_MUXL_INTSEL7_SHIFT      0x00000010u
N  #define  IRQ_MUXL_INTSEL7_DEFAULT    0x00000007u
N  #define  IRQ_MUXL_INTSEL7_OF(x)      _VALUEOF(x)
N
N  #define _IRQ_MUXL_INTSEL6_MASK       0x00007C00u
N  #define _IRQ_MUXL_INTSEL6_SHIFT      0x0000000Au
N  #define  IRQ_MUXL_INTSEL6_DEFAULT    0x00000006u
N  #define  IRQ_MUXL_INTSEL6_OF(x)      _VALUEOF(x)
N
N  #define _IRQ_MUXL_INTSEL5_MASK       0x000003E0u
N  #define _IRQ_MUXL_INTSEL5_SHIFT      0x00000005u
N  #define  IRQ_MUXL_INTSEL5_DEFAULT    0x00000005u
N  #define  IRQ_MUXL_INTSEL5_OF(x)      _VALUEOF(x)
N
N  #define _IRQ_MUXL_INTSEL4_MASK       0x0000001Fu
N  #define _IRQ_MUXL_INTSEL4_SHIFT      0x00000000u
N  #define  IRQ_MUXL_INTSEL4_DEFAULT    0x00000004u
N  #define  IRQ_MUXL_INTSEL4_OF(x)      _VALUEOF(x)
N
N  #define  IRQ_MUXL_OF(x)              _VALUEOF(x)
N
N  #define IRQ_MUXL_DEFAULT (Uint32)( \
N     _PER_FDEFAULT(IRQ,MUXL,INTSEL9) \
N    |_PER_FDEFAULT(IRQ,MUXL,INTSEL8) \
N    |_PER_FDEFAULT(IRQ,MUXL,INTSEL7) \
N    |_PER_FDEFAULT(IRQ,MUXL,INTSEL6) \
N    |_PER_FDEFAULT(IRQ,MUXL,INTSEL5) \
N    |_PER_FDEFAULT(IRQ,MUXL,INTSEL4) \
N  )
X  #define IRQ_MUXL_DEFAULT (Uint32)(      _PER_FDEFAULT(IRQ,MUXL,INTSEL9)     |_PER_FDEFAULT(IRQ,MUXL,INTSEL8)     |_PER_FDEFAULT(IRQ,MUXL,INTSEL7)     |_PER_FDEFAULT(IRQ,MUXL,INTSEL6)     |_PER_FDEFAULT(IRQ,MUXL,INTSEL5)     |_PER_FDEFAULT(IRQ,MUXL,INTSEL4)   )
N
N  #define IRQ_MUXL_RMK(intsel9,intsel8,intsel7,intsel6,intsel5,intsel4) \
N    (Uint32)( \
N     _PER_FMK(IRQ,MUXL,INTSEL9,intsel9) \
N    |_PER_FMK(IRQ,MUXL,INTSEL8,intsel8) \
N    |_PER_FMK(IRQ,MUXL,INTSEL7,intsel7) \
N    |_PER_FMK(IRQ,MUXL,INTSEL6,intsel6) \
N    |_PER_FMK(IRQ,MUXL,INTSEL5,intsel5) \
N    |_PER_FMK(IRQ,MUXL,INTSEL4,intsel4) \
N   )
X  #define IRQ_MUXL_RMK(intsel9,intsel8,intsel7,intsel6,intsel5,intsel4)     (Uint32)(      _PER_FMK(IRQ,MUXL,INTSEL9,intsel9)     |_PER_FMK(IRQ,MUXL,INTSEL8,intsel8)     |_PER_FMK(IRQ,MUXL,INTSEL7,intsel7)     |_PER_FMK(IRQ,MUXL,INTSEL6,intsel6)     |_PER_FMK(IRQ,MUXL,INTSEL5,intsel5)     |_PER_FMK(IRQ,MUXL,INTSEL4,intsel4)    )
N
N  #define _IRQ_MUXL_FGET(FIELD)\
N    _PER_FGET(_IRQ_MUXL_ADDR,IRQ,MUXL,##FIELD)
X  #define _IRQ_MUXL_FGET(FIELD)    _PER_FGET(_IRQ_MUXL_ADDR,IRQ,MUXL,##FIELD)
N
N  #define _IRQ_MUXL_FSET(FIELD,field)\
N    _PER_FSET(_IRQ_MUXL_ADDR,IRQ,MUXL,##FIELD,field)
X  #define _IRQ_MUXL_FSET(FIELD,field)    _PER_FSET(_IRQ_MUXL_ADDR,IRQ,MUXL,##FIELD,field)
N
N  #define _IRQ_MUXL_FSETS(FIELD,SYM)\
N    _PER_FSETS(_IRQ_MUXL_ADDR,IRQ,MUXL,##FIELD,##SYM)
X  #define _IRQ_MUXL_FSETS(FIELD,SYM)    _PER_FSETS(_IRQ_MUXL_ADDR,IRQ,MUXL,##FIELD,##SYM)
N
N
N/******************************************************************************\
N* _____________________
X
N* |                   |
N* |  E X T P O L      |
N* |___________________|
N*
N* EXTPOL - external interrupt polarity register
N*
N* FIELDS (msb -> lsb)
N* (rw) XIP
N*
N\******************************************************************************/
N  #define _IRQ_EXTPOL_ADDR            0x019C0008u
N
N  #define _IRQ_EXTPOL_XIP_MASK        0x0000000Fu
N  #define _IRQ_EXTPOL_XIP_SHIFT       0x00000000u
N  #define  IRQ_EXTPOL_XIP_DEFAULT     0x00000000u
N  #define  IRQ_EXTPOL_XIP_OF(x)       _VALUEOF(x)
N
N  #define  IRQ_EXTPOL_OF(x)           _VALUEOF(x)
N
N  #define IRQ_EXTPOL_DEFAULT (Uint32)( \
N     _PER_FDEFAULT(IRQ,EXTPOL,XIP) \
N  )
X  #define IRQ_EXTPOL_DEFAULT (Uint32)(      _PER_FDEFAULT(IRQ,EXTPOL,XIP)   )
N
N  #define IRQ_EXTPOL_RMK(xip) (Uint32)( \
N     _PER_FMK(IRQ,EXTPOL,XIP,xip) \
N  )
X  #define IRQ_EXTPOL_RMK(xip) (Uint32)(      _PER_FMK(IRQ,EXTPOL,XIP,xip)   )
N
N  #define _IRQ_EXTPOL_FGET(FIELD)\
N    _PER_FGET(_IRQ_EXTPOL_ADDR,IRQ,EXTPOL,##FIELD)
X  #define _IRQ_EXTPOL_FGET(FIELD)    _PER_FGET(_IRQ_EXTPOL_ADDR,IRQ,EXTPOL,##FIELD)
N
N  #define _IRQ_EXTPOL_FSET(FIELD,field)\
N    _PER_FSET(_IRQ_EXTPOL_ADDR,IRQ,EXTPOL,##FIELD,field)
X  #define _IRQ_EXTPOL_FSET(FIELD,field)    _PER_FSET(_IRQ_EXTPOL_ADDR,IRQ,EXTPOL,##FIELD,field)
N
N  #define _IRQ_EXTPOL_FSETS(FIELD,SYM)\
N    _PER_FSETS(_IRQ_EXTPOL_ADDR,IRQ,EXTPOL,##FIELD,##SYM)
X  #define _IRQ_EXTPOL_FSETS(FIELD,SYM)    _PER_FSETS(_IRQ_EXTPOL_ADDR,IRQ,EXTPOL,##FIELD,##SYM)
N
N
N/*----------------------------------------------------------------------------*/
N
N#endif /* IRQ_SUPPORT */
N#endif /* _CSL_IRQHAL_H_ */
N/******************************************************************************\
N* End of csl_irqhal.h
X
N\******************************************************************************/
N
L 19 "E:/TI_workspase/c6701_t/csl/csl_irq.h" 2
N
N
N#if (IRQ_SUPPORT)
X#if (( ( 1*0) | ( 1*0) | ( 1*0) | ( 1*0) | ( 1*0) | ( 1*0) | ( 1*1) | ( 1*0) | ( 1*0) | ( 1*0) | ( 1*0)| ( 1*0)| ( 1*0)| ( 1*0)| ( 1*0) | ( 1*0) | ( 1*0) | ( 1*0) | ( 1*0) | ( 1*0) | ( 1*0) | ( 1*0) | ( 1*0) | ( 1*0) | ( 0*0) ))
N/******************************************************************************\
N* scope and inline control macros
X
N\******************************************************************************/
N#ifdef __cplusplus
S#define CSLAPI extern "C" far 
N#else
N#define CSLAPI extern far
N#endif
N
N#undef  USEDEFS
N#undef  IDECL
N#undef  IDEF
N
N#ifdef  _IRQ_MOD_
S  #define IDECL CSLAPI
S  #define USEDEFS
S  #define IDEF
N#else
N  #ifdef  _INLINE
S    #define IDECL static inline
S    #define USEDEFS
S    #define IDEF  static inline
N  #else
N    #define IDECL CSLAPI
N  #endif
N#endif
N
N
N/******************************************************************************\
N* global macro declarations
X
N\******************************************************************************/
N
N/* misc global settings */
N#define IRQ_INT_CNT     16
N#define IRQ_EVENT_CNT   32
N
N#define IRQ_EVT_NA         IRQ_EVENT_CNT
N
N/* event id definitions */
N#if (CHIP_6410 | CHIP_6413 | CHIP_6418)
X#if (0 | 0 | 0)
S  
S    #define IRQ_EVT_DSPINT     0
S    #define IRQ_EVT_TINT0      1
S    #define IRQ_EVT_TINT1      2
S    #define IRQ_EVT_SDINTA     3
S    #define IRQ_EVT_EXTINT4    4
S    #define IRQ_EVT_GPINT4     4
S    #define IRQ_EVT_EXTINT5    5
S    #define IRQ_EVT_GPINT5     5
S    #define IRQ_EVT_EXTINT6    6
S    #define IRQ_EVT_GPINT6     6
S    #define IRQ_EVT_EXTINT7    7
S    #define IRQ_EVT_GPINT7     7
S    #define IRQ_EVT_EDMAINT    8
S    #define IRQ_EVT_EMUDTDMA   9
S    #define IRQ_EVT_EMURTDXRX  10
S    #define IRQ_EVT_EMURTDXTX  11
S    #define IRQ_EVT_XINT0      12
S    #define IRQ_EVT_RINT0      13
S    #define IRQ_EVT_XINT1      14
S    #define IRQ_EVT_RINT1      15
S    #define IRQ_EVT_GPINT0     16
S    #define IRQ_EVT_TINT2      19
S    #define IRQ_EVT_I2CINT0    22
S    #define IRQ_EVT_I2CINT1    23
S    #define IRQ_EVT_AXINT1     24
S    #define IRQ_EVT_ARINT1     25
S    #define IRQ_EVT_AXINT0     28
S    #define IRQ_EVT_ARINT0     29
S
S  #if (CHIP_6418)
S    #define IRQ_EVT_VCPINT     30
S  #endif
S
N#else 
N
N  #if (CHIP_DM642 | CHIP_DM641 | CHIP_DM640 | CHIP_6412)
X  #if (0 | 0 | 0 | 0)
S
S    #define IRQ_EVT_DSPINT     0
S    #define IRQ_EVT_TINT0      1
S    #define IRQ_EVT_TINT1      2
S    #define IRQ_EVT_SDINTA     3
S    #define IRQ_EVT_EXTINT4    4
S    #define IRQ_EVT_GPINT4     4
S    #define IRQ_EVT_EXTINT5    5
S    #define IRQ_EVT_GPINT5     5
S    #define IRQ_EVT_EXTINT6    6
S    #define IRQ_EVT_GPINT6     6
S    #define IRQ_EVT_EXTINT7    7
S    #define IRQ_EVT_GPINT7     7
S    #define IRQ_EVT_EDMAINT    8
S    #define IRQ_EVT_EMUDTDMA   9
S    #define IRQ_EVT_EMURTDXRX  10
S    #define IRQ_EVT_EMURTDXTX  11
S    #define IRQ_EVT_XINT0      12
S    #define IRQ_EVT_RINT0      13
S    #define IRQ_EVT_XINT1      14
S    #define IRQ_EVT_RINT1      15
S    #define IRQ_EVT_GPINT0     16
S    #define IRQ_EVT_TINT2      19
S    #define IRQ_EVT_I2CINT0    22
S    #define IRQ_EVT_MACINT     24
S
S   #if !(CHIP_6412)
S    #define IRQ_EVT_VINT0      25
S    #define IRQ_EVT_VINT1      26
S   #endif
S
S   #if (CHIP_DM642)
S    #define IRQ_EVT_VINT2      27
S   #endif
S
S   #if !(CHIP_6412)
S    #define IRQ_EVT_AXINT0     28
S    #define IRQ_EVT_ARINT0     29
S   #endif
S
N  #else
N
N    #define IRQ_EVT_DSPINT     0
N    #define IRQ_EVT_TINT0      1
N    #define IRQ_EVT_TINT1      2
N    #define IRQ_EVT_SDINT      3
N    #define IRQ_EVT_SDINTA     3
N    #define IRQ_EVT_EXTINT4    4
N    #define IRQ_EVT_GPINT4     4
N    #define IRQ_EVT_EXTINT5    5
N    #define IRQ_EVT_GPINT5     5
N    #define IRQ_EVT_EXTINT6    6
N    #define IRQ_EVT_GPINT6     6
N    #define IRQ_EVT_EXTINT7    7
N    #define IRQ_EVT_GPINT7     7
N    #define IRQ_EVT_EDMAINT    8
N    #define IRQ_EVT_DMAINT0    8
N    #define IRQ_EVT_EMUDTDMA   9
N    #define IRQ_EVT_DMAINT1    9
N    #define IRQ_EVT_EMURTDXRX  10
N    #define IRQ_EVT_DMAINT2    10
N    #define IRQ_EVT_EMURTDXTX  11
N    #define IRQ_EVT_DMAINT3    11
N    #define IRQ_EVT_XINT0      12
N    #define IRQ_EVT_RINT0      13
N    #define IRQ_EVT_XINT1      14
N    #define IRQ_EVT_RINT1      15
N    #define IRQ_EVT_GPINT0     16
N    #define IRQ_EVT_XINT2      17
N    #define IRQ_EVT_RINT2      18
N    #define IRQ_EVT_TINT2      19
N    #define IRQ_EVT_SDINTB     20
N    #define IRQ_EVT_PCIWAKE    21
N    #define IRQ_EVT_MDIO       21
N    #define IRQ_EVT_QDMAERR    22
N    #define IRQ_EVT_I2CINT0    22 /* 6713 */
N    #define IRQ_EVT_UINT       23
N    #define IRQ_EVT_I2CINT1    23 /* 6713 */
N    #define IRQ_EVT_I2CINT2    23 
N    #define IRQ_EVT_I2CINT3    22 
N    #define IRQ_EVT_I2CINT4    23 
N
N    #define IRQ_EVT_MACINT     24 /* DM642 */
N    #define IRQ_EVT_VINT0      25 /* DM642 */
N    #define IRQ_EVT_VINT1      26 /* DM642 */
N    #define IRQ_EVT_VINT2      27 /* DM642 */
N    #define IRQ_EVT_AXINT0     28 /* 6713 / DM642 */
N    #define IRQ_EVT_ARINT0     29 /* 6713 / DM642 */
N    #define IRQ_EVT_AXINT3     IRQ_EVT_EXTINT4 /* 6713 */
N    #define IRQ_EVT_ARINT3     IRQ_EVT_EXTINT5 /* 6713 */
N    #define IRQ_EVT_VCPINT     30
N    #define IRQ_EVT_AXINT1     30 /* 6713 */
N
N    #define IRQ_EVT_AXINT2     30 /* 6713 */
N    #define IRQ_EVT_AXINT4     IRQ_EVT_EXTINT6
N    #define IRQ_EVT_TCPINT     31
N    #define IRQ_EVT_ARINT1     31 /* 6713 */
N
N    #define IRQ_EVT_ARINT2     31 /* 6713 */
N    #define IRQ_EVT_ARINT4     IRQ_EVT_EXTINT7
N
N  #endif
N
N#endif
N/* interrupt masks */
N#define IRQ_MASK_NA 0x00000000
N#define IRQ_MASK_00 0x00000001
N#define IRQ_MASK_01 0x00000002
N#define IRQ_MASK_02 0x00000004
N#define IRQ_MASK_03 0x00000008
N#define IRQ_MASK_04 0x00000010
N#define IRQ_MASK_05 0x00000020
N#define IRQ_MASK_06 0x00000040
N#define IRQ_MASK_07 0x00000080
N#define IRQ_MASK_08 0x00000100
N#define IRQ_MASK_09 0x00000200
N#define IRQ_MASK_10 0x00000400
N#define IRQ_MASK_11 0x00000800
N#define IRQ_MASK_12 0x00001000
N#define IRQ_MASK_13 0x00002000
N#define IRQ_MASK_14 0x00004000
N#define IRQ_MASK_15 0x00008000
N
N/* defines used with the dispatcher functions */
N#define IRQ_CCMASK_NONE        0x00000001u
N#define IRQ_CCMASK_PCC_MAPPED  0x00000000u
N#define IRQ_CCMASK_PCC_ENABLE  0x00000040u
N#define IRQ_CCMASK_PCC_FREEZE  0x00000060u
N#define IRQ_CCMASK_PCC_BYPASS  0x00000080u
N#define IRQ_CCMASK_DCC_MAPPED  0x00000000u
N#define IRQ_CCMASK_DCC_ENABLE  0x00000008u
N#define IRQ_CCMASK_DCC_FREEZE  0x0000000Cu
N#define IRQ_CCMASK_DCC_BYPASS  0x00000010u
N#define IRQ_CCMASK_DEFAULT     IRQ_CCMASK_NONE
N#define IRQ_IEMASK_SELF        0x80000000u
N#define IRQ_IEMASK_ALL         0x0000FFFFu
N#define IRQ_IEMASK_DEFAULT     IRQ_IEMASK_SELF
N
N
N/* private stuff */
N#define _IRQ_DISPATCHTABLE_CNT   (IRQ_INT_CNT)
N#define _IRQ_EVENT2INTTABLE_CNT  (IRQ_EVENT_CNT+1)
N#define _IRQ_INT2EVENTTABLE_CNT  (IRQ_INT_CNT)
N
N
N/******************************************************************************\
N* global typedef declarations
X
N\******************************************************************************/
Ntypedef struct {
N  void   *funcAddr;
N  Uint32 ieMask;
N  Uint32 ccMask;
N  Uint32 funcArg;
N} _IRQ_Dispatch;
N
Ntypedef struct {
N  void   *funcAddr;
N  Uint32 funcArg;
N  Uint32 ccMask;
N  Uint32 ieMask;
N} IRQ_Config;
N
N
N/******************************************************************************\
N* global variable declarations
X
N\******************************************************************************/
N
N/* private vars */
Nextern far Uint32 _IRQ_eventTable[IRQ_EVENT_CNT+1];
Xextern far Uint32 _IRQ_eventTable[32+1];
Nextern far Uint32 _IRQ_intTable[IRQ_INT_CNT];
Xextern far Uint32 _IRQ_intTable[16];
Nextern far _IRQ_Dispatch _IRQ_internalDispatchTable[_IRQ_DISPATCHTABLE_CNT];
Xextern far _IRQ_Dispatch _IRQ_internalDispatchTable[(16)];
Nextern far _IRQ_Dispatch *_IRQ_dispatchTable;
N
N/******************************************************************************\
N* global function declarations
X
N\******************************************************************************/
N
N/* private functions */
NCSLAPI void _IRQ_init(Uint32 biosPresent, _IRQ_Dispatch *dispatchTable);
Xextern far void _IRQ_init(Uint32 biosPresent, _IRQ_Dispatch *dispatchTable);
N
N/* API functions */
NCSLAPI void IRQ_map(Uint32 eventId, Uint32 intNumber);
Xextern far void IRQ_map(Uint32 eventId, Uint32 intNumber);
NCSLAPI void *IRQ_setVecs(void *vecs);
Xextern far void *IRQ_setVecs(void *vecs);
NCSLAPI Uint32 IRQ_biosPresent();
Xextern far Uint32 IRQ_biosPresent();
NCSLAPI void IRQ_hook(int intNum, void *func);
Xextern far void IRQ_hook(int intNum, void *func);
N
N/* These functions only work with the DSP/BIOS HWI dispatcher */
NCSLAPI void IRQ_config(Uint32 eventId, IRQ_Config *config);
Xextern far void IRQ_config(Uint32 eventId, IRQ_Config *config);
NCSLAPI void IRQ_configArgs(Uint32 eventId, void *funcAddr, Uint32 funcArg,
Xextern far void IRQ_configArgs(Uint32 eventId, void *funcAddr, Uint32 funcArg,
N  Uint32 ccMask, Uint32 ieMask);
NCSLAPI void IRQ_getConfig(Uint32 eventId, IRQ_Config *config);
Xextern far void IRQ_getConfig(Uint32 eventId, IRQ_Config *config);
NCSLAPI Uint32 IRQ_getArg(Uint32 eventId);
Xextern far Uint32 IRQ_getArg(Uint32 eventId);
NCSLAPI void IRQ_setArg(Uint32 eventId, Uint32 arg);
Xextern far void IRQ_setArg(Uint32 eventId, Uint32 arg);
N
N
N/******************************************************************************\
N* inline function declarations
X
N\******************************************************************************/
NIDECL void IRQ_enable(Uint32 eventId);
Xextern far void IRQ_enable(Uint32 eventId);
NIDECL Uint32 IRQ_disable(Uint32 eventId);
Xextern far Uint32 IRQ_disable(Uint32 eventId);
NIDECL void IRQ_restore(Uint32 eventId, Uint32 ie);
Xextern far void IRQ_restore(Uint32 eventId, Uint32 ie);
NIDECL void IRQ_set(Uint32 eventId);
Xextern far void IRQ_set(Uint32 eventId);
NIDECL void IRQ_clear(Uint32 eventId);
Xextern far void IRQ_clear(Uint32 eventId);
NIDECL Uint32 IRQ_test(Uint32 eventId);
Xextern far Uint32 IRQ_test(Uint32 eventId);
NIDECL void IRQ_reset(Uint32 eventId);
Xextern far void IRQ_reset(Uint32 eventId);
NIDECL void IRQ_resetAll();
Xextern far void IRQ_resetAll();
N
NIDECL void IRQ_globalEnable();
Xextern far void IRQ_globalEnable();
NIDECL Uint32 IRQ_globalDisable();
Xextern far Uint32 IRQ_globalDisable();
NIDECL void IRQ_globalRestore(Uint32 gie);
Xextern far void IRQ_globalRestore(Uint32 gie);
N
NIDECL void IRQ_nmiEnable();
Xextern far void IRQ_nmiEnable();
NIDECL void IRQ_nmiDisable();
Xextern far void IRQ_nmiDisable();
N
N
N/******************************************************************************\
N* inline function definitions
X
N\******************************************************************************/
N#ifdef USEDEFS
S/*----------------------------------------------------------------------------*/
SIDEF void IRQ_enable(Uint32 eventId) {
S  IER |= _IRQ_eventTable[eventId];
S}
S/*----------------------------------------------------------------------------*/
SIDEF Uint32 IRQ_disable(Uint32 eventId) {
S  Uint32 ie = IER & _IRQ_eventTable[eventId];
S  IER &= ~_IRQ_eventTable[eventId];
S  return ie;
S}
S/*----------------------------------------------------------------------------*/
SIDEF void IRQ_restore(Uint32 eventId, Uint32 ie) {
S  if (ie) {
S    IER |= _IRQ_eventTable[eventId];
S  } else {
S    IER &= ~_IRQ_eventTable[eventId];
S  }
S}
S/*----------------------------------------------------------------------------*/
SIDEF void IRQ_set(Uint32 eventId) {
S  ISR = _IRQ_eventTable[eventId];
S}
S/*----------------------------------------------------------------------------*/
SIDEF void IRQ_clear(Uint32 eventId) {
S  ICR = _IRQ_eventTable[eventId];
S}
S/*----------------------------------------------------------------------------*/
SIDEF Uint32 IRQ_test(Uint32 eventId) {
S  return (Uint32)((IFR & _IRQ_eventTable[eventId]) ? 1 : 0);
S}
S/*----------------------------------------------------------------------------*/
SIDEF void IRQ_globalEnable() {
S  CHIP_FSET(CSR,GIE,1);
S}
S/*----------------------------------------------------------------------------*/
SIDEF Uint32 IRQ_globalDisable() {
S  Uint32 gie = CHIP_FGET(CSR,GIE);
S  CHIP_FSET(CSR,GIE,0);
S  return gie;
S}
S/*----------------------------------------------------------------------------*/
SIDEF void IRQ_globalRestore(Uint32 gie) {
S  CHIP_FSET(CSR,GIE,gie);
S}
S/*----------------------------------------------------------------------------*/
SIDEF void IRQ_reset(Uint32 eventId) {
S  IER &= ~_IRQ_eventTable[eventId];
S  ICR = _IRQ_eventTable[eventId];
S}
S/*----------------------------------------------------------------------------*/
SIDEF void IRQ_resetAll() {
S  CHIP_FSET(CSR,GIE,0);
S  CHIP_CRSET(IER,0x00000000);
S  CHIP_CRSET(ICR,0xFFFFFFFF);
S}
S/*----------------------------------------------------------------------------*/
SIDEF void IRQ_nmiEnable() {
S  IER |= 0x00000002;
S}
S/*----------------------------------------------------------------------------*/
SIDEF void IRQ_nmiDisable() {
S  IER &= ~0x00000002;
S}
S/*----------------------------------------------------------------------------*/
N#endif /* USEDEFS */
N
N
N#endif /* IRQ_SUPPORT */
N#endif /* _CSL_IRQ_H_ */
N/******************************************************************************\
N* End of csl_irq.h
X
N\******************************************************************************/
N
L 22 "E:/TI_workspase/c6701_t/csl/csl.h" 2
N#include <csl_timer.h>
L 1 "E:/TI_workspase/c6701_t/csl/csl_timer.h" 1
N/******************************************************************************\
N*           Copyright (C) 1999-2000 Texas Instruments Incorporated.
X
N*                           All Rights Reserved
N*------------------------------------------------------------------------------
N* FILENAME...... csl_timer.h
N* DATE CREATED.. 06/20/1999 
N* LAST MODIFIED. 07/24/2004   Re-introduced BIOS dependency due to compatibilty issues
N*                02/09/2004   Removed bios related items 
N*                10/03/2000
N\******************************************************************************/
N#ifndef _CSL_TIMER_H_
N#define _CSL_TIMER_H_
N
N#include <csl_chip.h> 
N#include <csl_irq.h>
N#include <csl_timerhal.h>
L 1 "E:/TI_workspase/c6701_t/csl/csl_timerhal.h" 1
N/******************************************************************************\
N*           Copyright (C) 2000 Texas Instruments Incorporated.
X
N*                           All Rights Reserved
N*------------------------------------------------------------------------------
N* FILENAME...... csl_timerhal.h
N* DATE CREATED.. 08/14/2000
N* LAST MODIFIED. 08/02/2004 - Adding support for C6418
N*                09/30/2003  Added SPND field description macros for CTL reg.
N*                10/03/2000
N*------------------------------------------------------------------------------
N* REGISTERS
N*
N* CTL0  - timer control register 0
N* CTL1  - timer control register 1
N* CTL2  - timer control register 2 (1)
N* PRD0  - timer period register 0
N* PRD1  - timer period register 1
N* PRD2  - timer period register 2 (1)
N* CNT0  - timer count register 0
N* CNT1  - timer count register 1
N* CNT2  - timer count register 2 (1)
N*
N* (1) - only supported on C64x devices
N*
N\******************************************************************************/
N#ifndef _CSL_TIMERHAL_H_
N#define _CSL_TIMERHAL_H_
N
N#include <csl_stdinc.h>
N#include <csl_chip.h>
N
N#if (TIMER_SUPPORT)
X#if (( ( 1*0) | ( 1*0) | ( 1*0) | ( 1*0) | ( 1*0) | ( 1*0) | ( 1*1) | ( 1*0) | ( 1*0) | ( 1*0) | ( 1*0)| ( 1*0)| ( 1*0)| ( 1*0)| ( 1*0) | ( 1*0) | ( 1*0) | ( 1*0) | ( 1*0) | ( 1*0) | ( 1*0) | ( 1*0) | ( 1*0) | ( 1*0) | ( 0*0) ))
N/******************************************************************************\
N* MISC section
X
N\******************************************************************************/
N
N#if (CHIP_6414 | CHIP_6415 | CHIP_6416 | CHIP_DM642 | CHIP_DM641 | CHIP_DM640 | CHIP_6412 | CHIP_6411 | CHIP_6410 | CHIP_6413 | CHIP_6418)
X#if (0 | 0 | 0 | 0 | 0 | 0 | 0 | 0 | 0 | 0 | 0)
S  #define TIMER_DEVICE_CNT  3
S  #define _TIMER_BASE_DEV0  0x01940000u
S  #define _TIMER_BASE_DEV1  0x01980000u
S  #define _TIMER_BASE_DEV2  0x01AC0000u
N#else
N  #define TIMER_DEVICE_CNT  2
N  #define _TIMER_BASE_DEV0  0x01940000u
N  #define _TIMER_BASE_DEV1  0x01980000u
N#endif
N
N
N/******************************************************************************\
N* module level register/field access macros
X
N\******************************************************************************/
N
N  /* ----------------- */
N  /* FIELD MAKE MACROS */
N  /* ----------------- */
N
N  #define TIMER_FMK(REG,FIELD,x)\
N    _PER_FMK(TIMER,##REG,##FIELD,x)
X  #define TIMER_FMK(REG,FIELD,x)    _PER_FMK(TIMER,##REG,##FIELD,x)
N
N  #define TIMER_FMKS(REG,FIELD,SYM)\
N    _PER_FMKS(TIMER,##REG,##FIELD,##SYM)
X  #define TIMER_FMKS(REG,FIELD,SYM)    _PER_FMKS(TIMER,##REG,##FIELD,##SYM)
N
N
N  /* -------------------------------- */
N  /* RAW REGISTER/FIELD ACCESS MACROS */
N  /* -------------------------------- */
N
N  #define TIMER_ADDR(REG)\
N    _TIMER_##REG##_ADDR
X  #define TIMER_ADDR(REG)    _TIMER_##REG##_ADDR
N
N  #define TIMER_RGET(REG)\
N    _PER_RGET(_TIMER_##REG##_ADDR,TIMER,##REG)
X  #define TIMER_RGET(REG)    _PER_RGET(_TIMER_##REG##_ADDR,TIMER,##REG)
N
N  #define TIMER_RSET(REG,x)\
N    _PER_RSET(_TIMER_##REG##_ADDR,TIMER,##REG,x)
X  #define TIMER_RSET(REG,x)    _PER_RSET(_TIMER_##REG##_ADDR,TIMER,##REG,x)
N
N  #define TIMER_FGET(REG,FIELD)\
N    _TIMER_##REG##_FGET(##FIELD)
X  #define TIMER_FGET(REG,FIELD)    _TIMER_##REG##_FGET(##FIELD)
N
N  #define TIMER_FSET(REG,FIELD,x)\
N    _TIMER_##REG##_FSET(##FIELD,##x)
X  #define TIMER_FSET(REG,FIELD,x)    _TIMER_##REG##_FSET(##FIELD,##x)
N
N  #define TIMER_FSETS(REG,FIELD,SYM)\
N    _TIMER_##REG##_FSETS(##FIELD,##SYM)
X  #define TIMER_FSETS(REG,FIELD,SYM)    _TIMER_##REG##_FSETS(##FIELD,##SYM)
N
N
N  /* ------------------------------------------ */
N  /* ADDRESS BASED REGISTER/FIELD ACCESS MACROS */
N  /* ------------------------------------------ */
N
N  #define TIMER_RGETA(addr,REG)\
N    _PER_RGET(addr,TIMER,##REG)
X  #define TIMER_RGETA(addr,REG)    _PER_RGET(addr,TIMER,##REG)
N
N  #define TIMER_RSETA(addr,REG,x)\
N    _PER_RSET(addr,TIMER,##REG,x)
X  #define TIMER_RSETA(addr,REG,x)    _PER_RSET(addr,TIMER,##REG,x)
N
N  #define TIMER_FGETA(addr,REG,FIELD)\
N    _PER_FGET(addr,TIMER,##REG,##FIELD)
X  #define TIMER_FGETA(addr,REG,FIELD)    _PER_FGET(addr,TIMER,##REG,##FIELD)
N
N  #define TIMER_FSETA(addr,REG,FIELD,x)\
N    _PER_FSET(addr,TIMER,##REG,##FIELD,x)
X  #define TIMER_FSETA(addr,REG,FIELD,x)    _PER_FSET(addr,TIMER,##REG,##FIELD,x)
N
N  #define TIMER_FSETSA(addr,REG,FIELD,SYM)\
N    _PER_FSETS(addr,TIMER,##REG,##FIELD,##SYM)
X  #define TIMER_FSETSA(addr,REG,FIELD,SYM)    _PER_FSETS(addr,TIMER,##REG,##FIELD,##SYM)
N
N
N  /* ----------------------------------------- */
N  /* HANDLE BASED REGISTER/FIELD ACCESS MACROS */
N  /* ----------------------------------------- */
N
N  #define TIMER_ADDRH(h,REG)\
N    (Uint32)(&((h)->baseAddr[_TIMER_##REG##_OFFSET]))
X  #define TIMER_ADDRH(h,REG)    (Uint32)(&((h)->baseAddr[_TIMER_##REG##_OFFSET]))
N
N  #define TIMER_RGETH(h,REG)\
N    TIMER_RGETA(TIMER_ADDRH(h,##REG),##REG)
X  #define TIMER_RGETH(h,REG)    TIMER_RGETA(TIMER_ADDRH(h,##REG),##REG)
N
N
N  #define TIMER_RSETH(h,REG,x)\
N    TIMER_RSETA(TIMER_ADDRH(h,##REG),##REG,x)
X  #define TIMER_RSETH(h,REG,x)    TIMER_RSETA(TIMER_ADDRH(h,##REG),##REG,x)
N
N
N  #define TIMER_FGETH(h,REG,FIELD)\
N    TIMER_FGETA(TIMER_ADDRH(h,##REG),##REG,##FIELD)
X  #define TIMER_FGETH(h,REG,FIELD)    TIMER_FGETA(TIMER_ADDRH(h,##REG),##REG,##FIELD)
N
N
N  #define TIMER_FSETH(h,REG,FIELD,x)\
N    TIMER_FSETA(TIMER_ADDRH(h,##REG),##REG,##FIELD,x)
X  #define TIMER_FSETH(h,REG,FIELD,x)    TIMER_FSETA(TIMER_ADDRH(h,##REG),##REG,##FIELD,x)
N
N
N  #define TIMER_FSETSH(h,REG,FIELD,SYM)\
N    TIMER_FSETSA(TIMER_ADDRH(h,##REG),##REG,##FIELD,##SYM)
X  #define TIMER_FSETSH(h,REG,FIELD,SYM)    TIMER_FSETSA(TIMER_ADDRH(h,##REG),##REG,##FIELD,##SYM)
N
N
N
N/******************************************************************************\
N* _____________________
X
N* |                   |
N* |  C T L            |
N* |___________________|
N*
N* CTL0  - timer control register 0
N* CTL1  - timer control register 1
N* CTL2  - timer control register 2 (1)
N*
N* FIELDS (msb -> lsb)
N* (rw) SPND   (1)
N* (r)  TSTAT
N* (rw) INVINP
N* (rw) CLKSRC
N* (rw) CP
N* (rw) HLD
N* (rw) GO
N* (rw) PWID
N* (r)  DATIN
N* (rw) DATOUT
N* (rw) INVOUT
N* (rw) FUNC
N*
N* (1) - only supported on C64x devices
N\******************************************************************************/
N  #define _TIMER_CTL_OFFSET            0
N
N  #define _TIMER_CTL0_ADDR             0x01940000u
N  #define _TIMER_CTL1_ADDR             0x01980000u
N  #if (TIMER_DEVICE_CNT == 3)
X  #if (2 == 3)
S    #define _TIMER_CTL2_ADDR           0x01AC0000u
N  #endif
N
N  #if (C64_SUPPORT)	
X  #if (( ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*1) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0)| ( 1*0)| ( 1*0)| ( 1*0)| ( 1*0) | ( 1*0) | ( 1*0) | ( 1*0) | ( 0*0) | ( 0*0) | ( 1*0) | ( 1*0) | ( 1*0) | ( 1*0) | ( 0*0) ))	
S	#define _TIMER_CTL_SPND_MASK         0x00008000u
S	#define _TIMER_CTL_SPND_SHIFT        0x0000000Fu
S	#define TIMER_CTL_SPND_DEFAULT       0x00000000u
S	#define TIMER_CTL_SPND_OF(x)         _VALUEOF(x)
S	#define TIMER_CTL_SPND_EMUSTOP       0x00000001u
S	#define TIMER_CTL_SPND_EMURUN        0x00000000u	
N  #endif
N	
N  #define _TIMER_CTL_TSTAT_MASK        0x00000800u
N  #define _TIMER_CTL_TSTAT_SHIFT       0x0000000Bu
N  #define  TIMER_CTL_TSTAT_DEFAULT     0x00000000u
N  #define  TIMER_CTL_TSTAT_OF(x)       _VALUEOF(x)
N  #define  TIMER_CTL_TSTAT_0           0x00000000u
N  #define  TIMER_CTL_TSTAT_1           0x00000001u
N
N  #define _TIMER_CTL_INVINP_MASK       0x00000400u
N  #define _TIMER_CTL_INVINP_SHIFT      0x0000000Au
N  #define  TIMER_CTL_INVINP_DEFAULT    0x00000000u
N  #define  TIMER_CTL_INVINP_OF(x)      _VALUEOF(x)
N  #define  TIMER_CTL_INVINP_NO         0x00000000u
N  #define  TIMER_CTL_INVINP_YES        0x00000001u
N
N  #define _TIMER_CTL_CLKSRC_MASK       0x00000200u
N  #define _TIMER_CTL_CLKSRC_SHIFT      0x00000009u
N  #define  TIMER_CTL_CLKSRC_DEFAULT    0x00000000u
N  #define  TIMER_CTL_CLKSRC_OF(x)      _VALUEOF(x)
N  #define  TIMER_CTL_CLKSRC_EXTERNAL   0x00000000u
N  #if (C64_SUPPORT)
X  #if (( ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*1) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0)| ( 1*0)| ( 1*0)| ( 1*0)| ( 1*0) | ( 1*0) | ( 1*0) | ( 1*0) | ( 0*0) | ( 0*0) | ( 1*0) | ( 1*0) | ( 1*0) | ( 1*0) | ( 0*0) ))
S    #define  TIMER_CTL_CLKSRC_CPUOVR8    0x00000001u
N  #else
N    #define  TIMER_CTL_CLKSRC_CPUOVR4    0x00000001u
N  #endif
N
N  #define _TIMER_CTL_CP_MASK           0x00000100u
N  #define _TIMER_CTL_CP_SHIFT          0x00000008u
N  #define  TIMER_CTL_CP_DEFAULT        0x00000000u
N  #define  TIMER_CTL_CP_OF(x)          _VALUEOF(x)
N  #define  TIMER_CTL_CP_PULSE          0x00000000u
N  #define  TIMER_CTL_CP_CLOCK          0x00000001u
N
N  #define _TIMER_CTL_HLD_MASK          0x00000080u
N  #define _TIMER_CTL_HLD_SHIFT         0x00000007u
N  #define  TIMER_CTL_HLD_DEFAULT       0x00000000u
N  #define  TIMER_CTL_HLD_OF(x)         _VALUEOF(x)
N  #define  TIMER_CTL_HLD_YES           0x00000000u
N  #define  TIMER_CTL_HLD_NO            0x00000001u
N
N  #define _TIMER_CTL_GO_MASK           0x00000040u
N  #define _TIMER_CTL_GO_SHIFT          0x00000006u
N  #define  TIMER_CTL_GO_DEFAULT        0x00000000u
N  #define  TIMER_CTL_GO_OF(x)          _VALUEOF(x)
N  #define  TIMER_CTL_GO_NO             0x00000000u
N  #define  TIMER_CTL_GO_YES            0x00000001u
N
N  #define _TIMER_CTL_PWID_MASK         0x00000010u
N  #define _TIMER_CTL_PWID_SHIFT        0x00000004u
N  #define  TIMER_CTL_PWID_DEFAULT      0x00000000u
N  #define  TIMER_CTL_PWID_OF(x)        _VALUEOF(x)
N  #define  TIMER_CTL_PWID_ONE          0x00000000u
N  #define  TIMER_CTL_PWID_TWO          0x00000001u
N
N  #define _TIMER_CTL_DATIN_MASK        0x00000008u
N  #define _TIMER_CTL_DATIN_SHIFT       0x00000003u
N  #define  TIMER_CTL_DATIN_DEFAULT     0x00000000u
N  #define  TIMER_CTL_DATIN_OF(x)       _VALUEOF(x)
N  #define  TIMER_CTL_DATIN_0           0x00000000u
N  #define  TIMER_CTL_DATIN_1           0x00000001u
N
N  #define _TIMER_CTL_DATOUT_MASK       0x00000004u
N  #define _TIMER_CTL_DATOUT_SHIFT      0x00000002u
N  #define  TIMER_CTL_DATOUT_DEFAULT    0x00000000u
N  #define  TIMER_CTL_DATOUT_OF(x)      _VALUEOF(x)
N  #define  TIMER_CTL_DATOUT_0          0x00000000u
N  #define  TIMER_CTL_DATOUT_1          0x00000001u
N
N  #define _TIMER_CTL_INVOUT_MASK       0x00000002u
N  #define _TIMER_CTL_INVOUT_SHIFT      0x00000001u
N  #define  TIMER_CTL_INVOUT_DEFAULT    0x00000000u
N  #define  TIMER_CTL_INVOUT_OF(x)      _VALUEOF(x)
N  #define  TIMER_CTL_INVOUT_NO         0x00000000u
N  #define  TIMER_CTL_INVOUT_YES        0x00000001u
N
N  #define _TIMER_CTL_FUNC_MASK         0x00000001u
N  #define _TIMER_CTL_FUNC_SHIFT        0x00000000u
N  #define  TIMER_CTL_FUNC_DEFAULT      0x00000000u
N  #define  TIMER_CTL_FUNC_OF(x)        _VALUEOF(x)
N  #define  TIMER_CTL_FUNC_GPIO         0x00000000u
N  #define  TIMER_CTL_FUNC_TOUT         0x00000001u
N
N  #define  TIMER_CTL_OF(x)             _VALUEOF(x)
N
N  #if (C64_SUPPORT)
X  #if (( ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*1) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0)| ( 1*0)| ( 1*0)| ( 1*0)| ( 1*0) | ( 1*0) | ( 1*0) | ( 1*0) | ( 0*0) | ( 0*0) | ( 1*0) | ( 1*0) | ( 1*0) | ( 1*0) | ( 0*0) ))
S	#define TIMER_CTL_DEFAULT (Uint32)( \
S		_PER_FDEFAULT(TIMER,CTL,SPND) \
S		|_PER_FDEFAULT(TIMER,CTL,TSTAT) \
S		|_PER_FDEFAULT(TIMER,CTL,INVINP) \
S		|_PER_FDEFAULT(TIMER,CTL,CLKSRC) \
S		|_PER_FDEFAULT(TIMER,CTL,CP) \
S		|_PER_FDEFAULT(TIMER,CTL,HLD) \
S		|_PER_FDEFAULT(TIMER,CTL,GO) \
S		|_PER_FDEFAULT(TIMER,CTL,PWID) \
S		|_PER_FDEFAULT(TIMER,CTL,DATIN) \
S		|_PER_FDEFAULT(TIMER,CTL,DATOUT) \
S		|_PER_FDEFAULT(TIMER,CTL,INVOUT) \
S		|_PER_FDEFAULT(TIMER,CTL,FUNC) \
S	)
X	#define TIMER_CTL_DEFAULT (Uint32)( 		_PER_FDEFAULT(TIMER,CTL,SPND) 		|_PER_FDEFAULT(TIMER,CTL,TSTAT) 		|_PER_FDEFAULT(TIMER,CTL,INVINP) 		|_PER_FDEFAULT(TIMER,CTL,CLKSRC) 		|_PER_FDEFAULT(TIMER,CTL,CP) 		|_PER_FDEFAULT(TIMER,CTL,HLD) 		|_PER_FDEFAULT(TIMER,CTL,GO) 		|_PER_FDEFAULT(TIMER,CTL,PWID) 		|_PER_FDEFAULT(TIMER,CTL,DATIN) 		|_PER_FDEFAULT(TIMER,CTL,DATOUT) 		|_PER_FDEFAULT(TIMER,CTL,INVOUT) 		|_PER_FDEFAULT(TIMER,CTL,FUNC) 	)
N  #else
N	#define TIMER_CTL_DEFAULT (Uint32)( \
N		_PER_FDEFAULT(TIMER,CTL,TSTAT) \
N		|_PER_FDEFAULT(TIMER,CTL,INVINP) \
N		|_PER_FDEFAULT(TIMER,CTL,CLKSRC) \
N		|_PER_FDEFAULT(TIMER,CTL,CP) \
N		|_PER_FDEFAULT(TIMER,CTL,HLD) \
N		|_PER_FDEFAULT(TIMER,CTL,GO) \
N		|_PER_FDEFAULT(TIMER,CTL,PWID) \
N		|_PER_FDEFAULT(TIMER,CTL,DATIN) \
N		|_PER_FDEFAULT(TIMER,CTL,DATOUT) \
N		|_PER_FDEFAULT(TIMER,CTL,INVOUT) \
N		|_PER_FDEFAULT(TIMER,CTL,FUNC) \
N	)
X	#define TIMER_CTL_DEFAULT (Uint32)( 		_PER_FDEFAULT(TIMER,CTL,TSTAT) 		|_PER_FDEFAULT(TIMER,CTL,INVINP) 		|_PER_FDEFAULT(TIMER,CTL,CLKSRC) 		|_PER_FDEFAULT(TIMER,CTL,CP) 		|_PER_FDEFAULT(TIMER,CTL,HLD) 		|_PER_FDEFAULT(TIMER,CTL,GO) 		|_PER_FDEFAULT(TIMER,CTL,PWID) 		|_PER_FDEFAULT(TIMER,CTL,DATIN) 		|_PER_FDEFAULT(TIMER,CTL,DATOUT) 		|_PER_FDEFAULT(TIMER,CTL,INVOUT) 		|_PER_FDEFAULT(TIMER,CTL,FUNC) 	)
N  #endif
N  
N  #if (C64_SUPPORT)
X  #if (( ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*1) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0)| ( 1*0)| ( 1*0)| ( 1*0)| ( 1*0) | ( 1*0) | ( 1*0) | ( 1*0) | ( 0*0) | ( 0*0) | ( 1*0) | ( 1*0) | ( 1*0) | ( 1*0) | ( 0*0) ))
S	#define TIMER_CTL_RMK(spnd,invinp,clksrc,cp,hld,go,pwid,datout,invout,func) \
S		(Uint32)( \
S		_PER_FMK(TIMER,CTL,SPND,spnd) \
S		|_PER_FMK(TIMER,CTL,INVINP,invinp) \
S		|_PER_FMK(TIMER,CTL,CLKSRC,clksrc) \
S		|_PER_FMK(TIMER,CTL,CP,cp) \
S		|_PER_FMK(TIMER,CTL,HLD,hld) \
S		|_PER_FMK(TIMER,CTL,GO,go) \
S		|_PER_FMK(TIMER,CTL,PWID,pwid) \
S		|_PER_FMK(TIMER,CTL,DATOUT,datout) \
S		|_PER_FMK(TIMER,CTL,INVOUT,invout) \
S		|_PER_FMK(TIMER,CTL,FUNC,func) \
S	)
X	#define TIMER_CTL_RMK(spnd,invinp,clksrc,cp,hld,go,pwid,datout,invout,func) 		(Uint32)( 		_PER_FMK(TIMER,CTL,SPND,spnd) 		|_PER_FMK(TIMER,CTL,INVINP,invinp) 		|_PER_FMK(TIMER,CTL,CLKSRC,clksrc) 		|_PER_FMK(TIMER,CTL,CP,cp) 		|_PER_FMK(TIMER,CTL,HLD,hld) 		|_PER_FMK(TIMER,CTL,GO,go) 		|_PER_FMK(TIMER,CTL,PWID,pwid) 		|_PER_FMK(TIMER,CTL,DATOUT,datout) 		|_PER_FMK(TIMER,CTL,INVOUT,invout) 		|_PER_FMK(TIMER,CTL,FUNC,func) 	)
N  #else
N	#define TIMER_CTL_RMK(invinp,clksrc,cp,hld,go,pwid,datout,invout,func) \
N		(Uint32)( \
N		_PER_FMK(TIMER,CTL,INVINP,invinp) \
N		|_PER_FMK(TIMER,CTL,CLKSRC,clksrc) \
N		|_PER_FMK(TIMER,CTL,CP,cp) \
N		|_PER_FMK(TIMER,CTL,HLD,hld) \
N		|_PER_FMK(TIMER,CTL,GO,go) \
N		|_PER_FMK(TIMER,CTL,PWID,pwid) \
N		|_PER_FMK(TIMER,CTL,DATOUT,datout) \
N		|_PER_FMK(TIMER,CTL,INVOUT,invout) \
N		|_PER_FMK(TIMER,CTL,FUNC,func) \
N	)
X	#define TIMER_CTL_RMK(invinp,clksrc,cp,hld,go,pwid,datout,invout,func) 		(Uint32)( 		_PER_FMK(TIMER,CTL,INVINP,invinp) 		|_PER_FMK(TIMER,CTL,CLKSRC,clksrc) 		|_PER_FMK(TIMER,CTL,CP,cp) 		|_PER_FMK(TIMER,CTL,HLD,hld) 		|_PER_FMK(TIMER,CTL,GO,go) 		|_PER_FMK(TIMER,CTL,PWID,pwid) 		|_PER_FMK(TIMER,CTL,DATOUT,datout) 		|_PER_FMK(TIMER,CTL,INVOUT,invout) 		|_PER_FMK(TIMER,CTL,FUNC,func) 	)
N  #endif
N		
N		
N  #define _TIMER_CTL_FGET(N,FIELD)\
N    _PER_FGET(_TIMER_CTL##N##_ADDR,TIMER,CTL,##FIELD)
X  #define _TIMER_CTL_FGET(N,FIELD)    _PER_FGET(_TIMER_CTL##N##_ADDR,TIMER,CTL,##FIELD)
N
N  #define _TIMER_CTL_FSET(N,FIELD,f)\
N    _PER_FSET(_TIMER_CTL##N##_ADDR,TIMER,CTL,##FIELD,f)
X  #define _TIMER_CTL_FSET(N,FIELD,f)    _PER_FSET(_TIMER_CTL##N##_ADDR,TIMER,CTL,##FIELD,f)
N
N  #define _TIMER_CTL_FSETS(N,FIELD,SYM)\
N    _PER_FSETS(_TIMER_CTL##N##_ADDR,TIMER,CTL,##FIELD,##SYM)
X  #define _TIMER_CTL_FSETS(N,FIELD,SYM)    _PER_FSETS(_TIMER_CTL##N##_ADDR,TIMER,CTL,##FIELD,##SYM)
N
N  #define _TIMER_CTL0_FGET(FIELD) _TIMER_CTL_FGET(0,##FIELD)
N  #define _TIMER_CTL1_FGET(FIELD) _TIMER_CTL_FGET(1,##FIELD)
N  #if  TIMER_DEVICE_CNT == 3
X  #if  2 == 3
S    #define _TIMER_CTL2_FGET(FIELD) _TIMER_CTL_FGET(2,##FIELD)
N  #endif
N
N  #define _TIMER_CTL0_FSET(FIELD,f) _TIMER_CTL_FSET(0,##FIELD,f)
N  #define _TIMER_CTL1_FSET(FIELD,f) _TIMER_CTL_FSET(1,##FIELD,f)
N  #if  TIMER_DEVICE_CNT == 3
X  #if  2 == 3
S    #define _TIMER_CTL2_FSET(FIELD,f) _TIMER_CTL_FSET(2,##FIELD,f)
N  #endif
N
N  #define _TIMER_CTL0_FSETS(FIELD,SYM) _TIMER_CTL_FSETS(0,##FIELD,##SYM)
N  #define _TIMER_CTL1_FSETS(FIELD,SYM) _TIMER_CTL_FSETS(1,##FIELD,##SYM)
N  #if  TIMER_DEVICE_CNT == 3
X  #if  2 == 3
S    #define _TIMER_CTL2_FSETS(FIELD,SYM) _TIMER_CTL_FSETS(2,##FIELD,##SYM)
N  #endif
N
N
N/******************************************************************************\
N* _____________________
X
N* |                   |
N* |  P R D            |
N* |___________________|
N*
N* PRD0  - timer period register 0
N* PRD1  - timer period register 1
N* PRD2  - timer period register 2 (1)
N*
N* (1) - only supported on C64x devices
N*
N* FIELDS (msb -> lsb)
N* (rw) PRD
N*
N\******************************************************************************/
N  #define _TIMER_PRD_OFFSET            1
N
N  #define _TIMER_PRD0_ADDR             0x01940004u
N  #define _TIMER_PRD1_ADDR             0x01980004u
N  #if  TIMER_DEVICE_CNT == 3
X  #if  2 == 3
S    #define _TIMER_PRD2_ADDR           0x01AC0004u
N  #endif
N
N  #define _TIMER_PRD_PRD_MASK          0xFFFFFFFFu
N  #define _TIMER_PRD_PRD_SHIFT         0x00000000u
N  #define  TIMER_PRD_PRD_DEFAULT       0x00000000u
N  #define  TIMER_PRD_PRD_OF(x)         _VALUEOF(x)
N
N  #define  TIMER_PRD_OF(x)             _VALUEOF(x)
N
N  #define TIMER_PRD_DEFAULT (Uint32)( \
N     _PER_FDEFAULT(TIMER,PRD,PRD) \
N  )
X  #define TIMER_PRD_DEFAULT (Uint32)(      _PER_FDEFAULT(TIMER,PRD,PRD)   )
N
N  #define TIMER_PRD_RMK(prd) (Uint32)( \
N     _PER_FMK(TIMER,PRD,PRD,prd) \
N  )
X  #define TIMER_PRD_RMK(prd) (Uint32)(      _PER_FMK(TIMER,PRD,PRD,prd)   )
N
N  #define _TIMER_PRD_FGET(N,FIELD)\
N    _PER_FGET(_TIMER_PRD##N##_ADDR,TIMER,PRD,##FIELD)
X  #define _TIMER_PRD_FGET(N,FIELD)    _PER_FGET(_TIMER_PRD##N##_ADDR,TIMER,PRD,##FIELD)
N
N  #define _TIMER_PRD_FSET(N,FIELD,f)\
N    _PER_FSET(_TIMER_PRD##N##_ADDR,TIMER,PRD,##FIELD,f)
X  #define _TIMER_PRD_FSET(N,FIELD,f)    _PER_FSET(_TIMER_PRD##N##_ADDR,TIMER,PRD,##FIELD,f)
N
N  #define _TIMER_PRD_FSETS(N,FIELD,SYM)\
N    _PER_FSETS(_TIMER_PRD##N##_ADDR,TIMER,PRD,##FIELD,##SYM)
X  #define _TIMER_PRD_FSETS(N,FIELD,SYM)    _PER_FSETS(_TIMER_PRD##N##_ADDR,TIMER,PRD,##FIELD,##SYM)
N
N  #define _TIMER_PRD0_FGET(FIELD) _TIMER_PRD_FGET(0,##FIELD)
N  #define _TIMER_PRD1_FGET(FIELD) _TIMER_PRD_FGET(1,##FIELD)
N  #if  TIMER_DEVICE_CNT == 3
X  #if  2 == 3
S    #define _TIMER_PRD2_FGET(FIELD) _TIMER_PRD_FGET(2,##FIELD)
N  #endif
N
N  #define _TIMER_PRD0_FSET(FIELD,f) _TIMER_PRD_FSET(0,##FIELD,f)
N  #define _TIMER_PRD1_FSET(FIELD,f) _TIMER_PRD_FSET(1,##FIELD,f)
N  #if  TIMER_DEVICE_CNT == 3
X  #if  2 == 3
S    #define _TIMER_PRD2_FSET(FIELD,f) _TIMER_PRD_FSET(2,##FIELD,f)
N  #endif
N
N  #define _TIMER_PRD0_FSETS(FIELD,SYM) _TIMER_PRD_FSETS(0,##FIELD,##SYM)
N  #define _TIMER_PRD1_FSETS(FIELD,SYM) _TIMER_PRD_FSETS(1,##FIELD,##SYM)
N  #if  TIMER_DEVICE_CNT == 3
X  #if  2 == 3
S    #define _TIMER_PRD2_FSETS(FIELD,SYM) _TIMER_PRD_FSETS(2,##FIELD,##SYM)
N  #endif
N
N
N/******************************************************************************\
N* _____________________
X
N* |                   |
N* |  C N T            |
N* |___________________|
N*
N* CNT0  - timer count register 0
N* CNT1  - timer count register 1
N* CNT2  - timer count register 2 (1)
N*
N* (1) - only supported on C64x devices
N*
N* FIELDS (msb -> lsb)
N* (rw) CNT
N*
N\******************************************************************************/
N  #define _TIMER_CNT_OFFSET            2
N
N  #define _TIMER_CNT0_ADDR             0x01940008u
N  #define _TIMER_CNT1_ADDR             0x01980008u
N  #if  TIMER_DEVICE_CNT == 3
X  #if  2 == 3
S    #define _TIMER_CNT2_ADDR           0x01AC0008u
N  #endif
N
N  #define _TIMER_CNT_CNT_MASK          0xFFFFFFFFu
N  #define _TIMER_CNT_CNT_MASK          0xFFFFFFFFu
N  #define _TIMER_CNT_CNT_SHIFT         0x00000000u
N  #define  TIMER_CNT_CNT_DEFAULT       0x00000000u
N  #define  TIMER_CNT_CNT_OF(x)         _VALUEOF(x)
N
N  #define  TIMER_CNT_OF(x)             _VALUEOF(x)
N
N  #define TIMER_CNT_DEFAULT (Uint32)( \
N     _PER_FDEFAULT(TIMER,CNT,CNT) \
N  )
X  #define TIMER_CNT_DEFAULT (Uint32)(      _PER_FDEFAULT(TIMER,CNT,CNT)   )
N
N  #define TIMER_CNT_RMK(cnt) (Uint32)( \
N     _PER_FMK(TIMER,CNT,CNT,cnt) \
N  )
X  #define TIMER_CNT_RMK(cnt) (Uint32)(      _PER_FMK(TIMER,CNT,CNT,cnt)   )
N
N  #define _TIMER_CNT_FGET(N,FIELD)\
N    _PER_FGET(_TIMER_CNT##N##_ADDR,TIMER,CNT,##FIELD)
X  #define _TIMER_CNT_FGET(N,FIELD)    _PER_FGET(_TIMER_CNT##N##_ADDR,TIMER,CNT,##FIELD)
N
N  #define _TIMER_CNT_FSET(N,FIELD,f)\
N    _PER_FSET(_TIMER_CNT##N##_ADDR,TIMER,CNT,##FIELD,f)
X  #define _TIMER_CNT_FSET(N,FIELD,f)    _PER_FSET(_TIMER_CNT##N##_ADDR,TIMER,CNT,##FIELD,f)
N
N  #define _TIMER_CNT_FSETS(N,FIELD,SYM)\
N    _PER_FSETS(_TIMER_CNT##N##_ADDR,TIMER,CNT,##FIELD,##SYM)
X  #define _TIMER_CNT_FSETS(N,FIELD,SYM)    _PER_FSETS(_TIMER_CNT##N##_ADDR,TIMER,CNT,##FIELD,##SYM)
N
N  #define _TIMER_CNT0_FGET(FIELD) _TIMER_CNT_FGET(0,##FIELD)
N  #define _TIMER_CNT1_FGET(FIELD) _TIMER_CNT_FGET(1,##FIELD)
N  #if  TIMER_DEVICE_CNT == 3
X  #if  2 == 3
S    #define _TIMER_CNT2_FGET(FIELD) _TIMER_CNT_FGET(2,##FIELD)
N  #endif
N
N  #define _TIMER_CNT0_FSET(FIELD,f) _TIMER_CNT_FSET(0,##FIELD,f)
N  #define _TIMER_CNT1_FSET(FIELD,f) _TIMER_CNT_FSET(1,##FIELD,f)
N  #if  TIMER_DEVICE_CNT == 3
X  #if  2 == 3
S    #define _TIMER_CNT2_FSET(FIELD,f) _TIMER_CNT_FSET(2,##FIELD,f)
N  #endif
N
N  #define _TIMER_CNT0_FSETS(FIELD,SYM) _TIMER_CNT_FSETS(0,##FIELD,##SYM)
N  #define _TIMER_CNT1_FSETS(FIELD,SYM) _TIMER_CNT_FSETS(1,##FIELD,##SYM)
N  #if  TIMER_DEVICE_CNT == 3
X  #if  2 == 3
S    #define _TIMER_CNT2_FSETS(FIELD,SYM) _TIMER_CNT_FSETS(2,##FIELD,##SYM)
N  #endif
N
N
N/*----------------------------------------------------------------------------*/
N
N#endif /* (TIMER_SUPPORT) */
N#endif /* _CSL_TIMERHAL_H_ */
N/******************************************************************************\
N* End of csl_timerhal.h
X
N\******************************************************************************/
N
L 17 "E:/TI_workspase/c6701_t/csl/csl_timer.h" 2
N
N
N#if (TIMER_SUPPORT)
X#if (( ( 1*0) | ( 1*0) | ( 1*0) | ( 1*0) | ( 1*0) | ( 1*0) | ( 1*1) | ( 1*0) | ( 1*0) | ( 1*0) | ( 1*0)| ( 1*0)| ( 1*0)| ( 1*0)| ( 1*0) | ( 1*0) | ( 1*0) | ( 1*0) | ( 1*0) | ( 1*0) | ( 1*0) | ( 1*0) | ( 1*0) | ( 1*0) | ( 0*0) ))
N/******************************************************************************\
N* scope and inline control macros
X
N\******************************************************************************/
N#ifdef __cplusplus
S#define CSLAPI extern "C" far 
N#else
N#define CSLAPI extern far
N#endif
N
N#undef  USEDEFS
N#undef  IDECL
N#undef  IDEF
N
N#ifdef  _TIMER_MOD_
S  #define IDECL CSLAPI
S  #define USEDEFS
S  #define IDEF
N#else
N  #ifdef  _INLINE
S    #define IDECL static inline
S    #define USEDEFS
S    #define IDEF  static inline
N  #else
N    #define IDECL CSLAPI
N  #endif
N#endif
N
N
N/******************************************************************************\
N* global macro declarations
X
N\******************************************************************************/
N
N/* TIMER_open() flags */
N#define TIMER_OPEN_RESET     (0x00000001)
N
N/* device identifiers for TIMER_open() */
N#define TIMER_DEVANY  (-1)
N#define TIMER_DEV0    (0)
N#define TIMER_DEV1    (1)
N#if (TIMER_DEVICE_CNT > 2)
X#if (2 > 2)
S  #define TIMER_DEV2    (2)
N#endif
N
N
N/******************************************************************************\
N* global typedef declarations
X
N\******************************************************************************/
N
N/* handle structure */
Ntypedef struct {
N  Uint32 allocated;
N  Uint32 eventId;
N  volatile Uint32 *baseAddr;
N} TIMER_Obj, *TIMER_Handle;
N
N/* device configuration structure */
Ntypedef struct {
N  Uint32 ctl;
N  Uint32 prd;
N  Uint32 cnt;
N} TIMER_Config;
N
N
N/******************************************************************************\
N* global variable declarations
X
N\******************************************************************************/
N
N/* predefined deviced handles for legacy - should not be used */
Nextern far TIMER_Handle _TIMER_hDev0;
Nextern far TIMER_Handle _TIMER_hDev1;
Nextern far TIMER_Handle _TIMER_hBios;
N
N
N/******************************************************************************\
N* global function declarations
X
N\******************************************************************************/
NCSLAPI TIMER_Handle TIMER_getBiosHandle(); 
Xextern far TIMER_Handle TIMER_getBiosHandle(); 
N
NCSLAPI void TIMER_reset(TIMER_Handle hTimer);
Xextern far void TIMER_reset(TIMER_Handle hTimer);
NCSLAPI void TIMER_resetAll();
Xextern far void TIMER_resetAll();
N
NCSLAPI TIMER_Handle TIMER_open(int devNum, Uint32 flags);
Xextern far TIMER_Handle TIMER_open(int devNum, Uint32 flags);
NCSLAPI void TIMER_close(TIMER_Handle hTimer);
Xextern far void TIMER_close(TIMER_Handle hTimer);
N
N
N/******************************************************************************\
N* inline function declarations
X
N\******************************************************************************/
NIDECL Uint32 TIMER_getEventId(TIMER_Handle hTimer);
Xextern far Uint32 TIMER_getEventId(TIMER_Handle hTimer);
N
NIDECL void TIMER_start(TIMER_Handle hTimer);
Xextern far void TIMER_start(TIMER_Handle hTimer);
NIDECL void TIMER_pause(TIMER_Handle hTimer);
Xextern far void TIMER_pause(TIMER_Handle hTimer);
NIDECL void TIMER_resume(TIMER_Handle hTimer);
Xextern far void TIMER_resume(TIMER_Handle hTimer);
N
NIDECL Uint32 TIMER_getPeriod(TIMER_Handle hTimer);
Xextern far Uint32 TIMER_getPeriod(TIMER_Handle hTimer);
NIDECL void   TIMER_setPeriod(TIMER_Handle hTimer, Uint32 period);
Xextern far void   TIMER_setPeriod(TIMER_Handle hTimer, Uint32 period);
NIDECL Uint32 TIMER_getCount(TIMER_Handle hTimer);
Xextern far Uint32 TIMER_getCount(TIMER_Handle hTimer);
NIDECL void   TIMER_setCount(TIMER_Handle hTimer, Uint32 count);
Xextern far void   TIMER_setCount(TIMER_Handle hTimer, Uint32 count);
N
NIDECL int  TIMER_getDatIn(TIMER_Handle hTimer);
Xextern far int  TIMER_getDatIn(TIMER_Handle hTimer);
NIDECL void TIMER_setDatOut(TIMER_Handle hTimer, int Val);
Xextern far void TIMER_setDatOut(TIMER_Handle hTimer, int Val);
NIDECL int  TIMER_getTstat(TIMER_Handle hTimer);
Xextern far int  TIMER_getTstat(TIMER_Handle hTimer);
N
NIDECL void TIMER_config(TIMER_Handle hTimer, TIMER_Config *config);
Xextern far void TIMER_config(TIMER_Handle hTimer, TIMER_Config *config);
NIDECL void TIMER_configArgs(TIMER_Handle hTimer, Uint32 ctl, Uint32 prd, 
Xextern far void TIMER_configArgs(TIMER_Handle hTimer, Uint32 ctl, Uint32 prd, 
N  Uint32 cnt);
NIDECL void TIMER_getConfig(TIMER_Handle hTimer, TIMER_Config *config);
Xextern far void TIMER_getConfig(TIMER_Handle hTimer, TIMER_Config *config);
N
N
N/******************************************************************************\
N* inline function definitions
X
N\******************************************************************************/
N#ifdef USEDEFS
S/*----------------------------------------------------------------------------*/
SIDEF Uint32 TIMER_getEventId(TIMER_Handle hTimer) {
S  return hTimer->eventId;
S}
S/*----------------------------------------------------------------------------*/
SIDEF void TIMER_start(TIMER_Handle hTimer) {
S  TIMER_FSETH(hTimer,CTL,HLD,1);
S  TIMER_FSETH(hTimer,CTL,GO,1);
S}
S/*----------------------------------------------------------------------------*/
SIDEF void TIMER_pause(TIMER_Handle hTimer) {
S  TIMER_FSETH(hTimer,CTL,HLD,0);
S}
S/*----------------------------------------------------------------------------*/
SIDEF void TIMER_resume(TIMER_Handle hTimer) {
S  TIMER_FSETH(hTimer,CTL,HLD,1);
S}
S/*----------------------------------------------------------------------------*/
SIDEF int  TIMER_getDatIn(TIMER_Handle hTimer) {
S  return TIMER_FGETH(hTimer,CTL,DATIN);
S}  
S/*----------------------------------------------------------------------------*/
SIDEF void TIMER_setDatOut(TIMER_Handle hTimer, int val) {
S  TIMER_FSETH(hTimer,CTL,DATOUT,val);
S}
S/*----------------------------------------------------------------------------*/
SIDEF int  TIMER_getTstat(TIMER_Handle hTimer) {
S  return TIMER_FGETH(hTimer,CTL,TSTAT);
S}
S/*----------------------------------------------------------------------------*/
SIDEF Uint32 TIMER_getPeriod(TIMER_Handle hTimer) {
S  return TIMER_RGETH(hTimer,PRD);
S}
S/*----------------------------------------------------------------------------*/
SIDEF void TIMER_setPeriod(TIMER_Handle hTimer, Uint32 period) {
S  TIMER_RSETH(hTimer,PRD,period);
S}
S/*----------------------------------------------------------------------------*/
SIDEF Uint32 TIMER_getCount(TIMER_Handle hTimer) {
S  return TIMER_RGETH(hTimer,CNT);
S}
S/*----------------------------------------------------------------------------*/
SIDEF void TIMER_setCount(TIMER_Handle hTimer, Uint32 count) {
S  TIMER_RSETH(hTimer,CNT,count);
S}
S/*----------------------------------------------------------------------------*/
SIDEF void TIMER_config(TIMER_Handle hTimer, TIMER_Config *config) {
S
S  Uint32 gie;
S  volatile Uint32 *base = (volatile Uint32 *)(hTimer->baseAddr);
S  register int x0,x1,x2;
S
S  gie = IRQ_globalDisable();
S
S  x0 = config->ctl;
S  x1 = config->prd;
S  x2 = config->cnt;
S
S  base[_TIMER_CTL_OFFSET] = 0x00000000;
S  base[_TIMER_PRD_OFFSET] = x1;
S  base[_TIMER_CNT_OFFSET] = x2;
S  base[_TIMER_CTL_OFFSET] = x0;
S
S  IRQ_globalRestore(gie);
S}
S/*----------------------------------------------------------------------------*/
SIDEF void TIMER_configArgs(TIMER_Handle hTimer, Uint32 ctl, Uint32 prd,
S  Uint32 cnt){
S
S  Uint32 gie;
S  volatile Uint32 *base = (volatile Uint32 *)(hTimer->baseAddr);
S
S  gie = IRQ_globalDisable();
S
S  base[_TIMER_CTL_OFFSET] = 0x00000000;
S  base[_TIMER_PRD_OFFSET] = prd;
S  base[_TIMER_CNT_OFFSET] = cnt;
S  base[_TIMER_CTL_OFFSET] = ctl;
S
S  IRQ_globalRestore(gie);
S}
S/*----------------------------------------------------------------------------*/
SIDEF void TIMER_getConfig(TIMER_Handle hTimer, TIMER_Config *config) {
S
S  Uint32 gie;
S  volatile Uint32 *base = (volatile Uint32 *)(hTimer->baseAddr);
S  volatile TIMER_Config* cfg = (volatile TIMER_Config*)config;
S  register int x0,x1,x2;
S
S  gie = IRQ_globalDisable();
S
S  x0 = base[_TIMER_CTL_OFFSET];
S  x1 = base[_TIMER_PRD_OFFSET];
S  x2 = base[_TIMER_CNT_OFFSET];
S
S  cfg->ctl = x0;
S  cfg->prd = x1;
S  cfg->cnt = x2;
S
S  IRQ_globalRestore(gie);
S}
S/*----------------------------------------------------------------------------*/
N#endif /* USEDEFS */
N
N
N#endif /* TIMER_SUPPORT */
N#endif /* _CSL_TIMER_H_ */
N/******************************************************************************\
N* End of csl_timer.h
X
N\******************************************************************************/
N
L 23 "E:/TI_workspase/c6701_t/csl/csl.h" 2
N
N
N/******************************************************************************\
N* scope and inline control macros
X
N\******************************************************************************/
N#ifdef __cplusplus
S#define CSLAPI extern "C" far 
N#else
N#define CSLAPI extern far
N#endif
N
N#undef  USEDEFS
N#undef  IDECL
N#undef  IDEF
N
N#ifdef  _CSL_MOD_
S  #define IDECL CSLAPI
S  #define USEDEFS
S  #define IDEF
N#else
N  #ifdef  _INLINE
S    #define IDECL static inline
S    #define USEDEFS
S    #define IDEF  static inline
N  #else
N    #define IDECL CSLAPI
N  #endif
N#endif
N
N
N/******************************************************************************\
N* global macro declarations
X
N\******************************************************************************/
N
N
N/******************************************************************************\
N* global typedef declarations
X
N\******************************************************************************/
N
N/* if this structure changes, be sure to also change it in csl_irq_.asm */
Ntypedef union {
N  struct {
N    Uint32 biosPresent;
N    _IRQ_Dispatch *dispatchTable;
N    Uint32 timerUsed;
N    Uint32 timerNum;
N  } args;
N  struct {
N    TIMER_Handle hTimer;
N    Uint32 *event2IntTbl;
N    Uint32 *int2EventTbl;
N  } ret;
N} _CSL_Config;
N/******************************************************************************\
N* global variable declarations
X
N\******************************************************************************/
N
N/******************************************************************************\
N* global function declarations
X
N\******************************************************************************/
NCSLAPI void _CSL_init(_CSL_Config *config);
Xextern far void _CSL_init(_CSL_Config *config);
N
NCSLAPI void CSL6201_LIB_();
Xextern far void CSL6201_LIB_();
NCSLAPI void CSL6202_LIB_();
Xextern far void CSL6202_LIB_();
NCSLAPI void CSL6203_LIB_();
Xextern far void CSL6203_LIB_();
NCSLAPI void CSL6204_LIB_();
Xextern far void CSL6204_LIB_();
NCSLAPI void CSL6205_LIB_();
Xextern far void CSL6205_LIB_();
NCSLAPI void CSL6211_LIB_();
Xextern far void CSL6211_LIB_();
NCSLAPI void CSL6701_LIB_();
Xextern far void CSL6701_LIB_();
NCSLAPI void CSL6711_LIB_();
Xextern far void CSL6711_LIB_();
NCSLAPI void CSL6712_LIB_();
Xextern far void CSL6712_LIB_();
NCSLAPI void CSL6713_LIB_();
Xextern far void CSL6713_LIB_();
NCSLAPI void CSLDA610_LIB_();
Xextern far void CSLDA610_LIB_();
NCSLAPI void CSLDM642_LIB_();
Xextern far void CSLDM642_LIB_();
NCSLAPI void CSLDM640_LIB_();
Xextern far void CSLDM640_LIB_();
NCSLAPI void CSLDM641_LIB_();
Xextern far void CSLDM641_LIB_();
NCSLAPI void CSL6412_LIB_();
Xextern far void CSL6412_LIB_();
NCSLAPI void CSL6414_LIB_();
Xextern far void CSL6414_LIB_();
NCSLAPI void CSL6415_LIB_();
Xextern far void CSL6415_LIB_();
NCSLAPI void CSL6416_LIB_();
Xextern far void CSL6416_LIB_();
NCSLAPI void CSL6711C_LIB_();
Xextern far void CSL6711C_LIB_();
NCSLAPI void CSL6712C_LIB_();
Xextern far void CSL6712C_LIB_();
NCSLAPI void CSL6411_LIB_();
Xextern far void CSL6411_LIB_();
N/* next two options are DRI300 versions */
NCSLAPI void CSL6410_LIB_();
Xextern far void CSL6410_LIB_();
NCSLAPI void CSL6413_LIB_();
Xextern far void CSL6413_LIB_();
NCSLAPI void CSL6418_LIB_();
Xextern far void CSL6418_LIB_();
N
N/******************************************************************************\
N* inline function declarations
X
N\******************************************************************************/
N
N
N/******************************************************************************\
N* special inline function
X
N\******************************************************************************/
N
N/* This function checks to make sure that the correct library is being */
N/* linked in compared to the CHIP_XXXX definition.                     */
N
Nstatic inline void CSL_init() {
N
N  #if (CHIP_6201)
X  #if (0)
S    CSL6201_LIB_();
S  #elif (CHIP_6202)
X  #elif (0)
S    CSL6202_LIB_();
S  #elif (CHIP_6203)
X  #elif (0)
S    CSL6203_LIB_();
S  #elif (CHIP_6204)
X  #elif (0)
S    CSL6204_LIB_();
S  #elif (CHIP_6205)
X  #elif (0)
S    CSL6205_LIB_();
S  #elif (CHIP_6211)
X  #elif (0)
S    CSL6211_LIB_();
N   #elif (CHIP_6701)
X   #elif (1)
N    CSL6701_LIB_();
N  #elif (CHIP_6711)
S    CSL6711_LIB_();
S  #elif (CHIP_6712)
S    CSL6712_LIB_();
S  #elif (CHIP_6713)
S    CSL6713_LIB_();
S  #elif (CHIP_DA610)
S    CSLDA610_LIB_();
S  #elif (CHIP_DM642)
S    CSLDM642_LIB_();
S  #elif (CHIP_DM640)
S    CSLDM640_LIB_();
S  #elif (CHIP_DM641)
S    CSLDM641_LIB_();
S  #elif (CHIP_6412)
S    CSL6412_LIB_();
S  #elif (CHIP_6414)
S    CSL6414_LIB_();
S  #elif (CHIP_6415)
S    CSL6415_LIB_();
S #elif (CHIP_6416)
S    CSL6416_LIB_();
S #elif (CHIP_6711C)
S    CSL6711C_LIB_();    
S #elif (CHIP_6712C)
S    CSL6712C_LIB_();
S #elif (CHIP_6411)
S    CSL6411_LIB_();
S/* next three are DRI300 versions */
S #elif (CHIP_6410)
S    CSL6410_LIB_();
S #elif (CHIP_6413)
S    CSL6413_LIB_();
S #elif (CHIP_6418)
S    CSL6418_LIB_();
N #endif
N
N  _CSL_init((_CSL_Config*)INV);
X  _CSL_init((_CSL_Config*)((void*)(-1)));
N}
N
N/*----------------------------------------------------------------------------*/
N
N
N/******************************************************************************\
N* inline function definitions
X
N\******************************************************************************/
N#ifdef USEDEFS
S/*----------------------------------------------------------------------------*/
S/*----------------------------------------------------------------------------*/
S/*----------------------------------------------------------------------------*/
N#endif /* USEDEFS */
N
N
N#endif /* _CSL_H_ */
N/******************************************************************************\
N* End of csl.h
X
N\******************************************************************************/
N
L 21 "E:/TI_workspase/c6701_t/csl/csl_emac.h" 2
N
N#include <csl_mdio.h>
L 1 "E:/TI_workspase/c6701_t/csl/csl_mdio.h" 1
N/*****************************************************************************\
N*           Copyright (C) 1999-2003 Texas Instruments Incorporated.
X
N*                           All Rights Reserved
N*------------------------------------------------------------------------------
N* FILENAME...... csl_mdio.h
N* DATE CREATED.. 02/08/2002
N* LAST MODIFIED. 05/09/2003
N*------------------------------------------------------------------------------
N* NOTE:
N*   When used in an multitasking environment, no MDIO function may be
N*   called while another MDIO function is operating on the same device
N*   handle in another thread. It is the responsibility of the application
N*   to assure adherence to this restriction.
N*
N* ALSO NOTE:
N*   When using the CSL EMAC module, the EMAC module will make use of this
N*   MDIO module. It is not necessary for the application to call any MDIO
N*   functions directly when the CSL EMAC module is in use.
N*
N\******************************************************************************/
N#ifndef _CSL_MDIO_H
N#define _CSL_MDIO_H_
N
N#include <csl.h>
N#include <csl_chip.h>
N#include <csl_irq.h>
N#include <csl_mdiohal.h>
L 1 "E:/TI_workspase/c6701_t/csl/csl_mdiohal.h" 1
N/*****************************************************************************\
N*           Copyright (C) 1999-2003 Texas Instruments Incorporated.
X
N*                           All Rights Reserved
N*------------------------------------------------------------------------------
N* FILENAME...... csl_mdiohal.h
N* DATE CREATED.. 02/08/2002
N* LAST MODIFIED. 03/05/2003
N*------------------------------------------------------------------------------
N* REGISTERS/PARAMETERS
N*
N* VERSION           - Module Version Register
N* CONTROL           - Module Control Register
N* ALIVE             - PHY "Alive" Indication Register
N* LINK              - PHY Link Status Register
N* LINKINTRAW        - Link Status Change Interrupt Register
N* LINKINTMASKED     - Link Status Change Interrupt Register (Masked)
N* USERINTRAW        - User Command Complete Interrupt
N* USERINTMASKED     - User Command Complete Interrupt (Masked)
N* USERINTMASKSET    - Enable User Command Complete Interrupt Mask
N* USERINTMASKCLEAR  - Disable User Command Complete Interrupt Mask
N* USERACCESS0       - User Access Register 0
N* USERPHYSEL0       - User PHY Select Register 0
N* USERACCESS1       - User Access Register 1
N* USERPHYSEL1       - User PHY Select Register 1
N*
N*\******************************************************************************/
N#ifndef _CSL_MDIOHAL_H
N#define _CSL_MDIOHAL_H_
N
N#include <csl_stdinc.h>
N#include <csl_chip.h>
N
N#if (MDIO_SUPPORT)
X#if (( ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*1) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0)| ( 1*0)| ( 1*0)| ( 1*0)| ( 1*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) ))
S
S/******************************************************************************\
S* MDIO Register section
X
S\******************************************************************************/
S
S#define _MDIO_BASE_ADDR   0x01c83800u
S
S
S/******************************************************************************\
S* module level register/field access macros
X
S\******************************************************************************/
S
S/* ----------------- */
S/* FIELD MAKE MACROS */
S/* ----------------- */
S
S// User Supplied Value
S#define MDIO_FMK(REG,FIELD,x)\
S  ((x<<_MDIO_##REG##_##FIELD##_SHIFT)&_MDIO_##REG##_##FIELD##_MASK)
X#define MDIO_FMK(REG,FIELD,x)  ((x<<_MDIO_##REG##_##FIELD##_SHIFT)&_MDIO_##REG##_##FIELD##_MASK)
S
S// Symbolic Value Name
S#define MDIO_FMKS(REG,FIELD,SYM)\
S  ((MDIO_##REG##_##FIELD##_##SYM<<_MDIO_##REG##_##FIELD##_SHIFT)\
S  &_MDIO_##REG##_##FIELD##_MASK)
X#define MDIO_FMKS(REG,FIELD,SYM)  ((MDIO_##REG##_##FIELD##_##SYM<<_MDIO_##REG##_##FIELD##_SHIFT)  &_MDIO_##REG##_##FIELD##_MASK)
S
S// MAC Index Flag Flag
S#define MDIO_FMKMIF(MACINDEX)    (1u<<(MACINDEX))
S
S
S/* -------------------------------- */
S/* RAW REGISTER/FIELD ACCESS MACROS */
S/* -------------------------------- */
S
S#define MDIO_ADDR(REG)\
S    _MDIO_##REG##_ADDR
X#define MDIO_ADDR(REG)    _MDIO_##REG##_ADDR
S
S#define MDIO_REG(REG)\
S    *(volatile Uint32*)(_MDIO_##REG##_ADDR)
X#define MDIO_REG(REG)    *(volatile Uint32*)(_MDIO_##REG##_ADDR)
S
S// Standard Registers
S#define MDIO_RGET(REG)\
S    (*(volatile Uint32*)(_MDIO_##REG##_ADDR))
X#define MDIO_RGET(REG)    (*(volatile Uint32*)(_MDIO_##REG##_ADDR))
S
S#define MDIO_RSET(REG,x)\
S    (*(volatile Uint32*)(_MDIO_##REG##_ADDR)=(x))
X#define MDIO_RSET(REG,x)    (*(volatile Uint32*)(_MDIO_##REG##_ADDR)=(x))
S
S#define MDIO_FGET(REG,FIELD)\
S    ((MDIO_RGET(REG)&_MDIO_##REG##_##FIELD##_MASK)\
S    >>_MDIO_##REG##_##FIELD##_SHIFT)
X#define MDIO_FGET(REG,FIELD)    ((MDIO_RGET(REG)&_MDIO_##REG##_##FIELD##_MASK)    >>_MDIO_##REG##_##FIELD##_SHIFT)
S
S#define MDIO_FSET(REG,FIELD,x)\
S    MDIO_RSET(REG,(MDIO_RGET(REG)&~_MDIO_##REG##_##FIELD##_MASK)|\
S    MDIO_FMK(REG,FIELD,x))
X#define MDIO_FSET(REG,FIELD,x)    MDIO_RSET(REG,(MDIO_RGET(REG)&~_MDIO_##REG##_##FIELD##_MASK)|    MDIO_FMK(REG,FIELD,x))
S
S#define MDIO_FSETS(REG,FIELD,SYM)\
S    MDIO_RSET(REG,(MDIO_RGET(REG)&~_MDIO_##REG##_##FIELD##_MASK)|\
S    MDIO_FMKS(REG,FIELD,SYM))
X#define MDIO_FSETS(REG,FIELD,SYM)    MDIO_RSET(REG,(MDIO_RGET(REG)&~_MDIO_##REG##_##FIELD##_MASK)|    MDIO_FMKS(REG,FIELD,SYM))
S
S
S
S/******************************************************************************\
S* _____________________
X
S* |                   |
S* |  VERSION          |
S* |___________________|
S*
S* TXIDVER           - TX Identification and Version Register
S*
S* FIELDS (msb -> lsb)
S* (r)   MODID       - Module Id
S* (r)   REVMAJ      - Major Revision
S* (r)   REVMIN      - Minor Revision
S*
S* MACROS SUPPORTED
S*  MDIO_FMK     y
S*  MDIO_FMKS    .
S*  MDIO_FMKMIF  .
S*  MDIO_ADDR    y
S*  MDIO_REG     y
S*  MDIO_RGET    y
S*  MDIO_RSET    y
S*  MDIO_FGET    y
S*  MDIO_FSET    y
S*  MDIO_FSETS   .
S*
S\******************************************************************************/
S#define _MDIO_VERSION_ADDR                      (_MDIO_BASE_ADDR+0x0000u)
S
S#define MDIO_VERSION                            MDIO_REG(VERSION)
S
S#define _MDIO_VERSION_MODID_MASK                0xFFFF0000u
S#define _MDIO_VERSION_MODID_SHIFT               16u
S#define  MDIO_VERSION_MODID_DEFAULT		0x00000007u	
S
S#define _MDIO_VERSION_REVMAJ_MASK               0x0000FF00u
S#define _MDIO_VERSION_REVMAJ_SHIFT              8u
S#define  MDIO_VERSION_REVMAJ_DEFAULT		0x00000000u	
S
S#define _MDIO_VERSION_REVMIN_MASK               0x000000FFu
S#define _MDIO_VERSION_REVMIN_SHIFT              0u
S#define	 MDIO_VERSION_REVMIN_DEFAULT		0x00000000u	
S
S
S
S/******************************************************************************\
S* _____________________
X
S* |                   |
S* |    CONTROL        |
S* |___________________|
S*
S* CONTROL           - MDIO Control Register
S*
S* FIELDS (msb -> lsb)
S* (r)   IDLE        - MDIO State Machine Idle
S* (rw)  ENABLE      - Enable Control
S* (rw)  PREAMBLE    - Preamble Disable
S* (rwc) FAULT       - Fault Indicator
S* (rw)  FAULTENB    - Fault Detect Enable
S* (rw)  INTTESTENB  - Link Test Enable
S* (rw)  CLKDIV      - Clock Divider
S*
S*
S* MACROS SUPPORTED
S*  MDIO_FMK     y
S*  MDIO_FMKS    y
S*  MDIO_FMKMIF  .
S*  MDIO_ADDR    y
S*  MDIO_REG     y
S*  MDIO_RGET    y
S*  MDIO_RSET    y
S*  MDIO_FGET    y
S*  MDIO_FSET    y
S*  MDIO_FSETS   y
S*
S\******************************************************************************/
S#define _MDIO_CONTROL_ADDR                      (_MDIO_BASE_ADDR+0x0004u)
S
S#define MDIO_CONTROL                            MDIO_REG(TXCONTROL)
S
S#define _MDIO_CONTROL_IDLE_MASK                 0x80000000u
S#define _MDIO_CONTROL_IDLE_SHIFT                31u
S#define  MDIO_CONTROL_IDLE_DEFAULT		0x00000001u	
S#define MDIO_CONTROL_IDLE_YES                   1u
S#define MDIO_CONTROL_IDLE_NO                    0u
S
S#define _MDIO_CONTROL_ENABLE_MASK               0x40000000u
S#define _MDIO_CONTROL_ENABLE_SHIFT              30u
S#define  MDIO_CONTROL_ENABLE_DEFAULT		0x00000000u	
S#define MDIO_CONTROL_ENABLE_YES                 1u
S#define MDIO_CONTROL_ENABLE_NO                  0u
S
S#define _MDIO_CONTROL_PREAMBLE_MASK             0x00100000u
S#define _MDIO_CONTROL_PREAMBLE_SHIFT            20u
S#define  MDIO_CONTROL_PREAMBLE_DEFAULT		0x00000000u	
S#define MDIO_CONTROL_PREAMBLE_DISABLED          1u
S#define MDIO_CONTROL_PREAMBLE_ENABLED           0u
S
S#define _MDIO_CONTROL_FAULT_MASK                0x00080000u
S#define _MDIO_CONTROL_FAULT_SHIFT               19u
S#define  MDIO_CONTROL_FAULT_DEFAULT		0x00000000u	
S#define MDIO_CONTROL_FAULT_YES                  1u
S#define MDIO_CONTROL_FAULT_NO                   0u
S
S#define _MDIO_CONTROL_FAULTENB_MASK             0x00040000u
S#define _MDIO_CONTROL_FAULTENB_SHIFT            18u
S#define  MDIO_CONTROL_FAULTENB_DEFAULT		0x00000000u	
S#define MDIO_CONTROL_FAULTENB_YES               1u
S#define MDIO_CONTROL_FAULTENB_NO                0u
S
S#define _MDIO_CONTROL_INTTESTENB_MASK           0x00020000u
S#define _MDIO_CONTROL_INTTESTENB_SHIFT          17u
S#define  MDIO_CONTROL_INTTESTENB_DEFAULT	0x00000000u	
S#define MDIO_CONTROL_INTTESTENB_YES             1u
S#define MDIO_CONTROL_INTTESTENB_NO              0u
S
S#define _MDIO_CONTROL_CLKDIV_MASK               0x000000FFu
S#define _MDIO_CONTROL_CLKDIV_SHIFT              0u
S#define  MDIO_CONTROL_CLKDIV_DEFAULT		0x000000FFu	
S
S
S
S/******************************************************************************\
S* _____________________
X
S* |                   |
S* |   ALIVE           |
S* |   LINK            |
S* |___________________|
S*
S* ALIVE             - PHY "Alive" Indication Register
S* LINK              - PHY Link Status Register
S*
S* FIELDS (msb -> lsb)
S*  PHY Index Flags (0-31) (use MDIO_FMKMIF)
S*
S* MACROS SUPPORTED
S*  MDIO_FMK     .
S*  MDIO_FMKS    .
S*  MDIO_FMKMIF  y
S*  MDIO_ADDR    y
S*  MDIO_REG     y
S*  MDIO_RGET    y
S*  MDIO_RSET    y
S*  MDIO_FGET    .
S*  MDIO_FSET    .
S*  MDIO_FSETS   .
S*
S\******************************************************************************/
S#define _MDIO_ALIVE_ADDR                        (_MDIO_BASE_ADDR+0x0008u)
S#define _MDIO_LINK_ADDR                         (_MDIO_BASE_ADDR+0x000Cu)
S
S#define MDIO_ALIVE                              MDIO_REG(ALIVE)
S#define MDIO_LINK                               MDIO_REG(LINK)
S
S
S
S/******************************************************************************\
S* _____________________
X
S* |                   |
S* | LINKINTRAW        |
S* | LINKINTMASKED     |
S* | USERINTRAW        |
S* | USERINTMASKED     |
S* | USERINTMASKSET    |
S* | USERINTMASKCLEAR  |
S* |___________________|
S*
S* LINKINTRAW        - Link Status Change Interrupt Register
S* LINKINTMASKED     - Link Status Change Interrupt Register (Masked)
S* USERINTRAW        - User Command Complete Interrupt
S* USERINTMASKED     - User Command Complete Interrupt (Masked)
S* USERINTMASKSET    - Enable User Command Complete Interrupt Mask
S* USERINTMASKCLEAR  - Disable User Command Complete Interrupt Mask
S*
S* FIELDS (msb -> lsb)
S*       MAC0        - Mac 0 Flag (yes/no)
S*       MAC1        - Mac 1 Flag (yes/no)
S*
S* MACROS SUPPORTED
S*  MDIO_FMK     y
S*  MDIO_FMKS    y
S*  MDIO_FMKMIF  .
S*  MDIO_ADDR    y
S*  MDIO_REG     y
S*  MDIO_RGET    y
S*  MDIO_RSET    y
S*  MDIO_FGET    y
S*  MDIO_FSET    y
S*  MDIO_FSETS   .
S*
S\******************************************************************************/
S#define _MDIO_LINKINTRAW_ADDR                   (_MDIO_BASE_ADDR+0x0010u)
S#define _MDIO_LINKINTMASKED_ADDR                (_MDIO_BASE_ADDR+0x0014u)
S#define _MDIO_USERINTRAW_ADDR                   (_MDIO_BASE_ADDR+0x0020u)
S#define _MDIO_USERINTMASKED_ADDR                (_MDIO_BASE_ADDR+0x0024u)
S#define _MDIO_USERINTMASKSET_ADDR               (_MDIO_BASE_ADDR+0x0028u)
S#define _MDIO_USERINTMASKCLEAR_ADDR             (_MDIO_BASE_ADDR+0x002Cu)
S
S#define MDIO_LINKINTRAW                         MDIO_REG(LINKINT)
S#define MDIO_LINKINTMASKED                      MDIO_REG(LINKINTMASKED)
S#define MDIO_USERINTRAW                         MDIO_REG(USERINTRAW)
S#define MDIO_USERINTMASKED                      MDIO_REG(USERINTMASKED)
S#define MDIO_USERINTMASKSET                     MDIO_REG(USERINTMASKSET)
S#define MDIO_USERINTMASKCLEAR                   MDIO_REG(USERINTMASKCLEAR)
S
S#define _MDIO_LINKINTRAW_MAC0_MASK              0x00000001u
S#define _MDIO_LINKINTRAW_MAC0_SHIFT             0u
S#define  MDIO_LINKINTRAW_MAC0_DEFAULT		0x00000000u	
S#define _MDIO_LINKINTRAW_MAC1_MASK              0x00000002u
S#define _MDIO_LINKINTRAW_MAC1_SHIFT             1u
S#define  MDIO_LINKINTRAW_MAC1_DEFAULT		0x00000000u	
S
S#define MDIO_LINKINTRAW_MAC0_YES                1u
S#define MDIO_LINKINTRAW_MAC0_NO                 0u
S#define MDIO_LINKINTRAW_MAC1_YES                1u
S#define MDIO_LINKINTRAW_MAC1_NO                 0u
S
S#define _MDIO_LINKINTMASKED_MAC0_MASK           0x00000001u
S#define _MDIO_LINKINTMASKED_MAC0_SHIFT          0u
S#define  MDIO_LINKINTMASKED_MAC0_DEFAULT	0x00000000u	
S#define _MDIO_LINKINTMASKED_MAC1_MASK           0x00000002u
S#define _MDIO_LINKINTMASKED_MAC1_SHIFT          1u
S#define  MDIO_LINKINTMASKED_MAC1_DEFAULT	0x00000000u	
S
S#define MDIO_LINKINTMASKED_MAC0_YES             1u
S#define MDIO_LINKINTMASKED_MAC0_NO              0u
S#define MDIO_LINKINTMASKED_MAC1_YES             1u
S#define MDIO_LINKINTMASKED_MAC1_NO              0u
S
S#define _MDIO_USERINTRAW_MAC0_MASK              0x00000001u
S#define _MDIO_USERINTRAW_MAC0_SHIFT             0u
S#define  MDIO_USERINTRAW_MAC0_DEFAULT		0x00000000u	
S#define _MDIO_USERINTRAW_MAC1_MASK              0x00000002u
S#define _MDIO_USERINTRAW_MAC1_SHIFT             1u
S#define	 MDIO_USERINTRAW_MAC1_DEFAULT		0x00000000u	
S
S#define MDIO_USERINTRAW_MAC0_YES                1u
S#define MDIO_USERINTRAW_MAC0_NO                 0u
S#define MDIO_USERINTRAW_MAC1_YES                1u
S#define MDIO_USERINTRAW_MAC1_NO                 0u
S
S#define _MDIO_USERINTMASKED_MAC0_MASK           0x00000001u
S#define _MDIO_USERINTMASKED_MAC0_SHIFT          0u
S#define  MDIO_USERINTMASKED_MAC0_DEFAULT	0x00000000u
S#define _MDIO_USERINTMASKED_MAC1_MASK           0x00000002u
S#define _MDIO_USERINTMASKED_MAC1_SHIFT          1u
S#define  MDIO_USERINTMASKED_MAC1_DEFAULT	0x00000000u	
S
S#define MDIO_USERINTMASKED_MAC0_YES             1u
S#define MDIO_USERINTMASKED_MAC0_NO              0u
S#define MDIO_USERINTMASKED_MAC1_YES             1u
S#define MDIO_USERINTMASKED_MAC1_NO              0u
S
S#define _MDIO_USERINTMASKSET_MAC0_MASK          0x00000001u
S#define _MDIO_USERINTMASKSET_MAC0_SHIFT         0u
S#define  MDIO_USERINTMASKSET_MAC0_DEFAULT	0x00000000u
S#define _MDIO_USERINTMASKSET_MAC1_MASK          0x00000002u
S#define _MDIO_USERINTMASKSET_MAC1_SHIFT         1u
S#define  MDIO_USERINTMASKSET_MAC1_DEFAULT	0x00000000u	
S
S#define MDIO_USERINTMASKSET_MAC0_YES            1u
S#define MDIO_USERINTMASKSET_MAC0_NO             0u
S#define MDIO_USERINTMASKSET_MAC1_YES            1u
S#define MDIO_USERINTMASKSET_MAC1_NO             0u
S
S#define _MDIO_USERINTMASKCLEAR_MAC0_MASK        0x00000001u
S#define _MDIO_USERINTMASKCLEAR_MAC0_SHIFT       0u
S#define  MDIO_USERINTMASKCLEAR_MAC0_DEFAULT	0x00000000u	
S#define _MDIO_USERINTMASKCLEAR_MAC1_MASK        0x00000002u
S#define _MDIO_USERINTMASKCLEAR_MAC1_SHIFT       1u
S#define  MDIO_USERINTMASKCLEAR_MAC1_DEFAULT	0x00000000u	
S
S#define MDIO_USERINTMASKCLEAR_MAC0_YES          1u
S#define MDIO_USERINTMASKCLEAR_MAC0_NO           0u
S#define MDIO_USERINTMASKCLEAR_MAC1_YES          1u
S#define MDIO_USERINTMASKCLEAR_MAC1_NO           0u
S
S
S
S/******************************************************************************\
S* _____________________
X
S* |                   |
S* |   USERACCESS0     |
S* |   USERACCESS1     |
S* |___________________|
S*
S* USERACCESS0       - User Access Register 0
S* USERACCESS1       - User Access Register 1
S*
S* FIELDS (msb -> lsb)
S* (rws) GO          - Go Bit
S* (rw)  WRITE       - Write Enable
S* (r)   ACK         - Acknowledge
S* (rw)  REGADR      - PHY Register Address
S* (rw)  PHYADR      - PHY Device Address
S* (rw)  DATA        - User Data to Read/Write
S*
S* MACROS SUPPORTED
S*  MDIO_FMK     y
S*  MDIO_FMKS    .
S*  MDIO_FMKMIF  .
S*  MDIO_ADDR    y
S*  MDIO_REG     y
S*  MDIO_RGET    y
S*  MDIO_RSET    y
S*  MDIO_FGET    y
S*  MDIO_FSET    y
S*  MDIO_FSETS   .
S*
S\******************************************************************************/
S#define _MDIO_USERACCESS0_ADDR                  (_MDIO_BASE_ADDR+0x0080u)
S#define _MDIO_USERACCESS1_ADDR                  (_MDIO_BASE_ADDR+0x0088u)
S
S#define  MDIO_USERACCESS0                       MDIO_REG(USERACCESS0)
S#define  MDIO_USERACCESS1                       MDIO_REG(USERACCESS1)
S
S#define _MDIO_USERACCESS0_GO_MASK               0x80000000u
S#define _MDIO_USERACCESS0_GO_SHIFT              31u
S#define  MDIO_USERACCESS0_GO_DEFAULT		0x00000000u
S#define _MDIO_USERACCESS0_WRITE_MASK            0x40000000u
S#define _MDIO_USERACCESS0_WRITE_SHIFT           30u
S#define  MDIO_USERACCESS0_WRITE_DEFAULT		0x00000000u
S#define _MDIO_USERACCESS0_ACK_MASK              0x20000000u
S#define _MDIO_USERACCESS0_ACK_SHIFT             29u
S#define  MDIO_USERACCESS0_ACK_DEFAULT		0x00000000u
S#define _MDIO_USERACCESS0_REGADR_MASK           0x03E00000u
S#define _MDIO_USERACCESS0_REGADR_SHIFT          21u
S#define  MDIO_USERACCESS0_REGADR_DEFAULT	0x00000000u
S#define _MDIO_USERACCESS0_PHYADR_MASK           0x001F0000u
S#define _MDIO_USERACCESS0_PHYADR_SHIFT          16u
S#define  MDIO_USERACCESS0_PHYADR_DEFAULT	0x00000000u
S#define _MDIO_USERACCESS0_DATA_MASK             0x0000FFFFu
S#define _MDIO_USERACCESS0_DATA_SHIFT            0u
S#define  MDIO_USERACCESS0_DATA_DEFAULT		0x00000000u
S
S#define _MDIO_USERACCESS1_GO_MASK               0x80000000u
S#define _MDIO_USERACCESS1_GO_SHIFT              31u
S#define  MDIO_USERACCESS1_GO_DEFAULT		0x00000000u
S#define _MDIO_USERACCESS1_WRITE_MASK            0x40000000u
S#define _MDIO_USERACCESS1_WRITE_SHIFT           30u
S#define  MDIO_USERACCESS1_WRITE_DEFAULT		0x00000000u
S#define _MDIO_USERACCESS1_ACK_MASK              0x20000000u
S#define _MDIO_USERACCESS1_ACK_SHIFT             29u
S#define  MDIO_USERACCESS1_ACK_DEFAULT		0x00000000u
S#define _MDIO_USERACCESS1_REGADR_MASK           0x03E00000u
S#define _MDIO_USERACCESS1_REGADR_SHIFT          21u
S#define  MDIO_USERACCESS1_REGADR_DEFAULT	0x00000000u
S#define _MDIO_USERACCESS1_PHYADR_MASK           0x001F0000u
S#define _MDIO_USERACCESS1_PHYADR_SHIFT          16u
S#define  MDIO_USERACCESS1_PHYADR_DEFAULT	0x00000000u
S#define _MDIO_USERACCESS1_DATA_MASK             0x0000FFFFu
S#define _MDIO_USERACCESS1_DATA_SHIFT            0u
S#define  MDIO_USERACCESS1_DATA_DEFAULT		0x00000000u
S
S
S/******************************************************************************\
S* _____________________
X
S* |                   |
S* |   USERPHYSEL0     |
S* |   USERPHYSEL1     |
S* |___________________|
S*
S* USERPHYSEL0       - User PHY Select Register 0
S* USERPHYSEL1       - User PHY Select Register 1
S*
S* FIELDS (msb -> lsb)
S* (rw)  LINKSEL     - Link Detect Type Selection
S* (rw)  LINKINTENB  - Link Interrupt Enable
S* (rw)  PHYADDR     - Address (0-31) of Phy to Use
S*
S* MACROS SUPPORTED
S*  MDIO_FMK     y
S*  MDIO_FMKS    y
S*  MDIO_FMKMIF  .
S*  MDIO_ADDR    y
S*  MDIO_REG     y
S*  MDIO_RGET    y
S*  MDIO_RSET    y
S*  MDIO_FGET    y
S*  MDIO_FSET    y
S*  MDIO_FSETS   y
S*
S\******************************************************************************/
S#define _MDIO_USERPHYSEL0_ADDR                  (_MDIO_BASE_ADDR+0x0084u)
S#define _MDIO_USERPHYSEL1_ADDR                  (_MDIO_BASE_ADDR+0x008Cu)
S
S#define  MDIO_USERPHYSEL0                       MDIO_REG(USERPHYSEL0)
S#define  MDIO_USERPHYSEL1                       MDIO_REG(USERPHYSEL1)
S
S#define _MDIO_USERPHYSEL0_LINKSEL_MASK          0x00000080u
S#define _MDIO_USERPHYSEL0_LINKSEL_SHIFT         7u
S#define  MDIO_USERPHYSEL0_LINKSEL_DEFAULT	0x00000000u
S#define MDIO_USERPHYSEL0_LINKSEL_MLINK          1u
S#define MDIO_USERPHYSEL0_LINKSEL_MDIO           0u
S
S#define _MDIO_USERPHYSEL0_LINKINTENB_MASK       0x00000040u
S#define _MDIO_USERPHYSEL0_LINKINTENB_SHIFT      6u
S#define  MDIO_USERPHYSEL0_LINKINTENB_DEFAULT	0x00000000u
S#define MDIO_USERPHYSEL0_LINKINTENB_ENABLE      1u
S#define MDIO_USERPHYSEL0_LINKINTENB_DISABLE     0u
S
S#define _MDIO_USERPHYSEL0_PHYADDR_MASK          0x0000001Fu
S#define _MDIO_USERPHYSEL0_PHYADDR_SHIFT         0u
S#define  MDIO_USERPHYSEL0_PHYADDR_DEFAULT	0x00000000u
S
S#define _MDIO_USERPHYSEL1_LINKSEL_MASK          0x00000080u
S#define _MDIO_USERPHYSEL1_LINKSEL_SHIFT         7u
S#define  MDIO_USERPHYSEL1_LINKSEL_DEFAULT	0x00000000u
S#define MDIO_USERPHYSEL1_LINKSEL_MLINK          1u
S#define MDIO_USERPHYSEL1_LINKSEL_MDIO           0u
S
S#define _MDIO_USERPHYSEL1_LINKINTENB_MASK       0x00000040u
S#define _MDIO_USERPHYSEL1_LINKINTENB_SHIFT      6u
S#define  MDIO_USERPHYSEL1_LINKINTENB_DEFAULT	0x00000000u
S#define MDIO_USERPHYSEL1_LINKINTENB_ENABLE      1u
S#define MDIO_USERPHYSEL1_LINKINTENB_DISABLE     0u
S
S#define _MDIO_USERPHYSEL1_PHYADDR_MASK          0x0000001Fu
S#define _MDIO_USERPHYSEL1_PHYADDR_SHIFT         0u
S#define  MDIO_USERPHYSEL1_PHYADDR_DEFAULT	0x00000000u
S
S
N#endif /* MDIO_SUPPORT */
N
N#endif /* _CSL_MDIOHAL_H_ */
N/******************************************************************************\
N* End of csl_mdiohal.h
X
N\******************************************************************************/
N
N
N
N
L 28 "E:/TI_workspase/c6701_t/csl/csl_mdio.h" 2
N
N
N#if (MDIO_SUPPORT)
X#if (( ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*1) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0)| ( 1*0)| ( 1*0)| ( 1*0)| ( 1*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) ))
S/*-----------------------------------------------------------------------*\
S* NEW TYPES
X
S\*-----------------------------------------------------------------------*/
S#ifndef _CSL_EMAC_TYPES
S#define _CSL_EMAC_TYPES
Stypedef unsigned int uint;
Stypedef void * Handle;
S#endif
S
S/*-----------------------------------------------------------------------*\
S* MDIO Configuration Mode Flags
X
S*
S* These flags determine how the MDIO module behaves
S\*-----------------------------------------------------------------------*/
S#define MDIO_MODEFLG_AUTONEG     0x0001 /* Use Autonegotiate         */
S/* The following bits are used for manual and fallback configuration */
S#define MDIO_MODEFLG_HD10        0x0002 /* Use 10Mb/s Half Duplex    */
S#define MDIO_MODEFLG_FD10        0x0004 /* Use 10Mb/s Full Duplex    */
S#define MDIO_MODEFLG_HD100       0x0008 /* Use 100Mb/s Half Duplex   */
S#define MDIO_MODEFLG_FD100       0x0010 /* Use 100Mb/s Full Duplex   */
S#define MDIO_MODEFLG_LOOPBACK    0x0020 /* Use PHY Loopback          */
S/* The following bits are reserved for use by the MDIO module */
S#define MDIO_MODEFLG_NWAYACTIVE  0x0040 /* NWAY is currently active  */
S
S/*-----------------------------------------------------------------------*\
S* MDIO Link Status Values
X
S*
S* These values indicate current PHY link status
S\*-----------------------------------------------------------------------*/
S#define MDIO_LINKSTATUS_NOLINK   0
S#define MDIO_LINKSTATUS_HD10     1
S#define MDIO_LINKSTATUS_FD10     2
S#define MDIO_LINKSTATUS_HD100    3
S#define MDIO_LINKSTATUS_FD100    4
S
S/*-----------------------------------------------------------------------*\
S* MDIO Events
X
S*
S* These events are returned by MDIO_timerTick() to allow the application
S* (or EMAC) to track MDIO status.
S\*-----------------------------------------------------------------------*/
S#define MDIO_EVENT_NOCHANGE      0   /* No change from previous status */
S#define MDIO_EVENT_LINKDOWN      1   /* Link down event                */
S#define MDIO_EVENT_LINKUP        2   /* Link (or re-link) event        */
S#define MDIO_EVENT_PHYERROR      3   /* No PHY connected               */
S
S
S/*-----------------------------------------------------------------------*\
S* MDIO_open()
X
S*
S* Opens the MDIO peripheral and start searching for a PHY device.
S*
S* It is assumed that the MDIO module is reset prior to calling this
S* function.
S\*-----------------------------------------------------------------------*/
SCSLAPI Handle MDIO_open( uint mdioModeFlags );
S
S/*-----------------------------------------------------------------------*\
S* MDIO_close()
X
S*
S* Close the MDIO peripheral and disable further operation.
S\*-----------------------------------------------------------------------*/
SCSLAPI void MDIO_close( Handle hMDIO );
S
S/*-----------------------------------------------------------------------*\
S* MDIO_getStatus()
X
S*
S* Called to get the status of the MDIO/PHY
S\*-----------------------------------------------------------------------*/
SCSLAPI void MDIO_getStatus( Handle hMDIO, uint *pPhy, uint *pLinkStatus );
S
S/*-----------------------------------------------------------------------*\
S* MDIO_timerTick()
X
S*
S* Called to signify that approx 100mS have elapsed
S*
S* Returns an MDIO event code (see MDIO Events in CSL_MDIO.H).
S\*-----------------------------------------------------------------------*/
SCSLAPI uint MDIO_timerTick( Handle hMDIO );
S
S/*-----------------------------------------------------------------------*\
S* MDIO_initPHY()
X
S*
S* Force a switch to the specified PHY, and start negotiation.
S*
S* This call is only used to override the normal PHY detection process.
S*
S* Returns 1 if the PHY selection completed OK, else 0
S\*-----------------------------------------------------------------------*/
SCSLAPI uint MDIO_initPHY( Handle hMDIO, uint phyAddr );
S
S/*-----------------------------------------------------------------------*\
S* MDIO_phyRegRead()
X
S*
S* Raw data read of a PHY register.
S*
S* Returns 1 if the PHY ACK'd the read, else 0
S\*-----------------------------------------------------------------------*/
SCSLAPI uint MDIO_phyRegRead( uint phyIdx, uint phyReg, Uint16 *pData );
S
S/*-----------------------------------------------------------------------*\
S* MDIO_phyRegWrite()
X
S*
S* Raw data write  of a PHY register.
S*
S* Returns 1 if the PHY ACK'd the write, else 0
S\*-----------------------------------------------------------------------*/
SCSLAPI uint MDIO_phyRegWrite( uint phyIdx, uint phyReg, Uint16 data );
S
N#endif /* MDIO_SUPPORT */
N#endif /* _CSL_MDIO_H_ */
N/******************************************************************************\
N* End of mdio.h
X
N\******************************************************************************/
L 23 "E:/TI_workspase/c6701_t/csl/csl_emac.h" 2
N
N#if (EMAC_SUPPORT)
X#if (( ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*1) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0)| ( 1*0)| ( 1*0)| ( 1*0)| ( 1*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) ))
S/*-----------------------------------------------------------------------*\
S* NEW TYPES
X
S\*-----------------------------------------------------------------------*/
S#ifndef _CSL_EMAC_TYPES
S#define _CSL_EMAC_TYPES
Stypedef unsigned int uint;
Stypedef void * Handle;
S#endif
S
S/*-----------------------------------------------------------------------*\
S* STANDARD DATA STRUCTURES
X
S\*-----------------------------------------------------------------------*/
S
S/*-----------------------------------------------------------------------*\
S* EMAC_Pkt
X
S*
S* The packet structure defines the basic unit of memory used to hold data
S* packets for the EMAC device.
S*
S* A packet is comprised of one or more packet buffers. Each packet buffer
S* contains a packet buffer header, and a pointer to the buffer data.
S* The EMAC_Pkt structure defines the packet buffer header.
S*
S* The pDataBuffer field points to the packet data. This is set when the
S* buffer is allocated, and is not altered.
S*
S* BufferLen holds the the total length of the data buffer that is used to
S* store the packet (or packet fragment). This size is set by the entity
S* that originally allocates the buffer, and is not altered.
S*
S* The Flags field contains additional information about the packet
S*
S* ValidLen holds the length of the valid data currently contained in the
S* data buffer.
S*
S* DataOffset is the byte offset from the start of the data buffer to the
S* first byte of valid data. Thus (ValidLen+DataOffet)<=BufferLen.
S*
S* Note that for receive buffer packets, the DataOffset field may be
S* assigned before there is any valid data in the packet buffer. This allows
S* the application to reserve space at the top of data buffer for private
S* use. In all instances, the DataOffset field must be valid for all packets
S* handled by EMAC.
S*
S* The data portion of the packet buffer represents a packet or a fragment
S* of a larger packet. This is determined by the Flags parameter. At the
S* start of every packet, the SOP bit is set in Flags. If the EOP bit is
S* also set, then the packet is not fragmented. Otherwise; the next packet
S* structure pointed to by the pNext field will contain the next fragment in
S* the packet. On either type of buffer, when the SOP bit is set in Flags,
S* then the PktChannel, PktLength, and PktFrags fields must also be valid.
S* These fields contain additional information about the packet.
S*
S* The PktChannel field detetmines what channel the packet has arrived on,
S* or what channel it should be transmitted on. The EMAC library supports
S* only a single receive channel, but allows for up to eight transmit
S* channels. Transmit channels can be treated as round-robin or priority
S* queues.
S*
S* The PktLength field holds the size of the entire packet. On single frag
S* packets (both SOP and EOP set in BufFlags), PktLength and ValidLen will
S* be equal.
S*
S* The PktFrags field holds the number of fragments (EMAC_Pkt records) used
S* to describe the packet. If more than 1 frag is present, the first record
S* must have EMAC_PKT_FLAGS_SOP flag set, with corresponding fields validated.
S* Each frag/record must be linked list using the pNext field, and the final
S* frag/record must have EMAC_PKT_FLAGS_EOP flag set and pNext=0.
S*
S* In systems where the packet resides in cacheable memory, the data buffer
S* must start on a cache line boundary and be an even multiple of cache
S* lines in size. The EMAC_Pkt header must not appear in the same cache line
S* as the data portion of the packet. On multi-fragment packets, some packet
S* fragments may reside in cacheable memory where others do not.
S*
S* ** NOTE: It is up to the caller to assure that all packet buffers    **
S* ** residing in cacheable memory are not currently stored in L1 or L2 **
S* ** cache when passed to any EMAC function                             **
S*
S* Some of the packet Flags can only be set if the device is in the
S* proper configuration to receive the corresponding frames. In order to
S* enable these flags, the following modes must be set:
S*       RxCrc Flag  : RXCRC Mode in EMAC_Config
S*       RxErr Flags : PASSERROR Mode in EMAC_Config
S*       RxCtl Flags : PASSCONTROL Mode in EMAC_Config
S*       RxPrm Flag  : EMAC_RXFILTER_ALL in EMAC_setReceiveFilter()
S*
S\*-----------------------------------------------------------------------*/
Stypedef struct _EMAC_Pkt {
S    Uint32           AppPrivate;   /* For use by the application            */
S    struct _EMAC_Pkt *pPrev;       /* Previous record                       */
S    struct _EMAC_Pkt *pNext;       /* Next record                           */
S    Uint8            *pDataBuffer; /* Pointer to Data Buffer (read only)    */
S    Uint32          BufferLen;    /* Physical Length of buffer (read only) */
S    Uint32          Flags;        /* Packet Flags                          */
S    Uint32          ValidLen;     /* Length of valid data in buffer        */
S    Uint32          DataOffset;   /* Byte offset to valid data             */
S    Uint32          PktChannel;   /* Tx/Rx Channel/Priority 0-7 (SOP only) */
S    Uint32          PktLength;    /* Length of Packet (SOP only)           */
S                                  /* (same as ValidLen on single frag Pkt) */
S    Uint32          PktFrags;     /* Number of frags in packet (SOP only)  */
S                                   /* (frag is EMAC_Pkt record - normally 1)*/
S    } EMAC_Pkt;
S
S/*
S// Packet Buffer Flags set in Flags
S*/
S#define EMAC_PKT_FLAGS_SOP         0x80000000u /* Start of packet           */
S#define EMAC_PKT_FLAGS_EOP         0x40000000u /* End of packet             */
S
S/*
S// The Following Packet flags are set in Flags on RX packets only
S*/
S#define EMAC_PKT_FLAGS_HASCRC      0x04000000u /* RxCrc: PKT has 4byte CRC  */
S#define EMAC_PKT_FLAGS_JABBER      0x02000000u /* RxErr: Jabber             */
S#define EMAC_PKT_FLAGS_OVERSIZE    0x01000000u /* RxErr: Oversize           */
S#define EMAC_PKT_FLAGS_FRAGMENT    0x00800000u /* RxErr: Fragment           */
S#define EMAC_PKT_FLAGS_UNDERSIZED  0x00400000u /* RxErr: Undersized         */
S#define EMAC_PKT_FLAGS_CONTROL     0x00200000u /* RxCtl: Control Frame      */
S#define EMAC_PKT_FLAGS_OVERRUN     0x00100000u /* RxErr: Overrun            */
S#define EMAC_PKT_FLAGS_CODEERROR   0x00080000u /* RxErr: Code Error         */
S#define EMAC_PKT_FLAGS_ALIGNERROR  0x00040000u /* RxErr: Alignment Error    */
S#define EMAC_PKT_FLAGS_CRCERROR    0x00020000u /* RxErr: Bad CRC            */
S#define EMAC_PKT_FLAGS_NOMATCH     0x00010000u /* RxPrm: No Match           */
S
S
S/*-----------------------------------------------------------------------*\
S* EMAC_Config
X
S*
S* The config structure defines how the EMAC device should operate. It is
S* passed to the device when the device is opened, and remains in effect
S* until the device is closed.
S*
S* The following is a short description of the configuration fields:
S*
S* ModeFlags    - Specify the Fixed Operating Mode of the Device
S* EMAC_CONFIG_MODEFLG_CHPRIORITY  - Treat TX channels as Priority Levels
S*                                  (Channel 7 is highest, 0 is lowest)
S* EMAC_CONFIG_MODEFLG_MACLOOPBACK - Set MAC in Internal Loopback for Testing
S* EMAC_CONFIG_MODEFLG_RXCRC       - Include the 4 byte EtherCRC in RX frames
S* EMAC_CONFIG_MODEFLG_TXCRC       - Assume TX Frames Include 4 byte EtherCRC
S* EMAC_CONFIG_MODEFLG_PASSERROR   - Receive Error Frames for Testing
S* EMAC_CONFIG_MODEFLG_PASSCONTROL - Receive Control Frames for Testing
S*
S* MdioModeFlags - Specify the MDIO/PHY Operation (See EMACMDIO.H)
S*
S* TxChannels    - Number of TX Channels to use (1-8, usually 1)
S*
S* MacAddr       - Device MAC address
S*
S* RxMaxPktPool  - Max Rx packet buffers to get from pool
S*                 (Must be in the range of 8 to 192)
S*
S* A list of callback functions is used to register callback functions with
S* a particular instance of the EMAC peripheral. Callback functions are
S* used by EMAC to communicate with the application. These functions are
S* REQUIRED for operation. The same callback table can be used for multiple
S* driver instances.
S*
S* The callback functions can be used by EMAC during any EMAC function, but
S* mostly occur during calls to EMAC_statusIsr() and EMAC_statusPoll().
S*
S* pfcbGetPacket -  Called by EMAC to get a free packet buffer from the
S*                  application layer for receive data. This function
S*                  should return NULL is no free packets are available.
S*                  The size of the packet buffer must be large enough
S*                  to accommodate a full sized packet (1514 or 1518
S*                  depending on the EMAC_CONFIG_MODEFLG_RXCRC flag), plus
S*                  any application buffer padding (DataOffset).
S*
S* pfcbFreePacket - Called by EMAC to give a free packet buffer back to
S*                  the application layer. This function is used to
S*                  return transmit packets. Note that at the time of the
S*                  call, structure fields other than pDataBuffer and
S*                  BufferLen are in an undefined state.
S*
S* pfcbRxPacket   - Called to give a received data packet to the application
S*                  layer. The applicaiton must accept the packet.
S*                  When the application is finished with the packet, it
S*                  can return it to its own free queue.
S*
S*                  This function also returns a pointer to a free packet to
S*                  replace the received packet on the EMAC free list. It
S*                  returns NULL when no free packets are available. The
S*                  return packet is the same as would be returned by
S*                  pfcbGetPacket.
S*
S*                  Thus if a newly received packet is not desired, it can
S*                  simply be returned to EMAC via the return value.
S*
S* pfcbStatus     - Called to indicate to the application that it
S*                  should call EMAC_getStatus() to read the current
S*                  device status. This call is made when device status
S*                  changes.
S*
S* pfcbStatistics - Called to indicate to the application that it
S*                  should call EMAC_getStatistics() to read the
S*                  current Ethernet statistics. Called when the
S*                  statistic counters are to the point of overflow.
S*
S* The hApplication calling calling argument is the application's handle
S* as supplied to the EMAC device in the EMAC_open() function.
S\*-----------------------------------------------------------------------*/
Stypedef struct _EMAC_Config {
S    uint        ModeFlags;      /* Configuation Mode Flags                */
S    uint        MdioModeFlags;  /* CSL_MDIO Mode Flags (see CSL_MDIO.H)   */
S    uint        TxChannels;     /* Number of Tx Channels to use (1-8)     */
S    Uint8       MacAddr[6];     /* Mac Address                            */
S    uint        RxMaxPktPool;   /* Max Rx packet buffers to get from pool */
S    EMAC_Pkt *  (*pfcbGetPacket)(Handle hApplication);
S    void        (*pfcbFreePacket)(Handle hApplication, EMAC_Pkt *pPacket);
S    EMAC_Pkt *  (*pfcbRxPacket)(Handle hApplication, EMAC_Pkt *pPacket);
S    void        (*pfcbStatus)(Handle hApplication);
S    void        (*pfcbStatistics)(Handle hApplication);
S} EMAC_Config;
S
S/*
S//  Configuration Mode Flags
S*/
S#define EMAC_CONFIG_MODEFLG_CHPRIORITY  0x0001 /* Use Tx channel priority  */
S#define EMAC_CONFIG_MODEFLG_MACLOOPBACK 0x0002 /* MAC internal loopback    */
S#define EMAC_CONFIG_MODEFLG_RXCRC       0x0004 /* Include CRC in RX frames */
S#define EMAC_CONFIG_MODEFLG_TXCRC       0x0008 /* Tx frames include CRC    */
S#define EMAC_CONFIG_MODEFLG_PASSERROR   0x0010 /* Pass error frames        */
S#define EMAC_CONFIG_MODEFLG_PASSCONTROL 0x0020 /* Pass control frames      */
S
S/*-----------------------------------------------------------------------*\
S* EMAC_Status
X
S*
S* The status structure contains information about the MAC's run-time
S* status.
S*
S* The following is a short description of the configuration fields:
S*
S* MdioLinkStatus - Current link status (non-zero on link) (see CSL_MDIO.H)
S*
S* PhyDev         - Current PHY device in use (0-31)
S*
S* RxPktHeld      - Current number of Rx packets held by the EMAC device
S*
S* TxPktHeld      - Current number of Tx packets held by the EMAC device
S*
S* FatalError     - Fatal Error Code (TBD)
S\*-----------------------------------------------------------------------*/
Stypedef struct _EMAC_Status {
S    uint        MdioLinkStatus; /* CSL_MDIO Link status (see CSL_MDIO.H) */
S    uint        PhyDev;         /* Current PHY device in use (0-31)      */
S    uint        RxPktHeld;      /* Number of packets held for Rx         */
S    uint        TxPktHeld;      /* Number of packets held for Tx         */
S    uint        FatalError;     /* Fatal Error when non-zero             */
S} EMAC_Status;
S
S
S/*-----------------------------------------------------------------------*\
S* EMAC_Statistics
X
S*
S* The statistics structure is the used to retrieve the current count
S* of various packet events in the system. These values represent the
S* delta values from the last time the statistics were read.
S\*-----------------------------------------------------------------------*/
Stypedef struct _EMAC_Statistics {
S    Uint32 RxGoodFrames;     /* Good Frames Received                         */
S    Uint32 RxBCastFrames;    /* Good Broadcast Frames Received               */
S    Uint32 RxMCastFrames;    /* Good Multicast Frames Received               */
S    Uint32 RxPauseFrames;    /* PauseRx Frames Received                      */
S    Uint32 RxCRCErrors;      /* Frames Received with CRC Errors              */
S    Uint32 RxAlignCodeErrors;/* Frames Received with Alignment/Code Errors   */
S    Uint32 RxOversized;      /* Oversized Frames Received                    */
S    Uint32 RxJabber;         /* Jabber Frames Received                       */
S    Uint32 RxUndersized;     /* Undersized Frames Received                   */
S    Uint32 RxFragments;      /* Rx Frame Fragments Received                  */
S    Uint32 RxFiltered;       /* Rx Frames Filtered Based on Address          */
S    Uint32 RxQOSFiltered;    /* Rx Frames Filtered Based on QoS Filtering    */
S    Uint32 RxOctets;         /* Total Received Bytes in Good Frames          */
S    Uint32 TxGoodFrames;     /* Good Frames Sent                             */
S    Uint32 TxBCastFrames;    /* Good Broadcast Frames Sent                   */
S    Uint32 TxMCastFrames;    /* Good Multicast Frames Sent                   */
S    Uint32 TxPauseFrames;    /* PauseTx Frames Sent                          */
S    Uint32 TxDeferred;       /* Frames Where Transmission was Deferred       */
S    Uint32 TxCollision;      /* Total Frames Sent With Collision             */
S    Uint32 TxSingleColl;     /* Frames Sent with Exactly One Collision       */
S    Uint32 TxMultiColl;      /* Frames Sent with Multiple Colisions          */
S    Uint32 TxExcessiveColl;  /* Tx Frames Lost Due to Excessive Collisions   */
S    Uint32 TxLateColl;       /* Tx Frames Lost Due to a Late Collision       */
S    Uint32 TxUnderrun;       /* Tx Frames Lost with Transmit Underrun Error  */
S    Uint32 TxCarrierSLoss;   /* Tx Frames Lost Due to Carrier Sense Loss     */
S    Uint32 TxOctets;         /* Total Transmitted Bytes in Good Frames       */
S    Uint32 Frame64;          /* Total Tx&Rx with Octet Size of 64            */
S    Uint32 Frame65t127;      /* Total Tx&Rx with Octet Size of 65 to 127     */
S    Uint32 Frame128t255;     /* Total Tx&Rx with Octet Size of 128 to 255    */
S    Uint32 Frame256t511;     /* Total Tx&Rx with Octet Size of 256 to 511    */
S    Uint32 Frame512t1023;    /* Total Tx&Rx with Octet Size of 512 to 1023   */
S    Uint32 Frame1024tUp;     /* Total Tx&Rx with Octet Size of >=1024      */
S    Uint32 NetOctets;        /* Sum of all Octets Tx or Rx on the Network    */
S    Uint32 RxSOFOverruns;    /* Total Rx Start of Frame Overruns             */
S    Uint32 RxMOFOverruns;    /* Total Rx Middle of Frame Overruns            */
S    Uint32 RxDMAOverruns;    /* Total Rx DMA Overruns                        */
S} EMAC_Statistics;
S
S
S/*-----------------------------------------------------------------------*\
S* Packet Filtering
X
S*
S* Packet Filtering Settings (cumulative)
S\*-----------------------------------------------------------------------*/
S#define EMAC_RXFILTER_NOTHING      0
S#define EMAC_RXFILTER_DIRECT       1
S#define EMAC_RXFILTER_BROADCAST    2
S#define EMAC_RXFILTER_MULTICAST    3
S#define EMAC_RXFILTER_ALLMULTICAST 4
S#define EMAC_RXFILTER_ALL          5
S
S/*-----------------------------------------------------------------------*\
S* STANDARD ERROR CODES
X
S\*-----------------------------------------------------------------------*/
S#define EMAC_ERROR_ALREADY   1   /* Operation has already been started        */
S#define EMAC_ERROR_NOTREADY  2   /* Device is not open or not ready           */
S#define EMAC_ERROR_DEVICE    3   /* Device hardware error                     */
S#define EMAC_ERROR_INVALID   4   /* Function or calling parameter is invalid  */
S#define EMAC_ERROR_BADPACKET 5   /* Supplied packet was invalid               */
S#define EMAC_ERROR_MACFATAL  6   /* Fatal Error in MAC - EMAC_close() required */
S
S/*-----------------------------------------------------------------------*\
S* STANDARD API FUNCTIONS
X
S*
S* IMPORTANT NOTE
S* --------------
S*   The application is charged with verifying that only one of the
S* following API calls may only be executing at a given time across
S* all threads and all interrupt functions.
S*
S\*-----------------------------------------------------------------------*/
S
S/*-----------------------------------------------------------------------*\
S* EMAC_enumerate()
X
S*
S* Enumerates the EMAC peripherals installed in the system and returns an
S* integer count. The EMAC devices are enumerated in a consistent
S* fashion so that each device can be later referenced by its physical
S* index value ranging from "1" to "n" where "n" is the count returned
S* by this function.
S\*-----------------------------------------------------------------------*/
SCSLAPI uint EMAC_enumerate( void );
S
S
S/*-----------------------------------------------------------------------*\
S* EMAC_open()
X
S*
S* Opens the EMAC peripheral at the given physical index and initializes
S* it to an embryonic state.
S*
S* The calling application must supply a operating configuration that
S* includes a callback function table. Data from this config structure is
S* copied into the device's internal instance structure so the structure
S* may be discarded after EMAC_open() returns. In order to change an item
S* in the configuration, the the EMAC device must be closed and then
S* re-opened with the new configuration.
S*
S* The application layer may pass in an hApplication callback handle,
S* that will be supplied by the EMAC device when making calls to the
S* application callback functions.
S*
S* An EMAC device handle is written to phEMAC. This handle must be saved
S* by the caller and then passed to other EMAC device functions.
S*
S* The default receive filter prevents normal packets from being received
S* until the receive filter is specified by calling EMAC_receiveFilter().
S*
S* A device reset is achieved by calling EMAC_close() followed by EMAC_open().
S*
S* The function returns zero on success, or an error code on failure.
S*
S* Possible error codes include:
S*   EMAC_ERROR_ALREADY   - The device is already open
S*   EMAC_ERROR_INVALID   - A calling parameter is invalid
S*
S\*-----------------------------------------------------------------------*/
SCSLAPI uint EMAC_open( int physicalIndex, Handle hApplication,
S                       EMAC_Config *pEMACConfig, Handle *phEMAC );
S
S
S/*-----------------------------------------------------------------------*\
S* EMAC_close()
X
S*
S* Closed the EMAC peripheral indicated by the supplied instance handle.
S* When called, the EMAC device will shutdown both send and receive
S* operations, and free all pending transmit and receive packets.
S*
S* The function returns zero on success, or an error code on failure.
S*
S* Possible error code include:
S*   EMAC_ERROR_INVALID   - A calling parameter is invalid
S*
S\*-----------------------------------------------------------------------*/
SCSLAPI uint EMAC_close( Handle hEMAC );
S
S
S/*-----------------------------------------------------------------------*\
S* EMAC_getStatus()
X
S*
S* Called to get the current status of the device. The device status
S* is copied into the supplied data structure.
S*
S* The function returns zero on success, or an error code on failure.
S*
S* Possible error code include:
S*   EMAC_ERROR_INVALID   - A calling parameter is invalid
S*
S\*-----------------------------------------------------------------------*/
SCSLAPI uint EMAC_getStatus( Handle hEMAC, EMAC_Status *pStatus );
S
S
S/*-----------------------------------------------------------------------*\
S* EMAC_setReceiveFilter()
X
S*
S* Called to set the packet filter for received packets. The filtering
S* level is inclusive, so BROADCAST would include both BROADCAST and
S* DIRECTED (UNICAST) packets.
S*
S* Available filtering modes include the following:
S*  EMAC_RXFILTER_NOTHING      - Receive nothing
S*  EMAC_RXFILTER_DIRECT       - Receive only Unicast to local MAC addr
S*  EMAC_RXFILTER_BROADCAST    - Receive direct and Broadcast
S*  EMAC_RXFILTER_MULTICAST    - Receive above plus multicast in mcast list
S*  EMAC_RXFILTER_ALLMULTICAST - Receive above plus all multicast
S*  EMAC_RXFILTER_ALL          - Receive all packets
S*
S* Note that if error frames and control frames are desired, reception of
S* these must be specified in the device configuration.
S*
S* The function returns zero on success, or an error code on failure.
S*
S* Possible error code include:
S*   EMAC_ERROR_INVALID   - A calling parameter is invalid
S*
S\*-----------------------------------------------------------------------*/
SCSLAPI uint EMAC_setReceiveFilter( Handle hEMAC, uint ReceiveFilter );
S
S
S/*-----------------------------------------------------------------------*\
S* EMAC_getReceiveFilter()
X
S*
S* Called to get the current packet filter setting for received packets.
S* The filter values are the same as those used in EMAC_setReceiveFilter().
S*
S* The current filter value is writter to the pointer supplied in
S* pReceiveFilter.
S*
S* The function returns zero on success, or an error code on failure.
S*
S* Possible error code include:
S*   EMAC_ERROR_INVALID   - A calling parameter is invalid
S*
S\*-----------------------------------------------------------------------*/
SCSLAPI uint EMAC_getReceiveFilter( Handle hEMAC, uint *pReceiveFilter );
S
S
S/*-----------------------------------------------------------------------*\
S* EMAC_getStatistics()
X
S*
S* Called to get the current device statistics. The statistics structure
S* contains a collection of event counts for various packet sent and
S* receive properties. Reading the statistics also clears the current
S* statistic counters, so the values read represent a delta from the last
S* call.
S*
S* The statistics information is copied into the structure pointed to
S* by the pStatistics argument.
S*
S* The function returns zero on success, or an error code on failure.
S*
S* Possible error code include:
S*   EMAC_ERROR_INVALID   - A calling parameter is invalid
S*
S\*-----------------------------------------------------------------------*/
SCSLAPI uint EMAC_getStatistics( Handle hEMAC, EMAC_Statistics *pStatistics );
S
S
S/*-----------------------------------------------------------------------*\
S* EMAC_setMulticast()
X
S*
S* This function is called to install a list of multicast addresses for
S* use in multicast address filtering. Each time this function is called,
S* any current multicast configuration is discarded in favor of the new
S* list. Thus a set with a list size of zero will remove all multicast
S* addresses from the device.
S*
S* Note that the multicast list configuration is stateless in that the
S* list of multicast addresses used to build the configuration is not
S* retained. Thus it is impossible to examine a list of currently installed
S* addresses.
S*
S* The addresses to install are pointed to by pMCastList. The length of
S* this list in bytes is 6 times the value of AddrCnt. When AddrCnt is
S* zero, the pMCastList parameter can be NULL.
S*
S* The function returns zero on success, or an error code on failure.
S* The multicast list settings are not altered in the event of a failure
S* code.
S*
S* Possible error code include:
S*   EMAC_ERROR_INVALID   - A calling parameter is invalid
S*
S\*-----------------------------------------------------------------------*/
SCSLAPI uint EMAC_setMulticast( Handle hEMAC, uint AddrCnt, Uint8 *pMCastList );
S
S
S
S/*-----------------------------------------------------------------------*\
S* EMAC_sendPacket()
X
S*
S* Sends a Ethernet data packet out the EMAC device. On a non-error return,
S* the EMAC device takes ownership of the packet. The packet is returned
S* to the application's free pool once it has been transmitted.
S*
S* The function returns zero on success, or an error code on failure.
S* When an error code is returned, the EMAC device has not taken ownership
S* of the packet.
S*
S* Possible error codes include:
S*   EMAC_ERROR_INVALID   - A calling parameter is invalid
S*   EMAC_ERROR_BADPACKET - The packet structure is invalid
S*
S\*-----------------------------------------------------------------------*/
SCSLAPI uint EMAC_sendPacket( Handle hEMAC, EMAC_Pkt *pPacket );
S
S
S/*-----------------------------------------------------------------------*\
S* EMAC_serviceCheck()
X
S*
S* This function should be called every time there is an EMAC device
S* interrupt. It maintains the status the EMAC.
S*
S* Note that the application has the responsibility for mapping the
S* physical device index to the correct EMAC_serviceCheck() function. If
S* more than one EMAC device is on the same interrupt, the function must be
S* called for each device.
S*
S* Possible error codes include:
S*   EMAC_ERROR_INVALID   - A calling parameter is invalid
S*   EMAC_ERROR_MACFATAL  - Fatal error in the MAC - Call EMAC_close()
S*
S\*-----------------------------------------------------------------------*/
SCSLAPI uint EMAC_serviceCheck( Handle hEMAC );
S
S
S/*-----------------------------------------------------------------------*\
S* EMAC_timerTick()
X
S*
S* This function should be called for each device in the system on a
S* periodic basis of 100mS (10 times a second). It is used to check the
S* status of the EMAC and MDIO device, and to potentially recover from
S* low Rx buffer conditions.
S*
S* Strict timing is not required, but the application should make a
S* reasonable attempt to adhere to the 100mS mark. A missed call should
S* not be "made up" by making mulitple sequential calls.
S*
S* A "polling" driver (one that calls EMAC_serviceCheck() in a tight loop),
S* must also adhere to the 100mS timing on this function.
S*
S* Possible error codes include:
S*   EMAC_ERROR_INVALID   - A calling parameter is invalid
S*
S\*-----------------------------------------------------------------------*/
SCSLAPI uint EMAC_timerTick( Handle hEMAC );
S
N#endif /* EMAC_SUPPORT */
N#endif /* _CSL_EMAC_H_ */
N
N/******************************************************************************\
N* End of emi.h
X
N\******************************************************************************/
N
L 21 "../csl/csl_emac.c" 2
N#include <csl_mdio.h>
L 1 "E:/TI_workspase/c6701_t/csl/csl_mdio.h" 1
N/*****************************************************************************\
N*           Copyright (C) 1999-2003 Texas Instruments Incorporated.
X
N*                           All Rights Reserved
N*------------------------------------------------------------------------------
N* FILENAME...... csl_mdio.h
N* DATE CREATED.. 02/08/2002
N* LAST MODIFIED. 05/09/2003
N*------------------------------------------------------------------------------
N* NOTE:
N*   When used in an multitasking environment, no MDIO function may be
N*   called while another MDIO function is operating on the same device
N*   handle in another thread. It is the responsibility of the application
N*   to assure adherence to this restriction.
N*
N* ALSO NOTE:
N*   When using the CSL EMAC module, the EMAC module will make use of this
N*   MDIO module. It is not necessary for the application to call any MDIO
N*   functions directly when the CSL EMAC module is in use.
N*
N\******************************************************************************/
N#ifndef _CSL_MDIO_H
N#define _CSL_MDIO_H_
N
N#include <csl.h>
N#include <csl_chip.h>
N#include <csl_irq.h>
N#include <csl_mdiohal.h>
L 1 "E:/TI_workspase/c6701_t/csl/csl_mdiohal.h" 1
N/*****************************************************************************\
N*           Copyright (C) 1999-2003 Texas Instruments Incorporated.
X
N*                           All Rights Reserved
N*------------------------------------------------------------------------------
N* FILENAME...... csl_mdiohal.h
N* DATE CREATED.. 02/08/2002
N* LAST MODIFIED. 03/05/2003
N*------------------------------------------------------------------------------
N* REGISTERS/PARAMETERS
N*
N* VERSION           - Module Version Register
N* CONTROL           - Module Control Register
N* ALIVE             - PHY "Alive" Indication Register
N* LINK              - PHY Link Status Register
N* LINKINTRAW        - Link Status Change Interrupt Register
N* LINKINTMASKED     - Link Status Change Interrupt Register (Masked)
N* USERINTRAW        - User Command Complete Interrupt
N* USERINTMASKED     - User Command Complete Interrupt (Masked)
N* USERINTMASKSET    - Enable User Command Complete Interrupt Mask
N* USERINTMASKCLEAR  - Disable User Command Complete Interrupt Mask
N* USERACCESS0       - User Access Register 0
N* USERPHYSEL0       - User PHY Select Register 0
N* USERACCESS1       - User Access Register 1
N* USERPHYSEL1       - User PHY Select Register 1
N*
N*\******************************************************************************/
N#ifndef _CSL_MDIOHAL_H
N#define _CSL_MDIOHAL_H_
N
N#include <csl_stdinc.h>
N#include <csl_chip.h>
N
N#if (MDIO_SUPPORT)
X#if (( ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*1) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0)| ( 1*0)| ( 1*0)| ( 1*0)| ( 1*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) ))
S
S/******************************************************************************\
S* MDIO Register section
X
S\******************************************************************************/
S
S#define _MDIO_BASE_ADDR   0x01c83800u
S
S
S/******************************************************************************\
S* module level register/field access macros
X
S\******************************************************************************/
S
S/* ----------------- */
S/* FIELD MAKE MACROS */
S/* ----------------- */
S
S// User Supplied Value
S#define MDIO_FMK(REG,FIELD,x)\
S  ((x<<_MDIO_##REG##_##FIELD##_SHIFT)&_MDIO_##REG##_##FIELD##_MASK)
X#define MDIO_FMK(REG,FIELD,x)  ((x<<_MDIO_##REG##_##FIELD##_SHIFT)&_MDIO_##REG##_##FIELD##_MASK)
S
S// Symbolic Value Name
S#define MDIO_FMKS(REG,FIELD,SYM)\
S  ((MDIO_##REG##_##FIELD##_##SYM<<_MDIO_##REG##_##FIELD##_SHIFT)\
S  &_MDIO_##REG##_##FIELD##_MASK)
X#define MDIO_FMKS(REG,FIELD,SYM)  ((MDIO_##REG##_##FIELD##_##SYM<<_MDIO_##REG##_##FIELD##_SHIFT)  &_MDIO_##REG##_##FIELD##_MASK)
S
S// MAC Index Flag Flag
S#define MDIO_FMKMIF(MACINDEX)    (1u<<(MACINDEX))
S
S
S/* -------------------------------- */
S/* RAW REGISTER/FIELD ACCESS MACROS */
S/* -------------------------------- */
S
S#define MDIO_ADDR(REG)\
S    _MDIO_##REG##_ADDR
X#define MDIO_ADDR(REG)    _MDIO_##REG##_ADDR
S
S#define MDIO_REG(REG)\
S    *(volatile Uint32*)(_MDIO_##REG##_ADDR)
X#define MDIO_REG(REG)    *(volatile Uint32*)(_MDIO_##REG##_ADDR)
S
S// Standard Registers
S#define MDIO_RGET(REG)\
S    (*(volatile Uint32*)(_MDIO_##REG##_ADDR))
X#define MDIO_RGET(REG)    (*(volatile Uint32*)(_MDIO_##REG##_ADDR))
S
S#define MDIO_RSET(REG,x)\
S    (*(volatile Uint32*)(_MDIO_##REG##_ADDR)=(x))
X#define MDIO_RSET(REG,x)    (*(volatile Uint32*)(_MDIO_##REG##_ADDR)=(x))
S
S#define MDIO_FGET(REG,FIELD)\
S    ((MDIO_RGET(REG)&_MDIO_##REG##_##FIELD##_MASK)\
S    >>_MDIO_##REG##_##FIELD##_SHIFT)
X#define MDIO_FGET(REG,FIELD)    ((MDIO_RGET(REG)&_MDIO_##REG##_##FIELD##_MASK)    >>_MDIO_##REG##_##FIELD##_SHIFT)
S
S#define MDIO_FSET(REG,FIELD,x)\
S    MDIO_RSET(REG,(MDIO_RGET(REG)&~_MDIO_##REG##_##FIELD##_MASK)|\
S    MDIO_FMK(REG,FIELD,x))
X#define MDIO_FSET(REG,FIELD,x)    MDIO_RSET(REG,(MDIO_RGET(REG)&~_MDIO_##REG##_##FIELD##_MASK)|    MDIO_FMK(REG,FIELD,x))
S
S#define MDIO_FSETS(REG,FIELD,SYM)\
S    MDIO_RSET(REG,(MDIO_RGET(REG)&~_MDIO_##REG##_##FIELD##_MASK)|\
S    MDIO_FMKS(REG,FIELD,SYM))
X#define MDIO_FSETS(REG,FIELD,SYM)    MDIO_RSET(REG,(MDIO_RGET(REG)&~_MDIO_##REG##_##FIELD##_MASK)|    MDIO_FMKS(REG,FIELD,SYM))
S
S
S
S/******************************************************************************\
S* _____________________
X
S* |                   |
S* |  VERSION          |
S* |___________________|
S*
S* TXIDVER           - TX Identification and Version Register
S*
S* FIELDS (msb -> lsb)
S* (r)   MODID       - Module Id
S* (r)   REVMAJ      - Major Revision
S* (r)   REVMIN      - Minor Revision
S*
S* MACROS SUPPORTED
S*  MDIO_FMK     y
S*  MDIO_FMKS    .
S*  MDIO_FMKMIF  .
S*  MDIO_ADDR    y
S*  MDIO_REG     y
S*  MDIO_RGET    y
S*  MDIO_RSET    y
S*  MDIO_FGET    y
S*  MDIO_FSET    y
S*  MDIO_FSETS   .
S*
S\******************************************************************************/
S#define _MDIO_VERSION_ADDR                      (_MDIO_BASE_ADDR+0x0000u)
S
S#define MDIO_VERSION                            MDIO_REG(VERSION)
S
S#define _MDIO_VERSION_MODID_MASK                0xFFFF0000u
S#define _MDIO_VERSION_MODID_SHIFT               16u
S#define  MDIO_VERSION_MODID_DEFAULT		0x00000007u	
S
S#define _MDIO_VERSION_REVMAJ_MASK               0x0000FF00u
S#define _MDIO_VERSION_REVMAJ_SHIFT              8u
S#define  MDIO_VERSION_REVMAJ_DEFAULT		0x00000000u	
S
S#define _MDIO_VERSION_REVMIN_MASK               0x000000FFu
S#define _MDIO_VERSION_REVMIN_SHIFT              0u
S#define	 MDIO_VERSION_REVMIN_DEFAULT		0x00000000u	
S
S
S
S/******************************************************************************\
S* _____________________
X
S* |                   |
S* |    CONTROL        |
S* |___________________|
S*
S* CONTROL           - MDIO Control Register
S*
S* FIELDS (msb -> lsb)
S* (r)   IDLE        - MDIO State Machine Idle
S* (rw)  ENABLE      - Enable Control
S* (rw)  PREAMBLE    - Preamble Disable
S* (rwc) FAULT       - Fault Indicator
S* (rw)  FAULTENB    - Fault Detect Enable
S* (rw)  INTTESTENB  - Link Test Enable
S* (rw)  CLKDIV      - Clock Divider
S*
S*
S* MACROS SUPPORTED
S*  MDIO_FMK     y
S*  MDIO_FMKS    y
S*  MDIO_FMKMIF  .
S*  MDIO_ADDR    y
S*  MDIO_REG     y
S*  MDIO_RGET    y
S*  MDIO_RSET    y
S*  MDIO_FGET    y
S*  MDIO_FSET    y
S*  MDIO_FSETS   y
S*
S\******************************************************************************/
S#define _MDIO_CONTROL_ADDR                      (_MDIO_BASE_ADDR+0x0004u)
S
S#define MDIO_CONTROL                            MDIO_REG(TXCONTROL)
S
S#define _MDIO_CONTROL_IDLE_MASK                 0x80000000u
S#define _MDIO_CONTROL_IDLE_SHIFT                31u
S#define  MDIO_CONTROL_IDLE_DEFAULT		0x00000001u	
S#define MDIO_CONTROL_IDLE_YES                   1u
S#define MDIO_CONTROL_IDLE_NO                    0u
S
S#define _MDIO_CONTROL_ENABLE_MASK               0x40000000u
S#define _MDIO_CONTROL_ENABLE_SHIFT              30u
S#define  MDIO_CONTROL_ENABLE_DEFAULT		0x00000000u	
S#define MDIO_CONTROL_ENABLE_YES                 1u
S#define MDIO_CONTROL_ENABLE_NO                  0u
S
S#define _MDIO_CONTROL_PREAMBLE_MASK             0x00100000u
S#define _MDIO_CONTROL_PREAMBLE_SHIFT            20u
S#define  MDIO_CONTROL_PREAMBLE_DEFAULT		0x00000000u	
S#define MDIO_CONTROL_PREAMBLE_DISABLED          1u
S#define MDIO_CONTROL_PREAMBLE_ENABLED           0u
S
S#define _MDIO_CONTROL_FAULT_MASK                0x00080000u
S#define _MDIO_CONTROL_FAULT_SHIFT               19u
S#define  MDIO_CONTROL_FAULT_DEFAULT		0x00000000u	
S#define MDIO_CONTROL_FAULT_YES                  1u
S#define MDIO_CONTROL_FAULT_NO                   0u
S
S#define _MDIO_CONTROL_FAULTENB_MASK             0x00040000u
S#define _MDIO_CONTROL_FAULTENB_SHIFT            18u
S#define  MDIO_CONTROL_FAULTENB_DEFAULT		0x00000000u	
S#define MDIO_CONTROL_FAULTENB_YES               1u
S#define MDIO_CONTROL_FAULTENB_NO                0u
S
S#define _MDIO_CONTROL_INTTESTENB_MASK           0x00020000u
S#define _MDIO_CONTROL_INTTESTENB_SHIFT          17u
S#define  MDIO_CONTROL_INTTESTENB_DEFAULT	0x00000000u	
S#define MDIO_CONTROL_INTTESTENB_YES             1u
S#define MDIO_CONTROL_INTTESTENB_NO              0u
S
S#define _MDIO_CONTROL_CLKDIV_MASK               0x000000FFu
S#define _MDIO_CONTROL_CLKDIV_SHIFT              0u
S#define  MDIO_CONTROL_CLKDIV_DEFAULT		0x000000FFu	
S
S
S
S/******************************************************************************\
S* _____________________
X
S* |                   |
S* |   ALIVE           |
S* |   LINK            |
S* |___________________|
S*
S* ALIVE             - PHY "Alive" Indication Register
S* LINK              - PHY Link Status Register
S*
S* FIELDS (msb -> lsb)
S*  PHY Index Flags (0-31) (use MDIO_FMKMIF)
S*
S* MACROS SUPPORTED
S*  MDIO_FMK     .
S*  MDIO_FMKS    .
S*  MDIO_FMKMIF  y
S*  MDIO_ADDR    y
S*  MDIO_REG     y
S*  MDIO_RGET    y
S*  MDIO_RSET    y
S*  MDIO_FGET    .
S*  MDIO_FSET    .
S*  MDIO_FSETS   .
S*
S\******************************************************************************/
S#define _MDIO_ALIVE_ADDR                        (_MDIO_BASE_ADDR+0x0008u)
S#define _MDIO_LINK_ADDR                         (_MDIO_BASE_ADDR+0x000Cu)
S
S#define MDIO_ALIVE                              MDIO_REG(ALIVE)
S#define MDIO_LINK                               MDIO_REG(LINK)
S
S
S
S/******************************************************************************\
S* _____________________
X
S* |                   |
S* | LINKINTRAW        |
S* | LINKINTMASKED     |
S* | USERINTRAW        |
S* | USERINTMASKED     |
S* | USERINTMASKSET    |
S* | USERINTMASKCLEAR  |
S* |___________________|
S*
S* LINKINTRAW        - Link Status Change Interrupt Register
S* LINKINTMASKED     - Link Status Change Interrupt Register (Masked)
S* USERINTRAW        - User Command Complete Interrupt
S* USERINTMASKED     - User Command Complete Interrupt (Masked)
S* USERINTMASKSET    - Enable User Command Complete Interrupt Mask
S* USERINTMASKCLEAR  - Disable User Command Complete Interrupt Mask
S*
S* FIELDS (msb -> lsb)
S*       MAC0        - Mac 0 Flag (yes/no)
S*       MAC1        - Mac 1 Flag (yes/no)
S*
S* MACROS SUPPORTED
S*  MDIO_FMK     y
S*  MDIO_FMKS    y
S*  MDIO_FMKMIF  .
S*  MDIO_ADDR    y
S*  MDIO_REG     y
S*  MDIO_RGET    y
S*  MDIO_RSET    y
S*  MDIO_FGET    y
S*  MDIO_FSET    y
S*  MDIO_FSETS   .
S*
S\******************************************************************************/
S#define _MDIO_LINKINTRAW_ADDR                   (_MDIO_BASE_ADDR+0x0010u)
S#define _MDIO_LINKINTMASKED_ADDR                (_MDIO_BASE_ADDR+0x0014u)
S#define _MDIO_USERINTRAW_ADDR                   (_MDIO_BASE_ADDR+0x0020u)
S#define _MDIO_USERINTMASKED_ADDR                (_MDIO_BASE_ADDR+0x0024u)
S#define _MDIO_USERINTMASKSET_ADDR               (_MDIO_BASE_ADDR+0x0028u)
S#define _MDIO_USERINTMASKCLEAR_ADDR             (_MDIO_BASE_ADDR+0x002Cu)
S
S#define MDIO_LINKINTRAW                         MDIO_REG(LINKINT)
S#define MDIO_LINKINTMASKED                      MDIO_REG(LINKINTMASKED)
S#define MDIO_USERINTRAW                         MDIO_REG(USERINTRAW)
S#define MDIO_USERINTMASKED                      MDIO_REG(USERINTMASKED)
S#define MDIO_USERINTMASKSET                     MDIO_REG(USERINTMASKSET)
S#define MDIO_USERINTMASKCLEAR                   MDIO_REG(USERINTMASKCLEAR)
S
S#define _MDIO_LINKINTRAW_MAC0_MASK              0x00000001u
S#define _MDIO_LINKINTRAW_MAC0_SHIFT             0u
S#define  MDIO_LINKINTRAW_MAC0_DEFAULT		0x00000000u	
S#define _MDIO_LINKINTRAW_MAC1_MASK              0x00000002u
S#define _MDIO_LINKINTRAW_MAC1_SHIFT             1u
S#define  MDIO_LINKINTRAW_MAC1_DEFAULT		0x00000000u	
S
S#define MDIO_LINKINTRAW_MAC0_YES                1u
S#define MDIO_LINKINTRAW_MAC0_NO                 0u
S#define MDIO_LINKINTRAW_MAC1_YES                1u
S#define MDIO_LINKINTRAW_MAC1_NO                 0u
S
S#define _MDIO_LINKINTMASKED_MAC0_MASK           0x00000001u
S#define _MDIO_LINKINTMASKED_MAC0_SHIFT          0u
S#define  MDIO_LINKINTMASKED_MAC0_DEFAULT	0x00000000u	
S#define _MDIO_LINKINTMASKED_MAC1_MASK           0x00000002u
S#define _MDIO_LINKINTMASKED_MAC1_SHIFT          1u
S#define  MDIO_LINKINTMASKED_MAC1_DEFAULT	0x00000000u	
S
S#define MDIO_LINKINTMASKED_MAC0_YES             1u
S#define MDIO_LINKINTMASKED_MAC0_NO              0u
S#define MDIO_LINKINTMASKED_MAC1_YES             1u
S#define MDIO_LINKINTMASKED_MAC1_NO              0u
S
S#define _MDIO_USERINTRAW_MAC0_MASK              0x00000001u
S#define _MDIO_USERINTRAW_MAC0_SHIFT             0u
S#define  MDIO_USERINTRAW_MAC0_DEFAULT		0x00000000u	
S#define _MDIO_USERINTRAW_MAC1_MASK              0x00000002u
S#define _MDIO_USERINTRAW_MAC1_SHIFT             1u
S#define	 MDIO_USERINTRAW_MAC1_DEFAULT		0x00000000u	
S
S#define MDIO_USERINTRAW_MAC0_YES                1u
S#define MDIO_USERINTRAW_MAC0_NO                 0u
S#define MDIO_USERINTRAW_MAC1_YES                1u
S#define MDIO_USERINTRAW_MAC1_NO                 0u
S
S#define _MDIO_USERINTMASKED_MAC0_MASK           0x00000001u
S#define _MDIO_USERINTMASKED_MAC0_SHIFT          0u
S#define  MDIO_USERINTMASKED_MAC0_DEFAULT	0x00000000u
S#define _MDIO_USERINTMASKED_MAC1_MASK           0x00000002u
S#define _MDIO_USERINTMASKED_MAC1_SHIFT          1u
S#define  MDIO_USERINTMASKED_MAC1_DEFAULT	0x00000000u	
S
S#define MDIO_USERINTMASKED_MAC0_YES             1u
S#define MDIO_USERINTMASKED_MAC0_NO              0u
S#define MDIO_USERINTMASKED_MAC1_YES             1u
S#define MDIO_USERINTMASKED_MAC1_NO              0u
S
S#define _MDIO_USERINTMASKSET_MAC0_MASK          0x00000001u
S#define _MDIO_USERINTMASKSET_MAC0_SHIFT         0u
S#define  MDIO_USERINTMASKSET_MAC0_DEFAULT	0x00000000u
S#define _MDIO_USERINTMASKSET_MAC1_MASK          0x00000002u
S#define _MDIO_USERINTMASKSET_MAC1_SHIFT         1u
S#define  MDIO_USERINTMASKSET_MAC1_DEFAULT	0x00000000u	
S
S#define MDIO_USERINTMASKSET_MAC0_YES            1u
S#define MDIO_USERINTMASKSET_MAC0_NO             0u
S#define MDIO_USERINTMASKSET_MAC1_YES            1u
S#define MDIO_USERINTMASKSET_MAC1_NO             0u
S
S#define _MDIO_USERINTMASKCLEAR_MAC0_MASK        0x00000001u
S#define _MDIO_USERINTMASKCLEAR_MAC0_SHIFT       0u
S#define  MDIO_USERINTMASKCLEAR_MAC0_DEFAULT	0x00000000u	
S#define _MDIO_USERINTMASKCLEAR_MAC1_MASK        0x00000002u
S#define _MDIO_USERINTMASKCLEAR_MAC1_SHIFT       1u
S#define  MDIO_USERINTMASKCLEAR_MAC1_DEFAULT	0x00000000u	
S
S#define MDIO_USERINTMASKCLEAR_MAC0_YES          1u
S#define MDIO_USERINTMASKCLEAR_MAC0_NO           0u
S#define MDIO_USERINTMASKCLEAR_MAC1_YES          1u
S#define MDIO_USERINTMASKCLEAR_MAC1_NO           0u
S
S
S
S/******************************************************************************\
S* _____________________
X
S* |                   |
S* |   USERACCESS0     |
S* |   USERACCESS1     |
S* |___________________|
S*
S* USERACCESS0       - User Access Register 0
S* USERACCESS1       - User Access Register 1
S*
S* FIELDS (msb -> lsb)
S* (rws) GO          - Go Bit
S* (rw)  WRITE       - Write Enable
S* (r)   ACK         - Acknowledge
S* (rw)  REGADR      - PHY Register Address
S* (rw)  PHYADR      - PHY Device Address
S* (rw)  DATA        - User Data to Read/Write
S*
S* MACROS SUPPORTED
S*  MDIO_FMK     y
S*  MDIO_FMKS    .
S*  MDIO_FMKMIF  .
S*  MDIO_ADDR    y
S*  MDIO_REG     y
S*  MDIO_RGET    y
S*  MDIO_RSET    y
S*  MDIO_FGET    y
S*  MDIO_FSET    y
S*  MDIO_FSETS   .
S*
S\******************************************************************************/
S#define _MDIO_USERACCESS0_ADDR                  (_MDIO_BASE_ADDR+0x0080u)
S#define _MDIO_USERACCESS1_ADDR                  (_MDIO_BASE_ADDR+0x0088u)
S
S#define  MDIO_USERACCESS0                       MDIO_REG(USERACCESS0)
S#define  MDIO_USERACCESS1                       MDIO_REG(USERACCESS1)
S
S#define _MDIO_USERACCESS0_GO_MASK               0x80000000u
S#define _MDIO_USERACCESS0_GO_SHIFT              31u
S#define  MDIO_USERACCESS0_GO_DEFAULT		0x00000000u
S#define _MDIO_USERACCESS0_WRITE_MASK            0x40000000u
S#define _MDIO_USERACCESS0_WRITE_SHIFT           30u
S#define  MDIO_USERACCESS0_WRITE_DEFAULT		0x00000000u
S#define _MDIO_USERACCESS0_ACK_MASK              0x20000000u
S#define _MDIO_USERACCESS0_ACK_SHIFT             29u
S#define  MDIO_USERACCESS0_ACK_DEFAULT		0x00000000u
S#define _MDIO_USERACCESS0_REGADR_MASK           0x03E00000u
S#define _MDIO_USERACCESS0_REGADR_SHIFT          21u
S#define  MDIO_USERACCESS0_REGADR_DEFAULT	0x00000000u
S#define _MDIO_USERACCESS0_PHYADR_MASK           0x001F0000u
S#define _MDIO_USERACCESS0_PHYADR_SHIFT          16u
S#define  MDIO_USERACCESS0_PHYADR_DEFAULT	0x00000000u
S#define _MDIO_USERACCESS0_DATA_MASK             0x0000FFFFu
S#define _MDIO_USERACCESS0_DATA_SHIFT            0u
S#define  MDIO_USERACCESS0_DATA_DEFAULT		0x00000000u
S
S#define _MDIO_USERACCESS1_GO_MASK               0x80000000u
S#define _MDIO_USERACCESS1_GO_SHIFT              31u
S#define  MDIO_USERACCESS1_GO_DEFAULT		0x00000000u
S#define _MDIO_USERACCESS1_WRITE_MASK            0x40000000u
S#define _MDIO_USERACCESS1_WRITE_SHIFT           30u
S#define  MDIO_USERACCESS1_WRITE_DEFAULT		0x00000000u
S#define _MDIO_USERACCESS1_ACK_MASK              0x20000000u
S#define _MDIO_USERACCESS1_ACK_SHIFT             29u
S#define  MDIO_USERACCESS1_ACK_DEFAULT		0x00000000u
S#define _MDIO_USERACCESS1_REGADR_MASK           0x03E00000u
S#define _MDIO_USERACCESS1_REGADR_SHIFT          21u
S#define  MDIO_USERACCESS1_REGADR_DEFAULT	0x00000000u
S#define _MDIO_USERACCESS1_PHYADR_MASK           0x001F0000u
S#define _MDIO_USERACCESS1_PHYADR_SHIFT          16u
S#define  MDIO_USERACCESS1_PHYADR_DEFAULT	0x00000000u
S#define _MDIO_USERACCESS1_DATA_MASK             0x0000FFFFu
S#define _MDIO_USERACCESS1_DATA_SHIFT            0u
S#define  MDIO_USERACCESS1_DATA_DEFAULT		0x00000000u
S
S
S/******************************************************************************\
S* _____________________
X
S* |                   |
S* |   USERPHYSEL0     |
S* |   USERPHYSEL1     |
S* |___________________|
S*
S* USERPHYSEL0       - User PHY Select Register 0
S* USERPHYSEL1       - User PHY Select Register 1
S*
S* FIELDS (msb -> lsb)
S* (rw)  LINKSEL     - Link Detect Type Selection
S* (rw)  LINKINTENB  - Link Interrupt Enable
S* (rw)  PHYADDR     - Address (0-31) of Phy to Use
S*
S* MACROS SUPPORTED
S*  MDIO_FMK     y
S*  MDIO_FMKS    y
S*  MDIO_FMKMIF  .
S*  MDIO_ADDR    y
S*  MDIO_REG     y
S*  MDIO_RGET    y
S*  MDIO_RSET    y
S*  MDIO_FGET    y
S*  MDIO_FSET    y
S*  MDIO_FSETS   y
S*
S\******************************************************************************/
S#define _MDIO_USERPHYSEL0_ADDR                  (_MDIO_BASE_ADDR+0x0084u)
S#define _MDIO_USERPHYSEL1_ADDR                  (_MDIO_BASE_ADDR+0x008Cu)
S
S#define  MDIO_USERPHYSEL0                       MDIO_REG(USERPHYSEL0)
S#define  MDIO_USERPHYSEL1                       MDIO_REG(USERPHYSEL1)
S
S#define _MDIO_USERPHYSEL0_LINKSEL_MASK          0x00000080u
S#define _MDIO_USERPHYSEL0_LINKSEL_SHIFT         7u
S#define  MDIO_USERPHYSEL0_LINKSEL_DEFAULT	0x00000000u
S#define MDIO_USERPHYSEL0_LINKSEL_MLINK          1u
S#define MDIO_USERPHYSEL0_LINKSEL_MDIO           0u
S
S#define _MDIO_USERPHYSEL0_LINKINTENB_MASK       0x00000040u
S#define _MDIO_USERPHYSEL0_LINKINTENB_SHIFT      6u
S#define  MDIO_USERPHYSEL0_LINKINTENB_DEFAULT	0x00000000u
S#define MDIO_USERPHYSEL0_LINKINTENB_ENABLE      1u
S#define MDIO_USERPHYSEL0_LINKINTENB_DISABLE     0u
S
S#define _MDIO_USERPHYSEL0_PHYADDR_MASK          0x0000001Fu
S#define _MDIO_USERPHYSEL0_PHYADDR_SHIFT         0u
S#define  MDIO_USERPHYSEL0_PHYADDR_DEFAULT	0x00000000u
S
S#define _MDIO_USERPHYSEL1_LINKSEL_MASK          0x00000080u
S#define _MDIO_USERPHYSEL1_LINKSEL_SHIFT         7u
S#define  MDIO_USERPHYSEL1_LINKSEL_DEFAULT	0x00000000u
S#define MDIO_USERPHYSEL1_LINKSEL_MLINK          1u
S#define MDIO_USERPHYSEL1_LINKSEL_MDIO           0u
S
S#define _MDIO_USERPHYSEL1_LINKINTENB_MASK       0x00000040u
S#define _MDIO_USERPHYSEL1_LINKINTENB_SHIFT      6u
S#define  MDIO_USERPHYSEL1_LINKINTENB_DEFAULT	0x00000000u
S#define MDIO_USERPHYSEL1_LINKINTENB_ENABLE      1u
S#define MDIO_USERPHYSEL1_LINKINTENB_DISABLE     0u
S
S#define _MDIO_USERPHYSEL1_PHYADDR_MASK          0x0000001Fu
S#define _MDIO_USERPHYSEL1_PHYADDR_SHIFT         0u
S#define  MDIO_USERPHYSEL1_PHYADDR_DEFAULT	0x00000000u
S
S
N#endif /* MDIO_SUPPORT */
N
N#endif /* _CSL_MDIOHAL_H_ */
N/******************************************************************************\
N* End of csl_mdiohal.h
X
N\******************************************************************************/
N
N
N
N
L 28 "E:/TI_workspase/c6701_t/csl/csl_mdio.h" 2
N
N
N#if (MDIO_SUPPORT)
X#if (( ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*1) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0)| ( 1*0)| ( 1*0)| ( 1*0)| ( 1*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) ))
S/*-----------------------------------------------------------------------*\
S* NEW TYPES
X
S\*-----------------------------------------------------------------------*/
S#ifndef _CSL_EMAC_TYPES
S#define _CSL_EMAC_TYPES
Stypedef unsigned int uint;
Stypedef void * Handle;
S#endif
S
S/*-----------------------------------------------------------------------*\
S* MDIO Configuration Mode Flags
X
S*
S* These flags determine how the MDIO module behaves
S\*-----------------------------------------------------------------------*/
S#define MDIO_MODEFLG_AUTONEG     0x0001 /* Use Autonegotiate         */
S/* The following bits are used for manual and fallback configuration */
S#define MDIO_MODEFLG_HD10        0x0002 /* Use 10Mb/s Half Duplex    */
S#define MDIO_MODEFLG_FD10        0x0004 /* Use 10Mb/s Full Duplex    */
S#define MDIO_MODEFLG_HD100       0x0008 /* Use 100Mb/s Half Duplex   */
S#define MDIO_MODEFLG_FD100       0x0010 /* Use 100Mb/s Full Duplex   */
S#define MDIO_MODEFLG_LOOPBACK    0x0020 /* Use PHY Loopback          */
S/* The following bits are reserved for use by the MDIO module */
S#define MDIO_MODEFLG_NWAYACTIVE  0x0040 /* NWAY is currently active  */
S
S/*-----------------------------------------------------------------------*\
S* MDIO Link Status Values
X
S*
S* These values indicate current PHY link status
S\*-----------------------------------------------------------------------*/
S#define MDIO_LINKSTATUS_NOLINK   0
S#define MDIO_LINKSTATUS_HD10     1
S#define MDIO_LINKSTATUS_FD10     2
S#define MDIO_LINKSTATUS_HD100    3
S#define MDIO_LINKSTATUS_FD100    4
S
S/*-----------------------------------------------------------------------*\
S* MDIO Events
X
S*
S* These events are returned by MDIO_timerTick() to allow the application
S* (or EMAC) to track MDIO status.
S\*-----------------------------------------------------------------------*/
S#define MDIO_EVENT_NOCHANGE      0   /* No change from previous status */
S#define MDIO_EVENT_LINKDOWN      1   /* Link down event                */
S#define MDIO_EVENT_LINKUP        2   /* Link (or re-link) event        */
S#define MDIO_EVENT_PHYERROR      3   /* No PHY connected               */
S
S
S/*-----------------------------------------------------------------------*\
S* MDIO_open()
X
S*
S* Opens the MDIO peripheral and start searching for a PHY device.
S*
S* It is assumed that the MDIO module is reset prior to calling this
S* function.
S\*-----------------------------------------------------------------------*/
SCSLAPI Handle MDIO_open( uint mdioModeFlags );
S
S/*-----------------------------------------------------------------------*\
S* MDIO_close()
X
S*
S* Close the MDIO peripheral and disable further operation.
S\*-----------------------------------------------------------------------*/
SCSLAPI void MDIO_close( Handle hMDIO );
S
S/*-----------------------------------------------------------------------*\
S* MDIO_getStatus()
X
S*
S* Called to get the status of the MDIO/PHY
S\*-----------------------------------------------------------------------*/
SCSLAPI void MDIO_getStatus( Handle hMDIO, uint *pPhy, uint *pLinkStatus );
S
S/*-----------------------------------------------------------------------*\
S* MDIO_timerTick()
X
S*
S* Called to signify that approx 100mS have elapsed
S*
S* Returns an MDIO event code (see MDIO Events in CSL_MDIO.H).
S\*-----------------------------------------------------------------------*/
SCSLAPI uint MDIO_timerTick( Handle hMDIO );
S
S/*-----------------------------------------------------------------------*\
S* MDIO_initPHY()
X
S*
S* Force a switch to the specified PHY, and start negotiation.
S*
S* This call is only used to override the normal PHY detection process.
S*
S* Returns 1 if the PHY selection completed OK, else 0
S\*-----------------------------------------------------------------------*/
SCSLAPI uint MDIO_initPHY( Handle hMDIO, uint phyAddr );
S
S/*-----------------------------------------------------------------------*\
S* MDIO_phyRegRead()
X
S*
S* Raw data read of a PHY register.
S*
S* Returns 1 if the PHY ACK'd the read, else 0
S\*-----------------------------------------------------------------------*/
SCSLAPI uint MDIO_phyRegRead( uint phyIdx, uint phyReg, Uint16 *pData );
S
S/*-----------------------------------------------------------------------*\
S* MDIO_phyRegWrite()
X
S*
S* Raw data write  of a PHY register.
S*
S* Returns 1 if the PHY ACK'd the write, else 0
S\*-----------------------------------------------------------------------*/
SCSLAPI uint MDIO_phyRegWrite( uint phyIdx, uint phyReg, Uint16 data );
S
N#endif /* MDIO_SUPPORT */
N#endif /* _CSL_MDIO_H_ */
N/******************************************************************************\
N* End of mdio.h
X
N\******************************************************************************/
L 22 "../csl/csl_emac.c" 2
N
N#if (EMAC_SUPPORT)
X#if (( ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*1) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0)| ( 1*0)| ( 1*0)| ( 1*0)| ( 1*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) ))
Sextern void   *memset(void *_mem, int _ch, uint _n);
S
S/*
S// We keep a local packet queue for transmit and receive packets.
S// The queue structure is OS independent.
S*/
S
S/*
S// Packet Queue
S*/
Stypedef struct _pktq {
S  uint              Count;      // Number of packets in queue
S  EMAC_Pkt          *pHead;     // Pointer to first packet
S  EMAC_Pkt          *pTail;     // Pointer to last packet
S} PKTQ;
S
S/*
S// Queue Helper Functions
S*/
Sstatic EMAC_Pkt *pqPop( PKTQ *pq );
Sstatic void pqPush( PKTQ *pq, EMAC_Pkt *pPktHdr );
Sstatic void pqPushChain( PKTQ *pq, EMAC_Pkt *pPktHdrFirst,
S                         EMAC_Pkt *pPktHdrLast, uint Count );
S
S
S/*
S// Transmit/Receive Descriptor Channel Structure
S// (One receive and up to 8 transmit in this driver)
S*/
Stypedef struct _EMAC_DescCh {
S    struct _EMAC_Device *pd;      /* Pointer to parent structure   */
S    PKTQ            DescQueue;    /* Packets queued as desc        */
S    PKTQ            WaitQueue;    /* Packets waiting for TX desc   */
S    uint            ChannelIndex; /* Channel index 0-7             */
S    uint            DescMax;      /* Max number of desc (buffs)    */
S    uint            DescCount;    /* Current number of desc        */
S    EMAC_Desc       *pDescFirst;  /* First desc location           */
S    EMAC_Desc       *pDescLast;   /* Last desc location            */
S    EMAC_Desc       *pDescRead;   /* Location to read next desc    */
S    EMAC_Desc       *pDescWrite;  /* Location to write nest desc   */
S} EMAC_DescCh;
S
S
S/*
S// Main Device Instance Structure
S*/
Stypedef struct _EMAC_Device {
S    Uint32          DevMagic;     /* Magic ID for this instance    */
S    Handle          hApplication; /* Calling Application's Handle  */
S    Handle          hMDIO;        /* Handle to MDIO Module      */
S    uint            RxFilter;     /* Current RX filter value       */
S    uint            PktMTU;       /* Max physical packet size      */
S    Uint32          MacHash1;     /* Hash value cache              */
S    Uint32          MacHash2;     /* Hash value cache              */
S    Uint32          FatalError;   /* Fatal Error Code              */
S    EMAC_Config     Config;       /* Original User Configuration   */
S    EMAC_Statistics Stats;        /* Current running statistics    */
S    EMAC_DescCh     RxCh;         /* Receive channel status        */
S    EMAC_DescCh     TxCh[8];      /* Transmit channel status       */
S} EMAC_Device;
S
S
S/*
S// Although the EMAC API is defined to support multiple device instances,
S// this version supports a single device instance
S*/
S
S/* Local copy of the EMAC device instance */
Sstatic uint             openFlag = 0;
Sstatic EMAC_Device      localDev;
S#define EMAC_DEVMAGIC   0x0aceface
S#define EMAC_NUMSTATS   36         /* The number of statistics regs */
S
S/*
S// Local Helper Functions
S*/
Sstatic void emacUpdateStats( EMAC_Device *pd );
Sstatic void emacEnqueueTx( EMAC_DescCh *pdc );
Sstatic void emacDequeueTx( EMAC_DescCh *pdc, EMAC_Desc *pDescLast );
Sstatic void emacEnqueueRx( EMAC_DescCh *pdc, uint fRestart );
Sstatic void emacDequeueRx( EMAC_DescCh *pdc, EMAC_Desc *pDescAck );
S
S
S/*--------------------------------------------------------------------*\
S* pqPop()
X
S*
S* Pop a desc buffer off a queue
S\*--------------------------------------------------------------------*/
Sstatic EMAC_Pkt *pqPop( PKTQ *pq )
S{
S    EMAC_Pkt *pPktHdr;
S
S    pPktHdr = pq->pHead;
S
S    if( pPktHdr )
S    {
S        pq->pHead = pPktHdr->pNext;
S        pq->Count--;
S    }
S
S    pPktHdr->pPrev = pPktHdr->pNext = 0;
S
S    return( pPktHdr );
S}
S
S/*--------------------------------------------------------------------*\
S* pqPush()
X
S*
S* Push a desc buffer onto a queue
S\*--------------------------------------------------------------------*/
Sstatic void pqPush( PKTQ *pq, EMAC_Pkt *pPktHdr )
S{
S    pPktHdr->pNext = 0;
S
S    if( !pq->pHead )
S    {
S        // Queue is empty - Initialize it with this one packet
S        pq->pHead = pPktHdr;
S        pq->pTail = pPktHdr;
S    }
S    else
S    {
S        // Queue is not empty - Push onto END
S        pq->pTail->pNext = pPktHdr;
S        pq->pTail        = pPktHdr;
S    }
S    pq->Count++;
S}
S
S/*--------------------------------------------------------------------*\
S* pqPushChain()
X
S*
S* Push a desc buffer chain onto a queue
S\*--------------------------------------------------------------------*/
Sstatic void pqPushChain( PKTQ *pq, EMAC_Pkt *pPktHdrFirst,
S                         EMAC_Pkt *pPktHdrLast, uint Count )
S{
S    pPktHdrLast->pNext = 0;
S
S    if( !pq->pHead )
S    {
S        // Queue is empty - Initialize it with this one packet
S        pq->pHead = pPktHdrFirst;
S        pq->pTail = pPktHdrLast;
S    }
S    else
S    {
S        // Queue is not empty - Push onto END
S        pq->pTail->pNext = pPktHdrFirst;
S        pq->pTail        = pPktHdrLast;
S    }
S    pq->Count += Count;
S}
S
S
S/*--------------------------------------------------------------------*\
S* emacUpdateStats()
X
S*
S* Update our local copy of the statistics
S\*--------------------------------------------------------------------*/
Sstatic void emacUpdateStats( EMAC_Device *pd )
S{
S    int             i;
S    volatile Uint32 *pRegAddr;
S    Uint32          *pStatAddr;
S    Uint32          statval;
S
S    pRegAddr = EMAC_ADDR(RXGOODFRAMES);
S    pStatAddr = (Uint32 *)(&pd->Stats);
S
S    /*
S    // There are "EMAC_NUMSTATS" statistics registers
S    // Note that when MIIEN is set in MACCONTROL, these registers
S    // are "write to decrement".
S    */
S    for( i=0; i<EMAC_NUMSTATS; i++ )
S    {
S        statval = *pRegAddr;
S        *pRegAddr++ = statval;
S        statval += *pStatAddr;
S        *pStatAddr++ = statval;
S    }
S}
S
S/*--------------------------------------------------------------------*\
S* emacEnqueueTx()
X
S*
S* Enqueue a TX packet and restart transmitter as needed
S\*--------------------------------------------------------------------*/
Sstatic void emacEnqueueTx( EMAC_DescCh *pdc )
S{
S    EMAC_Desc   *pDescOrg,*pDescThis;
S    EMAC_Pkt     *pPkt;
S    uint        PktFrags;
S    uint        CountOrg;
S
S    /*
S    // We need to be careful that we don't post half a packet to
S    // the list. Otherwise; we just fill in as much packet descriptor
S    // stuff as we can.
S    */
S    pDescOrg = pdc->pDescWrite;
S    CountOrg = pdc->DescCount;
S
S    /* Try to post any waiting packets */
S    while( pdc->WaitQueue.Count )
S    {
S        /* See if we have enough room for a new packet */
S        pPkt = pdc->WaitQueue.pHead;
S        PktFrags = pPkt->PktFrags;
S
S        /* If we don't have room, break out */
S        if( (PktFrags+pdc->DescCount) > pdc->DescMax )
S            break;
S
S        /* The next packet will fit, post it. */
S        while( PktFrags )
S        {
S            /* Pop the next frag off the wait queue */
S            pPkt = pqPop( &pdc->WaitQueue );
S
S            /* Assign the pointer to "this" desc */
S            pDescThis = pdc->pDescWrite;
S
S            /* Move the write pointer and bump count */
S            if( pdc->pDescWrite == pdc->pDescLast )
S                pdc->pDescWrite = pdc->pDescFirst;
S            else
S                pdc->pDescWrite++;
S            pdc->DescCount++;
S
S            /*
S            // If this is the last frag, the forward pointer is NULL
S            // Otherwise; this desc points to the next frag's desc
S            */
S            if( PktFrags==1 )
S                pDescThis->pNext = 0;
S            else
S                pDescThis->pNext = pdc->pDescWrite;
S
S            pDescThis->pBuffer   = pPkt->pDataBuffer + pPkt->DataOffset;
S            pDescThis->BufOffLen = pPkt->ValidLen;
S
S            if( pPkt->Flags & EMAC_PKT_FLAGS_SOP )
S                pDescThis->PktFlgLen = ((pPkt->Flags&
S                                       (EMAC_PKT_FLAGS_SOP|EMAC_PKT_FLAGS_EOP))
S                                       |pPkt->PktLength|EMAC_DSC_FLAG_OWNER);
S            else
S                pDescThis->PktFlgLen = (pPkt->Flags&EMAC_PKT_FLAGS_EOP)
S                                       |EMAC_DSC_FLAG_OWNER;
S
S            /* Enqueue this frag onto the desc queue */
S            pqPush( &pdc->DescQueue, pPkt );
S            PktFrags--;
S        }
S    }
S
S    /* If we posted anything, chain on the list or start the transmitter */
S    if( CountOrg != pdc->DescCount )
S    {
S        if( CountOrg )
S        {
S            /*
S            // Transmitter is already running. Just tack this packet on
S            // to the end of the list (we need to "back up" one descriptor)
S            */
S            if( pDescOrg == pdc->pDescFirst )
S                pDescThis = pdc->pDescLast;
S            else
S                pDescThis = pDescOrg - 1;
S            pDescThis->pNext = pDescOrg;
S        }
S        else
S        {
S            /* Transmitter is not running, start it up */
S            EMAC_RSETI( TXHDP, pdc->ChannelIndex, (Uint32)pDescOrg );
S        }
S    }
S}
S
S/*--------------------------------------------------------------------*\
S* emacDequeueTx()
X
S*
S* Dequeue all completed TX packets and return buffers to application
S\*--------------------------------------------------------------------*/
Sstatic void emacDequeueTx( EMAC_DescCh *pdc, EMAC_Desc *pDescAck )
S{
S    EMAC_Pkt     *pPkt;
S    Uint32      PktFlgLen;
S    register uint  i,j = (uint)pdc->pDescRead;
S
S    /* Get the status of the ACK descriptor */
S    PktFlgLen = pDescAck->PktFlgLen;
S
S    /* Calc the new "Read" descriptor */
S    if( pDescAck == pdc->pDescLast )
S        pdc->pDescRead = pdc->pDescFirst;
S    else
S        pdc->pDescRead = pDescAck+1;
S
S    i = (uint)pdc->pDescRead;
S
S    /* Turn i into a descriptor count */
S    if( j < i )
S        i = (i-j)/sizeof(EMAC_Desc);
S    else
S        i = pdc->DescMax - ((j-i)/sizeof(EMAC_Desc));
S
S    pdc->DescCount-=i;
S
S    /* Pop & Free Buffers 'till the last Descriptor */
S    while(i--)
S    {
S        /* Recover the buffer and free it */
S        pPkt = pqPop( &pdc->DescQueue );
S        if( pPkt )
S            (*localDev.Config.pfcbFreePacket)(pdc->pd->hApplication,pPkt);
S    }
S
S    /* If the transmitter stopped and we have more descriptors, then restart */
S    if( (PktFlgLen & EMAC_DSC_FLAG_EOQ) && pdc->DescCount )
S        EMAC_RSETI( TXHDP, pdc->ChannelIndex, (Uint32)pdc->pDescRead );
S
S    /* Try to post any waiting TX packets */
S    if( pdc->WaitQueue.Count )
S        emacEnqueueTx( pdc );
S}
S
S
S/*--------------------------------------------------------------------*\
S* emacEnqueueRx()
X
S*
S* Fill any empty RX descriptors with new buffers from the application
S\*--------------------------------------------------------------------*/
Sstatic void emacEnqueueRx( EMAC_DescCh *pdc, uint fRestart )
S{
S    EMAC_Pkt     *pPkt;
S    EMAC_Desc   *pDesc;
S    uint        CountOrg;
S
S    /* Keep the old count around */
S    CountOrg = pdc->DescCount;
S
S    /* Fill RX Packets Until Full */
S    while( pdc->DescCount < pdc->DescMax )
S    {
S        /* Get a buffer from the application */
S        pPkt = (*localDev.Config.pfcbGetPacket)(pdc->pd->hApplication);
S
S        /* If no more buffers are available, break out of loop */
S        if( !pPkt )
S            break;
S
S        /* Fill in the descriptor for this buffer */
S        pDesc = pdc->pDescWrite;
S
S        /* Move the write pointer and bump count */
S        if( pdc->pDescWrite == pdc->pDescLast )
S            pdc->pDescWrite = pdc->pDescFirst;
S        else
S            pdc->pDescWrite++;
S        pdc->DescCount++;
S
S        /* Supply buffer pointer with application supplied offset */
S        pDesc->pNext     = 0;
S        pDesc->pBuffer   = pPkt->pDataBuffer + pPkt->DataOffset;
S        pDesc->BufOffLen = localDev.PktMTU;
S        pDesc->PktFlgLen = EMAC_DSC_FLAG_OWNER;
S
S        /* Make the previous buffer point to us */
S        if( pDesc == pdc->pDescFirst )
S             pdc->pDescLast->pNext = pDesc;
S        else
S            (pDesc-1)->pNext = pDesc;
S
S        /* Push the packet buffer on the local descriptor queue */
S        pqPush( &pdc->DescQueue, pPkt );
S    }
S
S    /* Restart RX if we had ran out of descriptors and got some here */
S    if( fRestart && !CountOrg && pdc->DescCount )
S        EMAC_RSET( RX0HDP, (Uint32)pdc->pDescRead );
S}
S
S/*--------------------------------------------------------------------*\
S* emacDequeueRx()
X
S*
S* Dequeue all completed RX packets and give buffers to application
S\*--------------------------------------------------------------------*/
Sstatic void emacDequeueRx( EMAC_DescCh *pdc, EMAC_Desc *pDescAck )
S{
S    EMAC_Pkt     *pPkt;
S    EMAC_Pkt     *pPktNew;
S    EMAC_Desc   *pDescNewRxFirst,*pDescNewRxLast=0,*pTemp;
S    uint        tmp;
S    Uint32      PktFlgLen;
S
S    /* Remember the first new descriptor slot */
S    pDescNewRxFirst = pdc->pDescWrite;
S
S    /*
S    // Pop & Free Buffers 'till the last Descriptor
S    // One thing we know for sure is that all the decriptors from
S    // the read pointer to pDescAsk are linked to each other via
S    // their pNext field.
S    */
S    for( tmp=1; tmp; )
S    {
S        /* Get the status of this descriptor */
S        PktFlgLen = pdc->pDescRead->PktFlgLen;
S
S        /* Recover the buffer and free it */
S        pPkt = pqPop( &pdc->DescQueue );
S        if( pPkt )
S        {
S            /* Fill in the necessary packet header fields */
S            pPkt->Flags = PktFlgLen & 0xFFFF0000;
S            pPkt->ValidLen = pPkt->PktLength = PktFlgLen & 0xFFFF;
S            pPkt->PktChannel = 0;
S            pPkt->PktFrags = 1;
S
S            /* Pass the packet to the application */
S            pPktNew = (*localDev.Config.pfcbRxPacket)
S                                           (pdc->pd->hApplication,pPkt);
S        }
S
S        /* See if this was the last buffer */
S        if( pdc->pDescRead == pDescAck )
S            tmp = 0;
S
S        /* Move the read pointer and decrement count */
S        if( pdc->pDescRead == pdc->pDescLast )
S            pdc->pDescRead = pdc->pDescFirst;
S        else
S            pdc->pDescRead++;
S        pdc->DescCount--;
S
S        /* See if we got a replacement packet */
S        if( pPktNew )
S        {
S            /* We know we can immediately queue this packet */
S
S            /* Fill in the descriptor for this buffer */
S            pDescNewRxLast = pdc->pDescWrite;
S
S            /* Move the write pointer and bump count */
S            if( pdc->pDescWrite == pdc->pDescLast )
S                pdc->pDescWrite = pdc->pDescFirst;
S            else
S                pdc->pDescWrite++;
S            pdc->DescCount++;
S
S            /* Supply buffer pointer with application supplied offset */
S            pDescNewRxLast->pBuffer   = pPktNew->pDataBuffer + pPktNew->DataOffset;
S            pDescNewRxLast->BufOffLen = localDev.PktMTU;
S            pDescNewRxLast->PktFlgLen = EMAC_DSC_FLAG_OWNER;
S
S            /* Push the packet buffer on the local descriptor queue */
S            pqPush( &pdc->DescQueue, pPktNew );
S        }
S    }
S
S    /*
S    // If we added descriptors, make the pNext of the last NULL, and
S    // make the previous descriptor point to the new list we added.
S    */
S    if( pDescNewRxLast )
S    {
S        pDescNewRxLast->pNext = 0;
S
S        /* Make the previous buffer point to us */
S        if( pDescNewRxFirst == pdc->pDescFirst )
S            pTemp = pdc->pDescLast;
S        else
S            pTemp = pDescNewRxFirst-1;
S
S        /*
S        // If these pointers wrapped, the RX engine is stopped
S        // Otherwise; tack the new list to the old
S        */
S        if( pTemp != pDescNewRxLast )
S            pTemp->pNext = pDescNewRxFirst;
S    }
S
S    /* If the receiver stopped and we have more descriptors, then restart */
S    if( (PktFlgLen & EMAC_DSC_FLAG_EOQ) && pdc->DescCount )
S        EMAC_RSET( RX0HDP, (Uint32)pdc->pDescRead );
S}
S
S
S/*-----------------------------------------------------------------------*\
S* STANDARD API FUNCTIONS
X
S*
S* Note on Exclusion (Serialization):
S*   The application is charged with verifying that only one of the
S* following API calls may only be executing at a given time across
S* all threads and all interrupt functions.
S*
S\*-----------------------------------------------------------------------*/
S
S
S/*-----------------------------------------------------------------------*\
S* EMAC_enumerate()
X
S*
S* Enumerates the EMAC peripherals installed in the system and returns an
S* integer count. The EMAC devices are enumerated in a consistent
S* fashion so that each device can be later referenced by its physical
S* index value ranging from "1" to "n" where "n" is the count returned
S* by this function.
S\*-----------------------------------------------------------------------*/
Suint EMAC_enumerate( void )
S{
S    return(1);
S}
S
S
S/*-----------------------------------------------------------------------*\
S* EMAC_open()
X
S*
S* Opens the EMAC peripheral at the given physical index and initializes
S* it to an embryonic state.
S*
S* The calling application must supply a operating configuration that
S* includes a callback function table. Data from this config structure is
S* copied into the device's internal instance structure so the structure
S* may be discarded after EMAC_open() returns. In order to change an item
S* in the configuration, the the EMAC device must be closed and then
S* re-opened with the new configuration.
S*
S* The application layer may pass in an hApplication callback handle,
S* that will be supplied by the EMAC device when making calls to the
S* application callback functions.
S*
S* An EMAC device handle is written to phEMAC. This handle must be saved
S* by the caller and then passed to other EMAC device functions.
S*
S* The default receive filter prevents normal packets from being received
S* until the receive filter is specified by calling EMAC_receiveFilter().
S*
S* A device reset is achieved by calling EMAC_close() followed by EMAC_open().
S*
S* The function returns zero on success, or an error code on failure.
S*
S* Possible error codes include:
S*   EMAC_ERROR_ALREADY   - The device is already open
S*   EMAC_ERROR_INVALID   - A calling parameter is invalid
S*
S\*-----------------------------------------------------------------------*/
Suint EMAC_open( int physicalIndex, Handle hApplication,
S                EMAC_Config *pEMACConfig, Handle *phEMAC )
S{
S    int             i;
S    volatile Uint32 *pRegAddr;
S    Uint32          tmpval;
S    EMAC_Pkt        *pPkt;
S    uint            utemp1;
S    EMAC_Desc       *pDesc;
S
S    /* We only handle a single instance */
S    if( physicalIndex != 1 )
S        return( EMAC_ERROR_INVALID );
S
S    /* If the device is alread open, return an error */
S    if( openFlag )
S        return( EMAC_ERROR_ALREADY );
S
S    /*
S    //  Validate the supplied configuration structure
S    */
S    if( !pEMACConfig || !phEMAC )
S        return( EMAC_ERROR_INVALID );
S
S    /* Rx pool must be at least 8 to 192 */
S    if( pEMACConfig->RxMaxPktPool < 8 || pEMACConfig->RxMaxPktPool > 192 )
S        return( EMAC_ERROR_INVALID );
S
S    /* MAC address must be supplied and not a multicast address */
S    if( pEMACConfig->MacAddr[0] & 1 )
S        return( EMAC_ERROR_INVALID );
S    for( i=0; i<6 && !(pEMACConfig->MacAddr[i]); i++ )
S    if( i==6 )
S        return( EMAC_ERROR_INVALID );
S
S    /* Tx Channels must be 1-8 */
S    if( pEMACConfig->TxChannels < 1 || pEMACConfig->TxChannels > 8 )
S        return( EMAC_ERROR_INVALID );
S
S    /* Callback functions must be supplied */
S    if( !pEMACConfig->pfcbGetPacket || !pEMACConfig->pfcbFreePacket ||
S            !pEMACConfig->pfcbRxPacket || !pEMACConfig->pfcbStatus ||
S            !pEMACConfig->pfcbStatistics )
S        return( EMAC_ERROR_INVALID );
S
S
S    /* MDIO settings must be valid - at least one bit must be set */
S    if( !(pEMACConfig->MdioModeFlags & ( MDIO_MODEFLG_AUTONEG |
S                MDIO_MODEFLG_HD10  | MDIO_MODEFLG_FD10 |
S                MDIO_MODEFLG_HD100 | MDIO_MODEFLG_FD100 )) )
S        return( EMAC_ERROR_INVALID );
S
S    /*
S    // Init the instance structure
S    */
S
S    /* Default everything in our instance structure to zero */
S    memset( &localDev, 0, sizeof(EMAC_Device) );
S
S    /* Set the hApplication and RxFilter */
S    localDev.hApplication = hApplication;
S    localDev.RxFilter     = EMAC_RXFILTER_NOTHING;
S
S    /* Setup the new configuration */
S    localDev.Config = *pEMACConfig;
S
S
S    /*
S    //  Initialize the EMAC and MDIO devices
S    */
S
S    /*
S    // Globally disable EMAC/MDIO interrupts in wrapper and put both
S    // EMAC and MDIO modules into reset
S    */
S    EMAC_RSET( EWCTL, EMAC_FMKS( EWCTL, INTEN, DISABLE ) |
S                      EMAC_FMKS( EWCTL, EMACRST, YES ) |
S                      EMAC_FMKS( EWCTL, MDIORST, YES ) );
S
S    /* Wait about 100 cycles */
S    for( i=0; i<5; i++ )
S        tmpval = EMAC_RGET( EWCTL );
S
S    /* Leave EMAC/MDIO interrupts disabled and take both
S       EMAC and MDIO modules out of reset */
S    EMAC_RSET( EWCTL, EMAC_FMKS( EWCTL, INTEN, DISABLE ) |
S                      EMAC_FMKS( EWCTL, EMACRST, NO ) |
S                      EMAC_FMKS( EWCTL, MDIORST, NO ) );
S
S    /* Wait about 100 cycles */
S    for( i=0; i<5; i++ )
S        tmpval = EMAC_RGET( EWCTL );
S
S    /* Start the MII Configuration */
S    localDev.hMDIO = MDIO_open( pEMACConfig->MdioModeFlags );
S
S    /*
S    //  Setup the EMAC
S    */
S
S    /* Reset MAC Control */
S    EMAC_RSET( MACCONTROL, 0 );
S
S    /* Must manually init HDPs to NULL */
S    pRegAddr = EMAC_ADDR(TX0HDP);
S    for( i=0; i<8; i++ )
S        *pRegAddr++ = 0;
S    pRegAddr = EMAC_ADDR(RX0HDP);
S    for( i=0; i<8; i++ )
S        *pRegAddr++ = 0;
S
S    /*
S    // While MIIEN is clear in MACCONTROL, we can write directly to
S    // the statistics registers (there are "EMAC_NUMSTATS" of them).
S    */
S    pRegAddr = EMAC_ADDR(RXGOODFRAMES);
S    for( i=0; i<EMAC_NUMSTATS; i++ )
S        *pRegAddr++ = 0;
S
S    /* Setup device MAC address */
S    EMAC_RSET( MACADDRL0, localDev.Config.MacAddr[5] );
S    EMAC_RSET( MACADDRM, localDev.Config.MacAddr[4] );
S    tmpval = 0;
S    for( i=3; i>=0; i-- )
S        tmpval = (tmpval<<8) | localDev.Config.MacAddr[i];
S    EMAC_RSET( MACADDRH, tmpval );
S
S    /*
S    // Setup Special Receive Conditions (loopback, error frames, etc)
S    */
S
S    /* For us buffer offset will always be zero */
S    EMAC_RSET( RXBUFFEROFFSET, 0 );
S
S    /* Reset RX (M)ulticast (B)roadcast (P)romiscuous Enable register */
S    EMAC_RSET( RXMBPENABLE, 0 );
S    EMAC_RSET( MACHASH1, 0 );
S    EMAC_RSET( MACHASH2, 0 );
S
S    /* Clear Unicast RX on channel 0-7 */
S    EMAC_RSET( RXUNICASTCLEAR, 0xFF );
S
S    /* Set the pass RX CRC mode and adjust max buffer accordingly */
S    if( localDev.Config.ModeFlags & EMAC_CONFIG_MODEFLG_RXCRC )
S    {
S        EMAC_FSETS( RXMBPENABLE, RXPASSCRC, INCLUDE );
S        localDev.PktMTU = 1518;
S    }
S    else
S        localDev.PktMTU = 1514;
S
S    /* If PASSERROR is set, enable both ERROR and short frames */
S    if( localDev.Config.ModeFlags & EMAC_CONFIG_MODEFLG_PASSERROR )
S    {
S        EMAC_FSETS( RXMBPENABLE, RXCEFEN, ENABLE );
S        EMAC_FSETS( RXMBPENABLE, RXCSFEN, ENABLE );
S    }
S
S    /* If PASSCONTROL is set, enable control frames */
S    if( localDev.Config.ModeFlags & EMAC_CONFIG_MODEFLG_PASSCONTROL )
S        EMAC_FSETS( RXMBPENABLE, RXCMFEN, ENABLE );
S
S    /* Set the channel configuration to priority if requested */
S    if( localDev.Config.ModeFlags & EMAC_CONFIG_MODEFLG_CHPRIORITY )
S        EMAC_FSETS( MACCONTROL, TXPTYPE, CHANNELPRI );
S
S    /* Set MAC loopback if requested */
S    if( localDev.Config.ModeFlags & EMAC_CONFIG_MODEFLG_MACLOOPBACK )
S        EMAC_FSETS( MACCONTROL, LOOPBACK, ENABLE );
S
S    /*
S    // Enable TX and RX channel interrupts (set mask bits)
S    // Enable Host interrupts
S    */
S    EMAC_RSET( RXINTMASKCLEAR, 0xFF );
S    EMAC_RSET( TXINTMASKCLEAR, 0xFF );
S    EMAC_RSET( RXINTMASKSET, 1 );
S    for(i=0; i<localDev.Config.TxChannels; i++)
S        EMAC_RSET( TXINTMASKSET, (1<<i) );
S    EMAC_RSET( MACINTMASKSET, EMAC_FMK(MACINTMASKSET,HOSTERRINT,1) |
S                              EMAC_FMK(MACINTMASKSET,STATINT,1) );
S
S
S    /*
S    // Setup Receive Buffers
S    */
S
S    /*
S    // We give the first descriptors to RX The rest of the descriptors
S    // will be divided evenly among the TX channels. Odds are this
S    // will leave TX with a very large number of TX descriptors, but
S    // we'll only use what we need (driven from the application send
S    // requests). The RX descriptors are always kept fully populated.
S    */
S
S    /* Pointer to first descriptor to use on RX */
S    pDesc = (EMAC_Desc *)_EMAC_DSC_BASE_ADDR;
S
S    /* Number of descriptors for RX channel */
S    utemp1 = localDev.Config.RxMaxPktPool;
S
S    /* Init Rx */
S    localDev.RxCh.pd         = &localDev;
S    localDev.RxCh.DescMax    = utemp1;
S    localDev.RxCh.pDescFirst = pDesc;
S    localDev.RxCh.pDescLast  = pDesc + (utemp1 - 1);
S    localDev.RxCh.pDescRead  = pDesc;
S    localDev.RxCh.pDescWrite = pDesc;
S
S    /* Fill the descriptor table */
S    emacEnqueueRx( &localDev.RxCh, 0 );
S
S    /*
S    // If we didn't get the number of descriptor buffers that the
S    // application said we should, then the app lied to us. This is
S    // bad because we'll be constantly calling to the app to fill
S    // up our buffers. So we'll close now to make the problem
S    // obvious.
S    */
S    if( localDev.RxCh.DescCount < utemp1 )
S    {
S        /* Free all RX descriptors */
S        while( pPkt = pqPop( &localDev.RxCh.DescQueue ) )
S            (*localDev.Config.pfcbFreePacket)(localDev.hApplication, pPkt);
S
S        /* Close the MDIO Module */
S        MDIO_close( localDev.hMDIO );
S
S        /* Return the error condition */
S        return( EMAC_ERROR_INVALID );
S    }
S
S    /*
S    // Setup Transmit Buffers
S    */
S
S    /* Pointer to first descriptor to use on TX */
S    pDesc += utemp1;
S
S    /* Number of descriptors (max) per channel */
S    utemp1 = (_EDMA_DSC_ENTRY_COUNT-utemp1)/localDev.Config.TxChannels;
S
S    /* Init all TX channels in use */
S    for( i=0; i<(int)localDev.Config.TxChannels; i++)
S    {
S        localDev.TxCh[i].pd         = &localDev;
S        localDev.TxCh[i].DescMax    = utemp1;
S        localDev.TxCh[i].pDescFirst = pDesc;
S        localDev.TxCh[i].pDescLast  = pDesc + (utemp1 - 1);
S        localDev.TxCh[i].pDescRead  = pDesc;
S        localDev.TxCh[i].pDescWrite = pDesc;
S
S        pDesc += utemp1;
S    }
S
S
S    /*
S    // Enable RX, TX, and MII
S    //
S    // Note in full duplex mode we also need to set the FULLDUPLEX
S    // bit in MACCRONTROL. However, we don't know what to set until
S    // we have a link. Also, we must be able to dynamically change
S    // this bit if the cable is unplugged and re-linked with a different
S    // duplex.
S    */
S    EMAC_FSETS( TXCONTROL, TXEN, ENABLE );
S    EMAC_FSETS( RXCONTROL, RXEN, ENABLE );
S    EMAC_FSETS( MACCONTROL, MIIEN, ENABLE );
S
S    /* Startup RX */
S    EMAC_RSET( RX0HDP, (Uint32)localDev.RxCh.pDescRead );
S
S    /* Validate the device handle */
S    localDev.DevMagic = EMAC_DEVMAGIC;
S
S    /* Set the open flag */
S    openFlag = 1;
S
S    /* Give a handle back to the caller */
S    *phEMAC = &localDev;
S
S    /* Enable global interrupt in wrapper */
S    EMAC_FSETS( EWCTL, INTEN, ENABLE );
S
S    /* Return Success */
S    return( 0 );
S}
S
S
S/*-----------------------------------------------------------------------*\
S* EMAC_close()
X
S*
S* Closed the EMAC peripheral indicated by the supplied instance handle.
S* When called, the EMAC device will shutdown both send and receive
S* operations, and free all pending transmit and receive packets.
S*
S* The function returns zero on success, or an error code on failure.
S*
S* Possible error code include:
S*   EMAC_ERROR_INVALID   - A calling parameter is invalid
S*
S\*-----------------------------------------------------------------------*/
Suint EMAC_close( Handle hEMAC )
S{
S    EMAC_Device  *pd = (EMAC_Device *)hEMAC;
S    Uint32      i,tmp;
S    EMAC_Pkt     *pPkt;
S
S    /* Validate our handle */
S    if( !pd || pd->DevMagic != EMAC_DEVMAGIC )
S        return( EMAC_ERROR_INVALID );
S
S    /* Disable EMAC/MDIO interrupts in wrapper */
S    EMAC_FSETS( EWCTL, INTEN, DISABLE );
S
S    /*
S    // The close process consists of tearing down all the active
S    // channels (RX and TX) and then waiting for the teardown
S    // complete indication from the MAC. Then, all queued packets
S    // will be returned.
S    */
S
S        /* Teardown RX */
S        EMAC_RSET( RXTEARDOWN, 0 );
S
S        /* Teardown TX channels in use */
S    for( i=0; i<pd->Config.TxChannels; i++)
S        EMAC_RSET( TXTEARDOWN, i );
S
S    /* Only check teardown status if there was no fatal error         */
S    /* Otherwise; the EMAC is halted and cant be shutdown gracefully */
S    if( !pd->FatalError )
S    {
S        /* Wait for the teardown to complete */
S        for( tmp=0; tmp!=0xFFFFFFFC; tmp=EMAC_RGET(RX0INTACK) );
S        EMAC_RSET( RX0INTACK, tmp );
S
S            for( i=0; i<pd->Config.TxChannels; i++ )
S        {
S            for( tmp=0; tmp!=0xFFFFFFFC; tmp=EMAC_RGETI(TXINTACK,i) );
S            EMAC_RSETI( TXINTACK, i, tmp );
S        }
S    }
S
S    /* Disable RX, TX, and Clear MACCONTROL */
S    EMAC_FSETS( TXCONTROL, TXEN, DISABLE );
S    EMAC_FSETS( RXCONTROL, RXEN, DISABLE );
S    EMAC_RSET( MACCONTROL, 0 );
S
S    /* Free all RX buffers */
S    while( pPkt = pqPop( &pd->RxCh.DescQueue ) )
S        (*pd->Config.pfcbFreePacket)(localDev.hApplication, pPkt);
S
S    /* Free all TX buffers */
S    for( i=0; i<pd->Config.TxChannels; i++)
S    {
S        while( pPkt = pqPop( &pd->TxCh[i].DescQueue ) )
S            (*pd->Config.pfcbFreePacket)(localDev.hApplication, pPkt);
S        while( pPkt = pqPop( &pd->TxCh[i].WaitQueue ) )
S            (*pd->Config.pfcbFreePacket)(localDev.hApplication, pPkt);
S    }
S
S    /* Close the MDIO Module */
S    MDIO_close( pd->hMDIO );
S
S    /* Invalidate the EMAC handle */
S    pd->DevMagic = 0;
S
S    /* Clear the open flag */
S    openFlag = 0;
S
S    /* Exit with interrupts still disabled in the wrapper */
S    return(0);
S}
S
S
S/*-----------------------------------------------------------------------*\
S* EMAC_getStatus()
X
S*
S* Called to get the current status of the device. The device status
S* is copied into the supplied data structure.
S*
S* The function returns zero on success, or an error code on failure.
S*
S* Possible error code include:
S*   EMAC_ERROR_INVALID   - A calling parameter is invalid
S*
S\*-----------------------------------------------------------------------*/
Suint EMAC_getStatus( Handle hEMAC, EMAC_Status *pStatus )
S{
S    EMAC_Device  *pd = (EMAC_Device *)hEMAC;
S    uint        i,tmp;
S
S    /* Validate our handle */
S    if( !pd || pd->DevMagic != EMAC_DEVMAGIC || !pStatus )
S        return( EMAC_ERROR_INVALID );
S
S    /* Get the MDIO status */
S    MDIO_getStatus(pd->hMDIO, &pStatus->PhyDev, &pStatus->MdioLinkStatus );
S
S    /* Number of rx packets held */
S    pStatus->RxPktHeld = pd->RxCh.DescCount;
S
S    /* Number of tx packets held */
S    tmp = 0;
S    for( i=0; i<pd->Config.TxChannels; i++)
S    {
S        tmp += pd->TxCh[i].DescCount;
S        tmp += pd->TxCh[i].WaitQueue.Count;
S    }
S    pStatus->TxPktHeld = tmp;
S
S    /* Fatal error value */
S    pStatus->FatalError = pd->FatalError;
S
S    return(0);
S}
S
S
S/*-----------------------------------------------------------------------*\
S* EMAC_setReceiveFilter()
X
S*
S* Called to set the packet filter for received packets. The filtering
S* level is inclusive, so BROADCAST would include both BROADCAST and
S* DIRECTED (UNICAST) packets.
S*
S* Available filtering modes include the following:
S*  EMAC_RXFILTER_NOTHING      - Receive nothing
S*  EMAC_RXFILTER_DIRECT       - Receive only Unicast to local MAC addr
S*  EMAC_RXFILTER_BROADCAST    - Receive direct and Broadcast
S*  EMAC_RXFILTER_MULTICAST    - Receive above plus multicast in mcast list
S*  EMAC_RXFILTER_ALLMULTICAST - Receive above plus all multicast
S*  EMAC_RXFILTER_ALL          - Receive all packets
S*
S* Note that if error frames and control frames are desired, reception of
S* these must be specified in the device configuration.
S*
S* The function returns zero on success, or an error code on failure.
S*
S* Possible error code include:
S*   EMAC_ERROR_INVALID   - A calling parameter is invalid
S*
S\*-----------------------------------------------------------------------*/
Suint EMAC_setReceiveFilter( Handle hEMAC, uint ReceiveFilter )
S{
S    EMAC_Device  *pd = (EMAC_Device *)hEMAC;
S
S    /* Validate our handle */
S    if( !pd || pd->DevMagic != EMAC_DEVMAGIC || ReceiveFilter > EMAC_RXFILTER_ALL )
S        return( EMAC_ERROR_INVALID );
S
S    /*
S    // The following code relies on the numberic relation of the filter
S    // value such that the higher filter values receive more types of
S    // packets.
S    */
S
S    /* Disable Section */
S    if( ReceiveFilter < EMAC_RXFILTER_ALL )
S        EMAC_FSETS( RXMBPENABLE, RXCAFEN, DISABLE );
S    if( ReceiveFilter < EMAC_RXFILTER_ALLMULTICAST )
S    {
S        EMAC_RSET( MACHASH1, pd->MacHash1 );
S        EMAC_RSET( MACHASH2, pd->MacHash2 );
S    }
S    if( ReceiveFilter < EMAC_RXFILTER_MULTICAST )
S        EMAC_FSETS( RXMBPENABLE, MULTEN, DISABLE );
S    if( ReceiveFilter < EMAC_RXFILTER_BROADCAST )
S        EMAC_FSETS( RXMBPENABLE, BROADEN, DISABLE );
S    if( ReceiveFilter < EMAC_RXFILTER_DIRECT )
S        EMAC_RSET( RXUNICASTCLEAR, 1 );
S
S    /* Enable Section */
S    if( ReceiveFilter >= EMAC_RXFILTER_DIRECT )
S        EMAC_RSET( RXUNICASTSET, 1 );
S    if( ReceiveFilter >= EMAC_RXFILTER_BROADCAST )
S        EMAC_FSETS( RXMBPENABLE, BROADEN, ENABLE );
S    if( ReceiveFilter >= EMAC_RXFILTER_MULTICAST )
S        EMAC_FSETS( RXMBPENABLE, MULTEN, ENABLE );
S    if( ReceiveFilter >= EMAC_RXFILTER_ALLMULTICAST )
S    {
S        EMAC_RSET( MACHASH1, 0xffffffff );
S        EMAC_RSET( MACHASH1, 0xffffffff );
S    }
S    if( ReceiveFilter == EMAC_RXFILTER_ALL )
S        EMAC_FSETS( RXMBPENABLE, RXCAFEN, ENABLE );
S
S    pd->RxFilter = ReceiveFilter;
S    return(0);
S}
S
S
S/*-----------------------------------------------------------------------*\
S* EMAC_getReceiveFilter()
X
S*
S* Called to get the current packet filter setting for received packets.
S* The filter values are the same as those used in EMAC_setReceiveFilter().
S*
S* The current filter value is writter to the pointer supplied in
S* pReceiveFilter.
S*
S* The function returns zero on success, or an error code on failure.
S*
S* Possible error code include:
S*   EMAC_ERROR_INVALID   - A calling parameter is invalid
S*
S\*-----------------------------------------------------------------------*/
Suint EMAC_getReceiveFilter( Handle hEMAC, uint *pReceiveFilter )
S{
S    EMAC_Device  *pd = (EMAC_Device *)hEMAC;
S
S    /* Validate our handle */
S    if( !pd || pd->DevMagic != EMAC_DEVMAGIC || !pReceiveFilter )
S        return( EMAC_ERROR_INVALID );
S
S    *pReceiveFilter = pd->RxFilter;
S    return(0);
S}
S
S
S/*-----------------------------------------------------------------------*\
S* EMAC_getStatistics()
X
S*
S* Called to get the current device statistics. The statistics structure
S* contains a collection of event counts for various packet sent and
S* receive properties. Reading the statistics also clears the current
S* statistic counters, so the values read represent a delta from the last
S* call.
S*
S* The statistics information is copied into the structure pointed to
S* by the pStatistics argument.
S*
S* The function returns zero on success, or an error code on failure.
S*
S* Possible error code include:
S*   EMAC_ERROR_INVALID   - A calling parameter is invalid
S*
S\*-----------------------------------------------------------------------*/
Suint EMAC_getStatistics( Handle hEMAC, EMAC_Statistics *pStatistics )
S{
S    EMAC_Device  *pd = (EMAC_Device *)hEMAC;
S
S    /* Validate our handle */
S    if( !pd || pd->DevMagic != EMAC_DEVMAGIC || !pStatistics )
S        return( EMAC_ERROR_INVALID );
S
S    /* Update the stats */
S    emacUpdateStats( pd );
S
S    /* Copy the updated stats to the application */
S    *pStatistics = pd->Stats;
S
S    /* Clear our copy */
S    memset( &pd->Stats, 0, sizeof(EMAC_Statistics) );
S
S    return(0);
S}
S
S
S/*-----------------------------------------------------------------------*\
S* EMAC_setMulticast()
X
S*
S* This function is called to install a list of multicast addresses for
S* use in multicast address filtering. Each time this function is called,
S* any current multicast configuration is discarded in favor of the new
S* list. Thus a set with a list size of zero will remove all multicast
S* addresses from the device.
S*
S* Note that the multicast list configuration is stateless in that the
S* list of multicast addresses used to build the configuration is not
S* retained. Thus it is impossible to examine a list of currently installed
S* addresses.
S*
S* The addresses to install are pointed to by pMCastList. The length of
S* this list in bytes is 6 times the value of AddrCnt. When AddrCnt is
S* zero, the pMCastList parameter can be NULL.
S*
S* The function returns zero on success, or an error code on failure.
S* The multicast list settings are not altered in the event of a failure
S* code.
S*
S* Possible error code include:
S*   EMAC_ERROR_INVALID   - A calling parameter is invalid
S*
S\*-----------------------------------------------------------------------*/
Suint EMAC_setMulticast( Handle hEMAC, uint AddrCnt, Uint8 *pMCastList )
S{
S    EMAC_Device  *pd = (EMAC_Device *)hEMAC;
S    uint        tmp1,tmp2;
S    Uint8       HashVal,tmpval;
S
S    /* Validate our handle */
S    if( !pd || pd->DevMagic != EMAC_DEVMAGIC || (AddrCnt && !pMCastList) )
S        return( EMAC_ERROR_INVALID );
S
S    /* Clear the hash bits */
S    pd->MacHash1 = 0;
S    pd->MacHash2 = 0;
S
S    /* For each address in the list, hash and set the bit */
S    for( tmp1=0; tmp1<AddrCnt; tmp1++ )
S    {
S        HashVal=0;
S
S        for( tmp2=0; tmp2<2; tmp2++ )
S        {
S            tmpval = *pMCastList++;
S            HashVal ^= (tmpval>>2)^(tmpval<<4);
S            tmpval = *pMCastList++;
S            HashVal ^= (tmpval>>4)^(tmpval<<2);
S            tmpval = *pMCastList++;
S            HashVal ^= (tmpval>>6)^(tmpval);
S        }
S
S        if( HashVal & 0x20 )
S            pd->MacHash2 |= (1<<(HashVal&0x1f));
S        else
S            pd->MacHash1 |= (1<<(HashVal&0x1f));
S    }
S
S    /* We only write the hash table if the filter setting allows */
S    if( pd->RxFilter < EMAC_RXFILTER_ALLMULTICAST )
S    {
S        EMAC_RSET( MACHASH1, pd->MacHash1 );
S        EMAC_RSET( MACHASH2, pd->MacHash2 );
S    }
S
S    return(0);
S}
S
S
S/*-----------------------------------------------------------------------*\
S* EMAC_sendPacket()
X
S*
S* Sends a Ethernet data packet out the EMAC device. On a non-error return,
S* the EMAC device takes ownership of the packet. The packet is returned
S* to the application's free pool once it has been transmitted.
S*
S* The function returns zero on success, or an error code on failure.
S* When an error code is returned, the EMAC device has not taken ownership
S* of the packet.
S*
S* Possible error codes include:
S*   EMAC_ERROR_INVALID   - A calling parameter is invalid
S*   EMAC_ERROR_BADPACKET - The packet structure is invalid
S*
S\*-----------------------------------------------------------------------*/
Suint EMAC_sendPacket( Handle hEMAC, EMAC_Pkt *pPkt )
S{
S    EMAC_Device  *pd = (EMAC_Device *)hEMAC;
S    uint        fragcnt,pktlen;
S    EMAC_Pkt     *pPktLast;
S    EMAC_DescCh  *pdc;
S
S    /* Validate our handle */
S    if( !pd || pd->DevMagic != EMAC_DEVMAGIC || !pPkt )
S        return( EMAC_ERROR_INVALID );
S
S    /* Do some packet validation */
S    if( !(pPkt->Flags & EMAC_PKT_FLAGS_SOP) )
S        return( EMAC_ERROR_BADPACKET );
S
S    if( pPkt->PktChannel >= pd->Config.TxChannels )
S        return( EMAC_ERROR_BADPACKET );
S
S    if( pPkt->PktLength < 14 || pPkt->PktLength > pd->PktMTU )
S        return( EMAC_ERROR_BADPACKET );
S
S    /* Count the number of frags in this packet */
S    fragcnt = 1;
S    pktlen  = pPkt->PktLength;
S    pPktLast = pPkt;
S    while( !(pPktLast->Flags & EMAC_PKT_FLAGS_EOP) )
S    {
S        if( !pPktLast->pNext )
S            return( EMAC_ERROR_INVALID );
S        pktlen -= pPktLast->ValidLen;
S        pPktLast = pPktLast->pNext;
S        fragcnt++;
S
S        /* At this point we can't have another SOP */
S        if( pPktLast->Flags & EMAC_PKT_FLAGS_SOP )
S            return( EMAC_ERROR_INVALID );
S    }
S
S    /* Make sure PktLength and ValidLen agree */
S    if( pktlen != pPkt->ValidLen )
S        return( EMAC_ERROR_BADPACKET );
S
S    /* The final packet frag must be the last in the list */
S    if( pPktLast->pNext )
S        return( EMAC_ERROR_BADPACKET );
S
S    /* The frag count must be correct */
S    if( fragcnt != pPkt->PktFrags )
S        return( EMAC_ERROR_BADPACKET );
S
S    /* Now pad for 60 byte min size. We only pad the last fragment */
S    if( pPkt->PktLength < 60 )
S    {
S        pktlen = 60 - pPkt->PktLength;
S        pPkt->PktLength = 60;
S        pPktLast->ValidLen += pktlen;
S    }
S
S    /* Get a local pointer to the descriptor channel */
S    pdc = &(pd->TxCh[pPkt->PktChannel]);
S
S    /* Make sure this packet does not have too many frags to fit */
S    if( fragcnt > pdc->DescMax )
S        return( EMAC_ERROR_BADPACKET );
S
S    /*
S    // Queue and packet and service transmitter
S    */
S    pqPushChain( &pdc->WaitQueue, pPkt, pPktLast, fragcnt );
S    emacEnqueueTx( pdc );
S
S    return(0);
S}
S
S
S/*-----------------------------------------------------------------------*\
S* EMAC_serviceCheck()
X
S*
S* This function should be called every time there is an EMAC device
S* interrupt. It maintains the status the EMAC.
S*
S* Note that the application has the responsibility for mapping the
S* physical device index to the correct EMAC_serviceCheck() function. If
S* more than one EMAC device is on the same interrupt, the function must be
S* called for each device.
S*
S* Possible error codes include:
S*   EMAC_ERROR_INVALID   - A calling parameter is invalid
S*   EMAC_ERROR_MACFATAL  - Fatal error in the MAC - Call EMAC_close()
S*
S\*-----------------------------------------------------------------------*/
Suint EMAC_serviceCheck( Handle hEMAC )
S{
S    EMAC_Device  *pd = (EMAC_Device *)hEMAC;
S    Uint32      intflags,Desc,mask;
S    uint        tmp;
S
S    /* Validate our handle */
S    if( !pd || pd->DevMagic != EMAC_DEVMAGIC )
S        return( EMAC_ERROR_INVALID );
S
S    /* Disable EMAC/MDIO interrupts in wrapper */
S    EMAC_FSETS( EWCTL, INTEN, DISABLE );
S
S    /* Read the interrupt cause */
S    intflags = EMAC_RGET( MACINVECTOR );
S
S    /* Look for fatal errors first */
S    if( intflags & EMAC_FMK( MACINVECTOR, HOSTPEND, 1 ) )
S    {
S        /* Read the error status - we'll decode it by hand */
S        pd->FatalError = EMAC_RGET( MACSTATUS );
S
S        /* Tell the application */
S        (*localDev.Config.pfcbStatus)(pd->hApplication);
S
S        /* return with interrupt disabled in the wrapper */
S        return( EMAC_ERROR_MACFATAL );
S    }
S
S    /* Look for statistics interrupt */
S    if( intflags & EMAC_FMK( MACINVECTOR, STATPEND, 1 ) )
S    {
S        /* Read the stats and reset to zero         */
S        /* This is necessary to clear the interrupt */
S        emacUpdateStats( pd );
S
S        /* Tell the application */
S        (*localDev.Config.pfcbStatistics)(pd->hApplication);
S    }
S
S    /* Look for TX interrupt (channel 0-max) */
S    for( tmp=0; tmp<pd->Config.TxChannels; tmp++ )
S    {
S        mask = EMAC_FMK( MACINVECTOR, TXPEND, 1<<tmp );
S        if( intflags & mask )
S        {
S            /*
S            // For multichannel operation, we need to
S            // apply an errata workaround.
S            */
S            do
S            {
S                Desc = EMAC_RGETI( TXINTACK, tmp );
S                EMAC_RSETI( TXINTACK, tmp, Desc );
S            } while( pd->Config.TxChannels>1 && (EMAC_RGET(MACINVECTOR)&mask) );
S
S            emacDequeueTx( &pd->TxCh[tmp], (EMAC_Desc *)Desc );
S        }
S    }
S
S    /* Look for RX interrupt (channel 0) */
S    if( intflags & EMAC_FMK( MACINVECTOR, RXPEND, 1<<0 ) )
S    {
S        /*
S        // For multichannel operation, we need to apply the
S        // same errata workaround as TX. However this driver
S        // example only supports one RX channel.
S        */
S        Desc = EMAC_RGET( RX0INTACK );
S        EMAC_RSET( RX0INTACK, Desc );
S
S        emacDequeueRx( &pd->RxCh, (EMAC_Desc *)Desc );
S    }
S
S    /* Enable EMAC/MDIO interrupts in wrapper */
S    EMAC_FSETS( EWCTL, INTEN, ENABLE );
S
S    return(0);
S}
S
S/*-----------------------------------------------------------------------*\
S* EMAC_timerTick()
X
S*
S* This function should be called for each device in the system on a
S* periodic basis of 100mS (10 times a second). It is used to check the
S* status of the EMAC and MDIO device, and to potentially recover from
S* low Rx buffer conditions.
S*
S* Strict timing is not required, but the application should make a
S* reasonable attempt to adhere to the 100mS mark. A missed call should
S* not be "made up" by making mulitple sequential calls.
S*
S* A "polling" driver (one that calls EMAC_serviceCheck() in a tight loop),
S* must also adhere to the 100mS timing on this function.
S*
S* Possible error codes include:
S*   EMAC_ERROR_INVALID   - A calling parameter is invalid
S*
S\*-----------------------------------------------------------------------*/
Suint EMAC_timerTick( Handle hEMAC )
S{
S    EMAC_Device  *pd = (EMAC_Device *)hEMAC;
S    uint         mdioStatus,linkStatus;
S
S    /* Validate our handle */
S    if( !pd || pd->DevMagic != EMAC_DEVMAGIC )
S        return( EMAC_ERROR_INVALID );
S
S    /* Signal the MDIO */
S    mdioStatus = MDIO_timerTick( pd->hMDIO );
S
S    /* On a new link, set the EMAC duplex */
S    if( mdioStatus == MDIO_EVENT_LINKUP )
S    {
S        MDIO_getStatus( pd->hMDIO, 0, &linkStatus );
S
S        if( linkStatus == MDIO_LINKSTATUS_FD10 ||
S            linkStatus == MDIO_LINKSTATUS_FD100 )
S        {
S            EMAC_FSETS( MACCONTROL, FULLDUPLEX, ENABLE );
S        }
S        else
S        {
S            EMAC_FSETS( MACCONTROL, FULLDUPLEX, DISABLE );
S        }
S    }
S
S    if( mdioStatus != MDIO_EVENT_NOCHANGE )
S        (*localDev.Config.pfcbStatus)(pd->hApplication);
S
S    /* Re-fill Rx buffer queue if needed */
S    if( pd->RxCh.DescCount != pd->RxCh.DescMax )
S        emacEnqueueRx( &pd->RxCh, 1 );
S
S    return ( 0 );
S}
S
S
N#endif /* EMAC_SUPPORT */
N/******************************************************************************\
N* End of emac.c
X
N\******************************************************************************/
