L 1 "../csl/csl_i2c.c"
N/******************************************************************************\
N*           Copyright (C) 1999-2000 Texas Instruments Incorporated.
X
N*                           All Rights Reserved
N*------------------------------------------------------------------------------
N* FILENAME...... csl_i2c.c
N* DATE CREATED.. 10/17/2001
N* LAST MODIFIED. 08/02/2004 - Adding support for C6418
N*                11/09/2001
N\******************************************************************************/
N#define _I2C_MOD_
N#include <csl_i2c.h>
L 1 "E:/TI_workspase/c6701_t/csl/csl_i2c.h" 1
N/******************************************************************************\
N*           Copyright (C) 1999-2000 Texas Instruments Incorporated.
X
N*                           All Rights Reserved
N*------------------------------------------------------------------------------
N* FILENAME...... csl_i2c.h
N* DATE CREATED.. 06/11/1999 
N* LAST MODIFIED. 08/02/2004 - Adding support for C6418
N*                13/03/2002 - added I2C_outOfReset()
N*                01/08/2003 - Removing unused variable 'I2C_isrDispatchTable[6]'
N\******************************************************************************/
N#ifndef _CSL_I2C_H_
N#define _CSL_I2C_H_
N
N#include <csl_chip.h>
L 1 "E:/TI_workspase/c6701_t/csl/csl_chip.h" 1
N/******************************************************************************\
N*           Copyright (C) 1999-2001 Texas Instruments Incorporated.
X
N*                           All Rights Reserved
N*------------------------------------------------------------------------------
N* FILENAME...... csl_chip.h
N* DATE CREATED.. 08/19/1999 
N* LAST MODIFIED. 08/02/2004 - Adding support for C6418
N*                06/17/2003   - Added support for 6712C
N*                06/09/2003   - Added support for 6711C
N*                12/03/2001   - CHIP_configArgs
N*                11/08/2001   - CHIP_getSiliconRevId()
N*                             - CHIP_config() / CHIP_getConfig  DM642
N\******************************************************************************/
N#ifndef _CSL_CHIP_H_
N#define _CSL_CHIP_H_
N
N#include <csl_stdinc.h>
L 1 "E:/TI_workspase/c6701_t/csl/csl_stdinc.h" 1
N/******************************************************************************\
N*           Copyright (C) 1999-2000 Texas Instruments Incorporated.
X
N*                           All Rights Reserved
N*------------------------------------------------------------------------------
N* FILENAME...... csl_stdinc.h
N* DATE CREATED.. 03/11/1999 
N* LAST MODIFIED. 10/03/2000
N*                01/06/2005    Added _TI_STD_TYPES  directive to protect 
N*                              multiple definition of datatypes.
N\******************************************************************************/
N#ifndef _CSL_STDINC_H_
N#define _CSL_STDINC_H_
N
N#include <csl_stdinchal.h>
L 1 "E:/TI_workspase/c6701_t/csl/csl_stdinchal.h" 1
N/******************************************************************************\
N*           Copyright (C) 1999-2000 Texas Instruments Incorporated.
X
N*                           All Rights Reserved
N*------------------------------------------------------------------------------
N* FILENAME...... csl_stdinchal.h
N* DATE CREATED.. 03/11/1999 
N* LAST MODIFIED. 03/23/2001
N\******************************************************************************/
N#ifndef _CSL_STDINCHAL_H_
N#define _CSL_STDINCHAL_H_
N
N
N/******************************************************************************\
N* HAL macro definitions
X
N\******************************************************************************/
N
N  #define _VALUEOF(x) ((Uint32)(x))
N
N  /*******************************************************/
N  /* generic macros for field manipulation               */
N  /*******************************************************/
N
N  #define _PER_FSHIFT(PER,REG,FIELD) \
N    _##PER##_##REG##_##FIELD##_SHIFT
X  #define _PER_FSHIFT(PER,REG,FIELD)     _##PER##_##REG##_##FIELD##_SHIFT
N
N  #define _PER_FMASK(PER,REG,FIELD) \
N    _##PER##_##REG##_##FIELD##_MASK
X  #define _PER_FMASK(PER,REG,FIELD)     _##PER##_##REG##_##FIELD##_MASK
N
N  #define _PER_FSYM(PER,REG,FIELD,SYM)\
N    PER##_##REG##_##FIELD##_##SYM
X  #define _PER_FSYM(PER,REG,FIELD,SYM)    PER##_##REG##_##FIELD##_##SYM
N
N  #define _PER_FDEFAULT(PER,REG,FIELD) \
N    ((##PER##_##REG##_##FIELD##_DEFAULT << _##PER##_##REG##_##FIELD##_SHIFT) \
N    & _##PER##_##REG##_##FIELD##_MASK)
X  #define _PER_FDEFAULT(PER,REG,FIELD)     ((##PER##_##REG##_##FIELD##_DEFAULT << _##PER##_##REG##_##FIELD##_SHIFT)     & _##PER##_##REG##_##FIELD##_MASK)
N
N  #define _PER_FMK(PER,REG,FIELD,x) (\
N    (((Uint32)(x))<<_PER_FSHIFT(##PER,##REG,##FIELD))\
N    &_PER_FMASK(##PER,##REG,##FIELD)\
N  )
X  #define _PER_FMK(PER,REG,FIELD,x) (    (((Uint32)(x))<<_PER_FSHIFT(##PER,##REG,##FIELD))    &_PER_FMASK(##PER,##REG,##FIELD)  )
N
N  #define _PER_FMKS(PER,REG,FIELD,SYM) (\
N    (_PER_FSYM(##PER,##REG,##FIELD,##SYM)<<_PER_FSHIFT(##PER,##REG,##FIELD))\
N    &_PER_FMASK(##PER,##REG,##FIELD)\
N  )
X  #define _PER_FMKS(PER,REG,FIELD,SYM) (    (_PER_FSYM(##PER,##REG,##FIELD,##SYM)<<_PER_FSHIFT(##PER,##REG,##FIELD))    &_PER_FMASK(##PER,##REG,##FIELD)  )
N
N  #define _PER_FEXTRACT(PER,REG,FIELD,reg) (Uint32)(\
N    (((Uint32)(reg)&_PER_FMASK(##PER,##REG,##FIELD))\
N    >>_PER_FSHIFT(##PER,##REG,##FIELD))\
N  )
X  #define _PER_FEXTRACT(PER,REG,FIELD,reg) (Uint32)(    (((Uint32)(reg)&_PER_FMASK(##PER,##REG,##FIELD))    >>_PER_FSHIFT(##PER,##REG,##FIELD))  )
N
N  #define _PER_FINSERT(PER,REG,FIELD,reg,field) (Uint32)(\
N    (((Uint32)(reg)&~_PER_FMASK(##PER,##REG,##FIELD))|\
N    (((Uint32)(field)<<_PER_FSHIFT(##PER,##REG,##FIELD))\
N    &_PER_FMASK(##PER,##REG,##FIELD)))\
N  )
X  #define _PER_FINSERT(PER,REG,FIELD,reg,field) (Uint32)(    (((Uint32)(reg)&~_PER_FMASK(##PER,##REG,##FIELD))|    (((Uint32)(field)<<_PER_FSHIFT(##PER,##REG,##FIELD))    &_PER_FMASK(##PER,##REG,##FIELD)))  )
N
N  /*******************************************************/
N  /* macros for memmory mapped registers                 */
N  /*******************************************************/
N
N  #define _PER_RAOI(addr,PER,REG,and,or,inv)\
N    (*(volatile Uint32*)(addr))=(\
N      ((((*(volatile Uint32*)(addr))\
N      &((Uint32)(and)))\
N      |((Uint32)(or)))\
N      ^((Uint32)(inv)))\
N    )
X  #define _PER_RAOI(addr,PER,REG,and,or,inv)    (*(volatile Uint32*)(addr))=(      ((((*(volatile Uint32*)(addr))      &((Uint32)(and)))      |((Uint32)(or)))      ^((Uint32)(inv)))    )
N
N  #define _PER_RGET(addr,PER,REG) \
N    (*(volatile Uint32*)(addr))
X  #define _PER_RGET(addr,PER,REG)     (*(volatile Uint32*)(addr))
N
N  #define _PER_RSET(addr,PER,REG,x) \
N    (*(volatile Uint32*)(addr))=((Uint32)(x))
X  #define _PER_RSET(addr,PER,REG,x)     (*(volatile Uint32*)(addr))=((Uint32)(x))
N
N  #define _PER_FGET(addr,PER,REG,FIELD) \
N    _PER_FEXTRACT(##PER,##REG,##FIELD,_PER_RGET(addr,##PER,##REG))
X  #define _PER_FGET(addr,PER,REG,FIELD)     _PER_FEXTRACT(##PER,##REG,##FIELD,_PER_RGET(addr,##PER,##REG))
N
N  #define _PER_FSET(addr,PER,REG,FIELD,field)\
N    _PER_RSET(addr,##PER,##REG,\
N    _PER_FINSERT(##PER,##REG,##FIELD,_PER_RGET(addr,##PER,##REG),field))
X  #define _PER_FSET(addr,PER,REG,FIELD,field)    _PER_RSET(addr,##PER,##REG,    _PER_FINSERT(##PER,##REG,##FIELD,_PER_RGET(addr,##PER,##REG),field))
N
N  #define _PER_FSETS(addr,PER,REG,FIELD,SYM)\
N    _PER_RSET(addr,##PER,##REG,_PER_FINSERT(##PER,##REG,##FIELD,_PER_RGET(addr,##PER,##REG),\
N    _PER_FSYM(##PER,##REG,##FIELD,##SYM)))
X  #define _PER_FSETS(addr,PER,REG,FIELD,SYM)    _PER_RSET(addr,##PER,##REG,_PER_FINSERT(##PER,##REG,##FIELD,_PER_RGET(addr,##PER,##REG),    _PER_FSYM(##PER,##REG,##FIELD,##SYM)))
N
N  /*******************************************************/
N  /* macros for CPU control registers                    */
N  /*******************************************************/
N
N  #define _PER_CRGET(PER,REG) \
N    REG
X  #define _PER_CRGET(PER,REG)     REG
N
N  #define _PER_CRSET(PER,REG,reg) \
N    REG=((Uint32)(reg))
X  #define _PER_CRSET(PER,REG,reg)     REG=((Uint32)(reg))
N
N  #define _PER_CFGET(PER,REG,FIELD) \
N    _PER_FEXTRACT(##PER,##REG,##FIELD,_PER_CRGET(##PER,##REG))
X  #define _PER_CFGET(PER,REG,FIELD)     _PER_FEXTRACT(##PER,##REG,##FIELD,_PER_CRGET(##PER,##REG))
N
N  #define _PER_CFSET(PER,REG,FIELD,field)\
N    _PER_CRSET(##PER,##REG,\
N    _PER_FINSERT(##PER,##REG,##FIELD,_PER_CRGET(##PER,##REG),field))
X  #define _PER_CFSET(PER,REG,FIELD,field)    _PER_CRSET(##PER,##REG,    _PER_FINSERT(##PER,##REG,##FIELD,_PER_CRGET(##PER,##REG),field))
N
N  #define _PER_CFSETS(PER,REG,FIELD,SYM)\
N    _PER_CRSET(##PER,##REG,\
N    _PER_FINSERT(##PER,##REG,FIELD,_PER_CRGET(##PER,##REG),\
N    _PER_FSYM(##PER,##REG,##FIELD,##SYM)))
X  #define _PER_CFSETS(PER,REG,FIELD,SYM)    _PER_CRSET(##PER,##REG,    _PER_FINSERT(##PER,##REG,FIELD,_PER_CRGET(##PER,##REG),    _PER_FSYM(##PER,##REG,##FIELD,##SYM)))
N
N/*----------------------------------------------------------------------------*/
N
N#endif /* _CSL_STDINCHAL_H_ */
N/******************************************************************************\
N* End of csl_stdinchal.h
X
N\******************************************************************************/
N
L 15 "E:/TI_workspase/c6701_t/csl/csl_stdinc.h" 2
N
N
N/******************************************************************************\
N* macro declarations
X
N\******************************************************************************/
N
N/* a few standard constants */
N#ifndef TRUE
N  #define TRUE   1
N#endif
N#ifndef FALSE
N  #define FALSE  0
N#endif
N
N/* Invalid Pointer                                               */
N/* In many instances, it is better to use INV as opposed to NULL */
N/* because 0 may actually be a valid pointer                     */
N#ifndef INV
N  #define INV    ((void*)(-1))
N#endif
N
N#ifndef UNREFERENCED_PARAMETER
N  #define UNREFERENCED_PARAMETER(P)    ((P)=(P))
N#endif
N
N#ifndef REG32
N  #define REG32(addr) (*(volatile unsigned int*)(addr))
N  #define REG16(addr) (*(volatile unsigned short*)(addr))
N  #define REG8(addr)  (*(volatile unsigned char*)(addr))
N#endif
N
N/******************************************************************************\
N* typedef declarations
X
N\******************************************************************************/
N
N#include <tistdtypes.h> /* use typedefs provided with CCS*/
L 1 "E:/TI_workspase/c6701_t/csl/tistdtypes.h" 1
N/*
N *  ======== tistdtypes.h ========
N */
N
N/*
N * These types are also defined by other TI components.  They are bracketed
N * with _TI_STD_TYPES to avoid warnings for duplicate definition.
N *
N * You may get warnings about duplicate type definitions when using this
N * header file with earlier versions of DSP/BIOS and CSL.
N *
N * You can use the '-pds303' compiler option to suppress these warnings.
N */
N#ifndef _TI_STD_TYPES
N#define _TI_STD_TYPES
N
N/*
N * This '#ifndef STD_' is needed to protect from duplicate definitions
N * of Int, Uns, etc. in DSP/BIOS v4.x (e.g. 4.90, 4.80) since these versions
N * of DSP/BIOS did not contain the '#ifndef_TI_STD_TYPES' logic.
N */
N#ifndef STD_
N
N/*
N * Aliases for standard C types
N */
Ntypedef int			Int;
Ntypedef unsigned		Uns;
Ntypedef char			Char;
N
N/* pointer to null-terminated character sequence */
Ntypedef char			*String;
N
Ntypedef void			*Ptr;		/* pointer to arbitrary type */
N
Ntypedef unsigned short		Bool;		/* boolean */
N
N#endif /* STD_ */
N
N/*
N * Uint8, Uint16, Uint32, etc are defined to be "smallest unit of
N * available storage that is large enough to hold unsigned or integer
N * of specified size".
N */
N
N/* Handle the 6x ISA */
N#if defined(_TMS320C6X)
X#if 1L
N    /* Unsigned integer definitions (32bit, 16bit, 8bit) follow... */
N    typedef unsigned int	Uint32;
N    typedef unsigned short	Uint16;
N    typedef unsigned char	Uint8;
N
N    /* Signed integer definitions (32bit, 16bit, 8bit) follow... */
N    typedef int			Int32;
N    typedef short		Int16;
N    typedef char		Int8;
N
N/* Handle the 54x, 55x and 28x ISAs */
N#elif defined(_TMS320C5XX) || defined(__TMS320C55X__) || defined(_TMS320C28X)
S    /* Unsigned integer definitions (32bit, 16bit, 8bit) follow... */
S    typedef unsigned long	Uint32;
S    typedef unsigned short	Uint16;
S    typedef unsigned char	Uint8;
S
S    /* Signed integer definitions (32bit, 16bit, 8bit) follow... */
S    typedef long		Int32;
S    typedef short		Int16;
S    typedef char		Int8;
S
S#else
S    /* Other ISAs not supported */
S    #error <tistdtypes.h> is not supported for this target
N#endif  /* defined(_6x_) */
N
N#endif  /* _TI_STD_TYPES */
L 51 "E:/TI_workspase/c6701_t/csl/csl_stdinc.h" 2
N
N/******************************************************************************\
N* variable declarations
X
N\******************************************************************************/
N
N
N typedef long             Int40;
N typedef unsigned long    Uint40;
N/******************************************************************************\
N* function declarations
X
N\******************************************************************************/
N
N
N#endif /* _CSL_STDINC_H_ */
N/******************************************************************************\
N* End of csl_stdinc.h
X
N\******************************************************************************/
N
L 18 "E:/TI_workspase/c6701_t/csl/csl_chip.h" 2
N
N#include <csl_chiphal.h>
L 1 "E:/TI_workspase/c6701_t/csl/csl_chiphal.h" 1
N/******************************************************************************\
N*           Copyright (C) 2000 Texas Instruments Incorporated.
X
N*                           All Rights Reserved
N*------------------------------------------------------------------------------
N* FILENAME...... csl_chiphal.h
N* DATE CREATED.. 14 Aug 2000
N* LAST MODIFIED. 14 Jan 2004 Adding support for DRI300 versions (6410, 6413)
N*                05 Aug 2003 Removing external control cregisters EM,ER,IN,OUT and DIER.
N*                26 Jun 2003 Added support for 6411
N*                17 Jun 2003 Added support for 6712C
N*                28 May 2003 Added support for 6711C
N*                05 Nov 2001 DM642 , 6411 remove 6400
N*                03 Oct 2001 - CHIP_6713 - MCASP_SUPPORT - IIC_SUPPORT
N*                           - PERCFG register
N*                           - redefinition of CHIP_RSET() / CHIP_RGET()
N*                           - new CHIP_CRSET() / CHIP_CRGET() => modification of csl_irq.h
N*                04 Apr 2004-  Removing external control cregisters EM,ER,IN,OUT and DIER.
N*                12 Jan 2005-  Removing external control cregisters FMCR,FADCR,FAUCR and GFPGFR
N*                06 Apr 2005-  Removing the macros ATLEN,ATLMEN and ADIV according to data manual 
N*                              tms320c6410(13)-sprs247 dated: Feb26 2004 specifications. 
N*				 26 Jul 2005-  Added C++ support.
N*------------------------------------------------------------------------------
N* REGISTERS
N*
N* CSR    - control/status register
N* IFR    - interrupt flag register
N* ISR    - interrupt set register
N* ICR    - interrupt clear register
N* IER    - interrupt enable register
N* ISTP   - interrupt service table pointer register
N* IRP    - interrupt return pointer
N* NRP    - non-maskable interrupt return pointer
N* AMR    - addressing mode reister
N* PERCFG - Device Configuration register  (4)
N* DEVSTAT - Device Status Register (5)
N* JTAGID - JTAG ID register (5)
N*
N* (1) only supported on 67xx
N* (2) only supported on floating point devices
N* (3) only supported on 6411/14/15/16 devices
N* (4) only supported on 6713/DA610/DM642/6412/6711C/6712C devices
N* (5) only supported on DM642/6412/6410/6413 devices
N*
N\******************************************************************************/
N#ifndef _CSL_CHIPHAL_H_
N#define _CSL_CHIPHAL_H_
N
N#include <csl_stdinc.h>
N
N#ifdef __cplusplus
Sextern "C" {
N#endif
N
N
N/******************************************************************************\
N* CHIP identification section
X
N\******************************************************************************/
N#ifdef CHIP_BASELINE
S  #undef CHIP_BASELINE
S  #define CHIP_BASELINE 1
N#else
N  #define CHIP_BASELINE 0
N#endif
N
N#if (CHIP_BASELINE)
X#if (0)
S  #define CHIP_6201 1
N#endif
N
N#ifdef CHIP_6201
S  #undef CHIP_6201
S  #define CHIP_6201 1
N#else
N  #define CHIP_6201 0
N#endif
N
N#ifdef CHIP_6202
S  #undef CHIP_6202
S  #define CHIP_6202 1
N#else
N  #define CHIP_6202 0
N#endif
N
N#ifdef CHIP_6203
S  #undef CHIP_6203
S  #define CHIP_6203 1
N#else
N  #define CHIP_6203 0
N#endif
N
N#ifdef CHIP_6204
S  #undef CHIP_6204
S  #define CHIP_6204 1
N#else
N  #define CHIP_6204 0
N#endif
N
N#ifdef CHIP_6205
S  #undef CHIP_6205
S  #define CHIP_6205 1
N#else
N  #define CHIP_6205 0
N#endif
N
N#ifdef CHIP_6211
S  #undef CHIP_6211
S  #define CHIP_6211 1
N#else
N  #define CHIP_6211 0
N#endif
N
N#ifdef CHIP_6701
N  #undef CHIP_6701
N  #define CHIP_6701 1
N#else
S  #define CHIP_6701 0
N#endif
N
N#ifdef CHIP_6711
S  #undef CHIP_6711
S  #define CHIP_6711 1
N#else
N  #define CHIP_6711 0
N#endif
N
N#ifdef CHIP_6712
S  #undef CHIP_6712
S  #define CHIP_6712 1
N#else
N  #define CHIP_6712 0
N#endif
N
N
N#ifdef CHIP_6713
S  #undef CHIP_6713
S  #define CHIP_6713 1
N#else
N  #define CHIP_6713 0
N#endif
N
N#ifdef CHIP_DA610
S  #undef CHIP_DA610
S  #define CHIP_DA610 1
N#else
N  #define CHIP_DA610 0
N#endif
N
N#ifdef CHIP_DM642
S  #undef CHIP_DM642
S  #define CHIP_DM642 1
N#else
N  #define CHIP_DM642 0
N#endif
N
N#ifdef CHIP_DM641
S  #undef CHIP_DM641
S  #define CHIP_DM641 1
N#else
N  #define CHIP_DM641 0
N#endif
N
N#ifdef CHIP_DM640
S  #undef CHIP_DM640
S  #define CHIP_DM640 1
N#else
N  #define CHIP_DM640 0
N#endif
N
N#ifdef CHIP_6412
S  #undef CHIP_6412
S  #define CHIP_6412 1
N#else
N  #define CHIP_6412 0
N#endif
N
N#ifdef CHIP_6414
S  #undef CHIP_6414
S  #define CHIP_6414 1
N#else
N  #define CHIP_6414 0
N#endif
N
N#ifdef CHIP_6415
S  #undef CHIP_6415
S  #define CHIP_6415 1
N#else
N  #define CHIP_6415 0
N#endif
N
N#ifdef CHIP_6416
S  #undef CHIP_6416
S  #define CHIP_6416 1
N#else
N  #define CHIP_6416 0
N#endif
N
N#ifdef CHIP_6711C
S  #undef CHIP_6711C
S  #define CHIP_6711C 1
N#else
N  #define CHIP_6711C 0
N#endif
N
N#ifdef CHIP_6712C
S  #undef CHIP_6712C
S  #define CHIP_6712C 1
N#else
N  #define CHIP_6712C 0
N#endif
N
N#ifdef CHIP_6411
S  #undef CHIP_6411
S  #define CHIP_6411 1
N#else
N  #define CHIP_6411 0
N#endif
N
N/* next two are DRI300 versions */
N#ifdef CHIP_6410
S  #undef CHIP_6410
S  #define CHIP_6410 1
N#else
N  #define CHIP_6410 0
N#endif
N
N#ifdef CHIP_6413
S  #undef CHIP_6413
S  #define CHIP_6413 1
N#else
N  #define CHIP_6413 0
N#endif
N
N#ifdef CHIP_6418
S  #undef CHIP_6418
S  #define CHIP_6418 1
N#else
N  #define CHIP_6418 0
N#endif
N
N#define CHIP_OROFALL (\
N  CHIP_6201 | \
N  CHIP_6202 | \
N  CHIP_6203 | \
N  CHIP_6204 | \
N  CHIP_6205 | \
N  CHIP_6211 | \
N  CHIP_6701 | \
N  CHIP_6711 | \
N  CHIP_6712 | \
N  CHIP_6713 | \
N  CHIP_DA610 | \
N  CHIP_DM642 | \
N  CHIP_DM641 | \
N  CHIP_DM640 | \
N  CHIP_6412 | \
N  CHIP_6414 | \
N  CHIP_6415 | \
N  CHIP_6416 |  \
N  CHIP_6711C | \
N  CHIP_6712C | \
N  CHIP_6411 |\
N  CHIP_6410 |\
N  CHIP_6413 |\
N  CHIP_6418 \
N)
X#define CHIP_OROFALL (  CHIP_6201 |   CHIP_6202 |   CHIP_6203 |   CHIP_6204 |   CHIP_6205 |   CHIP_6211 |   CHIP_6701 |   CHIP_6711 |   CHIP_6712 |   CHIP_6713 |   CHIP_DA610 |   CHIP_DM642 |   CHIP_DM641 |   CHIP_DM640 |   CHIP_6412 |   CHIP_6414 |   CHIP_6415 |   CHIP_6416 |    CHIP_6711C |   CHIP_6712C |   CHIP_6411 |  CHIP_6410 |  CHIP_6413 |  CHIP_6418 )
N
N#if (CHIP_OROFALL==0)
X#if (( 0 | 0 | 0 | 0 | 0 | 0 | 1 | 0 | 0 | 0 | 0 | 0 | 0 | 0 | 0 | 0 | 0 | 0 | 0 | 0 | 0 | 0 | 0 | 0 )==0)
S  #error NO CHIP DEFINED (use -dCHIP_XXXX where XXXX is chip number, i.e. 6201)
N#endif
N
N#define CHIP_NONE 0
N
N#define CHIP_SUPPORT(c0,c1,c2,c3,c4,c5,c6,c7,c8,c9,c10,c11,c12,c13,c14,c15,c16,c17,c18,c19,c20,c21,c22,c23,c24) ( \
N  ( c0*CHIP_6201)  | \
N  ( c1*CHIP_6202)  | \
N  ( c2*CHIP_6203)  | \
N  ( c3*CHIP_6204)  | \
N  ( c4*CHIP_6205)  | \
N  ( c5*CHIP_6211)  | \
N  ( c6*CHIP_6701)  | \
N  ( c7*CHIP_6711)  | \
N  ( c8*CHIP_6712)  | \
N  ( c9*CHIP_6713)  | \
N  ( c10*CHIP_DA610)| \
N  ( c11*CHIP_DM642)| \
N  ( c12*CHIP_DM641)| \
N  ( c13*CHIP_DM640)| \
N  ( c14*CHIP_6412) | \
N  ( c15*CHIP_6414) | \
N  ( c16*CHIP_6415) | \
N  ( c17*CHIP_6416) | \
N  ( c18*CHIP_6711C) | \
N  ( c19*CHIP_6712C) | \
N  ( c20*CHIP_6411) | \
N  ( c21*CHIP_6410) | \
N  ( c22*CHIP_6413) | \
N  ( c23*CHIP_6418) | \
N  ( c24*CHIP_NONE)   \
N )
X#define CHIP_SUPPORT(c0,c1,c2,c3,c4,c5,c6,c7,c8,c9,c10,c11,c12,c13,c14,c15,c16,c17,c18,c19,c20,c21,c22,c23,c24) (   ( c0*CHIP_6201)  |   ( c1*CHIP_6202)  |   ( c2*CHIP_6203)  |   ( c3*CHIP_6204)  |   ( c4*CHIP_6205)  |   ( c5*CHIP_6211)  |   ( c6*CHIP_6701)  |   ( c7*CHIP_6711)  |   ( c8*CHIP_6712)  |   ( c9*CHIP_6713)  |   ( c10*CHIP_DA610)|   ( c11*CHIP_DM642)|   ( c12*CHIP_DM641)|   ( c13*CHIP_DM640)|   ( c14*CHIP_6412) |   ( c15*CHIP_6414) |   ( c16*CHIP_6415) |   ( c17*CHIP_6416) |   ( c18*CHIP_6711C) |   ( c19*CHIP_6712C) |   ( c20*CHIP_6411) |   ( c21*CHIP_6410) |   ( c22*CHIP_6413) |   ( c23*CHIP_6418) |   ( c24*CHIP_NONE)    )
N
N/*---------------------------------------------------------------------------------------*/
N/*                                     6 6 6 6 6 6 6 6 6 6 D D D D 6 6 6 6 6 6 6 6 6 6 N */
N/*                                     2 2 2 2 2 2 7 7 7 7 A M M M 4 4 4 4 7 7 4 4 4 4 O */
N/*                                     0 0 0 0 0 1 0 1 1 1 6 6 6 6 1 1 1 1 1 1 1 1 1 1 N */
N/*                                     1 2 3 4 5 1 1 1 2 3 1 4 4 4 2 4 5 6 1 2 1 0 3 8 E */
N/*                                                         0 2 1 0         C C           */
N/*---------------------------------------------------------------------------------------*/
N#define CACHE_SUPPORT     CHIP_SUPPORT(1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0)
N#define DMA_SUPPORT       CHIP_SUPPORT(1,1,1,1,1,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0)
N#define EDMA_SUPPORT      CHIP_SUPPORT(0,0,0,0,0,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0)
N#define EMIF_SUPPORT      CHIP_SUPPORT(1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,0,0,0,0,0)
N#define EMIFA_SUPPORT     CHIP_SUPPORT(0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,1,1,1,1,0)
N#define EMIFB_SUPPORT     CHIP_SUPPORT(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0)
N#define GPIO_SUPPORT      CHIP_SUPPORT(0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0)
N#define HPI_SUPPORT       CHIP_SUPPORT(1,0,0,0,0,1,1,1,0,1,1,1,1,0,1,1,1,1,1,0,1,1,1,1,0)
N#define I2C_SUPPORT       CHIP_SUPPORT(0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,0)
N#define IRQ_SUPPORT       CHIP_SUPPORT(1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0)
N#define MCASP_SUPPORT     CHIP_SUPPORT(0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,0)
N#define MCBSP_SUPPORT     CHIP_SUPPORT(1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0)
N#define PLL_SUPPORT       CHIP_SUPPORT(0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,1,1,0,0,0,0,0)
N#define TIMER_SUPPORT     CHIP_SUPPORT(1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0)
N#define XBUS_SUPPORT      CHIP_SUPPORT(0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0)
N#define PCI_SUPPORT       CHIP_SUPPORT(0,0,0,0,1,0,0,0,0,0,0,1,0,0,1,0,1,1,0,0,1,0,0,0,0)
N/*---------------------------------------------------------------------------------------*/
N/*                                     6 6 6 6 6 6 6 6 6 6 D D D D 6 6 6 6 6 6 6 6 6 6 N */
N/*                                     2 2 2 2 2 2 7 7 7 7 A M M M 4 4 4 4 7 7 4 4 4 4 O */
N/*                                     0 0 0 0 0 1 0 1 1 1 6 6 6 6 1 1 1 1 1 1 1 1 1 1 N */
N/*                                     1 2 3 4 5 1 1 1 2 3 1 4 4 4 2 4 5 6 1 2 1 0 3 8 E */
N/*                                                         0 2 1 0         C C           */
N/*---------------------------------------------------------------------------------------*/
N#define VP_SUPPORT        CHIP_SUPPORT(0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0)
N#define VIC_SUPPORT       CHIP_SUPPORT(0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0)
N#define DAT_SUPPORT       CHIP_SUPPORT(1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0)
N#define PWR_SUPPORT       CHIP_SUPPORT(1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0)
N#define UTOP_SUPPORT      CHIP_SUPPORT(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0)
N#define TCP_SUPPORT       CHIP_SUPPORT(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0)
N#define VCP_SUPPORT       CHIP_SUPPORT(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,1,0)
N#define EMAC_SUPPORT      CHIP_SUPPORT(0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0)
N#define MDIO_SUPPORT      CHIP_SUPPORT(0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0)
N#define EMU_SUPPORT	  CHIP_SUPPORT(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0)
N                                                                                       
N#define L2CACHE_SUPPORT   CHIP_SUPPORT(0,0,0,0,0,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0)
N#define TC_SUPPORT        CHIP_SUPPORT(0,0,0,0,0,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0)
N#define FPU_SUPPORT       CHIP_SUPPORT(0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,1,1,0,0,0,0,0)
N#define C01_SUPPORT       CHIP_SUPPORT(1,1,1,1,1,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0)
N#define C11_SUPPORT       CHIP_SUPPORT(0,0,0,0,0,1,0,1,1,1,1,0,0,0,0,0,0,0,1,1,0,0,0,0,0)
N#define C64_SUPPORT       CHIP_SUPPORT(0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,1,1,1,1,0)
N#define ATL_SUPPORT       CHIP_SUPPORT(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0)
N
N#define CACHE_L2_SUPPORT  L2CACHE_SUPPORT
N/*----------------------------------------------------------------------*/
N
N
N/******************************************************************************\
N* module level register/field access macros
X
N\******************************************************************************/
N
N  /* ----------------- */
N  /* FIELD MAKE MACROS */
N  /* ----------------- */
N
N  #define CHIP_FMK(REG,FIELD,x)\
N    _PER_FMK(CHIP,##REG,##FIELD,x)
X  #define CHIP_FMK(REG,FIELD,x)    _PER_FMK(CHIP,##REG,##FIELD,x)
N
N  #define CHIP_FMKS(REG,FIELD,SYM)\
N    _PER_FMKS(CHIP,##REG,##FIELD,##SYM)
X  #define CHIP_FMKS(REG,FIELD,SYM)    _PER_FMKS(CHIP,##REG,##FIELD,##SYM)
N
N
N  /* -------------------------------- */
N  /* RAW REGISTER/FIELD ACCESS MACROS */
N  /* -------------------------------- */
N
N  #define CHIP_CRGET(REG)\
N    _PER_CRGET(CHIP,##REG)
X  #define CHIP_CRGET(REG)    _PER_CRGET(CHIP,##REG)
N
N  #define CHIP_CRSET(REG,x)\
N    _PER_CRSET(CHIP,##REG,x)
X  #define CHIP_CRSET(REG,x)    _PER_CRSET(CHIP,##REG,x)
N
N  #define CHIP_RGET(REG)\
N   _PER_RGET(_CHIP_##REG##_ADDR,CHIP,##REG)
X  #define CHIP_RGET(REG)   _PER_RGET(_CHIP_##REG##_ADDR,CHIP,##REG)
N
N  #define CHIP_RSET(REG,x)\
N     _PER_RSET(_CHIP_##REG##_ADDR,CHIP,##REG,x)
X  #define CHIP_RSET(REG,x)     _PER_RSET(_CHIP_##REG##_ADDR,CHIP,##REG,x)
N
N
N  #define CHIP_FGET(REG,FIELD)\
N    _CHIP_##REG##_FGET(##FIELD)
X  #define CHIP_FGET(REG,FIELD)    _CHIP_##REG##_FGET(##FIELD)
N
N  #define CHIP_FSET(REG,FIELD,x)\
N    _CHIP_##REG##_FSET(##FIELD,x)
X  #define CHIP_FSET(REG,FIELD,x)    _CHIP_##REG##_FSET(##FIELD,x)
N
N  #define CHIP_FSETS(REG,FIELD,SYM)\
N    _CHIP_##REG##_FSETS(##FIELD,##SYM)
X  #define CHIP_FSETS(REG,FIELD,SYM)    _CHIP_##REG##_FSETS(##FIELD,##SYM)
N
N
N/******************************************************************************\
N* _____________________
X
N* |                   |
N* |  C S R            |
N* |___________________|
N*
N* CSR - control/status register
N*
N* FIELDS (msb -> lsb)
N* (r)  CPUID
N* (r)  REVID
N* (rw) PWRD
N* (rc) SAT
N* (r)  EN
N* (rw) PCC
N* (rw) DCC
N* (rw) PGIE
N* (rw) GIE
N*
N\******************************************************************************/
N  extern far cregister volatile unsigned int CSR;
N
N  #define _CHIP_CSR_CPUID_MASK         0xFF000000u
N  #define _CHIP_CSR_CPUID_SHIFT        0x00000018u
N  #define  CHIP_CSR_CPUID_DEFAULT      0x00000000u
N  #define  CHIP_CSR_CPUID_OF(x)        _VALUEOF(x)
N  #define  CHIP_CSR_CPUID_C62X         0x00000000u
N  #define  CHIP_CSR_CPUID_C67X         0x00000002u
N  #define  CHIP_CSR_CPUID_C64X         0x00000004u
N
N  #define _CHIP_CSR_REVID_MASK         0x00FF0000u
N  #define _CHIP_CSR_REVID_SHIFT        0x00000010u
N  #define  CHIP_CSR_REVID_DEFAULT      0x00000000u
N  #define  CHIP_CSR_REVID_OF(x)        _VALUEOF(x)
N  #define  CHIP_CSR_REVID_620120       0x00000001u
N  #define  CHIP_CSR_REVID_620121       0x00000001u
N  #define  CHIP_CSR_REVID_620130       0x00000002u
N  #define  CHIP_CSR_REVID_670100       0x00000201u
N  #define  CHIP_CSR_REVID_670110       0x00000202u
N  #define  CHIP_CSR_REVID_621110       0x00000002u
N  #define  CHIP_CSR_REVID_640010       0x00000801u
N  #define  CHIP_CSR_REVID_6202         0x00000002u
N  #define  CHIP_CSR_REVID_6202B        0x00000003u
N  #define  CHIP_CSR_REVID_6711         0x00000002u
N  #define  CHIP_CSR_REVID_6711C        0x00000003u
N  #define  CHIP_CSR_REVID_6712         0x00000002u
N  #define  CHIP_CSR_REVID_6712C        0x00000003u
N
N  #define _CHIP_CSR_PWRD_MASK          0x0000FC00u
N  #define _CHIP_CSR_PWRD_SHIFT         0x0000000Au
N  #define  CHIP_CSR_PWRD_DEFAULT       0x00000000u
N  #define  CHIP_CSR_PWRD_OF(x)         _VALUEOF(x)
N  #define  CHIP_CSR_PWRD_NONE          0x00000000u
N  #define  CHIP_CSR_PWRD_PD1A          0x00000009u
N  #define  CHIP_CSR_PWRD_PD1B          0x00000011u
N  #define  CHIP_CSR_PWRD_PD2           0x0000001Au
N  #define  CHIP_CSR_PWRD_PD3           0x0000001Cu
N
N  #define _CHIP_CSR_SAT_MASK           0x00000200u
N  #define _CHIP_CSR_SAT_SHIFT          0x00000009u
N  #define  CHIP_CSR_SAT_DEFAULT        0x00000000u
N  #define  CHIP_CSR_SAT_OF(x)          _VALUEOF(x)
N  #define  CHIP_CSR_SAT_0              0x00000000u
N  #define  CHIP_CSR_SAT_1              0x00000001u
N
N  #define _CHIP_CSR_EN_MASK            0x00000100u
N  #define _CHIP_CSR_EN_SHIFT           0x00000008u
N  #define  CHIP_CSR_EN_DEFAULT         0x00000000u
N  #define  CHIP_CSR_EN_OF(x)           _VALUEOF(x)
N  #define  CHIP_CSR_EN_BIG             0x00000000u
N  #define  CHIP_CSR_EN_LITTLE          0x00000001u
N
N  #define _CHIP_CSR_PCC_MASK           0x000000E0u
N  #define _CHIP_CSR_PCC_SHIFT          0x00000005u
N  #define  CHIP_CSR_PCC_DEFAULT        0x00000000u
N  #define  CHIP_CSR_PCC_OF(x)          _VALUEOF(x)
N  #define  CHIP_CSR_PCC_MAPPED         0x00000000u
N  #define  CHIP_CSR_PCC_ENABLE         0x00000002u
N  #define  CHIP_CSR_PCC_FREEZE         0x00000003u
N  #define  CHIP_CSR_PCC_BYPASS         0x00000004u
N
N  #define _CHIP_CSR_DCC_MASK           0x0000001Cu
N  #define _CHIP_CSR_DCC_SHIFT          0x00000002u
N  #define  CHIP_CSR_DCC_DEFAULT        0x00000000u
N  #define  CHIP_CSR_DCC_OF(x)          _VALUEOF(x)
N  #define  CHIP_CSR_DCC_MAPPED         0x00000000u
N  #define  CHIP_CSR_DCC_ENABLE         0x00000002u
N  #define  CHIP_CSR_DCC_FREEZE         0x00000003u
N  #define  CHIP_CSR_DCC_BYPASS         0x00000004u
N
N  #define _CHIP_CSR_PGIE_MASK          0x00000002u
N  #define _CHIP_CSR_PGIE_SHIFT         0x00000001u
N  #define  CHIP_CSR_PGIE_DEFAULT       0x00000000u
N  #define  CHIP_CSR_PGIE_OF(x)         _VALUEOF(x)
N  #define  CHIP_CSR_PGIE_0             0x00000000u
N  #define  CHIP_CSR_PGIE_1             0x00000001u
N
N  #define _CHIP_CSR_GIE_MASK           0x00000001u
N  #define _CHIP_CSR_GIE_SHIFT          0x00000000u
N  #define  CHIP_CSR_GIE_DEFAULT        0x00000000u
N  #define  CHIP_CSR_GIE_OF(x)          _VALUEOF(x)
N  #define  CHIP_CSR_GIE_0              0x00000000u
N  #define  CHIP_CSR_GIE_1              0x00000001u
N
N  #define  CHIP_CSR_OF(x)              _VALUEOF(x)
N
N  #define CHIP_CSR_DEFAULT (Uint32)( \
N     _PER_FDEFAULT(CHIP,CSR,CPUID) \
N    |_PER_FDEFAULT(CHIP,CSR,REVID) \
N    |_PER_FDEFAULT(CHIP,CSR,PWRD) \
N    |_PER_FDEFAULT(CHIP,CSR,SAT) \
N    |_PER_FDEFAULT(CHIP,CSR,EN) \
N    |_PER_FDEFAULT(CHIP,CSR,PCC) \
N    |_PER_FDEFAULT(CHIP,CSR,DCC) \
N    |_PER_FDEFAULT(CHIP,CSR,PGIE) \
N    |_PER_FDEFAULT(CHIP,CSR,GIE) \
N  )
X  #define CHIP_CSR_DEFAULT (Uint32)(      _PER_FDEFAULT(CHIP,CSR,CPUID)     |_PER_FDEFAULT(CHIP,CSR,REVID)     |_PER_FDEFAULT(CHIP,CSR,PWRD)     |_PER_FDEFAULT(CHIP,CSR,SAT)     |_PER_FDEFAULT(CHIP,CSR,EN)     |_PER_FDEFAULT(CHIP,CSR,PCC)     |_PER_FDEFAULT(CHIP,CSR,DCC)     |_PER_FDEFAULT(CHIP,CSR,PGIE)     |_PER_FDEFAULT(CHIP,CSR,GIE)   )
N
N  #define CHIP_CSR_RMK(pwrd,pcc,dcc,pgie,gie) (Uint32)( \
N     _PER_FMK(CHIP,CSR,PWRD,pwrd) \
N    |_PER_FMK(CHIP,CSR,PCC,pcc) \
N    |_PER_FMK(CHIP,CSR,DCC,dcc) \
N    |_PER_FMK(CHIP,CSR,PGIE,pgie) \
N    |_PER_FMK(CHIP,CSR,GIE,gie) \
N  )
X  #define CHIP_CSR_RMK(pwrd,pcc,dcc,pgie,gie) (Uint32)(      _PER_FMK(CHIP,CSR,PWRD,pwrd)     |_PER_FMK(CHIP,CSR,PCC,pcc)     |_PER_FMK(CHIP,CSR,DCC,dcc)     |_PER_FMK(CHIP,CSR,PGIE,pgie)     |_PER_FMK(CHIP,CSR,GIE,gie)   )
N
N  #define _CHIP_CSR_FGET(FIELD)\
N    _PER_CFGET(CHIP,CSR,##FIELD)
X  #define _CHIP_CSR_FGET(FIELD)    _PER_CFGET(CHIP,CSR,##FIELD)
N
N  #define _CHIP_CSR_FSET(FIELD,field)\
N    _PER_CFSET(CHIP,CSR,##FIELD,field)
X  #define _CHIP_CSR_FSET(FIELD,field)    _PER_CFSET(CHIP,CSR,##FIELD,field)
N
N  #define _CHIP_CSR_FSETS(FIELD,SYM)\
N    _PER_CFSETS(CHIP,CSR,##FIELD,##SYM)
X  #define _CHIP_CSR_FSETS(FIELD,SYM)    _PER_CFSETS(CHIP,CSR,##FIELD,##SYM)
N
N
N/******************************************************************************\
N* _____________________
X
N* |                   |
N* |  I F R            |
N* |___________________|
N*
N* IFR - interruppt flag register
N*
N* FIELDS (msb -> lsb)
N* (rw) IF
N*
N\******************************************************************************/
N  extern far cregister volatile unsigned int IFR;
N
N  #define _CHIP_IFR_IF_MASK          0x0000FFFFu
N  #define _CHIP_IFR_IF_SHIFT         0x00000000u
N  #define  CHIP_IFR_IF_DEFAULT       0x00000000u
N  #define  CHIP_IFR_IF_OF(x)         _VALUEOF(x)
N
N  #define  CHIP_IFR_OF(x)            _VALUEOF(x)
N
N  #define CHIP_IFR_DEFAULT (Uint32)( \
N     _PER_FDEFAULT(CHIP,IFR,IF)\
N  )
X  #define CHIP_IFR_DEFAULT (Uint32)(      _PER_FDEFAULT(CHIP,IFR,IF)  )
N
N  #define CHIP_IFR_RMK(if) (Uint32)( \
N     _PER_FMK(CHIP,IFR,IF,if)\
N  )
X  #define CHIP_IFR_RMK(if) (Uint32)(      _PER_FMK(CHIP,IFR,IF,if)  )
N
N  #define _CHIP_IFR_FGET(FIELD)\
N    _PER_CFGET(CHIP,IFR,##FIELD)
X  #define _CHIP_IFR_FGET(FIELD)    _PER_CFGET(CHIP,IFR,##FIELD)
N
N  #define _CHIP_IFR_FSET(FIELD,field)\
N    _PER_CFSET(CHIP,IFR,##FIELD,field)
X  #define _CHIP_IFR_FSET(FIELD,field)    _PER_CFSET(CHIP,IFR,##FIELD,field)
N
N  #define _CHIP_IFR_FSETS(FIELD,SYM)\
N    _PER_CFSETS(CHIP,IFR,##FIELD,##SYM)
X  #define _CHIP_IFR_FSETS(FIELD,SYM)    _PER_CFSETS(CHIP,IFR,##FIELD,##SYM)
N
N
N/******************************************************************************\
N* _____________________
X
N* |                   |
N* |  I S R            |
N* |___________________|
N*
N* ISR - interruppt set register
N*
N* FIELDS (msb -> lsb)
N* (w) IS
N*
N\******************************************************************************/
N  extern far cregister volatile unsigned int ISR;
N
N  #define _CHIP_ISR_IS_MASK          0x0000FFFFu
N  #define _CHIP_ISR_IS_SHIFT         0x00000000u
N  #define  CHIP_ISR_IS_DEFAULT       0x00000000u
N  #define  CHIP_ISR_IS_OF(x)         _VALUEOF(x)
N
N  #define  CHIP_ISR_OF(x)            _VALUEOF(x)
N
N  #define CHIP_ISR_DEFAULT (Uint32)( \
N     _PER_FDEFAULT(CHIP,ISR,IS)\
N  )
X  #define CHIP_ISR_DEFAULT (Uint32)(      _PER_FDEFAULT(CHIP,ISR,IS)  )
N
N  #define CHIP_ISR_RMK(is) (Uint32)( \
N     _PER_FMK(CHIP,ISR,IS,is)\
N  )
X  #define CHIP_ISR_RMK(is) (Uint32)(      _PER_FMK(CHIP,ISR,IS,is)  )
N
N  #define _CHIP_ISR_FGET(FIELD)\
N    _PER_CFGET(CHIP,ISR,##FIELD)
X  #define _CHIP_ISR_FGET(FIELD)    _PER_CFGET(CHIP,ISR,##FIELD)
N
N  #define _CHIP_ISR_FSET(FIELD,field)\
N    _PER_CFSET(CHIP,ISR,##FIELD,field)
X  #define _CHIP_ISR_FSET(FIELD,field)    _PER_CFSET(CHIP,ISR,##FIELD,field)
N
N  #define _CHIP_ISR_FSETS(FIELD,SYM)\
N    _PER_CFSETS(CHIP,ISR,##FIELD,##SYM)
X  #define _CHIP_ISR_FSETS(FIELD,SYM)    _PER_CFSETS(CHIP,ISR,##FIELD,##SYM)
N
N
N/******************************************************************************\
N* _____________________
X
N* |                   |
N* |  I C R            |
N* |___________________|
N*
N* ICR - interruppt clear register
N*
N* FIELDS (msb -> lsb)
N* (w) IC
N*
N\******************************************************************************/
N  extern far cregister volatile unsigned int ICR;
N
N  #define _CHIP_ICR_IC_MASK          0x0000FFFFu
N  #define _CHIP_ICR_IC_SHIFT         0x00000000u
N  #define  CHIP_ICR_IC_DEFAULT       0x00000000u
N  #define  CHIP_ICR_IC_OF(x)         _VALUEOF(x)
N
N  #define  CHIP_ICR_OF(x)            _VALUEOF(x)
N
N  #define CHIP_ICR_DEFAULT (Uint32)( \
N     _PER_FDEFAULT(CHIP,ICR,IC)\
N  )
X  #define CHIP_ICR_DEFAULT (Uint32)(      _PER_FDEFAULT(CHIP,ICR,IC)  )
N
N  #define CHIP_ICR_RMK(ic) (Uint32)( \
N     _PER_FMK(CHIP,ICR,IC,ic)\
N  )
X  #define CHIP_ICR_RMK(ic) (Uint32)(      _PER_FMK(CHIP,ICR,IC,ic)  )
N
N  #define _CHIP_ICR_FGET(FIELD)\
N    _PER_CFGET(CHIP,ICR,##FIELD)
X  #define _CHIP_ICR_FGET(FIELD)    _PER_CFGET(CHIP,ICR,##FIELD)
N
N  #define _CHIP_ICR_FSET(FIELD,field)\
N    _PER_CFSET(CHIP,ICR,##FIELD,field)
X  #define _CHIP_ICR_FSET(FIELD,field)    _PER_CFSET(CHIP,ICR,##FIELD,field)
N
N  #define _CHIP_ICR_FSETS(FIELD,SYM)\
N    _PER_CFSETS(CHIP,ICR,##FIELD,##SYM)
X  #define _CHIP_ICR_FSETS(FIELD,SYM)    _PER_CFSETS(CHIP,ICR,##FIELD,##SYM)
N
N
N/******************************************************************************\
N* _____________________
X
N* |                   |
N* |  I E R            |
N* |___________________|
N*
N* IER - interruppt enable register
N*
N* FIELDS (msb -> lsb)
N* (rw) IE
N*
N\******************************************************************************/
N  extern far cregister volatile unsigned int IER;
N
N  #define _CHIP_IER_IE_MASK          0x0000FFFFu
N  #define _CHIP_IER_IE_SHIFT         0x00000000u
N  #define  CHIP_IER_IE_DEFAULT       0x00000000u
N  #define  CHIP_IER_IE_OF(x)         _VALUEOF(x)
N
N  #define  CHIP_IER_OF(x)            _VALUEOF(x)
N
N  #define CHIP_IER_DEFAULT (Uint32)( \
N     _PER_FDEFAULT(CHIP,IER,IE)\
N  )
X  #define CHIP_IER_DEFAULT (Uint32)(      _PER_FDEFAULT(CHIP,IER,IE)  )
N
N  #define CHIP_IER_RMK(ie) (Uint32)( \
N     _PER_FMK(CHIP,IER,IE,ie)\
N  )
X  #define CHIP_IER_RMK(ie) (Uint32)(      _PER_FMK(CHIP,IER,IE,ie)  )
N
N  #define _CHIP_IER_FGET(FIELD)\
N    _PER_CFGET(CHIP,IER,##FIELD)
X  #define _CHIP_IER_FGET(FIELD)    _PER_CFGET(CHIP,IER,##FIELD)
N
N  #define _CHIP_IER_FSET(FIELD,field)\
N    _PER_CFSET(CHIP,IER,##FIELD,field)
X  #define _CHIP_IER_FSET(FIELD,field)    _PER_CFSET(CHIP,IER,##FIELD,field)
N
N  #define _CHIP_IER_FSETS(FIELD,SYM)\
N    _PER_CFSETS(CHIP,IER,##FIELD,##SYM)
X  #define _CHIP_IER_FSETS(FIELD,SYM)    _PER_CFSETS(CHIP,IER,##FIELD,##SYM)
N
N
N/******************************************************************************\
N* _____________________
X
N* |                   |
N* |  I S T P          |
N* |___________________|
N*
N* ISTP - interrupt service table pointer
N*
N* FIELDS (msb -> lsb)
N* (r)   HPEINT
N* (rw)  ISTB
N*
N\******************************************************************************/
N  extern far cregister volatile unsigned int ISTP;
N
N  #define _CHIP_ISTP_ISTB_MASK         0xFFFFFC00u
N  #define _CHIP_ISTP_ISTB_SHIFT        0x0000000Au
N  #define  CHIP_ISTP_ISTB_DEFAULT      0x00000000u
N  #define  CHIP_ISTP_ISTB_OF(x)        _VALUEOF(x)
N
N  #define _CHIP_ISTP_HPEINT_MASK       0x000003E0u
N  #define _CHIP_ISTP_HPEINT_SHIFT      0x00000005u
N  #define  CHIP_ISTP_HPEINT_DEFAULT    0x00000000u
N  #define  CHIP_ISTP_HPEINT_OF(x)      _VALUEOF(x)
N
N  #define  CHIP_ISTP_OF(x)             _VALUEOF(x)
N
N  #define CHIP_ISTP_DEFAULT (Uint32)( \
N     _PER_FDEFAULT(CHIP,ISTP,ISTB)\
N    |_PER_FDEFAULT(CHIP,ISTP,HPEINT)\
N  )
X  #define CHIP_ISTP_DEFAULT (Uint32)(      _PER_FDEFAULT(CHIP,ISTP,ISTB)    |_PER_FDEFAULT(CHIP,ISTP,HPEINT)  )
N
N  #define CHIP_ISTP_RMK(istb) (Uint32)( \
N     _PER_FMK(CHIP,ISTP,ISTB,istb)\
N  )
X  #define CHIP_ISTP_RMK(istb) (Uint32)(      _PER_FMK(CHIP,ISTP,ISTB,istb)  )
N
N  #define _CHIP_ISTP_FGET(FIELD)\
N    _PER_CFGET(CHIP,ISTP,##FIELD)
X  #define _CHIP_ISTP_FGET(FIELD)    _PER_CFGET(CHIP,ISTP,##FIELD)
N
N  #define _CHIP_ISTP_FSET(FIELD,field)\
N    _PER_CFSET(CHIP,ISTP,##FIELD,field)
X  #define _CHIP_ISTP_FSET(FIELD,field)    _PER_CFSET(CHIP,ISTP,##FIELD,field)
N
N  #define _CHIP_ISTP_FSETS(FIELD,SYM)\
N    _PER_CFSETS(CHIP,ISTP,##FIELD,##SYM)
X  #define _CHIP_ISTP_FSETS(FIELD,SYM)    _PER_CFSETS(CHIP,ISTP,##FIELD,##SYM)
N
N
N/******************************************************************************\
N* _____________________
X
N* |                   |
N* |  I R P            |
N* |___________________|
N*
N* IRP - interrupt return pointer
N*
N* FIELDS (msb -> lsb)
N* (rw) IRP
N*
N\******************************************************************************/
N  extern far cregister volatile unsigned int IRP;
N
N  #define _CHIP_IRP_IRP_MASK           0xFFFFFFFFu
N  #define _CHIP_IRP_IRP_SHIFT          0x00000000u
N  #define  CHIP_IRP_IRP_DEFAULT        0x00000000u
N  #define  CHIP_IRP_IRP_OF(x)          _VALUEOF(x)
N
N  #define  CHIP_IRP_OF(x)              _VALUEOF(x)
N
N  #define CHIP_IRP_DEFAULT (Uint32)( \
N     _PER_FDEFAULT(CHIP,IRP,IRP)\
N  )
X  #define CHIP_IRP_DEFAULT (Uint32)(      _PER_FDEFAULT(CHIP,IRP,IRP)  )
N
N  #define CHIP_IRP_RMK(irp) (Uint32)( \
N     _PER_FMK(CHIP,IRP,IRP,irp)\
N  )
X  #define CHIP_IRP_RMK(irp) (Uint32)(      _PER_FMK(CHIP,IRP,IRP,irp)  )
N
N  #define _CHIP_IRP_FGET(FIELD)\
N    _PER_CFGET(CHIP,IRP,##FIELD)
X  #define _CHIP_IRP_FGET(FIELD)    _PER_CFGET(CHIP,IRP,##FIELD)
N
N  #define _CHIP_IRP_FSET(FIELD,field)\
N    _PER_CFSET(CHIP,IRP,##FIELD,field)
X  #define _CHIP_IRP_FSET(FIELD,field)    _PER_CFSET(CHIP,IRP,##FIELD,field)
N
N  #define _CHIP_IRP_FSETS(FIELD,SYM)\
N    _PER_CFSETS(CHIP,IRP,##FIELD,##SYM)
X  #define _CHIP_IRP_FSETS(FIELD,SYM)    _PER_CFSETS(CHIP,IRP,##FIELD,##SYM)
N
N
N/******************************************************************************\
N* _____________________
X
N* |                   |
N* |  N R P            |
N* |___________________|
N*
N* NRP - non-maskable interrupt return pointer
N*
N* FIELDS (msb -> lsb)
N* (rw) NRP
N*
N\******************************************************************************/
N  extern far cregister volatile unsigned int NRP;
N
N  #define _CHIP_NRP_NRP_MASK           0xFFFFFFFFu
N  #define _CHIP_NRP_NRP_SHIFT          0x00000000u
N  #define  CHIP_NRP_NRP_DEFAULT        0x00000000u
N  #define  CHIP_NRP_NRP_OF(x)          _VALUEOF(x)
N
N  #define  CHIP_NRP_OF(x)              _VALUEOF(x)
N
N  #define CHIP_NRP_DEFAULT (Uint32)( \
N     _PER_FDEFAULT(CHIP,NRP,NRP)\
N  )
X  #define CHIP_NRP_DEFAULT (Uint32)(      _PER_FDEFAULT(CHIP,NRP,NRP)  )
N
N  #define CHIP_NRP_RMK(nrp) (Uint32)( \
N     _PER_FMK(CHIP,NRP,NRP,nrp)\
N  )
X  #define CHIP_NRP_RMK(nrp) (Uint32)(      _PER_FMK(CHIP,NRP,NRP,nrp)  )
N
N  #define _CHIP_NRP_FGET(FIELD)\
N    _PER_CFGET(CHIP,NRP,##FIELD)
X  #define _CHIP_NRP_FGET(FIELD)    _PER_CFGET(CHIP,NRP,##FIELD)
N
N  #define _CHIP_NRP_FSET(FIELD,field)\
N    _PER_CFSET(CHIP,NRP,##FIELD,field)
X  #define _CHIP_NRP_FSET(FIELD,field)    _PER_CFSET(CHIP,NRP,##FIELD,field)
N
N  #define _CHIP_NRP_FSETS(FIELD,SYM)\
N    _PER_CFSETS(CHIP,NRP,##FIELD,##SYM)
X  #define _CHIP_NRP_FSETS(FIELD,SYM)    _PER_CFSETS(CHIP,NRP,##FIELD,##SYM)
N
N
N/******************************************************************************\
N* _____________________
X
N* |                   |
N* |  A M R            |
N* |___________________|
N*
N* AMR - addressing mode register
N*
N* FIELDS (msb -> lsb)
N* (rw) BK1
N* (rw) BK0
N* (rw) B7MODE
N* (rw) B6MODE
N* (rw) B5MODE
N* (rw) B4MODE
N* (rw) A7MODE
N* (rw) A6MODE
N* (rw) A5MODE
N* (rw) A4MODE
N*
N\******************************************************************************/
N  extern far cregister volatile unsigned int AMR;
N
N  #define _CHIP_AMR_BK1_MASK           0x02E00000u
N  #define _CHIP_AMR_BK1_SHIFT          0x00000015u
N  #define  CHIP_AMR_BK1_DEFAULT        0x00000000u
N  #define  CHIP_AMR_BK1_OF(x)          _VALUEOF(x)
N  #define  CHIP_AMR_BK1_2              0x00000000u
N  #define  CHIP_AMR_BK1_4              0x00000001u
N  #define  CHIP_AMR_BK1_8              0x00000002u
N  #define  CHIP_AMR_BK1_16             0x00000003u
N  #define  CHIP_AMR_BK1_32             0x00000004u
N  #define  CHIP_AMR_BK1_64             0x00000005u
N  #define  CHIP_AMR_BK1_128            0x00000006u
N  #define  CHIP_AMR_BK1_256            0x00000007u
N  #define  CHIP_AMR_BK1_512            0x00000008u
N  #define  CHIP_AMR_BK1_1K             0x00000009u
N  #define  CHIP_AMR_BK1_2K             0x0000000Au
N  #define  CHIP_AMR_BK1_4K             0x0000000Bu
N  #define  CHIP_AMR_BK1_8K             0x0000000Cu
N  #define  CHIP_AMR_BK1_16K            0x0000000Du
N  #define  CHIP_AMR_BK1_32K            0x0000000Eu
N  #define  CHIP_AMR_BK1_64K            0x0000000Fu
N  #define  CHIP_AMR_BK1_128K           0x00000010u
N  #define  CHIP_AMR_BK1_256K           0x00000011u
N  #define  CHIP_AMR_BK1_512K           0x00000012u
N  #define  CHIP_AMR_BK1_1M             0x00000013u
N  #define  CHIP_AMR_BK1_2M             0x00000014u
N  #define  CHIP_AMR_BK1_4M             0x00000015u
N  #define  CHIP_AMR_BK1_8M             0x00000016u
N  #define  CHIP_AMR_BK1_16M            0x00000017u
N  #define  CHIP_AMR_BK1_32M            0x00000018u
N  #define  CHIP_AMR_BK1_64M            0x00000019u
N  #define  CHIP_AMR_BK1_128M           0x0000001Au
N  #define  CHIP_AMR_BK1_256M           0x0000001Bu
N  #define  CHIP_AMR_BK1_512M           0x0000001Cu
N  #define  CHIP_AMR_BK1_1G             0x0000001Du
N  #define  CHIP_AMR_BK1_2G             0x0000001Eu
N  #define  CHIP_AMR_BK1_4G             0x0000001Fu
N
N  #define _CHIP_AMR_BK0_MASK           0x001F0000u
N  #define _CHIP_AMR_BK0_SHIFT          0x00000010u
N  #define  CHIP_AMR_BK0_DEFAULT        0x00000000u
N  #define  CHIP_AMR_BK0_OF(x)          _VALUEOF(x)
N  #define  CHIP_AMR_BK0_2              0x00000000u
N  #define  CHIP_AMR_BK0_4              0x00000001u
N  #define  CHIP_AMR_BK0_8              0x00000002u
N  #define  CHIP_AMR_BK0_16             0x00000003u
N  #define  CHIP_AMR_BK0_32             0x00000004u
N  #define  CHIP_AMR_BK0_64             0x00000005u
N  #define  CHIP_AMR_BK0_128            0x00000006u
N  #define  CHIP_AMR_BK0_256            0x00000007u
N  #define  CHIP_AMR_BK0_512            0x00000008u
N  #define  CHIP_AMR_BK0_1K             0x00000009u
N  #define  CHIP_AMR_BK0_2K             0x0000000Au
N  #define  CHIP_AMR_BK0_4K             0x0000000Bu
N  #define  CHIP_AMR_BK0_8K             0x0000000Cu
N  #define  CHIP_AMR_BK0_16K            0x0000000Du
N  #define  CHIP_AMR_BK0_32K            0x0000000Eu
N  #define  CHIP_AMR_BK0_64K            0x0000000Fu
N  #define  CHIP_AMR_BK0_128K           0x00000010u
N  #define  CHIP_AMR_BK0_256K           0x00000011u
N  #define  CHIP_AMR_BK0_512K           0x00000012u
N  #define  CHIP_AMR_BK0_1M             0x00000013u
N  #define  CHIP_AMR_BK0_2M             0x00000014u
N  #define  CHIP_AMR_BK0_4M             0x00000015u
N  #define  CHIP_AMR_BK0_8M             0x00000016u
N  #define  CHIP_AMR_BK0_16M            0x00000017u
N  #define  CHIP_AMR_BK0_32M            0x00000018u
N  #define  CHIP_AMR_BK0_64M            0x00000019u
N  #define  CHIP_AMR_BK0_128M           0x0000001Au
N  #define  CHIP_AMR_BK0_256M           0x0000001Bu
N  #define  CHIP_AMR_BK0_512M           0x0000001Cu
N  #define  CHIP_AMR_BK0_1G             0x0000001Du
N  #define  CHIP_AMR_BK0_2G             0x0000001Eu
N  #define  CHIP_AMR_BK0_4G             0x0000001Fu
N
N
N  #define _CHIP_AMR_B7MODE_MASK        0x0000C000u
N  #define _CHIP_AMR_B7MODE_SHIFT       0x0000000Eu
N  #define  CHIP_AMR_B7MODE_DEFAULT     0x00000000u
N  #define  CHIP_AMR_B7MODE_OF(x)       _VALUEOF(x)
N  #define  CHIP_AMR_B7MODE_LINEAR      0x00000000u
N  #define  CHIP_AMR_B7MODE_CIRCULAR0   0x00000001u
N  #define  CHIP_AMR_B7MODE_CIRCULAR1   0x00000002u
N
N  #define _CHIP_AMR_B6MODE_MASK        0x00003000u
N  #define _CHIP_AMR_B6MODE_SHIFT       0x0000000Cu
N  #define  CHIP_AMR_B6MODE_DEFAULT     0x00000000u
N  #define  CHIP_AMR_B6MODE_OF(x)       _VALUEOF(x)
N  #define  CHIP_AMR_B6MODE_LINEAR      0x00000000u
N  #define  CHIP_AMR_B6MODE_CIRCULAR0   0x00000001u
N  #define  CHIP_AMR_B6MODE_CIRCULAR1   0x00000002u
N
N  #define _CHIP_AMR_B5MODE_MASK        0x00000C00u
N  #define _CHIP_AMR_B5MODE_SHIFT       0x0000000Au
N  #define  CHIP_AMR_B5MODE_DEFAULT     0x00000000u
N  #define  CHIP_AMR_B5MODE_OF(x)       _VALUEOF(x)
N  #define  CHIP_AMR_B5MODE_LINEAR      0x00000000u
N  #define  CHIP_AMR_B5MODE_CIRCULAR0   0x00000001u
N  #define  CHIP_AMR_B5MODE_CIRCULAR1   0x00000002u
N
N  #define _CHIP_AMR_B4MODE_MASK        0x00000300u
N  #define _CHIP_AMR_B4MODE_SHIFT       0x00000008u
N  #define  CHIP_AMR_B4MODE_DEFAULT     0x00000000u
N  #define  CHIP_AMR_B4MODE_OF(x)       _VALUEOF(x)
N  #define  CHIP_AMR_B4MODE_LINEAR      0x00000000u
N  #define  CHIP_AMR_B4MODE_CIRCULAR0   0x00000001u
N  #define  CHIP_AMR_B4MODE_CIRCULAR1   0x00000002u
N
N  #define _CHIP_AMR_A7MODE_MASK        0x000000C0u
N  #define _CHIP_AMR_A7MODE_SHIFT       0x00000006u
N  #define  CHIP_AMR_A7MODE_DEFAULT     0x00000000u
N  #define  CHIP_AMR_A7MODE_OF(x)       _VALUEOF(x)
N  #define  CHIP_AMR_A7MODE_LINEAR      0x00000000u
N  #define  CHIP_AMR_A7MODE_CIRCULAR0   0x00000001u
N  #define  CHIP_AMR_A7MODE_CIRCULAR1   0x00000002u
N
N  #define _CHIP_AMR_A6MODE_MASK        0x00000030u
N  #define _CHIP_AMR_A6MODE_SHIFT       0x00000004u
N  #define  CHIP_AMR_A6MODE_DEFAULT     0x00000000u
N  #define  CHIP_AMR_A6MODE_OF(x)       _VALUEOF(x)
N  #define  CHIP_AMR_A6MODE_LINEAR      0x00000000u
N  #define  CHIP_AMR_A6MODE_CIRCULAR0   0x00000001u
N  #define  CHIP_AMR_A6MODE_CIRCULAR1   0x00000002u
N
N  #define _CHIP_AMR_A5MODE_MASK        0x0000000Cu
N  #define _CHIP_AMR_A5MODE_SHIFT       0x00000002u
N  #define  CHIP_AMR_A5MODE_DEFAULT     0x00000000u
N  #define  CHIP_AMR_A5MODE_OF(x)       _VALUEOF(x)
N  #define  CHIP_AMR_A5MODE_LINEAR      0x00000000u
N  #define  CHIP_AMR_A5MODE_CIRCULAR0   0x00000001u
N  #define  CHIP_AMR_A5MODE_CIRCULAR1   0x00000002u
N
N  #define _CHIP_AMR_A4MODE_MASK        0x00000003u
N  #define _CHIP_AMR_A4MODE_SHIFT       0x00000000u
N  #define  CHIP_AMR_A4MODE_DEFAULT     0x00000000u
N  #define  CHIP_AMR_A4MODE_OF(x)       _VALUEOF(x)
N  #define  CHIP_AMR_A4MODE_LINEAR      0x00000000u
N  #define  CHIP_AMR_A4MODE_CIRCULAR0   0x00000001u
N  #define  CHIP_AMR_A4MODE_CIRCULAR1   0x00000002u
N
N  #define  CHIP_AMR_OF(x)              _VALUEOF(x)
N
N  #define CHIP_AMR_DEFAULT (Uint32)( \
N     _PER_FDEFAULT(CHIP,AMR,BK1)\
N    |_PER_FDEFAULT(CHIP,AMR,BK0)\
N    |_PER_FDEFAULT(CHIP,AMR,B7MODE)\
N    |_PER_FDEFAULT(CHIP,AMR,B6MODE)\
N    |_PER_FDEFAULT(CHIP,AMR,B5MODE)\
N    |_PER_FDEFAULT(CHIP,AMR,B4MODE)\
N    |_PER_FDEFAULT(CHIP,AMR,A7MODE)\
N    |_PER_FDEFAULT(CHIP,AMR,A6MODE)\
N    |_PER_FDEFAULT(CHIP,AMR,A5MODE)\
N    |_PER_FDEFAULT(CHIP,AMR,A4MODE)\
N  )
X  #define CHIP_AMR_DEFAULT (Uint32)(      _PER_FDEFAULT(CHIP,AMR,BK1)    |_PER_FDEFAULT(CHIP,AMR,BK0)    |_PER_FDEFAULT(CHIP,AMR,B7MODE)    |_PER_FDEFAULT(CHIP,AMR,B6MODE)    |_PER_FDEFAULT(CHIP,AMR,B5MODE)    |_PER_FDEFAULT(CHIP,AMR,B4MODE)    |_PER_FDEFAULT(CHIP,AMR,A7MODE)    |_PER_FDEFAULT(CHIP,AMR,A6MODE)    |_PER_FDEFAULT(CHIP,AMR,A5MODE)    |_PER_FDEFAULT(CHIP,AMR,A4MODE)  )
N
N  #define CHIP_AMR_RMK(bk1,bk0,b7mode,b6mode,b5mode,b4mode,a7,ode,\
N    a6mode,a5mode,a4mode) (Uint32)( \
N     _PER_FMK(CHIP,AMR,BK1,bk1)\
N    |_PER_FMK(CHIP,AMR,BK0,bk0)\
N    |_PER_FMK(CHIP,AMR,B7MODE,b7mode)\
N    |_PER_FMK(CHIP,AMR,B6MODE,b6mode)\
N    |_PER_FMK(CHIP,AMR,B5MODE,b5mode)\
N    |_PER_FMK(CHIP,AMR,B4MODE,b4mode)\
N    |_PER_FMK(CHIP,AMR,A7MODE,a7mode)\
N    |_PER_FMK(CHIP,AMR,A6MODE,a6mode)\
N    |_PER_FMK(CHIP,AMR,A5MODE,a5mode)\
N    |_PER_FMK(CHIP,AMR,A4MODE,a4mode)\
N  )
X  #define CHIP_AMR_RMK(bk1,bk0,b7mode,b6mode,b5mode,b4mode,a7,ode,    a6mode,a5mode,a4mode) (Uint32)(      _PER_FMK(CHIP,AMR,BK1,bk1)    |_PER_FMK(CHIP,AMR,BK0,bk0)    |_PER_FMK(CHIP,AMR,B7MODE,b7mode)    |_PER_FMK(CHIP,AMR,B6MODE,b6mode)    |_PER_FMK(CHIP,AMR,B5MODE,b5mode)    |_PER_FMK(CHIP,AMR,B4MODE,b4mode)    |_PER_FMK(CHIP,AMR,A7MODE,a7mode)    |_PER_FMK(CHIP,AMR,A6MODE,a6mode)    |_PER_FMK(CHIP,AMR,A5MODE,a5mode)    |_PER_FMK(CHIP,AMR,A4MODE,a4mode)  )
N
N  #define _CHIP_AMR_FGET(FIELD)\
N    _PER_CFGET(CHIP,AMR,##FIELD)
X  #define _CHIP_AMR_FGET(FIELD)    _PER_CFGET(CHIP,AMR,##FIELD)
N
N  #define _CHIP_AMR_FSET(FIELD,field)\
N    _PER_CFSET(CHIP,AMR,##FIELD,field)
X  #define _CHIP_AMR_FSET(FIELD,field)    _PER_CFSET(CHIP,AMR,##FIELD,field)
N
N  #define _CHIP_AMR_FSETS(FIELD,SYM)\
N    _PER_CFSETS(CHIP,AMR,##FIELD,##SYM)
X  #define _CHIP_AMR_FSETS(FIELD,SYM)    _PER_CFSETS(CHIP,AMR,##FIELD,##SYM)
N
N
N
N/******************************************************************************\
N* _____________________
X
N* |                   |
N* |  D E V C F G      |
N* |___________________|
N*
N* PERCFG - Device Configuration register (1)
N*
N* FIELDS (msb -> lsb)  CHIP_6713/CHIP_DA610
N* (rw) EKSRC
N* (rw) TOUT1SEL
N* (rw) TOUT0SEL
N* (rw) MCBSP0DIS
N* (rw) MCBSP1DIS
N* (rw) GPIO1EN (only for CHIP_DA610)
N*
N* FIELDS (msb -> lsb)  CHIP_DM642
N* (rw) VP2EN
N* (rw) VP1EN
N* (rw) VP0EN
N* (rw) I2C0EN
N* (rw) MCBSP1EN
N* (rw) MCBSP0EN
N* (rw) MCASP0EN
N*
N* FIELDS (msb -> lsb)  CHIP_6412
N* (rw) I2C0EN
N* (rw) MCBSP1EN
N* (rw) MCBSP0EN
N*
N* FIELDS (msb -> lsb)  CHIP_6711C/CHIP_6712C
N* (rw) EKSRC
N*
N* FIELDS (msb -> lsb)  CHIP_6410/CHIP_6413/CHIP_6418
N* (rw) AFCMUX
N* (rw) MCASP1EN
N* (rw) I2C1EN
N* (rw) I2C0EN
N* (r) MCBSP1EN
N* (r) MCBSP0EN
N* (rw) MCASP0EN
N*
N\******************************************************************************/
N
N#if (CHIP_DA610)
X#if (0)
S
S  #define   _CHIP_DEVCFG_ADDR              0x019C0200u
S  #define   _CHIP_DEVCFG_OFFSET             0
S
S  #define _CHIP_DEVCFG_GPIO1EN_MASK        0x00010000u
S  #define _CHIP_DEVCFG_GPIO1EN_SHIFT       0x0000000Fu
S  #define  CHIP_DEVCFG_GPIO1EN_DEFAULT     0x00000000u
S  #define  CHIP_DEVCFG_GPIO1EN_OF(x)       _VALUEOF(x)
S  #define  CHIP_DEVCFG_GPIO1EN_0           0x00000000u
S  #define  CHIP_DEVCFG_GPIO1EN_1           0x00000001u
S
S  #define _CHIP_DEVCFG_EKSRC_MASK          0x00000010u
S  #define _CHIP_DEVCFG_EKSRC_SHIFT         0x00000004u
S  #define  CHIP_DEVCFG_EKSRC_DEFAULT       0x00000000u
S  #define  CHIP_DEVCFG_EKSRC_OF(x)         _VALUEOF(x)
S  #define  CHIP_DEVCFG_EKSRC_SYSCLK3       0x00000000u
S  #define  CHIP_DEVCFG_EKSRC_ECLKIN        0x00000001u
S
S  #define _CHIP_DEVCFG_TOUT1SEL_MASK       0x00000008u
S  #define _CHIP_DEVCFG_TOUT1SEL_SHIFT      0x00000003u
S  #define  CHIP_DEVCFG_TOUT1SEL_DEFAULT    0x00000000u
S  #define  CHIP_DEVCFG_TOUT1SEL_OF(x)       _VALUEOF(x)
S  #define  CHIP_DEVCFG_TOUT1SEL_TOUT1PIN   0x00000000u
S  #define  CHIP_DEVCFG_TOUT1SEL_MCASPPIN   0x00000001u
S
S  #define _CHIP_DEVCFG_TOUT0SEL_MASK       0x00000004u
S  #define _CHIP_DEVCFG_TOUT0SEL_SHIFT      0x00000002u
S  #define  CHIP_DEVCFG_TOUT0SEL_DEFAULT    0x00000000u
S  #define  CHIP_DEVCFG_TOUT0SEL_OF(x)       _VALUEOF(x)
S  #define  CHIP_DEVCFG_TOUT0SEL_TOUT0PIN   0x00000000u
S  #define  CHIP_DEVCFG_TOUT0SEL_MCASPPIN   0x00000001u
S
S  #define _CHIP_DEVCFG_MCBSP0DIS_MASK       0x00000002u
S  #define _CHIP_DEVCFG_MCBSP0DIS_SHIFT      0x00000001u
S  #define  CHIP_DEVCFG_MCBSP0DIS_DEFAULT    0x00000000u
S  #define  CHIP_DEVCFG_MCBSP0DIS_OF(x)       _VALUEOF(x)
S  #define  CHIP_DEVCFG_MCBSP0DIS_0          0x00000000u
S  #define  CHIP_DEVCFG_MCBSP0DIS_1          0x00000001u
S
S  #define _CHIP_DEVCFG_MCBSP1DIS_MASK         0x00000001u
S  #define _CHIP_DEVCFG_MCBSP1DIS_SHIFT        0x00000000u
S  #define  CHIP_DEVCFG_MCBSP1DIS_DEFAULT      0x00000000u
S  #define  CHIP_DEVCFG_MCBSP1DIS_OF(x)        _VALUEOF(x)
S  #define  CHIP_DEVCFG_MCBSP1DIS_0            0x00000000u
S  #define  CHIP_DEVCFG_MCBSP1DIS_1            0x00000001u
S
S
S  #define  CHIP_DEVCFG_OF(x)              _VALUEOF(x)
S
S  #define CHIP_DEVCFG_DEFAULT (Uint32)( \
S     _PER_FDEFAULT(CHIP,DEVCFG,EKSRC) \
S    |_PER_FDEFAULT(CHIP,DEVCFG,TOUT1SEL) \
S    |_PER_FDEFAULT(CHIP,DEVCFG,TOUT0SEL) \
S    |_PER_FDEFAULT(CHIP,DEVCFG,MCBSP0DIS) \
S    |_PER_FDEFAULT(CHIP,DEVCFG,MCBSP1DIS) \
S    |_PER_FDEFAULT(CHIP,DEVCFG,GPIO1EN) \
S )
X  #define CHIP_DEVCFG_DEFAULT (Uint32)(      _PER_FDEFAULT(CHIP,DEVCFG,EKSRC)     |_PER_FDEFAULT(CHIP,DEVCFG,TOUT1SEL)     |_PER_FDEFAULT(CHIP,DEVCFG,TOUT0SEL)     |_PER_FDEFAULT(CHIP,DEVCFG,MCBSP0DIS)     |_PER_FDEFAULT(CHIP,DEVCFG,MCBSP1DIS)     |_PER_FDEFAULT(CHIP,DEVCFG,GPIO1EN)  )
S
S  #define CHIP_DEVCFG_RMK(eksrc,tout1sel,tout0sel,mcbsp0dis,mcbsp1dis,\
S                          gpio1en ) (Uint32)( \
S      _PER_FMK(CHIP,DEVCFG,EKSRC,eksrc) \
S    |_PER_FMK(CHIP,DEVCFG,TOUT1SEL,tout1sel) \
S    |_PER_FMK(CHIP,DEVCFG,TOUT0SEL,tout0sel) \
S    |_PER_FMK(CHIP,DEVCFG,MCBSP0DIS,mcbsp0dis) \
S    |_PER_FMK(CHIP,DEVCFG,MCBSP1DIS,mcbsp1dis) \
S    |_PER_FMK(CHIP,DEVCFG,GPIO1EN,gpio1en) \
S)
X  #define CHIP_DEVCFG_RMK(eksrc,tout1sel,tout0sel,mcbsp0dis,mcbsp1dis,                          gpio1en ) (Uint32)(       _PER_FMK(CHIP,DEVCFG,EKSRC,eksrc)     |_PER_FMK(CHIP,DEVCFG,TOUT1SEL,tout1sel)     |_PER_FMK(CHIP,DEVCFG,TOUT0SEL,tout0sel)     |_PER_FMK(CHIP,DEVCFG,MCBSP0DIS,mcbsp0dis)     |_PER_FMK(CHIP,DEVCFG,MCBSP1DIS,mcbsp1dis)     |_PER_FMK(CHIP,DEVCFG,GPIO1EN,gpio1en) )
S#elif (CHIP_6713)
X#elif (0)
S  #define   _CHIP_DEVCFG_ADDR              0x019C0200u
S  #define   _CHIP_DEVCFG_OFFSET             0
S
S  #define _CHIP_DEVCFG_EKSRC_MASK          0x00000010u
S  #define _CHIP_DEVCFG_EKSRC_SHIFT         0x00000004u
S  #define  CHIP_DEVCFG_EKSRC_DEFAULT       0x00000000u
S  #define  CHIP_DEVCFG_EKSRC_OF(x)         _VALUEOF(x)
S  #define  CHIP_DEVCFG_EKSRC_SYSCLK3       0x00000000u
S  #define  CHIP_DEVCFG_EKSRC_ECLKIN        0x00000001u
S
S  #define _CHIP_DEVCFG_TOUT1SEL_MASK       0x00000008u
S  #define _CHIP_DEVCFG_TOUT1SEL_SHIFT      0x00000003u
S  #define  CHIP_DEVCFG_TOUT1SEL_DEFAULT    0x00000000u
S  #define  CHIP_DEVCFG_TOUT1SEL_OF(x)       _VALUEOF(x)
S  #define  CHIP_DEVCFG_TOUT1SEL_TOUT1PIN   0x00000000u
S  #define  CHIP_DEVCFG_TOUT1SEL_MCASPPIN   0x00000001u
S
S  #define _CHIP_DEVCFG_TOUT0SEL_MASK       0x00000004u
S  #define _CHIP_DEVCFG_TOUT0SEL_SHIFT      0x00000002u
S  #define  CHIP_DEVCFG_TOUT0SEL_DEFAULT    0x00000000u
S  #define  CHIP_DEVCFG_TOUT0SEL_OF(x)       _VALUEOF(x)
S  #define  CHIP_DEVCFG_TOUT0SEL_TOUT0PIN   0x00000000u
S  #define  CHIP_DEVCFG_TOUT0SEL_MCASPPIN   0x00000001u
S
S  #define _CHIP_DEVCFG_MCBSP0DIS_MASK      0x00000002u
S  #define _CHIP_DEVCFG_MCBSP0DIS_SHIFT     0x00000001u
S  #define  CHIP_DEVCFG_MCBSP0DIS_DEFAULT   0x00000000u
S  #define  CHIP_DEVCFG_MCBSP0DIS_OF(x)     _VALUEOF(x)
S  #define  CHIP_DEVCFG_MCBSP0DIS_0         0x00000000u
S  #define  CHIP_DEVCFG_MCBSP0DIS_1         0x00000001u
S
S  #define _CHIP_DEVCFG_MCBSP1DIS_MASK      0x00000001u
S  #define _CHIP_DEVCFG_MCBSP1DIS_SHIFT     0x00000000u
S  #define  CHIP_DEVCFG_MCBSP1DIS_DEFAULT   0x00000000u
S  #define  CHIP_DEVCFG_MCBSP1DIS_OF(x)     _VALUEOF(x)
S  #define  CHIP_DEVCFG_MCBSP1DIS_0         0x00000000u
S  #define  CHIP_DEVCFG_MCBSP1DIS_1         0x00000001u
S
S
S  #define  CHIP_DEVCFG_OF(x)              _VALUEOF(x)
S
S  #define CHIP_DEVCFG_DEFAULT (Uint32)( \
S     _PER_FDEFAULT(CHIP,DEVCFG,EKSRC) \
S    |_PER_FDEFAULT(CHIP,DEVCFG,TOUT1SEL) \
S    |_PER_FDEFAULT(CHIP,DEVCFG,TOUT0SEL) \
S    |_PER_FDEFAULT(CHIP,DEVCFG,MCBSP0DIS) \
S    |_PER_FDEFAULT(CHIP,DEVCFG,MCBSP1DIS) \
S )
X  #define CHIP_DEVCFG_DEFAULT (Uint32)(      _PER_FDEFAULT(CHIP,DEVCFG,EKSRC)     |_PER_FDEFAULT(CHIP,DEVCFG,TOUT1SEL)     |_PER_FDEFAULT(CHIP,DEVCFG,TOUT0SEL)     |_PER_FDEFAULT(CHIP,DEVCFG,MCBSP0DIS)     |_PER_FDEFAULT(CHIP,DEVCFG,MCBSP1DIS)  )
S
S  #define CHIP_DEVCFG_RMK(eksrc,tout1sel,tout0sel,mcbsp0dis,mcbsp1dis\
S                          ) (Uint32)( \
S      _PER_FMK(CHIP,DEVCFG,EKSRC,eksrc) \
S    |_PER_FMK(CHIP,DEVCFG,TOUT1SEL,tout1sel) \
S    |_PER_FMK(CHIP,DEVCFG,TOUT0SEL,tout0sel) \
S    |_PER_FMK(CHIP,DEVCFG,MCBSP0DIS,mcbsp0dis) \
S    |_PER_FMK(CHIP,DEVCFG,MCBSP1DIS,mcbsp1dis) \
S)
X  #define CHIP_DEVCFG_RMK(eksrc,tout1sel,tout0sel,mcbsp0dis,mcbsp1dis                          ) (Uint32)(       _PER_FMK(CHIP,DEVCFG,EKSRC,eksrc)     |_PER_FMK(CHIP,DEVCFG,TOUT1SEL,tout1sel)     |_PER_FMK(CHIP,DEVCFG,TOUT0SEL,tout0sel)     |_PER_FMK(CHIP,DEVCFG,MCBSP0DIS,mcbsp0dis)     |_PER_FMK(CHIP,DEVCFG,MCBSP1DIS,mcbsp1dis) )
S
N#endif
N
N#if (CHIP_DM642 || CHIP_DM641 || CHIP_DM640 || CHIP_6412)
X#if (0 || 0 || 0 || 0)
S
S  #define   _CHIP_PERCFG_ADDR                0x01B3F000u
S  #define   _CHIP_PERCFG_OFFSET              0
S
S#if (CHIP_DM642)
S  #define _CHIP_PERCFG_VP2EN_MASK            0x00000040u
S  #define _CHIP_PERCFG_VP2EN_SHIFT           0x00000006u
S  #define  CHIP_PERCFG_VP2EN_DEFAULT         0x00000000u
S  #define  CHIP_PERCFG_VP2EN_OF(x)           _VALUEOF(x)
S  #define  CHIP_PERCFG_VP2EN_DISABLE         0x00000000u
S  #define  CHIP_PERCFG_VP2EN_ENABLE          0x00000001u
S#endif
S
S#if (CHIP_DM642 | CHIP_DM641)                          
S  #define _CHIP_PERCFG_VP1EN_MASK            0x00000020u
S  #define _CHIP_PERCFG_VP1EN_SHIFT           0x00000005u
S  #define  CHIP_PERCFG_VP1EN_DEFAULT         0x00000000u
S  #define  CHIP_PERCFG_VP1EN_OF(x)           _VALUEOF(x)
S  #define  CHIP_PERCFG_VP1EN_DISABLE         0x00000000u
S  #define  CHIP_PERCFG_VP1EN_ENABLE          0x00000001u
S#endif
S
S#if (CHIP_DM642 | CHIP_DM641 | CHIP_DM640)                          
S  #define _CHIP_PERCFG_VP0EN_MASK            0x00000010u
S  #define _CHIP_PERCFG_VP0EN_SHIFT           0x00000004u
S  #define  CHIP_PERCFG_VP0EN_DEFAULT         0x00000000u
S  #define  CHIP_PERCFG_VP0EN_OF(x)           _VALUEOF(x)
S  #define  CHIP_PERCFG_VP0EN_DISABLE         0x00000000u
S  #define  CHIP_PERCFG_VP0EN_ENABLE          0x00000001u
S#endif
S
S  #define _CHIP_PERCFG_I2C0EN_MASK           0x00000008u
S  #define _CHIP_PERCFG_I2C0EN_SHIFT          0x00000003u
S  #define  CHIP_PERCFG_I2C0EN_DEFAULT        0x00000000u
S  #define  CHIP_PERCFG_I2C0EN_OF(x)          _VALUEOF(x)
S  #define  CHIP_PERCFG_I2C0EN_DISABLE        0x00000000u
S  #define  CHIP_PERCFG_I2C0EN_ENABLE         0x00000001u
S
S  #define _CHIP_PERCFG_MCBSP1EN_MASK         0x00000004u
S  #define _CHIP_PERCFG_MCBSP1EN_SHIFT        0x00000002u
S  #define  CHIP_PERCFG_MCBSP1EN_DEFAULT      0x00000001u
S  #define  CHIP_PERCFG_MCBSP1EN_OF(x)        _VALUEOF(x)
S  #define  CHIP_PERCFG_MCBSP1EN_DISABLE      0x00000000u
S  #define  CHIP_PERCFG_MCBSP1EN_ENABLE       0x00000001u
S
S  #define _CHIP_PERCFG_MCBSP0EN_MASK         0x00000002u
S  #define _CHIP_PERCFG_MCBSP0EN_SHIFT        0x00000001u
S  #define  CHIP_PERCFG_MCBSP0EN_DEFAULT      0x00000001u
S  #define  CHIP_PERCFG_MCBSP0EN_OF(x)        _VALUEOF(x)
S  #define  CHIP_PERCFG_MCBSP0EN_DISABLE      0x00000000u
S  #define  CHIP_PERCFG_MCBSP0EN_ENABLE       0x00000001u
S
S#if (CHIP_DM642 | CHIP_DM641 | CHIP_DM640)
S  #define _CHIP_PERCFG_MCASP0EN_MASK         0x00000001u
S  #define _CHIP_PERCFG_MCASP0EN_SHIFT        0x00000000u
S  #define  CHIP_PERCFG_MCASP0EN_DEFAULT      0x00000000u
S  #define  CHIP_PERCFG_MCASP0EN_OF(x)         _VALUEOF(x)
S  #define  CHIP_PERCFG_MCASP0EN_DISABLE      0x00000000u
S  #define  CHIP_PERCFG_MCASP0EN_ENABLE       0x00000001u
S#endif
S
S
S  #define  CHIP_PERCFG_OF(x)              _VALUEOF(x)
S
S#if (CHIP_DM642)
S  #define CHIP_PERCFG_DEFAULT (Uint32)( \
S     _PER_FDEFAULT(CHIP,PERCFG,VP2EN) \
S    |_PER_FDEFAULT(CHIP,PERCFG,VP1EN) \
S    |_PER_FDEFAULT(CHIP,PERCFG,VP0EN) \
S    |_PER_FDEFAULT(CHIP,PERCFG,I2C0EN) \
S    |_PER_FDEFAULT(CHIP,PERCFG,MCBSP1EN) \
S    |_PER_FDEFAULT(CHIP,PERCFG,MCBSP0EN) \
S    |_PER_FDEFAULT(CHIP,PERCFG,MCASP0EN) \
S   )
X  #define CHIP_PERCFG_DEFAULT (Uint32)(      _PER_FDEFAULT(CHIP,PERCFG,VP2EN)     |_PER_FDEFAULT(CHIP,PERCFG,VP1EN)     |_PER_FDEFAULT(CHIP,PERCFG,VP0EN)     |_PER_FDEFAULT(CHIP,PERCFG,I2C0EN)     |_PER_FDEFAULT(CHIP,PERCFG,MCBSP1EN)     |_PER_FDEFAULT(CHIP,PERCFG,MCBSP0EN)     |_PER_FDEFAULT(CHIP,PERCFG,MCASP0EN)    )
S
S
S #define CHIP_PERCFG_RMK(vp2en,vp1en,vp0en,i2c0en,mcbsp1en,mcbsp0en,mcasp0en) (Uint32)( \
S     _PER_FMK(CHIP,PERCFG,VP2EN,vp2en) \
S    |_PER_FMK(CHIP,PERCFG,VP1EN,vp1en) \
S    |_PER_FMK(CHIP,PERCFG,VP0EN,vp0en) \
S    |_PER_FMK(CHIP,PERCFG,I2C0EN,i2c0en) \
S    |_PER_FMK(CHIP,PERCFG,MCBSP1EN,mcbsp1en) \
S    |_PER_FMK(CHIP,PERCFG,MCBSP0EN,mcbsp0en) \
S    |_PER_FMK(CHIP,PERCFG,MCASP0EN,mcasp0en) \
S  )
X #define CHIP_PERCFG_RMK(vp2en,vp1en,vp0en,i2c0en,mcbsp1en,mcbsp0en,mcasp0en) (Uint32)(      _PER_FMK(CHIP,PERCFG,VP2EN,vp2en)     |_PER_FMK(CHIP,PERCFG,VP1EN,vp1en)     |_PER_FMK(CHIP,PERCFG,VP0EN,vp0en)     |_PER_FMK(CHIP,PERCFG,I2C0EN,i2c0en)     |_PER_FMK(CHIP,PERCFG,MCBSP1EN,mcbsp1en)     |_PER_FMK(CHIP,PERCFG,MCBSP0EN,mcbsp0en)     |_PER_FMK(CHIP,PERCFG,MCASP0EN,mcasp0en)   )
S#endif
S
S#if (CHIP_DM641)
S  #define CHIP_PERCFG_DEFAULT (Uint32)( \
S     _PER_FDEFAULT(CHIP,PERCFG,VP1EN) \
S    |_PER_FDEFAULT(CHIP,PERCFG,VP0EN) \
S    |_PER_FDEFAULT(CHIP,PERCFG,I2C0EN) \
S    |_PER_FDEFAULT(CHIP,PERCFG,MCBSP1EN) \
S    |_PER_FDEFAULT(CHIP,PERCFG,MCBSP0EN) \
S    |_PER_FDEFAULT(CHIP,PERCFG,MCASP0EN) \
S   )
X  #define CHIP_PERCFG_DEFAULT (Uint32)(      _PER_FDEFAULT(CHIP,PERCFG,VP1EN)     |_PER_FDEFAULT(CHIP,PERCFG,VP0EN)     |_PER_FDEFAULT(CHIP,PERCFG,I2C0EN)     |_PER_FDEFAULT(CHIP,PERCFG,MCBSP1EN)     |_PER_FDEFAULT(CHIP,PERCFG,MCBSP0EN)     |_PER_FDEFAULT(CHIP,PERCFG,MCASP0EN)    )
S
S
S #define CHIP_PERCFG_RMK(vp1en,vp0en,i2c0en,mcbsp1en,mcbsp0en,mcasp0en) (Uint32)( \
S     _PER_FMK(CHIP,PERCFG,VP1EN,vp1en) \
S    |_PER_FMK(CHIP,PERCFG,VP0EN,vp0en) \
S    |_PER_FMK(CHIP,PERCFG,I2C0EN,i2c0en) \
S    |_PER_FMK(CHIP,PERCFG,MCBSP1EN,mcbsp1en) \
S    |_PER_FMK(CHIP,PERCFG,MCBSP0EN,mcbsp0en) \
S    |_PER_FMK(CHIP,PERCFG,MCASP0EN,mcasp0en) \
S  )
X #define CHIP_PERCFG_RMK(vp1en,vp0en,i2c0en,mcbsp1en,mcbsp0en,mcasp0en) (Uint32)(      _PER_FMK(CHIP,PERCFG,VP1EN,vp1en)     |_PER_FMK(CHIP,PERCFG,VP0EN,vp0en)     |_PER_FMK(CHIP,PERCFG,I2C0EN,i2c0en)     |_PER_FMK(CHIP,PERCFG,MCBSP1EN,mcbsp1en)     |_PER_FMK(CHIP,PERCFG,MCBSP0EN,mcbsp0en)     |_PER_FMK(CHIP,PERCFG,MCASP0EN,mcasp0en)   )
S#endif
S
S#if (CHIP_DM640)
S  #define CHIP_PERCFG_DEFAULT (Uint32)( \
S     _PER_FDEFAULT(CHIP,PERCFG,VP0EN) \
S    |_PER_FDEFAULT(CHIP,PERCFG,I2C0EN) \
S    |_PER_FDEFAULT(CHIP,PERCFG,MCBSP1EN) \
S    |_PER_FDEFAULT(CHIP,PERCFG,MCBSP0EN) \
S    |_PER_FDEFAULT(CHIP,PERCFG,MCASP0EN) \
S   )
X  #define CHIP_PERCFG_DEFAULT (Uint32)(      _PER_FDEFAULT(CHIP,PERCFG,VP0EN)     |_PER_FDEFAULT(CHIP,PERCFG,I2C0EN)     |_PER_FDEFAULT(CHIP,PERCFG,MCBSP1EN)     |_PER_FDEFAULT(CHIP,PERCFG,MCBSP0EN)     |_PER_FDEFAULT(CHIP,PERCFG,MCASP0EN)    )
S
S
S #define CHIP_PERCFG_RMK(vp0en,i2c0en,mcbsp1en,mcbsp0en,mcasp0en) (Uint32)( \
S     _PER_FMK(CHIP,PERCFG,VP0EN,vp0en) \
S    |_PER_FMK(CHIP,PERCFG,I2C0EN,i2c0en) \
S    |_PER_FMK(CHIP,PERCFG,MCBSP1EN,mcbsp1en) \
S    |_PER_FMK(CHIP,PERCFG,MCBSP0EN,mcbsp0en) \
S    |_PER_FMK(CHIP,PERCFG,MCASP0EN,mcasp0en) \
S  )
X #define CHIP_PERCFG_RMK(vp0en,i2c0en,mcbsp1en,mcbsp0en,mcasp0en) (Uint32)(      _PER_FMK(CHIP,PERCFG,VP0EN,vp0en)     |_PER_FMK(CHIP,PERCFG,I2C0EN,i2c0en)     |_PER_FMK(CHIP,PERCFG,MCBSP1EN,mcbsp1en)     |_PER_FMK(CHIP,PERCFG,MCBSP0EN,mcbsp0en)     |_PER_FMK(CHIP,PERCFG,MCASP0EN,mcasp0en)   )
S#endif
S
S#if (CHIP_6412)
S  #define CHIP_PERCFG_DEFAULT (Uint32)( \
S     _PER_FDEFAULT(CHIP,PERCFG,I2C0EN) \
S    |_PER_FDEFAULT(CHIP,PERCFG,MCBSP1EN) \
S    |_PER_FDEFAULT(CHIP,PERCFG,MCBSP0EN) \
S   )
X  #define CHIP_PERCFG_DEFAULT (Uint32)(      _PER_FDEFAULT(CHIP,PERCFG,I2C0EN)     |_PER_FDEFAULT(CHIP,PERCFG,MCBSP1EN)     |_PER_FDEFAULT(CHIP,PERCFG,MCBSP0EN)    )
S
S
S #define CHIP_PERCFG_RMK(i2c0en,mcbsp1en,mcbsp0en) (Uint32)( \
S    |_PER_FMK(CHIP,PERCFG,I2C0EN,i2c0en) \
S    |_PER_FMK(CHIP,PERCFG,MCBSP1EN,mcbsp1en) \
S    |_PER_FMK(CHIP,PERCFG,MCBSP0EN,mcbsp0en) \
S  )
X #define CHIP_PERCFG_RMK(i2c0en,mcbsp1en,mcbsp0en) (Uint32)(     |_PER_FMK(CHIP,PERCFG,I2C0EN,i2c0en)     |_PER_FMK(CHIP,PERCFG,MCBSP1EN,mcbsp1en)     |_PER_FMK(CHIP,PERCFG,MCBSP0EN,mcbsp0en)   )
S#endif
S
N#endif /* CHIP_DM642 || CHIP_6412  */
N
N#if (CHIP_6410 || CHIP_6413 || CHIP_6418)
X#if (0 || 0 || 0)
S
S  #define   _CHIP_PERCFG_ADDR                0x01B3F000u
S  #define   _CHIP_PERCFG_OFFSET              0
S  
S  #define _CHIP_PERCFG_AFCMUX_MASK           0x00000600u
S  #define _CHIP_PERCFG_AFCMUX_SHIFT          0x00000009u
S  #define  CHIP_PERCFG_AFCMUX_DEFAULT        0x00000000u
S  #define  CHIP_PERCFG_AFCMUX_OF(x)           _VALUEOF(x)
S  #define  CHIP_PERCFG_AFCMUX_PIN0           0x00000000u
S  #define  CHIP_PERCFG_AFCMUX_PIN1           0x00000001u
S  #define  CHIP_PERCFG_AFCMUX_PIN2           0x00000002u
S  #define  CHIP_PERCFG_AFCMUX_PIN3           0x00000003u
S 
S  #define _CHIP_PERCFG_MCASP1EN_MASK         0x00000100u
S  #define _CHIP_PERCFG_MCASP1EN_SHIFT        0x00000008u
S  #define  CHIP_PERCFG_MCASP1EN_DEFAULT      0x00000000u
S  #define  CHIP_PERCFG_MCASP1EN_OF(x)         _VALUEOF(x)
S  #define  CHIP_PERCFG_MCASP1EN_DISABLE      0x00000000u
S  #define  CHIP_PERCFG_MCASP1EN_ENABLE       0x00000001u
S
S  #define _CHIP_PERCFG_I2C1EN_MASK           0x00000080u
S  #define _CHIP_PERCFG_I2C1EN_SHIFT          0x00000007u
S  #define  CHIP_PERCFG_I2C1EN_DEFAULT        0x00000000u
S  #define  CHIP_PERCFG_I2C1EN_OF(x)          _VALUEOF(x)
S  #define  CHIP_PERCFG_I2C1EN_DISABLE        0x00000000u
S  #define  CHIP_PERCFG_I2C1EN_ENABLE         0x00000001u
S
S  #define _CHIP_PERCFG_I2C0EN_MASK           0x00000008u
S  #define _CHIP_PERCFG_I2C0EN_SHIFT          0x00000003u
S  #define  CHIP_PERCFG_I2C0EN_DEFAULT        0x00000000u
S  #define  CHIP_PERCFG_I2C0EN_OF(x)          _VALUEOF(x)
S  #define  CHIP_PERCFG_I2C0EN_DISABLE        0x00000000u
S  #define  CHIP_PERCFG_I2C0EN_ENABLE         0x00000001u
S
S  #define _CHIP_PERCFG_MCBSP1EN_MASK         0x00000004u
S  #define _CHIP_PERCFG_MCBSP1EN_SHIFT        0x00000002u
S  #define  CHIP_PERCFG_MCBSP1EN_DEFAULT      0x00000001u
S  #define  CHIP_PERCFG_MCBSP1EN_OF(x)        _VALUEOF(x)
S  #define  CHIP_PERCFG_MCBSP1EN_DISABLE      0x00000000u
S  #define  CHIP_PERCFG_MCBSP1EN_ENABLE       0x00000001u
S 
S  #define _CHIP_PERCFG_MCBSP0EN_MASK         0x00000002u
S  #define _CHIP_PERCFG_MCBSP0EN_SHIFT        0x00000001u
S  #define  CHIP_PERCFG_MCBSP0EN_DEFAULT      0x00000001u
S  #define  CHIP_PERCFG_MCBSP0EN_OF(x)        _VALUEOF(x)
S  #define  CHIP_PERCFG_MCBSP0EN_DISABLE      0x00000000u
S  #define  CHIP_PERCFG_MCBSP0EN_ENABLE       0x00000001u
S
S  #define _CHIP_PERCFG_MCASP0EN_MASK         0x00000001u
S  #define _CHIP_PERCFG_MCASP0EN_SHIFT        0x00000000u
S  #define  CHIP_PERCFG_MCASP0EN_DEFAULT      0x00000000u
S  #define  CHIP_PERCFG_MCASP0EN_OF(x)         _VALUEOF(x)
S  #define  CHIP_PERCFG_MCASP0EN_DISABLE      0x00000000u
S  #define  CHIP_PERCFG_MCASP0EN_ENABLE       0x00000001u
S
S  #define  CHIP_PERCFG_OF(x)              _VALUEOF(x)
S
S  #define CHIP_PERCFG_DEFAULT (Uint32)( \
S    _PER_FDEFAULT(CHIP,PERCFG,AFCMUX) \
S    |_PER_FDEFAULT(CHIP,PERCFG,MCASP1EN) \
S    |_PER_FDEFAULT(CHIP,PERCFG,I2C1EN) \
S    |_PER_FDEFAULT(CHIP,PERCFG,I2C0EN) \
S    |_PER_FDEFAULT(CHIP,PERCFG,MCBSP1EN) \
S    |_PER_FDEFAULT(CHIP,PERCFG,MCBSP0EN) \
S    |_PER_FDEFAULT(CHIP,PERCFG,MCASP0EN) \
S   )  
X  #define CHIP_PERCFG_DEFAULT (Uint32)(     _PER_FDEFAULT(CHIP,PERCFG,AFCMUX)     |_PER_FDEFAULT(CHIP,PERCFG,MCASP1EN)     |_PER_FDEFAULT(CHIP,PERCFG,I2C1EN)     |_PER_FDEFAULT(CHIP,PERCFG,I2C0EN)     |_PER_FDEFAULT(CHIP,PERCFG,MCBSP1EN)     |_PER_FDEFAULT(CHIP,PERCFG,MCBSP0EN)     |_PER_FDEFAULT(CHIP,PERCFG,MCASP0EN)    )  
S  
S
S #define CHIP_PERCFG_RMK(afcmux,mcasp1en,i2c1en,i2c0en,mcasp0en) (Uint32)( \
S    _PER_FMK(CHIP,PERCFG,AFCMUX,afcmux) \
S    |_PER_FMK(CHIP,PERCFG,MCASP1EN,mcasp1en) \
S    |_PER_FMK(CHIP,PERCFG,I2C1EN,i2c1en) \
S    |_PER_FMK(CHIP,PERCFG,I2C0EN,i2c0en) \
S    |_PER_FMK(CHIP,PERCFG,MCASP0EN,mcasp0en) \
S  )  
X #define CHIP_PERCFG_RMK(afcmux,mcasp1en,i2c1en,i2c0en,mcasp0en) (Uint32)(     _PER_FMK(CHIP,PERCFG,AFCMUX,afcmux)     |_PER_FMK(CHIP,PERCFG,MCASP1EN,mcasp1en)     |_PER_FMK(CHIP,PERCFG,I2C1EN,i2c1en)     |_PER_FMK(CHIP,PERCFG,I2C0EN,i2c0en)     |_PER_FMK(CHIP,PERCFG,MCASP0EN,mcasp0en)   )  
S
N#endif /* CHIP_6410 || CHIP_6413 || CHIP_6418 */
N
N#if (CHIP_6711C || CHIP_6712C)
X#if (0 || 0)
S  #define   _CHIP_DEVCFG_ADDR              0x019C0200u
S  #define   _CHIP_DEVCFG_OFFSET            0
S
S  #define _CHIP_DEVCFG_EKSRC_MASK          0x00000010u
S  #define _CHIP_DEVCFG_EKSRC_SHIFT         0x00000004u
S  #define  CHIP_DEVCFG_EKSRC_DEFAULT       0x00000000u
S  #define  CHIP_DEVCFG_EKSRC_OF(x)         _VALUEOF(x)
S  #define  CHIP_DEVCFG_EKSRC_SYSCLK3       0x00000000u
S  #define  CHIP_DEVCFG_EKSRC_ECLKIN        0x00000001u
S
S  #define  CHIP_DEVCFG_OF(x)              _VALUEOF(x)
S
S  #define CHIP_DEVCFG_DEFAULT (Uint32)( \
S     _PER_FDEFAULT(CHIP,DEVCFG,EKSRC) \
S )
X  #define CHIP_DEVCFG_DEFAULT (Uint32)(      _PER_FDEFAULT(CHIP,DEVCFG,EKSRC)  )
S
S  #define CHIP_PERCFG_RMK(eksrc) (Uint32)( \
S      _PER_FMK(CHIP,PERCFG,EKSRC,eksrc) \
S)
X  #define CHIP_PERCFG_RMK(eksrc) (Uint32)(       _PER_FMK(CHIP,PERCFG,EKSRC,eksrc) )
S
N#endif /* CHIP_6711C || CHIP_6712C */
N
N#if (CHIP_6711C || CHIP_6712C || CHIP_DA610 || CHIP_6713) 
X#if (0 || 0 || 0 || 0) 
S  #define _CHIP_DEVCFG_FGET(FIELD)\
S    _PER_FGET(_CHIP_DEVCFG_ADDR,CHIP,DEVCFG,##FIELD)
X  #define _CHIP_DEVCFG_FGET(FIELD)    _PER_FGET(_CHIP_DEVCFG_ADDR,CHIP,DEVCFG,##FIELD)
S
S  #define _CHIP_DEVCFG_FSET(FIELD,field)\
S    _PER_FSET(_CHIP_DEVCFG_ADDR,CHIP,DEVCFG,##FIELD,field)
X  #define _CHIP_DEVCFG_FSET(FIELD,field)    _PER_FSET(_CHIP_DEVCFG_ADDR,CHIP,DEVCFG,##FIELD,field)
S
S  #define _CHIP_DEVCFG_FSETS(FIELD,SYM)\
S    _PER_FSETS(_CHIP_DEVCFG_ADDR,CHIP,DEVCFG,##FIELD,##SYM)
X  #define _CHIP_DEVCFG_FSETS(FIELD,SYM)    _PER_FSETS(_CHIP_DEVCFG_ADDR,CHIP,DEVCFG,##FIELD,##SYM)
S   
N#else
N  
N  #define _CHIP_PERCFG_FGET(FIELD)\
N    _PER_FGET(_CHIP_PERCFG_ADDR,CHIP,PERCFG,##FIELD)
X  #define _CHIP_PERCFG_FGET(FIELD)    _PER_FGET(_CHIP_PERCFG_ADDR,CHIP,PERCFG,##FIELD)
N
N  #define _CHIP_PERCFG_FSET(FIELD,field)\
N    _PER_FSET(_CHIP_PERCFG_ADDR,CHIP,PERCFG,##FIELD,field)
X  #define _CHIP_PERCFG_FSET(FIELD,field)    _PER_FSET(_CHIP_PERCFG_ADDR,CHIP,PERCFG,##FIELD,field)
N
N  #define _CHIP_PERCFG_FSETS(FIELD,SYM)\
N    _PER_FSETS(_CHIP_PERCFG_ADDR,CHIP,PERCFG,##FIELD,##SYM)
X  #define _CHIP_PERCFG_FSETS(FIELD,SYM)    _PER_FSETS(_CHIP_PERCFG_ADDR,CHIP,PERCFG,##FIELD,##SYM)
N#endif
N
N/*----------------------------------------------------------------------------*/
N/******************************************************************************\
N* _____________________
X
N* |                   |
N* |  D E V S T A T    |
N* |___________________|
N*
N* DEVSTAT - Device Status Register (1)
N*
N* FIELDS (msb -> lsb)
N* DM642
N* (r) MACEN
N* (r) HPIWIDTH
N* (r) PCIEEAI
N* (r) PCIEN
N* (r) CLKMODE
N* (r) LENDIAN
N* (r) BOOTMODE
N* (r) AECLKINSEL
N*
N* DRI300
N* (r) PLLM
N* (r) OSCEXTRES
N* (r) CLKINSEL
N* (r) CLKMODE3
N* (r) HPIWIDTH
N* (r) HPIENZ
N* (r) CLKMODE2
N* (r) CLKMODE1
N* (r) CLKMODE0
N* (r) LENDIAN
N* (r) BOOTMODE
N* (r) AECLKINSEL
N*
N* 
N\******************************************************************************/
N#if (CHIP_DM642 | CHIP_DM641 | CHIP_DM640 | CHIP_6412)
X#if (0 | 0 | 0 | 0)
S
S  #define   _CHIP_DEVSTAT_ADDR                0x01B3F004u
S  #define   _CHIP_DEVSTAT_OFFSET              0
S
S  #define _CHIP_DEVSTAT_MACEN_MASK            0x00000800u
S  #define _CHIP_DEVSTAT_MACEN_SHIFT           0x0000000Bu
S  #define  CHIP_DEVSTAT_MACEN_DEFAULT         0x00000000u
S  #define  CHIP_DEVSTAT_MACEN_OF(x)           _VALUEOF(x)
S  #define  CHIP_DEVSTAT_MACEN_DISABLE         0x00000000u
S  #define  CHIP_DEVSTAT_MACEN_ENABLE          0x00000001u
S
S #if !(CHIP_DM640)
S  #define _CHIP_DEVSTAT_HPIWIDTH_MASK            0x00000400u
S  #define _CHIP_DEVSTAT_HPIWIDTH_SHIFT           0x0000000Au
S  #define  CHIP_DEVSTAT_HPIWIDTH_DEFAULT         0x00000000u
S  #define  CHIP_DEVSTAT_HPIWIDTH_OF(x)           _VALUEOF(x)
S  #define  CHIP_DEVSTAT_HPIWIDTH_16              0x00000000u
S  #define  CHIP_DEVSTAT_HPIWIDTH_32              0x00000001u
S #endif
S
S #if !(CHIP_DM641 | CHIP_DM640)
S  #define _CHIP_DEVSTAT_PCIEEAI_MASK            0x00000200u
S  #define _CHIP_DEVSTAT_PCIEEAI_SHIFT           0x00000009u
S  #define  CHIP_DEVSTAT_PCIEEAI_DEFAULT         0x00000000u
S  #define  CHIP_DEVSTAT_PCIEEAI_OF(x)           _VALUEOF(x)
S  #define  CHIP_DEVSTAT_PCIEEAI_NONE            0x00000000u
S  #define  CHIP_DEVSTAT_PCIEEAI_INIT            0x00000001u
S
S  #define _CHIP_DEVSTAT_PCIEN_MASK           0x00000100u
S  #define _CHIP_DEVSTAT_PCIEN_SHIFT          0x00000008u
S  #define  CHIP_DEVSTAT_PCIEN_DEFAULT        0x00000000u
S  #define  CHIP_DEVSTAT_PCIEN_OF(x)          _VALUEOF(x)
S  #define  CHIP_DEVSTAT_PCIEN_DISABLE        0x00000000u
S  #define  CHIP_DEVSTAT_PCIEN_ENABLE         0x00000001u
S #endif
S
S  #define _CHIP_DEVSTAT_CLKMODE_MASK         0x00000060u
S  #define _CHIP_DEVSTAT_CLKMODE_SHIFT        0x00000005u
S  #define  CHIP_DEVSTAT_CLKMODE_DEFAULT      0x00000001u
S  #define  CHIP_DEVSTAT_CLKMODE_OF(x)        _VALUEOF(x)
S  #define  CHIP_DEVSTAT_CLKMODE_X1           0x00000000u
S  #define  CHIP_DEVSTAT_CLKMODE_X6           0x00000001u
S  #define  CHIP_DEVSTAT_CLKMODE_X12          0x00000002u
S  #define  CHIP_DEVSTAT_CLKMODE_X20          0x00000003u
S
S  #define _CHIP_DEVSTAT_LENDIAN_MASK         0x00000010u
S  #define _CHIP_DEVSTAT_LENDIAN_SHIFT        0x00000004u
S  #define  CHIP_DEVSTAT_LENDIAN_DEFAULT      0x00000001u
S  #define  CHIP_DEVSTAT_LENDIAN_OF(x)        _VALUEOF(x)
S  #define  CHIP_DEVSTAT_LENDIAN_BIG          0x00000000u
S  #define  CHIP_DEVSTAT_LENDIAN_LITTLE       0x00000001u
S
S  #define _CHIP_DEVSTAT_BOOTMODE_MASK         0x0000000Cu
S  #define _CHIP_DEVSTAT_BOOTMODE_SHIFT        0x00000002u
S  #define  CHIP_DEVSTAT_BOOTMODE_DEFAULT      0x00000000u
S  #define  CHIP_DEVSTAT_BOOTMODE_OF(x)         _VALUEOF(x)
S  #define  CHIP_DEVSTAT_BOOTMODE_NONE         0x00000000u
S  #define  CHIP_DEVSTAT_BOOTMODE_HPIPCI       0x00000001u
S  #define  CHIP_DEVSTAT_BOOTMODE_EMIFA        0x00000003u
S
S  #define _CHIP_DEVSTAT_AECLKINSEL_MASK         0x00000003u
S  #define _CHIP_DEVSTAT_AECLKINSEL_SHIFT        0x00000000u
S  #define  CHIP_DEVSTAT_AECLKINSEL_DEFAULT      0x00000000u
S  #define  CHIP_DEVSTAT_AECLKINSEL_OF(x)         _VALUEOF(x)
S  #define  CHIP_DEVSTAT_AECLKINSEL_ECLKIN       0x00000000u
S  #define  CHIP_DEVSTAT_AECLKINSEL_CLKOUT4      0x00000001u
S  #define  CHIP_DEVSTAT_AECLKINSEL_CLKOUT6      0x00000002u
S  #define  CHIP_DEVSTAT_OF(x)              _VALUEOF(x)
S
S  #define  CHIP_DEVSTAT_OF(x)              _VALUEOF(x)
S
S  /* Read only Register */
S
S  #define _CHIP_DEVSTAT_FGET(FIELD)\
S    _PER_FGET(_CHIP_DEVSTAT_ADDR,CHIP,DEVSTAT,##FIELD)
X  #define _CHIP_DEVSTAT_FGET(FIELD)    _PER_FGET(_CHIP_DEVSTAT_ADDR,CHIP,DEVSTAT,##FIELD)
S
S
N#endif /* CHIP_DM642 | CHIP_6412  */
N
N#if (CHIP_6410 || CHIP_6413 || CHIP_6418)
X#if (0 || 0 || 0)
S
S  #define   _CHIP_DEVSTAT_ADDR                 0x01B3F004u
S  #define   _CHIP_DEVSTAT_OFFSET               0
S
S  #define _CHIP_DEVSTAT_PLLM_MASK              0x00F10000u
S  #define _CHIP_DEVSTAT_PLLM_SHIFT             0x00000013u
S  #define  CHIP_DEVSTAT_PLLM_DEFAULT           0x00000000u
S  #define  CHIP_DEVSTAT_PLLM_OF(x)             _VALUEOF(x)
S  #define  CHIP_DEVSTAT_PLLM_BYPASS            0x00000000u
S  #define  CHIP_DEVSTAT_PLLM_5                 0x00000001u
S  #define  CHIP_DEVSTAT_PLLM_6                 0x00000002u
S  #define  CHIP_DEVSTAT_PLLM_7                 0x00000003u
S  #define  CHIP_DEVSTAT_PLLM_8                 0x00000004u
S  #define  CHIP_DEVSTAT_PLLM_9                 0x00000005u
S  #define  CHIP_DEVSTAT_PLLM_10                0x00000006u
S  #define  CHIP_DEVSTAT_PLLM_11                0x00000007u
S  #define  CHIP_DEVSTAT_PLLM_12                0x00000008u
S  #define  CHIP_DEVSTAT_PLLM_16                0x00000009u
S  #define  CHIP_DEVSTAT_PLLM_18                0x0000000Au
S  #define  CHIP_DEVSTAT_PLLM_19                0x0000000Bu
S  #define  CHIP_DEVSTAT_PLLM_20                0x0000000Cu
S  #define  CHIP_DEVSTAT_PLLM_21                0x0000000Du
S  #define  CHIP_DEVSTAT_PLLM_22                0x0000000Eu
S  #define  CHIP_DEVSTAT_PLLM_24                0x0000000Fu
S 
S  #define _CHIP_DEVSTAT_OSCEXTRES_MASK         0x00020000u
S  #define _CHIP_DEVSTAT_OSCEXTRES_SHIFT        0x00000011u
S  #define  CHIP_DEVSTAT_OSCEXTRES_DEFAUL       0x00000001u
S  #define  CHIP_DEVSTAT_OSCEXTRES_OF(x)        _VALUEOF(x)
S  #define  CHIP_DEVSTAT_OSCEXTRES_DISABL       0x00000000u
S  #define  CHIP_DEVSTAT_OSCEXTRES_ENABLE       0x00000001u
S 
S  #define _CHIP_DEVSTAT_CLKINSEL_MASK          0x00010000u
S  #define _CHIP_DEVSTAT_CLKINSEL_SHIFT         0x00000010u
S  #define  CHIP_DEVSTAT_CLKINSEL_DEFAULT       0x00000000u
S  #define  CHIP_DEVSTAT_CLKINSEL_OF(x)         _VALUEOF(x)
S  #define  CHIP_DEVSTAT_CLKINSEL_DISABLE       0x00000000u
S  #define  CHIP_DEVSTAT_CLKINSEL_ENABLE        0x00000001u
S 
S  #define _CHIP_DEVSTAT_HPIWIDTH_MASK          0x00000400u
S  #define _CHIP_DEVSTAT_HPIWIDTH_SHIFT         0x0000000Au
S  #define  CHIP_DEVSTAT_HPIWIDTH_DEFAUL        0x00000000u
S  #define  CHIP_DEVSTAT_HPIWIDTH_OF(x)         _VALUEOF(x)
S  #define  CHIP_DEVSTAT_HPIWIDTH_16            0x00000000u
S  #define  CHIP_DEVSTAT_HPIWIDTH_32            0x00000001u
S 
S  #define _CHIP_DEVSTAT_HPIENZ_MASK            0x00000100u
S  #define _CHIP_DEVSTAT_HPIENZ_SHIFT           0x00000008u
S  #define  CHIP_DEVSTAT_HPIENZ_DEFAULT         0x00000000u
S  #define  CHIP_DEVSTAT_HPIENZ_OF(x)           _VALUEOF(x)
S  #define  CHIP_DEVSTAT_HPIENZ_ENABLE          0x00000000u
S  #define  CHIP_DEVSTAT_HPIENZ_DISABLE         0x00000001u
S 
S  #define _CHIP_DEVSTAT_CLKMODE_MASK          0x000010E0u
S  #define _CHIP_DEVSTAT_CLKMODE_SHIFT         0x00000005u
S  #define  CHIP_DEVSTAT_CLKMODE_DEFAULT       0x00000001u
S  #define  CHIP_DEVSTAT_CLKMODE_OF(x)         _VALUEOF(x)
S  #define  CHIP_DEVSTAT_CLKMODE_0             0x00000000u
S  #define  CHIP_DEVSTAT_CLKMODE_1             0x00000001u
S  #define  CHIP_DEVSTAT_CLKMODE_2             0x00000002u
S  #define  CHIP_DEVSTAT_CLKMODE_3             0x00000003u
S  #define  CHIP_DEVSTAT_CLKMODE_4             0x00000004u
S  #define  CHIP_DEVSTAT_CLKMODE_5             0x00000005u
S  #define  CHIP_DEVSTAT_CLKMODE_6             0x00000006u
S  #define  CHIP_DEVSTAT_CLKMODE_7             0x00000007u
S  #define  CHIP_DEVSTAT_CLKMODE_8             0x00000080u
S  #define  CHIP_DEVSTAT_CLKMODE_9             0x00000081u
S  #define  CHIP_DEVSTAT_CLKMODE_10            0x00000082u
S  #define  CHIP_DEVSTAT_CLKMODE_11            0x00000083u
S  #define  CHIP_DEVSTAT_CLKMODE_12            0x00000084u
S  #define  CHIP_DEVSTAT_CLKMODE_13            0x00000085u
S  #define  CHIP_DEVSTAT_CLKMODE_14            0x00000086u
S  #define  CHIP_DEVSTAT_CLKMODE_15            0x00000087u
S 
S  #define _CHIP_DEVSTAT_LENDIAN_MASK           0x00000010u
S  #define _CHIP_DEVSTAT_LENDIAN_SHIFT          0x00000004u
S  #define  CHIP_DEVSTAT_LENDIAN_DEFAULT        0x00000001u
S  #define  CHIP_DEVSTAT_LENDIAN_OF(x)          _VALUEOF(x)
S  #define  CHIP_DEVSTAT_LENDIAN_BIG            0x00000000u 
S  #define  CHIP_DEVSTAT_LENDIAN_LITTLE         0x00000001u
S 
S  #define _CHIP_DEVSTAT_BOOTMODE_MASK          0x0000000Cu
S  #define _CHIP_DEVSTAT_BOOTMODE_SHIFT         0x00000002u
S  #define  CHIP_DEVSTAT_BOOTMODE_DEFAULT       0x00000000u
S  #define  CHIP_DEVSTAT_BOOTMODE_OF(x)          _VALUEOF(x)
S  #define  CHIP_DEVSTAT_BOOTMODE_NONE          0x00000000u
S  #define  CHIP_DEVSTAT_BOOTMODE_HPI           0x00000001u
S  #define  CHIP_DEVSTAT_BOOTMODE_EMIFA         0x00000003u
S
S  #define _CHIP_DEVSTAT_AECLKINSEL_MASK        0x00000003u
S  #define _CHIP_DEVSTAT_AECLKINSEL_SHIFT       0x00000000u
S  #define  CHIP_DEVSTAT_AECLKINSEL_DEFAULT     0x00000000u
S  #define  CHIP_DEVSTAT_AECLKINSEL_OF(x)       _VALUEOF(x)
S  #define  CHIP_DEVSTAT_AECLKINSEL_ECLKIN      0x00000000u
S  #define  CHIP_DEVSTAT_AECLKINSEL_CLKOUT4     0x00000001u
S  #define  CHIP_DEVSTAT_AECLKINSEL_CLKOUT6     0x00000002u
S
S  #define  CHIP_DEVSTAT_OF(x)              _VALUEOF(x)
S
S  /* Read only Register */
S
S  #define _CHIP_DEVSTAT_FGET(FIELD)\
S    _PER_FGET(_CHIP_DEVSTAT_ADDR,CHIP,DEVSTAT,##FIELD)
X  #define _CHIP_DEVSTAT_FGET(FIELD)    _PER_FGET(_CHIP_DEVSTAT_ADDR,CHIP,DEVSTAT,##FIELD)
S
S
N#endif /* CHIP_6410 || CHIP_6413 || CHIP_6418 */
N
N/******************************************************************************\
N* _____________________
X
N* |                   |
N* |  J T A G I D      |
N* |___________________|
N*
N* JTAGID - JTAG ID register (1)
N*
N* FIELDS (msb -> lsb)
N* (r) VARIANT
N* (r) PART
N* (r) MANNUFACTURE
N* (r) LSB
N*
N* (1) Only for DM642
N*
N\******************************************************************************/
N
N
N#if (CHIP_DM642 || CHIP_DM641 || CHIP_DM640 || CHIP_6412 )
X#if (0 || 0 || 0 || 0 )
S
S  #define   _CHIP_JTAGID_ADDR                0x01B3F008u
S  #define   _CHIP_JTAGID_OFFSET              0
S
S  #define _CHIP_JTAGID_VARIANT_MASK          0xF0000000u
S  #define _CHIP_JTAGID_VARIANT_SHIFT         0x0000001Cu
S  #define  CHIP_JTAGID_VARIANT_DEFAULT       0x00000000u
S  #define  CHIP_JTAGID_VARIANT_OF(x)         _VALUEOF(x)
S
S  #define _CHIP_JTAGID_PART_MASK             0x0FFFF000u
S  #define _CHIP_JTAGID_PART_SHIFT            0x0000000Cu
S  #define  CHIP_JTAGID_PART_DEFAULT          0x00000079u
S  #define  CHIP_JTAGID_PART_OF(x)            _VALUEOF(x)
S
S  #define _CHIP_JTAGID_MANUFACTURE_MASK      0x00000FFEu
S  #define _CHIP_JTAGID_MANUFACTURE_SHIFT     0x00000001u
S  #define  CHIP_JTAGID_MANUFACTURE_DEFAULT   0x00000017u
S  #define  CHIP_JTAGID_MANUFACTURE_OF(x)     _VALUEOF(x)
S
S  #define _CHIP_JTAGID_LSB_MASK              0x00000001u
S  #define _CHIP_JTAGID_LSB_SHIFT             0x00000000u
S  #define  CHIP_JTAGID_LSB_DEFAULT           0x00000001u
S  #define  CHIP_JTAGID_LSB_OF(x)             _VALUEOF(x)
S
S  #define  CHIP_JTAGID_OF(x)              _VALUEOF(x)
S
S  #define _CHIP_JTAGID_FGET(FIELD)\
S    _PER_FGET(_CHIP_JTAGID_ADDR,CHIP,JTAGID,##FIELD)
X  #define _CHIP_JTAGID_FGET(FIELD)    _PER_FGET(_CHIP_JTAGID_ADDR,CHIP,JTAGID,##FIELD)
S
N#endif /* CHIP_DM642 || CHIP_6412  */
N
N/******************************************************************************\
N* _____________________
X
N* |                   |
N* |  P C F G L O C K  |
N* |___________________|
N*
N* PCFGLOCK - Peripheral Configuration Lock register (1)
N*
N* FIELDS (msb -> lsb)
N* (r) LOCKSTAT
N* (w) LOCK
N*
N* (1) Only for DM642
N*
N\******************************************************************************/
N
N#if (CHIP_DM642 || CHIP_DM641 || CHIP_DM640 || CHIP_6412 || CHIP_6410 || CHIP_6413 || CHIP_6418)
X#if (0 || 0 || 0 || 0 || 0 || 0 || 0)
S
S  #define   _CHIP_PCFGLOCK_ADDR                 0x01B3F018u
S  #define   _CHIP_PCFGLOCK_OFFSET               0
S
S  #define _CHIP_PCFGLOCK_LOCKSTAT_MASK          0x00000001u
S  #define _CHIP_PCFGLOCK_LOCKSTAT_SHIFT         0x00000000u
S  #define  CHIP_PCFGLOCK_LOCKSTAT_DEFAULT       0x00000001u
S  #define  CHIP_PCFGLOCK_LOCKSTAT_OF(x)         _VALUEOF(x)
S  #define  CHIP_PCFGLOCK_LOCKSTAT_UNLOCK        0x00000000u
S  #define  CHIP_PCFGLOCK_LOCKSTAT_LOCK          0x00000001u
S
S  #define _CHIP_PCFGLOCK_LOCK_MASK              0xFFFFFFFFu
S  #define _CHIP_PCFGLOCK_LOCK_SHIFT             0x00000000u
S  #define  CHIP_PCFGLOCK_LOCK_DEFAULT           0x00000000u
S  #define  CHIP_PCFGLOCK_LOCK_OF(x)             _VALUEOF(x)
S  #define  CHIP_PCFGLOCK_LOCK_UNLOCK            0x10C0010Cu
S  #define  CHIP_PCFGLOCK_LOCK_DISABLE           0x10C0010Cu
S
S  #define  CHIP_PCFGLOCK_OF(x)                  _VALUEOF(x)
S
S  #define _CHIP_PCFGLOCK_FGET(FIELD)\
S    _PER_FGET(_CHIP_PCFGLOCK_ADDR,CHIP,PCFGLOCK,##FIELD)
X  #define _CHIP_PCFGLOCK_FGET(FIELD)    _PER_FGET(_CHIP_PCFGLOCK_ADDR,CHIP,PCFGLOCK,##FIELD)
S
S  #define _CHIP_PCFGLOCK_FSET(FIELD,field)\
S    _PER_FSET(_CHIP_PCFGLOCK_ADDR,CHIP,PCFGLOCK,##FIELD,field)
X  #define _CHIP_PCFGLOCK_FSET(FIELD,field)    _PER_FSET(_CHIP_PCFGLOCK_ADDR,CHIP,PCFGLOCK,##FIELD,field)
S
S  #define _CHIP_PCFGLOCK_FSETS(FIELD,SYM)\
S    _PER_FSETS(_CHIP_PCFGLOCK_ADDR,CHIP,PCFGLOCK,##FIELD,##SYM)
X  #define _CHIP_PCFGLOCK_FSETS(FIELD,SYM)    _PER_FSETS(_CHIP_PCFGLOCK_ADDR,CHIP,PCFGLOCK,##FIELD,##SYM)
S
S
N#endif /* CHIP_DM642 || CHIP_DM641 || CHIP_DM640 || CHIP_6412 || CHIP_6410 || CHIP_6413 || CHIP_6418*/
N
N#ifdef __cplusplus
S}
N#endif
N
N/*----------------------------------------------------------------------------*/
N#endif /* _CSL_CHIPHAL_H_ */
N/******************************************************************************\
N* End of csl_chiphal.h
X
N\******************************************************************************/
N
L 20 "E:/TI_workspase/c6701_t/csl/csl_chip.h" 2
N#include <csl_emifhal.h>
L 1 "E:/TI_workspase/c6701_t/csl/csl_emifhal.h" 1
N/******************************************************************************\
N*           Copyright (C) 1999-2000 Texas Instruments Incorporated.
X
N*                           All Rights Reserved
N*------------------------------------------------------------------------------
N* FILENAME...... csl_emifhal.h
N* DATE CREATED.. 06/12/1999 
N* LAST MODIFIED. 06/17/2003  Added CHIP_6712C
N*                05/28/2003  Added CHIP_6711C
N*                10/03/2000
N*------------------------------------------------------------------------------
N* REGISTERS
N*
N* GBLCTL  - global control register
N* CECTL0  - CE space control register 0
N* CECTL1  - CE space control register 1
N* CECTL2  - CE space control register 2
N* CECTL3  - CE space control register 3
N* SDCTL   - SDRAM control regsiter
N* SDTIM   - SDRAM timing register
N* SDEXT   - SDRAM extension register (1)
N*
N* (1) - only supported on 6211,6711,6712,6713,6711C,6712C
N* 
N\******************************************************************************/
N#ifndef _CSL_EMIFHAL_H_
N#define _CSL_EMIFHAL_H_
N
N#include <csl_stdinc.h>
N#include <csl_chip.h>
L 1 "E:/TI_workspase/c6701_t/csl/csl_chip.h" 1
N/******************************************************************************\
N*           Copyright (C) 1999-2001 Texas Instruments Incorporated.
X
N*                           All Rights Reserved
N*------------------------------------------------------------------------------
N* FILENAME...... csl_chip.h
N* DATE CREATED.. 08/19/1999 
N* LAST MODIFIED. 08/02/2004 - Adding support for C6418
N*                06/17/2003   - Added support for 6712C
N*                06/09/2003   - Added support for 6711C
N*                12/03/2001   - CHIP_configArgs
N*                11/08/2001   - CHIP_getSiliconRevId()
N*                             - CHIP_config() / CHIP_getConfig  DM642
N\******************************************************************************/
N#ifndef _CSL_CHIP_H_
S#define _CSL_CHIP_H_
S
S#include <csl_stdinc.h>
S
S#include <csl_chiphal.h>
S#include <csl_emifhal.h>
S
S/******************************************************************************\
S* scope and inline control macros
X
S\******************************************************************************/
S#ifdef __cplusplus
S#define CSLAPI extern "C" far
S#else
S#define CSLAPI extern far
S#endif
S
S#undef  USEDEFS
S#undef  IDECL
S#undef  IDEF
S
S#ifdef  _CHIP_MOD_
S  #define IDECL CSLAPI
S  #define USEDEFS
S  #define IDEF
S#else
S  #ifdef  _INLINE
S    #define IDECL static inline
S    #define USEDEFS
S    #define IDEF  static inline
S  #else
S    #define IDECL CSLAPI
S  #endif
S#endif
S
S
S/******************************************************************************\
S* global macro declarations
X
S\******************************************************************************/
S#define CHIP_ENDIAN_BIG    0
S#define CHIP_ENDIAN_LITTLE 1
S
S#define CHIP_MAP_0         0
S#define CHIP_MAP_1         1
S
S/* Selected devices masks*/
S#if (CHIP_6713 || CHIP_DA610 || CHIP_6711C || CHIP_6712C)
S#define CHIP_EKSRC_SYSCLK3  0x00000000u
S#define CHIP_EKSRC_ECLKIN   0x00000010u
S#endif
S
S#if (CHIP_6713 || CHIP_DA610)
S#define CHIP_TOUT1          0x00000000u
S#define CHIP_AXR04_AXR111   0x00000008u
S
S#define CHIP_TOUT0          0x00000000u
S#define CHIP_AXR02_AXR113   0x00000004u
S
S#define CHIP_MCASP0         0x00000002u
S#define CHIP_MCBSP0         0x00000000u
S
S#define CHIP_I2C1           0x00000001u
S#define CHIP_MCBSP1         0x00000000u
S/* Full mask value */
S#define _CHIP_DEVCFG_MASK  0x0000001Fu
S#endif
S
S#if CHIP_DM642
S#define CHIP_VP2            0x00000040u
S#define CHIP_VP1            0x00000020u
S#define CHIP_VP0            0x00000010u
S#define CHIP_I2C            0x00000008u
S#define CHIP_MCBSP1         0x00000004u
S#define CHIP_MCBSP0         0x00000002u
S#define CHIP_MCASP0         0x00000001u
S
S#define _CHIP_PERCFG_MASK   0x0000007Fu
S#endif
S
S#if CHIP_DM641
S#define CHIP_VP1            0x00000020u
S#define CHIP_VP0            0x00000010u
S#define CHIP_I2C            0x00000008u
S#define CHIP_MCBSP1         0x00000004u
S#define CHIP_MCBSP0         0x00000002u
S#define CHIP_MCASP0         0x00000001u
S
S#define _CHIP_PERCFG_MASK   0x0000003Fu
S#endif
S
S#if CHIP_DM640
S#define CHIP_VP0            0x00000010u
S#define CHIP_I2C            0x00000008u
S#define CHIP_MCBSP1         0x00000004u
S#define CHIP_MCBSP0         0x00000002u
S#define CHIP_MCASP0         0x00000001u
S
S#define _CHIP_PERCFG_MASK   0x0000001Fu
S#endif
S
S#if CHIP_6412
S#define CHIP_I2C            0x00000008u
S#define CHIP_MCBSP1         0x00000004u
S#define CHIP_MCBSP0         0x00000002u
S#define _CHIP_PERCFG_MASK   0x0000000Eu
S#endif
S
S#if (CHIP_6410 || CHIP_6413 || CHIP_6418)
S#define CHIP_AFCMUX         0x00000600u
S#define CHIP_MCASP1         0x00000100u
S#define CHIP_I2C1           0x00000080u
S#define CHIP_I2C0           0x00000008u
S#define CHIP_MCBSP1         0x00000004u
S#define CHIP_MCBSP0         0x00000002u
S#define CHIP_MCASP0         0x00000001u
S
S#define _CHIP_PERCFG_MASK   0x0000078Fu
S#endif
S
S/******************************************************************************\
S* global typedef declarations
X
S\******************************************************************************/
S#if( CHIP_6711C || CHIP_6712C || CHIP_DA610 || CHIP_6713 )
Stypedef struct{
S   Uint32 devcfg;
S} CHIP_Config;
S#elif (CHIP_DM642 || CHIP_DM641 || CHIP_DM640  || CHIP_6412 || CHIP_6410 || CHIP_6413 || CHIP_6418)
Stypedef struct{
S   Uint32 percfg;
S} CHIP_Config; 
S#endif
S/******************************************************************************\
S* global variable declarations
X
S\******************************************************************************/
S
S
S/******************************************************************************\
S* global function declarations
X
S\******************************************************************************/
S
S
S/******************************************************************************\
S* inline function declarations
X
S\******************************************************************************/
SIDECL Uint32 CHIP_getCpuId();
SIDECL Uint32 CHIP_getRevId();
SIDECL Uint32 CHIP_getSiliconRevId();
SIDECL int    CHIP_getEndian();
SIDECL int    CHIP_getMapMode();
S
S#if (CHIP_DM642 || CHIP_DM641 || CHIP_DM640  || CHIP_6412 || CHIP_6410 || CHIP_6413 || CHIP_6418) 
SIDECL void   CHIP_config(CHIP_Config *config);
SIDECL void   CHIP_configArgs(Uint32 percfg);
SIDECL void   CHIP_getConfig(CHIP_Config *config); 
S#elif ( CHIP_6711C || CHIP_6712C || CHIP_DA610 || CHIP_6713 )
SIDECL void   CHIP_config(CHIP_Config *config);
SIDECL void   CHIP_configArgs(Uint32 devcfg);
SIDECL void   CHIP_getConfig(CHIP_Config *config); 
S#endif
S
S/******************************************************************************\
S* inline function definitions
X
S\******************************************************************************/
S#ifdef USEDEFS
S/*----------------------------------------------------------------------------*/
SIDEF Uint32 CHIP_getCpuId() {
S  return CHIP_FGET(CSR,CPUID);
S}
S/*----------------------------------------------------------------------------*/
SIDEF Uint32 CHIP_getRevId() {
S  return CHIP_FGET(CSR,REVID);
S}
S/*----------------------------------------------------------------------------*/
SIDEF Uint32 CHIP_getSiliconRevId() {
S  return (( 0x000F0000 & REG32(0x01B00200))>>16);
S}
S/*----------------------------------------------------------------------------*/
SIDEF int CHIP_getEndian() {
S  return CHIP_FGET(CSR,EN);
S}
S/*----------------------------------------------------------------------------*/
SIDEF int CHIP_getMapMode() {
S  int mapmode = 0;
S  #if (!C11_SUPPORT && !C64_SUPPORT)
S    mapmode = EMIF_FGET(GBLCTL,MAP);
S  #endif
S  return mapmode;
S}
S/*----------------------------------------------------------------------------*/
S#if (CHIP_6713 || CHIP_DM642 || CHIP_DM641 || CHIP_DM640 || CHIP_DA610 || CHIP_6412 || CHIP_6711C || CHIP_6712C || CHIP_6410 || CHIP_6413 || CHIP_6418)
SIDEF void   CHIP_config(CHIP_Config *config) {
S  Uint32 gie = CHIP_FGET(CSR,GIE);
S  
S#if( CHIP_6711C || CHIP_6712C || CHIP_DA610 || CHIP_6713 ) 
S    volatile Uint32 *base = (volatile Uint32 *)(_CHIP_DEVCFG_ADDR);
S    register int x0;
S    CHIP_FSET(CSR,GIE,0);
S    x0 = config->devcfg;
S    base[_CHIP_DEVCFG_OFFSET] = x0;
S    CHIP_FSET(CSR,GIE,gie);
S    
S#else 
S  volatile Uint32 *base = (volatile Uint32 *)(_CHIP_PERCFG_ADDR);
S  register int x0;
S  CHIP_FSET(CSR,GIE,0);
S  CHIP_FSETS(PCFGLOCK,LOCK,UNLOCK);
S  x0 = config->percfg;
S  base[_CHIP_PERCFG_OFFSET] = x0;
S  CHIP_FSET(CSR,GIE,gie);
S  
S#endif
S}      
S#endif
S/*----------------------------------------------------------------------------*/
S#if (CHIP_6713 || CHIP_DM642 || CHIP_DM641 || CHIP_DM640 || CHIP_DA610 || CHIP_6412 || CHIP_6711C || CHIP_6712C || CHIP_6410 || CHIP_6413 || CHIP_6418)
SIDEF void   CHIP_getConfig(CHIP_Config *config) {
S   Uint32 gie = CHIP_FGET(CSR,GIE);
S   
S#if( CHIP_6711C || CHIP_6712C || CHIP_DA610 || CHIP_6713 ) 
S   volatile Uint32 *base = (volatile Uint32 *)(_CHIP_DEVCFG_ADDR);
S   register int x0;
S
S   CHIP_FSET(CSR,GIE,0);
S
S   x0 = base[_CHIP_DEVCFG_OFFSET]; 
S   config->devcfg=x0;
S
S   CHIP_FSET(CSR,GIE,gie);
S   
S#else
S   volatile Uint32 *base = (volatile Uint32 *)(_CHIP_PERCFG_ADDR);
S   register int x0;
S
S   CHIP_FSET(CSR,GIE,0);
S
S   x0 = base[_CHIP_PERCFG_OFFSET]; 
S   config->percfg=x0;
S
S   CHIP_FSET(CSR,GIE,gie);
S   
S#endif
S}      
S#endif
S/*----------------------------------------------------------------------------*/
S   
S#if( CHIP_6711C || CHIP_6712C || CHIP_DA610 || CHIP_6713 )
S   IDEF void   CHIP_configArgs(Uint32 devcfg) {
S   Uint32 gie = CHIP_FGET(CSR,GIE);
S   volatile Uint32 *base = (volatile Uint32 *)(_CHIP_DEVCFG_ADDR);
S   CHIP_FSET(CSR,GIE,0);
S   base[_CHIP_DEVCFG_OFFSET]= devcfg; 
S   CHIP_FSET(CSR,GIE,gie);
S}   
S#elif (CHIP_DM642 || CHIP_DM641 || CHIP_DM640  || CHIP_6412 || CHIP_6410 || CHIP_6413 || CHIP_6418)
S   IDEF void   CHIP_configArgs(Uint32 percfg) {
S   Uint32 gie = CHIP_FGET(CSR,GIE);
S   volatile Uint32 *base = (volatile Uint32 *)(_CHIP_PERCFG_ADDR);
S
S   CHIP_FSET(CSR,GIE,0);
S
S#if(CHIP_DM642 || CHIP_6412)
S   CHIP_FSETS(PCFGLOCK,LOCK,UNLOCK);
S#endif
S
S   base[_CHIP_PERCFG_OFFSET]= percfg; 
S
S   CHIP_FSET(CSR,GIE,gie);
S}   
S#endif
S
S
S/*----------------------------------------------------------------------------*/
S#endif /* USEDEFS */
S
S
N#endif /* _CSL_CHIP_H_ */
N/******************************************************************************\
N* End of csl_chip.h
X
N\******************************************************************************/
N
L 30 "E:/TI_workspase/c6701_t/csl/csl_emifhal.h" 2
N
N#if (EMIF_SUPPORT)
X#if (( ( 1*0) | ( 1*0) | ( 1*0) | ( 1*0) | ( 1*0) | ( 1*0) | ( 1*1) | ( 1*0) | ( 1*0) | ( 1*0) | ( 1*0)| ( 0*0)| ( 0*0)| ( 0*0)| ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 1*0) | ( 1*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) ))
N/******************************************************************************\
N* MISC section
X
N\******************************************************************************/
N#define _EMIF_BASE_GLOBAL   0x01800000u
N
N
N/******************************************************************************\
N* module level register/field access macros
X
N\******************************************************************************/
N
N  /* ----------------- */
N  /* FIELD MAKE MACROS */
N  /* ----------------- */
N
N  #define EMIF_FMK(REG,FIELD,x)\
N    _PER_FMK(EMIF,##REG,##FIELD,x)
X  #define EMIF_FMK(REG,FIELD,x)    _PER_FMK(EMIF,##REG,##FIELD,x)
N
N  #define EMIF_FMKS(REG,FIELD,SYM)\
N    _PER_FMKS(EMIF,##REG,##FIELD,##SYM)
X  #define EMIF_FMKS(REG,FIELD,SYM)    _PER_FMKS(EMIF,##REG,##FIELD,##SYM)
N 
N 
N  /* -------------------------------- */
N  /* RAW REGISTER/FIELD ACCESS MACROS */
N  /* -------------------------------- */
N
N  #define EMIF_ADDR(REG)\
N    _EMIF_##REG##_ADDR
X  #define EMIF_ADDR(REG)    _EMIF_##REG##_ADDR
N
N  #define EMIF_RGET(REG)\
N    _PER_RGET(_EMIF_##REG##_ADDR,EMIF,##REG)
X  #define EMIF_RGET(REG)    _PER_RGET(_EMIF_##REG##_ADDR,EMIF,##REG)
N
N  #define EMIF_RSET(REG,x)\
N    _PER_RSET(_EMIF_##REG##_ADDR,EMIF,##REG,x)
X  #define EMIF_RSET(REG,x)    _PER_RSET(_EMIF_##REG##_ADDR,EMIF,##REG,x)
N
N  #define EMIF_FGET(REG,FIELD)\
N    _EMIF_##REG##_FGET(##FIELD)
X  #define EMIF_FGET(REG,FIELD)    _EMIF_##REG##_FGET(##FIELD)
N
N  #define EMIF_FSET(REG,FIELD,x)\
N    _EMIF_##REG##_FSET(##FIELD,##x)
X  #define EMIF_FSET(REG,FIELD,x)    _EMIF_##REG##_FSET(##FIELD,##x)
N
N  #define EMIF_FSETS(REG,FIELD,SYM)\
N    _EMIF_##REG##_FSETS(##FIELD,##SYM)
X  #define EMIF_FSETS(REG,FIELD,SYM)    _EMIF_##REG##_FSETS(##FIELD,##SYM)
N 
N 
N  /* ------------------------------------------ */
N  /* ADDRESS BASED REGISTER/FIELD ACCESS MACROS */
N  /* ------------------------------------------ */
N
N  #define EMIF_RGETA(addr,REG)\
N    _PER_RGET(addr,EMIF,##REG)
X  #define EMIF_RGETA(addr,REG)    _PER_RGET(addr,EMIF,##REG)
N
N  #define EMIF_RSETA(addr,REG,x)\
N    _PER_RSET(addr,EMIF,##REG,x)
X  #define EMIF_RSETA(addr,REG,x)    _PER_RSET(addr,EMIF,##REG,x)
N
N  #define EMIF_FGETA(addr,REG,FIELD)\
N    _PER_FGET(addr,EMIF,##REG,##FIELD)
X  #define EMIF_FGETA(addr,REG,FIELD)    _PER_FGET(addr,EMIF,##REG,##FIELD)
N
N  #define EMIF_FSETA(addr,REG,FIELD,x)\
N    _PER_FSET(addr,EMIF,##REG,##FIELD,x)
X  #define EMIF_FSETA(addr,REG,FIELD,x)    _PER_FSET(addr,EMIF,##REG,##FIELD,x)
N
N  #define EMIF_FSETSA(addr,REG,FIELD,SYM)\
N    _PER_FSETS(addr,EMIF,##REG,##FIELD,##SYM)
X  #define EMIF_FSETSA(addr,REG,FIELD,SYM)    _PER_FSETS(addr,EMIF,##REG,##FIELD,##SYM)
N
N
N/******************************************************************************\
N* _____________________
X
N* |                   |
N* |  G B L C T L      |
N* |___________________|
N*
N* GBLCTL  - global control register
N*
N* FIELDS (msb -> lsb)
N* (r)  BUSREQ  (1)
N* (r)  ARDY
N* (r)  HOLD
N* (r)  HOLDA
N* (rw) NOHOLD
N* (rw) SDCEN   (2)
N* (rw) SSCEN   (2)
N* (rw) EKEN    (4)
N* (rw) CLK1EN
N* (rw) CLK2EN  (3)
N* (rw) SSCRT   (2)(3)
N* (rw) RBTR8   (2)
N* (r)  MAP     (2)
N*
N* (1) - Field only exists for C11_SUPPORT
N* (2) - Field does not exist for C11_SUPPORT
N* (3) - Field does not exist for 6202/6203/6204/6205 
N* (4) - Field only exixts for C6713, DA610, 6711C, 6712C
N*
N\******************************************************************************/
N  #define _EMIF_GBLCTL_OFFSET          0
N
N  #define _EMIF_GBLCTL_ADDR            0x01800000u
N
N#if (C11_SUPPORT)
X#if (( ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 1*0) | ( 0*1) | ( 1*0) | ( 1*0) | ( 1*0) | ( 1*0)| ( 0*0)| ( 0*0)| ( 0*0)| ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 1*0) | ( 1*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) ))
S  #define _EMIF_GBLCTL_BUSREQ_MASK     0x00000800u
S  #define _EMIF_GBLCTL_BUSREQ_SHIFT    0x0000000Bu
S  #define  EMIF_GBLCTL_BUSREQ_DEFAULT  0x00000000u
S  #define  EMIF_GBLCTL_BUSREQ_OF(x)    _VALUEOF(x)
S  #define  EMIF_GBLCTL_BUSREQ_LOW      0x00000000u
S  #define  EMIF_GBLCTL_BUSREQ_HIGH     0x00000001u
N#endif
N
N  #define _EMIF_GBLCTL_ARDY_MASK       0x00000400u
N  #define _EMIF_GBLCTL_ARDY_SHIFT      0x0000000Au
N  #define  EMIF_GBLCTL_ARDY_DEFAULT    0x00000000u
N  #define  EMIF_GBLCTL_ARDY_OF(x)      _VALUEOF(x)
N  #define  EMIF_GBLCTL_ARDY_LOW        0x00000000u
N  #define  EMIF_GBLCTL_ARDY_HIGH       0x00000001u
N
N  #define _EMIF_GBLCTL_HOLD_MASK       0x00000200u
N  #define _EMIF_GBLCTL_HOLD_SHIFT      0x00000009u
N  #define  EMIF_GBLCTL_HOLD_DEFAULT    0x00000000u
N  #define  EMIF_GBLCTL_HOLD_OF(x)      _VALUEOF(x)
N  #define  EMIF_GBLCTL_HOLD_LOW        0x00000000u
N  #define  EMIF_GBLCTL_HOLD_HIGH       0x00000001u
N
N  #define _EMIF_GBLCTL_HOLDA_MASK      0x00000100u
N  #define _EMIF_GBLCTL_HOLDA_SHIFT     0x00000008u
N  #define  EMIF_GBLCTL_HOLDA_DEFAULT   0x00000000u
N  #define  EMIF_GBLCTL_HOLDA_OF(x)     _VALUEOF(x)
N  #define  EMIF_GBLCTL_HOLDA_LOW       0x00000000u
N  #define  EMIF_GBLCTL_HOLDA_HIGH      0x00000001u
N
N  #define _EMIF_GBLCTL_NOHOLD_MASK     0x00000080u
N  #define _EMIF_GBLCTL_NOHOLD_SHIFT    0x00000007u
N  #define  EMIF_GBLCTL_NOHOLD_DEFAULT  0x00000000u
N  #define  EMIF_GBLCTL_NOHOLD_OF(x)    _VALUEOF(x)
N  #define  EMIF_GBLCTL_NOHOLD_DISABLE  0x00000000u
N  #define  EMIF_GBLCTL_NOHOLD_ENABLE   0x00000001u
N
N#if (CHIP_6201 | CHIP_6202 | CHIP_6203 | CHIP_6204 | CHIP_6205 | CHIP_6701)
X#if (0 | 0 | 0 | 0 | 0 | 1)
N  #define _EMIF_GBLCTL_SDCEN_MASK      0x00000040u
N  #define _EMIF_GBLCTL_SDCEN_SHIFT     0x00000006u
N  #define  EMIF_GBLCTL_SDCEN_DEFAULT   0x00000001u
N  #define  EMIF_GBLCTL_SDCEN_OF(x)     _VALUEOF(x)
N  #define  EMIF_GBLCTL_SDCEN_DISABLE   0x00000000u
N  #define  EMIF_GBLCTL_SDCEN_ENABLE    0x00000001u
N#endif
N
N#if (CHIP_6201 | CHIP_6202 | CHIP_6203 | CHIP_6204 | CHIP_6205 | CHIP_6701)
X#if (0 | 0 | 0 | 0 | 0 | 1)
N  #define _EMIF_GBLCTL_SSCEN_MASK      0x00000020u
N  #define _EMIF_GBLCTL_SSCEN_SHIFT     0x00000005u
N  #define  EMIF_GBLCTL_SSCEN_DEFAULT   0x00000001u
N  #define  EMIF_GBLCTL_SSCEN_OF(x)     _VALUEOF(x)
N  #define  EMIF_GBLCTL_SSCEN_DISABLE   0x00000000u
N  #define  EMIF_GBLCTL_SSCEN_ENABLE    0x00000001u
N#endif
N
N#if (CHIP_6713 || CHIP_DA610 || CHIP_6711C || CHIP_6712C)
X#if (0 || 0 || 0 || 0)
S  #define _EMIF_GBLCTL_EKEN_MASK       0x00000020u
S  #define _EMIF_GBLCTL_EKEN_SHIFT      0x00000005u
S  #define  EMIF_GBLCTL_EKEN_DEFAULT    0x00000001u
S  #define  EMIF_GBLCTL_EKEN_OF(x)      _VALUEOF(x)
S  #define  EMIF_GBLCTL_EKEN_DISABLE    0x00000000u
S  #define  EMIF_GBLCTL_EKEN_ENABLE     0x00000001u
N#endif
N
N  #define _EMIF_GBLCTL_CLK1EN_MASK     0x00000010u
N  #define _EMIF_GBLCTL_CLK1EN_SHIFT    0x00000004u
N
N#if (CHIP_6713 || CHIP_DA610)
X#if (0 || 0)
S  #define  EMIF_GBLCTL_CLK1EN_DEFAULT  0x00000000u
N#else
N  #define  EMIF_GBLCTL_CLK1EN_DEFAULT  0x00000001u
N#endif
N
N  #define  EMIF_GBLCTL_CLK1EN_OF(x)    _VALUEOF(x)
N  #define  EMIF_GBLCTL_CLK1EN_DISABLE  0x00000000u
N  #define  EMIF_GBLCTL_CLK1EN_ENABLE   0x00000001u
N
N#if (!(CHIP_6202|CHIP_6203|CHIP_6204|CHIP_6205))
X#if (!(0|0|0|0))
N  #define _EMIF_GBLCTL_CLK2EN_MASK     0x00000008u
N  #define _EMIF_GBLCTL_CLK2EN_SHIFT    0x00000003u
N  #define  EMIF_GBLCTL_CLK2EN_DEFAULT  0x00000001u
N  #define  EMIF_GBLCTL_CLK2EN_OF(x)    _VALUEOF(x)
N  #define  EMIF_GBLCTL_CLK2EN_DISABLE  0x00000000u
N  #define  EMIF_GBLCTL_CLK2EN_ENABLE   0x00000001u
N#endif
N
N#if (CHIP_6201|CHIP_6701)
X#if (0|1)
N  #define _EMIF_GBLCTL_SSCRT_MASK      0x00000004u
N  #define _EMIF_GBLCTL_SSCRT_SHIFT     0x00000002u
N  #define  EMIF_GBLCTL_SSCRT_DEFAULT   0x00000000u
N  #define  EMIF_GBLCTL_SSCRT_OF(x)     _VALUEOF(x)
N  #define  EMIF_GBLCTL_SSCRT_CPUOVR2   0x00000000u
N  #define  EMIF_GBLCTL_SSCRT_CPU       0x00000001u
N#endif
N
N#if (!C11_SUPPORT)
X#if (!( ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 1*0) | ( 0*1) | ( 1*0) | ( 1*0) | ( 1*0) | ( 1*0)| ( 0*0)| ( 0*0)| ( 0*0)| ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 1*0) | ( 1*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) ))
N  #define _EMIF_GBLCTL_RBTR8_MASK      0x00000002u
N  #define _EMIF_GBLCTL_RBTR8_SHIFT     0x00000001u
N  #define  EMIF_GBLCTL_RBTR8_DEFAULT   0x00000000u
N  #define  EMIF_GBLCTL_RBTR8_OF(x)     _VALUEOF(x)
N  #define  EMIF_GBLCTL_RBTR8_HPRI      0x00000000u
N  #define  EMIF_GBLCTL_RBTR8_8ACC      0x00000001u
N#endif
N
N#if (!C11_SUPPORT)
X#if (!( ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 1*0) | ( 0*1) | ( 1*0) | ( 1*0) | ( 1*0) | ( 1*0)| ( 0*0)| ( 0*0)| ( 0*0)| ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 1*0) | ( 1*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) ))
N  #define _EMIF_GBLCTL_MAP_MASK        0x00000001u
N  #define _EMIF_GBLCTL_MAP_SHIFT       0x00000000u
N  #define  EMIF_GBLCTL_MAP_MAP1        0x00000000u
N  #define  EMIF_GBLCTL_MAP_MAP0        0x00000001u
N  #define  EMIF_GBLCTL_MAP_DEFAULT     0x00000000u
N  #define  EMIF_GBLCTL_MAP_OF(x)       _VALUEOF(x)
N#endif
N
N  #define  EMIF_GBLCTL_OF(x)           _VALUEOF(x)
N
N#if (CHIP_6201|CHIP_6701)
X#if (0|1)
N  #define EMIF_GBLCTL_DEFAULT (Uint32)( \
N    0x00003000\
N    |_PER_FDEFAULT(EMIF,GBLCTL,ARDY)\
N    |_PER_FDEFAULT(EMIF,GBLCTL,HOLD)\
N    |_PER_FDEFAULT(EMIF,GBLCTL,HOLDA)\
N    |_PER_FDEFAULT(EMIF,GBLCTL,NOHOLD)\
N    |_PER_FDEFAULT(EMIF,GBLCTL,SDCEN)\
N    |_PER_FDEFAULT(EMIF,GBLCTL,SSCEN)\
N    |_PER_FDEFAULT(EMIF,GBLCTL,CLK1EN)\
N    |_PER_FDEFAULT(EMIF,GBLCTL,CLK2EN)\
N    |_PER_FDEFAULT(EMIF,GBLCTL,SSCRT)\
N    |_PER_FDEFAULT(EMIF,GBLCTL,RBTR8)\
N    |_PER_FDEFAULT(EMIF,GBLCTL,MAP)\
N  )
X  #define EMIF_GBLCTL_DEFAULT (Uint32)(     0x00003000    |_PER_FDEFAULT(EMIF,GBLCTL,ARDY)    |_PER_FDEFAULT(EMIF,GBLCTL,HOLD)    |_PER_FDEFAULT(EMIF,GBLCTL,HOLDA)    |_PER_FDEFAULT(EMIF,GBLCTL,NOHOLD)    |_PER_FDEFAULT(EMIF,GBLCTL,SDCEN)    |_PER_FDEFAULT(EMIF,GBLCTL,SSCEN)    |_PER_FDEFAULT(EMIF,GBLCTL,CLK1EN)    |_PER_FDEFAULT(EMIF,GBLCTL,CLK2EN)    |_PER_FDEFAULT(EMIF,GBLCTL,SSCRT)    |_PER_FDEFAULT(EMIF,GBLCTL,RBTR8)    |_PER_FDEFAULT(EMIF,GBLCTL,MAP)  )
N
N  #define EMIF_GBLCTL_RMK(nohold,sdcen,sscen,clk1en,clk2en,sscrt,rbtr8) \
N    (Uint32)( \
N     _PER_FMK(EMIF,GBLCTL,NOHOLD,nohold)\
N    |_PER_FMK(EMIF,GBLCTL,SDCEN,sdcen)\
N    |_PER_FMK(EMIF,GBLCTL,SSCEN,sscen)\
N    |_PER_FMK(EMIF,GBLCTL,CLK1EN,clk1en)\
N    |_PER_FMK(EMIF,GBLCTL,CLK2EN,clk2en)\
N    |_PER_FMK(EMIF,GBLCTL,SSCRT,sscrt)\
N    |_PER_FMK(EMIF,GBLCTL,RBTR8,rbtr8)\
N  )
X  #define EMIF_GBLCTL_RMK(nohold,sdcen,sscen,clk1en,clk2en,sscrt,rbtr8)     (Uint32)(      _PER_FMK(EMIF,GBLCTL,NOHOLD,nohold)    |_PER_FMK(EMIF,GBLCTL,SDCEN,sdcen)    |_PER_FMK(EMIF,GBLCTL,SSCEN,sscen)    |_PER_FMK(EMIF,GBLCTL,CLK1EN,clk1en)    |_PER_FMK(EMIF,GBLCTL,CLK2EN,clk2en)    |_PER_FMK(EMIF,GBLCTL,SSCRT,sscrt)    |_PER_FMK(EMIF,GBLCTL,RBTR8,rbtr8)  )
N#endif
N
N#if (CHIP_6211|CHIP_6711)
X#if (0|0)
S  #define EMIF_GBLCTL_DEFAULT (Uint32)( \
S    0x00003000\
S    |_PER_FDEFAULT(EMIF,GBLCTL,BUSREQ)\
S    |_PER_FDEFAULT(EMIF,GBLCTL,ARDY)\
S    |_PER_FDEFAULT(EMIF,GBLCTL,HOLD)\
S    |_PER_FDEFAULT(EMIF,GBLCTL,HOLDA)\
S    |_PER_FDEFAULT(EMIF,GBLCTL,NOHOLD)\
S    |_PER_FDEFAULT(EMIF,GBLCTL,CLK1EN)\
S    |_PER_FDEFAULT(EMIF,GBLCTL,CLK2EN)\
S  )
X  #define EMIF_GBLCTL_DEFAULT (Uint32)(     0x00003000    |_PER_FDEFAULT(EMIF,GBLCTL,BUSREQ)    |_PER_FDEFAULT(EMIF,GBLCTL,ARDY)    |_PER_FDEFAULT(EMIF,GBLCTL,HOLD)    |_PER_FDEFAULT(EMIF,GBLCTL,HOLDA)    |_PER_FDEFAULT(EMIF,GBLCTL,NOHOLD)    |_PER_FDEFAULT(EMIF,GBLCTL,CLK1EN)    |_PER_FDEFAULT(EMIF,GBLCTL,CLK2EN)  )
S
S  #define EMIF_GBLCTL_RMK(nohold,clk1en,clk2en) (Uint32)( \
S     _PER_FMK(EMIF,GBLCTL,NOHOLD,nohold)\
S    |_PER_FMK(EMIF,GBLCTL,CLK1EN,clk1en)\
S    |_PER_FMK(EMIF,GBLCTL,CLK2EN,clk2en)\
S  )
X  #define EMIF_GBLCTL_RMK(nohold,clk1en,clk2en) (Uint32)(      _PER_FMK(EMIF,GBLCTL,NOHOLD,nohold)    |_PER_FMK(EMIF,GBLCTL,CLK1EN,clk1en)    |_PER_FMK(EMIF,GBLCTL,CLK2EN,clk2en)  )
N#endif
N
N#if (CHIP_6202|CHIP_6203|CHIP_6204|CHIP_6205)
X#if (0|0|0|0)
S  #define EMIF_GBLCTL_DEFAULT (Uint32)( \
S    0x00003008\
S    |_PER_FDEFAULT(EMIF,GBLCTL,ARDY)\
S    |_PER_FDEFAULT(EMIF,GBLCTL,HOLD)\
S    |_PER_FDEFAULT(EMIF,GBLCTL,HOLDA)\
S    |_PER_FDEFAULT(EMIF,GBLCTL,NOHOLD)\
S    |_PER_FDEFAULT(EMIF,GBLCTL,SDCEN)\
S    |_PER_FDEFAULT(EMIF,GBLCTL,SSCEN)\
S    |_PER_FDEFAULT(EMIF,GBLCTL,CLK1EN)\
S    |_PER_FDEFAULT(EMIF,GBLCTL,RBTR8)\
S    |_PER_FDEFAULT(EMIF,GBLCTL,MAP)\
S  )
X  #define EMIF_GBLCTL_DEFAULT (Uint32)(     0x00003008    |_PER_FDEFAULT(EMIF,GBLCTL,ARDY)    |_PER_FDEFAULT(EMIF,GBLCTL,HOLD)    |_PER_FDEFAULT(EMIF,GBLCTL,HOLDA)    |_PER_FDEFAULT(EMIF,GBLCTL,NOHOLD)    |_PER_FDEFAULT(EMIF,GBLCTL,SDCEN)    |_PER_FDEFAULT(EMIF,GBLCTL,SSCEN)    |_PER_FDEFAULT(EMIF,GBLCTL,CLK1EN)    |_PER_FDEFAULT(EMIF,GBLCTL,RBTR8)    |_PER_FDEFAULT(EMIF,GBLCTL,MAP)  )
S
S  #define EMIF_GBLCTL_RMK(nohold,sdcen,sscen,clk1en,rbtr8) (Uint32)( \
S     _PER_FMK(EMIF,GBLCTL,NOHOLD,nohold)\
S    |_PER_FMK(EMIF,GBLCTL,SDCEN,sdcen)\
S    |_PER_FMK(EMIF,GBLCTL,SSCEN,sscen)\
S    |_PER_FMK(EMIF,GBLCTL,CLK1EN,clk1en)\
S    |_PER_FMK(EMIF,GBLCTL,RBTR8,rbtr8)\
S  )
X  #define EMIF_GBLCTL_RMK(nohold,sdcen,sscen,clk1en,rbtr8) (Uint32)(      _PER_FMK(EMIF,GBLCTL,NOHOLD,nohold)    |_PER_FMK(EMIF,GBLCTL,SDCEN,sdcen)    |_PER_FMK(EMIF,GBLCTL,SSCEN,sscen)    |_PER_FMK(EMIF,GBLCTL,CLK1EN,clk1en)    |_PER_FMK(EMIF,GBLCTL,RBTR8,rbtr8)  )
N#endif
N
N#if (CHIP_6713 || CHIP_DA610 || CHIP_6711C || CHIP_6712C)
X#if (0 || 0 || 0 || 0)
S  #define EMIF_GBLCTL_DEFAULT (Uint32)( \
S    0x00003000\
S    |_PER_FDEFAULT(EMIF,GBLCTL,BUSREQ)\
S    |_PER_FDEFAULT(EMIF,GBLCTL,ARDY)\
S    |_PER_FDEFAULT(EMIF,GBLCTL,HOLD)\
S    |_PER_FDEFAULT(EMIF,GBLCTL,HOLDA)\
S    |_PER_FDEFAULT(EMIF,GBLCTL,NOHOLD)\
S    |_PER_FDEFAULT(EMIF,GBLCTL,EKEN)\
S    |_PER_FDEFAULT(EMIF,GBLCTL,CLK1EN)\
S    |_PER_FDEFAULT(EMIF,GBLCTL,CLK2EN)\
S  )
X  #define EMIF_GBLCTL_DEFAULT (Uint32)(     0x00003000    |_PER_FDEFAULT(EMIF,GBLCTL,BUSREQ)    |_PER_FDEFAULT(EMIF,GBLCTL,ARDY)    |_PER_FDEFAULT(EMIF,GBLCTL,HOLD)    |_PER_FDEFAULT(EMIF,GBLCTL,HOLDA)    |_PER_FDEFAULT(EMIF,GBLCTL,NOHOLD)    |_PER_FDEFAULT(EMIF,GBLCTL,EKEN)    |_PER_FDEFAULT(EMIF,GBLCTL,CLK1EN)    |_PER_FDEFAULT(EMIF,GBLCTL,CLK2EN)  )
S
S  #define EMIF_GBLCTL_RMK(nohold,eken,clk1en,clk2en) (Uint32)( \
S     _PER_FMK(EMIF,GBLCTL,NOHOLD,nohold)\
S    |_PER_FMK(EMIF,GBLCTL,EKEN,eken)\
S    |_PER_FMK(EMIF,GBLCTL,CLK1EN,clk1en)\
S    |_PER_FMK(EMIF,GBLCTL,CLK2EN,clk2en)\
S  )
X  #define EMIF_GBLCTL_RMK(nohold,eken,clk1en,clk2en) (Uint32)(      _PER_FMK(EMIF,GBLCTL,NOHOLD,nohold)    |_PER_FMK(EMIF,GBLCTL,EKEN,eken)    |_PER_FMK(EMIF,GBLCTL,CLK1EN,clk1en)    |_PER_FMK(EMIF,GBLCTL,CLK2EN,clk2en)  )
N#endif
N
N  #define _EMIF_GBLCTL_FGET(FIELD)\
N    _PER_FGET(_EMIF_GBLCTL_ADDR,EMIF,GBLCTL,##FIELD)
X  #define _EMIF_GBLCTL_FGET(FIELD)    _PER_FGET(_EMIF_GBLCTL_ADDR,EMIF,GBLCTL,##FIELD)
N
N  #define _EMIF_GBLCTL_FSET(FIELD,field)\
N    _PER_FSET(_EMIF_GBLCTL_ADDR,EMIF,GBLCTL,##FIELD,field)
X  #define _EMIF_GBLCTL_FSET(FIELD,field)    _PER_FSET(_EMIF_GBLCTL_ADDR,EMIF,GBLCTL,##FIELD,field)
N
N  #define _EMIF_GBLCTL_FSETS(FIELD,SYM)\
N    _PER_FSETS(_EMIF_GBLCTL_ADDR,EMIF,GBLCTL,##FIELD,##SYM)
X  #define _EMIF_GBLCTL_FSETS(FIELD,SYM)    _PER_FSETS(_EMIF_GBLCTL_ADDR,EMIF,GBLCTL,##FIELD,##SYM)
N
N
N/******************************************************************************\
N* _____________________
X
N* |                   |
N* |  C E C T L        |
N* |___________________|
N*
N* CECTL0 - CE space control register 0
N* CECTL1 - CE space control register 1
N* CECTL2 - CE space control register 2
N* CECTL3 - CE space control register 3
N*
N* FIELDS (msb -> lsb)
N* (rw) WRSETUP
N* (rw) WRSTRB
N* (rw) WRHLD
N* (rw) RDSETUP
N* (rw) TA       (1) 
N* (rw) RDSTRB
N* (rw) MTYPE
N* (rw) WRHLDMSB 
N* (rw) RDHLD
N*
N* (1) - Field only exists for C11_SUPPORT
N* 
N*
N\******************************************************************************/
N  #define _EMIF_CECTL0_OFFSET          2
N  #define _EMIF_CECTL1_OFFSET          1
N  #define _EMIF_CECTL2_OFFSET          4
N  #define _EMIF_CECTL3_OFFSET          5
N
N  #define _EMIF_CECTL0_ADDR            0x01800008u
N  #define _EMIF_CECTL1_ADDR            0x01800004u
N  #define _EMIF_CECTL2_ADDR            0x01800010u
N  #define _EMIF_CECTL3_ADDR            0x01800014u
N
N  #define _EMIF_CECTL_WRSETUP_MASK     0xF0000000u
N  #define _EMIF_CECTL_WRSETUP_SHIFT    0x0000001Cu
N  #define  EMIF_CECTL_WRSETUP_DEFAULT  0x0000000Fu
N  #define  EMIF_CECTL_WRSETUP_OF(x)    _VALUEOF(x)
N
N  #define _EMIF_CECTL_WRSTRB_MASK      0x0FC00000u
N  #define _EMIF_CECTL_WRSTRB_SHIFT     0x00000016u
N  #define  EMIF_CECTL_WRSTRB_DEFAULT   0x0000003Fu
N  #define  EMIF_CECTL_WRSTRB_OF(x)     _VALUEOF(x)
N
N  #define _EMIF_CECTL_WRHLD_MASK       0x00300000u
N  #define _EMIF_CECTL_WRHLD_SHIFT      0x00000014u
N  #define  EMIF_CECTL_WRHLD_DEFAULT    0x00000003u
N  #define  EMIF_CECTL_WRHLD_OF(x)      _VALUEOF(x)
N  
N  #define _EMIF_CECTL_RDSETUP_MASK     0x000F0000u
N  #define _EMIF_CECTL_RDSETUP_SHIFT    0x00000010u
N  #define  EMIF_CECTL_RDSETUP_DEFAULT  0x0000000Fu
N  #define  EMIF_CECTL_RDSETUP_OF(x)    _VALUEOF(x)
N
N#if (C11_SUPPORT)
X#if (( ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 1*0) | ( 0*1) | ( 1*0) | ( 1*0) | ( 1*0) | ( 1*0)| ( 0*0)| ( 0*0)| ( 0*0)| ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 1*0) | ( 1*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) ))
S  #define _EMIF_CECTL_TA_MASK          0x0000C000u
S  #define _EMIF_CECTL_TA_SHIFT         0x0000000Eu
S  #define  EMIF_CECTL_TA_DEFAULT       0x00000003u
S  #define  EMIF_CECTL_TA_OF(x)         _VALUEOF(x)
N#endif
N
N  #define _EMIF_CECTL_RDSTRB_MASK      0x00003F00u
N  #define _EMIF_CECTL_RDSTRB_SHIFT     0x00000008u
N  #define  EMIF_CECTL_RDSTRB_DEFAULT   0x0000003Fu
N  #define  EMIF_CECTL_RDSTRB_OF(x)     _VALUEOF(x)
N  
N#if (C11_SUPPORT)
X#if (( ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 1*0) | ( 0*1) | ( 1*0) | ( 1*0) | ( 1*0) | ( 1*0)| ( 0*0)| ( 0*0)| ( 0*0)| ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 1*0) | ( 1*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) ))
S  #define _EMIF_CECTL_MTYPE_MASK       0x000000F0u
S  #define _EMIF_CECTL_MTYPE_SHIFT      0x00000004u
S  #define  EMIF_CECTL_MTYPE_DEFAULT    0x00000002u
S  #define  EMIF_CECTL_MTYPE_OF(x)      _VALUEOF(x)
S  #if (CHIP_6712 || CHIP_6712C)  /* 16-bit EMIF */ 
S  #define  EMIFB_CECTL_MTYPE_ASYNC8     0x00000000u 
S  #define  EMIFB_CECTL_MTYPE_ASYNC16    0x00000001u 
S  #define  EMIFB_CECTL_MTYPE_SDRAM8     0x00000008u 
S  #define  EMIFB_CECTL_MTYPE_SDRAM16    0x00000009u 
S  #define  EMIFB_CECTL_MTYPE_SYNC8      0x0000000Au 
S  #define  EMIFB_CECTL_MTYPE_SYNC16     0x0000000Bu 
S  #else /* CHIP_6211/C6711/6711C 32-bit EMIF */
S  #define  EMIF_CECTL_MTYPE_ASYNC8     0x00000000u
S  #define  EMIF_CECTL_MTYPE_ASYNC16    0x00000001u
S  #define  EMIF_CECTL_MTYPE_ASYNC32    0x00000002u
S  #define  EMIF_CECTL_MTYPE_SDRAM32    0x00000003u
S  #define  EMIF_CECTL_MTYPE_SBSRAM32   0x00000004u
S  #define  EMIF_CECTL_MTYPE_SDRAM8     0x00000008u
S  #define  EMIF_CECTL_MTYPE_SDRAM16    0x00000009u
S  #define  EMIF_CECTL_MTYPE_SBSRAM8    0x0000000Au
S  #define  EMIF_CECTL_MTYPE_SBSRAM16   0x0000000Bu
S  #endif
S 
N#else
N  #define _EMIF_CECTL_MTYPE_MASK       0x00000070u
N  #define _EMIF_CECTL_MTYPE_SHIFT      0x00000004u
N  #define  EMIF_CECTL_MTYPE_DEFAULT    0x00000002u
N  #define  EMIF_CECTL_MTYPE_OF(x)      _VALUEOF(x)
N  #define  EMIF_CECTL_MTYPE_ASYNC8     0x00000000u
N  #define  EMIF_CECTL_MTYPE_ASYNC16    0x00000001u
N  #define  EMIF_CECTL_MTYPE_ASYNC32    0x00000002u
N  #define  EMIF_CECTL_MTYPE_SDRAM32    0x00000003u
N  #define  EMIF_CECTL_MTYPE_SBSRAM32   0x00000004u
N#endif
N
N
N#if (C11_SUPPORT )
X#if (( ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 1*0) | ( 0*1) | ( 1*0) | ( 1*0) | ( 1*0) | ( 1*0)| ( 0*0)| ( 0*0)| ( 0*0)| ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 1*0) | ( 1*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) ) )
S  #define _EMIF_CECTL_RDHLD_MASK       0x00000007u
S  #define _EMIF_CECTL_RDHLD_SHIFT      0x00000000u
S  #define  EMIF_CECTL_RDHLD_DEFAULT    0x00000003u
S  #define  EMIF_CECTL_RDHLD_OF(x)      _VALUEOF(x)
N#else
N  #define _EMIF_CECTL_RDHLD_MASK       0x00000003u
N  #define _EMIF_CECTL_RDHLD_SHIFT      0x00000000u
N  #define  EMIF_CECTL_RDHLD_DEFAULT    0x00000003u
N  #define  EMIF_CECTL_RDHLD_OF(x)      _VALUEOF(x)
N#endif
N
N  #define  EMIF_CECTL_OF(x)            _VALUEOF(x)
N
N#if (C11_SUPPORT)
X#if (( ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 1*0) | ( 0*1) | ( 1*0) | ( 1*0) | ( 1*0) | ( 1*0)| ( 0*0)| ( 0*0)| ( 0*0)| ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 1*0) | ( 1*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) ))
S  #define EMIF_CECTL_DEFAULT (Uint32)( \
S     _PER_FDEFAULT(EMIF,CECTL,WRSETUP)\
S    |_PER_FDEFAULT(EMIF,CECTL,WRSTRB)\
S    |_PER_FDEFAULT(EMIF,CECTL,WRHLD)\
S    |_PER_FDEFAULT(EMIF,CECTL,RDSETUP)\
S    |_PER_FDEFAULT(EMIF,CECTL,TA)\
S    |_PER_FDEFAULT(EMIF,CECTL,RDSTRB)\
S    |_PER_FDEFAULT(EMIF,CECTL,MTYPE)\
S    |_PER_FDEFAULT(EMIF,CECTL,RDHLD)\
S  )
X  #define EMIF_CECTL_DEFAULT (Uint32)(      _PER_FDEFAULT(EMIF,CECTL,WRSETUP)    |_PER_FDEFAULT(EMIF,CECTL,WRSTRB)    |_PER_FDEFAULT(EMIF,CECTL,WRHLD)    |_PER_FDEFAULT(EMIF,CECTL,RDSETUP)    |_PER_FDEFAULT(EMIF,CECTL,TA)    |_PER_FDEFAULT(EMIF,CECTL,RDSTRB)    |_PER_FDEFAULT(EMIF,CECTL,MTYPE)    |_PER_FDEFAULT(EMIF,CECTL,RDHLD)  )
S
S  #define EMIF_CECTL_RMK(wrsetup,wrstrb,wrhld,rdsetup,ta,rdstrb,mtype,\
S    rdhld) (Uint32)( \
S     _PER_FMK(EMIF,CECTL,WRSETUP,wrsetup)\
S    |_PER_FMK(EMIF,CECTL,WRSTRB,wrstrb)\
S    |_PER_FMK(EMIF,CECTL,WRHLD,wrhld)\
S    |_PER_FMK(EMIF,CECTL,RDSETUP,rdsetup)\
S    |_PER_FMK(EMIF,CECTL,TA,ta)\
S    |_PER_FMK(EMIF,CECTL,RDSTRB,rdstrb)\
S    |_PER_FMK(EMIF,CECTL,MTYPE,mtype)\
S    |_PER_FMK(EMIF,CECTL,RDHLD,rdhld)\
S  )
X  #define EMIF_CECTL_RMK(wrsetup,wrstrb,wrhld,rdsetup,ta,rdstrb,mtype,    rdhld) (Uint32)(      _PER_FMK(EMIF,CECTL,WRSETUP,wrsetup)    |_PER_FMK(EMIF,CECTL,WRSTRB,wrstrb)    |_PER_FMK(EMIF,CECTL,WRHLD,wrhld)    |_PER_FMK(EMIF,CECTL,RDSETUP,rdsetup)    |_PER_FMK(EMIF,CECTL,TA,ta)    |_PER_FMK(EMIF,CECTL,RDSTRB,rdstrb)    |_PER_FMK(EMIF,CECTL,MTYPE,mtype)    |_PER_FMK(EMIF,CECTL,RDHLD,rdhld)  )
N#endif
N
N
N
N#if (!C11_SUPPORT)
X#if (!( ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 1*0) | ( 0*1) | ( 1*0) | ( 1*0) | ( 1*0) | ( 1*0)| ( 0*0)| ( 0*0)| ( 0*0)| ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 1*0) | ( 1*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) ))
N  #define EMIF_CECTL_DEFAULT (Uint32)( \
N     _PER_FDEFAULT(EMIF,CECTL,WRSETUP)\
N    |_PER_FDEFAULT(EMIF,CECTL,WRSTRB)\
N    |_PER_FDEFAULT(EMIF,CECTL,WRHLD)\
N    |_PER_FDEFAULT(EMIF,CECTL,RDSETUP)\
N    |_PER_FDEFAULT(EMIF,CECTL,RDSTRB)\
N    |_PER_FDEFAULT(EMIF,CECTL,MTYPE)\
N    |_PER_FDEFAULT(EMIF,CECTL,RDHLD)\
N  )
X  #define EMIF_CECTL_DEFAULT (Uint32)(      _PER_FDEFAULT(EMIF,CECTL,WRSETUP)    |_PER_FDEFAULT(EMIF,CECTL,WRSTRB)    |_PER_FDEFAULT(EMIF,CECTL,WRHLD)    |_PER_FDEFAULT(EMIF,CECTL,RDSETUP)    |_PER_FDEFAULT(EMIF,CECTL,RDSTRB)    |_PER_FDEFAULT(EMIF,CECTL,MTYPE)    |_PER_FDEFAULT(EMIF,CECTL,RDHLD)  )
N
N  #define EMIF_CECTL_RMK(wrsetup,wrstrb,wrhld,rdsetup,rdstrb,mtype,\
N    rdhld) (Uint32)( \
N     _PER_FMK(EMIF,CECTL,WRSETUP,wrsetup)\
N    |_PER_FMK(EMIF,CECTL,WRSTRB,wrstrb)\
N    |_PER_FMK(EMIF,CECTL,WRHLD,wrhld)\
N    |_PER_FMK(EMIF,CECTL,RDSETUP,rdsetup)\
N    |_PER_FMK(EMIF,CECTL,RDSTRB,rdstrb)\
N    |_PER_FMK(EMIF,CECTL,MTYPE,mtype)\
N    |_PER_FMK(EMIF,CECTL,RDHLD,rdhld)\
N  )
X  #define EMIF_CECTL_RMK(wrsetup,wrstrb,wrhld,rdsetup,rdstrb,mtype,    rdhld) (Uint32)(      _PER_FMK(EMIF,CECTL,WRSETUP,wrsetup)    |_PER_FMK(EMIF,CECTL,WRSTRB,wrstrb)    |_PER_FMK(EMIF,CECTL,WRHLD,wrhld)    |_PER_FMK(EMIF,CECTL,RDSETUP,rdsetup)    |_PER_FMK(EMIF,CECTL,RDSTRB,rdstrb)    |_PER_FMK(EMIF,CECTL,MTYPE,mtype)    |_PER_FMK(EMIF,CECTL,RDHLD,rdhld)  )
N#endif
N
N  #define _EMIF_CECTL_FGET(N,FIELD)\
N    _PER_FGET(_EMIF_CECTL##N##_ADDR,EMIF,CECTL,##FIELD)
X  #define _EMIF_CECTL_FGET(N,FIELD)    _PER_FGET(_EMIF_CECTL##N##_ADDR,EMIF,CECTL,##FIELD)
N
N  #define _EMIF_CECTL_FSET(N,FIELD,f)\
N    _PER_FSET(_EMIF_CECTL##N##_ADDR,EMIF,CECTL,##FIELD,f)
X  #define _EMIF_CECTL_FSET(N,FIELD,f)    _PER_FSET(_EMIF_CECTL##N##_ADDR,EMIF,CECTL,##FIELD,f)
N
N  #define _EMIF_CECTL_FSETS(N,FIELD,SYM)\
N    _PER_FSETS(_EMIF_CECTL##N##_ADDR,EMIF,CECTL,##FIELD,##SYM)
X  #define _EMIF_CECTL_FSETS(N,FIELD,SYM)    _PER_FSETS(_EMIF_CECTL##N##_ADDR,EMIF,CECTL,##FIELD,##SYM)
N
N  #define _EMIF_CECTL0_FGET(FIELD) _EMIF_CECTL_FGET(0,##FIELD)
N  #define _EMIF_CECTL1_FGET(FIELD) _EMIF_CECTL_FGET(1,##FIELD)
N  #define _EMIF_CECTL2_FGET(FIELD) _EMIF_CECTL_FGET(2,##FIELD)
N  #define _EMIF_CECTL3_FGET(FIELD) _EMIF_CECTL_FGET(3,##FIELD)
N
N  #define _EMIF_CECTL0_FSET(FIELD,f) _EMIF_CECTL_FSET(0,##FIELD,f)
N  #define _EMIF_CECTL1_FSET(FIELD,f) _EMIF_CECTL_FSET(1,##FIELD,f)
N  #define _EMIF_CECTL2_FSET(FIELD,f) _EMIF_CECTL_FSET(2,##FIELD,f)
N  #define _EMIF_CECTL3_FSET(FIELD,f) _EMIF_CECTL_FSET(3,##FIELD,f)
N
N  #define _EMIF_CECTL0_FSETS(FIELD,SYM) _EMIF_CECTL_FSETS(0,##FIELD,##SYM)
N  #define _EMIF_CECTL1_FSETS(FIELD,SYM) _EMIF_CECTL_FSETS(1,##FIELD,##SYM)
N  #define _EMIF_CECTL2_FSETS(FIELD,SYM) _EMIF_CECTL_FSETS(2,##FIELD,##SYM)
N  #define _EMIF_CECTL3_FSETS(FIELD,SYM) _EMIF_CECTL_FSETS(3,##FIELD,##SYM)
N
N
N/******************************************************************************\
N* _____________________
X
N* |                   |
N* |  S D C T L        |
N* |___________________|
N*
N* SDCTL   - SDRAM control regsiter
N*
N* FIELDS (msb -> lsb)
N* (rw) SDBSZ (2)
N* (rw) SDRSZ (2)
N* (rw) SDCSZ (2)
N* (rw) SDWID (1)
N* (rw) RFEN
N* (r)  INIT
N* (rw) TRCD
N* (rw) TRP
N* (rw) TRC
N*
N* (1) - Field only exists for C01_SUPPORT
N* (2) - Field only exists for C11_SUPPORT 
N*
N\******************************************************************************/
N  #define _EMIF_SDCTL_OFFSET           6
N
N  #define _EMIF_SDCTL_ADDR             0x01800018u
N
N#if (C11_SUPPORT)
X#if (( ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 1*0) | ( 0*1) | ( 1*0) | ( 1*0) | ( 1*0) | ( 1*0)| ( 0*0)| ( 0*0)| ( 0*0)| ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 1*0) | ( 1*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) ))
S  #define _EMIF_SDCTL_SDBSZ_MASK       0x40000000u
S  #define _EMIF_SDCTL_SDBSZ_SHIFT      0x0000001Eu
S  #define  EMIF_SDCTL_SDBSZ_DEFAULT    0x00000000u
S  #define  EMIF_SDCTL_SDBSZ_OF(x)      _VALUEOF(x)
S  #define  EMIF_SDCTL_SDBSZ_2BANKS     0x00000000u
S  #define  EMIF_SDCTL_SDBSZ_4BANKS     0x00000001u
N#endif
N  
N#if (C11_SUPPORT)
X#if (( ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 1*0) | ( 0*1) | ( 1*0) | ( 1*0) | ( 1*0) | ( 1*0)| ( 0*0)| ( 0*0)| ( 0*0)| ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 1*0) | ( 1*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) ))
S  #define _EMIF_SDCTL_SDRSZ_MASK       0x30000000u
S  #define _EMIF_SDCTL_SDRSZ_SHIFT      0x0000001Cu
S  #define  EMIF_SDCTL_SDRSZ_DEFAULT    0x00000000u
S  #define  EMIF_SDCTL_SDRSZ_OF(x)      _VALUEOF(x)
S  #define  EMIF_SDCTL_SDRSZ_11ROW      0x00000000u
S  #define  EMIF_SDCTL_SDRSZ_12ROW      0x00000001u
S  #define  EMIF_SDCTL_SDRSZ_13ROW      0x00000002u
N#endif
N  
N#if (C11_SUPPORT)
X#if (( ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 1*0) | ( 0*1) | ( 1*0) | ( 1*0) | ( 1*0) | ( 1*0)| ( 0*0)| ( 0*0)| ( 0*0)| ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 1*0) | ( 1*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) ))
S  #define _EMIF_SDCTL_SDCSZ_MASK       0x0C000000u
S  #define _EMIF_SDCTL_SDCSZ_SHIFT      0x0000001Au
S  #define  EMIF_SDCTL_SDCSZ_DEFAULT    0x00000000u
S  #define  EMIF_SDCTL_SDCSZ_OF(x)      _VALUEOF(x)
S  #define  EMIF_SDCTL_SDCSZ_9COL       0x00000000u
S  #define  EMIF_SDCTL_SDCSZ_8COL       0x00000001u
S  #define  EMIF_SDCTL_SDCSZ_10COL      0x00000002u
N#endif
N  
N#if !(C11_SUPPORT) 
X#if !(( ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 1*0) | ( 0*1) | ( 1*0) | ( 1*0) | ( 1*0) | ( 1*0)| ( 0*0)| ( 0*0)| ( 0*0)| ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 1*0) | ( 1*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) )) 
N  #define _EMIF_SDCTL_SDWID_MASK       0x04000000u
N  #define _EMIF_SDCTL_SDWID_SHIFT      0x0000001Au
N  #define  EMIF_SDCTL_SDWID_DEFAULT    0x00000000u
N  #define  EMIF_SDCTL_SDWID_OF(x)      _VALUEOF(x)
N  #define  EMIF_SDCTL_SDWID_4X8BIT     0x00000000u
N  #define  EMIF_SDCTL_SDWID_2X16BIT    0x00000001u
N#endif
N  
N  #define _EMIF_SDCTL_RFEN_MASK        0x02000000u
N  #define _EMIF_SDCTL_RFEN_SHIFT       0x00000019u
N  #define  EMIF_SDCTL_RFEN_DEFAULT     0x00000001u
N  #define  EMIF_SDCTL_RFEN_OF(x)       _VALUEOF(x)
N  #define  EMIF_SDCTL_RFEN_DISABLE     0x00000000u
N  #define  EMIF_SDCTL_RFEN_ENABLE      0x00000001u
N
N  #define _EMIF_SDCTL_INIT_MASK        0x01000000u
N  #define _EMIF_SDCTL_INIT_SHIFT       0x00000018u
N  #define  EMIF_SDCTL_INIT_DEFAULT     0x00000001u
N  #define  EMIF_SDCTL_INIT_OF(x)       _VALUEOF(x)
N  #define  EMIF_SDCTL_INIT_NO          0x00000000u
N  #define  EMIF_SDCTL_INIT_YES         0x00000001u
N
N#if (C11_SUPPORT)
X#if (( ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 1*0) | ( 0*1) | ( 1*0) | ( 1*0) | ( 1*0) | ( 1*0)| ( 0*0)| ( 0*0)| ( 0*0)| ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 1*0) | ( 1*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) ))
S  #define _EMIF_SDCTL_TRCD_MASK        0x00F00000u
S  #define _EMIF_SDCTL_TRCD_SHIFT       0x00000014u
S  #define  EMIF_SDCTL_TRCD_DEFAULT     0x00000004u
S  #define  EMIF_SDCTL_TRCD_OF(x)       _VALUEOF(x)
N#else
N  #define _EMIF_SDCTL_TRCD_MASK        0x00F00000u
N  #define _EMIF_SDCTL_TRCD_SHIFT       0x00000014u
N  #define  EMIF_SDCTL_TRCD_DEFAULT     0x00000008u
N  #define  EMIF_SDCTL_TRCD_OF(x)       _VALUEOF(x)
N#endif
N
N  #define _EMIF_SDCTL_TRP_MASK         0x000F0000u
N  #define _EMIF_SDCTL_TRP_SHIFT        0x00000010u
N  #define  EMIF_SDCTL_TRP_DEFAULT      0x00000008u
N  #define  EMIF_SDCTL_TRP_OF(x)        _VALUEOF(x)
N
N  #define _EMIF_SDCTL_TRC_MASK         0x0000F000u
N  #define _EMIF_SDCTL_TRC_SHIFT        0x0000000Cu
N  #define  EMIF_SDCTL_TRC_DEFAULT      0x0000000Fu
N  #define  EMIF_SDCTL_TRC_OF(x)        _VALUEOF(x)
N
N  #define  EMIF_SDCTL_OF(x)            _VALUEOF(x)
N
N#if (C11_SUPPORT)
X#if (( ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 1*0) | ( 0*1) | ( 1*0) | ( 1*0) | ( 1*0) | ( 1*0)| ( 0*0)| ( 0*0)| ( 0*0)| ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 1*0) | ( 1*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) ))
S  #define EMIF_SDCTL_DEFAULT (Uint32)( \
S     _PER_FDEFAULT(EMIF,SDCTL,SDBSZ)\
S    |_PER_FDEFAULT(EMIF,SDCTL,SDRSZ)\
S    |_PER_FDEFAULT(EMIF,SDCTL,SDCSZ)\
S    |_PER_FDEFAULT(EMIF,SDCTL,RFEN)\
S    |_PER_FDEFAULT(EMIF,SDCTL,INIT)\
S    |_PER_FDEFAULT(EMIF,SDCTL,TRCD)\
S    |_PER_FDEFAULT(EMIF,SDCTL,TRP)\
S    |_PER_FDEFAULT(EMIF,SDCTL,TRC)\
S  )
X  #define EMIF_SDCTL_DEFAULT (Uint32)(      _PER_FDEFAULT(EMIF,SDCTL,SDBSZ)    |_PER_FDEFAULT(EMIF,SDCTL,SDRSZ)    |_PER_FDEFAULT(EMIF,SDCTL,SDCSZ)    |_PER_FDEFAULT(EMIF,SDCTL,RFEN)    |_PER_FDEFAULT(EMIF,SDCTL,INIT)    |_PER_FDEFAULT(EMIF,SDCTL,TRCD)    |_PER_FDEFAULT(EMIF,SDCTL,TRP)    |_PER_FDEFAULT(EMIF,SDCTL,TRC)  )
S
S  #define EMIF_SDCTL_RMK(sdbsz,sdrsz,sdcsz,rfen,init,trcd,trp,trc) (Uint32)(\
S     _PER_FMK(EMIF,SDCTL,SDBSZ,sdbsz)\
S    |_PER_FMK(EMIF,SDCTL,SDRSZ,sdrsz)\
S    |_PER_FMK(EMIF,SDCTL,SDCSZ,sdcsz)\
S    |_PER_FMK(EMIF,SDCTL,RFEN,rfen)\
S    |_PER_FMK(EMIF,SDCTL,INIT,init)\
S    |_PER_FMK(EMIF,SDCTL,TRCD,trcd)\
S    |_PER_FMK(EMIF,SDCTL,TRP,trp)\
S    |_PER_FMK(EMIF,SDCTL,TRC,trc)\
S  )
X  #define EMIF_SDCTL_RMK(sdbsz,sdrsz,sdcsz,rfen,init,trcd,trp,trc) (Uint32)(     _PER_FMK(EMIF,SDCTL,SDBSZ,sdbsz)    |_PER_FMK(EMIF,SDCTL,SDRSZ,sdrsz)    |_PER_FMK(EMIF,SDCTL,SDCSZ,sdcsz)    |_PER_FMK(EMIF,SDCTL,RFEN,rfen)    |_PER_FMK(EMIF,SDCTL,INIT,init)    |_PER_FMK(EMIF,SDCTL,TRCD,trcd)    |_PER_FMK(EMIF,SDCTL,TRP,trp)    |_PER_FMK(EMIF,SDCTL,TRC,trc)  )
N#endif
N
N#if !(C11_SUPPORT)
X#if !(( ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 1*0) | ( 0*1) | ( 1*0) | ( 1*0) | ( 1*0) | ( 1*0)| ( 0*0)| ( 0*0)| ( 0*0)| ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 1*0) | ( 1*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) ))
N  #define EMIF_SDCTL_DEFAULT (Uint32)( \
N     _PER_FDEFAULT(EMIF,SDCTL,SDWID)\
N    |_PER_FDEFAULT(EMIF,SDCTL,RFEN)\
N    |_PER_FDEFAULT(EMIF,SDCTL,INIT)\
N    |_PER_FDEFAULT(EMIF,SDCTL,TRCD)\
N    |_PER_FDEFAULT(EMIF,SDCTL,TRP)\
N    |_PER_FDEFAULT(EMIF,SDCTL,TRC)\
N  )
X  #define EMIF_SDCTL_DEFAULT (Uint32)(      _PER_FDEFAULT(EMIF,SDCTL,SDWID)    |_PER_FDEFAULT(EMIF,SDCTL,RFEN)    |_PER_FDEFAULT(EMIF,SDCTL,INIT)    |_PER_FDEFAULT(EMIF,SDCTL,TRCD)    |_PER_FDEFAULT(EMIF,SDCTL,TRP)    |_PER_FDEFAULT(EMIF,SDCTL,TRC)  )
N
N  #define EMIF_SDCTL_RMK(sdwid,rfen,init,trcd,trp,trc) (Uint32)(\
N     _PER_FMK(EMIF,SDCTL,SDWID,sdwid)\
N    |_PER_FMK(EMIF,SDCTL,RFEN,rfen)\
N    |_PER_FMK(EMIF,SDCTL,INIT,init)\
N    |_PER_FMK(EMIF,SDCTL,TRCD,trcd)\
N    |_PER_FMK(EMIF,SDCTL,TRP,trp)\
N    |_PER_FMK(EMIF,SDCTL,TRC,trc)\
N  )
X  #define EMIF_SDCTL_RMK(sdwid,rfen,init,trcd,trp,trc) (Uint32)(     _PER_FMK(EMIF,SDCTL,SDWID,sdwid)    |_PER_FMK(EMIF,SDCTL,RFEN,rfen)    |_PER_FMK(EMIF,SDCTL,INIT,init)    |_PER_FMK(EMIF,SDCTL,TRCD,trcd)    |_PER_FMK(EMIF,SDCTL,TRP,trp)    |_PER_FMK(EMIF,SDCTL,TRC,trc)  )
N#endif
N
N  #define _EMIF_SDCTL_FGET(FIELD)\
N    _PER_FGET(_EMIF_SDCTL_ADDR,EMIF,SDCTL,##FIELD)
X  #define _EMIF_SDCTL_FGET(FIELD)    _PER_FGET(_EMIF_SDCTL_ADDR,EMIF,SDCTL,##FIELD)
N
N  #define _EMIF_SDCTL_FSET(FIELD,field)\
N    _PER_FSET(_EMIF_SDCTL_ADDR,EMIF,SDCTL,##FIELD,field)
X  #define _EMIF_SDCTL_FSET(FIELD,field)    _PER_FSET(_EMIF_SDCTL_ADDR,EMIF,SDCTL,##FIELD,field)
N
N  #define _EMIF_SDCTL_FSETS(FIELD,SYM)\
N    _PER_FSETS(_EMIF_SDCTL_ADDR,EMIF,SDCTL,##FIELD,##SYM)
X  #define _EMIF_SDCTL_FSETS(FIELD,SYM)    _PER_FSETS(_EMIF_SDCTL_ADDR,EMIF,SDCTL,##FIELD,##SYM)
N
N
N/******************************************************************************\
N* _____________________
X
N* |                   |
N* |  S D T I M        |
N* |___________________|
N*
N* SDTIM   - SDRAM timing register
N*
N* FIELDS (msb -> lsb)
N* (rw) XRFR   (1)
N* (r)  CNTR
N* (rw) PERIOD
N*
N* (1) - Field only exists for C11_SUPPORT
N*
N\******************************************************************************/
N  #define _EMIF_SDTIM_OFFSET           7
N
N  #define _EMIF_SDTIM_ADDR             0x0180001Cu
N
N#if (C11_SUPPORT)
X#if (( ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 1*0) | ( 0*1) | ( 1*0) | ( 1*0) | ( 1*0) | ( 1*0)| ( 0*0)| ( 0*0)| ( 0*0)| ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 1*0) | ( 1*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) ))
S  #define _EMIF_SDTIM_XRFR_MASK        0x03000000u
S  #define _EMIF_SDTIM_XRFR_SHIFT       0x00000018u
S  #define  EMIF_SDTIM_XRFR_DEFAULT     0x00000000u
S  #define  EMIF_SDTIM_XRFR_OF(x)       _VALUEOF(x)
N#endif
N
N#if (C11_SUPPORT)
X#if (( ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 1*0) | ( 0*1) | ( 1*0) | ( 1*0) | ( 1*0) | ( 1*0)| ( 0*0)| ( 0*0)| ( 0*0)| ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 1*0) | ( 1*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) ))
S  #define _EMIF_SDTIM_CNTR_MASK        0x00FFF000u
S  #define _EMIF_SDTIM_CNTR_SHIFT       0x0000000Cu
S  #define  EMIF_SDTIM_CNTR_DEFAULT     0x000005DCu
S  #define  EMIF_SDTIM_CNTR_OF(x)       _VALUEOF(x)
N#else
N  #define _EMIF_SDTIM_CNTR_MASK        0x00FFF000u
N  #define _EMIF_SDTIM_CNTR_SHIFT       0x0000000Cu
N  #define  EMIF_SDTIM_CNTR_DEFAULT     0x00000040u
N  #define  EMIF_SDTIM_CNTR_OF(x)       _VALUEOF(x)
N#endif
N  
N#if (C11_SUPPORT)
X#if (( ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 1*0) | ( 0*1) | ( 1*0) | ( 1*0) | ( 1*0) | ( 1*0)| ( 0*0)| ( 0*0)| ( 0*0)| ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 1*0) | ( 1*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) ))
S  #define _EMIF_SDTIM_PERIOD_MASK      0x00000FFFu
S  #define _EMIF_SDTIM_PERIOD_SHIFT     0x00000000u
S  #define  EMIF_SDTIM_PERIOD_DEFAULT   0x000005DCu
S  #define  EMIF_SDTIM_PERIOD_OF(x)     _VALUEOF(x)
N#else
N  #define _EMIF_SDTIM_PERIOD_MASK      0x00000FFFu
N  #define _EMIF_SDTIM_PERIOD_SHIFT     0x00000000u
N  #define  EMIF_SDTIM_PERIOD_DEFAULT   0x00000040u
N  #define  EMIF_SDTIM_PERIOD_OF(x)     _VALUEOF(x)
N#endif
N
N  #define  EMIF_SDTIM_OF(x)            _VALUEOF(x)
N
N#if (C11_SUPPORT)
X#if (( ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 1*0) | ( 0*1) | ( 1*0) | ( 1*0) | ( 1*0) | ( 1*0)| ( 0*0)| ( 0*0)| ( 0*0)| ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 1*0) | ( 1*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) ))
S  #define EMIF_SDTIM_DEFAULT (Uint32)( \
S     _PER_FDEFAULT(EMIF,SDTIM,XRFR)\
S    |_PER_FDEFAULT(EMIF,SDTIM,CNTR)\
S    |_PER_FDEFAULT(EMIF,SDTIM,PERIOD)\
S  )
X  #define EMIF_SDTIM_DEFAULT (Uint32)(      _PER_FDEFAULT(EMIF,SDTIM,XRFR)    |_PER_FDEFAULT(EMIF,SDTIM,CNTR)    |_PER_FDEFAULT(EMIF,SDTIM,PERIOD)  )
S
S  #define EMIF_SDTIM_RMK(xrfr,period) (Uint32)(\
S     _PER_FMK(EMIF,SDTIM,XRFR,xrfr)\
S    |_PER_FMK(EMIF,SDTIM,PERIOD,period)\
S  )
X  #define EMIF_SDTIM_RMK(xrfr,period) (Uint32)(     _PER_FMK(EMIF,SDTIM,XRFR,xrfr)    |_PER_FMK(EMIF,SDTIM,PERIOD,period)  )
N#endif
N
N#if !(C11_SUPPORT)
X#if !(( ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 1*0) | ( 0*1) | ( 1*0) | ( 1*0) | ( 1*0) | ( 1*0)| ( 0*0)| ( 0*0)| ( 0*0)| ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 1*0) | ( 1*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) ))
N  #define EMIF_SDTIM_DEFAULT (Uint32)( \
N     _PER_FDEFAULT(EMIF,SDTIM,CNTR)\
N    |_PER_FDEFAULT(EMIF,SDTIM,PERIOD)\
N  )
X  #define EMIF_SDTIM_DEFAULT (Uint32)(      _PER_FDEFAULT(EMIF,SDTIM,CNTR)    |_PER_FDEFAULT(EMIF,SDTIM,PERIOD)  )
N
N  #define EMIF_SDTIM_RMK(period) (Uint32)(\
N     _PER_FMK(EMIF,SDTIM,PERIOD,period)\
N  )
X  #define EMIF_SDTIM_RMK(period) (Uint32)(     _PER_FMK(EMIF,SDTIM,PERIOD,period)  )
N#endif
N
N
N  #define _EMIF_SDTIM_FGET(FIELD)\
N    _PER_FGET(_EMIF_SDTIM_ADDR,EMIF,SDTIM,##FIELD)
X  #define _EMIF_SDTIM_FGET(FIELD)    _PER_FGET(_EMIF_SDTIM_ADDR,EMIF,SDTIM,##FIELD)
N
N  #define _EMIF_SDTIM_FSET(FIELD,field)\
N    _PER_FSET(_EMIF_SDTIM_ADDR,EMIF,SDTIM,##FIELD,field)
X  #define _EMIF_SDTIM_FSET(FIELD,field)    _PER_FSET(_EMIF_SDTIM_ADDR,EMIF,SDTIM,##FIELD,field)
N
N  #define _EMIF_SDTIM_FSETS(FIELD,SYM)\
N    _PER_FSETS(_EMIF_SDTIM_ADDR,EMIF,SDTIM,##FIELD,##SYM)
X  #define _EMIF_SDTIM_FSETS(FIELD,SYM)    _PER_FSETS(_EMIF_SDTIM_ADDR,EMIF,SDTIM,##FIELD,##SYM)
N
N
N/******************************************************************************\
N* _____________________
X
N* |                   |
N* |  S D E X T        |
N* |___________________|
N*
N* SDEXT   - SDRAM extension register (1)
N*
N* (1) - only supported on 6211,6711,6713,DA610,6711C,6712C
N*
N* FIELDS (msb -> lsb)
N* (rw) WR2RD
N* (rw) WR2DEAC
N* (rw) WR2WR
N* (rw) R2WDQM
N* (rw) RD2WR
N* (rw) RD2DEAC
N* (rw) RD2RD
N* (rw) THZP
N* (rw) TWR
N* (rw) TRRD
N* (rw) TRAS
N* (rw) TCL
N*
N\******************************************************************************/
N#if (C11_SUPPORT)
X#if (( ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 1*0) | ( 0*1) | ( 1*0) | ( 1*0) | ( 1*0) | ( 1*0)| ( 0*0)| ( 0*0)| ( 0*0)| ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 1*0) | ( 1*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) ))
S  #define _EMIF_SDEXT_OFFSET           8
S
S  #define _EMIF_SDEXT_ADDR             0x01800020u
S
S  #define _EMIF_SDEXT_WR2RD_MASK       0x00100000u
S  #define _EMIF_SDEXT_WR2RD_SHIFT      0x00000014u
S  #define  EMIF_SDEXT_WR2RD_DEFAULT    0x00000001u
S  #define  EMIF_SDEXT_WR2RD_OF(x)      _VALUEOF(x)
S
S  #define _EMIF_SDEXT_WR2DEAC_MASK     0x000C0000u
S  #define _EMIF_SDEXT_WR2DEAC_SHIFT    0x00000012u
S  #define  EMIF_SDEXT_WR2DEAC_DEFAULT  0x00000001u
S  #define  EMIF_SDEXT_WR2DEAC_OF(x)    _VALUEOF(x)
S
S  #define _EMIF_SDEXT_WR2WR_MASK       0x00020000u
S  #define _EMIF_SDEXT_WR2WR_SHIFT      0x00000011u
S  #define  EMIF_SDEXT_WR2WR_DEFAULT    0x00000001u
S  #define  EMIF_SDEXT_WR2WR_OF(x)      _VALUEOF(x)
S
S  #define _EMIF_SDEXT_R2WDQM_MASK      0x00018000u
S  #define _EMIF_SDEXT_R2WDQM_SHIFT     0x0000000Fu
S  #define  EMIF_SDEXT_R2WDQM_DEFAULT   0x00000003u
S  #define  EMIF_SDEXT_R2WDQM_OF(x)     _VALUEOF(x)
S
S  #define _EMIF_SDEXT_RD2WR_MASK       0x00007000u
S  #define _EMIF_SDEXT_RD2WR_SHIFT      0x0000000Cu
S  #define  EMIF_SDEXT_RD2WR_DEFAULT    0x00000005u
S  #define  EMIF_SDEXT_RD2WR_OF(x)      _VALUEOF(x)
S
S  #define _EMIF_SDEXT_RD2DEAC_MASK     0x00000C00u
S  #define _EMIF_SDEXT_RD2DEAC_SHIFT    0x0000000Au
S  #define  EMIF_SDEXT_RD2DEAC_DEFAULT  0x00000003u
S  #define  EMIF_SDEXT_RD2DEAC_OF(x)    _VALUEOF(x)
S
S  #define _EMIF_SDEXT_RD2RD_MASK       0x00000200u
S  #define _EMIF_SDEXT_RD2RD_SHIFT      0x00000009u
S  #define  EMIF_SDEXT_RD2RD_DEFAULT    0x00000001u
S  #define  EMIF_SDEXT_RD2RD_OF(x)      _VALUEOF(x)
S
S  #define _EMIF_SDEXT_THZP_MASK        0x00000180u
S  #define _EMIF_SDEXT_THZP_SHIFT       0x00000007u
S  #define  EMIF_SDEXT_THZP_DEFAULT     0x00000002u
S  #define  EMIF_SDEXT_THZP_OF(x)       _VALUEOF(x)
S
S  #define _EMIF_SDEXT_TWR_MASK         0x00000060u
S  #define _EMIF_SDEXT_TWR_SHIFT        0x00000005u
S  #define  EMIF_SDEXT_TWR_DEFAULT      0x00000001u
S  #define  EMIF_SDEXT_TWR_OF(x)        _VALUEOF(x)
S
S  #define _EMIF_SDEXT_TRRD_MASK        0x00000010u
S  #define _EMIF_SDEXT_TRRD_SHIFT       0x00000004u
S  #define  EMIF_SDEXT_TRRD_DEFAULT     0x00000001u
S  #define  EMIF_SDEXT_TRRD_OF(x)       _VALUEOF(x)
S
S  #define _EMIF_SDEXT_TRAS_MASK        0x0000000Eu
S  #define _EMIF_SDEXT_TRAS_SHIFT       0x00000001u
S  #define  EMIF_SDEXT_TRAS_DEFAULT     0x00000007u
S  #define  EMIF_SDEXT_TRAS_OF(x)       _VALUEOF(x)
S
S  #define _EMIF_SDEXT_TCL_MASK         0x00000001u
S  #define _EMIF_SDEXT_TCL_SHIFT        0x00000000u
S  #define  EMIF_SDEXT_TCL_DEFAULT      0x00000001u
S  #define  EMIF_SDEXT_TCL_OF(x)        _VALUEOF(x)
S
S  #define  EMIF_SDEXT_OF(x)            _VALUEOF(x)
S
S  #define EMIF_SDEXT_DEFAULT (Uint32)( \
S     _PER_FDEFAULT(EMIF,SDEXT,WR2RD)\
S    |_PER_FDEFAULT(EMIF,SDEXT,WR2DEAC)\
S    |_PER_FDEFAULT(EMIF,SDEXT,WR2WR)\
S    |_PER_FDEFAULT(EMIF,SDEXT,R2WDQM)\
S    |_PER_FDEFAULT(EMIF,SDEXT,RD2WR)\
S    |_PER_FDEFAULT(EMIF,SDEXT,RD2DEAC)\
S    |_PER_FDEFAULT(EMIF,SDEXT,RD2RD)\
S    |_PER_FDEFAULT(EMIF,SDEXT,THZP)\
S    |_PER_FDEFAULT(EMIF,SDEXT,TWR)\
S    |_PER_FDEFAULT(EMIF,SDEXT,TRRD)\
S    |_PER_FDEFAULT(EMIF,SDEXT,TRAS)\
S    |_PER_FDEFAULT(EMIF,SDEXT,TCL)\
S  )
X  #define EMIF_SDEXT_DEFAULT (Uint32)(      _PER_FDEFAULT(EMIF,SDEXT,WR2RD)    |_PER_FDEFAULT(EMIF,SDEXT,WR2DEAC)    |_PER_FDEFAULT(EMIF,SDEXT,WR2WR)    |_PER_FDEFAULT(EMIF,SDEXT,R2WDQM)    |_PER_FDEFAULT(EMIF,SDEXT,RD2WR)    |_PER_FDEFAULT(EMIF,SDEXT,RD2DEAC)    |_PER_FDEFAULT(EMIF,SDEXT,RD2RD)    |_PER_FDEFAULT(EMIF,SDEXT,THZP)    |_PER_FDEFAULT(EMIF,SDEXT,TWR)    |_PER_FDEFAULT(EMIF,SDEXT,TRRD)    |_PER_FDEFAULT(EMIF,SDEXT,TRAS)    |_PER_FDEFAULT(EMIF,SDEXT,TCL)  )
S
S  #define EMIF_SDEXT_RMK(wr2rd,wr2deac,wr2wr,r2wdqm,rd2wr,rd2deac,\
S    rd2rd,thzp,twr,trrd,tras,tcl) (Uint32)( \
S     _PER_FMK(EMIF,SDEXT,WR2RD,wr2rd)\
S    |_PER_FMK(EMIF,SDEXT,WR2DEAC,wr2deac)\
S    |_PER_FMK(EMIF,SDEXT,WR2WR,wr2wr)\
S    |_PER_FMK(EMIF,SDEXT,R2WDQM,r2wdqm)\
S    |_PER_FMK(EMIF,SDEXT,RD2WR,rd2wr)\
S    |_PER_FMK(EMIF,SDEXT,RD2DEAC,rd2deac)\
S    |_PER_FMK(EMIF,SDEXT,RD2RD,rd2rd)\
S    |_PER_FMK(EMIF,SDEXT,THZP,thzp)\
S    |_PER_FMK(EMIF,SDEXT,TWR,twr)\
S    |_PER_FMK(EMIF,SDEXT,TRRD,trrd)\
S    |_PER_FMK(EMIF,SDEXT,TRAS,tras)\
S    |_PER_FMK(EMIF,SDEXT,TCL,tcl)\
S  )
X  #define EMIF_SDEXT_RMK(wr2rd,wr2deac,wr2wr,r2wdqm,rd2wr,rd2deac,    rd2rd,thzp,twr,trrd,tras,tcl) (Uint32)(      _PER_FMK(EMIF,SDEXT,WR2RD,wr2rd)    |_PER_FMK(EMIF,SDEXT,WR2DEAC,wr2deac)    |_PER_FMK(EMIF,SDEXT,WR2WR,wr2wr)    |_PER_FMK(EMIF,SDEXT,R2WDQM,r2wdqm)    |_PER_FMK(EMIF,SDEXT,RD2WR,rd2wr)    |_PER_FMK(EMIF,SDEXT,RD2DEAC,rd2deac)    |_PER_FMK(EMIF,SDEXT,RD2RD,rd2rd)    |_PER_FMK(EMIF,SDEXT,THZP,thzp)    |_PER_FMK(EMIF,SDEXT,TWR,twr)    |_PER_FMK(EMIF,SDEXT,TRRD,trrd)    |_PER_FMK(EMIF,SDEXT,TRAS,tras)    |_PER_FMK(EMIF,SDEXT,TCL,tcl)  )
S
S  #define _EMIF_SDEXT_FGET(FIELD)\
S    _PER_FGET(_EMIF_SDEXT_ADDR,EMIF,SDEXT,##FIELD)
X  #define _EMIF_SDEXT_FGET(FIELD)    _PER_FGET(_EMIF_SDEXT_ADDR,EMIF,SDEXT,##FIELD)
S
S  #define _EMIF_SDEXT_FSET(FIELD,field)\
S    _PER_FSET(_EMIF_SDEXT_ADDR,EMIF,SDEXT,##FIELD,field)
X  #define _EMIF_SDEXT_FSET(FIELD,field)    _PER_FSET(_EMIF_SDEXT_ADDR,EMIF,SDEXT,##FIELD,field)
S
S  #define _EMIF_SDEXT_FSETS(FIELD,SYM)\
S    _PER_FSETS(_EMIF_SDEXT_ADDR,EMIF,SDEXT,##FIELD,##SYM)
X  #define _EMIF_SDEXT_FSETS(FIELD,SYM)    _PER_FSETS(_EMIF_SDEXT_ADDR,EMIF,SDEXT,##FIELD,##SYM)
S
N#endif
N
N/*----------------------------------------------------------------------------*/
N
N#endif /* EMIF_SUPPORT */
N#endif /* _CSL_EMIFHAL_H_ */
N/******************************************************************************\
N* End of csl_emifhal.h
X
N\******************************************************************************/
N
L 21 "E:/TI_workspase/c6701_t/csl/csl_chip.h" 2
N
N/******************************************************************************\
N* scope and inline control macros
X
N\******************************************************************************/
N#ifdef __cplusplus
S#define CSLAPI extern "C" far
N#else
N#define CSLAPI extern far
N#endif
N
N#undef  USEDEFS
N#undef  IDECL
N#undef  IDEF
N
N#ifdef  _CHIP_MOD_
S  #define IDECL CSLAPI
S  #define USEDEFS
S  #define IDEF
N#else
N  #ifdef  _INLINE
S    #define IDECL static inline
S    #define USEDEFS
S    #define IDEF  static inline
N  #else
N    #define IDECL CSLAPI
N  #endif
N#endif
N
N
N/******************************************************************************\
N* global macro declarations
X
N\******************************************************************************/
N#define CHIP_ENDIAN_BIG    0
N#define CHIP_ENDIAN_LITTLE 1
N
N#define CHIP_MAP_0         0
N#define CHIP_MAP_1         1
N
N/* Selected devices masks*/
N#if (CHIP_6713 || CHIP_DA610 || CHIP_6711C || CHIP_6712C)
X#if (0 || 0 || 0 || 0)
S#define CHIP_EKSRC_SYSCLK3  0x00000000u
S#define CHIP_EKSRC_ECLKIN   0x00000010u
N#endif
N
N#if (CHIP_6713 || CHIP_DA610)
X#if (0 || 0)
S#define CHIP_TOUT1          0x00000000u
S#define CHIP_AXR04_AXR111   0x00000008u
S
S#define CHIP_TOUT0          0x00000000u
S#define CHIP_AXR02_AXR113   0x00000004u
S
S#define CHIP_MCASP0         0x00000002u
S#define CHIP_MCBSP0         0x00000000u
S
S#define CHIP_I2C1           0x00000001u
S#define CHIP_MCBSP1         0x00000000u
S/* Full mask value */
S#define _CHIP_DEVCFG_MASK  0x0000001Fu
N#endif
N
N#if CHIP_DM642
X#if 0
S#define CHIP_VP2            0x00000040u
S#define CHIP_VP1            0x00000020u
S#define CHIP_VP0            0x00000010u
S#define CHIP_I2C            0x00000008u
S#define CHIP_MCBSP1         0x00000004u
S#define CHIP_MCBSP0         0x00000002u
S#define CHIP_MCASP0         0x00000001u
S
S#define _CHIP_PERCFG_MASK   0x0000007Fu
N#endif
N
N#if CHIP_DM641
X#if 0
S#define CHIP_VP1            0x00000020u
S#define CHIP_VP0            0x00000010u
S#define CHIP_I2C            0x00000008u
S#define CHIP_MCBSP1         0x00000004u
S#define CHIP_MCBSP0         0x00000002u
S#define CHIP_MCASP0         0x00000001u
S
S#define _CHIP_PERCFG_MASK   0x0000003Fu
N#endif
N
N#if CHIP_DM640
X#if 0
S#define CHIP_VP0            0x00000010u
S#define CHIP_I2C            0x00000008u
S#define CHIP_MCBSP1         0x00000004u
S#define CHIP_MCBSP0         0x00000002u
S#define CHIP_MCASP0         0x00000001u
S
S#define _CHIP_PERCFG_MASK   0x0000001Fu
N#endif
N
N#if CHIP_6412
X#if 0
S#define CHIP_I2C            0x00000008u
S#define CHIP_MCBSP1         0x00000004u
S#define CHIP_MCBSP0         0x00000002u
S#define _CHIP_PERCFG_MASK   0x0000000Eu
N#endif
N
N#if (CHIP_6410 || CHIP_6413 || CHIP_6418)
X#if (0 || 0 || 0)
S#define CHIP_AFCMUX         0x00000600u
S#define CHIP_MCASP1         0x00000100u
S#define CHIP_I2C1           0x00000080u
S#define CHIP_I2C0           0x00000008u
S#define CHIP_MCBSP1         0x00000004u
S#define CHIP_MCBSP0         0x00000002u
S#define CHIP_MCASP0         0x00000001u
S
S#define _CHIP_PERCFG_MASK   0x0000078Fu
N#endif
N
N/******************************************************************************\
N* global typedef declarations
X
N\******************************************************************************/
N#if( CHIP_6711C || CHIP_6712C || CHIP_DA610 || CHIP_6713 )
X#if( 0 || 0 || 0 || 0 )
Stypedef struct{
S   Uint32 devcfg;
S} CHIP_Config;
S#elif (CHIP_DM642 || CHIP_DM641 || CHIP_DM640  || CHIP_6412 || CHIP_6410 || CHIP_6413 || CHIP_6418)
X#elif (0 || 0 || 0  || 0 || 0 || 0 || 0)
Stypedef struct{
S   Uint32 percfg;
S} CHIP_Config; 
N#endif
N/******************************************************************************\
N* global variable declarations
X
N\******************************************************************************/
N
N
N/******************************************************************************\
N* global function declarations
X
N\******************************************************************************/
N
N
N/******************************************************************************\
N* inline function declarations
X
N\******************************************************************************/
NIDECL Uint32 CHIP_getCpuId();
Xextern far Uint32 CHIP_getCpuId();
NIDECL Uint32 CHIP_getRevId();
Xextern far Uint32 CHIP_getRevId();
NIDECL Uint32 CHIP_getSiliconRevId();
Xextern far Uint32 CHIP_getSiliconRevId();
NIDECL int    CHIP_getEndian();
Xextern far int    CHIP_getEndian();
NIDECL int    CHIP_getMapMode();
Xextern far int    CHIP_getMapMode();
N
N#if (CHIP_DM642 || CHIP_DM641 || CHIP_DM640  || CHIP_6412 || CHIP_6410 || CHIP_6413 || CHIP_6418) 
X#if (0 || 0 || 0  || 0 || 0 || 0 || 0) 
SIDECL void   CHIP_config(CHIP_Config *config);
SIDECL void   CHIP_configArgs(Uint32 percfg);
SIDECL void   CHIP_getConfig(CHIP_Config *config); 
S#elif ( CHIP_6711C || CHIP_6712C || CHIP_DA610 || CHIP_6713 )
X#elif ( 0 || 0 || 0 || 0 )
SIDECL void   CHIP_config(CHIP_Config *config);
SIDECL void   CHIP_configArgs(Uint32 devcfg);
SIDECL void   CHIP_getConfig(CHIP_Config *config); 
N#endif
N
N/******************************************************************************\
N* inline function definitions
X
N\******************************************************************************/
N#ifdef USEDEFS
S/*----------------------------------------------------------------------------*/
SIDEF Uint32 CHIP_getCpuId() {
S  return CHIP_FGET(CSR,CPUID);
S}
S/*----------------------------------------------------------------------------*/
SIDEF Uint32 CHIP_getRevId() {
S  return CHIP_FGET(CSR,REVID);
S}
S/*----------------------------------------------------------------------------*/
SIDEF Uint32 CHIP_getSiliconRevId() {
S  return (( 0x000F0000 & REG32(0x01B00200))>>16);
S}
S/*----------------------------------------------------------------------------*/
SIDEF int CHIP_getEndian() {
S  return CHIP_FGET(CSR,EN);
S}
S/*----------------------------------------------------------------------------*/
SIDEF int CHIP_getMapMode() {
S  int mapmode = 0;
S  #if (!C11_SUPPORT && !C64_SUPPORT)
S    mapmode = EMIF_FGET(GBLCTL,MAP);
S  #endif
S  return mapmode;
S}
S/*----------------------------------------------------------------------------*/
S#if (CHIP_6713 || CHIP_DM642 || CHIP_DM641 || CHIP_DM640 || CHIP_DA610 || CHIP_6412 || CHIP_6711C || CHIP_6712C || CHIP_6410 || CHIP_6413 || CHIP_6418)
SIDEF void   CHIP_config(CHIP_Config *config) {
S  Uint32 gie = CHIP_FGET(CSR,GIE);
S  
S#if( CHIP_6711C || CHIP_6712C || CHIP_DA610 || CHIP_6713 ) 
S    volatile Uint32 *base = (volatile Uint32 *)(_CHIP_DEVCFG_ADDR);
S    register int x0;
S    CHIP_FSET(CSR,GIE,0);
S    x0 = config->devcfg;
S    base[_CHIP_DEVCFG_OFFSET] = x0;
S    CHIP_FSET(CSR,GIE,gie);
S    
S#else 
S  volatile Uint32 *base = (volatile Uint32 *)(_CHIP_PERCFG_ADDR);
S  register int x0;
S  CHIP_FSET(CSR,GIE,0);
S  CHIP_FSETS(PCFGLOCK,LOCK,UNLOCK);
S  x0 = config->percfg;
S  base[_CHIP_PERCFG_OFFSET] = x0;
S  CHIP_FSET(CSR,GIE,gie);
S  
S#endif
S}      
S#endif
S/*----------------------------------------------------------------------------*/
S#if (CHIP_6713 || CHIP_DM642 || CHIP_DM641 || CHIP_DM640 || CHIP_DA610 || CHIP_6412 || CHIP_6711C || CHIP_6712C || CHIP_6410 || CHIP_6413 || CHIP_6418)
SIDEF void   CHIP_getConfig(CHIP_Config *config) {
S   Uint32 gie = CHIP_FGET(CSR,GIE);
S   
S#if( CHIP_6711C || CHIP_6712C || CHIP_DA610 || CHIP_6713 ) 
S   volatile Uint32 *base = (volatile Uint32 *)(_CHIP_DEVCFG_ADDR);
S   register int x0;
S
S   CHIP_FSET(CSR,GIE,0);
S
S   x0 = base[_CHIP_DEVCFG_OFFSET]; 
S   config->devcfg=x0;
S
S   CHIP_FSET(CSR,GIE,gie);
S   
S#else
S   volatile Uint32 *base = (volatile Uint32 *)(_CHIP_PERCFG_ADDR);
S   register int x0;
S
S   CHIP_FSET(CSR,GIE,0);
S
S   x0 = base[_CHIP_PERCFG_OFFSET]; 
S   config->percfg=x0;
S
S   CHIP_FSET(CSR,GIE,gie);
S   
S#endif
S}      
S#endif
S/*----------------------------------------------------------------------------*/
S   
S#if( CHIP_6711C || CHIP_6712C || CHIP_DA610 || CHIP_6713 )
S   IDEF void   CHIP_configArgs(Uint32 devcfg) {
S   Uint32 gie = CHIP_FGET(CSR,GIE);
S   volatile Uint32 *base = (volatile Uint32 *)(_CHIP_DEVCFG_ADDR);
S   CHIP_FSET(CSR,GIE,0);
S   base[_CHIP_DEVCFG_OFFSET]= devcfg; 
S   CHIP_FSET(CSR,GIE,gie);
S}   
S#elif (CHIP_DM642 || CHIP_DM641 || CHIP_DM640  || CHIP_6412 || CHIP_6410 || CHIP_6413 || CHIP_6418)
S   IDEF void   CHIP_configArgs(Uint32 percfg) {
S   Uint32 gie = CHIP_FGET(CSR,GIE);
S   volatile Uint32 *base = (volatile Uint32 *)(_CHIP_PERCFG_ADDR);
S
S   CHIP_FSET(CSR,GIE,0);
S
S#if(CHIP_DM642 || CHIP_6412)
S   CHIP_FSETS(PCFGLOCK,LOCK,UNLOCK);
S#endif
S
S   base[_CHIP_PERCFG_OFFSET]= percfg; 
S
S   CHIP_FSET(CSR,GIE,gie);
S}   
S#endif
S
S
S/*----------------------------------------------------------------------------*/
N#endif /* USEDEFS */
N
N
N#endif /* _CSL_CHIP_H_ */
N/******************************************************************************\
N* End of csl_chip.h
X
N\******************************************************************************/
N
L 15 "E:/TI_workspase/c6701_t/csl/csl_i2c.h" 2
N#include <csl_irq.h>
L 1 "E:/TI_workspase/c6701_t/csl/csl_irq.h" 1
N/******************************************************************************\
N*           Copyright (C) 1999-2000 Texas Instruments Incorporated.
X
N*                           All Rights Reserved
N*------------------------------------------------------------------------------
N* FILENAME...... csl_irq.h
N* DATE CREATED.. 06/09/1999 
N* LAST MODIFIED. 08/02/2004 - Adding support for C6418
N*                07/24/2004 - Re-introducing BIOS components from CSL due to compatibility issues.
N*                02/05/2004 Removed bios related components 
N*                10/03/2001
N*                - CHIP_RSET()/CHIP_RGET() replaced by CHIP_CRSET()/CHIP_CRGET()
N\******************************************************************************/
N#ifndef _CSL_IRQ_H_
N#define _CSL_IRQ_H_
N
N#include <csl_stdinc.h>
N#include <csl_chip.h>
N#include <csl_irqhal.h>
L 1 "E:/TI_workspase/c6701_t/csl/csl_irqhal.h" 1
N/******************************************************************************\
N*           Copyright (C) 1999-2000 Texas Instruments Incorporated.
X
N*                           All Rights Reserved
N*------------------------------------------------------------------------------
N* FILENAME...... csl_irqhal.h
N* DATE CREATED.. 06/20/1999 
N* LAST MODIFIED. 10/03/2000
N*------------------------------------------------------------------------------
N* REGISTERS
N*
N* MUXH   - interrupt multiplexer high register
N* MUXL   - interrupt multiplexer low register
N* EXTPOL - external interrupt polarity register
N*
N\******************************************************************************/
N#ifndef _CSL_IRQHAL_H_
N#define _CSL_IRQHAL_H_
N
N#include <csl_stdinchal.h>
N#include <csl_chip.h>
N
N#if (IRQ_SUPPORT)
X#if (( ( 1*0) | ( 1*0) | ( 1*0) | ( 1*0) | ( 1*0) | ( 1*0) | ( 1*1) | ( 1*0) | ( 1*0) | ( 1*0) | ( 1*0)| ( 1*0)| ( 1*0)| ( 1*0)| ( 1*0) | ( 1*0) | ( 1*0) | ( 1*0) | ( 1*0) | ( 1*0) | ( 1*0) | ( 1*0) | ( 1*0) | ( 1*0) | ( 0*0) ))
N/******************************************************************************\
N* MISC section
X
N\******************************************************************************/
N
N
N/******************************************************************************\
N* module level register/field access macros
X
N\******************************************************************************/
N
N  /* ----------------- */
N  /* FIELD MAKE MACROS */
N  /* ----------------- */
N
N  #define IRQ_FMK(REG,FIELD,x)\
N    _PER_FMK(IRQ,##REG,##FIELD,x)
X  #define IRQ_FMK(REG,FIELD,x)    _PER_FMK(IRQ,##REG,##FIELD,x)
N
N  #define IRQ_FMKS(REG,FIELD,SYM)\
N    _PER_FMKS(IRQ,##REG,##FIELD,##SYM)
X  #define IRQ_FMKS(REG,FIELD,SYM)    _PER_FMKS(IRQ,##REG,##FIELD,##SYM)
N 
N 
N  /* -------------------------------- */
N  /* RAW REGISTER/FIELD ACCESS MACROS */
N  /* -------------------------------- */
N
N  #define IRQ_ADDR(REG)\
N    _IRQ_##REG##_ADDR
X  #define IRQ_ADDR(REG)    _IRQ_##REG##_ADDR
N
N  #define IRQ_RGET(REG)\
N    _PER_RGET(_IRQ_##REG##_ADDR,IRQ,##REG)
X  #define IRQ_RGET(REG)    _PER_RGET(_IRQ_##REG##_ADDR,IRQ,##REG)
N
N  #define IRQ_RSET(REG,x)\
N    _PER_RSET(_IRQ_##REG##_ADDR,IRQ,##REG,x)
X  #define IRQ_RSET(REG,x)    _PER_RSET(_IRQ_##REG##_ADDR,IRQ,##REG,x)
N
N  #define IRQ_FGET(REG,FIELD)\
N    _IRQ_##REG##_FGET(##FIELD)
X  #define IRQ_FGET(REG,FIELD)    _IRQ_##REG##_FGET(##FIELD)
N
N  #define IRQ_FSET(REG,FIELD,x)\
N    _IRQ_##REG##_FSET(##FIELD,##x)
X  #define IRQ_FSET(REG,FIELD,x)    _IRQ_##REG##_FSET(##FIELD,##x)
N
N  #define IRQ_FSETS(REG,FIELD,SYM)\
N    _IRQ_##REG##_FSETS(##FIELD,##SYM)
X  #define IRQ_FSETS(REG,FIELD,SYM)    _IRQ_##REG##_FSETS(##FIELD,##SYM)
N 
N 
N  /* ------------------------------------------ */
N  /* ADDRESS BASED REGISTER/FIELD ACCESS MACROS */
N  /* ------------------------------------------ */
N
N  #define IRQ_RGETA(addr,REG)\
N    _PER_RGET(addr,IRQ,##REG)
X  #define IRQ_RGETA(addr,REG)    _PER_RGET(addr,IRQ,##REG)
N
N  #define IRQ_RSETA(addr,REG,x)\
N    _PER_RSET(addr,IRQ,##REG,x)
X  #define IRQ_RSETA(addr,REG,x)    _PER_RSET(addr,IRQ,##REG,x)
N
N  #define IRQ_FGETA(addr,REG,FIELD)\
N    _PER_FGET(addr,IRQ,##REG,##FIELD)
X  #define IRQ_FGETA(addr,REG,FIELD)    _PER_FGET(addr,IRQ,##REG,##FIELD)
N
N  #define IRQ_FSETA(addr,REG,FIELD,x)\
N    _PER_FSET(addr,IRQ,##REG,##FIELD,x)
X  #define IRQ_FSETA(addr,REG,FIELD,x)    _PER_FSET(addr,IRQ,##REG,##FIELD,x)
N
N  #define IRQ_FSETSA(addr,REG,FIELD,SYM)\
N    _PER_FSETS(addr,IRQ,##REG,##FIELD,##SYM)
X  #define IRQ_FSETSA(addr,REG,FIELD,SYM)    _PER_FSETS(addr,IRQ,##REG,##FIELD,##SYM)
N
N
N/******************************************************************************\
N* _____________________
X
N* |                   |
N* |  M U X H          |
N* |___________________|
N*
N* MUXH - interrupt multiplexer high register
N*
N* FIELDS (msb -> lsb)
N* (rw) INTSEL15
N* (rw) INTSEL14
N* (rw) INTSEL13
N* (rw) INTSEL12
N* (rw) INTSEL11
N* (rw) INTSEL10
N*
N\******************************************************************************/
N  #define _IRQ_MUXH_ADDR               0x019C0000u
N
N  #define _IRQ_MUXH_INTSEL15_MASK      0x7C000000u
N  #define _IRQ_MUXH_INTSEL15_SHIFT     0x0000001Au
N  #define  IRQ_MUXH_INTSEL15_DEFAULT   0x00000002u
N  #define  IRQ_MUXH_INTSEL15_OF(x)     _VALUEOF(x)
N
N  #define _IRQ_MUXH_INTSEL14_MASK      0x03E00000u
N  #define _IRQ_MUXH_INTSEL14_SHIFT     0x00000015u
N  #define  IRQ_MUXH_INTSEL14_DEFAULT   0x00000001u
N  #define  IRQ_MUXH_INTSEL14_OF(x)     _VALUEOF(x)
N
N  #define _IRQ_MUXH_INTSEL13_MASK      0x001F0000u
N  #define _IRQ_MUXH_INTSEL13_SHIFT     0x00000010u
N  #define  IRQ_MUXH_INTSEL13_DEFAULT   0x00000000u
N  #define  IRQ_MUXH_INTSEL13_OF(x)     _VALUEOF(x)
N
N  #define _IRQ_MUXH_INTSEL12_MASK      0x00007C00u
N  #define _IRQ_MUXH_INTSEL12_SHIFT     0x0000000Au
N  #define  IRQ_MUXH_INTSEL12_DEFAULT   0x0000000Bu
N  #define  IRQ_MUXH_INTSEL12_OF(x)     _VALUEOF(x)
N
N  #define _IRQ_MUXH_INTSEL11_MASK      0x000003E0u
N  #define _IRQ_MUXH_INTSEL11_SHIFT     0x00000005u
N  #define  IRQ_MUXH_INTSEL11_DEFAULT   0x0000000Au
N  #define  IRQ_MUXH_INTSEL11_OF(x)     _VALUEOF(x)
N
N  #define _IRQ_MUXH_INTSEL10_MASK      0x0000001Fu
N  #define _IRQ_MUXH_INTSEL10_SHIFT     0x00000000u
N  #define  IRQ_MUXH_INTSEL10_DEFAULT   0x00000003u
N  #define  IRQ_MUXH_INTSEL10_OF(x)     _VALUEOF(x)
N
N  #define  IRQ_MUXH_OF(x)              _VALUEOF(x)
N
N  #define IRQ_MUXH_DEFAULT (Uint32)( \
N     _PER_FDEFAULT(IRQ,MUXH,INTSEL15) \
N    |_PER_FDEFAULT(IRQ,MUXH,INTSEL14) \
N    |_PER_FDEFAULT(IRQ,MUXH,INTSEL13) \
N    |_PER_FDEFAULT(IRQ,MUXH,INTSEL12) \
N    |_PER_FDEFAULT(IRQ,MUXH,INTSEL11) \
N    |_PER_FDEFAULT(IRQ,MUXH,INTSEL10) \
N  )
X  #define IRQ_MUXH_DEFAULT (Uint32)(      _PER_FDEFAULT(IRQ,MUXH,INTSEL15)     |_PER_FDEFAULT(IRQ,MUXH,INTSEL14)     |_PER_FDEFAULT(IRQ,MUXH,INTSEL13)     |_PER_FDEFAULT(IRQ,MUXH,INTSEL12)     |_PER_FDEFAULT(IRQ,MUXH,INTSEL11)     |_PER_FDEFAULT(IRQ,MUXH,INTSEL10)   )
N
N  #define IRQ_MUXH_RMK(intsel15,intsel14,intsel13,intsel12,intsel11,intsel10) \
N    (Uint32)( \
N     _PER_FMK(IRQ,MUXH,INTSEL15,intsel15) \
N    |_PER_FMK(IRQ,MUXH,INTSEL14,intsel14) \
N    |_PER_FMK(IRQ,MUXH,INTSEL13,intsel13) \
N    |_PER_FMK(IRQ,MUXH,INTSEL12,intsel12) \
N    |_PER_FMK(IRQ,MUXH,INTSEL11,intsel11) \
N    |_PER_FMK(IRQ,MUXH,INTSEL10,intsel10) \
N   )
X  #define IRQ_MUXH_RMK(intsel15,intsel14,intsel13,intsel12,intsel11,intsel10)     (Uint32)(      _PER_FMK(IRQ,MUXH,INTSEL15,intsel15)     |_PER_FMK(IRQ,MUXH,INTSEL14,intsel14)     |_PER_FMK(IRQ,MUXH,INTSEL13,intsel13)     |_PER_FMK(IRQ,MUXH,INTSEL12,intsel12)     |_PER_FMK(IRQ,MUXH,INTSEL11,intsel11)     |_PER_FMK(IRQ,MUXH,INTSEL10,intsel10)    )
N
N  #define _IRQ_MUXH_FGET(FIELD)\
N    _PER_FGET(_IRQ_MUXH_ADDR,IRQ,MUXH,##FIELD)
X  #define _IRQ_MUXH_FGET(FIELD)    _PER_FGET(_IRQ_MUXH_ADDR,IRQ,MUXH,##FIELD)
N
N  #define _IRQ_MUXH_FSET(FIELD,field)\
N    _PER_FSET(_IRQ_MUXH_ADDR,IRQ,MUXH,##FIELD,field)
X  #define _IRQ_MUXH_FSET(FIELD,field)    _PER_FSET(_IRQ_MUXH_ADDR,IRQ,MUXH,##FIELD,field)
N
N  #define _IRQ_MUXH_FSETS(FIELD,SYM)\
N    _PER_FSETS(_IRQ_MUXH_ADDR,IRQ,MUXH,##FIELD,##SYM)
X  #define _IRQ_MUXH_FSETS(FIELD,SYM)    _PER_FSETS(_IRQ_MUXH_ADDR,IRQ,MUXH,##FIELD,##SYM)
N
N
N/******************************************************************************\
N* _____________________
X
N* |                   |
N* |  M U X L          |
N* |___________________|
N*
N* MUXL - interrupt multiplexer low register
N*
N* FIELDS (msb -> lsb)
N* (rw) INTSEL9
N* (rw) INTSEL8
N* (rw) INTSEL7
N* (rw) INTSEL6
N* (rw) INTSEL5
N* (rw) INTSEL4
N*
N\******************************************************************************/
N  #define _IRQ_MUXL_ADDR               0x019C0004u
N
N  #define _IRQ_MUXL_INTSEL9_MASK       0x7C000000u
N  #define _IRQ_MUXL_INTSEL9_SHIFT      0x0000001Au
N  #define  IRQ_MUXL_INTSEL9_DEFAULT    0x00000009u
N  #define  IRQ_MUXL_INTSEL9_OF(x)      _VALUEOF(x)
N
N  #define _IRQ_MUXL_INTSEL8_MASK       0x03E00000u
N  #define _IRQ_MUXL_INTSEL8_SHIFT      0x00000015u
N  #define  IRQ_MUXL_INTSEL8_DEFAULT    0x00000008u
N  #define  IRQ_MUXL_INTSEL8_OF(x)      _VALUEOF(x)
N
N  #define _IRQ_MUXL_INTSEL7_MASK       0x001F0000u
N  #define _IRQ_MUXL_INTSEL7_SHIFT      0x00000010u
N  #define  IRQ_MUXL_INTSEL7_DEFAULT    0x00000007u
N  #define  IRQ_MUXL_INTSEL7_OF(x)      _VALUEOF(x)
N
N  #define _IRQ_MUXL_INTSEL6_MASK       0x00007C00u
N  #define _IRQ_MUXL_INTSEL6_SHIFT      0x0000000Au
N  #define  IRQ_MUXL_INTSEL6_DEFAULT    0x00000006u
N  #define  IRQ_MUXL_INTSEL6_OF(x)      _VALUEOF(x)
N
N  #define _IRQ_MUXL_INTSEL5_MASK       0x000003E0u
N  #define _IRQ_MUXL_INTSEL5_SHIFT      0x00000005u
N  #define  IRQ_MUXL_INTSEL5_DEFAULT    0x00000005u
N  #define  IRQ_MUXL_INTSEL5_OF(x)      _VALUEOF(x)
N
N  #define _IRQ_MUXL_INTSEL4_MASK       0x0000001Fu
N  #define _IRQ_MUXL_INTSEL4_SHIFT      0x00000000u
N  #define  IRQ_MUXL_INTSEL4_DEFAULT    0x00000004u
N  #define  IRQ_MUXL_INTSEL4_OF(x)      _VALUEOF(x)
N
N  #define  IRQ_MUXL_OF(x)              _VALUEOF(x)
N
N  #define IRQ_MUXL_DEFAULT (Uint32)( \
N     _PER_FDEFAULT(IRQ,MUXL,INTSEL9) \
N    |_PER_FDEFAULT(IRQ,MUXL,INTSEL8) \
N    |_PER_FDEFAULT(IRQ,MUXL,INTSEL7) \
N    |_PER_FDEFAULT(IRQ,MUXL,INTSEL6) \
N    |_PER_FDEFAULT(IRQ,MUXL,INTSEL5) \
N    |_PER_FDEFAULT(IRQ,MUXL,INTSEL4) \
N  )
X  #define IRQ_MUXL_DEFAULT (Uint32)(      _PER_FDEFAULT(IRQ,MUXL,INTSEL9)     |_PER_FDEFAULT(IRQ,MUXL,INTSEL8)     |_PER_FDEFAULT(IRQ,MUXL,INTSEL7)     |_PER_FDEFAULT(IRQ,MUXL,INTSEL6)     |_PER_FDEFAULT(IRQ,MUXL,INTSEL5)     |_PER_FDEFAULT(IRQ,MUXL,INTSEL4)   )
N
N  #define IRQ_MUXL_RMK(intsel9,intsel8,intsel7,intsel6,intsel5,intsel4) \
N    (Uint32)( \
N     _PER_FMK(IRQ,MUXL,INTSEL9,intsel9) \
N    |_PER_FMK(IRQ,MUXL,INTSEL8,intsel8) \
N    |_PER_FMK(IRQ,MUXL,INTSEL7,intsel7) \
N    |_PER_FMK(IRQ,MUXL,INTSEL6,intsel6) \
N    |_PER_FMK(IRQ,MUXL,INTSEL5,intsel5) \
N    |_PER_FMK(IRQ,MUXL,INTSEL4,intsel4) \
N   )
X  #define IRQ_MUXL_RMK(intsel9,intsel8,intsel7,intsel6,intsel5,intsel4)     (Uint32)(      _PER_FMK(IRQ,MUXL,INTSEL9,intsel9)     |_PER_FMK(IRQ,MUXL,INTSEL8,intsel8)     |_PER_FMK(IRQ,MUXL,INTSEL7,intsel7)     |_PER_FMK(IRQ,MUXL,INTSEL6,intsel6)     |_PER_FMK(IRQ,MUXL,INTSEL5,intsel5)     |_PER_FMK(IRQ,MUXL,INTSEL4,intsel4)    )
N
N  #define _IRQ_MUXL_FGET(FIELD)\
N    _PER_FGET(_IRQ_MUXL_ADDR,IRQ,MUXL,##FIELD)
X  #define _IRQ_MUXL_FGET(FIELD)    _PER_FGET(_IRQ_MUXL_ADDR,IRQ,MUXL,##FIELD)
N
N  #define _IRQ_MUXL_FSET(FIELD,field)\
N    _PER_FSET(_IRQ_MUXL_ADDR,IRQ,MUXL,##FIELD,field)
X  #define _IRQ_MUXL_FSET(FIELD,field)    _PER_FSET(_IRQ_MUXL_ADDR,IRQ,MUXL,##FIELD,field)
N
N  #define _IRQ_MUXL_FSETS(FIELD,SYM)\
N    _PER_FSETS(_IRQ_MUXL_ADDR,IRQ,MUXL,##FIELD,##SYM)
X  #define _IRQ_MUXL_FSETS(FIELD,SYM)    _PER_FSETS(_IRQ_MUXL_ADDR,IRQ,MUXL,##FIELD,##SYM)
N
N
N/******************************************************************************\
N* _____________________
X
N* |                   |
N* |  E X T P O L      |
N* |___________________|
N*
N* EXTPOL - external interrupt polarity register
N*
N* FIELDS (msb -> lsb)
N* (rw) XIP
N*
N\******************************************************************************/
N  #define _IRQ_EXTPOL_ADDR            0x019C0008u
N
N  #define _IRQ_EXTPOL_XIP_MASK        0x0000000Fu
N  #define _IRQ_EXTPOL_XIP_SHIFT       0x00000000u
N  #define  IRQ_EXTPOL_XIP_DEFAULT     0x00000000u
N  #define  IRQ_EXTPOL_XIP_OF(x)       _VALUEOF(x)
N
N  #define  IRQ_EXTPOL_OF(x)           _VALUEOF(x)
N
N  #define IRQ_EXTPOL_DEFAULT (Uint32)( \
N     _PER_FDEFAULT(IRQ,EXTPOL,XIP) \
N  )
X  #define IRQ_EXTPOL_DEFAULT (Uint32)(      _PER_FDEFAULT(IRQ,EXTPOL,XIP)   )
N
N  #define IRQ_EXTPOL_RMK(xip) (Uint32)( \
N     _PER_FMK(IRQ,EXTPOL,XIP,xip) \
N  )
X  #define IRQ_EXTPOL_RMK(xip) (Uint32)(      _PER_FMK(IRQ,EXTPOL,XIP,xip)   )
N
N  #define _IRQ_EXTPOL_FGET(FIELD)\
N    _PER_FGET(_IRQ_EXTPOL_ADDR,IRQ,EXTPOL,##FIELD)
X  #define _IRQ_EXTPOL_FGET(FIELD)    _PER_FGET(_IRQ_EXTPOL_ADDR,IRQ,EXTPOL,##FIELD)
N
N  #define _IRQ_EXTPOL_FSET(FIELD,field)\
N    _PER_FSET(_IRQ_EXTPOL_ADDR,IRQ,EXTPOL,##FIELD,field)
X  #define _IRQ_EXTPOL_FSET(FIELD,field)    _PER_FSET(_IRQ_EXTPOL_ADDR,IRQ,EXTPOL,##FIELD,field)
N
N  #define _IRQ_EXTPOL_FSETS(FIELD,SYM)\
N    _PER_FSETS(_IRQ_EXTPOL_ADDR,IRQ,EXTPOL,##FIELD,##SYM)
X  #define _IRQ_EXTPOL_FSETS(FIELD,SYM)    _PER_FSETS(_IRQ_EXTPOL_ADDR,IRQ,EXTPOL,##FIELD,##SYM)
N
N
N/*----------------------------------------------------------------------------*/
N
N#endif /* IRQ_SUPPORT */
N#endif /* _CSL_IRQHAL_H_ */
N/******************************************************************************\
N* End of csl_irqhal.h
X
N\******************************************************************************/
N
L 19 "E:/TI_workspase/c6701_t/csl/csl_irq.h" 2
N
N
N#if (IRQ_SUPPORT)
X#if (( ( 1*0) | ( 1*0) | ( 1*0) | ( 1*0) | ( 1*0) | ( 1*0) | ( 1*1) | ( 1*0) | ( 1*0) | ( 1*0) | ( 1*0)| ( 1*0)| ( 1*0)| ( 1*0)| ( 1*0) | ( 1*0) | ( 1*0) | ( 1*0) | ( 1*0) | ( 1*0) | ( 1*0) | ( 1*0) | ( 1*0) | ( 1*0) | ( 0*0) ))
N/******************************************************************************\
N* scope and inline control macros
X
N\******************************************************************************/
N#ifdef __cplusplus
S#define CSLAPI extern "C" far 
N#else
N#define CSLAPI extern far
N#endif
N
N#undef  USEDEFS
N#undef  IDECL
N#undef  IDEF
N
N#ifdef  _IRQ_MOD_
S  #define IDECL CSLAPI
S  #define USEDEFS
S  #define IDEF
N#else
N  #ifdef  _INLINE
S    #define IDECL static inline
S    #define USEDEFS
S    #define IDEF  static inline
N  #else
N    #define IDECL CSLAPI
N  #endif
N#endif
N
N
N/******************************************************************************\
N* global macro declarations
X
N\******************************************************************************/
N
N/* misc global settings */
N#define IRQ_INT_CNT     16
N#define IRQ_EVENT_CNT   32
N
N#define IRQ_EVT_NA         IRQ_EVENT_CNT
N
N/* event id definitions */
N#if (CHIP_6410 | CHIP_6413 | CHIP_6418)
X#if (0 | 0 | 0)
S  
S    #define IRQ_EVT_DSPINT     0
S    #define IRQ_EVT_TINT0      1
S    #define IRQ_EVT_TINT1      2
S    #define IRQ_EVT_SDINTA     3
S    #define IRQ_EVT_EXTINT4    4
S    #define IRQ_EVT_GPINT4     4
S    #define IRQ_EVT_EXTINT5    5
S    #define IRQ_EVT_GPINT5     5
S    #define IRQ_EVT_EXTINT6    6
S    #define IRQ_EVT_GPINT6     6
S    #define IRQ_EVT_EXTINT7    7
S    #define IRQ_EVT_GPINT7     7
S    #define IRQ_EVT_EDMAINT    8
S    #define IRQ_EVT_EMUDTDMA   9
S    #define IRQ_EVT_EMURTDXRX  10
S    #define IRQ_EVT_EMURTDXTX  11
S    #define IRQ_EVT_XINT0      12
S    #define IRQ_EVT_RINT0      13
S    #define IRQ_EVT_XINT1      14
S    #define IRQ_EVT_RINT1      15
S    #define IRQ_EVT_GPINT0     16
S    #define IRQ_EVT_TINT2      19
S    #define IRQ_EVT_I2CINT0    22
S    #define IRQ_EVT_I2CINT1    23
S    #define IRQ_EVT_AXINT1     24
S    #define IRQ_EVT_ARINT1     25
S    #define IRQ_EVT_AXINT0     28
S    #define IRQ_EVT_ARINT0     29
S
S  #if (CHIP_6418)
S    #define IRQ_EVT_VCPINT     30
S  #endif
S
N#else 
N
N  #if (CHIP_DM642 | CHIP_DM641 | CHIP_DM640 | CHIP_6412)
X  #if (0 | 0 | 0 | 0)
S
S    #define IRQ_EVT_DSPINT     0
S    #define IRQ_EVT_TINT0      1
S    #define IRQ_EVT_TINT1      2
S    #define IRQ_EVT_SDINTA     3
S    #define IRQ_EVT_EXTINT4    4
S    #define IRQ_EVT_GPINT4     4
S    #define IRQ_EVT_EXTINT5    5
S    #define IRQ_EVT_GPINT5     5
S    #define IRQ_EVT_EXTINT6    6
S    #define IRQ_EVT_GPINT6     6
S    #define IRQ_EVT_EXTINT7    7
S    #define IRQ_EVT_GPINT7     7
S    #define IRQ_EVT_EDMAINT    8
S    #define IRQ_EVT_EMUDTDMA   9
S    #define IRQ_EVT_EMURTDXRX  10
S    #define IRQ_EVT_EMURTDXTX  11
S    #define IRQ_EVT_XINT0      12
S    #define IRQ_EVT_RINT0      13
S    #define IRQ_EVT_XINT1      14
S    #define IRQ_EVT_RINT1      15
S    #define IRQ_EVT_GPINT0     16
S    #define IRQ_EVT_TINT2      19
S    #define IRQ_EVT_I2CINT0    22
S    #define IRQ_EVT_MACINT     24
S
S   #if !(CHIP_6412)
S    #define IRQ_EVT_VINT0      25
S    #define IRQ_EVT_VINT1      26
S   #endif
S
S   #if (CHIP_DM642)
S    #define IRQ_EVT_VINT2      27
S   #endif
S
S   #if !(CHIP_6412)
S    #define IRQ_EVT_AXINT0     28
S    #define IRQ_EVT_ARINT0     29
S   #endif
S
N  #else
N
N    #define IRQ_EVT_DSPINT     0
N    #define IRQ_EVT_TINT0      1
N    #define IRQ_EVT_TINT1      2
N    #define IRQ_EVT_SDINT      3
N    #define IRQ_EVT_SDINTA     3
N    #define IRQ_EVT_EXTINT4    4
N    #define IRQ_EVT_GPINT4     4
N    #define IRQ_EVT_EXTINT5    5
N    #define IRQ_EVT_GPINT5     5
N    #define IRQ_EVT_EXTINT6    6
N    #define IRQ_EVT_GPINT6     6
N    #define IRQ_EVT_EXTINT7    7
N    #define IRQ_EVT_GPINT7     7
N    #define IRQ_EVT_EDMAINT    8
N    #define IRQ_EVT_DMAINT0    8
N    #define IRQ_EVT_EMUDTDMA   9
N    #define IRQ_EVT_DMAINT1    9
N    #define IRQ_EVT_EMURTDXRX  10
N    #define IRQ_EVT_DMAINT2    10
N    #define IRQ_EVT_EMURTDXTX  11
N    #define IRQ_EVT_DMAINT3    11
N    #define IRQ_EVT_XINT0      12
N    #define IRQ_EVT_RINT0      13
N    #define IRQ_EVT_XINT1      14
N    #define IRQ_EVT_RINT1      15
N    #define IRQ_EVT_GPINT0     16
N    #define IRQ_EVT_XINT2      17
N    #define IRQ_EVT_RINT2      18
N    #define IRQ_EVT_TINT2      19
N    #define IRQ_EVT_SDINTB     20
N    #define IRQ_EVT_PCIWAKE    21
N    #define IRQ_EVT_MDIO       21
N    #define IRQ_EVT_QDMAERR    22
N    #define IRQ_EVT_I2CINT0    22 /* 6713 */
N    #define IRQ_EVT_UINT       23
N    #define IRQ_EVT_I2CINT1    23 /* 6713 */
N    #define IRQ_EVT_I2CINT2    23 
N    #define IRQ_EVT_I2CINT3    22 
N    #define IRQ_EVT_I2CINT4    23 
N
N    #define IRQ_EVT_MACINT     24 /* DM642 */
N    #define IRQ_EVT_VINT0      25 /* DM642 */
N    #define IRQ_EVT_VINT1      26 /* DM642 */
N    #define IRQ_EVT_VINT2      27 /* DM642 */
N    #define IRQ_EVT_AXINT0     28 /* 6713 / DM642 */
N    #define IRQ_EVT_ARINT0     29 /* 6713 / DM642 */
N    #define IRQ_EVT_AXINT3     IRQ_EVT_EXTINT4 /* 6713 */
N    #define IRQ_EVT_ARINT3     IRQ_EVT_EXTINT5 /* 6713 */
N    #define IRQ_EVT_VCPINT     30
N    #define IRQ_EVT_AXINT1     30 /* 6713 */
N
N    #define IRQ_EVT_AXINT2     30 /* 6713 */
N    #define IRQ_EVT_AXINT4     IRQ_EVT_EXTINT6
N    #define IRQ_EVT_TCPINT     31
N    #define IRQ_EVT_ARINT1     31 /* 6713 */
N
N    #define IRQ_EVT_ARINT2     31 /* 6713 */
N    #define IRQ_EVT_ARINT4     IRQ_EVT_EXTINT7
N
N  #endif
N
N#endif
N/* interrupt masks */
N#define IRQ_MASK_NA 0x00000000
N#define IRQ_MASK_00 0x00000001
N#define IRQ_MASK_01 0x00000002
N#define IRQ_MASK_02 0x00000004
N#define IRQ_MASK_03 0x00000008
N#define IRQ_MASK_04 0x00000010
N#define IRQ_MASK_05 0x00000020
N#define IRQ_MASK_06 0x00000040
N#define IRQ_MASK_07 0x00000080
N#define IRQ_MASK_08 0x00000100
N#define IRQ_MASK_09 0x00000200
N#define IRQ_MASK_10 0x00000400
N#define IRQ_MASK_11 0x00000800
N#define IRQ_MASK_12 0x00001000
N#define IRQ_MASK_13 0x00002000
N#define IRQ_MASK_14 0x00004000
N#define IRQ_MASK_15 0x00008000
N
N/* defines used with the dispatcher functions */
N#define IRQ_CCMASK_NONE        0x00000001u
N#define IRQ_CCMASK_PCC_MAPPED  0x00000000u
N#define IRQ_CCMASK_PCC_ENABLE  0x00000040u
N#define IRQ_CCMASK_PCC_FREEZE  0x00000060u
N#define IRQ_CCMASK_PCC_BYPASS  0x00000080u
N#define IRQ_CCMASK_DCC_MAPPED  0x00000000u
N#define IRQ_CCMASK_DCC_ENABLE  0x00000008u
N#define IRQ_CCMASK_DCC_FREEZE  0x0000000Cu
N#define IRQ_CCMASK_DCC_BYPASS  0x00000010u
N#define IRQ_CCMASK_DEFAULT     IRQ_CCMASK_NONE
N#define IRQ_IEMASK_SELF        0x80000000u
N#define IRQ_IEMASK_ALL         0x0000FFFFu
N#define IRQ_IEMASK_DEFAULT     IRQ_IEMASK_SELF
N
N
N/* private stuff */
N#define _IRQ_DISPATCHTABLE_CNT   (IRQ_INT_CNT)
N#define _IRQ_EVENT2INTTABLE_CNT  (IRQ_EVENT_CNT+1)
N#define _IRQ_INT2EVENTTABLE_CNT  (IRQ_INT_CNT)
N
N
N/******************************************************************************\
N* global typedef declarations
X
N\******************************************************************************/
Ntypedef struct {
N  void   *funcAddr;
N  Uint32 ieMask;
N  Uint32 ccMask;
N  Uint32 funcArg;
N} _IRQ_Dispatch;
N
Ntypedef struct {
N  void   *funcAddr;
N  Uint32 funcArg;
N  Uint32 ccMask;
N  Uint32 ieMask;
N} IRQ_Config;
N
N
N/******************************************************************************\
N* global variable declarations
X
N\******************************************************************************/
N
N/* private vars */
Nextern far Uint32 _IRQ_eventTable[IRQ_EVENT_CNT+1];
Xextern far Uint32 _IRQ_eventTable[32+1];
Nextern far Uint32 _IRQ_intTable[IRQ_INT_CNT];
Xextern far Uint32 _IRQ_intTable[16];
Nextern far _IRQ_Dispatch _IRQ_internalDispatchTable[_IRQ_DISPATCHTABLE_CNT];
Xextern far _IRQ_Dispatch _IRQ_internalDispatchTable[(16)];
Nextern far _IRQ_Dispatch *_IRQ_dispatchTable;
N
N/******************************************************************************\
N* global function declarations
X
N\******************************************************************************/
N
N/* private functions */
NCSLAPI void _IRQ_init(Uint32 biosPresent, _IRQ_Dispatch *dispatchTable);
Xextern far void _IRQ_init(Uint32 biosPresent, _IRQ_Dispatch *dispatchTable);
N
N/* API functions */
NCSLAPI void IRQ_map(Uint32 eventId, Uint32 intNumber);
Xextern far void IRQ_map(Uint32 eventId, Uint32 intNumber);
NCSLAPI void *IRQ_setVecs(void *vecs);
Xextern far void *IRQ_setVecs(void *vecs);
NCSLAPI Uint32 IRQ_biosPresent();
Xextern far Uint32 IRQ_biosPresent();
NCSLAPI void IRQ_hook(int intNum, void *func);
Xextern far void IRQ_hook(int intNum, void *func);
N
N/* These functions only work with the DSP/BIOS HWI dispatcher */
NCSLAPI void IRQ_config(Uint32 eventId, IRQ_Config *config);
Xextern far void IRQ_config(Uint32 eventId, IRQ_Config *config);
NCSLAPI void IRQ_configArgs(Uint32 eventId, void *funcAddr, Uint32 funcArg,
Xextern far void IRQ_configArgs(Uint32 eventId, void *funcAddr, Uint32 funcArg,
N  Uint32 ccMask, Uint32 ieMask);
NCSLAPI void IRQ_getConfig(Uint32 eventId, IRQ_Config *config);
Xextern far void IRQ_getConfig(Uint32 eventId, IRQ_Config *config);
NCSLAPI Uint32 IRQ_getArg(Uint32 eventId);
Xextern far Uint32 IRQ_getArg(Uint32 eventId);
NCSLAPI void IRQ_setArg(Uint32 eventId, Uint32 arg);
Xextern far void IRQ_setArg(Uint32 eventId, Uint32 arg);
N
N
N/******************************************************************************\
N* inline function declarations
X
N\******************************************************************************/
NIDECL void IRQ_enable(Uint32 eventId);
Xextern far void IRQ_enable(Uint32 eventId);
NIDECL Uint32 IRQ_disable(Uint32 eventId);
Xextern far Uint32 IRQ_disable(Uint32 eventId);
NIDECL void IRQ_restore(Uint32 eventId, Uint32 ie);
Xextern far void IRQ_restore(Uint32 eventId, Uint32 ie);
NIDECL void IRQ_set(Uint32 eventId);
Xextern far void IRQ_set(Uint32 eventId);
NIDECL void IRQ_clear(Uint32 eventId);
Xextern far void IRQ_clear(Uint32 eventId);
NIDECL Uint32 IRQ_test(Uint32 eventId);
Xextern far Uint32 IRQ_test(Uint32 eventId);
NIDECL void IRQ_reset(Uint32 eventId);
Xextern far void IRQ_reset(Uint32 eventId);
NIDECL void IRQ_resetAll();
Xextern far void IRQ_resetAll();
N
NIDECL void IRQ_globalEnable();
Xextern far void IRQ_globalEnable();
NIDECL Uint32 IRQ_globalDisable();
Xextern far Uint32 IRQ_globalDisable();
NIDECL void IRQ_globalRestore(Uint32 gie);
Xextern far void IRQ_globalRestore(Uint32 gie);
N
NIDECL void IRQ_nmiEnable();
Xextern far void IRQ_nmiEnable();
NIDECL void IRQ_nmiDisable();
Xextern far void IRQ_nmiDisable();
N
N
N/******************************************************************************\
N* inline function definitions
X
N\******************************************************************************/
N#ifdef USEDEFS
S/*----------------------------------------------------------------------------*/
SIDEF void IRQ_enable(Uint32 eventId) {
S  IER |= _IRQ_eventTable[eventId];
S}
S/*----------------------------------------------------------------------------*/
SIDEF Uint32 IRQ_disable(Uint32 eventId) {
S  Uint32 ie = IER & _IRQ_eventTable[eventId];
S  IER &= ~_IRQ_eventTable[eventId];
S  return ie;
S}
S/*----------------------------------------------------------------------------*/
SIDEF void IRQ_restore(Uint32 eventId, Uint32 ie) {
S  if (ie) {
S    IER |= _IRQ_eventTable[eventId];
S  } else {
S    IER &= ~_IRQ_eventTable[eventId];
S  }
S}
S/*----------------------------------------------------------------------------*/
SIDEF void IRQ_set(Uint32 eventId) {
S  ISR = _IRQ_eventTable[eventId];
S}
S/*----------------------------------------------------------------------------*/
SIDEF void IRQ_clear(Uint32 eventId) {
S  ICR = _IRQ_eventTable[eventId];
S}
S/*----------------------------------------------------------------------------*/
SIDEF Uint32 IRQ_test(Uint32 eventId) {
S  return (Uint32)((IFR & _IRQ_eventTable[eventId]) ? 1 : 0);
S}
S/*----------------------------------------------------------------------------*/
SIDEF void IRQ_globalEnable() {
S  CHIP_FSET(CSR,GIE,1);
S}
S/*----------------------------------------------------------------------------*/
SIDEF Uint32 IRQ_globalDisable() {
S  Uint32 gie = CHIP_FGET(CSR,GIE);
S  CHIP_FSET(CSR,GIE,0);
S  return gie;
S}
S/*----------------------------------------------------------------------------*/
SIDEF void IRQ_globalRestore(Uint32 gie) {
S  CHIP_FSET(CSR,GIE,gie);
S}
S/*----------------------------------------------------------------------------*/
SIDEF void IRQ_reset(Uint32 eventId) {
S  IER &= ~_IRQ_eventTable[eventId];
S  ICR = _IRQ_eventTable[eventId];
S}
S/*----------------------------------------------------------------------------*/
SIDEF void IRQ_resetAll() {
S  CHIP_FSET(CSR,GIE,0);
S  CHIP_CRSET(IER,0x00000000);
S  CHIP_CRSET(ICR,0xFFFFFFFF);
S}
S/*----------------------------------------------------------------------------*/
SIDEF void IRQ_nmiEnable() {
S  IER |= 0x00000002;
S}
S/*----------------------------------------------------------------------------*/
SIDEF void IRQ_nmiDisable() {
S  IER &= ~0x00000002;
S}
S/*----------------------------------------------------------------------------*/
N#endif /* USEDEFS */
N
N
N#endif /* IRQ_SUPPORT */
N#endif /* _CSL_IRQ_H_ */
N/******************************************************************************\
N* End of csl_irq.h
X
N\******************************************************************************/
N
L 16 "E:/TI_workspase/c6701_t/csl/csl_i2c.h" 2
N#include <csl_i2chal.h>
L 1 "E:/TI_workspase/c6701_t/csl/csl_i2chal.h" 1
N/******************************************************************************\
N*           Copyright (C) 1999-2000 Texas Instruments Incorporated.
X
N*                           All Rights Reserved
N*------------------------------------------------------------------------------
N* FILENAME...... csl_i2chal.h
N* DATE CREATED.. 10/02/2001 
N* LAST MODIFIED. 08/02/2004 - Adding support for C6418
N*                11/19/2001    register renaming 
N*                11/09/2001    update bit field names 
N*                07/02/2003    update to latest spec.
N*------------------------------------------------------------------------------
N* REGISTERS
N*
N* I2COAR0    - I2C0 Own Address register
N* I2COAR1    - I2C1 Own Address register
N* I2CIER0    - I2C0 Interrupt Mask/Status register
N* I2CIER1    - I2C1 Interrupt Mask/Status register
N* I2CSTR0    - I2C0 Interrupt Status register
N* I2CSTR1    - I2C1 Interrupt Status register
N* I2CCLKL0   - I2C0 Clock Divider Low register
N* I2CCLKL1   - I2C1 Clock Divider Low register
N* I2CCLKH0   - I2C0 Clock Divider High register
N* I2CCLKH1   - I2C1 Clock Divider High register
N* I2CCNT0    - I2C0 Data Count register
N* I2CCNT1    - I2C1 Data Count register
N* I2CDRR0    - I2C0 Data Receive register
N* I2CDRR1    - I2C1 Data Receive register
N* I2CSAR0    - I2C0 Slave Address register
N* I2CSAR1    - I2C1 Slave Address register
N* I2CDXR0    - I2C0 Data Transmit register
N* I2CDXR1    - I2C1 Data Transmit register
N* I2CMDR0    - I2C0 Mode register
N* I2CMDR1    - I2C1 Mode register
N* I2CISRC0    - I2C0 Interrupt Vector register
N* I2CISRC1    - I2C1 Interrupt Vector register
N* I2CEMDR0   - I2C0 Extended Mode register(1)
N* I2CEMDR1   - I2C1 Extended Mode register(1)
N* I2CPSC0    - I2C0 Prescaler register
N* I2CPSC1    - I2C1 Prescaler register
N* I2CPID10   - I2C0 Peripheral ID register 1(1)
N* I2CPID11   - I2C1 Peripheral ID register 1(1)
N* I2CPID20   - I2C0 Peripheral ID register 2(1)
N* I2CPID21   - I2C1 Peripheral ID register 2(1)
N* I2CPFUNC0  - I2C0 Peripheral Functional register(1)
N* I2CPFUNC1  - I2C1 Peripheral Functional register(1)
N* I2CPDIR0   - I2C0 Pin Direction register(1)
N* I2CPDIR1   - I2C1 Pin Direction register(1)
N* I2CPDIN0   - I2C0 Pin Data In register(1)
N* I2CPDIN1   - I2C1 Pin Data In register(1)
N* I2CPDOUT0  - I2C0 Pin Data Out register(1)
N* I2CPDOUT1  - I2C1 Pin Data Out register(1)
N* I2CPDSET0  - I2C0 Pin Data Set register(1)
N* I2CPDSET1  - I2C1 Pin Data Set register(1)
N* I2CPDCLR0  - I2C0 Pin Data Clear register(1)
N* I2CPDCLR1  - I2C1 Pin Data Clear register(1)
N*
N* (1) For C6418/C6413/C6410 only
N\******************************************************************************/
N#ifndef _CSL_I2CHAL_H_
N#define _CSL_I2CHAL_H_
N
N#include <csl_stdinc.h>
N#include <csl_chip.h>
N#if (I2C_SUPPORT)
X#if (( ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*1) | ( 0*0) | ( 0*0) | ( 1*0) | ( 1*0)| ( 1*0)| ( 1*0)| ( 1*0)| ( 1*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 1*0) | ( 1*0) | ( 1*0) | ( 0*0) ))
S/******************************************************************************\
S* MISC section
X
S\******************************************************************************/
S#if (CHIP_6713 | CHIP_DA610 | CHIP_6413 | CHIP_6418 | CHIP_6410)
S  #define _I2C_PORT_CNT        2
S  #define _I2C_BASE_PORT0      0x01B40000u
S  #define _I2C_BASE_PORT1      0x01B44000u
S#endif
S
S#if (CHIP_DM642 | CHIP_DM641 | CHIP_DM640 | CHIP_6412)
S  #define _I2C_PORT_CNT        1
S  #define _I2C_BASE_PORT0      0x01B40000u
S#endif
S 
S
S/******************************************************************************\
S* module level register/field access macros
X
S\******************************************************************************/
S
S  /* ----------------- */
S  /* FIELD MAKE MACROS */
S  /* ----------------- */
S
S  #define I2C_FMK(REG,FIELD,x)\
S    _PER_FMK(I2C,##REG,##FIELD,x)
X  #define I2C_FMK(REG,FIELD,x)    _PER_FMK(I2C,##REG,##FIELD,x)
S
S  #define I2C_FMKS(REG,FIELD,SYM)\
S    _PER_FMKS(I2C,##REG,##FIELD,##SYM)
X  #define I2C_FMKS(REG,FIELD,SYM)    _PER_FMKS(I2C,##REG,##FIELD,##SYM)
S
S
S  /* -------------------------------- */
S  /* RAW REGISTER/FIELD ACCESS MACROS */
S  /* -------------------------------- */
S
S  #define I2C_ADDR(REG)\
S    _I2C_##REG##_ADDR
X  #define I2C_ADDR(REG)    _I2C_##REG##_ADDR
S
S  #define I2C_RGET(REG)\
S    _PER_RGET(_I2C_##REG##_ADDR,I2C,##REG)
X  #define I2C_RGET(REG)    _PER_RGET(_I2C_##REG##_ADDR,I2C,##REG)
S
S  #define I2C_RSET(REG,x)\
S    _PER_RSET(_I2C_##REG##_ADDR,I2C,##REG,x)
X  #define I2C_RSET(REG,x)    _PER_RSET(_I2C_##REG##_ADDR,I2C,##REG,x)
S
S  #define I2C_FGET(REG,FIELD)\
S    _I2C_##REG##_FGET(##FIELD)
X  #define I2C_FGET(REG,FIELD)    _I2C_##REG##_FGET(##FIELD)
S
S  #define I2C_FSET(REG,FIELD,x)\
S    _I2C_##REG##_FSET(##FIELD,##x)
X  #define I2C_FSET(REG,FIELD,x)    _I2C_##REG##_FSET(##FIELD,##x)
S
S  #define I2C_FSETS(REG,FIELD,SYM)\
S    _I2C_##REG##_FSETS(##FIELD,##SYM)
X  #define I2C_FSETS(REG,FIELD,SYM)    _I2C_##REG##_FSETS(##FIELD,##SYM)
S
S
S  /* ------------------------------------------ */
S  /* ADDRESS BASED REGISTER/FIELD ACCESS MACROS */
S  /* ------------------------------------------ */
S
S  #define I2C_RGETA(addr,REG)\
S    _PER_RGET(addr,I2C,##REG)
X  #define I2C_RGETA(addr,REG)    _PER_RGET(addr,I2C,##REG)
S
S  #define I2C_RSETA(addr,REG,x)\
S    _PER_RSET(addr,I2C,##REG,x)
X  #define I2C_RSETA(addr,REG,x)    _PER_RSET(addr,I2C,##REG,x)
S
S  #define I2C_FGETA(addr,REG,FIELD)\
S    _PER_FGET(addr,I2C,##REG,##FIELD)
X  #define I2C_FGETA(addr,REG,FIELD)    _PER_FGET(addr,I2C,##REG,##FIELD)
S
S  #define I2C_FSETA(addr,REG,FIELD,x)\
S    _PER_FSET(addr,I2C,##REG,##FIELD,x)
X  #define I2C_FSETA(addr,REG,FIELD,x)    _PER_FSET(addr,I2C,##REG,##FIELD,x)
S
S  #define I2C_FSETSA(addr,REG,FIELD,SYM)\
S    _PER_FSETS(addr,I2C,##REG,##FIELD,##SYM)
X  #define I2C_FSETSA(addr,REG,FIELD,SYM)    _PER_FSETS(addr,I2C,##REG,##FIELD,##SYM)
S
S
S  /* ----------------------------------------- */
S  /* HANDLE BASED REGISTER/FIELD ACCESS MACROS */
S  /* ----------------------------------------- */
S
S  #define I2C_ADDRH(h,REG)\
S    (Uint32)(&((h)->baseAddr[_I2C_##REG##_OFFSET]))
X  #define I2C_ADDRH(h,REG)    (Uint32)(&((h)->baseAddr[_I2C_##REG##_OFFSET]))
S
S  #define I2C_RGETH(h,REG)\
S    I2C_RGETA(I2C_ADDRH(h,##REG),##REG)
X  #define I2C_RGETH(h,REG)    I2C_RGETA(I2C_ADDRH(h,##REG),##REG)
S
S
S  #define I2C_RSETH(h,REG,x)\
S    I2C_RSETA(I2C_ADDRH(h,##REG),##REG,x)
X  #define I2C_RSETH(h,REG,x)    I2C_RSETA(I2C_ADDRH(h,##REG),##REG,x)
S
S
S  #define I2C_FGETH(h,REG,FIELD)\
S    I2C_FGETA(I2C_ADDRH(h,##REG),##REG,##FIELD)
X  #define I2C_FGETH(h,REG,FIELD)    I2C_FGETA(I2C_ADDRH(h,##REG),##REG,##FIELD)
S
S
S  #define I2C_FSETH(h,REG,FIELD,x)\
S    I2C_FSETA(I2C_ADDRH(h,##REG),##REG,##FIELD,x)
X  #define I2C_FSETH(h,REG,FIELD,x)    I2C_FSETA(I2C_ADDRH(h,##REG),##REG,##FIELD,x)
S
S
S  #define I2C_FSETSH(h,REG,FIELD,SYM)\
S    I2C_FSETSA(I2C_ADDRH(h,##REG),##REG,##FIELD,##SYM)
X  #define I2C_FSETSH(h,REG,FIELD,SYM)    I2C_FSETSA(I2C_ADDRH(h,##REG),##REG,##FIELD,##SYM)
S
S
S
S/******************************************************************************\
S*  ___________________
X
S* |                   |
S* |  I 2 C O A R      |
S* |___________________|
S*
S* I2COAR0    - I2C0 Own Address register
S* I2COAR1    - I2C1 Own Address register
S*
S* FIELDS (msb -> lsb)
S* (rw) A
S*
S\******************************************************************************/
S  #define _I2C_I2COAR_OFFSET           0
S
S  #define _I2C_I2COAR0_ADDR            0x01B40000
S  #define _I2C_I2COAR1_ADDR            0x01B44000
S
S  #define _I2C_I2COAR_A_MASK          0x000003FFu 
S  #define _I2C_I2COAR_A_SHIFT         0x00000000u
S  #define  I2C_I2COAR_A_DEFAULT       0x00000000u
S  #define  I2C_I2COAR_A_OF(x)         _VALUEOF(x)
S
S  #define  I2C_I2COAR_OF(x)             _VALUEOF(x)
S
S  #define I2C_I2COAR_DEFAULT (Uint32)(\
S     _PER_FDEFAULT(I2C,I2COAR,A)\
S  )
X  #define I2C_I2COAR_DEFAULT (Uint32)(     _PER_FDEFAULT(I2C,I2COAR,A)  )
S
S  #define I2C_I2COAR_RMK(a) (Uint32)(\
S     _PER_FMK(I2C,I2COAR,A,a)\
S  )
X  #define I2C_I2COAR_RMK(a) (Uint32)(     _PER_FMK(I2C,I2COAR,A,a)  )
S   
S  #define _I2C_I2COAR_FGET(N,FIELD)\
S    _PER_FGET(_I2C_I2COAR##N##_ADDR,I2C,I2COAR,##FIELD)
X  #define _I2C_I2COAR_FGET(N,FIELD)    _PER_FGET(_I2C_I2COAR##N##_ADDR,I2C,I2COAR,##FIELD)
S
S  #define _I2C_I2COAR_FSET(N,FIELD,field)\
S    _PER_FSET(_I2C_I2COAR##N##_ADDR,I2C,I2COAR,##FIELD,field)
X  #define _I2C_I2COAR_FSET(N,FIELD,field)    _PER_FSET(_I2C_I2COAR##N##_ADDR,I2C,I2COAR,##FIELD,field)
S
S  #define _I2C_I2COAR_FSETS(N,FIELD,SYM)\
S    _PER_FSETS(_I2C_I2COAR##N##_ADDR,I2C,I2COAR,##FIELD,##SYM)
X  #define _I2C_I2COAR_FSETS(N,FIELD,SYM)    _PER_FSETS(_I2C_I2COAR##N##_ADDR,I2C,I2COAR,##FIELD,##SYM)
S
S  #define _I2C_I2COAR0_FGET(FIELD) _I2C_I2COAR_FGET(0,##FIELD)
S  #define _I2C_I2COAR1_FGET(FIELD) _I2C_I2COAR_FGET(1,##FIELD)
S
S  #define _I2C_I2COAR0_FSET(FIELD,f) _I2C_I2COAR_FSET(0,##FIELD,f)
S  #define _I2C_I2COAR1_FSET(FIELD,f) _I2C_I2COAR_FSET(1,##FIELD,f)
S
S  #define _I2C_I2COAR0_FSETS(FIELD,SYM) _I2C_I2COAR_FSETS(0,##FIELD,##SYM)
S  #define _I2C_I2COAR1_FSETS(FIELD,SYM) _I2C_I2COAR_FSETS(1,##FIELD,##SYM)
S
S/******************************************************************************\
S*  (Keeping the old definitions for backward compatibility)
X
S*  ___________________
S* |                   |
S* |  I 2 C I M R      |
S* |___________________|
S*
S* I2CIMR0    - I2C0 Interrupt Mask/Status register
S* I2CIMR1    - I2C1 Interrupt Mask/Status register
S*
S* FIELDS (msb -> lsb)
S* (rw) ICXRDY
S* (rw) ICRRDY
S* (rw) ARDY
S* (rw) NACK
S* (rw) AL
S\******************************************************************************/
S#if (!(CHIP_6410 | CHIP_6413| CHIP_6418 ))
S
S  #define _I2C_I2CIMR_OFFSET           1
S
S  #define _I2C_I2CIMR0_ADDR            0x01B40004
S  #define _I2C_I2CIMR1_ADDR            0x01B44004
S
S  #define _I2C_I2CIMR_ICXRDY_MASK          0x00000010u
S  #define _I2C_I2CIMR_ICXRDY_SHIFT         0x00000004u
S  #define  I2C_I2CIMR_ICXRDY_DEFAULT       0x00000000u
S  #define  I2C_I2CIMR_ICXRDY_OF(x)         _VALUEOF(x)
S  #define  I2C_I2CIMR_ICXRDY_MSK           0x00000000u
S  #define  I2C_I2CIMR_ICXRDY_UNMSK         0x00000001u
S
S  #define _I2C_I2CIMR_ICRRDY_MASK          0x00000008u
S  #define _I2C_I2CIMR_ICRRDY_SHIFT         0x00000003u
S  #define  I2C_I2CIMR_ICRRDY_DEFAULT       0x00000000u
S  #define  I2C_I2CIMR_ICRRDY_OF(x)         _VALUEOF(x)
S  #define  I2C_I2CIMR_ICRRDY_MSK           0x00000000u
S  #define  I2C_I2CIMR_ICRRDY_UNMSK         0x00000001u
S
S  #define _I2C_I2CIMR_ARDY_MASK            0x00000004u
S  #define _I2C_I2CIMR_ARDY_SHIFT           0x00000002u
S  #define  I2C_I2CIMR_ARDY_DEFAULT         0x00000000u
S  #define  I2C_I2CIMR_ARDY_OF(x)           _VALUEOF(x)
S  #define  I2C_I2CIMR_ARDY_MSK             0x00000000u
S  #define  I2C_I2CIMR_ARDY_UNMSK           0x00000001u
S
S  #define _I2C_I2CIMR_NACK_MASK            0x00000002u
S  #define _I2C_I2CIMR_NACK_SHIFT           0x00000001u
S  #define  I2C_I2CIMR_NACK_DEFAULT         0x00000000u
S  #define  I2C_I2CIMR_NACK_OF(x)           _VALUEOF(x)
S  #define  I2C_I2CIMR_NACK_MSK             0x00000000u
S  #define  I2C_I2CIMR_NACK_UNMSK           0x00000001u
S
S  #define _I2C_I2CIMR_AL_MASK              0x00000001u
S  #define _I2C_I2CIMR_AL_SHIFT             0x00000000u
S  #define  I2C_I2CIMR_AL_DEFAULT           0x00000000u
S  #define  I2C_I2CIMR_AL_OF(x)             _VALUEOF(x)
S  #define  I2C_I2CIMR_AL_MSK               0x00000000u
S  #define  I2C_I2CIMR_AL_UNMSK             0x00000001u
S
S
S  #define  I2C_I2CIMR_OF(x)                _VALUEOF(x)
S
S  #define I2C_I2CIMR_DEFAULT (Uint32)(\
S      _PER_FDEFAULT(I2C,I2CIMR,ICXRDY)\
S     |_PER_FDEFAULT(I2C,I2CIMR,ICRRDY)\
S     |_PER_FDEFAULT(I2C,I2CIMR,ARDY)\
S     |_PER_FDEFAULT(I2C,I2CIMR,NACK)\
S     |_PER_FDEFAULT(I2C,I2CIMR,AL)\
S  )
X  #define I2C_I2CIMR_DEFAULT (Uint32)(      _PER_FDEFAULT(I2C,I2CIMR,ICXRDY)     |_PER_FDEFAULT(I2C,I2CIMR,ICRRDY)     |_PER_FDEFAULT(I2C,I2CIMR,ARDY)     |_PER_FDEFAULT(I2C,I2CIMR,NACK)     |_PER_FDEFAULT(I2C,I2CIMR,AL)  )
S
S  #define I2C_I2CIMR_RMK(icxrdy,icrrdy,ardy,nack,al) (Uint32)(\
S      _PER_FMK(I2C,I2CIMR,ICXRDY,icxrdy)\
S     |_PER_FMK(I2C,I2CIMR,ICRRDY,icrrdy)\
S     |_PER_FMK(I2C,I2CIMR,ARDY,ardy)\
S     |_PER_FMK(I2C,I2CIMR,NACK,nack)\
S     |_PER_FMK(I2C,I2CIMR,AL,al)\
S  )
X  #define I2C_I2CIMR_RMK(icxrdy,icrrdy,ardy,nack,al) (Uint32)(      _PER_FMK(I2C,I2CIMR,ICXRDY,icxrdy)     |_PER_FMK(I2C,I2CIMR,ICRRDY,icrrdy)     |_PER_FMK(I2C,I2CIMR,ARDY,ardy)     |_PER_FMK(I2C,I2CIMR,NACK,nack)     |_PER_FMK(I2C,I2CIMR,AL,al)  )
S  
S   
S  #define _I2C_I2CIMR_FGET(N,FIELD)\
S    _PER_FGET(_I2C_I2CIMR##N##_ADDR,I2C,I2CIMR,##FIELD)
X  #define _I2C_I2CIMR_FGET(N,FIELD)    _PER_FGET(_I2C_I2CIMR##N##_ADDR,I2C,I2CIMR,##FIELD)
S
S  #define _I2C_I2CIMR_FSET(N,FIELD,field)\
S    _PER_FSET(_I2C_I2CIMR##N##_ADDR,I2C,I2CIMR,##FIELD,field)
X  #define _I2C_I2CIMR_FSET(N,FIELD,field)    _PER_FSET(_I2C_I2CIMR##N##_ADDR,I2C,I2CIMR,##FIELD,field)
S
S  #define _I2C_I2CIMR_FSETS(N,FIELD,SYM)\
S    _PER_FSETS(_I2C_I2CIMR##N##_ADDR,I2C,I2CIMR,##FIELD,##SYM)
X  #define _I2C_I2CIMR_FSETS(N,FIELD,SYM)    _PER_FSETS(_I2C_I2CIMR##N##_ADDR,I2C,I2CIMR,##FIELD,##SYM)
S
S  #define _I2C_I2CIMR0_FGET(FIELD) _I2C_I2CIMR_FGET(0,##FIELD)
S  #define _I2C_I2CIMR1_FGET(FIELD) _I2C_I2CIMR_FGET(1,##FIELD)
S
S  #define _I2C_I2CIMR0_FSET(FIELD,f) _I2C_I2CIMR_FSET(0,##FIELD,f)
S  #define _I2C_I2CIMR1_FSET(FIELD,f) _I2C_I2CIMR_FSET(1,##FIELD,f)
S
S  #define _I2C_I2CIMR0_FSETS(FIELD,SYM) _I2C_I2CIMR_FSETS(0,##FIELD,##SYM)
S  #define _I2C_I2CIMR1_FSETS(FIELD,SYM) _I2C_I2CIMR_FSETS(1,##FIELD,##SYM)
S#endif
S
S/******************************************************************************\
S*  ___________________
X
S* |                   |
S* |  I 2 C I E R      |
S* |___________________|
S*
S* I2CIER0    - I2C0 Interrupt Mask/Status register
S* I2CIER1    - I2C1 Interrupt Mask/Status register
S*
S* FIELDS (msb -> lsb)
S* (rw) AAS(1)
S* (rw) SCD(1)
S* (rw) ICXRDY
S* (rw) ICRRDY
S* (rw) ARDY
S* (rw) NACK
S* (rw) AL
S*
S*  (1) For  C6418/C6413/C6410 only
S\******************************************************************************/
S  #define _I2C_I2CIER_OFFSET           1
S
S  #define _I2C_I2CIER0_ADDR            0x01B40004
S  #define _I2C_I2CIER1_ADDR            0x01B44004
S
S#if (CHIP_6413 | CHIP_6418 | CHIP_6410)
S  #define _I2C_I2CIER_AAS_MASK             0x00000040u
S  #define _I2C_I2CIER_AAS_SHIFT            0x00000006u
S  #define  I2C_I2CIER_AAS_DEFAULT          0x00000000u
S  #define  I2C_I2CIER_AAS_OF(x)            _VALUEOF(x)
S  #define  I2C_I2CIER_AAS_MSK              0x00000000u
S  #define  I2C_I2CIER_AAS_UNMSK            0x00000001u
S
S  #define _I2C_I2CIER_SCD_MASK             0x00000020u
S  #define _I2C_I2CIER_SCD_SHIFT            0x00000005u
S  #define  I2C_I2CIER_SCD_DEFAULT          0x00000000u
S  #define  I2C_I2CIER_SCD_OF(x)            _VALUEOF(x)
S  #define  I2C_I2CIER_SCD_MSK              0x00000000u
S  #define  I2C_I2CIER_SCD_UNMSK            0x00000001u
S#endif
S
S  #define _I2C_I2CIER_ICXRDY_MASK          0x00000010u
S  #define _I2C_I2CIER_ICXRDY_SHIFT         0x00000004u
S  #define  I2C_I2CIER_ICXRDY_DEFAULT       0x00000000u
S  #define  I2C_I2CIER_ICXRDY_OF(x)         _VALUEOF(x)
S  #define  I2C_I2CIER_ICXRDY_MSK           0x00000000u
S  #define  I2C_I2CIER_ICXRDY_UNMSK         0x00000001u
S
S  #define _I2C_I2CIER_ICRRDY_MASK          0x00000008u
S  #define _I2C_I2CIER_ICRRDY_SHIFT         0x00000003u
S  #define  I2C_I2CIER_ICRRDY_DEFAULT       0x00000000u
S  #define  I2C_I2CIER_ICRRDY_OF(x)         _VALUEOF(x)
S  #define  I2C_I2CIER_ICRRDY_MSK           0x00000000u
S  #define  I2C_I2CIER_ICRRDY_UNMSK         0x00000001u
S
S  #define _I2C_I2CIER_ARDY_MASK            0x00000004u
S  #define _I2C_I2CIER_ARDY_SHIFT           0x00000002u
S  #define  I2C_I2CIER_ARDY_DEFAULT         0x00000000u
S  #define  I2C_I2CIER_ARDY_OF(x)           _VALUEOF(x)
S  #define  I2C_I2CIER_ARDY_MSK             0x00000000u
S  #define  I2C_I2CIER_ARDY_UNMSK           0x00000001u
S
S  #define _I2C_I2CIER_NACK_MASK            0x00000002u
S  #define _I2C_I2CIER_NACK_SHIFT           0x00000001u
S  #define  I2C_I2CIER_NACK_DEFAULT         0x00000000u
S  #define  I2C_I2CIER_NACK_OF(x)           _VALUEOF(x)
S  #define  I2C_I2CIER_NACK_MSK             0x00000000u
S  #define  I2C_I2CIER_NACK_UNMSK           0x00000001u
S
S  #define _I2C_I2CIER_AL_MASK              0x00000001u
S  #define _I2C_I2CIER_AL_SHIFT             0x00000000u
S  #define  I2C_I2CIER_AL_DEFAULT           0x00000000u
S  #define  I2C_I2CIER_AL_OF(x)             _VALUEOF(x)
S  #define  I2C_I2CIER_AL_MSK               0x00000000u
S  #define  I2C_I2CIER_AL_UNMSK             0x00000001u
S
S
S  #define  I2C_I2CIER_OF(x)                _VALUEOF(x)
S
S#if (!(CHIP_6413 | CHIP_6418 | CHIP_6410))
S  #define I2C_I2CIER_DEFAULT (Uint32)(\
S      _PER_FDEFAULT(I2C,I2CIER,ICXRDY)\
S     |_PER_FDEFAULT(I2C,I2CIER,ICRRDY)\
S     |_PER_FDEFAULT(I2C,I2CIER,ARDY)\
S     |_PER_FDEFAULT(I2C,I2CIER,NACK)\
S     |_PER_FDEFAULT(I2C,I2CIER,AL)\
S  )
X  #define I2C_I2CIER_DEFAULT (Uint32)(      _PER_FDEFAULT(I2C,I2CIER,ICXRDY)     |_PER_FDEFAULT(I2C,I2CIER,ICRRDY)     |_PER_FDEFAULT(I2C,I2CIER,ARDY)     |_PER_FDEFAULT(I2C,I2CIER,NACK)     |_PER_FDEFAULT(I2C,I2CIER,AL)  )
S
S  #define I2C_I2CIER_RMK(icxrdy,icrrdy,ardy,nack,al) (Uint32)(\
S      _PER_FMK(I2C,I2CIER,ICXRDY,icxrdy)\
S     |_PER_FMK(I2C,I2CIER,ICRRDY,icrrdy)\
S     |_PER_FMK(I2C,I2CIER,ARDY,ardy)\
S     |_PER_FMK(I2C,I2CIER,NACK,nack)\
S     |_PER_FMK(I2C,I2CIER,AL,al)\
S  )
X  #define I2C_I2CIER_RMK(icxrdy,icrrdy,ardy,nack,al) (Uint32)(      _PER_FMK(I2C,I2CIER,ICXRDY,icxrdy)     |_PER_FMK(I2C,I2CIER,ICRRDY,icrrdy)     |_PER_FMK(I2C,I2CIER,ARDY,ardy)     |_PER_FMK(I2C,I2CIER,NACK,nack)     |_PER_FMK(I2C,I2CIER,AL,al)  )
S#else
S  #define I2C_I2CIER_DEFAULT (Uint32)(\
S      _PER_FDEFAULT(I2C,I2CIER,AAS)\
S     |_PER_FDEFAULT(I2C,I2CIER,SCD)\
S     |_PER_FDEFAULT(I2C,I2CIER,ICXRDY)\
S     |_PER_FDEFAULT(I2C,I2CIER,ICRRDY)\
S     |_PER_FDEFAULT(I2C,I2CIER,ARDY)\
S     |_PER_FDEFAULT(I2C,I2CIER,NACK)\
S     |_PER_FDEFAULT(I2C,I2CIER,AL)\
S  )
X  #define I2C_I2CIER_DEFAULT (Uint32)(      _PER_FDEFAULT(I2C,I2CIER,AAS)     |_PER_FDEFAULT(I2C,I2CIER,SCD)     |_PER_FDEFAULT(I2C,I2CIER,ICXRDY)     |_PER_FDEFAULT(I2C,I2CIER,ICRRDY)     |_PER_FDEFAULT(I2C,I2CIER,ARDY)     |_PER_FDEFAULT(I2C,I2CIER,NACK)     |_PER_FDEFAULT(I2C,I2CIER,AL)  )
S
S  #define I2C_I2CIER_RMK(aas,scd,icxrdy,icrrdy,ardy,nack,al) (Uint32)(\
S      _PER_FMK(I2C,I2CIER,AAS,aas)\
S     |_PER_FMK(I2C,I2CIER,SCD,scd)\
S     |_PER_FMK(I2C,I2CIER,ICXRDY,icxrdy)\
S     |_PER_FMK(I2C,I2CIER,ICRRDY,icrrdy)\
S     |_PER_FMK(I2C,I2CIER,ARDY,ardy)\
S     |_PER_FMK(I2C,I2CIER,NACK,nack)\
S     |_PER_FMK(I2C,I2CIER,AL,al)\
S  )
X  #define I2C_I2CIER_RMK(aas,scd,icxrdy,icrrdy,ardy,nack,al) (Uint32)(      _PER_FMK(I2C,I2CIER,AAS,aas)     |_PER_FMK(I2C,I2CIER,SCD,scd)     |_PER_FMK(I2C,I2CIER,ICXRDY,icxrdy)     |_PER_FMK(I2C,I2CIER,ICRRDY,icrrdy)     |_PER_FMK(I2C,I2CIER,ARDY,ardy)     |_PER_FMK(I2C,I2CIER,NACK,nack)     |_PER_FMK(I2C,I2CIER,AL,al)  )
S#endif  
S   
S  #define _I2C_I2CIER_FGET(N,FIELD)\
S    _PER_FGET(_I2C_I2CIER##N##_ADDR,I2C,I2CIER,##FIELD)
X  #define _I2C_I2CIER_FGET(N,FIELD)    _PER_FGET(_I2C_I2CIER##N##_ADDR,I2C,I2CIER,##FIELD)
S
S  #define _I2C_I2CIER_FSET(N,FIELD,field)\
S    _PER_FSET(_I2C_I2CIER##N##_ADDR,I2C,I2CIER,##FIELD,field)
X  #define _I2C_I2CIER_FSET(N,FIELD,field)    _PER_FSET(_I2C_I2CIER##N##_ADDR,I2C,I2CIER,##FIELD,field)
S
S  #define _I2C_I2CIER_FSETS(N,FIELD,SYM)\
S    _PER_FSETS(_I2C_I2CIER##N##_ADDR,I2C,I2CIER,##FIELD,##SYM)
X  #define _I2C_I2CIER_FSETS(N,FIELD,SYM)    _PER_FSETS(_I2C_I2CIER##N##_ADDR,I2C,I2CIER,##FIELD,##SYM)
S
S  #define _I2C_I2CIER0_FGET(FIELD) _I2C_I2CIER_FGET(0,##FIELD)
S  #define _I2C_I2CIER1_FGET(FIELD) _I2C_I2CIER_FGET(1,##FIELD)
S
S  #define _I2C_I2CIER0_FSET(FIELD,f) _I2C_I2CIER_FSET(0,##FIELD,f)
S  #define _I2C_I2CIER1_FSET(FIELD,f) _I2C_I2CIER_FSET(1,##FIELD,f)
S
S  #define _I2C_I2CIER0_FSETS(FIELD,SYM) _I2C_I2CIER_FSETS(0,##FIELD,##SYM)
S  #define _I2C_I2CIER1_FSETS(FIELD,SYM) _I2C_I2CIER_FSETS(1,##FIELD,##SYM)
S
S/******************************************************************************\
S*  ___________________
X
S* |                   |
S* |  I 2 C S T R      |
S* |___________________|
S*
S* I2CSTR0    - I2C0 Interrupt Status register
S* I2CSTR1    - I2C1 Interrupt Status register
S*
S* FIELDS (msb -> lsb)
S* (rc)  SDIR(1)
S* (rc)  NACKSNT
S* (rc)  BB
S* (r)   RSFULL
S* (r)   XSMT
S* (r)   AAS
S* (r)   AD0
S* (rc)  SCD(1)
S* (rc)  ICXRDY
S* (rc)  ICRRDY
S* (rc)  ARDY
S* (rc)  NACK
S* (rc)  AL
S*
S* (1) For  C6418/C6413/C6410 only
S\******************************************************************************/
S  #define _I2C_I2CSTR_OFFSET                2
S
S  #define _I2C_I2CSTR0_ADDR                 0x01B40008
S  #define _I2C_I2CSTR1_ADDR                 0x01B44008
S
S#if (CHIP_6413 | CHIP_6418 | CHIP_6410)
S  #define _I2C_I2CSTR_SDIR_MASK             0x00004000u
S  #define _I2C_I2CSTR_SDIR_SHIFT            0x0000000Eu
S  #define  I2C_I2CSTR_SDIR_DEFAULT          0x00000000u
S  #define  I2C_I2CSTR_SDIR_OF(x)            _VALUEOF(x)
S  #define  I2C_I2CSTR_SDIR_NONE             0x00000000u
S  #define  I2C_I2CSTR_SDIR_INT              0x00000001u
S  #define  I2C_I2CSTR_SDIR_CLR              0x00000001u
S#endif
S
S  #define _I2C_I2CSTR_NACKSNT_MASK          0x00002000u
S  #define _I2C_I2CSTR_NACKSNT_SHIFT         0x0000000Du
S  #define  I2C_I2CSTR_NACKSNT_DEFAULT       0x00000000u
S  #define  I2C_I2CSTR_NACKSNT_OF(x)         _VALUEOF(x)
S  #define  I2C_I2CSTR_NACKSNT_NONE          0x00000000u
S  #define  I2C_I2CSTR_NACKSNT_INT           0x00000001u
S  #define  I2C_I2CSTR_NACKSNT_CLR           0x00000001u
S
S  #define _I2C_I2CSTR_BB_MASK               0x00001000u
S  #define _I2C_I2CSTR_BB_SHIFT              0x0000000Cu
S  #define  I2C_I2CSTR_BB_DEFAULT            0x00000000u
S  #define  I2C_I2CSTR_BB_OF(x)              _VALUEOF(x)
S  #define  I2C_I2CSTR_BB_NONE               0x00000000u
S  #define  I2C_I2CSTR_BB_INT                0x00000001u
S  #define  I2C_I2CSTR_BB_CLR                0x00000001u
S
S  #define _I2C_I2CSTR_RSFULL_MASK           0x00000800u
S  #define _I2C_I2CSTR_RSFULL_SHIFT          0x0000000Bu
S  #define  I2C_I2CSTR_RSFULL_DEFAULT        0x00000000u
S  #define  I2C_I2CSTR_RSFULL_OF(x)          _VALUEOF(x)
S  #define  I2C_I2CSTR_RSFULL_NONE           0x00000000u
S  #define  I2C_I2CSTR_RSFULL_INT            0x00000001u
S
S  #define _I2C_I2CSTR_XSMT_MASK             0x00000400u
S  #define _I2C_I2CSTR_XSMT_SHIFT            0x0000000Au
S  #define  I2C_I2CSTR_XSMT_DEFAULT          0x00000001u
S  #define  I2C_I2CSTR_XSMT_OF(x)            _VALUEOF(x)
S  #define  I2C_I2CSTR_XSMT_NONE             0x00000000u
S  #define  I2C_I2CSTR_XSMT_INT              0x00000001u
S
S  #define _I2C_I2CSTR_AAS_MASK              0x00000200u
S  #define _I2C_I2CSTR_AAS_SHIFT             0x00000009u
S  #define  I2C_I2CSTR_AAS_DEFAULT           0x00000000u
S  #define  I2C_I2CSTR_AAS_OF(x)             _VALUEOF(x)
S  #define  I2C_I2CSTR_AAS_NONE              0x00000000u
S  #define  I2C_I2CSTR_AAS_INT               0x00000001u
S
S  #define _I2C_I2CSTR_AD0_MASK              0x00000100u
S  #define _I2C_I2CSTR_AD0_SHIFT             0x00000008u
S  #define  I2C_I2CSTR_AD0_DEFAULT           0x00000000u
S  #define  I2C_I2CSTR_AD0_OF(x)             _VALUEOF(x)
S  #define  I2C_I2CSTR_AD0_NONE              0x00000000u
S  #define  I2C_I2CSTR_AD0_INT               0x00000001u
S
S#if (CHIP_6413 | CHIP_6418 | CHIP_6410)
S  #define _I2C_I2CSTR_SCD_MASK              0x00000020u
S  #define _I2C_I2CSTR_SCD_SHIFT             0x00000005u
S  #define  I2C_I2CSTR_SCD_DEFAULT           0x00000000u
S  #define  I2C_I2CSTR_SCD_OF(x)             _VALUEOF(x)
S  #define  I2C_I2CSTR_SCD_NONE              0x00000000u
S  #define  I2C_I2CSTR_SCD_INT               0x00000001u
S  #define  I2C_I2CSTR_SCD_CLR               0x00000001u
S#endif
S
S  #define _I2C_I2CSTR_ICXRDY_MASK           0x00000010u
S  #define _I2C_I2CSTR_ICXRDY_SHIFT          0x00000004u
S  #define  I2C_I2CSTR_ICXRDY_DEFAULT        0x00000001u
S  #define  I2C_I2CSTR_ICXRDY_OF(x)          _VALUEOF(x)
S  #define  I2C_I2CSTR_ICXRDY_NONE           0x00000000u
S  #define  I2C_I2CSTR_ICXRDY_INT            0x00000001u
S  #define  I2C_I2CSTR_ICXRDY_CLR            0x00000001u
S
S  #define _I2C_I2CSTR_ICRRDY_MASK           0x00000008u
S  #define _I2C_I2CSTR_ICRRDY_SHIFT          0x00000003u
S  #define  I2C_I2CSTR_ICRRDY_DEFAULT        0x00000000u
S  #define  I2C_I2CSTR_ICRRDY_OF(x)          _VALUEOF(x)
S  #define  I2C_I2CSTR_ICRRDY_NONE           0x00000000u
S  #define  I2C_I2CSTR_ICRRDY_INT            0x00000001u
S  #define  I2C_I2CSTR_ICRRDY_CLR            0x00000001u
S
S  #define _I2C_I2CSTR_ARDY_MASK             0x00000004u
S  #define _I2C_I2CSTR_ARDY_SHIFT            0x00000002u
S  #define  I2C_I2CSTR_ARDY_DEFAULT          0x00000000u
S  #define  I2C_I2CSTR_ARDY_OF(x)            _VALUEOF(x)
S  #define  I2C_I2CSTR_ARDY_NONE             0x00000000u
S  #define  I2C_I2CSTR_ARDY_INT              0x00000001u
S  #define  I2C_I2CSTR_ARDY_CLR              0x00000001u
S
S  #define _I2C_I2CSTR_NACK_MASK             0x00000002u
S  #define _I2C_I2CSTR_NACK_SHIFT            0x00000001u
S  #define  I2C_I2CSTR_NACK_DEFAULT          0x00000000u
S  #define  I2C_I2CSTR_NACK_OF(x)            _VALUEOF(x)
S  #define  I2C_I2CSTR_NACK_NONE             0x00000000u
S  #define  I2C_I2CSTR_NACK_INT              0x00000001u
S  #define  I2C_I2CSTR_NACK_CLR              0x00000001u
S
S  #define _I2C_I2CSTR_AL_MASK               0x00000001u
S  #define _I2C_I2CSTR_AL_SHIFT              0x00000000u
S  #define  I2C_I2CSTR_AL_DEFAULT            0x00000000u
S  #define  I2C_I2CSTR_AL_OF(x)              _VALUEOF(x)
S  #define  I2C_I2CSTR_AL_NONE               0x00000000u
S  #define  I2C_I2CSTR_AL_INT                0x00000001u
S  #define  I2C_I2CSTR_AL_CLR                0x00000001u
S
S
S  #define  I2C_I2CSTR_OF(x)                _VALUEOF(x)
S
S#if !(CHIP_6413 | CHIP_6418 | CHIP_6410)
S  #define I2C_I2CSTR_DEFAULT (Uint32)(\
S      _PER_FDEFAULT(I2C,I2CSTR,NACKSNT)\
S     |_PER_FDEFAULT(I2C,I2CSTR,BB)\
S     |_PER_FDEFAULT(I2C,I2CSTR,RSFULL)\
S     |_PER_FDEFAULT(I2C,I2CSTR,XSMT)\
S     |_PER_FDEFAULT(I2C,I2CSTR,AAS)\
S     |_PER_FDEFAULT(I2C,I2CSTR,AD0)\
S     |_PER_FDEFAULT(I2C,I2CSTR,ICXRDY)\
S     |_PER_FDEFAULT(I2C,I2CSTR,ICRRDY)\
S     |_PER_FDEFAULT(I2C,I2CSTR,ARDY)\
S     |_PER_FDEFAULT(I2C,I2CSTR,NACK)\
S     |_PER_FDEFAULT(I2C,I2CSTR,AL)\
S  )
X  #define I2C_I2CSTR_DEFAULT (Uint32)(      _PER_FDEFAULT(I2C,I2CSTR,NACKSNT)     |_PER_FDEFAULT(I2C,I2CSTR,BB)     |_PER_FDEFAULT(I2C,I2CSTR,RSFULL)     |_PER_FDEFAULT(I2C,I2CSTR,XSMT)     |_PER_FDEFAULT(I2C,I2CSTR,AAS)     |_PER_FDEFAULT(I2C,I2CSTR,AD0)     |_PER_FDEFAULT(I2C,I2CSTR,ICXRDY)     |_PER_FDEFAULT(I2C,I2CSTR,ICRRDY)     |_PER_FDEFAULT(I2C,I2CSTR,ARDY)     |_PER_FDEFAULT(I2C,I2CSTR,NACK)     |_PER_FDEFAULT(I2C,I2CSTR,AL)  )
S#else
S  #define I2C_I2CSTR_DEFAULT (Uint32)(\
S      _PER_FDEFAULT(I2C,I2CSTR,SDIR)\
S     |_PER_FDEFAULT(I2C,I2CSTR,NACKSNT)\
S     |_PER_FDEFAULT(I2C,I2CSTR,BB)\
S     |_PER_FDEFAULT(I2C,I2CSTR,RSFULL)\
S     |_PER_FDEFAULT(I2C,I2CSTR,XSMT)\
S     |_PER_FDEFAULT(I2C,I2CSTR,AAS)\
S     |_PER_FDEFAULT(I2C,I2CSTR,AD0)\
S     |_PER_FDEFAULT(I2C,I2CSTR,SCD)\
S     |_PER_FDEFAULT(I2C,I2CSTR,ICXRDY)\
S     |_PER_FDEFAULT(I2C,I2CSTR,ICRRDY)\
S     |_PER_FDEFAULT(I2C,I2CSTR,ARDY)\
S     |_PER_FDEFAULT(I2C,I2CSTR,NACK)\
S     |_PER_FDEFAULT(I2C,I2CSTR,AL)\
S  )
X  #define I2C_I2CSTR_DEFAULT (Uint32)(      _PER_FDEFAULT(I2C,I2CSTR,SDIR)     |_PER_FDEFAULT(I2C,I2CSTR,NACKSNT)     |_PER_FDEFAULT(I2C,I2CSTR,BB)     |_PER_FDEFAULT(I2C,I2CSTR,RSFULL)     |_PER_FDEFAULT(I2C,I2CSTR,XSMT)     |_PER_FDEFAULT(I2C,I2CSTR,AAS)     |_PER_FDEFAULT(I2C,I2CSTR,AD0)     |_PER_FDEFAULT(I2C,I2CSTR,SCD)     |_PER_FDEFAULT(I2C,I2CSTR,ICXRDY)     |_PER_FDEFAULT(I2C,I2CSTR,ICRRDY)     |_PER_FDEFAULT(I2C,I2CSTR,ARDY)     |_PER_FDEFAULT(I2C,I2CSTR,NACK)     |_PER_FDEFAULT(I2C,I2CSTR,AL)  )
S#endif
S#if !(CHIP_6413 | CHIP_6418 | CHIP_6410)
S  #define I2C_I2CSTR_RMK(nacksnt,bb,icxrdy,icrrdy,ardy,nack,al) (Uint32)(\
S      _PER_FMK(I2C,I2CSTR,NACKSNT,nacksnt)\
S     |_PER_FMK(I2C,I2CSTR,BB,bb)\
S     |_PER_FMK(I2C,I2CSTR,ICXRDY,icxrdy)\
S     |_PER_FMK(I2C,I2CSTR,ICRRDY,icrrdy)\
S     |_PER_FMK(I2C,I2CSTR,ARDY,ardy)\
S     |_PER_FMK(I2C,I2CSTR,NACK,nack)\
S     |_PER_FMK(I2C,I2CSTR,AL,al)\
S  )
X  #define I2C_I2CSTR_RMK(nacksnt,bb,icxrdy,icrrdy,ardy,nack,al) (Uint32)(      _PER_FMK(I2C,I2CSTR,NACKSNT,nacksnt)     |_PER_FMK(I2C,I2CSTR,BB,bb)     |_PER_FMK(I2C,I2CSTR,ICXRDY,icxrdy)     |_PER_FMK(I2C,I2CSTR,ICRRDY,icrrdy)     |_PER_FMK(I2C,I2CSTR,ARDY,ardy)     |_PER_FMK(I2C,I2CSTR,NACK,nack)     |_PER_FMK(I2C,I2CSTR,AL,al)  )
S#else
S  #define I2C_I2CSTR_RMK(sdir,nacksnt,bb,scd,icxrdy,icrrdy,ardy,nack,al) (Uint32)(\
S      _PER_FMK(I2C,I2CSTR,SDIR,sdir)\
S      _PER_FMK(I2C,I2CSTR,NACKSNT,nacksnt)\
S     |_PER_FMK(I2C,I2CSTR,BB,bb)\
S     |_PER_FMK(I2C,I2CSTR,SCD,scd)\
S     |_PER_FMK(I2C,I2CSTR,ICXRDY,icxrdy)\
S     |_PER_FMK(I2C,I2CSTR,ICRRDY,icrrdy)\
S     |_PER_FMK(I2C,I2CSTR,ARDY,ardy)\
S     |_PER_FMK(I2C,I2CSTR,NACK,nack)\
S     |_PER_FMK(I2C,I2CSTR,AL,al)\
S  )
X  #define I2C_I2CSTR_RMK(sdir,nacksnt,bb,scd,icxrdy,icrrdy,ardy,nack,al) (Uint32)(      _PER_FMK(I2C,I2CSTR,SDIR,sdir)      _PER_FMK(I2C,I2CSTR,NACKSNT,nacksnt)     |_PER_FMK(I2C,I2CSTR,BB,bb)     |_PER_FMK(I2C,I2CSTR,SCD,scd)     |_PER_FMK(I2C,I2CSTR,ICXRDY,icxrdy)     |_PER_FMK(I2C,I2CSTR,ICRRDY,icrrdy)     |_PER_FMK(I2C,I2CSTR,ARDY,ardy)     |_PER_FMK(I2C,I2CSTR,NACK,nack)     |_PER_FMK(I2C,I2CSTR,AL,al)  )
S#endif
S  #define _I2C_I2CSTR_FGET(N,FIELD)\
S    _PER_FGET(_I2C_I2CSTR##N##_ADDR,I2C,I2CSTR,##FIELD)
X  #define _I2C_I2CSTR_FGET(N,FIELD)    _PER_FGET(_I2C_I2CSTR##N##_ADDR,I2C,I2CSTR,##FIELD)
S
S  #define _I2C_I2CSTR_FSET(N,FIELD,field)\
S    _PER_FSET(_I2C_I2CSTR##N##_ADDR,I2C,I2CSTR,##FIELD,field)
X  #define _I2C_I2CSTR_FSET(N,FIELD,field)    _PER_FSET(_I2C_I2CSTR##N##_ADDR,I2C,I2CSTR,##FIELD,field)
S
S  #define _I2C_I2CSTR_FSETS(N,FIELD,SYM)\
S    _PER_FSETS(_I2C_I2CSTR##N##_ADDR,I2C,I2CSTR,##FIELD,##SYM)
X  #define _I2C_I2CSTR_FSETS(N,FIELD,SYM)    _PER_FSETS(_I2C_I2CSTR##N##_ADDR,I2C,I2CSTR,##FIELD,##SYM)
S
S  #define _I2C_I2CSTR0_FGET(FIELD) _I2C_I2CSTR_FGET(0,##FIELD)
S  #define _I2C_I2CSTR1_FGET(FIELD) _I2C_I2CSTR_FGET(1,##FIELD)
S
S  #define _I2C_I2CSTR0_FSET(FIELD,f) _I2C_I2CSTR_FSET(0,##FIELD,f)
S  #define _I2C_I2CSTR1_FSET(FIELD,f) _I2C_I2CSTR_FSET(1,##FIELD,f)
S
S  #define _I2C_I2CSTR0_FSETS(FIELD,SYM) _I2C_I2CSTR_FSETS(0,##FIELD,##SYM)
S  #define _I2C_I2CSTR1_FSETS(FIELD,SYM) _I2C_I2CSTR_FSETS(1,##FIELD,##SYM)
S
S
S/******************************************************************************\
S*  ___________________
X
S* |                   |
S* |  I 2 C C L K L    |
S* |___________________|
S*
S* I2CCLKL0   - I2C0 Clock Divider Low register
S* I2CCLKL1   - I2C1 Clock Divider Low register
S*
S* FIELDS (msb -> lsb)
S* (rw) ICCL
S*
S\******************************************************************************/
S  #define _I2C_I2CCLKL_OFFSET           3
S
S  #define _I2C_I2CCLKL0_ADDR            0x01B4000C
S  #define _I2C_I2CCLKL1_ADDR            0x01B4400C
S
S  #define _I2C_I2CCLKL_ICCL_MASK           0x0000FFFFu
S  #define _I2C_I2CCLKL_ICCL_SHIFT          0x00000000u
S  #define  I2C_I2CCLKL_ICCL_DEFAULT        0x00000000u
S  #define  I2C_I2CCLKL_ICCL_OF(x)          _VALUEOF(x)
S
S  #define  I2C_I2CCLKL_OF(x)             _VALUEOF(x)
S
S  #define I2C_I2CCLKL_DEFAULT (Uint32)(\
S     _PER_FDEFAULT(I2C,I2CCLKL,ICCL)\
S  )
X  #define I2C_I2CCLKL_DEFAULT (Uint32)(     _PER_FDEFAULT(I2C,I2CCLKL,ICCL)  )
S
S  #define I2C_I2CCLKL_RMK(iccl) (Uint32)(\
S     _PER_FMK(I2C,I2CCLKL,ICCL,iccl)\
S  )
X  #define I2C_I2CCLKL_RMK(iccl) (Uint32)(     _PER_FMK(I2C,I2CCLKL,ICCL,iccl)  )
S   
S  #define _I2C_I2CCLKL_FGET(N,FIELD)\
S    _PER_FGET(_I2C_I2CCLKL##N##_ADDR,I2C,I2CCLKL,##FIELD)
X  #define _I2C_I2CCLKL_FGET(N,FIELD)    _PER_FGET(_I2C_I2CCLKL##N##_ADDR,I2C,I2CCLKL,##FIELD)
S
S  #define _I2C_I2CCLKL_FSET(N,FIELD,field)\
S    _PER_FSET(_I2C_I2CCLKL##N##_ADDR,I2C,I2CCLKL,##FIELD,field)
X  #define _I2C_I2CCLKL_FSET(N,FIELD,field)    _PER_FSET(_I2C_I2CCLKL##N##_ADDR,I2C,I2CCLKL,##FIELD,field)
S
S  #define _I2C_I2CCLKL_FSETS(N,FIELD,SYM)\
S    _PER_FSETS(_I2C_I2CCLKL##N##_ADDR,I2C,I2CCLKL,##FIELD,##SYM)
X  #define _I2C_I2CCLKL_FSETS(N,FIELD,SYM)    _PER_FSETS(_I2C_I2CCLKL##N##_ADDR,I2C,I2CCLKL,##FIELD,##SYM)
S
S  #define _I2C_I2CCLKL0_FGET(FIELD) _I2C_I2CCLKL_FGET(0,##FIELD)
S  #define _I2C_I2CCLKL1_FGET(FIELD) _I2C_I2CCLKL_FGET(1,##FIELD)
S
S  #define _I2C_I2CCLKL0_FSET(FIELD,f) _I2C_I2CCLKL_FSET(0,##FIELD,f)
S  #define _I2C_I2CCLKL1_FSET(FIELD,f) _I2C_I2CCLKL_FSET(1,##FIELD,f)
S
S  #define _I2C_I2CCLKL0_FSETS(FIELD,SYM) _I2C_I2CCLKL_FSETS(0,##FIELD,##SYM)
S  #define _I2C_I2CCLKL1_FSETS(FIELD,SYM) _I2C_I2CCLKL_FSETS(1,##FIELD,##SYM)
S
S
S/******************************************************************************\
S*  ___________________
X
S* |                   |
S* |  I 2 C C L K H    |
S* |___________________|
S*
S* I2CCLKH0   - I2C0 Clock Divider High register
S* I2CCLKH1   - I2C1 Clock Divider High register
S*
S* FIELDS (msb -> lsb)
S* (rw) ICCH
S*
S\******************************************************************************/
S  #define _I2C_I2CCLKH_OFFSET           4
S
S  #define _I2C_I2CCLKH0_ADDR            0x01B40010
S  #define _I2C_I2CCLKH1_ADDR            0x01B44010
S
S  #define _I2C_I2CCLKH_ICCH_MASK        0x0000FFFFu
S  #define _I2C_I2CCLKH_ICCH_SHIFT       0x00000000u
S  #define  I2C_I2CCLKH_ICCH_DEFAULT     0x00000000u
S  #define  I2C_I2CCLKH_ICCH_OF(x)       _VALUEOF(x)
S
S  #define  I2C_I2CCLKH_OF(x)             _VALUEOF(x)
S
S  #define I2C_I2CCLKH_DEFAULT (Uint32)(\
S     _PER_FDEFAULT(I2C,I2CCLKH,ICCH)\
S  )
X  #define I2C_I2CCLKH_DEFAULT (Uint32)(     _PER_FDEFAULT(I2C,I2CCLKH,ICCH)  )
S
S  #define I2C_I2CCLKH_RMK(icch) (Uint32)(\
S     _PER_FMK(I2C,I2CCLKH,ICCH,icch)\
S  )
X  #define I2C_I2CCLKH_RMK(icch) (Uint32)(     _PER_FMK(I2C,I2CCLKH,ICCH,icch)  )
S   
S  #define _I2C_I2CCLKH_FGET(N,FIELD)\
S    _PER_FGET(_I2C_I2CCLKH##N##_ADDR,I2C,I2CCLKH,##FIELD)
X  #define _I2C_I2CCLKH_FGET(N,FIELD)    _PER_FGET(_I2C_I2CCLKH##N##_ADDR,I2C,I2CCLKH,##FIELD)
S
S  #define _I2C_I2CCLKH_FSET(N,FIELD,field)\
S    _PER_FSET(_I2C_I2CCLKH##N##_ADDR,I2C,I2CCLKH,##FIELD,field)
X  #define _I2C_I2CCLKH_FSET(N,FIELD,field)    _PER_FSET(_I2C_I2CCLKH##N##_ADDR,I2C,I2CCLKH,##FIELD,field)
S
S  #define _I2C_I2CCLKH_FSETS(N,FIELD,SYM)\
S    _PER_FSETS(_I2C_I2CCLKH##N##_ADDR,I2C,I2CCLKH,##FIELD,##SYM)
X  #define _I2C_I2CCLKH_FSETS(N,FIELD,SYM)    _PER_FSETS(_I2C_I2CCLKH##N##_ADDR,I2C,I2CCLKH,##FIELD,##SYM)
S
S  #define _I2C_I2CCLKH0_FGET(FIELD) _I2C_I2CCLKH_FGET(0,##FIELD)
S  #define _I2C_I2CCLKH1_FGET(FIELD) _I2C_I2CCLKH_FGET(1,##FIELD)
S
S  #define _I2C_I2CCLKH0_FSET(FIELD,f) _I2C_I2CCLKH_FSET(0,##FIELD,f)
S  #define _I2C_I2CCLKH1_FSET(FIELD,f) _I2C_I2CCLKH_FSET(1,##FIELD,f)
S
S  #define _I2C_I2CCLKH0_FSETS(FIELD,SYM) _I2C_I2CCLKH_FSETS(0,##FIELD,##SYM)
S  #define _I2C_I2CCLKH1_FSETS(FIELD,SYM) _I2C_I2CCLKH_FSETS(1,##FIELD,##SYM)
S
S
S/******************************************************************************\
S*  ___________________
X
S* |                   |
S* |  I 2 C C N T      |
S* |___________________|
S*
S* I2CCNT0    - I2C0 Data Count register
S* I2CCNT1    - I2C1 Data Count register
S*
S* FIELDS (msb -> lsb)
S* (rw) ICDC
S\******************************************************************************/
S  #define _I2C_I2CCNT_OFFSET           5
S
S  #define _I2C_I2CCNT0_ADDR            0x01B40014
S  #define _I2C_I2CCNT1_ADDR            0x01B44014
S
S  #define _I2C_I2CCNT_ICDC_MASK        0x0000FFFFu
S  #define _I2C_I2CCNT_ICDC_SHIFT       0x00000000u
S  #define  I2C_I2CCNT_ICDC_DEFAULT     0x00000000u
S  #define  I2C_I2CCNT_ICDC_OF(x)       _VALUEOF(x)
S
S  #define  I2C_I2CCNT_OF(x)             _VALUEOF(x)
S
S  #define I2C_I2CCNT_DEFAULT (Uint32)(\
S     _PER_FDEFAULT(I2C,I2CCNT,ICDC)\
S  )
X  #define I2C_I2CCNT_DEFAULT (Uint32)(     _PER_FDEFAULT(I2C,I2CCNT,ICDC)  )
S
S  #define I2C_I2CCNT_RMK(icdc) (Uint32)(\
S     _PER_FMK(I2C,I2CCNT,ICDC,icdc)\
S  )
X  #define I2C_I2CCNT_RMK(icdc) (Uint32)(     _PER_FMK(I2C,I2CCNT,ICDC,icdc)  )
S   
S  #define _I2C_I2CCNT_FGET(N,FIELD)\
S    _PER_FGET(_I2C_I2CCNT##N##_ADDR,I2C,I2CCNT,##FIELD)
X  #define _I2C_I2CCNT_FGET(N,FIELD)    _PER_FGET(_I2C_I2CCNT##N##_ADDR,I2C,I2CCNT,##FIELD)
S
S  #define _I2C_I2CCNT_FSET(N,FIELD,field)\
S    _PER_FSET(_I2C_I2CCNT##N##_ADDR,I2C,I2CCNT,##FIELD,field)
X  #define _I2C_I2CCNT_FSET(N,FIELD,field)    _PER_FSET(_I2C_I2CCNT##N##_ADDR,I2C,I2CCNT,##FIELD,field)
S
S  #define _I2C_I2CCNT_FSETS(N,FIELD,SYM)\
S    _PER_FSETS(_I2C_I2CCNT##N##_ADDR,I2C,I2CCNT,##FIELD,##SYM)
X  #define _I2C_I2CCNT_FSETS(N,FIELD,SYM)    _PER_FSETS(_I2C_I2CCNT##N##_ADDR,I2C,I2CCNT,##FIELD,##SYM)
S
S  #define _I2C_I2CCNT0_FGET(FIELD) _I2C_I2CCNT_FGET(0,##FIELD)
S  #define _I2C_I2CCNT1_FGET(FIELD) _I2C_I2CCNT_FGET(1,##FIELD)
S
S  #define _I2C_I2CCNT0_FSET(FIELD,f) _I2C_I2CCNT_FSET(0,##FIELD,f)
S  #define _I2C_I2CCNT1_FSET(FIELD,f) _I2C_I2CCNT_FSET(1,##FIELD,f)
S
S  #define _I2C_I2CCNT0_FSETS(FIELD,SYM) _I2C_I2CCNT_FSETS(0,##FIELD,##SYM)
S  #define _I2C_I2CCNT1_FSETS(FIELD,SYM) _I2C_I2CCNT_FSETS(1,##FIELD,##SYM)
S
S
S/******************************************************************************\
S*  ___________________
X
S* |                   |
S* |  I 2 C D R R      |
S* |___________________|
S*
S* I2CDRR0    - I2C0 Data Receive register
S* I2CDRR1    - I2C1 Data Receive register
S*
S* FIELDS (msb -> lsb)
S* (r) D
S\******************************************************************************/
S  #define _I2C_I2CDRR_OFFSET           6
S
S  #define _I2C_I2CDRR0_ADDR            0x01B40018
S  #define _I2C_I2CDRR1_ADDR            0x01B44018
S
S  #define _I2C_I2CDRR_D_MASK        0x000000FFu
S  #define _I2C_I2CDRR_D_SHIFT       0x00000000u
S  #define  I2C_I2CDRR_D_DEFAULT     0x00000000u
S  #define  I2C_I2CDRR_D_OF(x)       _VALUEOF(x)
S
S  #define  I2C_I2CDRR_OF(x)             _VALUEOF(x)
S
S  #define I2C_I2CDRR_DEFAULT (Uint32)(\
S     _PER_FDEFAULT(I2C,I2CDRR,D)\
S  )
X  #define I2C_I2CDRR_DEFAULT (Uint32)(     _PER_FDEFAULT(I2C,I2CDRR,D)  )
S
S  #define I2C_I2CDRR_RMK(d) (Uint32)(\
S     _PER_FMK(I2C,I2CDRR,D,d)\
S  )
X  #define I2C_I2CDRR_RMK(d) (Uint32)(     _PER_FMK(I2C,I2CDRR,D,d)  )
S   
S  #define _I2C_I2CDRR_FGET(N,FIELD)\
S    _PER_FGET(_I2C_I2CDRR##N##_ADDR,I2C,I2CDRR,##FIELD)
X  #define _I2C_I2CDRR_FGET(N,FIELD)    _PER_FGET(_I2C_I2CDRR##N##_ADDR,I2C,I2CDRR,##FIELD)
S
S  #define _I2C_I2CDRR_FSET(N,FIELD,field)\
S    _PER_FSET(_I2C_I2CDRR##N##_ADDR,I2C,I2CDRR,##FIELD,field)
X  #define _I2C_I2CDRR_FSET(N,FIELD,field)    _PER_FSET(_I2C_I2CDRR##N##_ADDR,I2C,I2CDRR,##FIELD,field)
S
S  #define _I2C_I2CDRR_FSETS(N,FIELD,SYM)\
S    _PER_FSETS(_I2C_I2CDRR##N##_ADDR,I2C,I2CDRR,##FIELD,##SYM)
X  #define _I2C_I2CDRR_FSETS(N,FIELD,SYM)    _PER_FSETS(_I2C_I2CDRR##N##_ADDR,I2C,I2CDRR,##FIELD,##SYM)
S
S  #define _I2C_I2CDRR0_FGET(FIELD) _I2C_I2CDRR_FGET(0,##FIELD)
S  #define _I2C_I2CDRR1_FGET(FIELD) _I2C_I2CDRR_FGET(1,##FIELD)
S
S  #define _I2C_I2CDRR0_FSET(FIELD,f) _I2C_I2CDRR_FSET(0,##FIELD,f)
S  #define _I2C_I2CDRR1_FSET(FIELD,f) _I2C_I2CDRR_FSET(1,##FIELD,f)
S
S  #define _I2C_I2CDRR0_FSETS(FIELD,SYM) _I2C_I2CDRR_FSETS(0,##FIELD,##SYM)
S  #define _I2C_I2CDRR1_FSETS(FIELD,SYM) _I2C_I2CDRR_FSETS(1,##FIELD,##SYM)
S
S
S/******************************************************************************\
S*  ___________________
X
S* |                   |
S* |  I 2 C S A R      |
S* |___________________|
S*
S* I2CSAR0    - I2C0 Slave Address register
S* I2CSAR1    - I2C1 Slave Address register
S*
S* FIELDS (msb -> lsb)
S* (rw) A
S\******************************************************************************/
S  #define _I2C_I2CSAR_OFFSET           7
S
S  #define _I2C_I2CSAR0_ADDR            0x01B4001C
S  #define _I2C_I2CSAR1_ADDR            0x01B4401C
S
S  #define _I2C_I2CSAR_A_MASK           0x000003FFu
S  #define _I2C_I2CSAR_A_SHIFT          0x00000000u
S  #define  I2C_I2CSAR_A_DEFAULT        0x000003FFu /*???*/
S  #define  I2C_I2CSAR_A_OF(x)          _VALUEOF(x)
S
S  #define  I2C_I2CSAR_OF(x)             _VALUEOF(x)
S
S  #define I2C_I2CSAR_DEFAULT (Uint32)(\
S     _PER_FDEFAULT(I2C,I2CSAR,A)\
S  )
X  #define I2C_I2CSAR_DEFAULT (Uint32)(     _PER_FDEFAULT(I2C,I2CSAR,A)  )
S
S  #define I2C_I2CSAR_RMK(a) (Uint32)(\
S     _PER_FMK(I2C,I2CSAR,A,a)\
S  )
X  #define I2C_I2CSAR_RMK(a) (Uint32)(     _PER_FMK(I2C,I2CSAR,A,a)  )
S   
S  #define _I2C_I2CSAR_FGET(N,FIELD)\
S    _PER_FGET(_I2C_I2CSAR##N##_ADDR,I2C,I2CSAR,##FIELD)
X  #define _I2C_I2CSAR_FGET(N,FIELD)    _PER_FGET(_I2C_I2CSAR##N##_ADDR,I2C,I2CSAR,##FIELD)
S
S  #define _I2C_I2CSAR_FSET(N,FIELD,field)\
S    _PER_FSET(_I2C_I2CSAR##N##_ADDR,I2C,I2CSAR,##FIELD,field)
X  #define _I2C_I2CSAR_FSET(N,FIELD,field)    _PER_FSET(_I2C_I2CSAR##N##_ADDR,I2C,I2CSAR,##FIELD,field)
S
S  #define _I2C_I2CSAR_FSETS(N,FIELD,SYM)\
S    _PER_FSETS(_I2C_I2CSAR##N##_ADDR,I2C,I2CSAR,##FIELD,##SYM)
X  #define _I2C_I2CSAR_FSETS(N,FIELD,SYM)    _PER_FSETS(_I2C_I2CSAR##N##_ADDR,I2C,I2CSAR,##FIELD,##SYM)
S
S  #define _I2C_I2CSAR0_FGET(FIELD) _I2C_I2CSAR_FGET(0,##FIELD)
S  #define _I2C_I2CSAR1_FGET(FIELD) _I2C_I2CSAR_FGET(1,##FIELD)
S
S  #define _I2C_I2CSAR0_FSET(FIELD,f) _I2C_I2CSAR_FSET(0,##FIELD,f)
S  #define _I2C_I2CSAR1_FSET(FIELD,f) _I2C_I2CSAR_FSET(1,##FIELD,f)
S
S  #define _I2C_I2CSAR0_FSETS(FIELD,SYM) _I2C_I2CSAR_FSETS(0,##FIELD,##SYM)
S  #define _I2C_I2CSAR1_FSETS(FIELD,SYM) _I2C_I2CSAR_FSETS(1,##FIELD,##SYM)
S
S
S/******************************************************************************\
S*  ___________________
X
S* |                   |
S* |  I 2 C D X R      |
S* |___________________|
S*
S* I2CDXR0    - I2C0 Data Transmit register
S* I2CDXR1    - I2C1 Data Transmit register
S*
S* FIELDS (msb -> lsb)
S* (rw) D
S\******************************************************************************/
S  #define _I2C_I2CDXR_OFFSET           8
S
S  #define _I2C_I2CDXR0_ADDR            0x01B40020
S  #define _I2C_I2CDXR1_ADDR            0x01B44020
S
S  #define _I2C_I2CDXR_D_MASK           0x000000FFu
S  #define _I2C_I2CDXR_D_SHIFT          0x00000000u
S  #define  I2C_I2CDXR_D_DEFAULT        0x00000000u
S  #define  I2C_I2CDXR_D_OF(x)          _VALUEOF(x)
S
S  #define  I2C_I2CDXR_OF(x)             _VALUEOF(x)
S
S  #define I2C_I2CDXR_DEFAULT (Uint32)(\
S     _PER_FDEFAULT(I2C,I2CDXR,D)\
S  )
X  #define I2C_I2CDXR_DEFAULT (Uint32)(     _PER_FDEFAULT(I2C,I2CDXR,D)  )
S
S  #define I2C_I2CDXR_RMK(d) (Uint32)(\
S     _PER_FMK(I2C,I2CDXR,D,d)\
S  )
X  #define I2C_I2CDXR_RMK(d) (Uint32)(     _PER_FMK(I2C,I2CDXR,D,d)  )
S   
S  #define _I2C_I2CDXR_FGET(N,FIELD)\
S    _PER_FGET(_I2C_I2CDXR##N##_ADDR,I2C,I2CDXR,##FIELD)
X  #define _I2C_I2CDXR_FGET(N,FIELD)    _PER_FGET(_I2C_I2CDXR##N##_ADDR,I2C,I2CDXR,##FIELD)
S
S  #define _I2C_I2CDXR_FSET(N,FIELD,field)\
S    _PER_FSET(_I2C_I2CDXR##N##_ADDR,I2C,I2CDXR,##FIELD,field)
X  #define _I2C_I2CDXR_FSET(N,FIELD,field)    _PER_FSET(_I2C_I2CDXR##N##_ADDR,I2C,I2CDXR,##FIELD,field)
S
S  #define _I2C_I2CDXR_FSETS(N,FIELD,SYM)\
S    _PER_FSETS(_I2C_I2CDXR##N##_ADDR,I2C,I2CDXR,##FIELD,##SYM)
X  #define _I2C_I2CDXR_FSETS(N,FIELD,SYM)    _PER_FSETS(_I2C_I2CDXR##N##_ADDR,I2C,I2CDXR,##FIELD,##SYM)
S
S  #define _I2C_I2CDXR0_FGET(FIELD) _I2C_I2CDXR_FGET(0,##FIELD)
S  #define _I2C_I2CDXR1_FGET(FIELD) _I2C_I2CDXR_FGET(1,##FIELD)
S
S  #define _I2C_I2CDXR0_FSET(FIELD,f) _I2C_I2CDXR_FSET(0,##FIELD,f)
S  #define _I2C_I2CDXR1_FSET(FIELD,f) _I2C_I2CDXR_FSET(1,##FIELD,f)
S
S  #define _I2C_I2CDXR0_FSETS(FIELD,SYM) _I2C_I2CDXR_FSETS(0,##FIELD,##SYM)
S  #define _I2C_I2CDXR1_FSETS(FIELD,SYM) _I2C_I2CDXR_FSETS(1,##FIELD,##SYM)
S
S/******************************************************************************\
S*  ___________________
X
S* |                   |
S* |  I 2 C M D R      |
S* |___________________|
S*
S* I2CMDR0    - I2C0 Mode register
S* I2CMDR1    - I2C1 Mode register
S*
S* FIELDS (msb -> lsb)
S* (rw) NACKMOD
S* (rw) FREE
S* (rw) STT
S* (rw) STP
S* (rw) MST
S* (rw) TRX
S* (rw) XA
S* (rw) RM
S* (rw) DLB
S* (rw) IRS
S* (rw) STB
S* (rw) FDF
S* (rw) BC
S\******************************************************************************/
S  #define _I2C_I2CMDR_OFFSET           9
S
S  #define _I2C_I2CMDR0_ADDR            0x01B40024
S  #define _I2C_I2CMDR1_ADDR            0x01B44024
S
S  #define _I2C_I2CMDR_NACKMOD_MASK     0x00008000u
S  #define _I2C_I2CMDR_NACKMOD_SHIFT    0x0000000Fu
S  #define  I2C_I2CMDR_NACKMOD_DEFAULT  0x00000000u
S  #define  I2C_I2CMDR_NACKMOD_OF(x)    _VALUEOF(x)
S  #define  I2C_I2CMDR_NACKMOD_ACK      0x00000000u
S  #define  I2C_I2CMDR_NACKMOD_NACK     0x00000001u
S
S  #define _I2C_I2CMDR_FREE_MASK        0x00004000u
S  #define _I2C_I2CMDR_FREE_SHIFT       0x0000000Eu
S  #define  I2C_I2CMDR_FREE_DEFAULT     0x00000000u
S  #define  I2C_I2CMDR_FREE_OF(x)       _VALUEOF(x)
S  #define  I2C_I2CMDR_FREE_BSTOP       0x00000000u
S  #define  I2C_I2CMDR_FREE_RFREE       0x00000001u
S
S  #define _I2C_I2CMDR_STT_MASK         0x00002000u
S  #define _I2C_I2CMDR_STT_SHIFT        0x0000000Du
S  #define  I2C_I2CMDR_STT_DEFAULT      0x00000000u
S  #define  I2C_I2CMDR_STT_OF(x)        _VALUEOF(x)
S  #define  I2C_I2CMDR_STT_NONE         0x00000000u
S  #define  I2C_I2CMDR_STT_START        0x00000001u
S
S  #define _I2C_I2CMDR_STP_MASK         0x00000800u
S  #define _I2C_I2CMDR_STP_SHIFT        0x0000000Bu
S  #define  I2C_I2CMDR_STP_DEFAULT      0x00000000u
S  #define  I2C_I2CMDR_STP_OF(x)        _VALUEOF(x)
S  #define  I2C_I2CMDR_STP_NONE         0x00000000u
S  #define  I2C_I2CMDR_STP_STOP         0x00000001u
S
S  #define _I2C_I2CMDR_MST_MASK         0x00000400u
S  #define _I2C_I2CMDR_MST_SHIFT        0x0000000Au
S  #define  I2C_I2CMDR_MST_DEFAULT      0x00000000u
S  #define  I2C_I2CMDR_MST_OF(x)        _VALUEOF(x)
S  #define  I2C_I2CMDR_MST_SLAVE        0x00000000u
S  #define  I2C_I2CMDR_MST_MASTER       0x00000001u
S
S  #define _I2C_I2CMDR_TRX_MASK         0x00000200u
S  #define _I2C_I2CMDR_TRX_SHIFT        0x00000009u
S  #define  I2C_I2CMDR_TRX_DEFAULT      0x00000000u
S  #define  I2C_I2CMDR_TRX_OF(x)        _VALUEOF(x)
S  #define  I2C_I2CMDR_TRX_RCV          0x00000000u
S  #define  I2C_I2CMDR_TRX_XMT          0x00000001u
S
S  #define _I2C_I2CMDR_XA_MASK          0x00000100u
S  #define _I2C_I2CMDR_XA_SHIFT         0x00000008u
S  #define  I2C_I2CMDR_XA_DEFAULT       0x00000000u
S  #define  I2C_I2CMDR_XA_OF(x)         _VALUEOF(x)
S  #define  I2C_I2CMDR_XA_7BIT          0x00000000u
S  #define  I2C_I2CMDR_XA_10BIT         0x00000001u
S
S  #define _I2C_I2CMDR_RM_MASK          0x00000080u
S  #define _I2C_I2CMDR_RM_SHIFT         0x00000007u
S  #define  I2C_I2CMDR_RM_DEFAULT       0x00000000u
S  #define  I2C_I2CMDR_RM_OF(x)         _VALUEOF(x)
S  #define  I2C_I2CMDR_RM_NONE          0x00000000u
S  #define  I2C_I2CMDR_RM_REPEAD        0x00000001u
S
S  #define _I2C_I2CMDR_DLB_MASK         0x00000040u
S  #define _I2C_I2CMDR_DLB_SHIFT        0x00000006u
S  #define  I2C_I2CMDR_DLB_DEFAULT      0x00000000u
S  #define  I2C_I2CMDR_DLB_OF(x)        _VALUEOF(x)
S  #define  I2C_I2CMDR_DLB_NONE         0x00000000u
S  #define  I2C_I2CMDR_DLB_LOOPBACK     0x00000001u
S
S  #define _I2C_I2CMDR_IRS_MASK         0x00000020u
S  #define _I2C_I2CMDR_IRS_SHIFT        0x00000005u
S  #define  I2C_I2CMDR_IRS_DEFAULT      0x00000000u
S  #define  I2C_I2CMDR_IRS_OF(x)        _VALUEOF(x)
S  #define  I2C_I2CMDR_IRS_RST          0x00000000u
S  #define  I2C_I2CMDR_IRS_NRST         0x00000001u
S
S  #define _I2C_I2CMDR_STB_MASK         0x00000010u
S  #define _I2C_I2CMDR_STB_SHIFT        0x00000004u
S  #define  I2C_I2CMDR_STB_DEFAULT      0x00000000u
S  #define  I2C_I2CMDR_STB_OF(x)        _VALUEOF(x)
S  #define  I2C_I2CMDR_STB_NONE         0x00000000u
S  #define  I2C_I2CMDR_STB_SET          0x00000001u
S
S  #define _I2C_I2CMDR_FDF_MASK         0x00000008u
S  #define _I2C_I2CMDR_FDF_SHIFT        0x00000003u
S  #define  I2C_I2CMDR_FDF_DEFAULT      0x00000000u
S  #define  I2C_I2CMDR_FDF_OF(x)        _VFDFUEOF(x)
S  #define  I2C_I2CMDR_FDF_NONE         0x00000000u
S  #define  I2C_I2CMDR_FDF_SET          0x00000001u
S
S  #define _I2C_I2CMDR_BC_MASK          0x00000007u
S  #define _I2C_I2CMDR_BC_SHIFT         0x00000000u
S  #define  I2C_I2CMDR_BC_DEFAULT       0x00000000u
S  #define  I2C_I2CMDR_BC_OF(x)         _VALUEOF(x)
S  #define  I2C_I2CMDR_BC_BIT8FDF       0x00000000u
S  #define  I2C_I2CMDR_BC_BIT7FDF       0x00000007u
S  #define  I2C_I2CMDR_BC_BIT6FDF       0x00000006u
S  #define  I2C_I2CMDR_BC_BIT5FDF       0x00000005u
S  #define  I2C_I2CMDR_BC_BIT4FDF       0x00000004u
S  #define  I2C_I2CMDR_BC_BIT3FDF       0x00000003u
S  #define  I2C_I2CMDR_BC_BIT2FDF       0x00000002u
S  #define  I2C_I2CMDR_BC_BIT1FDF       0x00000001u
S
S  #define  I2C_I2CMDR_OF(x)                _VALUEOF(x)
S
S  #define I2C_I2CMDR_DEFAULT (Uint32)(\
S      _PER_FDEFAULT(I2C,I2CMDR,NACKMOD)\
S     |_PER_FDEFAULT(I2C,I2CMDR,FREE)\
S     |_PER_FDEFAULT(I2C,I2CMDR,STT)\
S     |_PER_FDEFAULT(I2C,I2CMDR,STP)\
S     |_PER_FDEFAULT(I2C,I2CMDR,MST)\
S     |_PER_FDEFAULT(I2C,I2CMDR,TRX)\
S     |_PER_FDEFAULT(I2C,I2CMDR,XA)\
S     |_PER_FDEFAULT(I2C,I2CMDR,RM)\
S     |_PER_FDEFAULT(I2C,I2CMDR,DLB)\
S     |_PER_FDEFAULT(I2C,I2CMDR,IRS)\
S     |_PER_FDEFAULT(I2C,I2CMDR,STB)\
S     |_PER_FDEFAULT(I2C,I2CMDR,FDF)\
S     |_PER_FDEFAULT(I2C,I2CMDR,BC)\
S  )
X  #define I2C_I2CMDR_DEFAULT (Uint32)(      _PER_FDEFAULT(I2C,I2CMDR,NACKMOD)     |_PER_FDEFAULT(I2C,I2CMDR,FREE)     |_PER_FDEFAULT(I2C,I2CMDR,STT)     |_PER_FDEFAULT(I2C,I2CMDR,STP)     |_PER_FDEFAULT(I2C,I2CMDR,MST)     |_PER_FDEFAULT(I2C,I2CMDR,TRX)     |_PER_FDEFAULT(I2C,I2CMDR,XA)     |_PER_FDEFAULT(I2C,I2CMDR,RM)     |_PER_FDEFAULT(I2C,I2CMDR,DLB)     |_PER_FDEFAULT(I2C,I2CMDR,IRS)     |_PER_FDEFAULT(I2C,I2CMDR,STB)     |_PER_FDEFAULT(I2C,I2CMDR,FDF)     |_PER_FDEFAULT(I2C,I2CMDR,BC)  )
S
S  #define I2C_I2CMDR_RMK(nackmod,free,stt,stp,mst,trx,xa,rm,dlb,irs,stb,fdf,bc) (Uint32)(\
S      _PER_FMK(I2C,I2CMDR,NACKMOD,nackmod)\
S     |_PER_FMK(I2C,I2CMDR,FREE,free)\
S     |_PER_FMK(I2C,I2CMDR,STT,stt)\
S     |_PER_FMK(I2C,I2CMDR,STP,stp)\
S     |_PER_FMK(I2C,I2CMDR,MST,mst)\
S     |_PER_FMK(I2C,I2CMDR,TRX,trx)\
S     |_PER_FMK(I2C,I2CMDR,XA,xa)\
S     |_PER_FMK(I2C,I2CMDR,RM,rm)\
S     |_PER_FMK(I2C,I2CMDR,DLB,dlb)\
S     |_PER_FMK(I2C,I2CMDR,IRS,irs)\
S     |_PER_FMK(I2C,I2CMDR,STB,stb)\
S     |_PER_FMK(I2C,I2CMDR,FDF,fdf)\
S     |_PER_FMK(I2C,I2CMDR,BC,bc)\
S  )
X  #define I2C_I2CMDR_RMK(nackmod,free,stt,stp,mst,trx,xa,rm,dlb,irs,stb,fdf,bc) (Uint32)(      _PER_FMK(I2C,I2CMDR,NACKMOD,nackmod)     |_PER_FMK(I2C,I2CMDR,FREE,free)     |_PER_FMK(I2C,I2CMDR,STT,stt)     |_PER_FMK(I2C,I2CMDR,STP,stp)     |_PER_FMK(I2C,I2CMDR,MST,mst)     |_PER_FMK(I2C,I2CMDR,TRX,trx)     |_PER_FMK(I2C,I2CMDR,XA,xa)     |_PER_FMK(I2C,I2CMDR,RM,rm)     |_PER_FMK(I2C,I2CMDR,DLB,dlb)     |_PER_FMK(I2C,I2CMDR,IRS,irs)     |_PER_FMK(I2C,I2CMDR,STB,stb)     |_PER_FMK(I2C,I2CMDR,FDF,fdf)     |_PER_FMK(I2C,I2CMDR,BC,bc)  )
S   
S  #define _I2C_I2CMDR_FGET(N,FIELD)\
S    _PER_FGET(_I2C_I2CMDR##N##_ADDR,I2C,I2CMDR,##FIELD)
X  #define _I2C_I2CMDR_FGET(N,FIELD)    _PER_FGET(_I2C_I2CMDR##N##_ADDR,I2C,I2CMDR,##FIELD)
S
S  #define _I2C_I2CMDR_FSET(N,FIELD,field)\
S    _PER_FSET(_I2C_I2CMDR##N##_ADDR,I2C,I2CMDR,##FIELD,field)
X  #define _I2C_I2CMDR_FSET(N,FIELD,field)    _PER_FSET(_I2C_I2CMDR##N##_ADDR,I2C,I2CMDR,##FIELD,field)
S
S  #define _I2C_I2CMDR_FSETS(N,FIELD,SYM)\
S    _PER_FSETS(_I2C_I2CMDR##N##_ADDR,I2C,I2CMDR,##FIELD,##SYM)
X  #define _I2C_I2CMDR_FSETS(N,FIELD,SYM)    _PER_FSETS(_I2C_I2CMDR##N##_ADDR,I2C,I2CMDR,##FIELD,##SYM)
S
S  #define _I2C_I2CMDR0_FGET(FIELD) _I2C_I2CMDR_FGET(0,##FIELD)
S  #define _I2C_I2CMDR1_FGET(FIELD) _I2C_I2CMDR_FGET(1,##FIELD)
S
S  #define _I2C_I2CMDR0_FSET(FIELD,f) _I2C_I2CMDR_FSET(0,##FIELD,f)
S  #define _I2C_I2CMDR1_FSET(FIELD,f) _I2C_I2CMDR_FSET(1,##FIELD,f)
S
S  #define _I2C_I2CMDR0_FSETS(FIELD,SYM) _I2C_I2CMDR_FSETS(0,##FIELD,##SYM)
S  #define _I2C_I2CMDR1_FSETS(FIELD,SYM) _I2C_I2CMDR_FSETS(1,##FIELD,##SYM)
S
S/******************************************************************************\
S*  (Keeping the old definitions for backward compatibility)
X
S*  ___________________
S* |                   |
S* |  I 2 C I V R      |
S* |___________________|
S*
S* I2CIVR0    - I2C0 Interrupt Vector register
S* I2CIVR1    - I2C1 Interrupt Vector register
S*
S* FIELDS (msb -> lsb)
S* (r) INTCODE
S\******************************************************************************/
S
S#if (!(CHIP_6410 | CHIP_6413 | CHIP_6418))
S  #define _I2C_I2CIVR_OFFSET           10
S
S  #define _I2C_I2CIVR0_ADDR            0x01B40028
S  #define _I2C_I2CIVR1_ADDR            0x01B44028
S
S  /*** old names ***/
S  #define _I2C_I2CISR0_ADDR        _I2C_I2CIVR0_ADDR            
S  #define _I2C_I2CISR1_ADDR        _I2C_I2CIVR1_ADDR            
S
S  #define _I2C_I2CIVR_INTCODE_MASK     0x00000007u
S  #define _I2C_I2CIVR_INTCODE_SHIFT    0x00000000u
S  #define  I2C_I2CIVR_INTCODE_DEFAULT  0x00000000u
S  #define  I2C_I2CIVR_INTCODE_OF(x)    _VALUEOF(x)
S  #define  I2C_I2CIVR_INTCODE_NONE     0x00000000u
S  #define  I2C_I2CIVR_INTCODE_AL       0x00000001u
S  #define  I2C_I2CIVR_INTCODE_NACK     0x00000002u
S  #define  I2C_I2CIVR_INTCODE_RAR      0x00000003u
S  #define  I2C_I2CIVR_INTCODE_RDR      0x00000004u
S  #define  I2C_I2CIVR_INTCODE_XDR      0x00000005u
S
S  #define  I2C_I2CIVR_OF(x)             _VALUEOF(x)
S
S  #define I2C_I2CIVR_DEFAULT (Uint32)(\
S     _PER_FDEFAULT(I2C,I2CIVR,INTCODE)\
S  )
X  #define I2C_I2CIVR_DEFAULT (Uint32)(     _PER_FDEFAULT(I2C,I2CIVR,INTCODE)  )
S
S  #define I2C_I2CIVR_RMK(intcode) (Uint32)(\
S     _PER_FMK(I2C,I2CIVR,INTCODE,intcode)\
S  )
X  #define I2C_I2CIVR_RMK(intcode) (Uint32)(     _PER_FMK(I2C,I2CIVR,INTCODE,intcode)  )
S   
S  #define _I2C_I2CIVR_FGET(N,FIELD)\
S    _PER_FGET(_I2C_I2CIVR##N##_ADDR,I2C,I2CIVR,##FIELD)
X  #define _I2C_I2CIVR_FGET(N,FIELD)    _PER_FGET(_I2C_I2CIVR##N##_ADDR,I2C,I2CIVR,##FIELD)
S
S  #define _I2C_I2CIVR_FSET(N,FIELD,field)\
S    _PER_FSET(_I2C_I2CIVR##N##_ADDR,I2C,I2CIVR,##FIELD,field)
X  #define _I2C_I2CIVR_FSET(N,FIELD,field)    _PER_FSET(_I2C_I2CIVR##N##_ADDR,I2C,I2CIVR,##FIELD,field)
S
S  #define _I2C_I2CIVR_FSETS(N,FIELD,SYM)\
S    _PER_FSETS(_I2C_I2CIVR##N##_ADDR,I2C,I2CIVR,##FIELD,##SYM)
X  #define _I2C_I2CIVR_FSETS(N,FIELD,SYM)    _PER_FSETS(_I2C_I2CIVR##N##_ADDR,I2C,I2CIVR,##FIELD,##SYM)
S
S  #define _I2C_I2CIVR0_FGET(FIELD) _I2C_I2CIVR_FGET(0,##FIELD)
S  #define _I2C_I2CIVR1_FGET(FIELD) _I2C_I2CIVR_FGET(1,##FIELD)
S
S  #define _I2C_I2CIVR0_FSET(FIELD,f) _I2C_I2CIVR_FSET(0,##FIELD,f)
S  #define _I2C_I2CIVR1_FSET(FIELD,f) _I2C_I2CIVR_FSET(1,##FIELD,f)
S
S  #define _I2C_I2CIVR0_FSETS(FIELD,SYM) _I2C_I2CIVR_FSETS(0,##FIELD,##SYM)
S  #define _I2C_I2CIVR1_FSETS(FIELD,SYM) _I2C_I2CIVR_FSETS(1,##FIELD,##SYM)
S#endif
S
S/******************************************************************************\
S*  ___________________
X
S* |                   |
S* |  I 2 C I S R C    |
S* |___________________|
S*
S* I2CISRC0    - I2C0 Interrupt Vector register
S* I2CISRC1    - I2C1 Interrupt Vector register
S*
S* FIELDS (msb -> lsb)
S* (r) INTCODE
S\******************************************************************************/
S
S  #define _I2C_I2CISRC_OFFSET           10
S
S  #define _I2C_I2CISRC0_ADDR            0x01B40028
S  #define _I2C_I2CISRC1_ADDR            0x01B44028
S
S  #define _I2C_I2CISRC_INTCODE_MASK     0x00000007u
S  #define _I2C_I2CISRC_INTCODE_SHIFT    0x00000000u
S  #define  I2C_I2CISRC_INTCODE_DEFAULT  0x00000000u
S  #define  I2C_I2CISRC_INTCODE_OF(x)    _VALUEOF(x)
S  #define  I2C_I2CISRC_INTCODE_NONE     0x00000000u
S  #define  I2C_I2CISRC_INTCODE_AL       0x00000001u
S  #define  I2C_I2CISRC_INTCODE_NACK     0x00000002u
S  #define  I2C_I2CISRC_INTCODE_RAR      0x00000003u
S  #define  I2C_I2CISRC_INTCODE_RDR      0x00000004u
S  #define  I2C_I2CISRC_INTCODE_XDR      0x00000005u
S#if (CHIP_6413 | CHIP_6418 | CHIP_6410)
S  #define  I2C_I2CISRC_INTCODE_SCD      0x00000006u
S  #define  I2C_I2CISRC_INTCODE_AAS      0x00000007u
S#endif
S
S  #define  I2C_I2CISRC_OF(x)             _VALUEOF(x)
S
S  #define I2C_I2CISRC_DEFAULT (Uint32)(\
S     _PER_FDEFAULT(I2C,I2CISRC,INTCODE)\
S  )
X  #define I2C_I2CISRC_DEFAULT (Uint32)(     _PER_FDEFAULT(I2C,I2CISRC,INTCODE)  )
S
S  #define I2C_I2CISRC_RMK(intcode) (Uint32)(\
S     _PER_FMK(I2C,I2CISRC,INTCODE,intcode)\
S  )
X  #define I2C_I2CISRC_RMK(intcode) (Uint32)(     _PER_FMK(I2C,I2CISRC,INTCODE,intcode)  )
S   
S  #define _I2C_I2CISRC_FGET(N,FIELD)\
S    _PER_FGET(_I2C_I2CISRC##N##_ADDR,I2C,I2CISRC,##FIELD)
X  #define _I2C_I2CISRC_FGET(N,FIELD)    _PER_FGET(_I2C_I2CISRC##N##_ADDR,I2C,I2CISRC,##FIELD)
S
S  #define _I2C_I2CISRC_FSET(N,FIELD,field)\
S    _PER_FSET(_I2C_I2CISRC##N##_ADDR,I2C,I2CISRC,##FIELD,field)
X  #define _I2C_I2CISRC_FSET(N,FIELD,field)    _PER_FSET(_I2C_I2CISRC##N##_ADDR,I2C,I2CISRC,##FIELD,field)
S
S  #define _I2C_I2CISRC_FSETS(N,FIELD,SYM)\
S    _PER_FSETS(_I2C_I2CISRC##N##_ADDR,I2C,I2CISRC,##FIELD,##SYM)
X  #define _I2C_I2CISRC_FSETS(N,FIELD,SYM)    _PER_FSETS(_I2C_I2CISRC##N##_ADDR,I2C,I2CISRC,##FIELD,##SYM)
S
S  #define _I2C_I2CISRC0_FGET(FIELD) _I2C_I2CISRC_FGET(0,##FIELD)
S  #define _I2C_I2CISRC1_FGET(FIELD) _I2C_I2CISRC_FGET(1,##FIELD)
S
S  #define _I2C_I2CISRC0_FSET(FIELD,f) _I2C_I2CISRC_FSET(0,##FIELD,f)
S  #define _I2C_I2CISRC1_FSET(FIELD,f) _I2C_I2CISRC_FSET(1,##FIELD,f)
S
S  #define _I2C_I2CISRC0_FSETS(FIELD,SYM) _I2C_I2CISRC_FSETS(0,##FIELD,##SYM)
S  #define _I2C_I2CISRC1_FSETS(FIELD,SYM) _I2C_I2CISRC_FSETS(1,##FIELD,##SYM)
S
S/******************************************************************************\
S*  ___________________
X
S* |                   |
S* |  I 2 C E M D R    |
S* |___________________|
S*
S* I2CEMDR0    - I2C0 Extended Mode register(1)
S* I2CEMDR1    - I2C1 Extended Mode register(1)
S*
S* FIELDS (msb -> lsb)
S* (rw) XRDYM
S*
S* (1) For C6418/C6413/C6410 only
S\******************************************************************************/
S#if (CHIP_6413 | CHIP_6418 | CHIP_6410)
S  #define _I2C_I2CEMDR_OFFSET           11
S
S  #define _I2C_I2CEMDR0_ADDR            0x01B4002C
S  #define _I2C_I2CEMDR1_ADDR            0x01B4402C
S
S  #define _I2C_I2CEMDR_XRDYM_MASK         0x00000001u
S  #define _I2C_I2CEMDR_XRDYM_SHIFT        0x00000000u
S  #define  I2C_I2CEMDR_XRDYM_DEFAULT      0x00000001u
S  #define  I2C_I2CEMDR_XRDYM_OF(x)        _VALUEOF(x)
S  #define  I2C_I2CEMDR_XRDYM_MSTACK       0x00000000u
S  #define  I2C_I2CEMDR_XRDYM_DXRCPY       0x00000001u
S
S  #define  I2C_I2CEMDR_OF(x)             _VALUEOF(x)
S
S  #define I2C_I2CEMDR_DEFAULT (Uint32)(\
S     _PER_FDEFAULT(I2C,I2CEMDR,XRDYM)\
S  )
X  #define I2C_I2CEMDR_DEFAULT (Uint32)(     _PER_FDEFAULT(I2C,I2CEMDR,XRDYM)  )
S
S  #define I2C_I2CEMDR_RMK(xrdym) (Uint32)(\
S     _PER_FMK(I2C,I2CEMDR,XRDYM,xrdym)\
S  )
X  #define I2C_I2CEMDR_RMK(xrdym) (Uint32)(     _PER_FMK(I2C,I2CEMDR,XRDYM,xrdym)  )
S   
S  #define _I2C_I2CEMDR_FGET(N,FIELD)\
S    _PER_FGET(_I2C_I2CEMDR##N##_ADDR,I2C,I2CEMDR,##FIELD)
X  #define _I2C_I2CEMDR_FGET(N,FIELD)    _PER_FGET(_I2C_I2CEMDR##N##_ADDR,I2C,I2CEMDR,##FIELD)
S
S  #define _I2C_I2CEMDR_FSET(N,FIELD,field)\
S    _PER_FSET(_I2C_I2CEMDR##N##_ADDR,I2C,I2CEMDR,##FIELD,field)
X  #define _I2C_I2CEMDR_FSET(N,FIELD,field)    _PER_FSET(_I2C_I2CEMDR##N##_ADDR,I2C,I2CEMDR,##FIELD,field)
S
S  #define _I2C_I2CEMDR_FSETS(N,FIELD,SYM)\
S    _PER_FSETS(_I2C_I2CEMDR##N##_ADDR,I2C,I2CEMDR,##FIELD,##SYM)
X  #define _I2C_I2CEMDR_FSETS(N,FIELD,SYM)    _PER_FSETS(_I2C_I2CEMDR##N##_ADDR,I2C,I2CEMDR,##FIELD,##SYM)
S
S  #define _I2C_I2CEMDR0_FGET(FIELD) _I2C_I2CEMDR_FGET(0,##FIELD)
S  #define _I2C_I2CEMDR1_FGET(FIELD) _I2C_I2CEMDR_FGET(1,##FIELD)
S
S  #define _I2C_I2CEMDR0_FSET(FIELD,f) _I2C_I2CEMDR_FSET(0,##FIELD,f)
S  #define _I2C_I2CEMDR1_FSET(FIELD,f) _I2C_I2CEMDR_FSET(1,##FIELD,f)
S
S  #define _I2C_I2CEMDR0_FSETS(FIELD,SYM) _I2C_I2CEMDR_FSETS(0,##FIELD,##SYM)
S  #define _I2C_I2CEMDR1_FSETS(FIELD,SYM) _I2C_I2CEMDR_FSETS(1,##FIELD,##SYM)
S#endif
S
S/******************************************************************************\
S*  ___________________
X
S* |                   |
S* |  I 2 C P S C      |
S* |___________________|
S*
S* I2CPSC0    - I2C0 Prescaler register
S* I2CPSC1    - I2C1 Prescaler register
S*
S* FIELDS (msb -> lsb)
S* (rw) IPSC
S\******************************************************************************/
S  #define _I2C_I2CPSC_OFFSET           12
S
S  #define _I2C_I2CPSC0_ADDR            0x01B40030
S  #define _I2C_I2CPSC1_ADDR            0x01B44030
S
S  #define _I2C_I2CPSC_IPSC_MASK     0x000000FFu
S  #define _I2C_I2CPSC_IPSC_SHIFT    0x00000000u
S  #define  I2C_I2CPSC_IPSC_DEFAULT  0x00000000u
S  #define  I2C_I2CPSC_IPSC_OF(x)    _VALUEOF(x)
S
S  #define  I2C_I2CPSC_OF(x)             _VALUEOF(x)
S
S  #define I2C_I2CPSC_DEFAULT (Uint32)(\
S     _PER_FDEFAULT(I2C,I2CPSC,IPSC)\
S  )
X  #define I2C_I2CPSC_DEFAULT (Uint32)(     _PER_FDEFAULT(I2C,I2CPSC,IPSC)  )
S
S  #define I2C_I2CPSC_RMK(ipsc) (Uint32)(\
S     _PER_FMK(I2C,I2CPSC,IPSC,ipsc)\
S  )
X  #define I2C_I2CPSC_RMK(ipsc) (Uint32)(     _PER_FMK(I2C,I2CPSC,IPSC,ipsc)  )
S   
S  #define _I2C_I2CPSC_FGET(N,FIELD)\
S    _PER_FGET(_I2C_I2CPSC##N##_ADDR,I2C,I2CPSC,##FIELD)
X  #define _I2C_I2CPSC_FGET(N,FIELD)    _PER_FGET(_I2C_I2CPSC##N##_ADDR,I2C,I2CPSC,##FIELD)
S
S  #define _I2C_I2CPSC_FSET(N,FIELD,field)\
S    _PER_FSET(_I2C_I2CPSC##N##_ADDR,I2C,I2CPSC,##FIELD,field)
X  #define _I2C_I2CPSC_FSET(N,FIELD,field)    _PER_FSET(_I2C_I2CPSC##N##_ADDR,I2C,I2CPSC,##FIELD,field)
S
S  #define _I2C_I2CPSC_FSETS(N,FIELD,SYM)\
S    _PER_FSETS(_I2C_I2CPSC##N##_ADDR,I2C,I2CPSC,##FIELD,##SYM)
X  #define _I2C_I2CPSC_FSETS(N,FIELD,SYM)    _PER_FSETS(_I2C_I2CPSC##N##_ADDR,I2C,I2CPSC,##FIELD,##SYM)
S
S  #define _I2C_I2CPSC0_FGET(FIELD) _I2C_I2CPSC_FGET(0,##FIELD)
S  #define _I2C_I2CPSC1_FGET(FIELD) _I2C_I2CPSC_FGET(1,##FIELD)
S
S  #define _I2C_I2CPSC0_FSET(FIELD,f) _I2C_I2CPSC_FSET(0,##FIELD,f)
S  #define _I2C_I2CPSC1_FSET(FIELD,f) _I2C_I2CPSC_FSET(1,##FIELD,f)
S
S  #define _I2C_I2CPSC0_FSETS(FIELD,SYM) _I2C_I2CPSC_FSETS(0,##FIELD,##SYM)
S  #define _I2C_I2CPSC1_FSETS(FIELD,SYM) _I2C_I2CPSC_FSETS(1,##FIELD,##SYM)
S
S/******************************************************************************\
S*  ___________________
X
S* |                   |
S* |  I 2 C P I D 1    |
S* |___________________|
S*
S* I2CPID10    - I2C0 Peripheral ID Register 1(1)
S* I2CPID11    - I2C1 Peripheral ID Register 1(1)
S*
S* FIELDS (msb -> lsb)
S* (r) CLASS
S* (r) REVISION
S*
S* (1) For C6418/C6413/C6410 only
S\******************************************************************************/
S#if (CHIP_6413 | CHIP_6418 | CHIP_6410)
S  #define _I2C_I2CPID1_OFFSET           13
S
S  #define _I2C_I2CPID10_ADDR            0x01B40034
S  #define _I2C_I2CPID11_ADDR            0x01B44034
S
S  #define _I2C_I2CPID1_CLASS_MASK     0x0000FF00u
S  #define _I2C_I2CPID1_CLASS_SHIFT    0x00000008u
S  #define  I2C_I2CPID1_CLASS_DEFAULT  0x00000001u
S  #define  I2C_I2CPID1_CLASS_OF(x)    _VALUEOF(x)
S
S  #define _I2C_I2CPID1_REVISION_MASK     0x000000FFu
S  #define _I2C_I2CPID1_REVISION_SHIFT    0x00000000u
S  #define  I2C_I2CPID1_REVISION_DEFAULT  0x00000025u
S  #define  I2C_I2CPID1_REVISION_OF(x)    _VALUEOF(x)
S
S  #define  I2C_I2CPID1_OF(x)             _VALUEOF(x)
S  
S  #define I2C_I2CPID1_DEFAULT (Uint32)(\
S     _PER_FDEFAULT(I2C,I2CPID1,CLASS)\
S    |_PER_FDEFAULT(I2C,I2CPID1,REVISION)\
S  )
X  #define I2C_I2CPID1_DEFAULT (Uint32)(     _PER_FDEFAULT(I2C,I2CPID1,CLASS)    |_PER_FDEFAULT(I2C,I2CPID1,REVISION)  )
S
S  #define _I2C_I2CPID1_FGET(N,FIELD)\
S    _PER_FGET(_I2C_I2CPID1##N##_ADDR,I2C,I2CPID1,##FIELD)
X  #define _I2C_I2CPID1_FGET(N,FIELD)    _PER_FGET(_I2C_I2CPID1##N##_ADDR,I2C,I2CPID1,##FIELD)
S
S  #define _I2C_I2CPID10_FGET(FIELD) _I2C_I2CPID1_FGET(0,##FIELD)
S  #define _I2C_I2CPID11_FGET(FIELD) _I2C_I2CPID1_FGET(1,##FIELD)
S#endif /* CHIP_6413 | CHIP_6418 | CHIP_6410 */
S
S/******************************************************************************\
S*  ___________________
X
S* |                   |
S* |  I 2 C P I D 2    |
S* |___________________|
S*
S* I2CPID20    - I2C0 Peripheral ID Register 2(1)
S* I2CPID21    - I2C1 Peripheral ID Register 2(1)
S*
S* FIELDS (msb -> lsb)
S* (r) TYPE
S*
S* (1) For C6418/C6413/C6410 only
S\******************************************************************************/
S#if (CHIP_6413 | CHIP_6418 | CHIP_6410)
S  #define _I2C_I2CPID2_OFFSET           14
S
S  #define _I2C_I2CPID20_ADDR            0x01B40038
S  #define _I2C_I2CPID21_ADDR            0x01B44038
S
S  #define _I2C_I2CPID2_TYPE_MASK     0x000000FFu
S  #define _I2C_I2CPID2_TYPE_SHIFT    0x00000000u
S  #define  I2C_I2CPID2_TYPE_DEFAULT  0x00000005u
S  #define  I2C_I2CPID2_TYPE_OF(x)    _VALUEOF(x)
S
S  #define  I2C_I2CPID2_OF(x)             _VALUEOF(x)
S  
S  #define I2C_I2CPID2_DEFAULT (Uint32)(\
S     _PER_FDEFAULT(I2C,I2CPID2,TYPE)\
S  )
X  #define I2C_I2CPID2_DEFAULT (Uint32)(     _PER_FDEFAULT(I2C,I2CPID2,TYPE)  )
S
S  #define _I2C_I2CPID2_FGET(N,FIELD)\
S    _PER_FGET(_I2C_I2CPID2##N##_ADDR,I2C,I2CPID2,##FIELD)
X  #define _I2C_I2CPID2_FGET(N,FIELD)    _PER_FGET(_I2C_I2CPID2##N##_ADDR,I2C,I2CPID2,##FIELD)
S
S  #define _I2C_I2CPID20_FGET(FIELD) _I2C_I2CPID2_FGET(0,##FIELD)
S  #define _I2C_I2CPID21_FGET(FIELD) _I2C_I2CPID2_FGET(1,##FIELD)
S
S#endif /* CHIP_6413 | CHIP_6418 | CHIP_6410) */
S
S/******************************************************************************\
S* _____________________
X
S* |                   |
S* |  I 2 C P F U N C  |
S* |___________________|
S*
S* I2CPFUNC0  - I2C 0 Pin Function Register(1)
S* I2CPFUNC1  - I2C 1 Pin Function Register(1)
S*
S* FIELDS (msb -> lsb)
S* (rw) GPMODE 
S*
S* (1) For C6418/C6413/C6410 only
S\******************************************************************************/
S#if (CHIP_6413 | CHIP_6418 | CHIP_6410)
S  #define _I2C_I2CPFUNC_OFFSET            18
S
S  #define _I2C_I2CPFUNC0_ADDR              0x01B40048
S  #define _I2C_I2CPFUNC1_ADDR              0x01B44048
S
S  #define _I2C_I2CPFUNC_GPMODE_MASK            0x00000001u
S  #define _I2C_I2CPFUNC_GPMODE_SHIFT           0x00000000u
S  #define  I2C_I2CPFUNC_GPMODE_DEFAULT         0x00000000u
S  #define  I2C_I2CPFUNC_GPMODE_OF(x)           _VALUEOF(x)
S  #define  I2C_I2CPFUNC_GPMODE_ENABLE          0x00000001u
S  #define  I2C_I2CPFUNC_GPMODE_DISABLE         0x00000000u
S  
S  #define  I2C_I2CPFUNC_OF(x)             _VALUEOF(x)
S
S  #define I2C_I2CPFUNC_DEFAULT (Uint32)(\
S    _PER_FDEFAULT(I2C,I2CPFUNC,GPMODE)\
S  )
X  #define I2C_I2CPFUNC_DEFAULT (Uint32)(    _PER_FDEFAULT(I2C,I2CPFUNC,GPMODE)  )
S
S  #define I2C_I2CPFUNC_RMK(gpmode) (Uint32)(\
S    _PER_FMK(I2C,I2CPFUNC,GPMODE,gpmode)\
S  )
X  #define I2C_I2CPFUNC_RMK(gpmode) (Uint32)(    _PER_FMK(I2C,I2CPFUNC,GPMODE,gpmode)  )
S
S  #define _I2C_I2CPFUNC_FGET(N,FIELD)\
S    _PER_FGET(_I2C_I2CPFUNC##N##_ADDR,I2C,I2CPFUNC,##FIELD)
X  #define _I2C_I2CPFUNC_FGET(N,FIELD)    _PER_FGET(_I2C_I2CPFUNC##N##_ADDR,I2C,I2CPFUNC,##FIELD)
S
S  #define _I2C_I2CPFUNC_FSET(N,FIELD,field)\
S    _PER_FSET(_I2C_I2CPFUNC##N##_ADDR,I2C,I2CPFUNC,##FIELD,field)
X  #define _I2C_I2CPFUNC_FSET(N,FIELD,field)    _PER_FSET(_I2C_I2CPFUNC##N##_ADDR,I2C,I2CPFUNC,##FIELD,field)
S
S  #define _I2C_I2CPFUNC_FSETS(N,FIELD,SYM)\
S    _PER_FSETS(_I2C_I2CPFUNC##N##_ADDR,I2C,I2CPFUNC,##FIELD,##SYM)
X  #define _I2C_I2CPFUNC_FSETS(N,FIELD,SYM)    _PER_FSETS(_I2C_I2CPFUNC##N##_ADDR,I2C,I2CPFUNC,##FIELD,##SYM)
S
S  #define _I2C_I2CPFUNC0_FGET(FIELD) _I2C_I2CPFUNC_FGET(0,##FIELD)
S  #define _I2C_I2CPFUNC1_FGET(FIELD) _I2C_I2CPFUNC_FGET(1,##FIELD)
S
S  #define _I2C_I2CPFUNC0_FSET(FIELD,f) _I2C_I2CPFUNC_FSET(0,##FIELD,f)
S  #define _I2C_I2CPFUNC1_FSET(FIELD,f) _I2C_I2CPFUNC_FSET(1,##FIELD,f)
S
S  #define _I2C_I2CPFUNC0_FSETS(FIELD,SYM) _I2C_I2CPFUNC_FSETS(0,##FIELD,##SYM)
S  #define _I2C_I2CPFUNC1_FSETS(FIELD,SYM) _I2C_I2CPFUNC_FSETS(1,##FIELD,##SYM)
S#endif /* CHIP_6413 | CHIP_6418 | CHIP_6410) */
S  
S/******************************************************************************\
S* ___________________
X
S* |                 |
S* |  I 2 C P D I R  |
S* |_________________|
S*
S* I2CPDIR0  - I2C 0 Pin Direction Register(1)
S* I2CPDIR1  - I2C 1 Pin Direction Register(1)
S*
S* FIELDS (msb -> lsb)
S* (rw) SDADIR
S* (rw) SCLDIR
S*
S* (1) For C6418/C6413/C6410 only
S\******************************************************************************/
S#if (CHIP_6413 | CHIP_6418 | CHIP_6410)
S  #define _I2C_I2CPDIR_OFFSET             19
S
S  #define _I2C_I2CPDIR0_ADDR              0x01B4004C
S  #define _I2C_I2CPDIR1_ADDR              0x01B4404C
S
S  #define _I2C_I2CPDIR_SDADIR_MASK         0x00000002u
S  #define _I2C_I2CPDIR_SDADIR_SHIFT        0x00000001u
S  #define  I2C_I2CPDIR_SDADIR_DEFAULT      0x00000000u
S  #define  I2C_I2CPDIR_SDADIR_OF(x)        _VALUEOF(x)
S  #define  I2C_I2CPDIR_SDADIR_INPUT        0x00000000u
S  #define  I2C_I2CPDIR_SDADIR_OUTPUT       0x00000001u
S  
S  #define _I2C_I2CPDIR_SCLDIR_MASK         0x00000001u
S  #define _I2C_I2CPDIR_SCLDIR_SHIFT        0x00000000u
S  #define  I2C_I2CPDIR_SCLDIR_DEFAULT      0x00000000u
S  #define  I2C_I2CPDIR_SCLDIR_OF(x)        _VALUEOF(x)
S  #define  I2C_I2CPDIR_SCLDIR_INPUT        0x00000000u
S  #define  I2C_I2CPDIR_SCLDIR_OUTPUT       0x00000001u
S  
S  #define  I2C_I2CPDIR_OF(x)              _VALUEOF(x)
S
S  #define I2C_I2CPDIR_DEFAULT (Uint32)(\
S    _PER_FDEFAULT(I2C,I2CPDIR,SDADIR)\
S   |_PER_FDEFAULT(I2C,I2CPDIR,SCLDIR)\
S  )
X  #define I2C_I2CPDIR_DEFAULT (Uint32)(    _PER_FDEFAULT(I2C,I2CPDIR,SDADIR)   |_PER_FDEFAULT(I2C,I2CPDIR,SCLDIR)  )
S
S  #define I2C_I2CPDIR_RMK(sdadir,scldir) (Uint32)(\
S    _PER_FMK(I2C,I2CPDIR,SDADIR,sdadir)\
S   |_PER_FMK(I2C,I2CPDIR,SCLDIR,scldir)\
S  )
X  #define I2C_I2CPDIR_RMK(sdadir,scldir) (Uint32)(    _PER_FMK(I2C,I2CPDIR,SDADIR,sdadir)   |_PER_FMK(I2C,I2CPDIR,SCLDIR,scldir)  )
S
S  #define _I2C_I2CPDIR_FGET(N,FIELD)\
S    _PER_FGET(_I2C_I2CPDIR##N##_ADDR,I2C,I2CPDIR,##FIELD)
X  #define _I2C_I2CPDIR_FGET(N,FIELD)    _PER_FGET(_I2C_I2CPDIR##N##_ADDR,I2C,I2CPDIR,##FIELD)
S
S  #define _I2C_I2CPDIR_FSET(N,FIELD,field)\
S    _PER_FSET(_I2C_I2CPDIR##N##_ADDR,I2C,I2CPDIR,##FIELD,field)
X  #define _I2C_I2CPDIR_FSET(N,FIELD,field)    _PER_FSET(_I2C_I2CPDIR##N##_ADDR,I2C,I2CPDIR,##FIELD,field)
S
S  #define _I2C_I2CPDIR_FSETS(N,FIELD,SYM)\
S    _PER_FSETS(_I2C_I2CPDIR##N##_ADDR,I2C,I2CPDIR,##FIELD,##SYM)
X  #define _I2C_I2CPDIR_FSETS(N,FIELD,SYM)    _PER_FSETS(_I2C_I2CPDIR##N##_ADDR,I2C,I2CPDIR,##FIELD,##SYM)
S
S  #define _I2C_I2CPDIR0_FGET(FIELD) _I2C_I2CPDIR_FGET(0,##FIELD)
S  #define _I2C_I2CPDIR1_FGET(FIELD) _I2C_I2CPDIR_FGET(1,##FIELD)
S
S  #define _I2C_I2CPDIR0_FSET(FIELD,f) _I2C_I2CPDIR_FSET(0,##FIELD,f)
S  #define _I2C_I2CPDIR1_FSET(FIELD,f) _I2C_I2CPDIR_FSET(1,##FIELD,f)
S
S  #define _I2C_I2CPDIR0_FSETS(FIELD,SYM) _I2C_I2CPDIR_FSETS(0,##FIELD,##SYM)
S  #define _I2C_I2CPDIR1_FSETS(FIELD,SYM) _I2C_I2CPDIR_FSETS(1,##FIELD,##SYM)
S#endif /* CHIP_6413 | CHIP_6418 | CHIP_6410) */
S
S/******************************************************************************\
S* ___________________
X
S* |                 |
S* |  I 2 C P D I N  |
S* |_________________|
S*
S* I2CPDIN0  - I2C 0 Pin Data In Register(1)
S* I2CPDIN1  - I2C 1 Pin Data In Register(1)
S*
S* FIELDS (msb -> lsb)
S* (r) SDAIN
S* (r) SCLIN
S*
S* (1) For C6418/C6413/C6410 only
S\******************************************************************************/
S#if (CHIP_6413 | CHIP_6418 | CHIP_6410)
S  #define _I2C_I2CPDIN_OFFSET             20
S
S  #define _I2C_I2CPDIN0_ADDR              0x01B40050
S  #define _I2C_I2CPDIN1_ADDR              0x01B44050
S
S  #define _I2C_I2CPDIN_SDAIN_MASK         0x00000002u
S  #define _I2C_I2CPDIN_SDAIN_SHIFT        0x00000001u
S  #define  I2C_I2CPDIN_SDAIN_OF(x)        _VALUEOF(x)
S  #define  I2C_I2CPDIN_SDAIN_LOW          0x00000000u
S  #define  I2C_I2CPDIN_SDAIN_HIGH         0x00000001u
S  
S  #define _I2C_I2CPDIN_SCLIN_MASK         0x00000001u
S  #define _I2C_I2CPDIN_SCLIN_SHIFT        0x00000000u
S  #define  I2C_I2CPDIN_SCLIN_OF(x)        _VALUEOF(x)
S  #define  I2C_I2CPDIN_SCLIN_LOW          0x00000000u
S  #define  I2C_I2CPDIN_SCLIN_HIGH         0x00000001u
S  
S  #define  I2C_I2CPDIN_OF(x)              _VALUEOF(x)
S
S  #define I2C_I2CPDIN_DEFAULT (Uint32)(\
S    _PER_FDEFAULT(I2C,I2CPDIN,SDAIN)\
S   |_PER_FDEFAULT(I2C,I2CPDIN,SCLIN)\
S  )
X  #define I2C_I2CPDIN_DEFAULT (Uint32)(    _PER_FDEFAULT(I2C,I2CPDIN,SDAIN)   |_PER_FDEFAULT(I2C,I2CPDIN,SCLIN)  )
S
S  #define I2C_I2CPDIN_RMK(sdain,sclin) (Uint32)(\
S    _PER_FMK(I2C,I2CPDIN,SDAIN,sdain)\
S   |_PER_FMK(I2C,I2CPDIN,SCLIN,sclin)\
S  )
X  #define I2C_I2CPDIN_RMK(sdain,sclin) (Uint32)(    _PER_FMK(I2C,I2CPDIN,SDAIN,sdain)   |_PER_FMK(I2C,I2CPDIN,SCLIN,sclin)  )
S
S  #define _I2C_I2CPDIN_FGET(N,FIELD)\
S    _PER_FGET(_I2C_I2CPDIN##N##_ADDR,I2C,I2CPDIN,##FIELD)
X  #define _I2C_I2CPDIN_FGET(N,FIELD)    _PER_FGET(_I2C_I2CPDIN##N##_ADDR,I2C,I2CPDIN,##FIELD)
S
S  #define _I2C_I2CPDIN0_FGET(FIELD) _I2C_I2CPDIN_FGET(0,##FIELD)
S  #define _I2C_I2CPDIN1_FGET(FIELD) _I2C_I2CPDIN_FGET(1,##FIELD)
S
S#endif /* CHIP_6413 | CHIP_6418 | CHIP_6410) */
S
S/******************************************************************************\
S* _____________________
X
S* |                   |
S* |  I 2 C P D O U T  |
S* |___________________|
S*
S* I2CPDOUT0  - I2C 0 Pin Data Out Register(1)
S* I2CPDOUT1  - I2C 1 Pin Data Out Register(1)
S*
S* FIELDS (msb -> lsb)
S* (rw) SDAOUT
S* (rw) SCLOUT
S*
S* (1) For C6418/C6413/C6410 only
S\******************************************************************************/
S#if (CHIP_6413 | CHIP_6418 | CHIP_6410)
S  #define _I2C_I2CPDOUT_OFFSET              21
S
S  #define _I2C_I2CPDOUT0_ADDR               0x01B40054
S  #define _I2C_I2CPDOUT1_ADDR               0x01B44054
S
S  #define _I2C_I2CPDOUT_SDAOUT_MASK         0x00000002u
S  #define _I2C_I2CPDOUT_SDAOUT_SHIFT        0x00000001u
S  #define  I2C_I2CPDOUT_SDAOUT_DEFAULT      0x00000000u
S  #define  I2C_I2CPDOUT_SDAOUT_OF(x)        _VALUEOF(x)
S  #define  I2C_I2CPDOUT_SDAOUT_LOW          0x00000000u
S  #define  I2C_I2CPDOUT_SDAOUT_HIGH         0x00000001u
S  
S  #define _I2C_I2CPDOUT_SCLOUT_MASK         0x00000001u
S  #define _I2C_I2CPDOUT_SCLOUT_SHIFT        0x00000000u
S  #define  I2C_I2CPDOUT_SCLOUT_DEFAULT      0x00000000u
S  #define  I2C_I2CPDOUT_SCLOUT_OF(x)        _VALUEOF(x)
S  #define  I2C_I2CPDOUT_SCLOUT_LOW          0x00000000u
S  #define  I2C_I2CPDOUT_SCLOUT_HIGH         0x00000001u
S  
S  #define  I2C_I2CPDOUT_OF(x)              _VALUEOF(x)
S
S  #define I2C_I2CPDOUT_DEFAULT (Uint32)(\
S    _PER_FDEFAULT(I2C,I2CPDOUT,SDAOUT)\
S   |_PER_FDEFAULT(I2C,I2CPDOUT,SCLOUT)\
S  )
X  #define I2C_I2CPDOUT_DEFAULT (Uint32)(    _PER_FDEFAULT(I2C,I2CPDOUT,SDAOUT)   |_PER_FDEFAULT(I2C,I2CPDOUT,SCLOUT)  )
S
S  #define I2C_I2CPDOUT_RMK(sdaout,sclout) (Uint32)(\
S    _PER_FMK(I2C,I2CPDOUT,SDAOUT,sdaout)\
S   |_PER_FMK(I2C,I2CPDOUT,SCLOUT,sclout)\
S  )
X  #define I2C_I2CPDOUT_RMK(sdaout,sclout) (Uint32)(    _PER_FMK(I2C,I2CPDOUT,SDAOUT,sdaout)   |_PER_FMK(I2C,I2CPDOUT,SCLOUT,sclout)  )
S
S  #define _I2C_I2CPDOUT_FGET(N,FIELD)\
S    _PER_FGET(_I2C_I2CPDOUT##N##_ADDR,I2C,I2CPDOUT,##FIELD)
X  #define _I2C_I2CPDOUT_FGET(N,FIELD)    _PER_FGET(_I2C_I2CPDOUT##N##_ADDR,I2C,I2CPDOUT,##FIELD)
S
S  #define _I2C_I2CPDOUT_FSET(N,FIELD,field)\
S    _PER_FSET(_I2C_I2CPDOUT##N##_ADDR,I2C,I2CPDOUT,##FIELD,field)
X  #define _I2C_I2CPDOUT_FSET(N,FIELD,field)    _PER_FSET(_I2C_I2CPDOUT##N##_ADDR,I2C,I2CPDOUT,##FIELD,field)
S
S  #define _I2C_I2CPDOUT_FSETS(N,FIELD,SYM)\
S    _PER_FSETS(_I2C_I2CPDOUT##N##_ADDR,I2C,I2CPDOUT,##FIELD,##SYM)
X  #define _I2C_I2CPDOUT_FSETS(N,FIELD,SYM)    _PER_FSETS(_I2C_I2CPDOUT##N##_ADDR,I2C,I2CPDOUT,##FIELD,##SYM)
S
S  #define _I2C_I2CPDOUT0_FGET(FIELD) _I2C_I2CPDOUT_FGET(0,##FIELD)
S  #define _I2C_I2CPDOUT1_FGET(FIELD) _I2C_I2CPDOUT_FGET(1,##FIELD)
S
S  #define _I2C_I2CPDOUT0_FSET(FIELD,f) _I2C_I2CPDOUT_FSET(0,##FIELD,f)
S  #define _I2C_I2CPDOUT1_FSET(FIELD,f) _I2C_I2CPDOUT_FSET(1,##FIELD,f)
S
S  #define _I2C_I2CPDOUT0_FSETS(FIELD,SYM) _I2C_I2CPDOUT_FSETS(0,##FIELD,##SYM)
S  #define _I2C_I2CPDOUT1_FSETS(FIELD,SYM) _I2C_I2CPDOUT_FSETS(1,##FIELD,##SYM)
S#endif /* CHIP_6413 | CHIP_6418 | CHIP_6410) */
S
S/******************************************************************************\
S* _____________________
X
S* |                   |
S* |  I 2 C P D S E T  |
S* |___________________|
S*
S* I2CPDSET0  - I2C 0 Pin Data Set Register(1)
S* I2CPDSET1  - I2C 1 Pin Data Set Register(1)
S*
S* FIELDS (msb -> lsb)
S* (rw) PDSET1
S* (rw) PDSET0
S*
S* (1) For C6418/C6413/C6410 only
S*
S* Note: Read of these two bits is indeterminate
S\******************************************************************************/
S#if (CHIP_6413 | CHIP_6418 | CHIP_6410)
S  #define _I2C_I2CPDSET_OFFSET              22
S
S  #define _I2C_I2CPDSET0_ADDR               0x01B40058
S  #define _I2C_I2CPDSET1_ADDR               0x01B44058
S
S  #define _I2C_I2CPDSET_SDAOUT_MASK         0x00000002u
S  #define _I2C_I2CPDSET_SDAOUT_SHIFT        0x00000001u
S  #define  I2C_I2CPDSET_SDAOUT_DEFAULT      0x00000000u
S  #define  I2C_I2CPDSET_SDAOUT_OF(x)        _VALUEOF(x)
S  #define  I2C_I2CPDSET_SDAOUT_UNCHGN       0x00000000u
S  #define  I2C_I2CPDSET_SDAOUT_SET          0x00000001u
S  
S  #define _I2C_I2CPDSET_SCLOUT_MASK         0x00000001u
S  #define _I2C_I2CPDSET_SCLOUT_SHIFT        0x00000000u
S  #define  I2C_I2CPDSET_SCLOUT_DEFAULT      0x00000000u
S  #define  I2C_I2CPDSET_SCLOUT_OF(x)        _VALUEOF(x)
S  #define  I2C_I2CPDSET_SCLOUT_UNCHGN       0x00000000u
S  #define  I2C_I2CPDSET_SCLOUT_SET          0x00000001u
S  
S  #define  I2C_I2CPDSET_OF(x)              _VALUEOF(x)
S
S  #define I2C_I2CPDSET_DEFAULT (Uint32)(\
S    _PER_FDEFAULT(I2C,I2CPDSET,SDAOUT)\
S   |_PER_FDEFAULT(I2C,I2CPDSET,SCLOUT)\
S  )
X  #define I2C_I2CPDSET_DEFAULT (Uint32)(    _PER_FDEFAULT(I2C,I2CPDSET,SDAOUT)   |_PER_FDEFAULT(I2C,I2CPDSET,SCLOUT)  )
S
S  #define I2C_I2CPDSET_RMK(sdaout,sclout) (Uint32)(\
S    _PER_FMK(I2C,I2CPDSET,SDAOUT,sdaout)\
S   |_PER_FMK(I2C,I2CPDSET,SCLOUT,sclout)\
S  )
X  #define I2C_I2CPDSET_RMK(sdaout,sclout) (Uint32)(    _PER_FMK(I2C,I2CPDSET,SDAOUT,sdaout)   |_PER_FMK(I2C,I2CPDSET,SCLOUT,sclout)  )
S
S  #define _I2C_I2CPDSET_FGET(N,FIELD)\
S    _PER_FGET(_I2C_I2CPDSET##N##_ADDR,I2C,I2CPDSET,##FIELD)
X  #define _I2C_I2CPDSET_FGET(N,FIELD)    _PER_FGET(_I2C_I2CPDSET##N##_ADDR,I2C,I2CPDSET,##FIELD)
S
S  #define _I2C_I2CPDSET_FSET(N,FIELD,field)\
S    _PER_FSET(_I2C_I2CPDSET##N##_ADDR,I2C,I2CPDSET,##FIELD,field)
X  #define _I2C_I2CPDSET_FSET(N,FIELD,field)    _PER_FSET(_I2C_I2CPDSET##N##_ADDR,I2C,I2CPDSET,##FIELD,field)
S
S  #define _I2C_I2CPDSET_FSETS(N,FIELD,SYM)\
S    _PER_FSETS(_I2C_I2CPDSET##N##_ADDR,I2C,I2CPDSET,##FIELD,##SYM)
X  #define _I2C_I2CPDSET_FSETS(N,FIELD,SYM)    _PER_FSETS(_I2C_I2CPDSET##N##_ADDR,I2C,I2CPDSET,##FIELD,##SYM)
S
S  #define _I2C_I2CPDSET0_FGET(FIELD) _I2C_I2CPDSET_FGET(0,##FIELD)
S  #define _I2C_I2CPDSET1_FGET(FIELD) _I2C_I2CPDSET_FGET(1,##FIELD)
S
S  #define _I2C_I2CPDSET0_FSET(FIELD,f) _I2C_I2CPDSET_FSET(0,##FIELD,f)
S  #define _I2C_I2CPDSET1_FSET(FIELD,f) _I2C_I2CPDSET_FSET(1,##FIELD,f)
S
S  #define _I2C_I2CPDSET0_FSETS(FIELD,SYM) _I2C_I2CPDSET_FSETS(0,##FIELD,##SYM)
S  #define _I2C_I2CPDSET1_FSETS(FIELD,SYM) _I2C_I2CPDSET_FSETS(1,##FIELD,##SYM)
S#endif /* CHIP_6413 | CHIP_6418 | CHIP_6410) */
S
S/******************************************************************************\
S* _____________________
X
S* |                   |
S* |  I 2 C P D C L R  |
S* |___________________|
S*
S* I2CPDCLR0  - I2C 0 Pin Data Clear Register(1)
S* I2CPDCLR1  - I2C 1 Pin Data Clear Register(1)
S*
S* FIELDS (msb -> lsb)
S* (rw) PDCLR1
S* (rw) PDCLR0
S*
S* (1) For C6418/C6413/C6410 only
S*
S* Note: Read of these two bits is indeterminate
S\******************************************************************************/
S#if (CHIP_6413 | CHIP_6418 | CHIP_6410)
S  #define _I2C_I2CPDCLR_OFFSET              23
S
S  #define _I2C_I2CPDCLR0_ADDR               0x01B4005C
S  #define _I2C_I2CPDCLR1_ADDR               0x01B4405C
S
S  #define _I2C_I2CPDCLR_SDAOUT_MASK         0x00000002u
S  #define _I2C_I2CPDCLR_SDAOUT_SHIFT        0x00000001u
S  #define  I2C_I2CPDCLR_SDAOUT_DEFAULT      0x00000000u
S  #define  I2C_I2CPDCLR_SDAOUT_OF(x)        _VALUEOF(x)
S  #define  I2C_I2CPDCLR_SDAOUT_UNCHGN       0x00000000u
S  #define  I2C_I2CPDCLR_SDAOUT_CLR          0x00000001u
S  
S  #define _I2C_I2CPDCLR_SCLOUT_MASK         0x00000001u
S  #define _I2C_I2CPDCLR_SCLOUT_SHIFT        0x00000000u
S  #define  I2C_I2CPDCLR_SCLOUT_DEFAULT      0x00000000u
S  #define  I2C_I2CPDCLR_SCLOUT_OF(x)        _VALUEOF(x)
S  #define  I2C_I2CPDCLR_SCLOUT_UNCHGN       0x00000000u
S  #define  I2C_I2CPDCLR_SCLOUT_CLR          0x00000001u
S  
S  #define  I2C_I2CPDCLR_OF(x)              _VALUEOF(x)
S
S  #define I2C_I2CPDCLR_DEFAULT (Uint32)(\
S    _PER_FDEFAULT(I2C,I2CPDCLR,SDAOUT)\
S   |_PER_FDEFAULT(I2C,I2CPDCLR,SCLOUT)\
S  )
X  #define I2C_I2CPDCLR_DEFAULT (Uint32)(    _PER_FDEFAULT(I2C,I2CPDCLR,SDAOUT)   |_PER_FDEFAULT(I2C,I2CPDCLR,SCLOUT)  )
S
S  #define I2C_I2CPDCLR_RMK(sdaout,sclout) (Uint32)(\
S    _PER_FMK(I2C,I2CPDCLR,SDAOUT,sdaout)\
S   |_PER_FMK(I2C,I2CPDCLR,SCLOUT,sclout)\
S  )
X  #define I2C_I2CPDCLR_RMK(sdaout,sclout) (Uint32)(    _PER_FMK(I2C,I2CPDCLR,SDAOUT,sdaout)   |_PER_FMK(I2C,I2CPDCLR,SCLOUT,sclout)  )
S
S  #define _I2C_I2CPDCLR_FGET(N,FIELD)\
S    _PER_FGET(_I2C_I2CPDCLR##N##_ADDR,I2C,I2CPDCLR,##FIELD)
X  #define _I2C_I2CPDCLR_FGET(N,FIELD)    _PER_FGET(_I2C_I2CPDCLR##N##_ADDR,I2C,I2CPDCLR,##FIELD)
S
S  #define _I2C_I2CPDCLR_FSET(N,FIELD,field)\
S    _PER_FSET(_I2C_I2CPDCLR##N##_ADDR,I2C,I2CPDCLR,##FIELD,field)
X  #define _I2C_I2CPDCLR_FSET(N,FIELD,field)    _PER_FSET(_I2C_I2CPDCLR##N##_ADDR,I2C,I2CPDCLR,##FIELD,field)
S
S  #define _I2C_I2CPDCLR_FSETS(N,FIELD,SYM)\
S    _PER_FSETS(_I2C_I2CPDCLR##N##_ADDR,I2C,I2CPDCLR,##FIELD,##SYM)
X  #define _I2C_I2CPDCLR_FSETS(N,FIELD,SYM)    _PER_FSETS(_I2C_I2CPDCLR##N##_ADDR,I2C,I2CPDCLR,##FIELD,##SYM)
S
S  #define _I2C_I2CPDCLR0_FGET(FIELD) _I2C_I2CPDCLR_FGET(0,##FIELD)
S  #define _I2C_I2CPDCLR1_FGET(FIELD) _I2C_I2CPDCLR_FGET(1,##FIELD)
S
S  #define _I2C_I2CPDCLR0_FSET(FIELD,f) _I2C_I2CPDCLR_FSET(0,##FIELD,f)
S  #define _I2C_I2CPDCLR1_FSET(FIELD,f) _I2C_I2CPDCLR_FSET(1,##FIELD,f)
S
S  #define _I2C_I2CPDCLR0_FSETS(FIELD,SYM) _I2C_I2CPDCLR_FSETS(0,##FIELD,##SYM)
S  #define _I2C_I2CPDCLR1_FSETS(FIELD,SYM) _I2C_I2CPDCLR_FSETS(1,##FIELD,##SYM)
S#endif /* CHIP_6413 | CHIP_6418 | CHIP_6410 */
S
N#endif /* I2C_SUPPORT */
N#endif /* _CSL_I2CHAL_H_ */
N/******************************************************************************\
N* End of csl_i2chal.h
X
N\******************************************************************************/
L 17 "E:/TI_workspase/c6701_t/csl/csl_i2c.h" 2
N
N
N/* defining i2cimr as i2cier for backward compatibility */
N
N#define i2cimr i2cier
N
N#if (I2C_SUPPORT)
X#if (( ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*1) | ( 0*0) | ( 0*0) | ( 1*0) | ( 1*0)| ( 1*0)| ( 1*0)| ( 1*0)| ( 1*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 1*0) | ( 1*0) | ( 1*0) | ( 0*0) ))
S/******************************************************************************\
S* scope and inline control macros
X
S\******************************************************************************/
S#ifdef __cplusplus
S#define CSLAPI extern "C" far
S#else
S#define CSLAPI extern far
S#endif
S
S#undef  USEDEFS
S#undef  IDECL
S#undef  IDEF
S
S#ifdef  _I2C_MOD_
S  #define IDECL CSLAPI
S  #define USEDEFS
S  #define IDEF
S#else
S  #ifdef  _INLINE
S    #define IDECL static inline
S    #define USEDEFS
S    #define IDEF  static inline
S  #else
S    #define IDECL CSLAPI
S  #endif
S#endif
S
S
S/******************************************************************************\
S* global macro declarations
X
S\******************************************************************************/
S
S/* I2C_open() flags */
S#define I2C_OPEN_RESET     (0x00000001)
S
S/* device identifiers for I2C_open() */
S
S#if (CHIP_6713 | CHIP_DA610 | CHIP_6413 | CHIP_6418 | CHIP_6410)
S  #define I2C_DEV0           (0)
S  #define I2C_DEV1           (1)
S#endif
S
S#if (CHIP_DM642 | CHIP_DM641 | CHIP_DM640 | CHIP_6412)
S  #define I2C_DEV0           (0)
S#endif
S
S/* device identifiers for I2C_open() */
S
S#if (CHIP_6713 | CHIP_DA610 | CHIP_6413 | CHIP_6418 | CHIP_6410)
S  #define I2C_PORT0          I2C_DEV0
S  #define I2C_PORT1          I2C_DEV1
S#endif
S
S#if (CHIP_DM642 | CHIP_DM641 | CHIP_DM640 | CHIP_6412)
S  #define I2C_PORT0           I2C_DEV0
S#endif
S
S/* error codes */
S#define I2C_ERR_ALLOC	        (0x00000000) 
S#define I2C_ERR_INVALID_HANDLE  (0x00000001) 
S
S#define I2C_EVT_AL      0x01     // Arbitration win/lose
S#define I2C_EVT_NACK    0x02     // No acknowledgement 
S#define I2C_EVT_ARDY    0x03     // register access ready
S#define I2C_EVT_ICRRDY  0x04     // receive data ready
S#define I2C_EVT_ICXRDY  0x05     // transmit data ready
S
S#if (CHIP_6413 | CHIP_6418 | CHIP_6410)
S  #define I2C_EVT_SCD     0x06     // stop condition detect 
S  #define I2C_EVT_AAS     0x07     // address as slave
S#endif
S
S/******************************************************************************\
S* global typedef declarations
X
S\******************************************************************************/
S
S/* device handle object */
Stypedef struct {
S  Uint32 allocated;
S  Uint32 eventId;
S  volatile Uint32 *baseAddr;
S  Uint32 i2cdrrAddr;
S  Uint32 i2cdxrAddr;
S} I2C_Obj, *I2C_Handle;
S
S/* device configuration structure */
Stypedef struct {
S	Uint32 i2coar;
S	Uint32 i2cier;
S	Uint32 i2cclkl;
S	Uint32 i2cclkh;
S	Uint32 i2ccnt;
S	Uint32 i2csar;
S	Uint32 i2cmdr;
S	Uint32 i2cpsc;
S#if (CHIP_6413 | CHIP_6418 | CHIP_6410)
S        Uint32 i2cemdr;
S        Uint32 i2cpfunc;
S        Uint32 i2cpdir;
S#endif    
S} I2C_Config;
S
Stypedef struct {
S	Uint32 addrmode;        /* 7 or 10 bit address mode */
S	Uint32 ownaddr;         /* don't care if master */
S	Uint32 sysinclock;      /* clkout value (Mhz)  */
S	Uint32 rate;            /* a number between 10 and 400 in kbps*/
S	Uint32 bitbyte;         /* number of bits/byte to be received or transmitted */
S	Uint32 dlb;             /* digital loopback mode */
S	Uint32 free;	        /* free mode */
S} I2C_Init;
S
S
S/******************************************************************************\
S* global variable declarations
X
S\******************************************************************************/
S
S/******************************************************************************\
S* global function declarations
X
S\******************************************************************************/
SCSLAPI void I2C_reset(I2C_Handle hI2c);
SCSLAPI void I2C_resetAll();
SCSLAPI I2C_Handle I2C_open(int devNum, Uint32 flags);
SCSLAPI void I2C_close(I2C_Handle hI2c);
S//CSLAPI void I2C_init(I2C_Init *init);
S
S/******************************************************************************\
S* inline function declarations
X
S\******************************************************************************/
SIDECL Uint32 I2C_getXmtAddr(I2C_Handle hI2c);
SIDECL Uint32 I2C_getRcvAddr(I2C_Handle hI2c);
SIDECL Uint32 I2C_getEventId(I2C_Handle hI2c);
SIDECL Uint32 I2C_rfull(I2C_Handle hI2c);
SIDECL Uint32 I2C_rrdy(I2C_Handle hI2c);
SIDECL Uint32 I2C_xempty(I2C_Handle hI2c);
SIDECL Uint32 I2C_xrdy(I2C_Handle hI2c);
SIDECL Uint32 I2C_bb(I2C_Handle hI2c);
S
SIDECL void I2C_writeByte(I2C_Handle hI2c, Uint8 val);
SIDECL Uint8 I2C_readByte(I2C_Handle hI2c);
S
SIDECL void I2C_sendStop(I2C_Handle hI2c);
SIDECL void I2C_start(I2C_Handle hI2c);
SIDECL void I2C_outOfReset(I2C_Handle hI2c);
S
SIDECL Uint32 I2C_intClear(I2C_Handle hI2c);
SIDECL void I2C_intClearAll(I2C_Handle hI2c);
SIDECL void I2C_intEvtEnable(I2C_Handle hI2c,Uint32 maskFlag);
SIDECL void I2C_intEvtDisable(I2C_Handle hI2c,Uint32 unmaskFlag);
S
SIDECL void I2C_config(I2C_Handle hI2c,I2C_Config *config);
S
S#if (CHIP_6413 | CHIP_6418 | CHIP_6410)
S  IDECL void I2C_configArgs(I2C_Handle hI2c,Uint32 i2coar,Uint32 i2cier,Uint32 i2cclkl,
S                            Uint32 i2cclkh,Uint32 i2ccnt,Uint32 i2csar,Uint32 i2cmdr,
S                            Uint32 i2cpsc,Uint32 i2cemdr,Uint32 i2cpfunc,Uint32 i2cpdir);
S#else
S  IDECL void I2C_configArgs(I2C_Handle hI2c,Uint32 i2coar,Uint32 i2cier,Uint32 i2cclkl,
S                            Uint32 i2cclkh,Uint32 i2ccnt,Uint32 i2csar,Uint32 i2cmdr,
S                            Uint32 i2cpsc);
S
S#endif
SIDECL void I2C_getConfig(I2C_Handle hI2c,I2C_Config *config);
S
S
S/******************************************************************************\
S* inline function definitions
X
S\******************************************************************************/
S#ifdef USEDEFS
S#if (CHIP_6413 | CHIP_6418 | CHIP_6410)
S/*----------------------------------------------------------------------------*/
SIDEF Uint32 I2C_getPins(I2C_Handle hI2c) {
S    return I2C_RGETH(hI2c,I2CPDIN);
S}
S/*----------------------------------------------------------------------------*/
SIDEF void I2C_setPins(I2C_Handle hI2c,Uint32 pins) {
S    I2C_RSETH(hI2c,I2CPDSET,
S        (
S          I2C_FMK(I2CPDSET, SCLOUT, pins>>_I2C_I2CPDSET_SCLOUT_SHIFT)
S         |I2C_FMK(I2CPDSET, SDAOUT, pins>>_I2C_I2CPDSET_SDAOUT_SHIFT)
S        )
S    );        
S}
SIDEF void I2C_clearPins(I2C_Handle hI2c,Uint32 pins) {
S    I2C_RSETH(hI2c,I2CPDCLR,
S        (
S          I2C_FMK(I2CPDCLR, SCLOUT, pins>>_I2C_I2CPDCLR_SCLOUT_SHIFT)
S         |I2C_FMK(I2CPDCLR, SDAOUT, pins>>_I2C_I2CPDCLR_SDAOUT_SHIFT)
S        )
S    );        
S}
S/*----------------------------------------------------------------------------*/
SIDEF Uint32 I2C_getExtMode(I2C_Handle hI2C) {
S    return I2C_FGETH(hI2C,I2CEMDR,XRDYM);
S}
S/*----------------------------------------------------------------------------*/
SIDEF void I2C_setMstAck(I2C_Handle hI2C) {
S    I2C_FSETSH(hI2C,I2CEMDR,XRDYM,MSTACK);
S}
S/*----------------------------------------------------------------------------*/
SIDEF void I2C_setDxrCpy(I2C_Handle hI2C) {
S    I2C_FSETSH(hI2C,I2CEMDR,XRDYM,DXRCPY);
S}
S#endif
S/*----------------------------------------------------------------------------*/
SIDEF Uint32 I2C_getXmtAddr(I2C_Handle hI2c) {
S  return (Uint32)(hI2c->i2cdxrAddr);
S}
S/*----------------------------------------------------------------------------*/
SIDEF Uint32 I2C_getRcvAddr(I2C_Handle hI2c) {
S  return (Uint32)(hI2c->i2cdrrAddr);
S}
S/*----------------------------------------------------------------------------*/
SIDEF Uint32 I2C_getEventId(I2C_Handle hI2c) {
S  return (Uint32)(hI2c->eventId);
S}
S/*----------------------------------------------------------------------------*/
SIDEF Uint32 I2C_rfull(I2C_Handle hI2c){
S return	I2C_FGETH(hI2c,I2CSTR,RSFULL);
S}
S/*----------------------------------------------------------------------------*/
SIDEF Uint32 I2C_rrdy(I2C_Handle hI2c){
S return	I2C_FGETH(hI2c,I2CSTR,ICRRDY);
S}
S/*----------------------------------------------------------------------------*/
SIDEF Uint32 I2C_xempty(I2C_Handle hI2c){
S return I2C_FGETH(hI2c,I2CSTR,XSMT);
S}
S/*----------------------------------------------------------------------------*/
SIDEF Uint32 I2C_xrdy(I2C_Handle hI2c){
S return	I2C_FGETH(hI2c,I2CSTR,ICXRDY);
S}
S/*----------------------------------------------------------------------------*/
SIDEF Uint32 I2C_bb(I2C_Handle hI2c){
S return	I2C_FGETH(hI2c,I2CSTR,BB);
S}
S/*----------------------------------------------------------------------------*/
SIDEF Uint8 I2C_readByte(I2C_Handle hI2c) {
S  return (*(volatile Uint8 *)(hI2c->i2cdrrAddr));
S}
S/*----------------------------------------------------------------------------*/
SIDEF void I2C_writeByte(I2C_Handle hI2c, Uint8 val) {
S  (*(volatile Uint8 *)(hI2c->i2cdxrAddr)) = val;
S}
S/*----------------------------------------------------------------------------*/
SIDEF void I2C_sendStop(I2C_Handle hI2c){
S 	I2C_FSETSH(hI2c,I2CMDR,STP,STOP);
S}
S/*----------------------------------------------------------------------------*/
SIDEF void I2C_start(I2C_Handle hI2c){
S	I2C_FSETSH(hI2c,I2CMDR,STT,START);
S}
S/*----------------------------------------------------------------------------*/
SIDEF void I2C_outOfReset(I2C_Handle hI2c){
S	I2C_FSETSH(hI2c,I2CMDR,IRS,NRST);
S}
S/*----------------------------------------------------------------------------*/
SIDEF Uint32 I2C_intClear(I2C_Handle hI2c){
S    return I2C_RGETH(hI2c,I2CISRC);
S}
S/*----------------------------------------------------------------------------*/
SIDEF void I2C_intClearAll(I2C_Handle hI2c){
S   Uint32 x=I2C_RGETH(hI2c,I2CISRC);
S    while(x != 0) { x=I2C_RGETH(hI2c,I2CISRC); }
S}
S/*----------------------------------------------------------------------------*/
SIDEF void I2C_intEvtEnable(I2C_Handle hI2c,Uint32 maskFlag){
S
S    Uint32 newMask;
S
S	newMask = I2C_RGETH(hI2c,I2CIER) | maskFlag;
S	I2C_RSETH(hI2c,I2CIER,newMask);
S	IRQ_enable(hI2c->eventId);
S
S}
S/*----------------------------------------------------------------------------*/
SIDEF void I2C_intEvtDisable(I2C_Handle hI2c,Uint32 unmaskFlag){
S
S	Uint32 newMask;
S
S	newMask = I2C_RGETH(hI2c,I2CIER) & unmaskFlag;
S	I2C_RSETH(hI2c,I2CIER,newMask);
S
S    #if (CHIP_6410 | CHIP_6413| CHIP_6418 )
S	if(!(I2C_RGETH(hI2c,I2CIER) & 0x0000007F))
S    #else
S	if(!(I2C_RGETH(hI2c,I2CIER) & 0x0000001F))
S    #endif
S		IRQ_disable(hI2c->eventId);
S}
S/*----------------------------------------------------------------------------*/
S
SIDEF void I2C_config(I2C_Handle hI2c, I2C_Config *config) {
S
S  Uint32 gie;
S  volatile Uint32 *base = (volatile Uint32 *)(hI2c->baseAddr);
S  register int x0,x1,x2,x3,x4,x5,x6,x7;
S#if (CHIP_6413 | CHIP_6418 | CHIP_6410)
S  register int x8,x9,x10;
S#endif
S
S  gie = IRQ_globalDisable();
S
S  /* the compiler generates more efficient code if the loads */
S  /* and stores are grouped together rather than intermixed  */
S  x0 = config->i2coar;
S  x1 = config->i2cier;
S  x2 = config->i2cclkl;
S  x3 = config->i2cclkh;
S  x4 = config->i2ccnt;
S  x5 = config->i2csar;
S  x6 = config->i2cpsc;
S  x7 = config->i2cmdr;
S#if (CHIP_6413 | CHIP_6418 | CHIP_6410)
S  x8 = config->i2cemdr;
S  x9 = config->i2cpfunc;
S  x10 = config->i2cpdir;
S#endif  
S
S  base[_I2C_I2COAR_OFFSET]   = x0;
S  base[_I2C_I2CIER_OFFSET]   = x1;
S  base[_I2C_I2CCLKL_OFFSET]  = x2;
S  base[_I2C_I2CCLKH_OFFSET]  = x3;
S  base[_I2C_I2CCNT_OFFSET]   = x4;
S  base[_I2C_I2CSAR_OFFSET]   = x5;
S  base[_I2C_I2CPSC_OFFSET]   = x6;
S  base[_I2C_I2CMDR_OFFSET]   = x7;
S#if (CHIP_6413 | CHIP_6418 | CHIP_6410)
S  base[_I2C_I2CEMDR_OFFSET]  = x8;
S  base[_I2C_I2CPFUNC_OFFSET] = x9;
S  base[_I2C_I2CPDIR_OFFSET]  = x10;
S#endif
S
S  IRQ_globalRestore(gie);
S}
S/*----------------------------------------------------------------------------*/
S#if (CHIP_6413 | CHIP_6418 | CHIP_6410)
SIDEF void I2C_configArgs(I2C_Handle hI2c,Uint32 i2coar,Uint32 i2cier,Uint32 i2cclkl,
S                         Uint32 i2cclkh,Uint32 i2ccnt,Uint32 i2csar,Uint32 i2cmdr,
S                         Uint32 i2cpsc,Uint32 i2cemdr,Uint32 i2cpfunc,Uint32 i2cpdir){
S
S  Uint32 gie;
S  volatile Uint32 *base = (volatile Uint32 *)(hI2c->baseAddr);
S
S  gie = IRQ_globalDisable();
S
S  base[_I2C_I2COAR_OFFSET]   = i2coar;
S  base[_I2C_I2CIER_OFFSET]   = i2cier;
S  base[_I2C_I2CCLKL_OFFSET]  = i2cclkl;
S  base[_I2C_I2CCLKH_OFFSET]  = i2cclkh;
S  base[_I2C_I2CCNT_OFFSET]   = i2ccnt;
S  base[_I2C_I2CSAR_OFFSET]   = i2csar;
S  base[_I2C_I2CPSC_OFFSET]   = i2cpsc;
S  base[_I2C_I2CMDR_OFFSET]   = i2cmdr;
S  base[_I2C_I2CEMDR_OFFSET]  = i2cemdr;
S  base[_I2C_I2CPFUNC_OFFSET] = i2cpfunc;
S  base[_I2C_I2CPDIR_OFFSET]  = i2cpdir;
S
S  IRQ_globalRestore(gie);
S}
S#else
SIDEF void I2C_configArgs(I2C_Handle hI2c,Uint32 i2coar,Uint32 i2cier,
SUint32 i2cclkl,Uint32 i2cclkh,Uint32 i2ccnt,Uint32 i2csar,
SUint32 i2cmdr,Uint32 i2cpsc){
S
S  Uint32 gie;
S  volatile Uint32 *base = (volatile Uint32 *)(hI2c->baseAddr);
S
S  gie = IRQ_globalDisable();
S
S  base[_I2C_I2COAR_OFFSET]  = i2coar;
S  base[_I2C_I2CIER_OFFSET]  = i2cier;
S  base[_I2C_I2CCLKL_OFFSET] = i2cclkl;
S  base[_I2C_I2CCLKH_OFFSET] = i2cclkh;
S  base[_I2C_I2CCNT_OFFSET]  = i2ccnt;
S  base[_I2C_I2CSAR_OFFSET]  = i2csar;
S  base[_I2C_I2CPSC_OFFSET]  = i2cpsc;
S  base[_I2C_I2CMDR_OFFSET]  = i2cmdr;
S
S  IRQ_globalRestore(gie);
S}
S#endif
S/*----------------------------------------------------------------------------*/
S#if (CHIP_6413 | CHIP_6418 | CHIP_6410)
SIDEF void I2C_getConfig(I2C_Handle hI2c, I2C_Config *config) {
S
S  Uint32 gie;
S  volatile Uint32 *base = (volatile Uint32 *)(hI2c->baseAddr);
S  register int x0,x1,x2,x3,x4,x5,x6,x7,x8,x9,x10;
S
S  gie = IRQ_globalDisable();
S
S  /* the compiler generates more efficient code if the loads */
S  /* and stores are grouped together rather than intermixed  */
S
S  x0 = base[_I2C_I2COAR_OFFSET];
S  x1 = base[_I2C_I2CIER_OFFSET];
S  x2 = base[_I2C_I2CCLKL_OFFSET];
S  x3 = base[_I2C_I2CCLKH_OFFSET];
S  x4 = base[_I2C_I2CCNT_OFFSET];
S  x5 = base[_I2C_I2CSAR_OFFSET];
S  x6 = base[_I2C_I2CMDR_OFFSET];
S  x7 = base[_I2C_I2CPSC_OFFSET];
S  x8 = base[_I2C_I2CEMDR_OFFSET];
S  x9 = base[_I2C_I2CPFUNC_OFFSET];
S  x10 = base[_I2C_I2CPDIR_OFFSET];
S
S  config->i2coar   = x0;
S  config->i2cier   = x1;
S  config->i2cclkl  = x2;
S  config->i2cclkh  = x3;
S  config->i2ccnt   = x4;
S  config->i2csar   = x5;
S  config->i2cmdr   = x6;
S  config->i2cpsc   = x7;
S  config->i2cemdr  = x8;
S  config->i2cpfunc = x9;
S  config->i2cpdir  = x10;
S
S  IRQ_globalRestore(gie);
S}
S#else
SIDEF void I2C_getConfig(I2C_Handle hI2c, I2C_Config *config) {
S
S  Uint32 gie;
S  volatile Uint32 *base = (volatile Uint32 *)(hI2c->baseAddr);
S  register int x0,x1,x2,x3,x4,x5,x6,x7;
S
S  gie = IRQ_globalDisable();
S
S  /* the compiler generates more efficient code if the loads */
S  /* and stores are grouped together rather than intermixed  */
S
S  x0 = base[_I2C_I2COAR_OFFSET];
S  x1 = base[_I2C_I2CIER_OFFSET];
S  x2 = base[_I2C_I2CCLKL_OFFSET];
S  x3 = base[_I2C_I2CCLKH_OFFSET];
S  x4 = base[_I2C_I2CCNT_OFFSET];
S  x5 = base[_I2C_I2CSAR_OFFSET];
S  x6 = base[_I2C_I2CMDR_OFFSET];
S  x7 = base[_I2C_I2CPSC_OFFSET];
S
S  config->i2coar  = x0;
S  config->i2cier  = x1;
S  config->i2cclkl = x2;
S  config->i2cclkh = x3;
S  config->i2ccnt  = x4;
S  config->i2csar  = x5;
S  config->i2cmdr  = x6;
S  config->i2cpsc  = x7;
S
S  IRQ_globalRestore(gie);
S}
S#endif
S/*----------------------------------------------------------------------------*/
S#endif /* USEDEFS */
S
S
N#endif /* I2C_SUPPORT */
N#endif /* _CSL_I2C_H_ */
N/******************************************************************************\
N* End of csl_i2c.h
X
N\******************************************************************************/
N
L 12 "../csl/csl_i2c.c" 2
N
N
N#if (I2C_SUPPORT)
X#if (( ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*1) | ( 0*0) | ( 0*0) | ( 1*0) | ( 1*0)| ( 1*0)| ( 1*0)| ( 1*0)| ( 1*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 1*0) | ( 1*0) | ( 1*0) | ( 0*0) ))
S/******************************************************************************\
S*                         L O C A L   S E C T I O N
X
S\******************************************************************************/
S
S
S/******************************************************************************\
S* static macro declarations
X
S\******************************************************************************/
S#define DEVICE_ENTRY(devNum) { \
S  FALSE, \
S  IRQ_EVT_I2CINT##devNum##, \
S  (volatile Uint32*)_I2C_BASE_PORT##devNum##, \
S  _I2C_I2CDRR##devNum##_ADDR, \
S  _I2C_I2CDXR##devNum##_ADDR \
S}
X#define DEVICE_ENTRY(devNum) {   FALSE,   IRQ_EVT_I2CINT##devNum##,   (volatile Uint32*)_I2C_BASE_PORT##devNum##,   _I2C_I2CDRR##devNum##_ADDR,   _I2C_I2CDXR##devNum##_ADDR }
S
S
S/******************************************************************************\
S* static typedef declarations
X
S\******************************************************************************/
S
S
S/******************************************************************************\
S* static function declarations
X
S\******************************************************************************/
S
S
S/******************************************************************************\
S* static variable definitions
X
S\******************************************************************************/
Sstatic I2C_Obj _I2C_deviceTable[_I2C_PORT_CNT] = {
S#if (CHIP_6713 | CHIP_DA610 | CHIP_6413 | CHIP_6418 | CHIP_6410)
S   DEVICE_ENTRY(0)
S  ,DEVICE_ENTRY(1)
S#endif
S#if (CHIP_DM642 | CHIP_DM641 | CHIP_DM640 | CHIP_6412)
S   DEVICE_ENTRY(0)
S#endif
S  };
S
S
S
S
S/******************************************************************************\
S* static function definitions
X
S\******************************************************************************/
S
S
S/******************************************************************************\
S*                        G L O B A L   S E C T I O N
X
S\******************************************************************************/
S
S
S/******************************************************************************\
S* global variable definitions
X
S\******************************************************************************/
S
S/******************************************************************************\
S* global function definitions
X
S\******************************************************************************/
S
S/*----------------------------------------------------------------------------*/
Svoid I2C_reset(I2C_Handle hI2c) {
S  
S  Uint32 gie;
S
S  gie = IRQ_globalDisable();
S
S  if (hI2c == INV) {
S    I2C_reset((I2C_Handle)(&(_I2C_deviceTable[0])));
S  #if (CHIP_6713 | CHIP_DA610 | CHIP_6413 | CHIP_6418 | CHIP_6410)
S    I2C_reset((I2C_Handle)(&(_I2C_deviceTable[1])));
S  #endif
S  } else {
S    I2C_RSETH(hI2c,I2COAR,I2C_I2COAR_DEFAULT);
S    I2C_RSETH(hI2c,I2CIER,I2C_I2CIER_DEFAULT);
S    I2C_RSETH(hI2c,I2CSTR,I2C_I2CSTR_DEFAULT);
S    I2C_RSETH(hI2c,I2CCLKL,I2C_I2CCLKL_DEFAULT);
S    I2C_RSETH(hI2c,I2CCLKH,I2C_I2CCLKH_DEFAULT);
S    I2C_RSETH(hI2c,I2CCNT,I2C_I2CCNT_DEFAULT);
S    I2C_RSETH(hI2c,I2CSAR,I2C_I2CSAR_DEFAULT);
S    I2C_RSETH(hI2c,I2CPSC,I2C_I2CPSC_DEFAULT);
S    I2C_RSETH(hI2c,I2CDXR,I2C_I2CDXR_DEFAULT);
S    
S    while(I2C_RGETH(hI2c,I2CISRC))  /* Reading I2CISRC clears the interrupt flag */
S              ;
S
S    I2C_RSETH(hI2c,I2CMDR,I2C_I2CMDR_DEFAULT); /* I2C is reset mode  IRS=0 */
S
S#if (CHIP_6413 | CHIP_6418 | CHIP_6410)
S    I2C_RSETH(hI2c,I2CEMDR,I2C_I2CEMDR_DEFAULT);
S    I2C_RSETH(hI2c,I2CPFUNC,I2C_I2CPFUNC_DEFAULT);
S    I2C_RSETH(hI2c,I2CPDIR,I2C_I2CPDIR_DEFAULT);
S    I2C_RSETH(hI2c,I2CPDOUT,I2C_I2CPDOUT_DEFAULT);
S#endif    
S	IRQ_reset(hI2c->eventId);
S  }
S  
S  IRQ_globalRestore(gie);
S  
S  return;
S}
S/*----------------------------------------------------------------------------*/
Svoid I2C_resetAll() {
S  I2C_reset(INV);
S}
S/*----------------------------------------------------------------------------*/
SI2C_Handle I2C_open(int devNum, Uint32 flags) {
S
S  Uint32 gie;
S
S  I2C_Handle hI2c = INV;
S
S  gie = IRQ_globalDisable();
S  if (!_I2C_deviceTable[devNum].allocated) {
S    hI2c = &(_I2C_deviceTable[devNum]);
S    _I2C_deviceTable[devNum].allocated = TRUE;
S
S    if (hI2c != INV) {
S      if (flags & I2C_OPEN_RESET) {
S        I2C_reset(hI2c);
S      }
S    }
S  }
S
S  IRQ_globalRestore(gie);
S
S  return hI2c;
S}
S/*----------------------------------------------------------------------------*/
Svoid I2C_close(I2C_Handle hI2c) {
S
S  Uint32 gie;
S
S  gie = IRQ_globalDisable();
S
S  if (hI2c != INV) {
S    I2C_reset(hI2c);
S    hI2c->allocated = FALSE;
S  }
S  
S  IRQ_globalRestore(gie);
S  
S  return;
S}
S/*----------------------------------------------------------------------------*/
S
N#endif /* I2C_SUPPORT */
N/******************************************************************************\
N* End of csl_i2c.c
X
N\******************************************************************************/
N
